unit u_ZusFelder;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Buttons, ExtCtrls, JvExStdCtrls, JvListBox, gnugettext,
   u_ShLowUtils, u_AdminBase;

type
   Tfrm_ZusFelder = class (TForm)
      edt_ZusName: TEdit;
      lbl_ZusName: TLabel;
      grbx_Typ: TRadioGroup;
      grbx_Mode: TRadioGroup;
      grbx_AusText: TGroupBox;
      edt_AusText: TEdit;
      sbtn_AddText: TSpeedButton;
      sbtn_RemText: TSpeedButton;
      lbl_AusText: TLabel;
      btn_Cancel: TButton;
      btn_OK: TButton;
      lb_AusText: TJvListBox;
      cb_DutyField: TCheckBox;
      lbl_checkprog: TLabel;
      edt_checkprogr: TEdit;
    btn_Checkprogramm: TSpeedButton;
      sbtn_sortvalues: TSpeedButton;
      sbtn_unsortvalues: TSpeedButton;
      cb_Verknuepfung: TCheckBox;
      cb_Dokumentname: TCheckBox;
      procedure grbx_TypClick(Sender: TObject);
      procedure lb_AusTextClick(Sender: TObject);
      procedure sbtn_RemTextClick(Sender: TObject);
      procedure sbtn_AddTextClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure btn_CheckprogrammClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure sbtn_sortvaluesClick(Sender: TObject);
      procedure sbtn_unsortvaluesClick(Sender: TObject);
      procedure edt_ZusNameChange(Sender: TObject);
   private
      fishowing: boolean;
      { Private-Deklarationen }
   public
      fitype: integer;
      { Public-Deklarationen }
   end;

var
   frm_ZusFelder: Tfrm_ZusFelder;

implementation

uses u_MainForm;

{$R *.dfm}

procedure Tfrm_ZusFelder.grbx_TypClick(Sender: TObject);
begin
   if ((grbx_Typ.ItemIndex and 3) > 1) then
      grbx_AusText.Enabled := True else grbx_AusText.Enabled := False;
   if fishowing then
   begin
      case grbx_Typ.ItemIndex of
         0:
         begin
            if fitype = 1 then
            begin
               BfShowMessage(_('Sie mchten das Feld des Typs Datum in Typ Universalfeld umwandeln.') + #13 +
                  _('Dies wird leider nicht untersttzt.'));
               fishowing := false;
               grbx_Typ.ItemIndex := 1;
               fishowing := true;
            end;
            {   if fitype = 2 then
            begin
                BfShowMessage('Sie mchten das Feld des Typs Datum in Typ Auswahlfeld umwandeln.' + #13+
                                 'Dies wird leider nicht untersttzt.');
                fishowing:=false;
                grbx_Typ.ItemIndex:=1;
                fishowing:=true;
            end;      }
         end;
         1:
         begin
            if fitype = 0 then
            begin
               BfShowMessage(_('Sie mchten das Feld des Typs Universalfeld in Typ Datum umwandeln.') + #10 +
                  _('Bitte fhren Sie anschlieend char2date aus.'));
            end;
            if fitype = 2 then
            begin
               BfShowMessage(_('Sie mchten das Feld des Typs Auswahlfeld in Typ Datum umwandeln.') + #10 +
                  _('Dies wird leider nicht untersttzt.'));
               fishowing := false;
               grbx_Typ.ItemIndex := 2;
               fishowing := true;
            end;
         end;
         2:
         begin
            if fitype = 1 then
            begin
               BfShowMessage(_('Sie mchten das Feld des Typs Datum in Typ Auswahlfeld umwandeln.') + #10 +
                  _('Dies wird leider nicht untersttzt.'));
               fishowing := false;
               grbx_Typ.ItemIndex := 1;
               fishowing := true;
            end;
         end;
      else
      begin
         if fitype = 1 then
         begin
            BfShowMessage(_('Sie mchten das Feld des Typs Datum in einen anderen Typ umwandeln.') + #10 +
               _('Dies wird leider nicht untersttzt.'));
            fishowing := false;
            grbx_Typ.ItemIndex := 1;
            fishowing := true;
         end;
      end;
      end;
   end;
end;

procedure Tfrm_ZusFelder.lb_AusTextClick(Sender: TObject);
var iCount: Integer;
begin
   for iCount := 0 to (lb_AusText.Count - 1) do
   begin
      if lb_AusText.Selected[iCount] then
      begin
         edt_AusText.Text := lb_AusText.Items.Strings[iCount];
         break;
      end;
   end;
end;

procedure Tfrm_ZusFelder.sbtn_RemTextClick(Sender: TObject);
var iCount: Integer;
begin
   for iCount := 0 to (lb_AusText.Count - 1) do
   begin
      if lb_AusText.Selected[iCount] then
      begin
         lb_AusText.Items.Delete(iCount);
         break;
      end;
   end;
end;

procedure Tfrm_ZusFelder.sbtn_AddTextClick(Sender: TObject);
begin
   if lb_AusText.Items.IndexOf(edt_AusText.Text) = -1 then
   begin
      lb_AusText.Items.Add(edt_AusText.Text);
      edt_AusText.Text := '';
   end
   else BfShowMessage(_('Dieser Auswahltext ist schon vorhanden.'));
end;

procedure Tfrm_ZusFelder.FormShow(Sender: TObject);
begin
   fishowing := true;
   // frm_ZusFelder.edt_ZusName.setfocus;
end;

procedure Tfrm_ZusFelder.btn_CheckprogrammClick(Sender: TObject);
var   sFileName: string;
begin
   if PromptForFileName(sFileName, '', '', _('Programm zur berprfung der Zusatzfeldingabe'), '', false) then
   begin
      edt_checkprogr.Text := sFilename;
   end;
end;

procedure Tfrm_ZusFelder.FormCreate(Sender: TObject);
begin
   TranslateComponent(self);
   fishowing := false;
end;

procedure Tfrm_ZusFelder.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   fishowing := false;
end;

procedure Tfrm_ZusFelder.sbtn_sortvaluesClick(Sender: TObject);
begin
   lb_AusText.sorted := true;
   sbtn_sortvalues.visible := false;
   sbtn_unsortvalues.Visible := true;
end;

procedure Tfrm_ZusFelder.sbtn_unsortvaluesClick(Sender: TObject);
begin
   lb_AusText.sorted := false;
   sbtn_sortvalues.visible := true;
   sbtn_unsortvalues.Visible := false;
end;

procedure Tfrm_ZusFelder.edt_ZusNameChange(Sender: TObject);
begin
   frm_MainForm.edt_ZusFields.Text := frm_ZusFelder.edt_ZusName.text;
end;

end.
