unit u_mysql_login;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  Tmysql_login = class(TForm)
    lbl_root: TLabel;
    edt_root: TEdit;
    lbl_rootpass: TLabel;
    edt_rootpass: TEdit;
    lbl_mysqlserver: TLabel;
    edt_mysqlserver: TEdit;
    lbl_mysqlport: TLabel;
    edt_mysqlport: TEdit;
    btn_Connect: TButton;
    btn_cancel: TButton;
    procedure edt_rootChange(Sender: TObject);
    procedure edt_mysqlserverChange(Sender: TObject);
    procedure edt_mysqlportChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    function enableBTN: Boolean;
  public
    { Public-Deklarationen }
  end;

var
  mysql_login: Tmysql_login;

implementation

{$R *.dfm}

function Tmysql_login.enableBTN :Boolean;
begin
   btn_Connect.Enabled := (Trim(edt_root.Text) <> '')
                     and (Trim(edt_mysqlport.Text) <> '') and (Trim(edt_mysqlserver.Text) <> '');

end;




procedure Tmysql_login.edt_rootChange(Sender: TObject);
begin
	enableBTN;
end;

procedure Tmysql_login.edt_mysqlserverChange(Sender: TObject);
begin
	enableBTN;
end;

procedure Tmysql_login.edt_mysqlportChange(Sender: TObject);
begin
	enableBTN;
end;

procedure Tmysql_login.FormCreate(Sender: TObject);
begin
	TranslateComponent(Self, 'AdministratorV3');
end;

end.
