unit u_zusatzrights;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ComCtrls, Buttons, gnugettext,
   u_ShLowUtils, u_ShDbUtils;

type
   Tfrm_zusatzrights = class (TForm)
      sbtn_ArcRAddMem: TSpeedButton;
      sbtn_ArcRRemMem: TSpeedButton;
      lv_UsrGrp: TListView;
      lv_ArcMember: TListView;
      lv_status: TListView;
      btn_stsxsdefault: TButton;
      Label5: TLabel;
      btn_del: TButton;
      Edit1: TEdit;
      Edit2: TEdit;
      Label6: TLabel;
      Label7: TLabel;
      btn_Close: TButton;
      btn_ReadOnly: TButton;
      procedure sbtn_ArcRAddMemClick(Sender: TObject);
      procedure sbtn_ArcRRemMemClick(Sender: TObject);
      procedure lv_statusSelectItem(Sender: TObject; Item: TListItem;
         Selected: Boolean);
      procedure FormShow(Sender: TObject);
      procedure btn_stsxsdefaultClick(Sender: TObject);
      procedure btn_tablestatusClick(Sender: TObject);
      procedure btn_delClick(Sender: TObject);
      procedure Edit2KeyUp(Sender: TObject; var Key: Word;
         Shift: TShiftState);
      procedure Edit1KeyUp(Sender: TObject; var Key: Word;
         Shift: TShiftState);
      procedure FormCreate(Sender: TObject);
    procedure btn_ReadOnlyClick(Sender: TObject);
   private
      procedure checkexistency;
      { Private-Deklarationen }
   public
      procedure readrights;
      procedure readgroupsuser;
      { Public-Deklarationen }
   end;

var
   frm_zusatzrights: Tfrm_zusatzrights;

implementation

uses u_MainForm, strutils, u_dm_mainform;

{$R *.dfm}


procedure Tfrm_zusatzrights.readrights;
var listsid: integer;
cfgxs:Boolean;
sSQL:string;
begin
   GgfLogEvntBeg('Tfrm_zusatzrights.readrights begin');
   try
      if  DbTableExist('cfgxs_' + GArcTblName) then
      begin
          if lv_Status.SelCount > 0 then
          begin
             listsid := integer(lv_Status.Selected.Data);
             try

                sSQL:= 'select usr_Name from sys_usr left join  cfgxs_' + GArcTblName + ' as a on sys_usr.usr_id = a.usr_id ' +
                   'and Grp_ID = 0  where grp_ID = 0 and cfg_id =' + inttostr(listsid) +
                   ' and not (usr_name like ' + #39 + 'del\_%' + #39 + ') group by usr_name order by usr_name';

                if dm_mainform.UsrSelectedSZ(sSQL) then
                begin
                   GgfLogEvnt('Tfrm_zusatzrights.readgroupsuser select usr_Name ... RecordCount='+IntToStr(dm_MainForm.my_q_usr_selected_sz.RecordCount));
                   lv_ArcMember.Items.Clear;
                   while not dm_mainform.my_q_usr_selected_sz.Eof do
                   begin
                      with lv_ArcMember.Items.Add do
                      begin
                         Caption := dm_mainform.my_q_usr_selected_sz.FieldByName('usr_name').AsString;
                         ImageIndex := 3;
                      end;
                      dm_mainform.my_q_usr_selected_sz.Next;
                   end;
                end
                else ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'), 2013, True);


                sSQL:= 'select grp_Name from sys_grp left join cfgxs_' + GArcTblName + ' as a on sys_grp.grp_id = a.grp_id ' +
                   ' and Usr_ID = 0 where cfg_id =' + inttostr(listsid) +
                   ' and not (grp_name like ' + #39 + 'del\_%' + #39 + ') group by grp_name order by grp_name';

                if dm_mainform.GrpSQLSelectedSZ(sSQL) then
                begin
                   GgfLogEvnt('Tfrm_zusatzrights.readgroupsuser select grp_Name ... RecordCount='+IntToStr(dm_MainForm.my_q_Grp_all_sz.RecordCount));
                   while not dm_mainform.my_q_Grp_selected_sz.Eof do
                   begin
                      with lv_ArcMember.Items.Add do
                      begin
                         Caption := dm_mainform.my_q_Grp_selected_sz.FieldByName('grp_name').AsString;
                         ImageIndex := 2;
                      end;
                      dm_mainform.my_q_Grp_selected_sz.Next;
                   end;
                end
                else ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Gruppen'), 2013, True);

             except
                on e: exception do
                   ErrorMsg('sbtn_ArcRRemMemClick', _('Fehler beim Auslesen der Gruppen und Benutzer:')+' ' + e.Message, 2019, True);
             end;
          end;
      end;
   finally
      GgfLogEvntEnd('Tfrm_zusatzrights.readrights end');
   end
end;


procedure Tfrm_zusatzrights.readgroupsuser;
var listsid: integer;
cfgxs:Boolean;
sSQL:string;
begin
   cfgxs:=False;
   GgfLogEvntBeg('Tfrm_zusatzrights.readgroupsuser begin');
   try
      if  DbTableExist('cfgxs_' + GArcTblName) then
        cfgxs:=True;

      if lv_Status.SelCount > 0 then
      begin
         listsid := integer(lv_Status.Selected.Data);
         lv_UsrGrp.Items.Clear;

         if cfgxs then
          sSQL:= 'select grp_Name from sys_grp left join cfgxs_' + GArcTblName + ' as a on sys_grp.grp_id = a.grp_id ' +
            'and cfg_id =' + inttostr(listsid) + ' and Usr_ID = 0 where a.Grp_ID is NULL  ' +
            ' and not (grp_name like ' + #39 + 'del\_%' + #39 + ') order by grp_Name'
          else
            sSQL:= 'select grp_Name from sys_grp where not (grp_name like '+#39+'del\_%'+#39+') order by grp_Name';

         if dm_MainForm.GrpSQLALLSZ(sSQL) then
         begin
            GgfLogEvnt('Tfrm_zusatzrights.readgroupsuser select grp_Name ... RecordCount='+IntToStr(dm_MainForm.my_q_Grp_all_sz.RecordCount));
            while not dm_mainform.my_q_Grp_all_sz.Eof do
            begin
               if lowercase(leftstr(dm_mainform.my_q_Grp_all_sz.FieldByName('grp_name').AsString, 4)) <> 'del_' then
               begin
                  with lv_UsrGrp.Items.Add do
                  begin
                     Caption := dm_mainform.my_q_Grp_all_sz.FieldByName('grp_name').AsString;
                     ImageIndex := 2;
                  end;
               end;
               dm_mainform.my_q_Grp_all_sz.Next;
            end;
         end
         else ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'), 2013, True);

         if cfgxs then
                 sSQL:= 'select usr_Name from sys_usr left join cfgxs_' + GArcTblName + ' as a on sys_usr.usr_id = a.usr_id ' +
            'and Grp_ID = 0 and cfg_id =' + inttostr(listsid) + ' where grp_ID is null ' +
            ' and not (usr_name like ' + #39 + 'del\_%' + #39 + ') group by usr_name order by usr_name'
         else
            sSQL:= 'select usr_Name from sys_usr where not (usr_name like '+#39+'del\_%'+#39+') order by usr_Name';


         if dm_MainForm.UsrSQLALLSZ(sSQL) then
         begin
            GgfLogEvnt('Tfrm_zusatzrights.readgroupsuser select usr_Name ... RecordCount='+IntToStr(dm_MainForm.my_q_usr_selected_sz.RecordCount));
            while not dm_mainform.my_q_usr_all_sz.Eof do
            begin
               if lowercase(leftstr(dm_mainform.my_q_usr_all_sz.FieldByName('usr_name').AsString, 4)) <> 'del_' then
               begin
                  with lv_UsrGrp.Items.Add do
                  begin
                     Caption := dm_mainform.my_q_usr_all_sz.FieldByName('usr_name').AsString;
                     ImageIndex := 3;
                  end;
               end;
               //end;
               dm_mainform.my_q_usr_all_sz.Next;
            end;
         end
         else ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'), 2013, True);
      end;
   finally
      GgfLogEvntEnd('Tfrm_zusatzrights.readgroupsuser end');
   end
end;

procedure Tfrm_zusatzrights.FormShow(Sender: TObject);
begin
   frm_MainForm.ArchivSQL('select * from cfg_' + GArcTblName + ' order by pos');
   lv_status.Items.Clear;
   while not dm_mainform.my_qry_Arc.Eof do
   begin

      lv_status.AddItem(dm_mainform.my_qry_Arc.FieldByName('disp_Name').AsString, TObject(dm_mainform.my_qry_Arc.FieldByName('cfg_id').AsInteger));

      dm_mainform.my_qry_Arc.Next;
   end;
 
   readgroupsuser;
   btn_tablestatusClick(Sender);
end;


procedure Tfrm_zusatzrights.sbtn_ArcRAddMemClick(Sender: TObject);
var TmpUpdStr, lscaption: String;
   licount, lGrpID, lUsrID, listsid: integer;
   lbfound: boolean;
begin
   lbfound:=false;
   checkexistency;
   if lv_Status.SelCount > 0 then
      listsid := integer(lv_Status.Selected.Data)
   else
      exit;

   if (lv_UsrGrp.SelCount <> 0) and (lv_UsrGrp.Selected.ImageIndex = 3) then
   begin
      if frm_MainForm.tmpSQL('Select * from sys_usr where Usr_Name = ' + #39 + lv_UsrGrp.Selected.Caption + #39) then
      begin
         lscaption := lv_UsrGrp.Selected.Caption;
         lUsrID := dm_mainform.my_q_tmp.FieldByName('Usr_ID').AsInteger;
         try
            dm_mainform.my_q_tmp2.sql.text := 'Select * from cfgxs_' + GArcTblName + ' where cfg_id = ' + IntToStr(listsid) + ' and usr_id = ' + IntToStr(lUsrID) + ' and grp_id = 0';
            dm_mainform.my_q_tmp2.Execute;
         except
            on e: exception do
               ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim berprfen eines Benutzers in ein Archiv:')+' ' + e.Message, 2015, True);
         end;
         if dm_mainform.my_q_tmp2.recordcount = 0 then
         begin
            try
               DbX('Insert into cfgxs_' + GArcTblName + ' (CFG_ID, USR_ID, Grp_ID) Values (' + IntToStr(listsid) + ', ' + IntToStr(lUsrID) + ', 0)');
            except
               on e: exception do
                  ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Hinzufgen eines Benutzers in ein Archiv:')+' ' + e.Message, 2015, True);
            end;
         end;
      end
      else ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Auslesen der USR_ID eines Benutzers'), 2014, True);
      readrights;
      readgroupsuser;
      //    GetArcRights(GArcID);
      for licount := 0 to lv_ArcMember.Items.Count - 1 do
      begin
         if lv_ArcMember.Items.Item[licount].Caption = lscaption then
         begin
            lv_ArcMember.ItemIndex := licount;
            break;
         end;
      end;

      if lv_UsrGRP_item >= lv_usrGrp.Items.Count then
      begin
         lv_usrGrp.ItemIndex := lv_usrGrp.Items.Count - 1;
      end
      else
      begin
         lv_usrGrp.ItemIndex := lv_UsrGRP_item
      end;

      readrights;
      readgroupsuser;
      btn_tablestatusClick(SENDER);
      exit;
   end;

   if (lv_UsrGrp.SelCount <> 0) and (lv_UsrGrp.Selected.ImageIndex = 2) then
   begin
      if frm_MainForm.tmpSQL('Select * from sys_grp where grp_name = ' + #39 + lv_UsrGrp.Selected.Caption + #39) then
      begin
         if dm_mainform.my_q_tmp.recordcount > 0 then
         begin
            lGrpID := dm_mainform.my_q_tmp.FieldByName('Grp_id').AsInteger;
            if frm_MainForm.tmpSQL('Select * from sys_grpusr where grp_id = ' + IntToStr(lGrpID)) then
            begin
               try
                  dm_mainform.my_q_tmp2.sql.text := 'Select * from cfgxs_' + GArcTblName + ' where cfg_id = ' + IntToStr(listsid) + '  and grp_id = ' + IntToStr(lGrpID);
                  dm_mainform.my_q_tmp2.Execute;
               except
                  on e: exception do
                     ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim berprfen eines Benutzers in ein Archiv:')+' ' + e.Message, 2015, True);
               end;
               while not dm_mainform.my_q_tmp.Eof do
               begin
                  lbfound := false;
                  dm_mainform.my_q_tmp2.first;
                  while not dm_mainform.my_q_tmp2.Eof do
                  begin
                     if dm_mainform.my_q_tmp.FieldByName('USR_ID').AsInteger = dm_mainform.my_q_tmp2.FieldByName('USR_ID').AsInteger then
                     begin
                        lbfound := true;
                     end;
                     dm_mainform.my_q_tmp2.next;
                  end;

                  if not lbfound then
                  begin
                     TmpUpdStr := TmpUpdStr + '(' + IntToStr(listsid) + ',' + IntToStr(dm_mainform.my_q_tmp.FieldByName('USR_ID').AsInteger) + ',' + IntToStr(lGrpID) + '),';
                  end;
                  dm_mainform.my_q_tmp.Next;
               end;

               //TODO:  hier wird beim hinzufgen einer Gruppe explizit ein user mit der
               // id = 0 hinzugefgt, warum ?
               dm_mainform.my_q_tmp2.first;
               while not dm_mainform.my_q_tmp2.Eof do
               begin
                  if 0 = dm_mainform.my_q_tmp2.FieldByName('USR_ID').AsInteger then
                  begin
                     lbfound := true;
                  end;
                  dm_mainform.my_q_tmp2.next;
               end;
               if not lbfound then
               begin
                  TmpUpdStr := TmpUpdStr + '(' + IntToStr(listsid) + ',0,' + IntToStr(lGrpID) + ')';
               end;
               try
                  DbX('insert into cfgxs_' + GArcTblName + ' (CFG_ID, USR_ID, Grp_ID) Values ' + TmpUpdStr);
               except
                  on e: exception do
                  begin
                     ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Hinzufgen eines Benutzers in ein Archiv:')+' ' + e.Message, 2015, True);
                     exit;
                  end;
               end;
            end
            else ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Auslesen der Benutzer einer Gruppe'), 2012, True);
         end;
      end
      else ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Auslesen der Grp_ID'), 2015, True);
      readrights;
      readgroupsuser;

      btn_tablestatusClick(SENDER);
      exit;
   end;
   btn_tablestatusClick(SENDER);
end;

//3.5.0.21 [2337]
procedure Tfrm_zusatzrights.sbtn_ArcRRemMemClick(Sender: TObject);
var lsMember, lsFeld, lsSql: string;  liImageIndex, liCfgId: integer;
begin
   if not Assigned(lv_ArcMember.Selected)
   then Exit;
   checkexistency;

   lsMember := AddQuote(lv_ArcMember.Selected.Caption);
   liImageIndex := lv_ArcMember.Selected.ImageIndex;
   lsFeld := AddQuote(lv_status.Selected.Caption);
   liCfgId := DbTableColumnGetInteger('Select * from cfg_'+GArcTblName+' where Disp_Name = ' + lsFeld);

   if (liCfgId > 0) and (lv_ArcMember.SelCount <> 0) then
   begin
      case liImageIndex of
         3 : //User
         begin
            GUsrID := DbTableColumnGetInteger('Select * from sys_usr where Usr_Name = ' + lsMember);
            if GUsrID = -1 then
               ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Auslesen der USR_ID eines Benutzers'), 2014, True)
            else
               try
                  lsSql := 'delete from cfgxs_' + GArcTblName +
                           ' where  (usr_id = ' + IntToStr(GUsrID) + ') and (Grp_ID = 0) ' +
                           ' and ( cfg_id = '+IntToStr(liCfgId)+'  )';
                  DbX(lsSql);
               except
                  on e: exception do
                     ErrorMsg('sbtn_ArcRRemMemClick', _('Fehler beim Entfernen eines Benutzers aus einem Archiv:')+' ' + e.Message, 2018, True);
               end;

            if lv_Arcmem_item >= lv_ArcMember.Items.Count then
            begin
               lv_ArcMember.ItemIndex := lv_ArcMember.Items.Count - 1;
            end
            else
            begin
               lv_ArcMember.ItemIndex := lv_ArcMem_item;
            end;
         end;

         2: //Gruppe
         begin
            GGrpID := DbTableColumnGetInteger('Select * from sys_grp where grp_name = ' + lsMember);
            if GGrpID = -1 then
               ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Auslesen der GRP_ID eines Benutzers'), 2012, True)
            else
               try
                  lsSql := 'delete from cfgxs_' + GArcTblName +
                           ' where  (Grp_ID = ' + IntToStr(GGrpID)+') ' +
                           ' and ( cfg_id = '+IntToStr(liCfgId)+'  )';
                  DbX(lsSql);
               except
                  on e: exception do
                     ErrorMsg('sbtn_ArcRRemMemClick', _('Fehler beim Entfernen einer Gruppe aus einem Archiv:')+' ' + e.Message, 2019, True);
               end;
            //    ReadArcRights(GArcID);
         end;
      end;
   end;
   readrights;
   readgroupsuser;
   btn_tablestatusClick(SENDER);
end;

procedure Tfrm_zusatzrights.lv_statusSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
   GgfLogEvntBeg('Tfrm_zusatzrights.lv_statusSelectItem begin');
   try
      try

         readrights;
         readgroupsuser;
      except
         on e: exception do
            ErrorMsg('lv_statusSelectItem', _('Fehler beim Auflisten einer Gruppe:')+' ' + e.Message, 2019, True);
      end;
      btn_tablestatusClick(Sender);
   finally
      GgfLogEvntEnd('Tfrm_zusatzrights.lv_statusSelectItem end');
   end
end;





procedure Tfrm_zusatzrights.btn_stsxsdefaultClick(Sender: TObject);
var listsid: integer;
begin
   checkexistency;
   if lv_Status.SelCount > 0 then
   begin
      listsid := integer(lv_Status.Selected.Data);
      try
         // rejoin where stsxs_id is null
         //3.5.0.36  hier kam es zur expotentiellen verdopplung von eintrgen. distinct lst das problem
         DbX('insert into cfgxs_' + GArcTblName + ' (cfg_id,usr_id, grp_id) ' +
            ' select distinct ' + inttostr(listsid) + ' , a.usr_id, a.grp_id from sys_arcxs as a left join cfgxs_' +
            GArcTblName + ' as b on (b.usr_id=a.usr_id and b.grp_id= a.grp_id) where arc_id = ' + inttostr(Garcid) +
            ' and ( find_in_set(' + #39 + 'write' + #39 + ', rights) or  find_in_set(' + #39 + 'modify' + #39 + ', rights))' +
            ' and ((cfgxs_id is null) or (cfg_id <> ' + inttostr(listsid) + ' ))');
      except
         on e: exception do
            ErrorMsg('sbtn_ArcRRemMemClick', _('Fehler beim Entfernen einer Gruppe aus einem Archiv:')+' ' + e.Message, 2019, True);
      end;
   end;
   readrights;
   readgroupsuser;
   btn_tablestatusClick(SENDER);
end;


procedure Tfrm_zusatzrights.btn_tablestatusClick(Sender: TObject);
begin
   try
      if not DbTableExist('cfgxs_' + GArcTblName) then
      begin
         label5.Caption := _('Noch keine Zusatzfeldrechte gesetzt.');
         btn_del.Enabled:=False;
         btn_ReadOnly.Enabled:=True;
      end
      else
      begin
         frm_MainForm.ArchivSQL('select * from cfgxs_' + GArcTblName );
         if  dm_mainform.my_qry_Arc.RecordCount = 0 then
          label5.Caption := _('Es sind Zusatzfeldrechte gesetzt (nur lesend).')
         else
           label5.Caption := _('Es sind Zusatzfeldrechte gesetzt.');
         btn_del.Enabled:=True;
         btn_ReadOnly.Enabled:=False;
      end;
   except on e: exception do
      begin
      end;
   end;
end;

procedure Tfrm_zusatzrights.btn_delClick(Sender: TObject);
begin

   if MessageDlg(_('Sind Sie sicher, dass Sie die Rechte lschen mchten?')
      , mtWarning, [mbYes, mbCancel], 0) = mrCancel then
      Exit;

   try
      DbX('Drop Table cfgxs_' + GArcTblName);
   except
      on e: Exception do
         ErrorMsg('btn_delClick', _('Fehler beim Lschen der cfgxs_ Archivtabelle:')+' ' + e.Message, 1004, True);
   end;
   lv_ArcMember.Items.Clear;
   readrights;
   readgroupsuser;
   btn_tablestatusClick(SENDER);
end;

procedure Tfrm_zusatzrights.Edit2KeyUp(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin

   lv_ArcMember.Items.Clear;
   if Edit2.text <> '' then
   begin
      dm_mainform.my_q_usr_selected_sz.first;
      while not dm_mainform.my_q_usr_selected_sz.eof do
      begin
         if pos(lowercase(Edit2.text),
            lowercase(dm_mainform.my_q_usr_selected_sz.fieldbyname('usr_name').AsString)) > 0
         then
         begin

            with lv_ArcMember.Items.Add do
            begin
               Caption := dm_mainform.my_q_Usr_selected_sz.FieldByName('usr_name').AsString;
               ImageIndex := 3;
            end;
         end;


         dm_mainform.my_q_usr_selected_sz.next;
      end;
      dm_mainform.my_q_grp_selected_sz.first;
      while not dm_mainform.my_q_grp_selected_sz.eof do
      begin
         if pos(lowercase(Edit2.text),
            lowercase(dm_mainform.my_q_grp_selected_sz.fieldbyname('grp_name').AsString)) > 0
         then
         begin

            with lv_ArcMember.Items.Add do
            begin
               Caption := dm_mainform.my_q_grp_selected_sz.FieldByName('grp_name').AsString;
               ImageIndex := 2;
            end;
         end;


         dm_mainform.my_q_grp_selected_sz.next;
      end;
   end
   else
   begin
      dm_mainform.my_q_usr_selected_sz.first;
      while not dm_mainform.my_q_usr_selected_sz.eof do
      begin

         with lv_ArcMember.Items.Add do
         begin
            Caption := dm_mainform.my_q_Usr_selected_sz.FieldByName('usr_name').AsString;
            ImageIndex := 3;
         end;


         dm_mainform.my_q_usr_selected_sz.next;
      end;
      dm_mainform.my_q_grp_selected_sz.first;
      while not dm_mainform.my_q_grp_selected_sz.eof do
      begin

         with lv_ArcMember.Items.Add do
         begin
            Caption := dm_mainform.my_q_grp_selected_sz.FieldByName('grp_name').AsString;
            ImageIndex := 2;
         end;


         dm_mainform.my_q_grp_selected_sz.next;
      end;
   end;
end;

procedure Tfrm_zusatzrights.Edit1KeyUp(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin

   lv_UsrGrp.Items.Clear;
   if Edit1.text <> '' then
   begin
      dm_mainform.my_q_grp_all_sz.first;
      while not dm_mainform.my_q_grp_all_sz.eof do
      begin
         if pos(lowercase(Edit1.text),
            lowercase(dm_mainform.my_q_grp_all_sz.fieldbyname('grp_name').AsString)) > 0
         then
         begin

            with lv_UsrGrp.Items.Add do
            begin
               Caption := dm_mainform.my_q_grp_all_sz.FieldByName('grp_name').AsString;
               ImageIndex := 2;
            end;
         end;


         dm_mainform.my_q_grp_all_sz.next;
      end;

      dm_mainform.my_q_usr_all_sz.first;
      while not dm_mainform.my_q_usr_all_sz.eof do
      begin
         if pos(lowercase(Edit1.text),
            lowercase(dm_mainform.my_q_usr_all_sz.fieldbyname('usr_name').AsString)) > 0
         then
         begin

            with lv_UsrGrp.Items.Add do
            begin
               Caption := dm_mainform.my_q_Usr_all_sz.FieldByName('usr_name').AsString;
               ImageIndex := 3;
            end;
         end;


         dm_mainform.my_q_usr_all_sz.next;
      end;
   end
   else
   begin
      dm_mainform.my_q_grp_all_sz.first;
      while not dm_mainform.my_q_grp_all_sz.eof do
      begin
         with lv_UsrGrp.Items.Add do
         begin
            Caption := dm_mainform.my_q_grp_all_sz.FieldByName('grp_name').AsString;
            ImageIndex := 2;
         end;
         dm_mainform.my_q_grp_all_sz.next;
      end;
      dm_mainform.my_q_usr_all_sz.first;
      while not dm_mainform.my_q_usr_all_sz.eof do
      begin
         with lv_UsrGrp.Items.Add do
         begin
            Caption := dm_mainform.my_q_Usr_all_sz.FieldByName('usr_name').AsString;
            ImageIndex := 3;
         end;
         dm_mainform.my_q_usr_all_sz.next;
      end;
   end;
end;


procedure Tfrm_zusatzrights.checkexistency;
begin
   if not DbTableExist('cfgxs_' + GArcTblName) then
   begin
      try
         DbX('CREATE TABLE `' + 'cfgxs_' + GArcTblName + '` (' +
            '`cfgxs_id` bigint(20) unsigned NOT NULL auto_increment  PRIMARY KEY,' +
            '`cfg_id` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            '`usr_id` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            '`grp_id` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 +
            ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
            'COMMENT=' + #39 + 'Rechte fr Dokumentstatussetzen eines Archives' + #39);
      except on e: exception do
         begin
         end;
      end;
   end;
end;

procedure Tfrm_zusatzrights.FormCreate(Sender: TObject);
begin
   TranslateComponent(self);
end;

procedure Tfrm_zusatzrights.btn_ReadOnlyClick(Sender: TObject);
begin
    checkexistency;
    btn_tablestatusClick(SENDER);
end;

end.
