unit u_bfaMessage;

/////////////////////////////////////////////////////////////////////////////
//
//  0706051130 showBfaMessage
//             Message 1  bitte warten Sie bis die Uebertragung beendet ist
//
//             Das Modul ist zu erweitern falls andere Meldungen ausgegeben werden sollen
// letzter Stand 0706051610
//

interface

{3.6<}
uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, RxGIF, JvExControls, JvImageTransform, JvStarfield,
   ExtCtrls, gnugettext,
   u_ShLowUtils;
{>3.6}

type
   Tfrm_ShowBfaMessage = class (TForm)
      Label1: TLabel;
      JvStarfield1: TJvStarfield;
      Image1: TImage;
      Label2: TLabel;
      Shape1: TShape;
      Shape2: TShape;
      Shape3: TShape;
      Shape4: TShape;
    procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_ShowBfaMessage: Tfrm_ShowBfaMessage;

implementation


{$R *.dfm}


procedure Tfrm_ShowBfaMessage.FormCreate(Sender: TObject);
var
   iCount, iPos: integer;
   slBind, lsPar, lsParL, lsParCom, lsParVal, lsLanguage, lsLangPath: string;
begin
   BD.LogPath := BD.EnvTemp;
   BD.LogName := 'BfaMessage<%d>.log';

   if not (directoryexists(BD.AppdataBitfarm)) then
      try
         mkDir(BD.AppdataBitfarm);
      except on e: exception do
            logevnt('formcreate ' + e.message);
      end;
   // Auswertung der Parameter (teilweise)
   BD.LogOn := false;

   lsLanguage := '';
   for iCount := 1 to ParamCount do
   begin
      lsPar := ParamStr(icount);
      lsParL := lowercase(lsPar);
      iPos := Pos(':',lsParL);
      if iPos = 0 then
         iPos := maxint-1;
      lsParCom := Copy(lsParL,1,iPos-1); // das vor dem Doppelpunkt (oder alles wenn keiner)
      lsParVal := Copy(lsParL,iPos+1,maxint); // das vor nach Doppelpunkt (oder nix wenn keiner)
      if lsParL = '-debug' then
      begin
         BD.LogOn := true;
         Continue;
      end;
      if lsParCom = '-lang' then   //z.B. "-lang:en"
      begin lsLanguage := lsParVal; Continue; end;
      if lsParCom = '-langpath' then   //z.B. "-lang:en"
         begin lsLangPath := lsParVal; Continue; end;
   end;
   GnugettextTextdomain('BfaMessage', lsLangPath, lsLanguage);
   TranslateComponent(self);
end;

end.
