unit u_MainForm;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, ExtCtrls, ComCtrls, StdCtrls, gnugettext, psIBTreeView, Buttons, IniFiles, Registry,
   Mask, JvExMask, JvToolEdit, strutils, Placemnt, JvExStdCtrls, JvCombobox,
   JvListComb, ImgList, jvstatictext, JvExControls, JvLabel, JvEdit,
   TBXDkPanels, TB2Item, TBX, TB2Dock, TB2Toolbar, Menus,
   MyAccess,
   u_ShBase, u_ShLowUtils, u_ShDm, u_ShHighUtils, u_ShDbUtils, u_ShFrameZusFldMulti,
   u_ShSql, JvExForms, JvScrollBox, u_ShStatefields, JvExExtCtrls,
  JvExtComponent, JvSpacer;


// Globale Proceduren und Funktionen
procedure ErrorMsg(ErrMod, ErrMsg: String; ErrID: Integer; LogErr: boolean);
procedure GetChilds(StartNode: TTreeNode; ChildList: TStringList);
function SetSystemVariable(const Name, Wert: String): boolean;
function GetSystemVariable(const Name: String): String;
function GenNewName: String;
function GetStringFromResource(Name: String): String;
//function StrToWords(const InputStr: string): TStringList;
function ParserSemiColonusebackspace(InputStr: string): string;

//read registry before usgin bGSavLastLgrArc
procedure ReadbGSavLastLgrArc;

type
   Tfrm_Main = class (TForm)
      stb_Main: TStatusBar;
      pnl_Input: TPanel;
      pnl_Tree: TPanel;
      pctrl_Input: TPageControl;
      tbs_IStd: TTabSheet;
      tbs_IVtx: TTabSheet;
      tbs_IZus: TTabSheet;
      memo_Vtx: TMemo;
    sbx_IZus_old: TScrollBox;
      dbtv_Main: TpsDBTreeView;
      pnl_IAbst: TPanel;
      pnl_TOpt: TPanel;
      pnl_TAbst: TPanel;
      img_Tree: TImage;
      lb_Slw: TListBox;
      edt_Slw: TEdit;
      sbtn_AddSlw: TSpeedButton;
      sbtn_DelSlw: TSpeedButton;
      lbl_ISlw: tlabel;
      pnl_IFunc: TPanel;
      chbx_ManVtx: TCheckBox;
      chbx_OCRVtx: TCheckBox;
      pnl_IVtxOpt: TPanel;
      cbx_Arc: TComboBox;
      cbx_Lgr: TComboBox;
      lbl_ILgr: tlabel;
      lbl_IArc: tlabel;
      chbx_ACol: TCheckBox;
      chbx_AHigh: TCheckBox;
      lbl_IRef: tlabel;
      Splitter1: TSplitter;
      spdbt_delref: TSpeedButton;
      spdbt_addref: TSpeedButton;
      fms_MainForm: TFormStorage;
      ImageList1: TImageList;
      Jvetitel: TJvEdit;
      jvltitel: TJvLabel;
      grpbx_wvl: TGroupBox;
      StaticText1: TLabel;
      StaticText2: TLabel;
      StaticText3: TLabel;
      StaticText4: TLabel;
      st_erinnerung: TLabel;
      JvCCB_je: TJvCheckedComboBox;
      JvCCB_efa: TJvCheckedComboBox;
      JvCCB_eb: TJvCheckedComboBox;
      jde_erinnerung: TJvDateEdit;
      Label1: TLabel;
      edt_info: TEdit;
      st_opttim: TLabel;
      jcbx_opttim: TJvCheckedComboBox;
      tbx_favwvl: TTBXToolbar;
      tbx_wvlfavbear0: TTBXItem;
      tbx_wvlfavbear1: TTBXItem;
      tbx_wvlfavbear2: TTBXItem;
      tbx_wvlfavbear3: TTBXItem;
      tbx_wvlfavbear4: TTBXItem;
      tbx_wvlfavbear5: TTBXItem;
      tbx_wvlfavbear6: TTBXItem;
      tbx_wvlfavbear7: TTBXItem;
      tbx_wvlfavbear8: TTBXItem;
      tbx_wvlfavbear9: TTBXItem;
      lb_ref: TListBox;
      Image1: TImage;
      Image2: TImage;
      pnl_colorhigh: TPanel;
      edt_ref: TEdit;
      lbl_termin: TLabel;
      jde_termin: TJvDateEdit;
      im_ref: TImage;
      im_slw: TImage;
    FormStorage1: TFormStorage;
    sbx_IZus: TJvScrollBox;
    tbbt_search: TTBXButton;
    tbxb_reset: TTBXButton;
    tbxt_PluginButtons1: TTBXToolbar;
    tbxtm1: TTBXItem;
    tbxsbmntm1: TTBXSubmenuItem;
    tbxtm2: TTBXItem;
    tbxtm3: TTBXItem;
    lbl1: TLabel;
    pnl1: TPanel;
    tbxtm5: TTBXItem;
    bfaStatefields1: bfaStatefields;
    JvSpacer1: TJvSpacer;
    btn_Arc: TBitBtn;
    btn_Reset: TBitBtn;
      //procedure sbtn_TExitClick(Sender: TObject);
      procedure sbtn_AddSlwClick(Sender: TObject);
      procedure sbtn_DelSlwClick(Sender: TObject);
      procedure lb_SlwClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure cbx_ArcChange(Sender: TObject);
      procedure cbx_LgrChange(Sender: TObject);
      procedure dbtv_MainClick(Sender: TObject);
      procedure btn_ArcClick(Sender: TObject);
      procedure btn_ResetClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormCreate(Sender: TObject);
      procedure cb_ReferenzClick(Sender: TObject);
      procedure cb_ReferenzKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
      procedure spdbt_addrefClick(Sender: TObject);
      procedure spdbt_delrefClick(Sender: TObject);
      procedure edt_SlwKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
      procedure lb_SlwKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
      procedure tbbt_searchClick(Sender: TObject);
      procedure cbx_LgrCloseUp(Sender: TObject);
      procedure cbx_ArcCloseUp(Sender: TObject);
      procedure tbxb_resetClick(Sender: TObject);
      procedure FormActivate(Sender: TObject);
      procedure loadfavwvlhints;
      procedure tbx_wvlfavbear0Click(Sender: TObject);
      procedure lb_refClick(Sender: TObject);
      procedure edt_refKeyDown(Sender: TObject; var Key: Word;
         Shift: TShiftState);
    procedure dbtv_MainAdvancedCustomDrawItem(Sender: TCustomTreeView;
      Node: TTreeNode; State: TCustomDrawState; Stage: TCustomDrawStage;
      var PaintImages, DefaultDraw: Boolean);
    procedure tbxtm1Click(Sender: TObject);
    procedure tbxtm5Click(Sender: TObject);
    procedure tbxtm4Click(Sender: TObject);
    procedure tbxtm3Click(Sender: TObject);
    procedure tbxtm2Click(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure Splitter1CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);

   private
      { Private-Deklarationen }
      ZusFldFrame:TFrameZusFldMulti;
      gsdruckpfad: string;
      figdocid: Int64;
      function SaveLgrArcStat: boolean;
      function LoadLgrArcStat: boolean;
      procedure SaveLastLgrArc;
      procedure Searchzusfield(Sender: TObject);
      procedure copygdocidclipbrd;
      procedure ZusFlsTyp0EditKeyPress(Sender: TObject; var Key: Char);
   protected
      procedure WndProc(var Msg: TMessage); override;
      procedure CreateParams(var Params: TCreateParams); override;
   public
      { Public-Deklarationen }
      fhasdocid: boolean;
      fbcpclipbrdgdocid: boolean;
      function ConnectDB(fbusefilename: boolean): boolean;
      procedure ShowPrgInfo;
      procedure ReadLgrArcTree;
      procedure ReadCbxLgr;
      procedure ReadCbxArc;
      procedure WriteJobFile;
      procedure InitScan;
      Function ReadUserName: boolean;
		function CheckValue(sField, sValue : string): string;
      function LgrArcSQL(SQLCMD: String): boolean;
      function LoadOptReg: boolean;
      function TmpSQL(SQLCMD: String): boolean;
      function CreZusFields: Integer;
      function DelZusFields: Integer;
      function ChkZusfield(bUseCheckprogram: Boolean): boolean;
      function ClrZusFields: Boolean;
      function sendviewermessage: string;
      function HandleMessages(var Msg: TMessage): Boolean;
      procedure zusfeldonchange(Sender: TObject);
      procedure auswahlfeldonchange(Sender: TObject);
      function ShellExecute_AndWait(Operation, FileName,
         Parameter, Directory: string; Show: word; bWait: boolean): longint;   //11.04.2011 b.takacs 3.5.0.16
      procedure CheckFieldinComboBox(cbx: TJvCheckedComboBox); //14.04.2011 b.takacs 3.5.0.17 [2520]

   end;

var
   frm_Main: Tfrm_Main;
   sGConnection, sGUsrName, sGTmpName, sGArcName, sIArcName, sGLgrName,
   sGDocName, sGPath, sGProfil, gsimporterplugin: String;
   iGUsrID, iGDocID, iGArcID, iGLgrID, iGZusFCount: Integer;
   bGSavLastLgrArc, runfirsttime, gbreceivedviewermessage, bGIgnoreAddfieldRights,
   gbmaskinputpanel, gbShowDocViewer, gbdebug, gbHasCFGXS: boolean;
   sBearbeiter: string = '';
   sUsr: string = '';
   // get the usr_ids maybe not necessary...
   gSLitems_eb: TStringList;
   gSLitems_je: TStringList;
   gSLitems_efa: TStringList;


   TorPflichtfeld, KeyPflichtfeld, TorlockPflichtfeld: integer;
   GbDocnamepflicht: boolean;
   comp: TComponent;         // comp wurde globalisiert.
   ZusWert, NOG_Fieldlist, Actualfieldlist: Tstringlist;
   NOG_FelderNAme: Array [0..25] of string;

   bCheckFields: boolean = true; //10.03.2011 b.takacs 3.5.0.13

   gRestoreColor : TColor;


implementation

uses u_dm_Main, u_dm_DB, u_Info, u_Optionen, u_Login, TlHelp32, spin,
   ShellAPI, JvSpin, ActiveDs_TLB, adshlp, u_ShDlgAddFields, u_ShDefs;

{$R *.dfm}

//
//  Name:
//  Parameters:
//  Description:
//  Return value:
// []  b.takacs  11.04.2011 b.takacs 3.5.0.16
//------------------------------------------------------------------------------
function Tfrm_Main.ShellExecute_AndWait(Operation, FileName,
   Parameter, Directory: string; Show: word; bWait: boolean): longint;
var
   bOK: boolean;
   Info: TShellExecuteInfo;
{
  ****** Parameters ******
  Operation:

  edit  Launches an editor and opens the document for editing.
  explore Explores the folder specified by lpFile.
  find Initiates a search starting from the specified directory.
  open Opens the file, folder specified by the lpFile parameter.
  print Prints the document file specified by lpFile.
  properties Displays the file or folder's properties.

  FileName:

  Specifies the name of the file or object on which
  ShellExecuteEx will perform the action specified by the lpVerb parameter.

  Parameter:

  String that contains the application parameters.
  The parameters must be separated by spaces.

  Directory:

  specifies the name of the working directory.
  If this member is not specified, the current directory is used as the working directory.

  Show:

  Flags that specify how an application is to be shown when it is opened.
  It can be one of the SW_ values

  bWait:

  If true, the function waits for the process to terminate
}
begin
   FillChar(Info, SizeOf(Info), Chr(0));
   Info.cbSize := SizeOf(Info);
   Info.fMask := SEE_MASK_NOCLOSEPROCESS;
   Info.lpVerb := PChar(Operation);
   Info.lpFile := PChar(FileName);
   Info.lpParameters := PChar(Parameter);
   Info.lpDirectory := PChar(Directory);
   Info.nShow := Show;
   bOK := boolean(ShellExecuteEx(@Info));
   if bOK then
   begin
      if bWait then
      begin
         while
            WaitForSingleObject(Info.hProcess, 100) = WAIT_TIMEOUT do
            Application.ProcessMessages;
         bOK := GetExitCodeProcess(Info.hProcess, DWORD(Result));
      end
      else
         Result := 0;
   end;
   if not bOK then
      Result := -1;
end;
//
                          
{3.6<}
function ParserSemiColonusebackspace(InputStr: string): string;
begin
   Result := StringReplace(InputStr, ';', '', [rfReplaceAll]);
   Result := StringReplace(Result, '' + #39 + '', '\' + #39, [rfReplaceAll]);
end;

function IsExeRunning(const AExeName: string): boolean;
var
   h: THandle;
   p: TProcessEntry32;
begin
   p.dwSize := SizeOf(p);
   h := CreateToolHelp32Snapshot(TH32CS_SnapProcess, 0);
   try
      Process32First(h, p);
      repeat
         Result := AnsiUpperCase(AExeName) = AnsiUpperCase(p.szExeFile);
      until Result or (not Process32Next(h, p));
   finally
      CloseHandle(h);
   end;
end;


//function StrToWords(const InputStr: string): TStringList;
//   /////////////////////////////////////////////////////////////////////////////////////////////////////////////
//   ///  30.09.2006 modifiziert by NG.
//   ///
//   ///  Diese Function zerlegt einen String in einzelne Worte
//   ///  bzw Phrasen und listet diese in einer Stringlist auf.
//   ///                                                                                                                        //
//   ///  Parameter: InputStr        String mit Suchbegriffen
//   ///
//   ///  Ausgabe: StringList mit einzelnen Worten und Phrasen
//   ///
//   /////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//const
//   sTrennZeichen = ' .,!?';
//var
//   iCount, iWortStart, iWortEnde: integer;
//   bPhrase: boolean;
//   sOP, sWort, slStr: string;
//begin
//   Result := TStringList.Create;
//   Result.Clear;
//   iWortStart := 0;
//   iWortEnde := 0;
//   iCount := 0;
//   bPhrase := False;
//   sOP := '';
//   // trim the input!
//   slStr := trim(InputStr);
//   while iCount <= Length(slStr) do
//   begin
//      if IsDelimiter('"', slStr, iCount) then
//      begin
//         if not bPhrase then
//         begin
//            bPhrase := True;
//            iWortStart := iCount + 1;
//            if IsDelimiter('+-*', slStr, iCount - 1) then
//               sOp := slStr[iCount - 1]
//            else
//               sOp := '';
//         end
//         else
//            bPhrase := False;
//      end;
//      if IsDelimiter(sTrennZeichen, slStr, iCount) and not bPhrase then
//      begin
//         if iWortStart <= iWortEnde then
//         begin
//            iWortEnde := iCount;
//            sWort := Trim(StringReplace(Copy(slStr, iWortStart,
//               iWortEnde - iWortStart), '"', '', [rfReplaceAll]));
//            if ((Length(trim(sWort)) >= 1) and (not IsDelimiter('+-*', sWort, 1) or
//               (Length(trim(sWort)) > 1))) then
//               Result.Add(sOP + sWort);
//            iWortStart := iWortEnde + 1;
//         end;
//      end;
//      iWortEnde := iCount;
//      Inc(iCount);
//   end;
//   if iWortStart <= iWortEnde then
//      Result.Add(sOP + Trim(StringReplace(Copy(slStr, iWortStart, 1 +
//         iWortEnde - iWortStart), '"', '', [rfReplaceAll])));
//end;


procedure ErrorMsg(ErrMod, ErrMsg: String; ErrID: Integer; LogErr: boolean);
//////////////////////////////////////////////////////////////////
///  10.04.2005 Erstellt ErrorMsg by SV.                       ///
///                                                            ///
///  Diese Procedure blendet ein Meldungsfenster mit der       ///
///  Fehlermeldung ErrMsg von Modul ErrMod und Fehler ID       ///
///  ErrID ein. Optional kann dieser Event auch mit LogErr     ///
///  in einer Datei geloggt werden (LogEvnt)                   ///
///                                                            ///
//////////////////////////////////////////////////////////////////
begin
   MessageDlg('Fehler in Modul: ' + ErrMod + #13 + 'Fehlercode: ' + IntToStr(ErrID) + #13 + #13 +
      ErrMsg, mtError, [mbOk], 0);
   if LogErr then
      LogEvnt(IntToStr(ErrID) + '    ' + 'Fehler in Modul: ' + ErrMod + '    ' + ErrMsg);
end;

function GetStringFromResource(Name: String): String;
   //////////////////////////////////////////////////////////////////
   ///  02.05.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion liest die Kompilierte Resource in 'Name'   ///
   ///  aus und liefert ihren Inhalt als Delphi String            ///
   ///                                                            ///
   ///  Ausgabe: String                                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
begin
   with TResourceStream.Create(HInstance, Name, RT_RCDATA) do
      try
         SetLength(Result, Size);
         Read(Result[1], Size);
      finally
         Free;
      end;
end;

procedure GetChilds(StartNode: TTreeNode; ChildList: TStringList);
//////////////////////////////////////////////////////////////////
///  03.05.2005 Erstellt by SV.                                ///
///                                                            ///
///  Diese Procedur wertet alle Unterknoten von StartNode aus  ///
///  Und liefert das Ergebnis an eine Stringliste              ///
///                                                            ///
///  Ausgabe: 'ArcName'.Object(ArcID) in ChildList             ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var SubNode: TTreeNode;
begin
   SubNode := StartNode.getFirstChild;
   while Assigned(SubNode) do
   begin
      GetChilds(SubNode, ChildList);
      if SubNode.ImageIndex = 1 then
         ChildList.AddObject(SubNode.Text, TObject(SubNode.Data));
      SubNode := SubNode.getNextSibling;
   end;
end;

function SetSystemVariable(const Name, Wert: String): boolean;
   /////////////////////////////////////////////////////////////
   ///   Erstellt 06.06.2005 by SV                           ///
   ///                                                       ///
   ///   Setzt eine Systemvariable auf einen neuen Wert      ///
   ///                                                       ///
   ///   Parameter:  Name          Name der Systemvariable   ///
   ///               Wert          Wert der Systemvariable   ///
   ///                                                       ///
   ///   Rckgabe:   True          bei Erfolg                ///
   ///               False         bei Fehlschlag            ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
begin
   result := SetEnvironmentVariable(PChar(Name), PChar(Wert));
end;

function GetSystemVariable(const Name: String): String;
   /////////////////////////////////////////////////////////////
   ///   Erstellt 06.06.2005 by SV                           ///
   ///                                                       ///
   ///   Liest eine Systemvariable aus                       ///
   ///                                                       ///
   ///   Parameter:  Name          Name der Systemvariable   ///
   ///                                                       ///
   ///   Rckgabe:   String mit Wert der Systemvariable      ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
begin
   SetLength(Result, 255);
   SetLength(Result, GetEnvironmentVariable(PChar(Name), PChar(Result), 255));
end;

function GenNewName: String;
   /////////////////////////////////////////////////////////////
   ///   Erstellt 07.06.2005 by SV                           ///
   ///                                                       ///
   ///   Erzeugt einen String mit dem aktuellen Datum und    ///
   ///   der aktuellen Uhrzeit                               ///
   ///                                                       ///
   ///   Parameter:  keine                                   ///
   ///                                                       ///
   ///   Rckgabe:   String mit Datum + Uhrzeit              ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
begin
   DateTimeToString(result, 'ddmmyyyyhhnnss', now);
   result := result + inttostr(Random(99999));
end;
{>3.6}

function Tfrm_Main.SaveLgrArcStat: boolean;
   //////////////////////////////////////////////////////////////////
   ///  06.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion sichert den optischen Aufbau des Lager    ///
   ///  und Archiv Baumes in der Registrierung.                   ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var iCount, iID: Integer;
   reg: TRegistry;
begin
   result := True;
   reg := TRegistry.Create;
   try
      try
         reg.RootKey := HKEY_CURRENT_USER;
         reg.OpenKey('Software\bitfarm\Archiv_V3\Importer\LgrArcTree', True);
         for iCount := 0 to dbtv_Main.Items.Count - 1 do
         begin
            iID := Integer(dbtv_Main.Items.Item[iCount].Data);
            reg.WriteBool(IntToStr(iID), dbtv_Main.Items.Item[iCount].Expanded);
         end;
         reg.CloseKey;
      except
         on e: exception do
         begin
            result := False;
            ErrorMsg('SaveLgrArcStat', 'Fehler beim Speichern des Treestatus: ' + e.Message, 2038, True);
         end;
      end;
   finally
      FreeAndNil(reg);
   end;
end;

function Tfrm_Main.LoadLgrArcStat: boolean;
   //////////////////////////////////////////////////////////////////
   ///  06.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion liest den optischen Aufbau des Lager und   ///
   ///  Archiv Baumes aus der Registrierung.                      ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var iCount, iID: Integer;
   reg: TRegistry;
   lbdelete: boolean;
begin
   result := True;
   reg := TRegistry.Create;
   try
      try
      	with reg do
         begin
            reg.RootKey := HKEY_CURRENT_USER;
            reg.OpenKey('Software\bitfarm\Archiv_V3\Importer\LgrArcTree', True);
            dbtv_Main.Enabled := False;

            iCount := 0;
            while iCount <= dbtv_Main.Items.Count - 1 do
            begin
               if (dbtv_Main.Items.Item[iCount].ImageIndex = 2) or
                  (dbtv_Main.Items.Item[iCount].ImageIndex = 0) then
               begin
                  if (not dbtv_Main.Items.Item[iCount].HasChildren) then
                  begin
                  	dbtv_Main.Items.Item[iCount].delete;
                     if iCount > 0 then
                      Dec(iCount);
                  end
                  else
                  	inc(iCount);
               end
               else
               	inc(iCount);
            end;

            iCount := 0;
            for icount := 0 to dbtv_Main.Items.Count - 1 do
            begin
               iID := integer(dbtv_Main.Items.Item[iCount].Data);
               // check first if value exists
               if ValueExists(IntToStr(iID)) then
               begin
                  // Korrektur des zuckenden Treestatus
                  if ReadBool(IntToStr(iID)) then
                     dbtv_Main.Items.Item[iCount].Expand(False)
                  else
                     dbtv_Main.Items.Item[iCount].Collapse(False);
               end;
            end;

            dbtv_Main.Enabled := True;
            reg.CloseKey;
         end;

      except
         on e: exception do
         begin
            result := False;
            //ErrorMsg('LoadLgrArcStat', 'Fehler beim Laden des Treestatus: ' + e.Message, 2038, True);
         end;
      end;
   finally
      FreeAndNil(reg);
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfrm_Main.WriteJobFile;
var
   ini: TIniFile; slReferenzen:TStringlist;
   iCount, jcount, licounter, litimeroptionen: Integer;
   sFeld, sName, sWert, sActualfield: String;
   comp1: TComponent; //#3.5
   lbZusVerkn: boolean;
begin
   slReferenzen:=TStringlist.Create;
   try
      slReferenzen.Assign(lb_ref.Items);
      figdocid := 0;
      if fhasdocid then
      begin
         try
            dm_db.my_cmd.sql.text := 'insert into sys_gdocid () values ()';
            dm_db.my_cmd.execute;
            figdocid := dm_db.my_cmd.InsertId;
         except on e: exception do
            begin
            end;
         end;
      end;

      ini := TIniFile.Create(sGPath + sGDocName + '.JOB');
      try
         try
          	with ini do
            begin
               WriteString('Version', 'Version', '3.0');
               WriteString('Archiv', 'Profil', sGProfil);
               WriteString('Archiv', 'Name', cbx_Arc.Text);
               WriteString('Archiv', 'Tabelle', sIArcName);
               WriteString('Document', 'DOCID', '');
               if fhasdocid then
                	WriteInteger('Document', 'gdoc_id', figdocid);

               WriteString('Document', 'Titel', jvetitel.Text);
               WriteString('Document', 'Orginal', '');
               WriteString('Document', 'Kopie', '');
               WriteString('Document', 'Quelle', '');
               if sGUsrName = '' then
                	sGUsrName := GetSystemVariable('username');

               if sGUsrName = '' then
                	sGUsrName := 'unbekannt';

               WriteString('Document', 'Benutzer', sGUsrName);
               WriteString('Document', 'Volltext', '');
               WriteString('Document', 'Status', IntToStr(bfaStatefields1.State));
               WriteString('Document', 'StatStr', '');
               WriteString('Document', 'OCR_QF', '');
               if chbx_OCRVtx.Checked then
		           	WriteString('Document', 'OCR_Typ', 'OMP')
               else
               	WriteString('Document', 'OCR_Typ', 'TXT');
               WriteString('Document', 'Schlagworte', '');
               WriteString('Document', 'Datum', '');
               sWert := '';
               if chbx_ACol.Checked then
                	sWert := sWert + 'Color';
               if chbx_AHigh.Checked then
                	sWert := sWert + 'Highres';
               WriteString('Document', 'Filter', sWert);

               if sUsr <> '' then
               begin
                   WriteString('Tasks', 'Termin', DateToStr(jde_termin.date));
                   WriteString('Tasks', 'Alarm', DateToStr(jde_erinnerung.Date));
                   WriteString('Tasks', 'Bearbeiter', sUsr);
               end
               else
               begin
                WriteString('Tasks', 'Termin', '');
                WriteString('Tasks', 'Alarm', '');
                WriteString('Tasks', 'Bearbeiter', sUsr);
               end;

               if (edt_info.text = '') then
                	WriteString('Tasks', 'Notiz', cbx_Arc.Text)
               else
                	WriteString('Tasks', 'Notiz', trim(edt_info.text));

               litimeroptionen := 0;
               // first bit is reserved to je or efa! 
               for licounter := 0 to jcbx_opttim.Items.Count - 1 do
               begin
                  if jcbx_opttim.IsChecked(licounter) then
                  begin
                      litimeroptionen := litimeroptionen or (1 shl (licounter + 1));
                  end;
               end;
               WriteInteger('Tasks', 'TimerOptionen', litimeroptionen);
               WriteInteger('Zusatzfelder', 'Felder', iGZusFCount);
               for iCount := 0 to iGZusFCount - 1 do
               begin
                  with sbx_IZus.FindComponent('zlbl_Tmp' + IntToStr(iCount)) as tjvstatictext do
                  begin
                     sFeld := Hint;  //z.B.: 'add_15092005160955'
                     sActualfield:=Actualfieldlist.Strings[iCount]; //z.B.: 'Steuernummer (V):'
                     sName := copy(sActualfield, 1, Length(sActualfield) - 1); // Doppelpunkt hinten weg
                  end;
                  sWert := '';
                  comp := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmp' + IntToStr(iCount));
                  if comp is TEdit then
                  begin
                     if TEdit(Comp).Color <> cColorNoRightInit then
                      	sWert := TEdit(Comp).Text;
                  end;
                  if comp is TJvDateEdit then
                  begin
                     if TJvDateEdit(Comp).Color <> cColorNoRightInit then
                     	sWert := TJvDateEdit(comp).Text;
                  end;
                  if comp is TComboBox then
                  begin
                     if TComboBox(Comp).Color <> cColorNoRightInit then
                     begin
                     	sWert := TComboBox(comp).Text;
                        if Trim(sWert) <> '' then
                           sWert := CheckValue(sFeld,sWert);
                     end;
                  end;

                  if comp is TjvcheckedComboBox then
                  begin
                     if TjvcheckedComboBox(Comp).Color <> cColorNoRightInit then
                     	sWert := TjvcheckedComboBox(comp).Text;
                  end;
                  if comp is Tspinedit then
                  begin
                     if Tspinedit(comp).Color <> cColorNoRightInit then
                     begin
                        sWert := Tspinedit(comp).Text;
                        comp1 := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmp_cbx_' + IntToStr(iCount));
                        if comp1 <> nil then
                        begin
                     		if TComboBox(comp1).Text <> '' then
	                        	sWert := sWert + TComboBox(comp1).Text
                           else
                              sWert := '';
                        end
                        else
                        	sWert := '';

                     end;
                  end;
                  if comp is Tjvspinedit then
                  begin
                     if Tspinedit(comp).Color <> cColorNoRightInit then
                     	sWert := Tjvspinedit(comp).Text;
                  end;

                  // parsen von unbrauchbaren EIntrgen fr die Job-Date als da wren:
                  // 0 bzw 0,00 und 0,0000000 fr Dezimalfelder und ' . . ' fr Datum
                  // f.schneider  [2588]

                  if sWert = '0' then sWert := '';
                  if sWert = '0,00' then sWert := '';
                  if sWert = '0,0000000000' then sWert := '';
                  if sWert = '  .  .    ' then sWert := '';
                  if sWert = '01.01.1900' then sWert := '';
                  if sWert = '0T' then sWert := '';
                  if sWert = '0M' then sWert := '';
                  if sWert = '0J' then sWert := '';

                  sWert := ParseAddfields(sWert);
                  WriteString('Zusatzfelder', 'ZusTitel' + IntToStr(iCount + 1), sName);
                  WriteString('Zusatzfelder', 'ZusFeld' + IntToStr(iCount + 1), sFeld);
                  WriteString('Zusatzfelder', 'ZusWert' + IntToStr(iCount + 1), sWert);
                  lbZusVerkn:=PruefeObVerknuepfungAnlegen(sIArcName, sFeld);
                  if lbZusVerkn then
                  begin
                   //VerknuepfenAnhandZusatzfelder
                   ZusatzfelderAuftrennen(sWert,slReferenzen);
                  end;
               end;

               WriteString('Referenz', 'Anzahl', inttostr(slReferenzen.Count));
               if slReferenzen.Count <> 0 then
               begin
                  for jCount := 0 to slReferenzen.Count - 1 do
                  begin
                   WriteString('Referenz', 'Referenz' + inttostr(jCount + 1), slReferenzen[jcount]);
                  end;
               end;

            end;
         except
         	on e: exception do
            	ErrorMsg('btn_CreJob', 'Fehler beim Erstellen der Vorlagen Datei: ' + e.Message, 2023, True);
         end;
         if fbcpclipbrdgdocid then
         begin
          	copygdocidclipbrd;
         end;
      finally
         if Assigned(ini) then
         begin
	         ini.UpdateFile;
          	FreeAndNil(ini);
         end;
		end;
   finally
    slReferenzen.Free;
   end;
end;

function  Tfrm_Main.CheckValue(sField, sValue : string): string;
begin
    Result := sValue;
(*    // wenn das Feld wirklich vom Typ Auswahlfeld ist, dann prfe den Inhalt
    dm_DB.my_q_tmp_2.SQL.Text := 'Select * from cfg_' + sIArcName
    		+ ' where Feld_Name = ' +#39+ sField +#39+ ' and Typ = 2';
    dm_DB.my_q_tmp_2.Execute;

    if dm_DB.my_q_tmp_2.RecordCount = 0 then    //  ansonsten prfe nicht
    begin                                       // (da wir ber die Verschlagwortzungssuche hierher geraten sind)
    	Result := sValue;
      exit;
    end;

    // wenn wir keinen strictmode haben ist auch alles okay
    if (dm_DB.my_q_tmp_2.FieldByName('Optionen').AsInteger and cZusatzFeldOptStrict) = 0 then
    begin
    	Result := sValue;
      exit;
    end;

    dm_DB.my_q_tmp_2.SQL.Text := 'Select * from cfg_' + sIArcName
    		+ ' where Feld_Name = ' +#39+ sField +#39+ ' and Werte like '+#39+'%'+ sValue +'%'+#39;
    dm_DB.my_q_tmp_2.Execute;

    if dm_DB.my_q_tmp_2.RecordCount > 0 then
    begin
    	Result := sValue
    end
    else
    begin
    	Result := '';
      BfShowMessage(_('Hinweis!') + #13 + _('Ein Auswahlfeld hat ein ungltigen Wert.')
      + #13 + _('Der Wert wird nicht gespeichert.'));

    end;
*)
end;

Function Tfrm_Main.ReadUserName: boolean;
var
   ini: TIniFile;
   lsuser, slpass, slprofil, ng_user, lsappdata,lsredmonuser: string;
   lbauth, lbmslog, lbusepass: boolean;
   reg: TRegistry;
   liwaiting: integer;
   lADSystemInfo: TADSystemInfo;
   l_aUser: IADsUser;

begin
   if gbdebug then
      LogEvnt('Tfrm_Main.ReadUserName');

   result := false;
   lbauth := false;
   liwaiting := 0;
   lbmslog := false;
   lbusepass := true;

   //  bei win7 wird appdata des systemusers ausgewertet, daher wird der pfad umgebogen
   //  f.schneider [2583]
   lsappdata:= GetSystemVariable('APPDATA');
   lsredmonuser:= GetSystemVariable('REDMON_USER');
   If (Pos('system32',lsappdata) > 0) And (lsredmonuser <> '') then
      lsappdata:='c:\users\'+lsredmonuser+'\AppData\Roaming\bitfarm-archiv\mylogin.ini'
   else
      lsappdata:=lsappdata + '\bitfarm-archiv\mylogin.ini';

   if gbdebug then
      LogEvnt('lsappdata:' + lsappdata);
   if IsExeRunning('ViewerV3.exe') then
   begin
      gbreceivedviewermessage := false;
      sendviewermessage;
      while (not gbreceivedviewermessage) and
         (liwaiting < 100) do
      begin
         application.ProcessMessages;
         sleep(50);
         inc(liwaiting);
      end;
      if liwaiting = 100 then
      begin
         exit;
      end;
      ng_user := sGusrname;
      ini := TIniFile.Create(Pchar(lsappdata));
      if fileexists(lsappdata) then
      begin
         slprofil := ini.readstring('User', 'Profil', '');
      end;
      if (slprofil <> sGProfil) and (slprofil <> '') then
      begin
         sGProfil := slprofil;
         if not ConnectDB(false) then
         begin
            exit;
         end;
      end;
      if ng_user <> '' then
      begin
         lsuser := sGusrname;
         lbauth := true;
      end;
      if gbdebug then
      	LogEvnt('IsExeRunning:' + sGusrname);
   end
   else
   begin

      reg := TRegistry.Create;
      with reg do
      begin
         RootKey := HKEY_CURRENT_USER;
         OpenKey('\Software\bitfarm\Archiv_V3\Viewer\Login', True);
         if ValueExists('Conn') then
         begin
            slprofil := ReadString('Conn');
         end;
         OpenKey('\Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
         if ValueExists('mslogon') then
         begin
            lbmslog := ReadBool('mslogon');
         end;
         closekey;
      end;
      if assigned(reg) then
         freeandnil(reg);

      if gbdebug then
      	LogEvnt('Profil aus Registry:' + slprofil + ' mslogon:' + BoolToStr(lbmslog));

      if (slprofil <> sGProfil) and (slprofil <> '') then
      begin
         sGProfil := slprofil;

         if not ConnectDB(false) then
         begin
            if gbdebug then
            	LogEvnt('not ConnectDB');
            exit;
         end;
      end;

      if lbmslog then
      begin
         lADSystemInfo := TADSystemInfo.Create(Self);
         if lADSystemInfo <> nil then
         begin
            if SUCCEEDED(ADsGetObject('LDAP://' + lADSystemInfo.UserName,
               IADsUser, l_aUser)) then
            begin
               lsuser := l_aUser.Get('sAMAccountName');
               lbusepass := false;
            end;
         end;
      end
      else
      begin
         ini := TIniFile.Create(Pchar(lsappdata));
         if fileexists(lsappdata) then
         begin
            slprofil := ini.readstring('User', 'Profil', '');
            if slprofil <> sGProfil then
            begin
               sGProfil := slprofil;
               if not ConnectDB(false) then
               begin
                  exit;
               end;
            end;
            if ini.ValueExists('User', 'UserName') then
            begin
               lsuser := ini.ReadString('User', 'UserName', '');
               if lsuser = '' then
               begin
                  exit;
               end;
            end;
            if ini.ValueExists('User', 'SavePass') then
            begin
               bgSavePass := ini.ReadBool('User', 'SavePass', true);
            end
            else
            begin
               bgSavePass := true;
            end;

            if (ini.ValueExists('User', 'Password') and bgSavePass) then
            begin
               slpass := ini.ReadString('User', 'Password', '');
            end;
         end;
      end;
   end;
   if gbdebug then
      logevnt('Appdata:' + ini.FileName + ' User:' + lsuser);

   // edt_Pass.Text :=XOR_encryption(slpass);
   //I prefer mine encription but we want standize.
   //              slpass;
   if TmpSQL('select * from sys_usr where Usr_Name = ' + #34 + lsuser + #34) then
   begin
      with dm_DB.my_q_Tmp do
      begin
         if RecordCount <> 0 then
         begin

            if gbdebug then
            begin
               logevnt('slpass ' + lsuser + '; lbauth ' + booltostr(lbauth) + ' rcc ' + inttostr(dm_DB.my_q_Tmp.recordcount) +
                  ' usr_id ' + FieldByName('usr_id').AsString + ' ' + inttostr(length(FieldByName('usr_pass').AsString))
                  + inttostr(length(slpass)));
            end;
            if lbusepass then
            begin
               if (slpass <> FieldByName('usr_pass').AsString) and (not lbauth) then
               begin
                  exit;
               end;
            end;
            iGUsrID := FieldByName('usr_id').AsInteger;
            sGUsrName := FieldByName('usr_name').AsString;
            result := true;
         end;
      end;
   end;
   stb_main.panels[1].Text := sGUsrName;
end;


procedure Tfrm_Main.ReadLgrArcTree;
//////////////////////////////////////////////////////////////////
///  02.05.2005 Erstellt ReadLgrArcTree by SV.                 ///
///                                                            ///
///  Diese Procedure liest alle Lager und Archive aus der      ///
///  Tabelle sys_arc.                                          ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var iCount: Integer;
begin
   // if LgrArcSQL('SELECT * FROM sys_arc order by type, arc_name') then
   if LgrArcSQL('Select Sql_No_cache * FROM sys_arc left join sys_arcxs using(arc_id) where usr_id = '
      + IntToStr(iGUsrID) +
      ' or Type = 0 group by sys_arc.Arc_id order by Type, arc_Name, sys_arc.Arc_id') then
   begin
      dbtv_Main.AutoExpand := False;
      for iCount := 0 to (dbtv_Main.Items.Count - 1) do
         dbtv_Main.Items.Item[iCount].SelectedIndex := dbtv_Main.Items.Item[iCount].ImageIndex + 2;
      dbtv_Main.FullCollapse;
   end;
end;

function Tfrm_Main.LgrArcSQL(SQLCMD: String): boolean;
   //////////////////////////////////////////////////////////////////
   ///  17.06.2005 Erstellt von SV.                               ///
   ///                                                            ///
   ///  bergibt SQL Komandos an die MyDAC Komponenten und setzt  ///
   ///  den Cursor auf den ersten Datensatz                       ///
   ///                                                            ///
   ///  Parameter: SQLCMD        String mit SQL-Anweisung         ///
   ///                                                            ///
   ///  Ausgabe:   True          Bei Erfolg                       ///
   ///             False         Bei Fehlschlag                   ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
begin
   try
      with dm_db.my_q_LgrArc do
      begin
         Close;
         SQL.Text := SQLCMD;
         Open;
         First;
         result := True;
      end;
   except
      on e: Exception do
      begin
         LogEvnt('1000    Fehler in Modul: LgrArcSQL    ' + e.message);
         result := false;
      end;
   end;
end;

function Tfrm_Main.TmpSQL(SQLCMD: String): boolean;
   //////////////////////////////////////////////////////////////////
   ///  17.06.2005 Erstellt von SV.                               ///
   ///                                                            ///
   ///  bergibt SQL Komandos an die MyDAC Komponenten und setzt  ///
   ///  den Cursor auf den ersten Datensatz                       ///
   ///                                                            ///
   ///  Parameter: SQLCMD        String mit SQL-Anweisung         ///
   ///                                                            ///
   ///  Ausgabe:   True          Bei Erfolg                       ///
   ///             False         Bei Fehlschlag                   ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
begin
   try
      with dm_db.my_q_Tmp do
      begin
         Close;
         SQL.Text := SQLCMD;
         Open;
         First;
         result := True;
      end;
   except
      on e: Exception do
      begin
         LogEvnt('1000    Fehler in Modul: TmpSQL    ' + e.message);
         result := false;
      end;
   end;
end;

procedure Tfrm_Main.InitScan;
begin
   frm_Opt.CheckOptReg;
   sGPath := GetSystemVariable('Temp') + '\';// Importer\';
   if not (directoryexists(sGPath)) then
   begin
      mkDir(sGPath);
   end;
   sGDocName := GenNewName;
   ReadLgrArcTree;
   ReadCbxLgr;
   ReadCbxArc;
   LoadOptReg;
   if gbmaskinputpanel then
   begin
      pnl_input.Visible := false;
   end;
end;

function Tfrm_Main.LoadOptReg: boolean;
var reg, reg2: TRegistry;
begin
   result := True;
   reg := TRegistry.Create;
   reg2 := TRegistry.Create;
   with reg do
   begin
      try
         try
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Importer\Options', True);
            chbx_ManVtx.Checked := ReadBool('ManVtx');
            chbx_OcrVtx.Checked := ReadBool('ManOcrVtx');
            chbx_ACol.Checked := ReadBool('Color');
            chbx_AHigh.Checked := ReadBool('HighRes');
            if valueexists('ShowDocViewer') then
               gbShowDocViewer := ReadBool('ShowDocViewer')
            else
               gbShowDocViewer := false;
            if ValueExists('cpclipbrdgdocid') then
               fbcpclipbrdgdocid := ReadBool('cpclipbrdgdocid')
            else
               fbcpclipbrdgdocid := false;
            if valueexists('SavLastLgrArc') then
               gbmaskinputpanel := ReadBool('Maskinputpanel')
            else
               gbmaskinputpanel := false;
            if valueexists('SavLastLgrArc') then
               bGSavLastLgrArc := ReadBool('SavLastLgrArc')
            else
               bGSavLastLgrArc := true;
            //new style
             if ValueExists('StdLgr') then
            begin
               cbx_Lgr.ItemIndex := cbx_Lgr.Items.IndexOfObject(TObject(ReadInteger('StdLgr')));
               cbx_Lgr.OnChange(cbx_Lgr);
            end;
            if ValueExists('StdArc') then
            begin
               cbx_arc.ItemIndex := cbx_arc.Items.IndexOfObject(TObject(ReadInteger('StdArc')));
               cbx_arc.OnChange(cbx_arc);
            end;
            // click on the application so it select the right archiv on the second click
            dbtv_Main.Select(dbtv_Main.GetNodeID(iGLgrID), []);
            dbtv_Main.Select(dbtv_Main.GetNodeID(iGArcID), []);
            dbtv_Main.OnClick(self);
///////////////// 24.05.2011 b.takacs 3.5.1.2 -->
            try
              reg2.RootKey := HKEY_CURRENT_USER;
              reg2.OpenKey('Software\bitfarm\Archiv_V3\Importer\LgrArcTree', True);
              reg2.WriteBool(IntToStr(iGLgrID),true);
              reg2.WriteBool(IntToStr(iGArcID),true);
            finally
              reg2.Free;
            end;
///////////////// 24.05.2011 b.takacs 3.5.1.2 <--

         except
            result := False;
         end;
      finally
         If Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;

procedure Tfrm_Main.SaveLastLgrArc;
var reg: TRegistry;
begin
   reg := TRegistry.Create;
   with reg do
   begin
      try
         RootKey := HKEY_CURRENT_USER;
         OpenKey('Software\bitfarm\Archiv_V3\Importer\Options', True);
         WriteInteger('StdLgr', iGLgrID);
         WriteInteger('StdArc', iGArcID);
      finally
         If Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;

procedure Tfrm_Main.ReadCbxLgr;
begin
   if TmpSQL('select arc_id, arc_Name from sys_arc where type = 0 order by arc_name') then
   begin
      try
         cbx_Lgr.Items.Clear;
         with dm_DB.my_q_Tmp do
            while not Eof do
            begin
               cbx_Lgr.Items.AddObject(FieldByName('arc_name').AsString, TObject(FieldByName('Arc_ID').AsInteger));
               Next;
            end;
      except
         on e: exception do
            ErrorMsg('ReadCbxLgr', 'Fehler beim Auslesen der LagerOrte: ' + e.Message, 2001, True);
      end;
   end
   else ErrorMsg('ReadCbxLgr', 'Fehler bei Select Anweisung!', 2002, True);
   dm_DB.my_q_Tmp.Close;
   cbx_Lgr.ItemIndex := 0;
   cbx_LgrChange(self);
end;

procedure Tfrm_Main.ReadCbxArc;
begin
   if TmpSQL('select sys_arc.Arc_ID, Arc_Name from sys_arc  left join sys_arcxs ' +
      'using(arc_id) where usr_id = '
      + IntToStr(iGUsrID) + ' and lgr_id = ' + IntToStr(iGLgrID) + ' and Type = 1 group by sys_arc.arc_id order by arc_name') then
   begin
      try
         cbx_Arc.Items.Clear;
         cbx_Arc.Items.Add('Bitte Archiv whlen...');
         with dm_DB.my_q_Tmp do
            while not Eof do
            begin
               cbx_Arc.Items.AddObject(FieldByName('arc_name').AsString, TObject(FieldByName('Arc_ID').AsInteger));
               Next;
            end;
      except
         on e: exception do
            ErrorMsg('ReadCbxArc', 'Fehler beim Auslesen der LagerOrte: ' + e.Message, 2001, True);
      end;
   end
   else ErrorMsg('ReadCbxArc', 'Fehler bei Select Anweisung!', 2002, True);
   dm_DB.my_q_Tmp.Close;
   cbx_Arc.ItemIndex := 0;
   cbx_ArcChange(self);
end;


function Tfrm_Main.CreZusFields: Integer;
   /////////////////////////////////////////////////////////////
   ///  03.05.2005   Erstellt von SV                         ///
   ///  12.12.2005   nderung auf mehrere Feld Typen (SV)    ///
   ///                                                       ///
   ///  Diese Funktion liest aus der Tabelle cfg_[xxxxxx]    ///
   ///  die Zusatzfelder aus und erstellt dynamisch neue     ///
   ///  Label und Edit Komponenten

   ///  Zusatz felder erzeugen auf frm_Mainform              ///
   ///                                                       ///
   ///  Ausgabe: Anzahl der erstellten Komponentenstze      ///
   ///           (1x Edit und 1x Label)                      ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
var
   edt: array of TEdit;
   
   lbl: array of tjvstatictext;
   cbx: array of TComboBox;
   dat: array of TJvDateEdit;
   chx: array of Tcheckbox;
   tbxb: array of TTBXButton;
   ccb: array of TcheckBox;
   spe: array of TSpinEdit;
   lfbit: array of TTBXButton;
   jccb: array of TjvcheckedComboBox;
   lganzzahl: array of TJvSpinEdit;
   ldouble: array of TjvSpinEdit;

   iC, iEdt, iCbx, iDat, iTyp, iCntEdt,
   iCntCbx, iCntCCbx, iCntLbl, iCntDat, iCntChx, liindex,
   iCnttbxb, licount2, icntccb, iCntSpi, iCntbxb, litaborder,
   iCntganzzahl, iCntdouble, liscroll, litop: Integer;
   StrFName, lswert, sAdd, lsDispName: string;
   lfont: tfont;
   lstlw: tstringlist;
   reg: Tregistry;
   lbrechte, lbfound: boolean;
   ZusFldFrame:TFrameZusFldMulti;
   lTyp: eAddFieldType;
   sbxWidth: integer;

   s1, s2: string;
   x: integer;

begin
   if gbdebug then
   begin
      LogEvnt('Tfrm_Main.CreZusFields');
   end;

   litaborder := 0;
   iCntEdt := 0;
   iCntCbx := 0;
   iCntLbl := 0;
   iCntDat := 0;
   iCntChx := 0;
   iCnttbxb := 0;
   iCntbxb := 0;
   iCntCCbx := 0;
   iCntSpi := 0;
   tbbt_search.Visible := false;
   tbxb_reset.visible := false;
   if not Assigned(NOG_Fieldlist) then
   begin
      NOG_Fieldlist := tstringlist.Create;
      ZusWert := tstringlist.Create;
   end;
   if not Assigned(Actualfieldlist) then
   begin
      Actualfieldlist := tstringlist.Create;
   end
   else
   begin
      Actualfieldlist.clear;
   end;
   lbrechte := false;
   if gbHasCFGXS then
      dm_db.my_q_tmp_2.SQL.Text := 'select * from sys_cfgxs where arc_id='+IntToStr(iGArcID)
   else
   	dm_DB.my_q_tmp_2.SQL.Text := 'show tables like  "cfgxs_' + sIArcName + '"';
   try
      dm_DB.my_q_tmp_2.execute;
   except on e: exception do
      begin
      end;
   end;
   if dm_DB.my_q_tmp_2.recordcount > 0 then
   begin
   	if gbHasCFGXS then
         dm_db.my_q_tmp_2.SQL.Text := 'select * from sys_cfgxs where arc_id='+IntToStr(iGArcID)+' and usr_id = ' + inttostr(iGUsrID)
      else
      	dm_DB.my_q_tmp_2.SQL.Text := 'SELECT * FROM cfgxs_' + sIArcName + ' where usr_id = ' + inttostr(iGUsrID);
      try
         dm_DB.my_q_tmp_2.execute;
      except on e: exception do
         begin
         end;
      end;
      lbrechte := true;
   end;
   with dm_DB.my_q_Tmp do
   begin
      if sbx_IZus.ComponentCount > 0 then
         DelZusFields;
      SQL.Text := 'Select * from cfg_' + sIArcName + ' where typ <> 4 order by pos';
      Open;
      First;
      try
         result := RecordCount;
         if RecordCount = 0 then
         begin
            Close;
            Exit;
         end;
         tbbt_search.visible := true;
         tbxb_reset.visible := true;

         Filtered := False;
         SetLength(lbl, RecordCount);

         TorPflichtfeld := 0;
         tbbt_search.Top := 0;
         tbxb_reset.top := 0;
         litaborder := 2;
         sbxWidth := sbx_IZus.width;

         reg := Tregistry.create;
         try
            try
               with reg do
               begin
                  RootKey := HKEY_CURRENT_USER;
                  try
	                  OpenKey('Software\bitfarm\Archiv_V3\Importtools\' + sGProfil + '\' + inttostr(iGArcID), True);
   					except
                      LogEvnt(_('Fehler ffnen des Registrykeys (Standardwerte)') + sGProfil + '\' + inttostr(iGArcID));
                  end;

                  litop := 0;
                  liscroll := 0;
                  for iC := 0 to (RecordCount - 1) do
                  begin

                     iTyp := FieldByName('Typ').AsInteger;
                     lbl[iCntLbl] := tjvstatictext.Create(sbx_IZus);
                     lbl[iCntLbl].Name := 'zlbl_Tmp' + IntToStr(iC);
                     lbl[iCntLbl].Caption := FieldByName('Disp_Name').AsString + ':';

                     Actualfieldlist.Add(lbl[iCntLbl].Caption);

                     if lbrechte then
                     begin
                     	lbfound := false;
                        dm_DB.my_q_tmp_2.first;
                        while not dm_DB.my_q_tmp_2.eof do
                        begin
                           if dm_DB.my_q_tmp_2.fieldbyname('CFG_ID').AsInteger = FieldByName('CFG_ID').AsInteger then
                           begin
                              lbfound := true;
                              break;
                           end;
                           dm_DB.my_q_tmp_2.next;
                        end;
                     end
                     else
	                     lbfound := True;    // gibt es keine Rechtetabelle haben wir generell Zugriff

                     if bGIgnoreAddfieldRights then
                        lbfound := True;   // werden die Rechte ignoriert, haben wir generell Zugriff

                     liindex := NOG_fieldList.IndexOf(lbl[iCntLbl].Caption);
                     if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                     begin
                        lbl[iCntLbl].Caption := '*' + lbl[iCntLbl].Caption;

                     end;
                     lbl[iCntLbl].Hint := FieldByName('Feld_Name').AsString;
                     try
                        if valueexists(FieldByName('Feld_Name').AsString) then
                        begin
                           lswert := readstring(FieldByName('Feld_Name').AsString);
                        end
                        else
                        begin
                           lswert := '';
                        end;
                     except
                         LogEvnt(_('Fehler beim Lesen eines Standardwertes:')+FieldByName('Feld_Name').AsString);
                         lswert := '';
                     end;
                     if lswert = cEmptyDateString then
		                  lswert := '';
                     lbl[iCntLbl].ParentShowHint := True;
                     lbl[iCntLbl].Left := 8;
                     lbl[iCntLbl].Top := 8 + (38 * iC);

                     if litop + 73 > sbx_IZus.Height then
                     begin
                        liscroll := 16;
                     end
                     else
                     begin
                        litop := lbl[iCntLbl].Top;
                     end;
                     lbl[iCntLbl].Height := 13;
                     lbl[iCntLbl].Tag := FieldByName('typ').AsInteger;

                     lfont := canvas.Font;
                     canvas.Font := lbl[iCntLbl].Font;
                     lbl[iCntLbl].width := 4 + canvas.TextWidth(lbl[iCntLbl].caption);

                     if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                     begin
                        inc(torPflichtfeld);
                     end;

                     lTyp := eAddFieldType (iTyp);

                     if lTyp = zfld00_Universal then
                     begin
                        SetLength(edt, iCntEdt + 1);
                        frm_zuspflicht.CreateUniversal(False,edt,iCntEdt,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                        'zedt_Tmp',28,(sbxWidth-70)-liScroll,[akLeft,akRight,akTop],lbfound);
                        dec(iCntEdt,1);
                        edt[iCntEdt].OnChange := frm_Main.zusfeldonchange;
                        edt[iCntEdt].OnKeyPress := frm_Main.ZusFlsTyp0EditKeyPress;
                        if lswert <> '' then
	                        edt[iCntEdt].Tag := edt[iCntEdt].Tag or 4;
                        Inc(iCntEdt,1);

                     end
                     else
                     if lTyp = zfld01_Datum then
                     begin
                        SetLength(dat, iCntDat + 1);
                        frm_zuspflicht.CreateDatum(False,dat,iCntDat,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                  'zedt_Tmp',28,150,[akLeft,akTop,akRight],lbfound);
                        dec(iCntDat,1);
                        dat[iCntDat].OnChange := frm_Main.zusfeldonchange;
                        if lswert <> '' then
	                        dat[iCntDat].Tag := dat[iCntDat].Tag or 4;
                        Inc(iCntDat,1);

                     end
                     else
                     if lTyp = zfld02_Auswahl then
                     begin
                        SetLength(cbx, iCntCbx + 1);
                        frm_zuspflicht.CreateAuswahl(False,cbx,iCntCbx,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                    'zedt_Tmp',28,(sbxWidth-70)-liScroll,[akLeft,akTop,akRight],'',lbfound, -1, False);
                        dec(iCntCbx,1);

//                        if (FieldByName('Optionen').AsInteger and cZusatzFeldOptStrict) <> 0 then
                        	cbx[iCntCbx].onchange := frm_Main.zusfeldonchange;
//                        else
//                           cbx[iCntCbx].onchange := frm_Main.auswahlfeldonchange;
                        if lswert <> '' then
	                        cbx[iCntCbx].Tag := cbx[iCntCbx].Tag or 4;
                        cbx[iCntCbx].OnExit:= nil;
                        Inc(iCntCbx,1);
                     end
                     else
                     if lTyp = zfld03_MehrfachAuswahl then
                     begin
                        frm_zuspflicht.CreateMehrfachauswahl(False,lbl,ZusFldFrame,lfbit,jccb,iCntCCbx,iCntbxb,lsDispName,sbx_IZus,IC,lswert,litaborder,
                            cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,sAdd,iCntLbl,28,(sbxWidth-70)-liScroll,sIarcname,frm_Main.zusfeldonchange,lbfound);
                        SetLength(jccb, iCntCCbx + 1);
                        jccb[iCntCCbx] := ZusFldFrame.ComboBox;
                        if lswert <> '' then
	                        jccb[iCntCCbx].Tag := jccb[iCntCCbx].Tag or 4;
                        Inc(iCntCCbx, 1);
                        SetLength(lfbit, iCntbxb + 1);
                        lfbit[iCntbxb] := ZusFldFrame.Button;
                        Inc(iCntbxb, 1);
                     end
                     else
                     if lTyp = zfld05_Intervall then
                     begin
                        s1:= ''; s2:= '';     //23.08.2011 b.takacs 3.5.1.10
                        if lswert <> '' then
                        begin
                        for x:= 1 to pos(';',lswert) - 1 do
                         	s1:= s1 + lswert[x];
                        for x:= pos(';',lswert)+1 to length(lswert) do
                         	s2:= s2 + lswert[x];
                        end;

                        SetLength(spe, iCntSpi + 1);
                        frm_zuspflicht.CreateIntervall(False,spe,iCntSpi,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                    'zedt_Tmp',28,75,[akLeft,akTop],lbfound);
                        dec(iCntSpi,1);
                        spe[iCntSpi].OnChange := frm_Main.zusfeldonchange;
                        if lswert <> '' then
                        begin
                        	spe[iCntSpi].Text := s1;  //23.08.2011 b.takacs 3.5.1.10
                           spe[iCntSpi].Tag := spe[iCntSpi].Tag or 4;
                        end;

                        Inc(iCntSpi,1);

                        SetLength(cbx, iCntCbx + 1);
                        frm_zuspflicht.CreateAuswahl(False,cbx,iCntCbx,sbx_IZus,IC,'',litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                    'zedt_Tmp_cbx_',(spe[iCntSpi-1].Left + spe[iCntSpi-1].Width + 25),75,[akTop,akRight],'T,M,J',lbfound,-1,True);
                        dec(iCntCbx,1);
                        cbx[iCntCbx].OnChange := nil;
                          cbx[iCntCbx].OnExit:= nil;
                        if lswert <> '' then
                           cbx[iCntCbx].ItemIndex :=  cbx[iCntCbx].Items.IndexOf(s2);

                        Inc(iCntCbx,1);
                     end
                     else
                     if lTyp = zfld06_GanzZahl then
                     begin
                        SetLength(lganzzahl, iCntganzzahl + 1);
                        frm_zuspflicht.CreateGanzZahl(False,lganzzahl,iCntganzzahl,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                    'zedt_Tmp',28,75,[akLeft,akTop],lbfound);
                        dec(iCntganzzahl,1);
                        lganzzahl[iCntganzzahl].onchange := frm_Main.zusfeldonchange;
                        if lswert <> '' then
	                        lganzzahl[iCntganzzahl].Tag := lganzzahl[iCntganzzahl].Tag or 4;
                        Inc(iCntganzzahl,1);
                     end
                     else
                     if (lTyp = zfld07_FliessKomma) or (ltyp = zfld08_Waehrung)
                     then
                     begin
                        SetLength(ldouble, iCntdouble + 1);
                        frm_zuspflicht.CreateFliessKommaWaehrung(False,ldouble,iCntdouble,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                    'zedt_Tmp',28,75,[akLeft,akTop],iTyp,lbfound);
                        dec(iCntdouble,1);
                        ldouble[iCntdouble].OnChange := frm_Main.zusfeldonchange;
                        if lswert <> '' then
	                        ldouble[iCntdouble].Tag := ldouble[iCntdouble].Tag or 4;                        
                        Inc(iCntdouble,1);
                     end;

                     lbl[iCntLbl].Parent := sbx_IZus;

                     SetLength(chx, iCntchx + 1);
                     chx[iCntchx] := Tcheckbox.Create(sbx_IZus);
                     chx[iCntChx].Name := 'zedt_Tmpchx' + IntToStr(iC);
                     chx[iCntchx].Left := 8;
                     chx[iCntchx].Top := 21 + (38 * iC);
                     chx[iCntchx].Height := 21;
                     chx[iCntchx].Width := (20);
                     chx[iCntchx].Anchors := [akLeft, akTop];
                     chx[iCntchx].Tag := FieldByName('Mode').AsInteger;
                     chx[iCntchx].Caption := '';
                     chx[iCntchx].Parent := sbx_IZus;
                     chx[iCntchx].TabStop := false;
                     inc(iCntchx, 1);

                     // die kleine Schaltflche rechts daneben.
                     SetLength(tbxb, iCnttbxb + 1);
                     tbxb[iCnttbxb] := TTBXButton.Create(sbx_IZus);
                     tbxb[iCnttbxb].Name := 'zedt_Tmptbxb' + IntToStr(iC);
                     tbxb[iCnttbxb].Left := (sbx_IZus.Width - 25) - liscroll;
                     tbxb[iCnttbxb].Top := 21 + (38 * iC);
                     tbxb[iCnttbxb].Height := 21;
                     tbxb[iCnttbxb].Width := (15);
                     tbxb[iCnttbxb].Anchors := [akright, akTop];
                     tbxb[iCnttbxb].Tag := FieldByName('Mode').AsInteger;
                     tbxb[iCnttbxb].Caption := '';
                     tbxb[iCnttbxb].hint := FieldByName('Feld_Name').AsString;
                     tbxb[iCnttbxb].showhint := false;
                     tbxb[iCnttbxb].Onclick := Searchzusfield;
                     tbxb[iCnttbxb].Images := dm_Shared.il_ShScroll; //dm_Main.jil_Scroll;
                     tbxb[iCnttbxb].ImageIndex := 1;
                     tbxb[iCnttbxb].TabStop := false;

                     tbxb[iCnttbxb].Parent := sbx_IZus;

                     inc(iCnttbxb, 1);
                     inc(iCntLbl, 1);
                     Next;
                  end;
                  //inc(iCntLbl, 1);
                  if tbbt_Search.Top < 21 + (38 * iC) then
                  begin
                     tbbt_Search.Top := 21 + (38 * iC);

                     tbxb_reset.top := 21 + (38 * iC);
                  end;
               end;
            except
               on e: exception do
               begin
                  ErrorMsg('ReadReg', _('Fehler beim Laden der Optionen:')+' ' + e.Message,
                     2000, True);
                  LogEvnt(_('Fehler beim Laden der Optionen:')+' ' + e.Message);
               end;
            end;
         finally
            begin
               reg.CloseKey;
               if Assigned(reg) then
                  freeandnil(reg);
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('CreZusFields',
               'Fehler beim dynamischen Erzeugen der Zusatzfelder: ' + e.Message +
               #13 +
               'Bitte beenden Sie die Anwendung und starten diese erneut!', 2000,
               True);
            result := 0;
            dm_DB.my_q_Tmp.Close;
         end;
      end;
      dm_DB.my_q_Tmp.Close;
   end;

   tbbt_Search.taborder := litaborder;
   inc(litaborder);
   tbxb_reset.taborder := litaborder;

end;


// Hier werden etliche Zeichen verboten
procedure Tfrm_Main.ZusFlsTyp0EditKeyPress(Sender: TObject; var Key: Char); //3.5.0.22
begin
   // if not (key in ['0'..'9',#13,#8, '.' , ',' ]) then key := #0;
   if Key in [
      '!', // Trenner
      //'"', // Anfhrungszeichen, reserviert als Quote und auch SQL //3.5.0.46 [2414]
      //  '%', // wegen SQL mit like //3.5.0.71 wieder dazu
      #39, // Apostroph, wegen SQL
      '(', // wegen SQL
      ')', // wegen SQL
      '\', // wegen SQL
      '*', // vielleicht mal Platzhalter
      // ',', // Trenner //3.5.0.31 wegen Thomas, Herr Pi(e)tsch?
      '?', // vielleicht mal Platzhalter
      '`', // wegen SQL
      '{', // wegen - rein vorsichtshalber
      '|', // wegen - rein vorsichtshalber
      '}', // wegen - rein vorsichtshalber
      #160 // geschtztes Leerzeichen
      ] then
         Key := #0;
end;




{>3.6}

function Tfrm_Main.DelZusFields: Integer;
var
   lcomp: Tcomponent;
begin
   result := 0;
   if sbx_IZus.ComponentCount = 0 then
      exit;
   try
      try

         sbx_IZus.visible := false;
         while sbx_IZus.ComponentCount > 0 do
         begin
            lcomp := sbx_IZus.Components[0];
            freeandnil(lcomp);
            //      sbx_IZus.Components[0].Free;
            inc(result, 1);
         end;
         ZusFldFrame := nil;
      except
         on e: exception do
         begin
            ErrorMsg('DelZusFields', 'Fehler beim Entfernen der Zusatzfelder: ' + e.Message, 2006, True);
            result := 0;
         end;
      end;
   finally

      sbx_IZus.visible := true;
   end;

   tbbt_search.visible := false;
   tbxb_reset.visible := false;
   torpflichtfeld := 0;
end;

procedure Tfrm_Main.ShowPrgInfo;
begin
   Application.CreateForm(Tfrm_Info, frm_Info);
   frm_Info.ShowModal;
   frm_Info.Release;
end;
(*
procedure Tfrm_Main.sbtn_TExitClick(Sender: TObject);
begin

   if frm_Main.tbxtm4.Checked then
   begin
      Splitter1.Align := alLeft;
      pnl_Tree.Visible := False;
      pnl_Input.Align := alClient;

      frm_Main.tbxtm4.Checked := False;

   end
   else
   begin

   	pnl_Tree.Align := alNone;
      pnl_Input.Align := alNone;
      pnl_Input.Width := 271;
      Splitter1.Align := alNone;

      pnl_Input.Align := alRight;
      pnl_Tree.Align := alLeft;
      Splitter1.Align := alRight;
      Splitter1.MinSize := 223;
      Splitter1.Update;
      pnl_Tree.Align := alClient;

      pnl_Tree.Visible := True;

      frm_Main.tbxtm4.Checked := True;

   end;
end;
*)
procedure Tfrm_Main.sbtn_AddSlwClick(Sender: TObject);
var
   i, j: integer;
begin
   if edt_Slw.Text <> '' then
   begin
      if lb_Slw.Items.IndexOf(edt_Slw.Text) = -1 then
      begin
         lb_Slw.Items.Add(edt_Slw.Text);
         lb_Slw.Canvas.Font := lb_Slw.Font;
         j := 0;  // Set scroll width for terms
         for i := 0 to (lb_Slw.Items.Count - 1) do
            if (lb_Slw.Canvas.TextWidth(lb_Slw.Items[i]) > j) then
               j := lb_Slw.Canvas.TextWidth(lb_Slw.Items[i]);
         lb_Slw.ScrollWidth := j + 15;
         edt_Slw.Text := '';
      end;
   end;
   edt_Slw.SelectAll;
end;

procedure Tfrm_Main.sbtn_DelSlwClick(Sender: TObject);
var
   i, j: integer;
begin
   if edt_Slw.Text <> '' then
   begin
      lb_Slw.Items.Delete(lb_Slw.Items.IndexOf(edt_Slw.Text));

      lb_Slw.Canvas.Font := lb_Slw.Font;
      j := 0;  // Set scroll width for terms
      for i := 0 to (lb_Slw.Items.Count - 1) do
         if (lb_Slw.Canvas.TextWidth(lb_Slw.Items[i]) > j) then
            j := lb_Slw.Canvas.TextWidth(lb_Slw.Items[i]);
      lb_Slw.ScrollWidth := j + 15;
   end;
end;

procedure Tfrm_Main.lb_SlwClick(Sender: TObject);
var iCount: Integer;
begin
   for iCount := 0 to (lb_Slw.Items.Count - 1) do
      if lb_Slw.Selected[iCount] then
      begin
         edt_Slw.Text := lb_Slw.Items.Strings[iCount];
         break;
      end;
end;


function Tfrm_Main.ConnectDB(fbusefilename: boolean): boolean;
var
   ini: TIniFile;
   sFileName: string;
begin
   if fbusefilename then
   begin
      if (ParamCount = 0) or not (FileExists(ParamStr(1))
      	or  FileExists(ExtractFilePath(ParamStr(0)) + ParamStr(1) + '.con')) then
         sFileName := ExtractFilePath(ParamStr(0)) + 'Standard.con'
      else
      begin
         if FileExists(ParamStr(1)) then
         	sFileName := ParamStr(1)
         else if FileExists(ExtractFilePath(ParamStr(0)) + ParamStr(1) + '.CON') then
            sFilename := ExtractFilePath(ParamStr(0)) + ParamStr(1) + '.con';
      end;

      sGProfil := ChangeFileExt(ExtractFileName(sFileName), '');
   end
   else
   begin
      sFileName := ExtractFilePath(ParamStr(0)) + sGProfil + '.con';
   end;

	if not FileExists(sFileName) then
   begin
   	Result := False;
      Exit;
   end;

   try
      try
         ini := TIniFile.Create(sFileName);
         with ini do
         begin
            dm_DB.my_Con.Disconnect;
            dm_DB.my_con.Server := ReadString('Connection', 'Server', '');
            dm_DB.my_con.Port := ReadInteger('Connection', 'Port', 3306);
            dm_DB.my_con.Database := ReadString('Connection', 'DB', '');
            dm_DB.my_con.Username := Decrypt(ReadString('Connection', 'User',
               ' '), GlobalKey);
            dm_DB.my_con.Password := Decrypt(ReadString('Connection', 'Pass',
               ' '), GlobalKey);
            gsdruckpfad := ReadString('Scripts', 'uncclientspooler', '');
            gsimporterplugin:= ReadString('Options', 'importerplugin', '');
            dm_DB.my_con.Connect;
         end;
      except
         on e: exception do
         begin
            LogEvnt('2003    Fehler beim Auslesen der Connection: ' + e.Message);
            result := False;
         end;
      end;
      if not dm_DB.my_con.Connected then
      begin
         BfShowMessage(_('Fehler!') + #13 +
            _('Es ist konnte keine Verbindung mit dem Archiv') + #13 +
            _('Server hergestellt werden. Whlen Sie ein anderes Profil') + #13 +
            _('oder wenden Sie sich an Ihren Administrator.'));
         result := False;
      end
      else
      begin
         result := true;
      end;
   finally
      if Assigned(ini) then
         FreeAndNil(ini);
   end;
end;

procedure Tfrm_Main.FormShow(Sender: TObject);
var ini: TIniFile;
   li, licounter, iIgnore: integer;

begin
   li := 0;
   iIgnore := 0;
   sGusrname := '';
   //logevnt('showingform');
   if paramcount > 1 then
   begin
      for licounter := 2 to paramcount do
      begin
         if (paramstr(licounter) = '-debug') then //[2467]
         begin
            gbdebug := true;
            dm_DB.MySQLMonitor1.Active := true; //[2467]
         end;
      end;
   end;
   if ConnectDB(true) then
   begin
      if not ReadUserName then
      begin
         if gbdebug then
            logevnt('not readusername');
         Application.CreateForm(Tfrm_Login, frm_Login);
         if frm_Login.ShowModal <> mrOk then
         begin
            ExitProcess(0);
            exit;
         end;
         frm_Login.Release;
      end;
   end
   else
   begin
      //logevnt('connect missed');
      Application.CreateForm(Tfrm_Login, frm_Login);
      if frm_Login.ShowModal <> mrOk then
      begin
         ExitProcess(0);
         exit;
      end;
      frm_Login.Release;
   end;


   sGConnection := ExtractFilePath(ParamStr(0)) + sGProfil + '.con';
   ini := TIniFile.Create(sGConnection);
   try
      try
         with ini do
         begin
            (*dm_DB.my_Con.Disconnect;
            dm_DB.my_con.Server := ReadString('Connection', 'Server', '');
            dm_DB.my_con.Port := ReadInteger('Connection', 'Port', 3306);
            dm_DB.my_con.Database := ReadString('Connection', 'DB', '');
            fsdomain := ReadString('Connection', 'Domain', '');
            dm_DB.my_con.Username := Decrypt(ReadString('Connection', 'User', ' '), GlobalKey);
            dm_DB.my_con.Password := Decrypt(ReadString('Connection', 'Pass', ' '), GlobalKey);
            *)
            sGArcPath := ReadString('Scripts', 'Archivverzeichnis', '');
            sGclientprogram := ReadString('Scripts', 'clientprogramm', '');
            sGCopyPath := ReadString('Scripts', 'archivkopie', sGArcPath);
            sGClntSpool := ReadString('Scripts', 'uncclientspooler', '');
            gsimporterplugin:= ReadString('Options', 'importerplugin', '');
            iIgnore := ReadInteger('Options', 'ignorerightsatimport',0);
            if iIgnore = 1 then
            	bGIgnoreAddfieldRights := True
            else
               bGIgnoreAddfieldRights := False;


         end;
      except
         on e: exception do
            LogEvnt('2003    Fehler beim Auslesen der Connection: ' + e.Message);
      end;


      jvccb_je.Items.Clear;
      jvccb_efa.Items.Clear;
      jvccb_eb.Items.Clear;
      // leeren eintrag erzeugen der am Anfang der Liste steht.
      gSLitems_eb := TStringList.Create;
      gSLitems_je := TStringList.Create;
      gSLitems_efa := TStringList.Create;

      if TmpSQL('select usr_id, usr_Name  from sys_usr where (usr_name not like  ' + #39 + 'DEL_%' + #39 + ') and (usr_name not like  ' + #39 + 'system' + #39 + ') order by usr_name') then
      begin

         with dm_DB.my_q_Tmp do
            while not Eof do
            begin
               jvccb_eb.Items.Add(FieldByName('usr_name').AsString);
               gSLitems_eb.Add(FieldByName('usr_id').AsString);
               Next;
            end;
      end
      else ErrorMsg('ReadUsr', 'Fehler beim Auslesen der Benutzer', 2013, True);
      if TmpSQL('select grp_id, grp_Name,  grp_name from sys_grp where grp_name not like  ' + #39 + 'DEL_%' + #39 +
         ' order by grp_name') then
      begin
         with dm_DB.my_q_Tmp do
            while not Eof do
            begin
               jvccb_je.Items.Add(FieldByName('grp_name').AsString);
               gSLitems_je.Add(FieldByName('grp_id').AsString);
               jvccb_efa.Items.Add(FieldByName('grp_name').AsString);
               gSLitems_efa.Add(FieldByName('grp_id').AsString);
               Next;
            end;
         dm_DB.my_q_Tmp.Close
      end
      else ErrorMsg('ReadUsr', 'Fehler beim Auslesen der Benutzer', 2013, True);
      //if lv_Usr.Items.Count > 0 then lv_Usr.Items[0].Selected := True;
      dm_DB.my_q_Tmp.Close;

      // ende fuellen der Benutzerauswahl
      jde_termin.date := date;
      jde_erinnerung.date := date + 7;
      gbHasCFGXS := DbTableExist('sys_cfgxs');
      
      InitScan;
      LoadLgrArcStat;

      if paramcount > 1 then
      begin
         for licounter := 2 to paramcount do
         begin
            if (pos('-A:', paramstr(licounter)) > 0) then
            begin
               try
                  li := strtoint(copy(paramstr(licounter), 4, length(paramstr(licounter))));
               except on e: Exception do
                  begin
                     li := -1;
                  end;
               end;
               if li <> -1 then
               begin
                  dbtv_Main.Select(dbtv_Main.GetNodeID(li), []);
                  dbtv_Main.OnClick(self);
               end;
            end;
            if (pos('-D:', paramstr(licounter)) > 0) then
            begin
               Jvetitel.Text := copy(paramstr(licounter), 4, length(paramstr(licounter)));
            end;

            //[2467]
            if (paramstr(licounter) = '-debug') then //[2467]
            begin
               gbdebug := true;
               dm_DB.MySQLMonitor1.Active := true;
            end;
         end;
      end;
      fhasdocid := false;
      if TmpSQL('show tables like ' + #39 + 'sys_gdocid' + #39) then
      begin
         try
            if dm_DB.my_q_Tmp.recordcount > 0 then
            begin
               fhasdocid := true;
            end;
         except on e: exception do
            begin
               ErrorMsg('formshow', 'Fehler beim Auslesen der gdocid: ' +
                  e.Message, 2015, True);
            end;
         end;
      end;
      loadfavwvlhints;

//      ReadColorscheme;

      bfaStatefields1.fclTeal := gclTeal;
      bfaStatefields1.fclLime := gclLime;
      bfaStatefields1.fclRed := gclRed;

      bfaStatefields1.ThreeStates := False;
      bfaStatefields1.IgnoreRightsAtImport := bGIgnoreAddfieldRights;
      bfaStatefields1.UserID := iGUsrID;
   finally
      BringToFront; //22.08.2011 b.takacs 3.5.1.10 [3152]
      if Assigned(ini) then
         FreeAndNil(ini);
   end;
end;

procedure Tfrm_Main.cbx_ArcChange(Sender: TObject);
var liarcold: integer;
begin
   // new style, like manuscan, check for errors and reset things on error
   try

      if cbx_Arc.ItemIndex < 1 then
      begin
         cbx_Arc.ItemIndex := cbx_Arc.Items.IndexOf(cbx_Arc.Text);
      end;
      if (cbx_Arc.ItemIndex > 0) then
      begin
         if iGArcID = Integer(cbx_Arc.Items.Objects[cbx_Arc.ItemIndex]) then
         begin
            exit;
         end;
         liarcold := iGArcID;
         iGArcID := Integer(cbx_Arc.Items.Objects[cbx_Arc.ItemIndex]);
         if TmpSQL('select * from sys_arc where arc_id = ' + IntToStr(iGArcID)) then
         begin
            sGArcName := dm_DB.my_q_Tmp.FieldByName('Arc_Name').AsString;
            sIArcName := dm_DB.my_q_Tmp.FieldByName('Arc_TblName').AsString;
         end
         else
         begin
            ErrorMsg('cbx_ArchivChange', 'Fehler beim Auslesen des Archivnamens', 2001, True);
            dm_DB.my_q_Tmp.Close;
            exit;
         end;
         if dm_DB.my_q_Tmp.FieldDefList.Find('Options') <> nil then
         begin
            GbDocnamepflicht := (dm_DB.my_q_Tmp.FieldByName('Options').AsInteger and 1) = 1;
            if GbDocnamepflicht then
            begin
               Jvetitel.Color := cColorPflichtfeld;
            end
            else
            begin
               Jvetitel.Color := clwhite;
            end;
         end
         else
         begin
            GbDocnamepflicht := false;
            Jvetitel.Color := clwhite;
         end;
         DelZusFields;

         if sbx_IZus.ComponentCount > 0 then
            ErrorMsg('DelZusFields', 'Fehler beim Entfernen aller Zusatzfelder, bitte beenden' + #13 +
               'Sie die Anwendung und starten diese neu!', 2006, True)
         else
         	iGZusFCount := CreZusFields;

        Application.ProcessMessages;

         if Sender.ClassNameIs('TComboBox') or
            (liarcold <> iGArcID) then
         begin
            dbtv_Main.Select(dbtv_Main.GetNodeID(iGArcID), []);
            dbtv_Main.Update;
         end
      end
      else
      begin

         if sbx_IZus.ComponentCount > 0 then
            DelZusFields;
         iGArcId := -1;
         iGZusFCount := 0;
      end;

      bfaStatefields1.CreateStatefields(iGArcId);
   finally
      dm_DB.my_q_Tmp.Close;
   end;
end;

procedure Tfrm_Main.cbx_LgrChange(Sender: TObject);
begin
   if cbx_Lgr.ItemIndex = -1 then
   begin
      cbx_Lgr.ItemIndex := cbx_Lgr.Items.IndexOf(cbx_Lgr.Text);
   end;
   if cbx_Lgr.ItemIndex <> -1 then
   begin
      iGLgrID := Integer(cbx_Lgr.Items.Objects[cbx_Lgr.ItemIndex]);
      sGLgrName := cbx_Lgr.Items.Strings[cbx_Lgr.itemIndex];

      ReadCbxArc;

      if Sender.ClassNameIs('TComboBox') then
         dbtv_Main.Select(dbtv_Main.GetNodeID(iGLgrID), []);
   end;
   bfaStatefields1.CreateStatefields(iGLgrID);
end;


procedure Tfrm_Main.dbtv_MainClick(Sender: TObject);
begin
   if runfirsttime then
   begin
      runfirsttime := false;
      exit; //else runfirsttime:= false;
   end;
   // put here so it doesnt block or fail on first time!
{Importer: Merkt sich zwar das letzte Lager und Archiv, diese sind aber offensichtlich nicht logisch
ausgewhlt. Beispiel: Bei Pflichtfeldern sagt er trotz Eingabe, man solle diese ausfllen. Nach erneutem
Anklicken des Archives funktioniert es dann.}
   // braucht man torpflichtfeld hier nicht, wird spter benutzt, wo es sinnvoller ist
   //    torpflichtfeld:= 0; 
   if dbtv_Main.Selected = nil then
   begin
      dbtv_Main.Select(dbtv_Main.Items.Item[0]);
   end;
   if dbtv_Main.Selected <> nil then
   begin
      if dbtv_Main.Selected.ImageIndex = 0 then
      begin
         cbx_Lgr.ItemIndex := cbx_Lgr.Items.IndexOfObject(TObject(dbtv_Main.Selected.data));
         cbx_LgrChange(self);
      end;
      if dbtv_Main.Selected.ImageIndex = 1 then
      begin
         cbx_Lgr.ItemIndex := cbx_Lgr.Items.IndexOfObject(TObject(dbtv_Main.Selected.Parent.data));
         cbx_LgrChange(self);

         cbx_Arc.ItemIndex := cbx_Arc.Items.IndexOfObject(TObject(dbtv_Main.Selected.data));
         cbx_ArcChange(self);
         pnl_input.Visible := true;
      end;
   end;
end;

///////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_Main.btn_ArcClick(Sender: TObject);

var i, rc: integer;
begin
   if (cbx_Lgr.ItemIndex = -1) or (cbx_Arc.ItemIndex <= 0) then
   begin
      BfShowMessage(_('Sie mssen erst einen Lagerort und ein Archiv auswhlen') + #13 +
         _('um ein Dokument zu archivieren.'));
      exit;
   end;
   susr := '';

   for i := 0 to jvccb_je.Items.Count - 1 do
   begin
      if jvccb_je.IsChecked(i) then
      begin
         susr := sUsr + '' + jvccb_je.items.Strings[i] + ';';
      end;

      if jvccb_efa.IsChecked(i) then
      begin
         susr := sUsr + '#' + jvccb_efa.items.Strings[i] + ';';
      end;
   end;
   for i := 0 to jvccb_eb.Items.Count - 1 do
   begin
      if jvccb_eb.IsChecked(i) then
      begin

         susr := sUsr + jvccb_eb.items.Strings[i] + ';';
      end;
   end;

   if rightstr(sUsr,1) = ';' then
      sUsr:=Copy(sUsr,1,length(sUsr)-1);

   ///////////////////////////////////////////////////////////////////////////////////////////////////////
   //  Auf ausgefllte Pflichtfelder prfen

   frm_zuspflicht.fsDestIarcname := sIArcName;

   if not bGIgnoreAddfieldRights then
   begin
   	if not frm_zuspflicht.CheckZusfieldsRights(iGUsrID) then
	   	Exit;    // wenn nicht alle Pflichtfelder gefllt sind, dann darf man nicht importieren
   end;

   if not ChkZusfield(True) then //11.04.2011 b.takacs 3.5.0.16
   	 exit;

//   if not ChkStrictField(sbx_IZus, sIArcName) then
//   	Exit;

   //if not bGIgnoreAddfieldRights then
   //begin
      torlockpflichtfeld := torpflichtfeld - keypflichtfeld;
      if TorlockPflichtfeld <> 0 then
      Begin
         BfShowMessage(_('Sie mssen erst die Pflichtfelder ausfllen.') + #13 + _('Pflichtfelder sind mit einem *(Stern) gekennzeichnet.') + #13 +
            _('Fehlende Felder:') + inttostr(torlockpflichtfeld));
         if torlockpflichtfeld < 0 then
         begin
            logevnt('2 tor ' + inttostr(torpflichtfeld) + ' key ' + inttostr(keypflichtfeld));
         end;
         pctrl_Input.ActivePage := tbs_IZus;
         exit;
      end;

   //end;

   if (Jvetitel.Text = '') and GbDocnamepflicht then
   begin
      BfShowMessage(_('Sie mssen erst den Dokumenttitel angeben.'));
      pctrl_Input.ActivePageIndex := 0;
      Jvetitel.SetFocus;
      exit;
   end;

   lb_Slw.Items.SaveToFile(sGPath + 'SLW' + sGDocName + '.SLW');
   if chbx_ManVtx.Checked then
      memo_Vtx.Lines.SaveToFile(sGPath + 'VTX' + sGDocName + '.VTX');

   WriteJobFile;

    // hier das Plugin ansetzen
    if gsimporterplugin <> '' then
    begin
      LogEvnt('Importerplugin: ' + extractfilepath(ParamStr(0)) + '\Viewer-Files\plugins\'
         + gsimporterplugin + ' "' + sGPath + sGDocName +'"');

       if FileExists(extractfilepath(ParamStr(0)) + '\Viewer-Files\plugins\' + gsimporterplugin) then
       begin
         rc := dm_Main.ShellExecute_AndWait('', extractfilepath(ParamStr(0)) + '\Viewer-Files\plugins\'
          + gsimporterplugin,'"' + sGPath + sGDocName +'"' , extractfilepath(ParamStr(0)), SW_hide, True);
         if rc <> 0 then
         begin
            if rc = 127 then
            begin
              LogEvnt(_('Plugin: Abbruch durch den Benutzer'));
              BfShowMessage(_('Plugin: Abbruch durch den Benutzer'));
							if FileExists(sGPath + sGDocName + '.JOB') then
              	DeleteFile(sGPath + sGDocName + '.JOB');
							if FileExists(sGPath + 'SLW' + sGDocName + '.SLW') then
              	DeleteFile(sGPath + 'SLW' + sGDocName + '.SLW');
							if FileExists(sGPath + 'VTX' + sGDocName + '.VTX') then
              	DeleteFile(sGPath + 'VTX' + sGDocName + '.VTX');
              exit;
            end;
            if rc = 255 then  // Abbruch ohne Rckmeldung, Programm kann weiter verwendet werden
            begin
               Exit;
            end;
            LogEvnt(_('Fehler beim Ausfhren des Plugins')  + ' rc=' + IntToStr(rc));
            BfShowMessage(_('Fehler beim Ausfhren des Plugins'));
         end;
       end
       else
       begin
          LogEvnt('Plugin: ' + extractfilepath(ParamStr(0)) + '\Viewer-Files\plugins\' + gsimporterplugin + ' konnte nicht gefunden werden');
       end;
    end;

   ReadbGSavLastLgrArc;

   if bGSavLastLgrArc then
      SaveLastLgrArc;
   Application.Terminate;
end;


procedure ReadbGSavLastLgrArc;
var reg: TRegistry;
begin
   reg := TRegistry.Create;
   with reg do
   begin
      try
         RootKey := HKEY_CURRENT_USER;
         OpenKey('Software\bitfarm\Archiv_V3\Importer\Options', True);
         if valueexists('SavLastLgrArc') then
         begin
            bGSavLastLgrArc := ReadBool('SavLastLgrArc');
         end
         else
         begin
            bGSavLastLgrArc := true;
         end;
      finally
         If Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;
procedure Tfrm_Main.btn_ResetClick(Sender: TObject);
begin
   lb_Slw.Clear;
   edt_Slw.Text := '';
   // edt_IRef.Text := '';
   memo_Vtx.Clear;
   Exitcode := -1;
   frm_Main.Close;
end;

procedure Tfrm_Main.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SaveLgrArcStat;
   ReadbGSavLastLgrArc;
   if bGSavLastLgrArc then
      SaveLastLgrArc;
   dm_DB.my_q_Tmp.Close;
   dm_DB.my_q_LgrArc.Close;
   dm_DB.my_Con.Disconnect;
   Exitcode := -1;
   Application.Terminate;
end;


{3.6<}
function Tfrm_Main.ChkZusfield(bUseCheckprogram: Boolean): boolean;
var 
   iCount: Integer;
   sFeld, sName, sWert: String;
   comp1: TComponent;
   comp: TComponent;
   jvstcomp: tjvstatictext;
   lbchecked: boolean;
   lsCheckPrg, lsinput: string;
begin
   Result := true;
   keypflichtfeld := 0;
   ///  ini := TIniFile.Create(FileName);
   try
      try
         //with ini do
         //begin
         //    logevnt('3 TorPflichtfeld '+inttostr(TorPflichtfeld));
         for iCount := 0 to (iGZusFCount - 1) do
         begin
            jvstcomp := tjvstatictext(sbx_IZus.FindComponent('zlbl_Tmp' +
               IntToStr(iCount)));

            sFeld := jvstcomp.Hint;
            sName := copy(jvstcomp.Caption, 1, Length(jvstcomp.Caption) - 1);
            sWert := '';
            comp := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmp' + IntToStr(iCount));

            if comp is TEdit then
            begin
               sWert := TEdit(comp).Text;
            end;
            if comp is TJvDateEdit then
            begin
               sWert := TJvDateEdit(comp).Text;
               if swert = cEmptyDateString then
                  swert := '';
            end;
            if comp is TComboBox then
            begin
               sWert := TComboBox(comp).Text;
            end;
            if comp is TSpinEdit then
            begin
               sWert := TSpinEdit(comp).Text;
            end;
            if comp is TjvSpinEdit then
            begin
               sWert := TjvSpinEdit(comp).Text;
            end;
            if comp is TjvcheckedComboBox then
            begin
               sWert := TjvcheckedComboBox(comp).Text;
            end;

             if (swert = '""') or (swert = cEmptyDateString) or (swert = '0,0000000000')
                or (swert = '0') or (swert='0,00') then
                  swert := '';

            if (leftstr(sname, 1) = '*') and (swert <> '') then
               inc(keypflichtfeld);

            if bUseCheckprogram and (swert <> '') then
            begin
            	if DbDoSkySQL(dm_db.my_q_Tmp,'select * from cfg_' + sIarcname + ' where Feld_name = ' +
                  #39 + sFeld + #39) then
               begin
                  lbchecked := True;
                  lsCheckPrg:=dm_db.my_q_tmp.FieldByName('chck_prog').AsString;
                  if (dm_db.my_q_tmp.RecordCount <> 0) and
                    (dm_db.my_q_tmp.FieldDefList.Find('chck_prog') <> nil) then
                  begin
                     if (dm_db.my_q_tmp.FieldByName('chck_prog').AsString <> null) and
                       (lsCheckPrg <> '') then
                     begin
                       lbchecked :=
                          (ShellExecute_AndWait('', extractfilename(lsCheckPrg),
                          swert, extractfilepath(lsCheckPrg), SW_HIDE, True) = 0);
                     end;
                  end;
                  while not lbchecked do
                  begin
                     if InputQuery(_('Eingabeberprfung'),
                       _('Die Eingabe wurde zurckgewiesen. Bitte geben Sie einen gltigen Wert ein.'),
                       lsinput) then
                     begin
                        swert := lsinput;

                        if comp is TEdit then
                        begin
                           TEdit(comp).Text := sWert;
                        end;
                        if comp is TJvDateEdit then
                        begin
                           if swert = cEmptyDateString then
                              swert := '';
                           TJvDateEdit(comp).Text := sWert;
                        end;
                        if comp is TComboBox then
                        begin
                           TComboBox(comp).Text := sWert;
                        end;
                        if comp is TSpinEdit then
                        begin
                           TSpinEdit(comp).Text := sWert;
                        end;
                        if comp is TjvSpinEdit then
                        begin
                           TjvSpinEdit(comp).Text := sWert;
                        end;
                        if comp is TjvcheckedComboBox then
                        begin
                           TjvcheckedComboBox(comp).Text := sWert;
                        end;

                        lbchecked :=
                          (ShellExecute_AndWait('', extractfilename(lsCheckPrg),
                          lsinput, extractfilepath(lsCheckPrg), SW_HIDE, True) = 0);
                     end
                     else
                     begin
                        Result := False;
                        Exit; //18.02.2011 b.takacs 3.5.0.162
                     end;
                  end;
               end;
            end;
         end;
         //end;
      except
         on e: exception do
            ErrorMsg('ChkZusfield', 'Fehler beim Erstellen der Vorlagen Datei: ' + e.Message, 2023, True);
      end;
   finally
      //if Assigned(ini) then FreeAndNil(ini);
   end;
end;


procedure Tfrm_Main.FormCreate(Sender: TObject);
var
   icount, iPos: integer;
   lsPar, lsParL, lsParCom, lsParVal, lsLanguage, lsLangPath, lsArcId: string;
begin
	//Menu := dm_Main.mnu_Main; //3.5.0.8 dann halt auf die harte Tour
   runfirsttime := true;
   BD.LogPath := BD.EnvTemp;
   BD.LogName := 'ImporterV3.log';

   for icount := 0 to paramcount do
   begin
      lsPar := ParamStr(icount);
      lsParL := lowercase(lsPar);
      iPos := Pos(':',lsParL);
      if iPos = 0 then
         iPos := maxint-1;
      lsParCom := Copy(lsParL,1,iPos-1); // das vor dem Doppelpunkt (oder alles wenn keiner)
      lsParVal := Copy(lsParL,iPos+1,maxint); // das vor nach Doppelpunkt (oder nix wenn keiner)

      if lsParCom = '-lang' then   //z.B. "-lang:en"
         begin lsLanguage := lsParVal; Continue; end;
      if lsParCom = '-langpath' then   //z.B. "-lang:en"
         begin lsLangPath := lsParVal; Continue; end;
      if lsParCom = '-arcid' then
         begin lsArcId := lsParVal;Continue; end;
   end;

   GnugettextTextdomain('ImporterV3', lsLangPath, lsLanguage);
   TranslateComponent(self);
   
   SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height,
      SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
   SetWindowLong(Handle, GWL_HWNDPARENT, 0);
end;

procedure Tfrm_Main.cb_ReferenzClick(Sender: TObject);
begin
   //  cb_Referenz.AutoDropDown:= true;
end;

procedure Tfrm_Main.cb_ReferenzKeyDown(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin
   //////////////////////////////////////////////////////////////////////////


   if (Key = VK_Return)//and (cb_Referenz.text <> '')
   then
   begin

      //    cb_Referenz.Items.Add(cb_Referenz.Text);

      //    cb_Referenz.text :='';
   end;


  {if (key=VK_DELETE) then
  begin
    cb_Referenz.Items.Delete(cb_Referenz.ItemIndex);
  end;}
end;

procedure Tfrm_Main.spdbt_addrefClick(Sender: TObject);
var
   i, j: integer;
begin
{  if edt_ref.Text <> '' then
  begin
   lb_ref.Items.Add(edt.Text);
   edt_ref.text :='';
  end;
  }

   if edt_ref.Text <> '' then
   begin
      if lb_ref.Items.IndexOf(edt_ref.Text) = -1 then
      begin
         lb_ref.Items.Add(edt_ref.Text);

         lb_ref.Canvas.Font := lb_ref.Font;
         j := 0;  // Set scroll width for terms
         for i := 0 to (lb_ref.Items.Count - 1) do
            if (lb_ref.Canvas.TextWidth(lb_ref.Items[i]) > j) then
               j := lb_ref.Canvas.TextWidth(lb_ref.Items[i]);
         lb_ref.ScrollWidth := j + 15;
         edt_ref.Text := '';
      end;
   end;
   edt_ref.SelectAll;
end;

procedure Tfrm_Main.spdbt_delrefClick(Sender: TObject);
var
   i, j: integer;
begin
   if edt_ref.Text <> '' then
   begin
      lb_ref.Items.Delete(lb_ref.Items.IndexOf(edt_ref.Text));

      lb_ref.Canvas.Font := lb_ref.Font;
      j := 0;  // Set scroll width for terms
      for i := 0 to (lb_ref.Items.Count - 1) do
         if (lb_ref.Canvas.TextWidth(lb_ref.Items[i]) > j) then
            j := lb_ref.Canvas.TextWidth(lb_ref.Items[i]);
      lb_ref.ScrollWidth := j + 15;
   end;
end;

procedure Tfrm_Main.edt_SlwKeyDown(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin
   if (key = VK_Return) and (edt_Slw.Text <> '') then
   begin
   	if lb_Slw.Items.IndexOf(edt_Slw.Text) = -1 then
      begin
         lb_Slw.Items.Add(edt_Slw.Text);
         edt_slw.Text := '';
      end;
   end;


   if (key = VK_DELETE) then
   begin
      if edt_Slw.Text <> '' then
         lb_Slw.Items.Delete(lb_Slw.Items.IndexOf(edt_Slw.Text));
   end;
end;

procedure Tfrm_Main.lb_SlwKeyDown(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin

   if (key = VK_DELETE) then
   begin
      if edt_Slw.Text <> '' then
         lb_Slw.Items.Delete(lb_Slw.Items.IndexOf(edt_Slw.Text));
   end;
end;


function tfrm_Main.sendviewermessage: string;
var
   CopyData: TCopyDataStruct;
   lsmesg: string;
   DataSize: Integer;
   Data: pchar;
   PData: PChar;
   Wdw: HWND;
begin
   Wdw := FindWindow(PChar('bitfarm.Viewer.V3'), nil);
   lsmesg := '-I:bitfarm.Importer.V3';
   DataSize := length(lsmesg);
   Inc(DataSize, Length(lsmesg) + 1);
   Data := StrAlloc(DataSize + 1);

   try
      PData := Data;
      StrPCopy(PData, lsmesg);
      Inc(PData, Length(lsmesg) + 1);
      PData^ := #0;
      CopyData.lpData := Data;
      CopyData.cbData := DataSize;
      CopyData.dwData := $DDED;
      Result := inttostr(SendMessage(Wdw, WM_COPYDATA, 0, LPARAM(@CopyData)));
   finally
      StrDispose(Data);
   end;
end;

procedure tfrm_Main.WndProc(var Msg: TMessage);
//////////////////////////////////////////////////////////////////
///  12.08.2005 Erstellt by SV                                 ///
///                                                            ///
///  bergibt die Windows Messages                             ///
///                                                            ///
//////////////////////////////////////////////////////////////////
begin
   if not frm_Main.HandleMessages(Msg) then
      inherited;
end;


function tfrm_Main.HandleMessages(var Msg: TMessage): Boolean;
var
   PData: PChar;
   Param: string;
begin
   if Msg.Msg = WM_COPYDATA then
   begin
      if TWMCopyData(Msg).CopyDataStruct.dwData = $DDED then
      begin
         PData := TWMCopyData(Msg).CopyDataStruct.lpData;
         while PData^ <> #0 do
         begin
            Param := StrPas(PData);
            sGusrname := Param;
            gbreceivedviewermessage := true;
            Inc(PData, Length(Param) + 1);
         end;
         Msg.Result := 1;
      end
      else
         Msg.Result := 0;
      application.ProcessMessages;

      Result := True;
   end
   else
      Result := False;
end;

procedure tfrm_Main.CreateParams(var Params: TCreateParams);
//////////////////////////////////////////////////////////////////
///  12.08.2005 Erstellt by SV                                 ///
///                                                            ///
///  bergibt Parameter an die Windows Message Que             ///
///                                                            ///
//////////////////////////////////////////////////////////////////
begin
   inherited;
   StrCopy(Params.WinClassName, 'bitfarm.Importer.V3');
   //  SingleInst.CreateParams(Params);
end;


{3.6<}
procedure Tfrm_Main.tbbt_searchClick(Sender: TObject);
var
   iCount, licount2, litop: integer;
   comp, comp2, comp3, comp4, comp5: TComponent;
   lCompFrame : TComponent; //TFrameZusFldMulti;
   bfound, bpflicht: boolean;
   lstext,lsconju: string;
   lsaddname, lsgroupby, lsSql, lsSql2, lsTmp: string;
   ncbx: TComboBox;
   lstlw: Tstringlist;
   FrameZusFldMulti: TFrameZusFldMulti;
   comp6, lfbedt: tcomponent;
   liScroll, xTmp: integer;
   xCfgTab  : clCfgTab;
   xCfgRec  : clCfgRec;
   xAddField: clAddField;
begin
   bpflicht := false;
   if gbdebug then
   begin
      LogEvnt('Tfrm_Main.btn_SearchClick');
   end;

	litop:= tbbt_search.Top;
   liscroll:= 0;
   dm_db.my_q_Tmp.sql.text := 'select * from arc_' + sIarcname;
   lsconju := ' and ';
   bfound := false;
   for iCount := 0 to (sbx_IZus.ComponentCount - 1) do
   begin
      comp := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmpchx' + IntToStr(iCount));
      comp2 := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmp' + IntToStr(iCount));
      comp3 := sbx_IZus.FindComponent('zlbl_Tmp' + IntToStr(iCount));
      //    comp5:= sbx_ZusFeld.FindComponent('jbzedt_Tmp' + IntToStr(iCount));
      if comp = NIL then
        break;

      lsaddname := tlabel(comp3).Hint;

      xCfgTab := clCfgTab.Create (sIArcName);
      xCfgTab.setFeldName (lsaddname);
      xCfgTab.load;
      xCfgRec := xCfgTab.getRec;

      if lsgroupby = '' then
      begin
         lsgroupby := lsaddname;
      end
      else
      begin
         lsgroupby := lsgroupby + ',' + lsaddname;
      end;
      if comp2 is Tedit then
      begin
         lstext := tedit(comp2).Text;
      end
      else
      if comp2 is TJvDateEdit then
      begin
         lstext := TJvDateEdit(comp2).Text;
      end
      else
      if comp2 is TComboBox then
      begin
         lstext := TComboBox(comp2).Text;
      end
      else
      if comp2 is TjvcheckedComboBox then
      begin
         lstext := TjvcheckedComboBox(comp2).Text;
      end
      else
      if comp2 is Tspinedit then
      begin
         lstext := Tspinedit(comp2).Text;
         comp4 := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmp_cbx_' + IntToStr(iCount));
         lstext := lstext + TComboBox(comp4).Text;
      end;

      if Tcheckbox(comp).Checked then
      begin
         // 20.10.2011 f.schneider  v3.5.1.11
         // wir suchen nur nach einem ganzen Ausdruck und trennen nicht nach Leerzeichen
         //lstlw := StrToWords(ParserSemiColonusebackspace(lstext));
         lstlw:= TStringList.Create();
         if xCfgRec.Typ = zfld01_Datum then
         begin
          lstext := FormatDateTime ('yyyy-mm-dd', StrToDate (lstext));

          lstlw.Add (lstext);
         end
         else
         begin
          lstlw.Add(ParseSemicolonUseBackslash(lstext));
         end;

         if not bfound then
         begin
            if lstlw.count > 0 then
            begin
               dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' where (';
               for licount2 := 0 to lstlw.Count - 1 do
               begin
                  lstlw.Strings[licount2] := Trim(stringreplace(lstlw.Strings[licount2], ',', '', [rfReplaceAll]));
                  if licount2 = 0 then
                  begin
                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + '(' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end
                  else
                  begin
                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' or (' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end;
               end;
               dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ')';
            end;
            bfound := true;
         end
         else
         begin
            dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + lsconju + '(';
            if lstlw.count > 0 then
            begin
               for licount2 := 0 to lstlw.Count - 1 do
               begin
                  lstlw.Strings[licount2] := Trim(stringreplace(lstlw.Strings[licount2], ',', '', [rfReplaceAll]));
                  if licount2 = 0 then
                  begin
                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + '(' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end
                  else
                  begin
                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' or (' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end;
               end;
               dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ')';
            end;
         end;
         freeandnil(lstlw);
      end;
   end;
   dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' group by ' + lsgroupby;
   dm_db.my_q_Tmp.Execute;

   for iCount := 0 to (sbx_IZus.ComponentCount - 1) do
   begin
      comp := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmpchx' + IntToStr(iCount));
      comp2 := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmp' + IntToStr(iCount));
      comp3 := sbx_IZus.FindComponent('zlbl_Tmp' + IntToStr(iCount));
      comp4 := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmp_cbx_' + IntToStr(iCount));
      comp5 := sbx_IZus.FindComponent('lfbzedt_Tmp' + IntToStr(iCount));
      comp6 := sbx_IZus.FindComponent('zedt_Tmptbxb' + IntToStr(iCount));
      lfbedt:= FindComponentRekursivFrame(sbx_IZus, 'lfbzedt_Tmp' +  IntToStr(iCount));

      if comp = NIL then
        break;

      if litop + 74 > sbx_IZus.Height then
      begin
          liscroll := 16;
      end
      else
      begin
          litop := tbbt_search.Top;
      end;

      if not Tcheckbox(comp).Checked then
      begin
         if comp2 is Tedit then
         begin
            if tedit(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TJvDateEdit then
         begin
            if TJvDateEdit(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TComboBox then
         begin
            if TComboBox(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TSpinEdit then
         begin
            if TSpinEdit(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TjvSpinEdit then
         begin
            if TjvSpinEdit(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TjvcheckedComboBox then
         begin
            if TjvcheckedComboBox(comp2).NoFocusColor = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end;
         comp2.Free;
         if comp4 <> nil then
         begin
            comp4.free;
         end;
         if comp5 <> nil then
         begin
            comp5.free;
         end;

         if lfbedt <> nil then
         	 (lfbedt as TTBXButton).Visible:= false;

         xTmp := sbx_IZus.VertScrollBar.Position;

         (comp6 as TTBXButton).ImageIndex:= 0;

         ncbx := TComboBox.Create(sbx_IZus);
         ncbx.Name := 'zedt_Tmp' + IntToStr(iCount);

         ncbx.Left := 28;
         ncbx.Top := 21 + (38 * iCount) - xTmp;
         ncbx.Height := 21;
         ncbx.Width := (sbx_IZus.Width - 70)-liScroll;
         ncbx.Anchors := [akLeft, akTop, akRight];
         ncbx.OnChange := frm_Main.zusfeldonchange;
         ncbx.Parent := sbx_IZus;

         ncbx.Clear;
         ncbx.Items.Add('');
         if bpflicht then
         begin
            ncbx.Color := cColorPflichtfeld;
         end;
         bpflicht:=False;
         ncbx.Sorted := true;
         dm_db.my_q_Tmp.First;
         while not dm_db.my_q_Tmp.eof do
         begin
            if (dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring <> '')
               and (0 >= ncbx.Items.IndexOf(dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring)) then
            begin
               ncbx.Items.Add(dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring);
            end;
            dm_db.my_q_Tmp.Next;
         end;
          if (ncbx as TComboBox).Items.Count = 2 then
          begin
             (ncbx as TComboBox).ItemIndex := 1;
          end;
      end;
   end;

  FreeAndNil    (xCfgTab);
end;


procedure Tfrm_Main.cbx_LgrCloseUp(Sender: TObject);
begin

   if (cbx_Lgr.Items.Count > cbx_Lgr.ItemIndex)
      and (cbx_Lgr.ItemIndex > -1) then
   begin
      if iGLgrID <> Integer(cbx_Lgr.Items.Objects[cbx_Lgr.ItemIndex]) then
      begin
         cbx_Lgr.OnChange(cbx_Lgr);
      end;
   end;
end;

procedure Tfrm_Main.cbx_ArcCloseUp(Sender: TObject);
begin
   if (cbx_Arc.Items.Count > cbx_Arc.ItemIndex)
      and (cbx_Arc.ItemIndex > -1) then
   begin
      if iGArcID <> Integer(cbx_Arc.Items.Objects[cbx_Arc.ItemIndex]) then
      begin
         cbx_Arc.OnChange(cbx_Arc);
      end;
   end;
end;

function Tfrm_Main.ClrZusFields: boolean;
//var iCount: Integer;
begin
   result := True;
   try
      ClearAdditionalFields(sbx_IZus);

   except
      on e: exception do
      begin
         ErrorMsg('ClrZusFields', 'Fehler beim Leeren der Zusatzfelder: ' +
            e.Message, 2006, True);
         result := False;
      end;
   end;
end;

procedure Tfrm_Main.tbxb_resetClick(Sender: TObject);
var i: integer;
begin
   //ClrZusFields;     //m.frey warum war das auskommentiert? siehe auch vtiger 2127
   //ClrZusFields; //m.frey, ich mache es wieder rein fr Rev 3.4.0.36
   // 3.5.0.12       f.schneider und mache es wieder raus
   for i := 0 to ZusWert.Count -1 do
      ZusWert.Strings[i] := '';

   cbx_Arc.ItemIndex :=
      cbx_Arc.Items.IndexOfObject(TObject(igarcid));
   iGArcID := -1;
   cbx_Arc.OnChange(cbx_Arc);
end;

{3.6<}
procedure Tfrm_Main.zusfeldonchange(Sender: TObject);
var
   lindex, liTmp: integer;
   lsadd, lsnc, sls, lsTmp: string;
   lcc: Tcomponent;
begin
   if sender.ClassName = 'TEdit' then
   begin
      lsadd := Actualfieldlist.Strings[strtoint(copy(TEdit(sender).name, 9, length(TEdit(sender).name)))];
      lindex := NOG_Fieldlist.IndexOf(lsadd);
      if lindex = -1 then
      begin
         NOG_Fieldlist.Add(lsadd);
         ZusWert.Add(TEdit(sender).Text);
      end
      else
      begin
         ZusWert.Strings[lindex] := TEdit(sender).Text;
      end;
   end;
   if sender.ClassName = 'TComboBox' then
   begin
       if pos('zedt_Tmp_cbx_', TComboBox(sender).name) > 0 then
      begin
         lsadd := Actualfieldlist.Strings[strtoint(copy(TComboBox(sender).name, 14, length(TComboBox(sender).name)))];

         lsnc := copy(TSpinEdit(sender).name, length('zedt_Tmp_cbx_') + 1, 1);
         lcc := (FindComponentRekursivFrame(frm_main.sbx_IZus, 'zedt_Tmp' + lsnc));
         if
         TSpinEdit(lcc).value = 0 then
         begin
            TSpinEdit(lcc).value := 1;
         end;
         sls := TSpinEdit(lcc).Text + TComboBox(sender).Text;
      end
      else
      begin
         lsadd := Actualfieldlist.Strings[strtoint(copy(TComboBox(sender).name, 9, length(TComboBox(sender).name)))];
         sls := TComboBox(sender).Text;
      end;
      lindex := NOG_Fieldlist.IndexOf(lsadd);
      if lindex = -1 then
      begin
         NOG_Fieldlist.Add(lsadd);
         ZusWert.Add(sls);
      end
      else
      begin
         ZusWert.Strings[lindex] := sls;
      end;

      if  (TComboBox(sender).Items.IndexOf(sls) = -1) and (sls <>'') then
      begin
         TComboBox(sender).Color := cColorRed;
      end
      else
      begin
         if TComboBox(sender).Color <> cColorNoRightInit then
	         TComboBox(sender).Color := cColorWhite;
      end;


   end;
   if sender is TJvDateEdit then
   begin
      //3.5.0.9 [2466]
      //lsadd := Actualfieldlist.Strings[strtoint(copy(TJvDateEdit(sender).name, 9, length(TJvDateEdit(sender).name)))];
      lsTmp:= copy(TJvDateEdit(sender).name, 9, length(TJvDateEdit(sender).name));
      liTmp := strtoint(lsTmp);
      if Actualfieldlist.Count = 0 then
         Exit;
      //\\3.5.0.9 [2466]

      lsadd := Actualfieldlist.Strings[liTmp];

      lindex := NOG_Fieldlist.IndexOf(lsadd);
      if lindex = -1 then
      begin
         NOG_Fieldlist.Add(lsadd);
         ZusWert.Add(TJvDateEdit(sender).Text);
      end
      else
      begin
         ZusWert.Strings[lindex] := TJvDateEdit(sender).Text;
      end;
   end;
   if sender is TJvSpinEdit then
   begin
      lsadd := Actualfieldlist.Strings[strtoint(copy(TJvSpinEdit(sender).name, 9, length(TJvSpinEdit(sender).name)))];
      lindex := NOG_Fieldlist.IndexOf(lsadd);
      if lindex = -1 then
      begin
         NOG_Fieldlist.Add(lsadd);
         ZusWert.Add(TJvSpinEdit(sender).Text);
      end
      else
      begin
         ZusWert.Strings[lindex] := TJvSpinEdit(sender).Text;
      end;
   end;
   if sender is TSpinEdit then
   begin
      // TSpinEdit(sender).MinValue:=0;

      lsnc := copy(TSpinEdit(sender).name, 9, Length(TSpinEdit(sender).name));
      lcc := (FindComponentRekursivFrame(frm_main.sbx_IZus, 'zedt_Tmp_cbx_' + lsnc));
      if lcc <> nil then
      begin
         if TCOMBOBOX(lcc).text = '' then
         begin
            TCOMBOBOX(lcc).itemindex := 0;
         end;
         sls := TSpinEdit(sender).Text + TCOMBOBOX(lcc).Text;
         lsadd := Actualfieldlist.Strings[strtoint(copy(TSpinEdit(sender).name, 9, length(TSpinEdit(sender).name)))];
         lindex := NOG_Fieldlist.IndexOf(lsadd);
         if lindex = -1 then
         begin
            NOG_Fieldlist.Add(lsadd);
            ZusWert.Add(sls);
         end
         else
         begin
            ZusWert.Strings[lindex] := sls;
         end;
      end;
   end;
end;
{>3.6}

procedure Tfrm_Main.auswahlfeldonchange(Sender: TObject);
var
   lindex, liTmp: integer;
   lsadd, lsnc, sls, lsTmp: string;
   lcc: Tcomponent;
begin

   if sender.ClassName = 'TComboBox' then
   begin
       if pos('zedt_Tmp_cbx_', TComboBox(sender).name) > 0 then
      begin
         lsadd := Actualfieldlist.Strings[strtoint(copy(TComboBox(sender).name, 14, length(TComboBox(sender).name)))];

         lsnc := copy(TSpinEdit(sender).name, length('zedt_Tmp_cbx_') + 1, 1);
         lcc := (FindComponentRekursivFrame(frm_main.sbx_IZus, 'zedt_Tmp' + lsnc));
         if
         TSpinEdit(lcc).value = 0 then
         begin
            TSpinEdit(lcc).value := 1;
         end;
         sls := TSpinEdit(lcc).Text + TComboBox(sender).Text;
      end
      else
      begin
         lsadd := Actualfieldlist.Strings[strtoint(copy(TComboBox(sender).name, 9, length(TComboBox(sender).name)))];
         sls := TComboBox(sender).Text;
      end;
      lindex := NOG_Fieldlist.IndexOf(lsadd);
      if lindex = -1 then
      begin
         NOG_Fieldlist.Add(lsadd);
         ZusWert.Add(sls);
      end
      else
      begin
         ZusWert.Strings[lindex] := sls;
      end;
      (*
      if  (TComboBox(sender).Items.IndexOf(sls) = -1) and (sls <>'') then
      begin
         TComboBox(sender).Color := cColorRed;
      end
      else
      begin  *)
         if TComboBox(sender).Color <> cColorNoRightInit then
	         TComboBox(sender).Color := cColorWhite;
      //end;


   end;

end;



procedure Tfrm_Main.FormActivate(Sender: TObject);
begin

   if not assigned(NOG_FieldList) then
      NOG_FieldList := Tstringlist.Create;
   if not assigned(Actualfieldlist) then
      Actualfieldlist := Tstringlist.Create;
   if not assigned(ZusWert) then
      ZusWert := tstringlist.Create;

   SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top, Width, Height,
      SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);  // und zurck
   SetWindowLong(Handle, GWL_HWNDPARENT, Application.Handle); // und zurck
end;


{3.6<}
procedure Tfrm_Main.Searchzusfield(Sender: TObject);
var lstlw: TStringList;
  procedure WertAuswerten(Werte:string;ComboBox: TJvCheckedComboBox);
   var i: integer;  sTmp: string;
   begin
      // v3.5.0.89 f.schneider Test
      lstlw := StrToWords6 (Werte);
      //lstlw := StrToWords7 ('"",' + Werte);
      try
         for i := 0 to lstlw.Count - 1 do
         begin
            sTmp := lstlw.Strings[i];
            //lstlw.Strings[licount2] := Trim(stringreplace(sTmp, ',', ' ', [rfReplaceAll])); //m.frey: das brauchen wir doch nicht mehr?
            if (ComboBox.Items.IndexOf(lstlw.Strings[i]) = -1) and  //noch nicht drin?
               (lstlw.Strings[i] <> '') then
            begin
               ComboBox.Items.Add(lstlw.Strings[i]);
            end;
         end;
      finally
         FreeAndNil(lstlw);
      end;
   end;
var
   lstmp, lssst, lsZusatzname, lsZusatzValue: string;
   linum: integer;
   lcomp, lcomp1, lfbedt: TComponent;
   FrameZusFldMulti: TFrameZusFldMulti;
   ljvst: tjvstatictext;
   bpflicht: boolean;
   ncbx: TComboBox;
   lsender: TTBXButton;
   lsItem: string; //[2351]
      xDateTmp: TDateTime;
   xAddField: clAddField;
   xTmp     : integer;
   bMehrFach: boolean;
  edt: array of TEdit;
  lbl: array of tjvstatictext;
  cbx: array of TComboBox;
  dat: array of TJvDateEdit;
  chx: array of Tcheckbox;
  tbxb: array of TTBXButton;
//  ccb: array of TcheckBox;
  spe: array of TSpinEdit;
  lfbit: array of TTBXButton;
  jccb: array of TjvcheckedComboBox;
  lganzzahl: array of TJvSpinEdit;
  ldouble: array of TjvSpinEdit;
  iC, //iCsave,  iEdt, iCbx, iDat,
  iTyp, iCntEdt, iCntCbx, iCntCCbx, iCntLbl, iCntDat,
  iCntchx, litaborder, //licount2,
  iCntbxb, iCntSpi,
  iCnttbxb, iCntganzzahl, iCntdouble, liTop, liScroll: integer;
  lfont: tfont;
//  lbfoundre,
  lbfound, lbrechte: boolean;
  lswert, lsDispName: string;
 // lstlw: Tstringlist;
  ZusFldFrame:TFrameZusFldMulti;
  lTyp     : eAddFieldType;
  sbxWidth: integer;
  s: string;
begin
   if gbdebug then
   begin
      LogEvnt('Tfrm_Main.Searchzusfield');
   end;
   iCntEdt := 0;
   iCntCbx := 0;
   iCntLbl := 0;
   iCntDat := 0;
   iCntChx := 0;
   iCnttbxb := 0;
   iCntbxb := 0;
   iCntCCbx := 0;
   iCntSpi := 0;
   iCntganzzahl := 0;
   iCntdouble := 0;
   litaborder := 2;

   litop := tbbt_search.Top;
   liScroll:= 0;

   sbxWidth:= sbx_IZus.Width;

   bpflicht := false;

   lbrechte := false;
   if gbHasCFGXS then
      dm_db.my_q_tmp_2.SQL.Text := 'select * from sys_cfgxs where arc_id='+IntToStr(iGArcID)
   else
   	dm_DB.my_q_tmp_2.SQL.Text := 'show tables like  "cfgxs_' + sIArcName + '"';
   try
      dm_DB.my_q_tmp_2.execute;
   except on e: exception do
      begin
      end;
   end;
   if dm_DB.my_q_tmp_2.recordcount > 0 then
   begin
   	if gbHasCFGXS then
         dm_db.my_q_tmp_2.SQL.Text := 'select * from sys_cfgxs where arc_id='+IntToStr(iGArcID)+' and usr_id = ' + inttostr(iGUsrID)
      else
      	dm_DB.my_q_tmp_2.SQL.Text := 'SELECT * FROM cfgxs_' + sIArcName + ' where usr_id = ' + inttostr(iGUsrID);
      try
         dm_DB.my_q_tmp_2.execute;
      except on e: exception do
         begin
         end;
      end;
      lbrechte := true;
   end;

   if (Sender as TTBXButton).ImageIndex = 1 then
   begin
   	(Sender as TTBXButton).ImageIndex:= 0;
      bpflicht := false;//[Warnung] u_dm_MainForm.pas(6051): Variable 'bpflicht' ist mglicherweise nicht initialisiert worden
      bMehrFach:= false;
      with frm_zuspflicht do
      begin
         lsender := TTBXButton(sender);
         lstmp := copy(lsender.name, length('zedt_Tmptbxb') + 1, length(lsender.name) - length('zedt_Tmptbxb'));
         trystrtoint(lstmp, linum);
         lcomp := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmp' + lstmp);
         ljvst := tjvstatictext(sbx_IZus.FindComponent('zlbl_Tmp' + lstmp));
         lfbedt:= FindComponentRekursivFrame(sbx_IZus, 'lfbzedt_Tmp' + lstmp);

         case ljvst.Tag of
           0:
           begin
              lssst := Tedit(lcomp).text;

              if tedit(lcomp).Color = cColorPflichtfeld then
              begin
                 bpflicht := true;
              end
              else
              begin
                 bpflicht := false;
              end;
           end;
           1:
           begin
              lssst    := TJvDateEdit(lcomp).text;
              if lssst <> cEmptyDateString then
              begin
                 xDateTmp := StrToDate      (lssst);
                 lssst    := FormatDateTime ('yyyy-mm-dd', xDateTmp);
              end
              else
                lssst:= '';

              if TJvDateEdit(lcomp).Color = cColorPflichtfeld then
              begin
                 bpflicht := true;
              end
              else
              begin
                 bpflicht := false;
              end;
           end;
           2:
           begin
              lssst := TComboBox(lcomp).text;
              if TComboBox(lcomp).Color = cColorPflichtfeld then
              begin
                 bpflicht := true;
              end
              else
              begin
                 bpflicht := false;
              end;
           end;
           3:
           begin
              lssst := TComboBox(lcomp).text;
              if lcomp is TJvCheckedComboBox then  //12.10.2010 b.takacs [2755] 3.5.0.109
                bMehrfach:= true;
              if TComboBox(lcomp).Color = cColorPflichtfeld then
              begin
                 bpflicht := true;
              end
              else
              begin
                 bpflicht := false;
              end;
           end;
           5:
           begin
              lssst := tspinedit(lcomp).text;
              lcomp1 := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmp_cbx_' + lstmp);
              lssst := lssst + TComboBox(lcomp1).text;
              lcomp1.Free;
              if tspinedit(lcomp).Color = cColorPflichtfeld then
              begin
                 bpflicht := true;
              end
              else
              begin
                 bpflicht := false;
              end;
           end;
         end;

         if lfbedt <> nil then
         	(lfbedt as TTBXButton).visible:= false;

         lcomp1 := sbx_IZus.FindComponent('jbzedt_Tmp' + lstmp);
         if lcomp1 <> nil then
         begin
           lcomp1.free;
         end;
         dm_db.my_q_CreZusTmp.sql.text := 'select * from arc_' + u_MainForm.sIArcname +
           ' where ' + lsender.hint + ' like ' + #39 + '%' + lssst + '%' + #39 + ' order by ' + lsender.hint + ';';
         dm_db.my_q_CreZusTmp.execute;

         lcomp.Free;

         if litop + 74 > sbx_IZus.Height then
         begin
             liscroll := 16;
         end
         else
         begin
             litop := tbbt_search.Top;
         end;

         ncbx:= TComboBox.Create(sbx_IZus);

         ncbx.Name := 'zedt_Tmp' + lstmp;


   		xTmp :=  sbx_IZus.VertScrollBar.Position;

         (ncbx as TComboBox).Left := 28;
         (ncbx as TComboBox).Hint := lsender.Hint;
         (ncbx as TComboBox).Top := 21 + (38 * linum) - xTmp;
         (ncbx as TComboBox).Height := 21;
         (ncbx as TComboBox).Width := (sbx_IZus.width - 70)-liScroll;
         (ncbx as TComboBox).Anchors := [akLeft, akTop, akRight];
         (ncbx as TComboBox).Parent := sbx_IZus;
         // Die Komponente erst am Schlu sichtbar machen
         (ncbx as TComboBox).Clear;
         (ncbx as TComboBox).Items.Add('');

         xAddField := clArchiv.getInstance.AddFieldTab.findComp ((ncbx as TComboBox).Name);

         if (xAddField <> nil) then
         begin
         	xAddField.isCatchWord := true;
         end;

         if bpflicht then
         begin
          (ncbx as TComboBox).Color := cColorPflichtfeld;
         end;
         dm_db.my_q_CreZusTmp.First;
         while not dm_db.my_q_CreZusTmp.eof do
         begin
            if (dm_db.my_q_CreZusTmp.fieldbyname(lsender.Hint).asstring <> '')
             and (0 >= (ncbx as TComboBox).Items.IndexOf(dm_db.my_q_CreZusTmp.fieldbyname(lsender.Hint).asstring)) then
            begin
             (ncbx as TComboBox).Items.Add(dm_db.my_q_CreZusTmp.fieldbyname(lsender.Hint).asstring);
            end;
            dm_db.my_q_CreZusTmp.Next;
         end;
         if (ncbx as TComboBox).Items.Count = 2 then
         begin
         	(ncbx as TComboBox).ItemIndex := 1;
         end;

       //end;

      end;
   end
   else if ((Sender as TTBXButton).ImageIndex = 0) then
   begin
      (Sender as TTBXButton).ImageIndex:= 1;
      bpflicht := false;//[Warnung] u_dm_MainForm.pas(6051): Variable 'bpflicht' ist mglicherweise nicht initialisiert worden
      bMehrFach:= false;
      with frm_zuspflicht do
      begin
         lsender := TTBXButton(sender);
         lstmp := copy(lsender.name, length('zedt_Tmptbxb') + 1, length(lsender.name) - length('zedt_Tmptbxb'));
         trystrtoint(lstmp, linum);
         lcomp := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmp' + lstmp);
         ljvst := tjvstatictext(sbx_IZus.FindComponent('zlbl_Tmp' + lstmp));
         case ljvst.Tag of
           0:
           begin
              lssst := Tedit(lcomp).text;

              if tedit(lcomp).Color = cColorPflichtfeld then
              begin
                 bpflicht := true;
              end
              else
              begin
                 bpflicht := false;
              end;
           end;
           1:
           begin
              lssst    := '';
            (*  xDateTmp := StrToDate      (lssst);
              lssst    := FormatDateTime ('yyyy-mm-dd', xDateTmp);  *)

              if TJvDateEdit(lcomp).Color = cColorPflichtfeld then
              begin
                 bpflicht := true;
              end
              else
              begin
                 bpflicht := false;
              end;
           end;
           2:
           begin
              lssst := TComboBox(lcomp).text;
              if TComboBox(lcomp).Color = cColorPflichtfeld then
              begin
                 bpflicht := true;
              end
              else
              begin
                 bpflicht := false;
              end;
           end;
           3:
           begin
              lssst := TComboBox(lcomp).text;
              if lcomp is TJvCheckedComboBox then  //12.10.2010 b.takacs [2755] 3.5.0.109
                bMehrfach:= true;
              if TComboBox(lcomp).Color = cColorPflichtfeld then
              begin
                 bpflicht := true;
              end
              else
              begin
                 bpflicht := false;
              end;
           end;
           5:
           begin
              lssst := tspinedit(lcomp).text;
              lcomp1 := FindComponentRekursivFrame(sbx_IZus, 'zedt_Tmp_cbx_' + lstmp);
              lssst := lssst + TComboBox(lcomp1).text;
              lcomp1.Free;
              if tspinedit(lcomp).Color = cColorPflichtfeld then
              begin
                 bpflicht := true;
              end
              else
              begin
                 bpflicht := false;
              end;
           end;
         end;

         lcomp1 := sbx_IZus.FindComponent('jbzedt_Tmp' + lstmp);
         if lcomp1 <> nil then
         begin
           lcomp1.free;
         end;

         lcomp.Free;

         sbx_IZus.Repaint;
         Application.ProcessMessages;

         s:= 'Select * from cfg_' + u_mainform.sIArcName +
          	'  where  (typ <> 4) and (Feld_Name=' + #39 + lsender.hint + #39 + ') order by pos';
         dm_DB.my_q_Tmp.SQL.Text := s;
         dm_db.my_q_Tmp.execute;

         lbfound := false;
         if lbrechte then
         begin
            dm_DB.my_q_tmp_2.first;
            while not dm_DB.my_q_tmp_2.eof do
            begin
               if dm_DB.my_q_tmp_2.fieldbyname('CFG_ID').AsInteger = dm_DB.my_q_Tmp.FieldByName('CFG_ID').AsInteger then
               begin
                  lbfound := true;
                  break;
               end;
               dm_DB.my_q_tmp_2.next;
            end;
         end
         else
            lbfound := True;

         if litop + 74 > sbx_IZus.Height then
         begin
             liscroll := 16;
         end
         else
         begin
             litop := (ljvst as TJvStaticText).Top;
         end;

         xTmp :=  sbx_IZus.VertScrollBar.Position;

         lTyp          := eAddFieldType (dm_DB.my_q_Tmp.FieldByName('Typ').AsInteger);
         IC:= strToInt(lstmp);
         if lTyp = zfld00_Universal then
         begin
                  SetLength(edt, iCntEdt + 1);
           frm_zuspflicht.CreateUniversal(false,edt,iCntEdt,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                 'zedt_Tmp',28,(sbxWidth-70)-liScroll,[akLeft,akTop,akRight], lbfound,xTmp);
           dec(iCntEdt,1);
           edt[iCntEdt].OnChange:= frm_Main.zusfeldonchange;
           inc(iCntEdt,1);
         end
         else
         if lTyp = zfld01_Datum then
         begin
            SetLength(dat, iCntDat + 1);
                   frm_zuspflicht.CreateDatum(false,dat,iCntDat,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                               'zedt_Tmp',28,150,[akLeft,akTop,akRight],lbfound,xTmp);
           dec(iCntDat,1);
           dat[iCntDat].OnChange:= frm_Main.zusfeldonchange;
           inc(iCntDat,1);
         end
         else
         if lTyp = zfld02_Auswahl then
         begin
            SetLength(cbx, iCntCbx + 1);
            frm_zuspflicht.CreateAuswahl(false,cbx,iCntCbx,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                  'zedt_Tmp',28,(sbxWidth-70)-liScroll,[akLeft,akTop,akRight],'',lbfound,xTmp);
           dec(iCntCbx,1);
           cbx[iCntCbx].OnChange:= frm_Main.zusfeldonchange;
           cbx[iCntCbx].OnExit:= nil;
           inc(iCntCbx,1);
         end
         else
         if lTyp = zfld03_MehrfachAuswahl then
         begin
             SetLength(lbl, iCntLbl + 1);
            lbl[iCntLbl] := TJvStaticText.Create(nil);
            lbl[iCntLbl].Name := lsender.Name;
            lbl[iCntLbl].Hint := lsender.Hint;
            lbl[iCntLbl].Tag := lsender.Tag;

            frm_zuspflicht.CreateMehrfachauswahl(false,lbl,ZusFldFrame,lfbit,jccb,iCntCCbx,iCntbxb,lsDispName,sbx_IZus,IC,lswert,litaborder,
               cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,sAdd,iCntLbl,28,(sbxWidth-70)-liScroll,u_MainForm.sIarcname,frm_Main.zusfeldonchange,lbfound,xTmp);
           SetLength(jccb, iCntCCbx + 1);
           jccb[iCntCCbx] := ZusFldFrame.ComboBox;
           Inc(iCntCCbx, 1);
           SetLength(lfbit, iCntbxb + 1);
           lfbit[iCntbxb] := ZusFldFrame.Button;
           ZusFldFrame.Button.Visible:= true;
           Inc(iCntbxb, 1);
         end
         else
         if lTyp = zfld05_Intervall then
         begin
            SetLength(spe, iCntSpi + 1);
            frm_zuspflicht.CreateIntervall(false,spe,iCntSpi,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                  'zedt_Tmp',28,75,[akLeft,akTop],lbfound,xTmp);
           dec(iCntSpi,1);
           spe[iCntSpi].OnChange:= frm_Main.zusfeldonchange;
           inc(iCntSpi,1);
         end
         else
         if lTyp = zfld06_GanzZahl then
         begin
            SetLength(lganzzahl, iCntganzzahl + 1);
            frm_zuspflicht.CreateGanzZahl(false,lganzzahl,iCntganzzahl,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                  'zedt_Tmp',28,75,[akLeft,akTop],lbfound,xTmp);
           dec(iCntganzzahl,1);
           lganzzahl[iCntganzzahl].OnChange:= frm_Main.zusfeldonchange;
           inc(iCntganzzahl,1);
         end
         else
         if   (lTyp = zfld07_FliessKomma)
           or (ltyp = zfld08_Waehrung   )
         then
         begin
            SetLength(ldouble, iCntdouble + 1);
            frm_zuspflicht.CreateFliessKommaWaehrung(false,ldouble,iCntdouble,sbx_IZus,IC,lswert,litaborder,cZusatzFeldOptEingabepflicht,dm_DB.my_q_Tmp,
                                  'zedt_Tmp',28,0,[akLeft,akTop],iTyp,lbfound,xTmp);
           dec(iCntdouble,1);
           ldouble[iCntdouble].OnChange:= frm_Main.zusfeldonchange;
           inc(iCntdouble,1);
         end;
      end;
	end;
end;


procedure Tfrm_Main.tbx_wvlfavbear0Click(Sender: TObject);
var
   lini: Tinifile;
   lstaskfavnr: string;
   litimeroptionen, licounter, licounter1, liindex,
   liabstand: integer;
   lstrl: TStringList;
begin
{  if mnu_Speicherinfo.Visible then
    logevnt('tbx_wvldelfavbear0Click');    }
   lini := tinifile.Create(GetSystemVariable('APPDATA') + '\bitfarm-archiv\' +
      'wvlfav.ini');
   licounter1 := ttbxitem(Sender).Tag;
   lstaskfavnr := 'Task' + IntToStr(licounter1);
   try
      try
         with lini do
         begin

            litimeroptionen := 0;
            if Valueexists(lstaskfavnr, 'Optionen') then
            begin
               litimeroptionen := ReadInteger(lstaskfavnr, 'Optionen', litimeroptionen);
            end;
            for licounter := 0 to jcbx_opttim.Items.Count - 1 do
            begin
               // Nach Erledigung zurck 2
               // Erinnerungsmail senden 4
               // nicht Einzelmodusinbearbeitung 8

               if ((litimeroptionen and (1 shl (licounter + 1))) =
                  (1 shl (licounter + 1))) then
               begin
                  jcbx_opttim.Checked[licounter] := True;
               end
               else
               begin
                  jcbx_opttim.Checked[licounter] := False;
               end;
            end;
            lstrl := StrToWords(stringreplace(ReadString(lstaskfavnr,
               'Workersje', ''), ',', ' ', [rfReplaceAll]));
            JvCCB_je.SetUnCheckedAll(nil);
            for licounter := 0 to lstrl.Count - 1 do
            begin
               liindex := JvCCB_je.Items.IndexOf(lstrl.Strings[licounter]);
               if liindex > -1 then
               begin
                  JvCCB_je.Checked[liindex] := True;
               end
               else
               begin
                  JvCCB_je.Checked[licounter] := False;
               end;
            end;
            lstrl.Free;
            lstrl := StrToWords(stringreplace(ReadString(lstaskfavnr, 'Workersefa', ''),
               ',', ' ', [rfReplaceAll]));
            JvCCB_efa.SetUnCheckedAll(nil);
            for licounter := 0 to lstrl.Count - 1 do
            begin
               liindex := JvCCB_efa.Items.IndexOf(lstrl.Strings[licounter]);
               if liindex > -1 then
               begin
                  JvCCB_efa.Checked[liindex] := True;
               end
               else
               begin
                  JvCCB_efa.Checked[licounter] := False;
               end;
            end;
            lstrl.Free;
            lstrl := StrToWordswvl(
               stringreplace(ReadString(lstaskfavnr, 'Workerseb', ''),
               ',', ' ', [rfReplaceAll]));
            JvCCB_eb.SetUnCheckedAll(nil);
            for licounter := 0 to lstrl.Count - 1 do
            begin
               liindex := JvCCB_eb.Items.IndexOf(lstrl.Strings[licounter]);
               if liindex > -1 then
               begin
                  JvCCB_eb.Checked[liindex] := True;
               end
               else
               begin
                  JvCCB_eb.Checked[licounter] := False;
               end;
            end;
            lstrl.Free;
            liabstand := ReadInteger('Task' + IntToStr(licounter), 'Abstand', 7);
            //          frm_AddDocTime.dtp_DocTime.datetime := now;
            jde_termin.date := now;
            jde_erinnerung.Date := now + liabstand;
            edt_info.Text := ReadString(lstaskfavnr, 'Info', '');
         end;
      except
         on e: Exception do
         begin
         end;
      end;
   finally
      begin
         if Assigned(lini) then
         begin
            lini.UpdateFile;
            FreeAndNil(lini);
         end;
      end;
   end;
end;


procedure Tfrm_Main.loadfavwvlhints;
var
   lini: Tinifile;
   lstrl, lsgrpe, lsgrpf: TStringList;
   licounter, liabstand: integer;
   lsmemotext, lsadd, lsjunk: string;
   lttbitem: ttbxitem;
   lbfoundonce: boolean;
begin
   tbx_favwvl.Visible := false;
   try
      try
         if not fileexists(GetSystemVariable('APPDATA') + '\bitfarm-archiv\' +
            'wvlfav.ini') then
            exit;
         lini := tinifile.Create(GetSystemVariable('APPDATA') +
            '\bitfarm-archiv\' + 'wvlfav.ini');
         with lini do
         begin
            lbfoundonce := false;
            for licounter := 0 to 9 do
            begin

               if assigned(lstrl) then
                  FreeAndNil(lstrl);
               lttbitem := ttbxitem(FindComponent('tbx_wvlfavbear' + IntToStr(liCounter)));

               if lini.SectionExists('Task' + inttostr(licounter)) then
               begin
                  lstrl := StrToWordswvl(
                     stringreplace(ReadString('Task' + IntToStr(licounter), 'Workerseb', ''),
                     ',', ' ', [rfReplaceAll]));

                  lsgrpf := StrToWordswvl(
                     stringreplace(ReadString('Task' + IntToStr(licounter), 'Workersefa', ''),
                     ',', ' ', [rfReplaceAll]));
                  lsgrpe := StrToWordswvl(
                     stringreplace(ReadString('Task' + IntToStr(licounter), 'Workersje', ''),
                     ',', ' ', [rfReplaceAll]));
                  lsmemotext := ReadString('Task' + IntToStr(licounter), 'Info', '');
                  liabstand := ReadInteger('Task' + IntToStr(licounter), 'Abstand', 7);
                  lsadd := '';
                  lsjunk := '';
                  if trim(lstrl.text) <> '' then
                  begin
                     lsadd := 'Bearbeiter:' + lstrl.text;
                  end;
                  if trim(lsgrpf.text) <> '' then
                  begin
                     lsadd := lsadd + 'Gruppen:' + lsgrpf.text;
                  end;
                  if (trim(lsgrpf.text) <> '') and (trim(lsgrpe.text) <> '') then
                  begin
                     lsadd := lsadd + ';' + lsgrpe.text;
                     lsjunk := ';';
                  end
                  else
                  if (trim(lsgrpe.text) <> '') then
                  begin
                     lsadd := lsadd + 'Gruppen:' + lsgrpe.text;
                     lsjunk := ';';
                  end;
                  if trim(lsmemotext) <> '' then
                  begin
                     lsadd := lsadd + lsjunk + ' Info:' + lsmemotext;
                     lsjunk := ';';
                  end;
                  lttbitem.Hint := lsadd
                     + lsjunk + ' Frist:' + inttostr(liabstand) + ' Tage';
                  lttbitem.Visible := true;
                  lbfoundonce := true;
               end
               else
               begin
                  lttbitem.Visible := false;
                  lttbitem.Hint := '';
               end;
            end;
            if lbfoundonce then
            begin
               tbx_favwvl.Visible := true;
            end
            else
            begin
               tbx_favwvl.Visible := false;
            end;
         end;
      except
         on e: Exception do
         begin
         end;
      end;
   finally
      if assigned(lini) then
         FreeAndNil(lini);
      if assigned(lstrl) then
         FreeAndNil(lstrl);
   end;
end;


procedure Tfrm_Main.lb_refClick(Sender: TObject);
var iCount: Integer;
begin
   for iCount := 0 to (lb_ref.Items.Count - 1) do
      if lb_ref.Selected[iCount] then
      begin
         edt_ref.Text := lb_ref.Items.Strings[iCount];
         break;
      end;
end;

procedure Tfrm_Main.edt_refKeyDown(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin

   if (key = VK_Return) and (edt_ref.Text <> '') then
   begin
   	if lb_ref.Items.IndexOf(edt_ref.Text) = -1 then
      begin
         lb_ref.Items.Add(edt_ref.Text);
         edt_ref.Text := '';
      end;
   end;


   if (key = VK_DELETE) then
   begin
      if edt_ref.Text <> '' then
         lb_ref.Items.Delete(lb_ref.Items.IndexOf(edt_ref.Text));
   end;
end;


procedure Tfrm_Main.copygdocidclipbrd;
var
   sID: string;
   lstitel: string;
begin
   sID := inttostr(figdocid);
   if trim(jvetitel.Text) = '' then
   begin
      lstitel := 'gdocid:' + sID;
   end
   else
   begin
      lstitel := jvetitel.Text;
   end;
   dm_main.cplinktoclbrd('gdocid:' + sID, '<a href="gdocid:' + sID + '">' + lstitel + '</a>');
end;
//
//  Name: CheckFieldinComboBox
//  Parameters:  cbx: TJvCheckedComboBox
//  Description:  check the checkbox in the list
//  Return value:
// [2520] 3.5.0.17 b.takacs
//------------------------------------------------------------------------------
procedure Tfrm_Main.CheckFieldinComboBox(cbx: TJvCheckedComboBox);
var
	i,j : integer;
  tmp, tmp2: string;
begin
  if cbx.Text <> '' then
  begin
    i:= 1;
    tmp:= '';
    tmp2:= cbx.Text;
    while (Pos(';',tmp2)>0) and (i<=Length(tmp2)+1) do
    begin
      if (tmp2[i]<>';') and (i<=Length(tmp2)) then
      	tmp:= tmp + tmp2[i]
      else
      begin
      	for j:=1 to cbx.Items.Count do
        begin
          if cbx.Items[j] = tmp then
          begin
          	cbx.Checked[j]:= true;
          end;
        end;
        tmp:= '';
      end;

    	inc(i);
    end;
  end;
end;
//

procedure Tfrm_Main.dbtv_MainAdvancedCustomDrawItem(
  Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState;
  Stage: TCustomDrawStage; var PaintImages, DefaultDraw: Boolean);
begin
   //highlight with clgray!
   if Sender.canvas.brush.color = clHighlight then
   begin
      Sender.canvas.brush.color := clgray;
      Sender.Canvas.Font.Style := [fsBold];
    end;
    If (State = [cdsHot]) and (Stage = cdPrePaint) then
    begin
      Sender.Canvas.Font.Style := [fsUnderline];
      Sender.Canvas.Font.Color := clBlue;
    end
    else if not (cdsSelected in State) then
    begin
      Sender.Canvas.Font.Style := [fsUnderline];
      Sender.Canvas.Font.Style := [];
    end;
end;

procedure Tfrm_Main.tbxtm1Click(Sender: TObject);
begin
	frm_Main.Close();
end;

procedure Tfrm_Main.tbxtm5Click(Sender: TObject);
begin
   frm_Opt.ShowModal;
   frm_Main.LoadOptReg;
end;

procedure Tfrm_Main.tbxtm4Click(Sender: TObject);
begin
   //frm_Main.sbtn_TExitClick(self);
end;

procedure Tfrm_Main.tbxtm3Click(Sender: TObject);
begin
	dm_Main.stdzusatz(self);
end;

procedure Tfrm_Main.tbxtm2Click(Sender: TObject);
begin
	frm_Main.ShowPrgInfo;
end;

procedure Tfrm_Main.btn1Click(Sender: TObject);
begin
   OutputDebugString('');

end;

procedure Tfrm_Main.Splitter1CanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
	if frm_Main.Width - NewSize < 300 then
   	Accept := False;
end;


end.


