unit u_dm_Main;

interface

uses
   SysUtils, Classes, ImgList, Controls, JvImageList, JvComponent,
   JvAppEvent, TB2Item, TBX, Menus, JvAppStorage, JvAppRegistryStorage,
   JvComponentBase, Dialogs, JvDialogs,
   StdCtrls, ieview, imageenview, ievect, shellapi, strutils, Windows, forms,
   gnugettext, u_ShBase, u_ShDbUtils, u_ShHighUtils, u_ShVoransicht,
   u_ShLowUtils, u_ShFrameZusFldMulti;

type
   Tdm_Main = class (TDataModule)
    il_Main_alt: TJvImageList;
      japp_Evnt: TJvAppEvents;
      jil_DocToolbar: TJvImageList;
      jil_Optionen: TJvImageList;
      jil_LgrArc: TJvImageList;
      jil_ScanFunc: TJvImageList;
      jil_Scroll: TJvImageList;
      tpum_DocTools: TTBXPopupMenu;
      tbsi_Comp: TTBXSubmenuItem;
      tbi_CompAuto: TTBXItem;
      tbsep_Comp_1: TTBXSeparatorItem;
      tbi_CompG4: TTBXItem;
      tbi_CompLZW: TTBXItem;
      tbi_CompPack: TTBXItem;
      tbi_CompJpeg: TTBXItem;
      tbi_TTurnRight: TTBXItem;
      tbi_TFlip: TTBXItem;
      tbi_TTurnLeft: TTBXItem;
      tbsep_T1: TTBXSeparatorItem;
      tbi_TDelPage: TTBXItem;
      tbi_TRemPixel: TTBXItem;
      tbi_TDeSkew: TTBXItem;
      tbi_TRemBorder: TTBXItem;
      tbsep_T2: TTBXSeparatorItem;
      tbi_TLastPg: TTBXItem;
      tbi_TPgNext: TTBXItem;
      tbi_TPgPrev: TTBXItem;
      tbi_TFirstPg: TTBXItem;
      tbsi_Col: TTBXSubmenuItem;
      tbi_ColTrue: TTBXItem;
      tbi_ColPal8: TTBXItem;
      tbi_ColPal4: TTBXItem;
      tbi_ColSW: TTBXItem;
      tbsi_Tools: TTBXSubmenuItem;
      tbsep_Comp_2: TTBXSeparatorItem;
      tbi_CompUn: TTBXItem;
      tbi_ColGray4: TTBXItem;
      tbi_ColGray8: TTBXItem;
      appRegStorage: TJvAppRegistryStorage;
      jil_Menu: TJvImageList;
      ImageList1: TImageList;
      tbsi_zusfields: TTBXSubmenuItem;
      im_list16: TImageList;
      im_doctoolbar16: TImageList;
      pum_standard: TPopupMenu;
      Rckgngig1: TMenuItem;
      N1: TMenuItem;
      Ausschneiden1: TMenuItem;
      Kopieren1: TMenuItem;
      Einfgen1: TMenuItem;
      Lschen1: TMenuItem;
      N2: TMenuItem;
      AllesMarkieren1: TMenuItem;
      N3: TMenuItem;
      Dokumentendatenlschen1: TMenuItem;
      Wiedervorlagedatenlschen1: TMenuItem;
      DokundWvldatenlschen1: TMenuItem;
      il_LgrArc: TImageList;
    il_stempelfav2: TImageList;
    il_stempelfav: TImageList;
    il_Main: TImageList;
      procedure tbi_TTurnLeftClick(Sender: TObject);
      procedure tbi_TFlipClick(Sender: TObject);
      procedure tbi_TTurnRightClick(Sender: TObject);
      procedure tbi_TRemBorderClick(Sender: TObject);
      procedure tbi_TDeSkewClick(Sender: TObject);
      procedure tbi_TRemPixelClick(Sender: TObject);
      procedure tbi_TDelPageClick(Sender: TObject);
      procedure tbi_TFirstPgClick(Sender: TObject);
      procedure tbi_TPgPrevClick(Sender: TObject);
      procedure tbi_TPgNextClick(Sender: TObject);
      procedure tbi_TLastPgClick(Sender: TObject);
      procedure tbi_CompAutoClick(Sender: TObject);
      procedure tbi_CompPackClick(Sender: TObject);
      procedure tbi_CompG4Click(Sender: TObject);
      procedure tbi_CompLZWClick(Sender: TObject);
      procedure tbi_CompJpegClick(Sender: TObject);
      procedure tbi_CompUnClick(Sender: TObject);
      procedure tbi_ColSWClick(Sender: TObject);
      procedure tbi_ColGray4Click(Sender: TObject);
      procedure tbi_ColPal4Click(Sender: TObject);
      procedure tbi_ColGray8Click(Sender: TObject);
      procedure tbi_ColPal8Click(Sender: TObject);
      procedure tbi_ColTrueClick(Sender: TObject);
      procedure Rckgngig1Click(Sender: TObject);
      procedure Ausschneiden1Click(Sender: TObject);
      procedure Kopieren1Click(Sender: TObject);
      procedure Einfgen1Click(Sender: TObject);
      procedure Lschen1Click(Sender: TObject);
      procedure AllesMarkieren1Click(Sender: TObject);
      procedure Dokumentendatenlschen1Click(Sender: TObject);
      procedure Wiedervorlagedatenlschen1Click(Sender: TObject);
      procedure DokundWvldatenlschen1Click(Sender: TObject);
      procedure DataModuleCreate(Sender: TObject);
   private
      function FormatHTMLClipboardHeader(HTMLText: string): string;
   public
      fbshowformtext: boolean;

      procedure cplinktoclbrd(const str, htmlStr: string);
      function ShellExecute_AndWait(Operation, FileName,
         Parameter, Directory: string; Show: word; bWait: boolean): longint;
      function StrToWords2(const InputStr: string): TStringList;
      procedure pum_ImpZusClick(Sender: TObject);
      procedure createannodata(fidx: integer);
//      function ReadObjVals(ObjType, Idx: integer): boolean;
//      function CheckObjVals: boolean;
      { Private-Deklarationen }
      { Public-Deklarationen }
   end;

var
   dm_Main: Tdm_Main;

implementation

uses u_Main, Registry, graphics, Messages;
{$R *.dfm}

procedure Tdm_Main.tbi_TTurnLeftClick(Sender: TObject);
begin
   frm_Main.tbi_PV_TurnLeft.Click;
end;

procedure Tdm_Main.tbi_TFlipClick(Sender: TObject);
begin
   frm_Main.tbi_PV_Flip.Click;
end;

procedure Tdm_Main.tbi_TTurnRightClick(Sender: TObject);
begin
   frm_Main.tbi_PV_TurnRight.Click;
end;

procedure Tdm_Main.tbi_TRemBorderClick(Sender: TObject);
begin
   frm_Main.tbi_PV_RemBorder.Click;
end;

procedure Tdm_Main.tbi_TDeSkewClick(Sender: TObject);
begin
   frm_Main.tbi_PV_DeSkew.Click;
end;

procedure Tdm_Main.tbi_TRemPixelClick(Sender: TObject);
begin
   frm_Main.tbi_PV_RemPixel.Click;
end;

procedure Tdm_Main.tbi_TDelPageClick(Sender: TObject);
begin
   frm_Main.tbi_PV_DelPageClick(Sender);
end;

procedure Tdm_Main.tbi_TFirstPgClick(Sender: TObject);
begin
   frm_Main.tbi_PV_FirstPg.Click;
end;

procedure Tdm_Main.tbi_TPgPrevClick(Sender: TObject);
begin
   frm_Main.tbi_PV_PgPrev.Click;
end;

procedure Tdm_Main.tbi_TPgNextClick(Sender: TObject);
begin
   frm_Main.tbi_PV_PgNext.Click;
end;

procedure Tdm_Main.tbi_TLastPgClick(Sender: TObject);
begin
   frm_Main.tbi_PV_LastPg.Click;
end;

procedure Tdm_Main.tbi_CompAutoClick(Sender: TObject);
begin
   frm_Main.Compress(0);
end;

procedure Tdm_Main.tbi_CompPackClick(Sender: TObject);
begin
   frm_Main.Compress(1);
end;

procedure Tdm_Main.tbi_CompG4Click(Sender: TObject);
begin
   frm_Main.Compress(2);
end;

procedure Tdm_Main.tbi_CompLZWClick(Sender: TObject);
begin
   frm_Main.Compress(3);
end;

procedure Tdm_Main.tbi_CompJpegClick(Sender: TObject);
begin
   frm_Main.Compress(4);
end;

procedure Tdm_Main.tbi_CompUnClick(Sender: TObject);
begin
   frm_Main.Compress(5);
end;

procedure Tdm_Main.tbi_ColSWClick(Sender: TObject);
begin
   frm_Main.ChangeColor(0);
end;

procedure Tdm_Main.tbi_ColGray4Click(Sender: TObject);
begin
   frm_Main.ChangeColor(1);
end;

procedure Tdm_Main.tbi_ColPal4Click(Sender: TObject);
begin
   frm_Main.ChangeColor(2);
end;

procedure Tdm_Main.tbi_ColGray8Click(Sender: TObject);
begin
   frm_Main.ChangeColor(3);
end;

procedure Tdm_Main.tbi_ColPal8Click(Sender: TObject);
begin
   frm_Main.ChangeColor(4);
end;

procedure Tdm_Main.tbi_ColTrueClick(Sender: TObject);
begin
   frm_Main.ChangeColor(5);
end;


procedure Tdm_Main.pum_ImpZusClick(Sender: TObject);
var
   TmpEdt: TEdit;
   lstr: Tstringlist;
   im: TImageEnVect;
   lsdocname, lsoutput: string;
   lst1: Tstringlist;
   li, lipos1, lipos2, lipos3: integer;
begin
  	try
      with Sender as TTBCustomItem do
      begin
         TmpEdt := TEdit(FindComponentRekursivFrame(frm_main.sbx_IZus, 'zedt_Tmp' +
            Copy(Hint, 9, Length(Hint)))); //#3.5

         if TmpEdt = nil then
            Exit;

         if frm_Main.fra_Voransicht.img_DocView.Selected then
         begin
            lstr := Tstringlist.create;
            im := TImageEnVect.Create(nil);
            frm_Main.fra_Voransicht.img_DocView.CopySelectionToBitmap(im.Bitmap);
            lsdocname := GetSystemVariable('temp') + '\temp.pbm';
            im.IO.SaveToFile(lsdocname);
            lsoutput := changefileext(lsdocname, '.html');
            logevnt('"' + extractfilepath(ParamStr(0)) + 'Viewer-Files\ocrocmd\ocrocmd.exe" "' +
               lsdocname + '"  "' + lsoutput + '"');

            ShellExecute_AndWait('',
               extractfilepath(ParamStr(0)) + 'Viewer-Files\bats\ocroexec.bat',
               '"' + extractfilepath(ParamStr(0)) + 'Viewer-Files\ocrocmd\ocrocmd.exe" "' +
               lsdocname + '"  "' + lsoutput + '"',
               extractfilepath(ParamStr(0)), SW_hide, True);
            im.free;

            lst1 := Tstringlist.create;
            lst1.LoadFromFile(lsoutput);
            for li := 0 to lst1.Count - 1 do
            begin
               lipos1 := pos('title=' + #39 + 'bbox', lst1.Strings[li]);

               if lipos1 > 0 then
               begin
                  lipos2 := posex('>', lst1.Strings[li], lipos1);
                  lipos3 := posex('</span>', lst1.Strings[li], lipos2);
                  if lipos3 = 0 then
                  begin
                     lipos3 := length(lst1.Strings[li]);
                  end;
                  lstr.Add(copy(lst1.Strings[li], lipos2 + 1, lipos3 - lipos2 - 1));
               end;
            end;
            TmpEdt.Text := trim(lstr.Text);
            TmpEdt.Modified := True;
            TmpEdt.Tag := TmpEdt.Tag or 4;
         end;
      end;
   finally
      frm_Main.fra_Voransicht.img_DocView.DeSelect;
      frm_Main.tbi_normalmouseClick(sender);
   end;
end;



function Tdm_Main.ShellExecute_AndWait(Operation, FileName,
   Parameter, Directory: string; Show: word; bWait: boolean): longint;
var
   bOK: boolean;
   Info: TShellExecuteInfo;
{
  ****** Parameters ******
  Operation:

  edit  Launches an editor and opens the document for editing.
  explore Explores the folder specified by lpFile.
  find Initiates a search starting from the specified directory.
  open Opens the file, folder specified by the lpFile parameter.
  print Prints the document file specified by lpFile.
  properties Displays the file or folder's properties.

  FileName:

  Specifies the name of the file or object on which
  ShellExecuteEx will perform the action specified by the lpVerb parameter.

  Parameter:

  String that contains the application parameters.
  The parameters must be separated by spaces.

  Directory:

  specifies the name of the working directory.
  If this member is not specified, the current directory is used as the working directory.

  Show:

  Flags that specify how an application is to be shown when it is opened.
  It can be one of the SW_ values

  bWait:

  If true, the function waits for the process to terminate
}
begin
   FillChar(Info, SizeOf(Info), Chr(0));
   Info.cbSize := SizeOf(Info);
   Info.fMask := SEE_MASK_NOCLOSEPROCESS;
   Info.lpVerb := PChar(Operation);
   Info.lpFile := PChar(FileName);
   Info.lpParameters := PChar(Parameter);
   Info.lpDirectory := PChar(Directory);
   Info.nShow := Show;
   bOK := boolean(ShellExecuteEx(@Info));
   if bOK then
   begin
      if bWait then
      begin
         while
            WaitForSingleObject(Info.hProcess, 100) = WAIT_TIMEOUT do
            Application.ProcessMessages;
         bOK := GetExitCodeProcess(Info.hProcess, DWORD(Result));
      end
      else
         Result := 0;
   end;
   if not bOK then
      Result := -1;
end;


function Tdm_Main.StrToWords2(const InputStr: string): TStringList;
   //////////////////////////////////////////////////////////////////
   ///  30.08.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function zerlegt einen String in einzelne Worte     ///
   ///  bzw Phrasen und listet diese in einer Stringlist auf.     ///
   ///                                                            ///
   ///  Parameter: InputStr        String mit Suchbegriffen       ///
   ///                                                            ///
   ///  Ausgabe: StringList mit einzelnen Worten und Phrasen      ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
const
   sTrennZeichen = ' .,!?';
var
   iCount, iWortStart, iWortEnde: integer;
   bPhrase: boolean;
   sWort: string;
begin
   Result := TStringList.Create;
   Result.Clear;

   if trim(inputstr) = '' then
      exit;
   iWortStart := 0;
   iWortEnde := 0;
   iCount := 0;
   bPhrase := False;
   while iCount <= Length(InputStr) do
   begin
      if IsDelimiter('"', InputStr, iCount) then
      begin
         if not bPhrase then
         begin
            bPhrase := True;
            iWortStart := iCount + 1;
            //if IsDelimiter('+-*', InputStr, iCount - 1) then inc(iCount, 1);
         end
         else
            bPhrase := False;
      end;
      if IsDelimiter(sTrennZeichen, InputStr, iCount) and not bPhrase then
      begin
         if iWortStart <= iWortEnde then
         begin
            iWortEnde := iCount;
            sWort := Trim(StringReplace(Copy(InputStr, iWortStart,
               iWortEnde - iWortStart), '"', '', [rfReplaceAll]));
            if swort <> '' then
            begin
               if (Ord(sWort[1]) = $2B) or (Ord(sWort[1]) = $2D) then
                  sWort := Copy(sWort, 2, Length(sWort));
               Result.Add(sWort);
            end;
            
            iWortStart := iWortEnde + 1;
         end;
      end;
      iWortEnde := iCount;
      Inc(iCount);
   end;
   if iWortStart < iWortEnde then
      Result.Add(Trim(StringReplace(Copy(InputStr, iWortStart, 1 +
         iWortEnde - iWortStart), '"', '', [rfReplaceAll])));
end;



procedure Tdm_Main.createannodata(fidx: integer);
var

   mydata: PAnnoData;
   lstmp: string;
begin
   getmem(mydata, sizeof(TAnnoData));

   mydata^.Ersteller := sGUsrName;
   mydata^.Veraenderer := '';
   DateTimeToString(lstmp, 'dd.mm.yyyy hh:nn:ss', now);
   mydata^.Datum := lstmp;
   mydata^.version := '0.1';
   frm_Main.fra_Voransicht.img_DocView.ObjUserDataLength[fidx] := sizeof(TAnnoData);
   frm_Main.fra_Voransicht.img_DocView.ObjUserData[fidx] := mydata;
end;


//function Tdm_Main.ReadObjVals(ObjType, Idx: integer): boolean;
//var
//   reg: TRegistry;
//   fsTmp: TFontStyles;
//   shTmp: TIEShape;
//   bsTmp: TBrushStyle;
//   lpTmp: TIELabelPos;
//   psTmp: TPenStyle;
//   rtTmp: TIEVRulerType;
//   ruTmp: TIEUnits;
//   //    ssTmp: TIEVSoftShadow;
//   osTmp: TIEVStyle;
//   taTmp: TIEAlignment;
//   sRegKeyName: string;
//begin
//   Result := True;
//   CheckObjVals;
//   reg := TRegistry.Create;
//   case ObjType of
//      0:
//         sRegKeyName := 'Line';
//      1:
//         sRegKeyName := 'Box';
//      2:
//         sRegKeyName := 'Ellipse';
//      3:
//         sRegKeyName := 'Arc';
//      4:
//         sRegKeyName := 'Bitmap';
//      5:
//         sRegKeyName := 'Text';
//      6:
//         sRegKeyName := 'Ruler';
//      7:
//         sRegKeyName := 'Polyline';
//      8:
//         sRegKeyName := 'Angle';
//      9:
//         sRegKeyName := 'Note';
//      10:
//         sRegKeyName := 'LineLabel';
//      11:
//         sRegKeyName := 'HiLite';
//      12:
//         sRegKeyName := 'Poligon';
//      13:
//         sRegKeyName := 'FreeHand';
//      14:
//         sRegKeyName := 'Arrow';
//      15:
//         sRegKeyName := 'Text';
//      16:
//         sRegKeyName := 'Freihand';
//      17:
//         sRegKeyName := 'Freihand1';
//      18:
//         sRegKeyName := 'Freihand2';
//      19:
//         sRegKeyName := 'Freihand3';
//      20:
//         sRegKeyName := 'Freihand4';
//      21:
//         sRegKeyName := 'Text1';
//      22:
//         sRegKeyName := 'Text2';
//      23:
//         sRegKeyName := 'Text3';
//      24:
//         sRegKeyName := 'Text4';
//      25:
//         sRegKeyName := 'Note1';
//      26:
//         sRegKeyName := 'Note2';
//      27:
//         sRegKeyName := 'Note3';
//      28:
//         sRegKeyName := 'Note4';
//      29:
//         sRegKeyName := 'HiLite1';
//      30:
//         sRegKeyName := 'HiLite2';
//      31:
//         sRegKeyName := 'HiLite3';
//      32:
//         sRegKeyName := 'HiLite4';
//   end;
//   try
//      try
//         with reg do
//         begin
//            RootKey := HKEY_CURRENT_USER;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\' + sRegKeyName, True);
//            with frm_Main.fra_Voransicht.img_DocView do
//            begin
//               // ObjTransparency[idx]:=120; // Transparenz setzen
//               if ValueExists('ObjArcEndingAngle') then
//                  ObjArcEndingAngle[idx] := ReadFloat('ObjArcEndingAngle')
//               else
//                  ObjArcEndingAngle[idx] := 90;
//               if ValueExists('ObjArcStartingAngle') then
//                  ObjArcStartingAngle[idx] := ReadFloat('ObjArcStartingAngle')
//               else
//                  ObjArcStartingAngle[idx] := 0;
//               if ValueExists('ObjBeginShape') then
//                  ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp))
//               else
//                  shTmp := iesNONE;
//               ObjBeginShape[Idx] := shTmp;
//               if ValueExists('ObjBitmapBorder') then
//                  ObjBitmapBorder[idx] := ReadBool('ObjBitmapBorder')
//               else
//                  ObjBitmapBorder[idx] := False;
//               if ValueExists('ObjBoxHighLight') then
//                  ObjBoxHighLight[idx] := ReadBool('ObjBoxHighLight')
//               else
//                  ObjBoxHighLight[idx] := False;
//               if ValueExists('ObjBrushColor') then
//                  ObjBrushColor[idx] := ReadInteger('ObjBrushColor')
//               else
//                  ObjBrushColor[idx] := clYellow;
//               if ValueExists('ObjBrushStyle') then
//                  ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp))
//               else
//               begin
//                  if (ObjType > 15) and (ObjType < 21) then
//                  begin
//                     bsTmp := bsClear;
//                  end
//                  else
//                  begin
//                     bsTmp := bsSolid;
//                  end;
//               end;
//               ObjBrushStyle[idx] := bsTmp;
//               if ValueExists('ObjEndShape') then
//                  ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp))
//               else
//                  shTmp := iesNONE;
//               ObjEndShape[Idx] := shTmp;
//               if ValueExists('ObjFontAngle') then
//                  ObjFontAngle[idx] := ReadFloat('ObjFontAngle')
//               else
//                  ObjFontAngle[idx] := 0;
//               if ValueExists('ObjFontHeight') then
//                  ObjFontHeight[idx] := ReadInteger('ObjFontHeight')
//               else
//                  ObjFontHeight[idx] := 72;
//               if ValueExists('ObjFontLocked') then
//                  ObjFontLocked[idx] := ReadBool('ObjFontLocked')
//               else
//                  ObjFontLocked[idx] := False;
//               if ValueExists('ObjFontName') then
//                  ObjFontName[idx] := ReadString('ObjFontName')
//               else
//                  ObjFontName[idx] := 'Arial';
//               if ValueExists('ObjFontStyles') then
//                  ReadBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp))
//               else
//                  fsTmp := [];
//               ObjFontStyles[idx] := fsTmp;
//               if ValueExists('ObjLabelBrushColor') then
//                  ObjLabelBrushColor[idx] := ReadInteger('ObjLabelBrushColor')
//               else
//                  ObjLabelBrushColor[idx] := clGreen;
//               if ValueExists('ObjLabelBrushStyle') then
//                  ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp))
//               else
//                  bsTmp := bsSolid;
//               ObjLabelBrushStyle[idx] := bsTmp;
//               if ValueExists('ObjLabelPosition') then
//                  ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp))
//               else
//                  lpTmp := ielBegin;
//               ObjLabelPosition[idx] := lpTmp;
//               if ValueExists('ObjMemoBorderColor') then
//                  ObjMemoBorderColor[idx] := ReadInteger('ObjMemoBorderColor')
//               else
//                  ObjMemoBorderColor[idx] := clBlack;
//
//               if ValueExists('ObjAutoIncreaseLine') then
//                  //ObjAutoIncreaseLine[idx] := ReadBool('ObjAutoIncreaseLine')
//               else
//                  //ObjAutoIncreaseLine[idx] := false;
//               if ValueExists('ObjAutoIncreaseHeight') then
//                  //ObjAutoIncreaseHeight[idx] := ReadBool('ObjAutoIncreaseHeight')
//               else
//                  //ObjAutoIncreaseHeight[idx] := false;
//               if ValueExists('ObjMemoBorderStyle') then
//                  ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp))
//               else
//                  psTmp := psSolid;
//               ObjMemoBorderStyle[idx] := psTmp;
//               if ValueExists('ObjMemoFixedHeight') then
//                  ObjMemoFixedHeight[idx] := ReadInteger('ObjMemoFixedHeight')
//               else
//                  ObjMemoFixedHeight[idx] := 0;
//               if ValueExists('ObjMemoLineSpace') then
//                  ObjMemoLineSpace[idx] := ReadInteger('ObjMemoLineSpace')
//               else
//                  ObjMemoLineSpace[idx] := 0;
//               if ValueExists('ObjName') then
//                  ObjName[idx] := ReadString('ObjName')
//               else
//                  ObjName[idx] := 'Neues Objekt ' + IntToStr(idx);
//               if ValueExists('ObjPenColor') then
//                  ObjPenColor[idx] := ReadInteger('ObjPenColor')
//               else
//                  ObjPenColor[idx] := clBlack;
//               if ValueExists('ObjPenStyle') then
//                  ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp))
//               else
//                  psTmp := psSolid;
//               ObjPenStyle[idx] := psTmp;
//               if ValueExists('ObjPenWidth') then
//                  ObjPenWidth[idx] := ReadInteger('ObjPenWidth')
//               else
//                  ObjPenWidth[idx] := 1;
//               if ValueExists('ObjPolylineClosed') then
//                  ObjPolylineClosed[idx] := ReadBool('ObjPolylineClosed')
//               else
//                  ObjPolylineClosed[idx] := False;
//               if ValueExists('ObjRulerType') then
//                  ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp))
//               else
//                  rtTmp := iertRULER;
//               ObjRulerType[idx] := rtTmp;
//               if ValueExists('ObjRulerUnit') then
//                  ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp))
//               else
//                  ruTmp := ieuPIXELS;
//               ObjRulerUnit[idx] := ruTmp;
//               if ValueExists('ObjShapeHeight') then
//                  ObjShapeHeight[idx] := ReadInteger('ObjShapeHeight')
//               else
//                  ObjShapeHeight[idx] := 0;
//               if ValueExists('ObjShapeWidth') then
//                  ObjShapeWidth[idx] := ReadInteger('ObjShapeWidth')
//               else
//                  ObjShapeWidth[idx] := 0;
//               //           if ValueExists('ObjSoftShadow') then ReadBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp)) else ssTmp.Enabled := False;
//               //          ObjSoftShadow[idx].Enabled := ssTmp.Enabled;
//               //          ObjSoftShadow[idx].Radius := ssTmp.Radius;
//               //          ObjSoftShadow[idx].OffsetX := ssTmp.OffsetX;
//               //          ObjSoftShadow[idx].OffsetY := ssTmp.OffsetY;
//               if ValueExists('ObjStyle') then
//                  ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp))
//               else
//                  osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//               ObjStyle[idx] := osTmp;
//               if ValueExists('ObjTextAlign') then
//                  ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp))
//               else
//                  taTmp := iejLeft;
//               ObjTextAlign[idx] := taTmp;
//               if ValueExists('ObjTextAutoSize') then
//                  ObjTextAutoSize[idx] := ReadBool('ObjTextAutoSize')
//               else
//                  ObjTextAutoSize[idx] := False;
//               if ValueExists('ObjTextCurveCharRot') then
//                  ObjTextCurveCharRot[idx] := ReadFloat('ObjTextCurveCharRot')
//               else
//                  ObjTextCurveCharRot[idx] := 0;
//               if ValueExists('ObjText') then
//                  ObjText[idx] := ReadString('ObjText')
//               else
//                  ObjText[idx] := 'Neuer Text ' + IntToStr(idx);
//               if ValueExists('ObjTransparency') then
//                  ObjTransparency[idx] := ReadInteger('ObjTransparency')
//               else
//                  ObjTransparency[idx] := 255;
//
//               if ValueExists('Objwidth') then
//                  Objwidth[idx] := ReadInteger('Objwidth');
//               if ValueExists('objheight') then
//                  Objheight[idx] := ReadInteger('objheight');
//               if ValueExists('Showtextform') then
//                  fbshowformtext := ReadBool('Showtextform')
//               else
//                  fbshowformtext := false;
//            end;
//            CloseKey;
//         end;
//      except
//         on e: Exception do
//         begin
//            ErrorMsg('frm_DocEdit.ReadObjVals', 'Fehler bei Laden aus der Registrierung: ' +
//               e.Message, 2029, True);
//            Result := False;
//         end;
//      end;
//   finally
//      if Assigned(reg) then
//         FreeAndNil(reg);
//   end;
//end;
//
//
//function Tdm_Main.CheckObjVals: boolean;
//var
//   reg: TRegistry;
//   fsTmp: TFontStyles;
//   shTmp: TIEShape;
//   bsTmp: TBrushStyle;
//   lpTmp: TIELabelPos;
//   //    ssTmp: TIEVSoftShadow;
//   psTmp: TPenStyle;
//   rtTmp: TIEVRulerType;
//   ruTmp: TIEUnits;
//   osTmp: TIEVStyle;
//   taTmp: TIEAlignment;
//   licounter: integer;
//   lszus: string;
//begin
//   if gbdebug then
//      logevnt('doc CheckObjVals');
//   Result := True;
//   reg := TRegistry.Create;
//   try
//      try
//         with reg do
//         begin
//            RootKey := HKEY_CURRENT_USER;
//            // Linie definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsClear;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Line', True);
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Neue Linie');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clBlue);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 2);
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 0);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 0);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            CloseKey;
//            // Box definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsClear;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Box', True);
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjBoxHighLight') then
//               WriteBool('ObjBoxHighLight', False);
//            if not ValueExists('ObjBrushColor') then
//               WriteInteger('ObjBrushColor', clWhite);
//            if not ValueExists('ObjBrushStyle') then
//               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Neues Rechteck');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clBlack);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 2);
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 0);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 0);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            CloseKey;
//            // HiLite definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsClear;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            for licounter := 0 to 4 do
//            begin
//               if licounter = 0 then
//               begin
//                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\HiLite', True);
//               end
//               else
//               begin
//                  lszus := inttostr(licounter);
//                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\HiLite' + lszus, True);
//               end;
//               case licounter of
//                  0:
//                  begin
//                     if not ValueExists('ObjBrushColor') then
//                        WriteInteger('ObjBrushColor', clYellow);
//                  end;
//                  1:
//                  begin
//                     if not ValueExists('ObjBrushColor') then
//                        WriteInteger('ObjBrushColor', cllime);
//                  end;
//                  2:
//                  begin
//                     if not ValueExists('ObjBrushColor') then
//                        WriteInteger('ObjBrushColor', clred);
//                  end;
//                  3:
//                  begin
//                     if not ValueExists('ObjBrushColor') then
//                        WriteInteger('ObjBrushColor', clblue);
//                  end;
//                  4:
//                  begin
//                     if not ValueExists('ObjBrushColor') then
//                        WriteInteger('ObjBrushColor', $000080FF);
//                  end;
//               end;
//               if not ValueExists('ObjBeginShape') then
//                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//               if not ValueExists('ObjEndShape') then
//                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//               if not ValueExists('ObjBoxHighLight') then
//                  WriteBool('ObjBoxHighLight', True);
//               if not ValueExists('ObjBrushColor') then
//                  WriteInteger('ObjBrushColor', clYellow);
//               if not ValueExists('ObjBrushStyle') then
//                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//               if not ValueExists('ObjName') then
//                  WriteString('ObjName', 'Neues Rechteck');
//               if not ValueExists('ObjPenColor') then
//                  WriteInteger('ObjPenColor', clYellow);
//               if not ValueExists('ObjPenStyle') then
//                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//               if not ValueExists('ObjPenWidth') then
//                  WriteInteger('ObjPenWidth', 2);
//               if not ValueExists('ObjShapeHeight') then
//                  WriteInteger('ObjShapeHeight', 0);
//               if not ValueExists('ObjShapeWidth') then
//                  WriteInteger('ObjShapeWidth', 0);
//               //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//               if not ValueExists('ObjStyle') then
//                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//               if not ValueExists('ObjTransparency') then
//                  WriteInteger('ObjTransparency', 255);
//               if not ValueExists('Objwidth') then
//                  WriteInteger('Objwidth', 400);
//               if not ValueExists('objheight') then
//                  WriteInteger('objheight', 400);
//               CloseKey;
//            end;
//            // Elipse definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsClear;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Ellipse', True);
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjBoxHighLight') then
//               WriteBool('ObjBoxHighLight', False);
//            if not ValueExists('ObjBrushColor') then
//               WriteInteger('ObjBrushColor', clWhite);
//            if not ValueExists('ObjBrushStyle') then
//               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Neue Ellipse');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clGreen);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 2);
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 0);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 0);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            CloseKey;
//            // Winkel definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsClear;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Arc', True);
//            if not ValueExists('ObjArcEndingAngle') then
//               WriteFloat('ObjArcEndingAngle', 90);
//            if not ValueExists('ObjArcStartingAngle') then
//               WriteFloat('ObjArcStartingAngle', 90);
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjBrushColor') then
//               WriteInteger('ObjBrushColor', clWhite);
//            if not ValueExists('ObjBrushStyle') then
//               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Neuer Winkel');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clBlack);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 2);
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 0);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 0);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            CloseKey;
//            // Text definieren
//            shTmp := iesNONE;
//            psTmp := psClear;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsClear;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//
//            for licounter := 0 to 4 do
//            begin
//               if licounter = 0 then
//               begin
//                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Text', True);
//               end
//               else
//               begin
//                  lszus := inttostr(licounter);
//                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Text' + lszus, True);
//               end;
//               case licounter of
//                  0:
//                  begin
//                     if not ValueExists('ObjText') then
//                        WriteString('ObjText', 'Neuer Text');
//                     // it will read hex!!! so 72 in dec= 114!
//                     if not ValueExists('ObjFontHeight') then
//                        WriteInteger('ObjFontHeight', 72);
//                     if not ValueExists('ObjPenColor') then
//                        WriteInteger('ObjPenColor', clBlack);
//                  end;
//                  1:
//                  begin
//                     if not ValueExists('ObjText') then
//                        WriteString('ObjText', 'Neuer Text 1');
//                     // it will read hex!!! so 72 in dec= 114!
//                     if not ValueExists('ObjFontHeight') then
//                        WriteInteger('ObjFontHeight', 72);
//                     if not ValueExists('ObjPenColor') then
//                        WriteInteger('ObjPenColor', clred);
//                  end;
//                  2:
//                  begin
//                     if not ValueExists('ObjText') then
//                        WriteString('ObjText', 'Neuer Text 2');
//                     // it will read hex!!! so 72 in dec= 114!
//                     if not ValueExists('ObjFontHeight') then
//                        WriteInteger('ObjFontHeight', 72);
//                     if not ValueExists('ObjPenColor') then
//                        WriteInteger('ObjPenColor', clgreen);
//                  end;
//                  3:
//                  begin
//                     if not ValueExists('ObjText') then
//                        WriteString('ObjText', 'Neuer Text 3');
//                     // it will read hex!!! so 72 in dec= 114!
//                     if not ValueExists('ObjFontHeight') then
//                        WriteInteger('ObjFontHeight', 96);
//                     if not ValueExists('ObjPenColor') then
//                        WriteInteger('ObjPenColor', clBlack);
//                  end;
//                  4:
//                  begin
//                     if not ValueExists('ObjText') then
//                        WriteString('ObjText', 'Neuer Text 4');
//                     // it will read hex!!! so 72 in dec= 114!
//                     if not ValueExists('ObjFontHeight') then
//                        WriteInteger('ObjFontHeight', 288);
//                     if not ValueExists('ObjPenColor') then
//                        WriteInteger('ObjPenColor', clBlack);
//                  end;
//               end;
//
//               if not ValueExists('ObjBeginShape') then
//                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//               if not ValueExists('ObjEndShape') then
//                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//               if not ValueExists('ObjBrushColor') then
//                  WriteInteger('ObjBrushColor', clWhite);
//               if not ValueExists('ObjBrushStyle') then
//                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//               if not ValueExists('ObjFontAngle') then
//                  WriteFloat('ObjFontAngle', 0);
//               if not ValueExists('ObjFontLocked') then
//                  WriteBool('ObjFontLocked', False);
//               if not ValueExists('ObjFontName') then
//                  WriteString('ObjFontName', 'Arial');
//               if not ValueExists('ObjFontStyles') then
//                  WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
//               if not ValueExists('ObjName') then
//                  WriteString('ObjName', 'Neuer Text');
//               if not ValueExists('ObjPenStyle') then
//                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//               if not ValueExists('ObjMemoBorderColor') then
//                  WriteInteger('ObjMemoBorderColor', clNone);
//               if not ValueExists('ObjAutoIncreaseLine') then
//                  WriteInteger('ObjAutoIncreaseLine', clNone);
//               if not ValueExists('ObjAutoIncreaseHeight') then
//                  WriteInteger('ObjAutoIncreaseHeight', clNone);
//               if not ValueExists('ObjPenWidth') then
//                  WriteInteger('ObjPenWidth', 2);
//               if not ValueExists('ObjShapeHeight') then
//                  WriteInteger('ObjShapeHeight', 0);
//               if not ValueExists('ObjShapeWidth') then
//                  WriteInteger('ObjShapeWidth', 0);
//
//               if not ValueExists('ObjLabelBrushStyle') then
//                  WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
//               if not ValueExists('ObjMemoBorderStyle') then
//                  WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
//               //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//               if not ValueExists('ObjStyle') then
//                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//               if not ValueExists('ObjTransparency') then
//                  WriteInteger('ObjTransparency', 255);
//               if not ValueExists('Objwidth') then
//                  WriteInteger('Objwidth', 400);
//               if not ValueExists('objheight') then
//                  WriteInteger('objheight', 400);
//               if not ValueExists('ObjTextAlign') then
//                  WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//               if not ValueExists('ObjTextAutoSize') then
//                  WriteBool('ObjTextAutoSize', False);
//               if not ValueExists('ObjTextCurveCharRot') then
//                  WriteFloat('ObjTextCurveCharRot', 0);
//               if not ValueExists('Showtextform') then
//                  WriteBool('Showtextform', false);
//               CloseKey;
//            end;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Stempel', True);
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjBrushColor') then
//               WriteInteger('ObjBrushColor', clWhite);
//            if not ValueExists('ObjBrushStyle') then
//               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjFontAngle') then
//               WriteFloat('ObjFontAngle', 0);
//            if not ValueExists('ObjFontHeight') then
//               WriteInteger('ObjFontHeight', 72);
//            if not ValueExists('ObjFontLocked') then
//               WriteBool('ObjFontLocked', False);
//            if not ValueExists('ObjFontName') then
//               WriteString('ObjFontName', 'Arial');
//            if not ValueExists('ObjFontStyles') then
//               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Neuer Text');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clBlack);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 2);
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 0);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 0);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            if not ValueExists('ObjTextAlign') then
//               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//            if not ValueExists('ObjTextAutoSize') then
//               WriteBool('ObjTextAutoSize', False);
//            if not ValueExists('ObjTextCurveCharRot') then
//               WriteFloat('ObjTextCurveCharRot', 0);
//            if not ValueExists('ObjText') then
//               WriteString('ObjText', 'Neuer Text');
//            CloseKey;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Buchungsstempel', True);
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjBrushColor') then
//               WriteInteger('ObjBrushColor', clWhite);
//            if not ValueExists('ObjBrushStyle') then
//               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjFontAngle') then
//               WriteFloat('ObjFontAngle', 0);
//            if not ValueExists('ObjFontHeight') then
//               WriteInteger('ObjFontHeight', 72);
//            if not ValueExists('ObjFontLocked') then
//               WriteBool('ObjFontLocked', False);
//            if not ValueExists('ObjFontName') then
//               WriteString('ObjFontName', 'Arial');
//            if not ValueExists('ObjFontStyles') then
//               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Buchungsstempel');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clBlack);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 2);
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 0);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 0);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            if not ValueExists('ObjTextAlign') then
//               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//            if not ValueExists('ObjTextAutoSize') then
//               WriteBool('ObjTextAutoSize', False);
//            if not ValueExists('ObjTextCurveCharRot') then
//               WriteFloat('ObjTextCurveCharRot', 0);
//            if not ValueExists('ObjText') then
//               WriteString('ObjText', '');
//            CloseKey;
//            // Notiz definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsSolid;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            for licounter := 0 to 4 do
//            begin
//               if licounter = 0 then
//               begin
//                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Note', True);
//               end
//               else
//               begin
//                  lszus := inttostr(licounter);
//                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Note' + lszus, True);
//               end;
//               if not ValueExists('ObjBeginShape') then
//                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//               if not ValueExists('ObjEndShape') then
//                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//               case licounter of
//                  0:
//                  begin
//                     if not ValueExists('ObjBrushColor') then
//                        WriteInteger('ObjBrushColor', clYellow);
//                  end;
//                  1:
//                  begin
//                     if not ValueExists('ObjBrushColor') then
//                        WriteInteger('ObjBrushColor', cllime);
//                  end;
//                  2:
//                  begin
//                     if not ValueExists('ObjBrushColor') then
//                        WriteInteger('ObjBrushColor', clred);
//                  end;
//                  3:
//                  begin
//                     if not ValueExists('ObjBrushColor') then
//                        WriteInteger('ObjBrushColor', clblue);
//                  end;
//                  4:
//                  begin
//                     if not ValueExists('ObjBrushColor') then
//                        WriteInteger('ObjBrushColor', $000080FF);
//                  end;
//               end;
//               if not ValueExists('ObjBrushStyle') then
//                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//               if not ValueExists('ObjFontAngle') then
//                  WriteFloat('ObjFontAngle', 0);
//               if not ValueExists('ObjFontHeight') then
//                  WriteInteger('ObjFontHeight', 72);
//               if not ValueExists('ObjFontLocked') then
//                  WriteBool('ObjFontLocked', False);
//               if not ValueExists('ObjFontName') then
//                  WriteString('ObjFontName', 'Arial');
//               if not ValueExists('ObjFontStyles') then
//                  WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
//               if not ValueExists('ObjMemoBorderColor') then
//                  WriteInteger('ObjMemoBorderColor', clBlack);
//               if not ValueExists('ObjAutoIncreaseLine') then
//                  WriteInteger('ObjAutoIncreaseLine', clNone);
//               if not ValueExists('ObjAutoIncreaseHeight') then
//                  WriteInteger('ObjAutoIncreaseHeight', clNone);
//               if not ValueExists('ObjMemoBorderStyle') then
//                  WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
//               if not ValueExists('ObjMemoFixedHeight') then
//                  WriteInteger('ObjMemoFixedHeight', 0);
//               if not ValueExists('ObjMemoLineSpace') then
//                  WriteInteger('ObjMemoLineSpace', 0);
//               if not ValueExists('ObjName') then
//                  WriteString('ObjName', 'Neue Notiz ');
//               if not ValueExists('ObjPenColor') then
//                  WriteInteger('ObjPenColor', clBlack);
//               if not ValueExists('ObjPenStyle') then
//                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//               if not ValueExists('ObjPenWidth') then
//                  WriteInteger('ObjPenWidth', 2);
//               if not ValueExists('ObjShapeHeight') then
//                  WriteInteger('ObjShapeHeight', 0);
//               if not ValueExists('ObjShapeWidth') then
//                  WriteInteger('ObjShapeWidth', 0);
//               //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//               if not ValueExists('ObjStyle') then
//                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//               if not ValueExists('ObjTransparency') then
//                  WriteInteger('ObjTransparency', 255);
//               if not ValueExists('Objwidth') then
//                  WriteInteger('Objwidth', 400);
//               if not ValueExists('objheight') then
//                  WriteInteger('objheight', 400);
//               if not ValueExists('ObjTextAlign') then
//                  WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//               if not ValueExists('ObjTextAutoSize') then
//                  WriteBool('ObjTextAutoSize', False);
//               if not ValueExists('ObjTextCurveCharRot') then
//                  WriteFloat('ObjTextCurveCharRot', 0);
//               if not ValueExists('ObjText') then
//                  WriteString('ObjText', 'Neue Notiz ');
//               CloseKey;
//            end;
//            // Poligon definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsSolid;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Poligon', True);
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjBrushColor') then
//               WriteInteger('ObjBrushColor', clSkyBlue);
//            if not ValueExists('ObjBrushStyle') then
//               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Neue PolyLinie');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clBlue);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 2);
//            if not ValueExists('ObjPolylineClosed') then
//            begin
//               WriteBool('ObjPolylineClosed', True);
//            end;
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 0);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 0);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            CloseKey;
//            // Polyline definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsClear;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Polyline', True);
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Neue PolyLinie');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clBlue);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 2);
//            if not ValueExists('ObjPolylineClosed') then
//               WriteBool('ObjPolylineClosed', False);
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 0);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 0);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            CloseKey;
//            // LineLabel definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsSolid;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\LineLabel', True);
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjBrushColor') then
//               WriteInteger('ObjBrushColor', clInfoBk);
//            if not ValueExists('ObjBrushStyle') then
//               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjFontAngle') then
//               WriteFloat('ObjFontAngle', 0);
//            if not ValueExists('ObjFontHeight') then
//               WriteInteger('ObjFontHeight', 72);
//            if not ValueExists('ObjFontLocked') then
//               WriteBool('ObjFontLocked', False);
//            if not ValueExists('ObjFontName') then
//               WriteString('ObjFontName', 'Arial');
//            if not ValueExists('ObjFontStyles') then
//               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
//            if not ValueExists('ObjLabelBrushColor') then
//               WriteInteger('ObjLabelBrushColor', clInfoBK);
//            if not ValueExists('ObjLabelBrushStyle') then
//               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjLabelPosition') then
//               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Neuer Aufkleber');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clBlack);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 1);
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 0);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 0);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            if not ValueExists('ObjTextAlign') then
//               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//            if not ValueExists('ObjTextAutoSize') then
//               WriteBool('ObjTextAutoSize', False);
//            if not ValueExists('ObjTextCurveCharRot') then
//               WriteFloat('ObjTextCurveCharRot', 0);
//            if not ValueExists('ObjText') then
//               WriteString('ObjText', 'Neuer Aufkleber');
//            CloseKey;
//            // Messlinie definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsSolid;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertQUOTECENTER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Ruler', True);
//            shTmp := iesOUTARROW;
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjBrushColor') then
//               WriteInteger('ObjBrushColor', clInfoBk);
//            if not ValueExists('ObjBrushStyle') then
//               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjFontAngle') then
//               WriteFloat('ObjFontAngle', 0);
//            if not ValueExists('ObjFontHeight') then
//               WriteInteger('ObjFontHeight', 8);
//            if not ValueExists('ObjFontLocked') then
//               WriteBool('ObjFontLocked', False);
//            if not ValueExists('ObjFontName') then
//               WriteString('ObjFontName', 'MS Sans Serif');
//            if not ValueExists('ObjFontStyles') then
//               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
//            if not ValueExists('ObjLabelBrushColor') then
//               WriteInteger('ObjLabelBrushColor', clInfoBK);
//            if not ValueExists('ObjLabelBrushStyle') then
//               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjLabelPosition') then
//               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Neue Messlinie');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clBlack);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 1);
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 30);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 30);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            if not ValueExists('ObjTextAlign') then
//               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//            if not ValueExists('ObjTextAutoSize') then
//               WriteBool('ObjTextAutoSize', False);
//            if not ValueExists('ObjTextCurveCharRot') then
//               WriteFloat('ObjTextCurveCharRot', 0);
//            if not ValueExists('ObjText') then
//               WriteString('ObjText', 'Neue Messlinie');
//            if not ValueExists('ObjRulerType') then
//               WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
//            if not ValueExists('ObjRulerUnit') then
//               WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
//            CloseKey;
//            // Winkelmessen definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsSolid;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Angle', True);
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjBrushColor') then
//               WriteInteger('ObjBrushColor', clInfoBk);
//            if not ValueExists('ObjBrushStyle') then
//               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjFontAngle') then
//               WriteFloat('ObjFontAngle', 0);
//            if not ValueExists('ObjFontHeight') then
//               WriteInteger('ObjFontHeight', 8);
//            if not ValueExists('ObjFontLocked') then
//               WriteBool('ObjFontLocked', False);
//            if not ValueExists('ObjFontName') then
//               WriteString('ObjFontName', 'MS Sans Serif');
//            if not ValueExists('ObjFontStyles') then
//               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
//            if not ValueExists('ObjLabelBrushColor') then
//               WriteInteger('ObjLabelBrushColor', clInfoBK);
//            if not ValueExists('ObjLabelBrushStyle') then
//               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjLabelPosition') then
//               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Neue Messlinie');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clBlack);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 1);
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 30);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 30);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            if not ValueExists('ObjTextAlign') then
//               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//            if not ValueExists('ObjTextAutoSize') then
//               WriteBool('ObjTextAutoSize', False);
//            if not ValueExists('ObjTextCurveCharRot') then
//               WriteFloat('ObjTextCurveCharRot', 0);
//            if not ValueExists('ObjText') then
//               WriteString('ObjText', 'Neue Messlinie');
//            if not ValueExists('ObjRulerType') then
//               WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
//            if not ValueExists('ObjRulerUnit') then
//               WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
//            CloseKey;
//            // Pfeil definieren
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsSolid;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Arrow', True);
//            if not ValueExists('ObjEndShape') then
//               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//            shTmp := iesNONE;
//            if not ValueExists('ObjBeginShape') then
//               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//            if not ValueExists('ObjBrushColor') then
//               WriteInteger('ObjBrushColor', clNavy);
//            if not ValueExists('ObjBrushStyle') then
//               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//            if not ValueExists('ObjName') then
//               WriteString('ObjName', 'Neuer Pfeil');
//            if not ValueExists('ObjPenColor') then
//               WriteInteger('ObjPenColor', clBlack);
//            if not ValueExists('ObjPenStyle') then
//               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//            if not ValueExists('ObjPenWidth') then
//               WriteInteger('ObjPenWidth', 2);
//            if not ValueExists('ObjShapeHeight') then
//               WriteInteger('ObjShapeHeight', 30);
//            if not ValueExists('ObjShapeWidth') then
//               WriteInteger('ObjShapeWidth', 30);
//            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//            if not ValueExists('ObjStyle') then
//               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//            if not ValueExists('ObjTransparency') then
//               WriteInteger('ObjTransparency', 255);
//            if not ValueExists('Objwidth') then
//               WriteInteger('Objwidth', 400);
//            if not ValueExists('objheight') then
//               WriteInteger('objheight', 400);
//            CloseKey;
//            //Freihand
//            shTmp := iesNONE;
//            psTmp := psSolid;
//            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
//            bsTmp := bsClear;
//            fsTmp := [];
//            taTmp := iejLeft;
//            rtTmp := iertRULER;
//            ruTmp := ieuPIXELS;
//            lpTmp := ielBegin;
//            for licounter := 0 to 4 do
//            begin
//               if licounter = 0 then
//               begin
//                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Freihand', True);
//               end
//               else
//               begin
//                  lszus := inttostr(licounter);
//                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Freihand' + lszus, True);
//               end;
//               case licounter of
//                  0:
//                  begin
//                     if not ValueExists('ObjPenColor') then
//                        WriteInteger('ObjPenColor', clBlack);
//                  end;
//                  1:
//                  begin
//                     if not ValueExists('ObjPenColor') then
//                        WriteInteger('ObjPenColor', clGreen);
//                  end;
//
//                  2:
//                  begin
//                     if not ValueExists('ObjPenColor') then
//                        WriteInteger('ObjPenColor', clred);
//                  end;
//
//                  3:
//                  begin
//                     if not ValueExists('ObjPenColor') then
//                        WriteInteger('ObjPenColor', clblue);
//                  end;
//
//                  4:
//                  begin
//                     if not ValueExists('ObjPenColor') then
//                        WriteInteger('ObjPenColor', $000080FF);
//                  end;
//               end;
//               if not ValueExists('ObjBrushStyle') then
//                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//               if not ValueExists('ObjBeginShape') then
//                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//               if not ValueExists('ObjEndShape') then
//                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//               if not ValueExists('ObjName') then
//                  WriteString('ObjName', 'Neue PolyLinie');
//               if not ValueExists('ObjPenStyle') then
//                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//               if not ValueExists('ObjPenWidth') then
//                  WriteInteger('ObjPenWidth', 2);
//               if not ValueExists('ObjPolylineClosed') then
//                  WriteBool('ObjPolylineClosed', False);
//               if not ValueExists('ObjShapeHeight') then
//                  WriteInteger('ObjShapeHeight', 0);
//               if not ValueExists('ObjShapeWidth') then
//                  WriteInteger('ObjShapeWidth', 0);
//               //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
//               if not ValueExists('ObjStyle') then
//                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//               if not ValueExists('ObjTransparency') then
//                  WriteInteger('ObjTransparency', 255);
//               if not ValueExists('Objwidth') then
//                  WriteInteger('Objwidth', 400);
//               if not ValueExists('objheight') then
//                  WriteInteger('objheight', 400);
//               CloseKey;
//            end;
//         end;
//      except
//         on e: Exception do
//         begin
//            ErrorMsg('frm_DocEdit.CheckObjVals',
//               'Fehler beim berprfen der Registrierung: ' + e.Message, 2031, True);
//            Result := False;
//         end;
//      end;
//   finally
//      if Assigned(reg) then
//         FreeAndNil(reg);
//   end;
//end;
//

//from http://www.swissdelphicenter.ch/torry/printcode.php?id=1391
function Tdm_Main.FormatHTMLClipboardHeader(HTMLText: string): string;
const
   CrLf = #13#10;
begin
   Result := 'Version:0.9' + CrLf;
   Result := Result + 'StartHTML:-1' + CrLf;
   Result := Result + 'EndHTML:-1' + CrLf;
   Result := Result + 'StartFragment:000081' + CrLf;
   Result := Result + 'EndFragment:' + CrLf;
   Result := Result + HTMLText + CrLf;
   Result := StringReplace(Result, '', Format('%.6d', [Length(Result)]), []);
end;

//The second parameter is optional and is put into the clipboard as CF_HTML.
//Function can be used standalone or in conjunction with the VCL clipboard so long as
//you use the USEVCLCLIPBOARD conditional define
//($define USEVCLCLIPBOARD}
//(and clipboard.open, clipboard.close).
//Code from http://www.lorriman.com
procedure Tdm_Main.cplinktoclbrd(const str: string; const htmlStr: string);
var
   gMem: HGLOBAL;
   lp: PChar;
   Strings: array[0..1] of string;
   Formats: array[0..1] of UINT;
   i: Integer;
begin
   {$IFNDEF USEVCLCLIPBOARD}
   Win32Check(OpenClipBoard(0));
   {$ENDIF}
   try
      //most descriptive first as per api docs
      Strings[0] := FormatHTMLClipboardHeader(htmlStr);
      Strings[1] := str;
      Formats[0] := RegisterClipboardFormat('HTML Format');
      Formats[1] := CF_TEXT;
      {$IFNDEF USEVCLCLIPBOARD}
      Win32Check(EmptyClipBoard);
      {$ENDIF}
      for i := 0 to High(Strings) do
      begin
         if Strings[i] = '' then
            Continue;
         //an extra "1" for the null terminator
         gMem := GlobalAlloc(GMEM_DDESHARE + GMEM_MOVEABLE, Length(Strings[i]) + 1);
         {Succeeded, now read the stream contents into the memory the pointer points at}
         try
            Win32Check(gmem <> 0);
            lp := GlobalLock(gMem);
            Win32Check(lp <> nil);
            CopyMemory(lp, PChar(Strings[i]), Length(Strings[i]) + 1);
         finally
            GlobalUnlock(gMem);
         end;
         Win32Check(gmem <> 0);
         SetClipboardData(Formats[i], gMEm);
         Win32Check(gmem <> 0);
      end;
   finally
      {$IFNDEF USEVCLCLIPBOARD}
      Win32Check(CloseClipBoard);
      {$ENDIF}
   end;
end;


procedure Tdm_Main.Rckgngig1Click(Sender: TObject);
begin

   SendMessage(TWinControl(frm_Main.ActiveControl).Handle, WM_UNDO, 0, 0);
end;

procedure Tdm_Main.Ausschneiden1Click(Sender: TObject);
begin
   SendMessage(TWinControl(frm_Main.ActiveControl).Handle, WM_CUT, 0, 0);
end;


procedure Tdm_Main.Kopieren1Click(Sender: TObject);
begin
   SendMessage(TWinControl(frm_Main.ActiveControl).Handle, WM_COPY, 0, 0);
end;

procedure Tdm_Main.Einfgen1Click(Sender: TObject);
begin
   SendMessage(TWinControl(frm_Main.ActiveControl).Handle, WM_PASTE, 0, 0);
end;

procedure Tdm_Main.Lschen1Click(Sender: TObject);
begin
   SendMessage(TWinControl(frm_Main.ActiveControl).Handle, WM_CLEAR, 0, 0);
end;

procedure Tdm_Main.AllesMarkieren1Click(Sender: TObject);

begin
   SendMessage(TWinControl(frm_Main.ActiveControl).Handle, EM_SETSEL, 0, -1);
end;


procedure Tdm_Main.Dokumentendatenlschen1Click(Sender: TObject);
begin
   frm_Main.jedt_Slw.Text := '';
   // jedt_Ref.Text := '';
   frm_Main.lb_Slw.Clear;
   frm_Main.Jvetitel.Text := '';
   frm_Main.jmemo_DocVTX.Lines.Clear;
   frm_Main.chbx_ManVtx.Checked := False;
   frm_Main.chbx_OCRVTX.Checked := not gbnoocr;
   frm_Main.lb_Ref.Clear;
   frm_main.jve_ref.Text := '';
   frm_Main.ReadReg;
end;

procedure Tdm_Main.Wiedervorlagedatenlschen1Click(Sender: TObject);
begin
   frm_Main.jcbx_opttim.SetUnCheckedAll;
   frm_Main.JvCCB_eb.SetUnCheckedAll;
   frm_Main.jde_termin.Text := '  .  .    ';
   frm_Main.jde_erinnerung.Text := '  .  .    ';
   frm_Main.JvCCB_je.SetUnCheckedAll;
   frm_Main.JvCCB_efa.SetUnCheckedAll;
   frm_Main.Jedt_info.Text := '';
end;

procedure Tdm_Main.DokundWvldatenlschen1Click(Sender: TObject);
begin
   Dokumentendatenlschen1Click(sender);
   Wiedervorlagedatenlschen1Click(sender);
end;

procedure Tdm_Main.DataModuleCreate(Sender: TObject);
begin

   TranslateComponent(self);
end;

end.


