unit u_ShDlgAddFields;

interface

uses
   gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, JvExForms, JvScrollBox, strutils, //{} u_dm_ViewerMain,
   TBXDkPanels,
   u_ShLowUtils, u_ShHighUtils, u_ShBase, u_ShDm, u_dm_DB, u_ShDbUtils, u_ShFrameZusFldMulti,
   u_ShDefs, Menus, MyAccess, JvStaticText, JvToolEdit, JvCombobox, spin, JvSpin;

type
   Tfrm_zuspflicht = class (TForm)
      Panel1: TPanel;
      Panel2: TPanel;
      lbl_doctitel: TLabel;
      Panel3: TPanel;
      lbl_docid: TLabel;
      btn_ok: TTBXButton;
      btn_cancel: TTBXButton;
    pum_Restore: TPopupMenu;
    Feldzurckzuschalten1: TMenuItem;
    sbx_ZusFeld: TJvScrollBox;
    tbbt_search: TTBXButton;
    tbxb_reset: TTBXButton;

      procedure btn_okClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure tbxb_resetClick(Sender: TObject);
      procedure tbbt_searchClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure btn_cancelClick(Sender: TObject);
    procedure Feldzurckzuschalten1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
   private
      { Private-Deklarationen }
      ZusFldFrame:TFrameZusFldMulti;
      procedure zusfeldonchange(Sender: TObject);
      procedure Searchzusfield(Sender: TObject);
      procedure setMoveOk (Ok: Boolean);

   public
      { Public-Deklarationen }
      fTorpflichtfeld: integer;
      fkeypflichtfeld: integer;
      fsDestIarcname: string;
      fsSrcIarcname: string;
      sIArcName, sNewArcName: string;
      iGUsrID, igDocid, igArcid, igNewArcid :Integer;
      fiZusFcount: integer;
      bMove, bPflichtfelder: Boolean;
      slZusFeld, slZusFeldWert, slHistory: TstringList;

      function CreZusFields: integer;
      function DelZusFields: integer;
      function ChkZusfield(bUseCheckprogram:Boolean): boolean;
		function CheckZusfieldsRights(UserID: Integer): Boolean;      //s.u.
      procedure GetModifiedForHistory;
      procedure onChangeComboBox (Sender: TObject);  // 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
      procedure onExitComboBox   (Sender: TObject);  // 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.

      procedure RestoreAdditionalFields(Sender: TJvScrollBox); //27.08.2011 b.takacs 3.5.1.34 [3126]

//////////////////////////////////////   04.08.2011 b.takacs 3.5.1.35 [3126] -->

		procedure CreateUniversal(search:boolean; var edt: array of TEdit; var iCntEdt: integer; sbxZusFeld: TJvScrollBox; IC: integer; lswert: string;
      												  var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
                                sName: string; iLeft: integer; iWidth: integer; aAnchors: TAnchors; bColor: boolean = false; iTop: integer = -1);

      procedure CreateDatum(search:boolean; var dat: array of TJvDateEdit; var iCntDat: integer; sbxZusFeld: TJvScrollBox; IC: integer; lswert: string;
            var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
            sName: string; iLeft: integer; iWidth: integer; aAnchors: TAnchors; bColor: boolean = false; iTop: integer = -1);

		procedure CreateAuswahl(search:boolean; var cbx: array of TComboBox; var iCntCbx: integer; sbxZusFeld: TJvScrollBox; IC: integer;
            lswert: string; var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
            cbxName: string; cbxLeft: integer; cbxWidth: integer; cbxAnchors: TAnchors; ItemsCommaText: string; bColor: boolean = false; iTop: integer = -1; bFixed: Boolean = False);

      procedure CreateMehrfachAuswahl(search:boolean; var lbl: array of tjvstatictext; var ZusFldFrame:TFrameZusFldMulti; var lfbit: array of TTBXButton; var jccb: array of TjvcheckedComboBox;
            var iCntCCbx: integer; var iCntbxb: integer; var lsDispName:string; sbxZusFeld: TJvScrollBox; IC: integer; lswert: string; var litaborder: integer;
            liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery; var sAdd: string; var iCntLbl: integer; iLeft: integer; iWidth: integer; sArcName: string; event: TNotifyEvent; bColor: boolean = false; iTop: integer = -1);

      procedure CreateIntervall(search:boolean; var spe: array of TSpinEdit; var iCntSpi: integer; sbxZusFeld: TJvScrollBox; IC: integer;
            lswert: string; var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
            sName: string; iLeft: integer; iWidth: integer; aAnchors: TAnchors; bcolor: boolean = false; iTop: integer = -1);

      procedure CreateGanzZahl(search: boolean; var lganzzahl: array of TJvSpinEdit; var iCntganzzahl: integer; sbxZusFeld: TJvScrollBox; IC: integer;
            lswert: string; var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
            sName: string; iLeft: integer; iWidth: integer; aAnchors: TAnchors; bColor: boolean = false; iTop: integer = -1);

      procedure CreateFliessKommaWaehrung(search: boolean; var ldouble: array of TJvSpinEdit; var iCntdouble: integer; sbxZusFeld: TJvScrollBox; IC: integer;
            lswert: string; var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
            sName: string; iLeft: integer; iWidth: integer; aAnchors: TAnchors;  iTyp: integer; bColor: boolean = false; iTop: integer = -1);


      procedure onExitComboBoxBySearch (Sender: TObject);

   end;

var
   frm_zuspflicht: Tfrm_zuspflicht;
   liZusatzFeldOptEingabepflicht,lInd: Integer;
   sAdd:string;
   bShowing : Boolean;

implementation

uses
  u_ShCompUtils;

var
  (*  Zweck:
        Beim Klick IN die ComboBox kann u.U. onExit aktiviert werden.
        Um Probleme damit zu verhindern wird dieses Flag genutzt.
  *)
  gExitFlag: Boolean;

{$R *.dfm}


function Tfrm_zuspflicht.CreZusFields: integer;
var
  edt: array of TEdit;
  lbl: array of tjvstatictext;
  cbx: array of TComboBox;
  dat: array of TJvDateEdit;
  chx: array of Tcheckbox;
  tbxb: array of TTBXButton;
  spe: array of TSpinEdit;
  lfbit: array of TTBXButton;
  jccb: array of TjvcheckedComboBox;
  lganzzahl: array of TJvSpinEdit;
  ldouble: array of TjvSpinEdit;
  iC, iTyp, iCntEdt, iCntCbx, iCntCCbx, iCntLbl, iCntDat,
  iCntchx, litaborder,
  iCntbxb, iCntSpi,
  iCnttbxb, iCntganzzahl, iCntdouble, liTop, liscroll: integer;
  lfont: tfont;
  lbfound, lbrechte, lbhasxs: boolean;
  lswert, lsDispName: string;
  ZusFldFrame:TFrameZusFldMulti;
  lTyp     : eAddFieldType;
  sbxWidth: integer;
   s2: string;
   x: integer;

begin
    GgfLogEvntBeg ('Tfrm_zuspflicht.CreZusFields Beginn');

   iCntEdt := 0;
   iCntCbx := 0;
   iCntLbl := 0;
   iCntDat := 0;
   iCntChx := 0;
   iCnttbxb := 0;
   iCntbxb := 0;
   iCntCCbx := 0;
   iCntSpi := 0;
   iCntganzzahl := 0;
   iCntdouble := 0;
   litaborder := 2;
   tbbt_search.Visible := false;
   tbxb_reset.visible := false;

   liTop:= tbbt_search.Top;
   liScroll:= 0;
   lbrechte := False;
   lbhasxs := false;

   if not bMove then
      btn_ok.Caption:='Speichern';
   if bPflichtfelder then
      liZusatzFeldOptEingabepflicht := 1
   else
      liZusatzFeldOptEingabepflicht := 0;

   dm_DB.my_q_tmpcrestatus1.SQL.Text := 'show tables like  "cfgxs_' + fsDestIarcname + '"';
   try
      dm_DB.my_q_tmpcrestatus1.execute;
   except on e: exception do
      begin
      end;
   end;
   if dm_DB.my_q_tmpcrestatus1.recordcount > 0 then
   begin
      lbhasxs := true;
      dm_DB.my_q_tmpcrestatus1.SQL.Text := 'SELECT * FROM cfgxs_' + fsDestIarcname + ' where usr_id = ' + inttostr(iGUsrID);
      try
         dm_DB.my_q_tmpcrestatus1.execute;
      except on e: exception do
         begin
         end;
      end;
   end;

   with dm_DB.my_q_CreZusFields do
   begin
      if sbx_ZusFeld.ComponentCount > 0 then
         DelZusFields;

      DbExecSql(dm_DB.my_q_CreZusFields,'Select * from cfg_' + fsDestIarcname + ' where typ <> 4 order by pos'); //wegen vtiger 2182
      try
         Result := RecordCount;
         if Result = 0 then
         begin
            Close;
            Exit;
         end;
         dm_db.my_q_tmp_2.sql.Text := 'select * from cfg_' + fsSrcIarcname + ' where typ <> 4 order by pos';
         dm_db.my_q_tmp_2.execute;

         tbbt_search.visible := true;
         tbxb_reset.visible := true;
         Filtered := False;
         SetLength(lbl, RecordCount);

         fTorPflichtfeld := 0;

         sbx_ZusFeld.AutoScroll := True;
         sbx_ZusFeld.Update;
         sbx_ZusFeld.Refresh;
         sbxWidth:= sbx_ZusFeld.Width;

         for iC := 0 to (RecordCount - 1) do
         begin
            iTyp := FieldByName('Typ').AsInteger;
            lbl[iCntLbl] := tjvstatictext.Create(sbx_ZusFeld);
            lbl[iCntLbl].Name := 'zlbl_Tmp' + IntToStr(iC);
            lbl[iCntLbl].Caption := FieldByName('Disp_Name').AsString + ':';

            lbfound := false;
            if lbhasxs then
            begin
               lbrechte := False;
               dm_DB.my_q_tmpcrestatus1.first;
               while not dm_DB.my_q_tmpcrestatus1.eof do
               begin
                  if dm_DB.my_q_tmpcrestatus1.fieldbyname('CFG_ID').AsInteger = FieldByName('CFG_ID').AsInteger then
                  begin
                     lbrechte := True;
                     break;
                  end;
                  dm_DB.my_q_tmpcrestatus1.next;
               end;
            end
            else
            begin
               lbrechte := True;
            end;
            lswert := '';
            dm_db.my_q_tmp_2.first;
            while not dm_db.my_q_tmp_2.eof do
            begin
               if dm_db.my_q_tmp_2.FieldByName('Disp_Name').AsString =
                  FieldByName('Disp_Name').AsString then
               begin
                  lbfound := true;
                  break;
               end;
               dm_db.my_q_tmp_2.Next;
            end;
            if lbfound then
            begin
               if (dm_db.my_q_Arc.FieldDefList.Find(dm_db.my_q_tmp_2.FieldByName('Feld_Name').AsString) = nil)
               then
               begin
                  dm_db.my_q_tmp_Arc.sql.Text := 'select * from arc_' + fsSrcIarcname + ' where doc_id =' + inttostr(igdocid);
                  dm_db.my_q_tmp_Arc.execute;
                  if (dm_db.my_q_tmp_Arc.FieldDefList.Find(dm_db.my_q_tmp_2.FieldByName('Feld_Name').AsString) <> nil) then
                  begin
                     lswert := dm_db.my_q_tmp_Arc.FieldByName(dm_db.my_q_tmp_2.FieldByName('Feld_Name').AsString).asstring;
                  end
                  else
                  begin
                     lswert := '';
                  end;
               end
               else
               begin
                  lswert := dm_db.my_q_arc.FieldByName(dm_db.my_q_tmp_2.FieldByName('Feld_Name').AsString).AsString;
               end;
            end;

            lfont := canvas.Font;
            canvas.Font := lbl[iCntLbl].Font;
            lbl[iCntLbl].Width := 4 + canvas.TextWidth(lbl[iCntLbl].Caption);
            canvas.Font := lfont;

            // Beschreibeung des namens des Pflichtfeldes modifizieren
            if ((FieldByName('Optionen').AsInteger and liZusatzFeldOptEingabepflicht) <> 0) and (lswert = '') and lbrechte then  // Datenfeld Optionen prfen ob 1
            begin
               lbl[iCntLbl].Caption := '*' + lbl[iCntLbl].Caption;
               Inc(ftorPflichtfeld);

            end;

            lbl[iCntLbl].Hint := FieldByName('Feld_Name').AsString;
            lbl[iCntLbl].ParentShowHint := True;
            lbl[iCntLbl].Left := 8;
            lbl[iCntLbl].Top := 8 + (38 * iC);
            lbl[iCntLbl].Height := 13;
            lbl[iCntLbl].Tag := FieldByName('typ').AsInteger;
            lbl[iCntLbl].Parent := sbx_ZusFeld;
            lbl[iCntLbl].TabStop := false;

            if litop + 74 > sbx_ZusFeld.Height then
                liscroll := 16
            else
                litop := lbl[iCntLbl].Top;

            // Vorbelegung bei Speicher-Modus bernehmen, falls bergeben
            if not bMove then
            begin
              if slZusFeld.Count > 0 then
              begin
                lInd:= slZusFeld.IndexOf(lbl[iCntLbl].Hint);
                if lInd > -1 then
                  lswert:= slZusFeldWert[lInd]
              end;
            end;
            lTyp          := eAddFieldType (iTyp);

            if lTyp = zfld00_Universal then
            begin
							SetLength(edt, iCntEdt + 1);
              CreateUniversal(false,edt,iCntEdt,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusFields,
              								'zedt_Tmp',28,(sbxWidth-70)-liScroll,[akLeft,akRight,akTop], lbrechte);
            end
            else
            if lTyp = zfld01_Datum then
            begin
               SetLength(dat, iCntDat + 1);
							 CreateDatum(false,dat,iCntDat,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusFields,
               						 'zedt_Tmp',28,150,[akLeft,akTop,akRight], lbrechte);
            end
            else
            if lTyp = zfld02_Auswahl then
            begin
               SetLength(cbx, iCntCbx + 1);
               CreateAuswahl(false,cbx,iCntCbx,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusFields,
               							 'zedt_Tmp',28,(sbxWidth-70)-liScroll,[akLeft,akTop,akRight],'', lbrechte);
            end
            else
            if lTyp = zfld03_MehrfachAuswahl then
            begin
            	CreateMehrfachauswahl(false,lbl,ZusFldFrame,lfbit,jccb,iCntCCbx,iCntbxb,lsDispName,sbx_ZusFeld,IC,lswert,litaborder,
              		liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusFields,sAdd,iCntLbl,28,(sbxWidth-70)-liScroll,fsDestIarcname,zusfeldonchange, lbrechte);
              SetLength(jccb, iCntCCbx + 1);
              jccb[iCntCCbx] := ZusFldFrame.ComboBox;
              Inc(iCntCCbx, 1);
              SetLength(lfbit, iCntbxb + 1);
              lfbit[iCntbxb] := ZusFldFrame.Button;
              lfbit[iCntbxb].TabStop := false;
              Inc(iCntbxb, 1);
            end
            else
            if lTyp = zfld05_Intervall then
            begin
            	SetLength(spe, iCntSpi + 1);
               CreateIntervall(false,spe,iCntSpi,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusFields,
               							 'zedt_Tmp',28,75,[akLeft,akTop], lbrechte);

               SetLength(cbx, iCntCbx + 1);
               CreateAuswahl(false,cbx,iCntCbx,sbx_ZusFeld,IC,'',litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusFields,
               							 'zedt_Tmp_cbx_',(spe[iCntSpi-1].Left + spe[iCntSpi-1].Width + 25),75,[akLeft,akTop],'T,M,J', lbrechte, -1, True);
               							 //'zedt_Tmp_cbx_',(spe[iCntSpi-1].Left + spe[iCntSpi-1].Width + 25),75,[akTop,akRight],'T,M,J', lbrechte, -1, True);

                s2:= '';
                if lswert <> '' then
                begin
                	Dec(iCntCbx,1);
                  for x:= pos(';',lswert)+1 to length(lswert) do
                    s2:= s2 + lswert[x];
                  //cbx[iCntCbx].Text:= s2;
                  cbx[iCntCbx].ItemIndex := cbx[iCntCbx].Items.IndexOf(s2);
                	Inc(iCntCbx,1);
                end;
            end
            else
            if lTyp = zfld06_GanzZahl then
            begin
               SetLength(lganzzahl, iCntganzzahl + 1);
               CreateGanzZahl(false,lganzzahl,iCntganzzahl,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusFields,
               							 'zedt_Tmp',28,75,[akLeft,akTop], lbrechte);
            end
            else
            if   (lTyp = zfld07_FliessKomma)
              or (ltyp = zfld08_Waehrung   )
            then
            begin
               SetLength(ldouble, iCntdouble + 1);
               CreateFliessKommaWaehrung(false,ldouble,iCntdouble,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusFields,
               							 'zedt_Tmp',28,75,[akLeft,akTop],iTyp, lbrechte);
            end;
            lbl[iCntLbl].Parent := sbx_ZusFeld;

            // Die Komponenten erst am Schlu sichtbar machen
            SetLength(chx, iCntchx + 1);
            chx[iCntchx] := Tcheckbox.Create(sbx_ZusFeld);
            chx[iCntChx].Name := 'zedt_Tmpchx' + IntToStr(iC);
            chx[iCntchx].Left := 8;
            chx[iCntchx].Top := 21 + (38 * iC);
            chx[iCntchx].Height := 21;
            chx[iCntchx].Width := (20);
            chx[iCntchx].Anchors := [akLeft, akTop];
            chx[iCntchx].Tag := FieldByName('Mode').AsInteger;
            chx[iCntchx].Caption := '';
            chx[iCntchx].Parent := sbx_ZusFeld;
            chx[iCntchx].TabStop := false;
            inc(iCntchx, 1);

            SetLength(tbxb, iCnttbxb + 1);
            tbxb[iCnttbxb] := TTBXButton.Create(sbx_ZusFeld);
            tbxb[iCnttbxb].Name := 'zedt_Tmptbxb' + IntToStr(iC);
            tbxb[iCnttbxb].Left := (sbxWidth - 25)-liScroll;
            tbxb[iCnttbxb].Top := 21 + (38 * iC);
            tbxb[iCnttbxb].Height := 21;
            tbxb[iCnttbxb].Width := (15);
            tbxb[iCnttbxb].Anchors := [akright, akTop];
            tbxb[iCnttbxb].Tag := FieldByName('Mode').AsInteger;
            tbxb[iCnttbxb].Caption := '';
            tbxb[iCnttbxb].hint := FieldByName('Feld_Name').AsString;
            tbxb[iCnttbxb].showhint := false;
            tbxb[iCnttbxb].Onclick := Searchzusfield;
            tbxb[iCnttbxb].Images := dm_Shared.il_ShScroll; //dm_MainForm2.jv_scroll;
            tbxb[iCnttbxb].ImageIndex := 1;
            tbxb[iCnttbxb].TabStop := false;
            tbxb[iCnttbxb].Parent := sbx_ZusFeld;

            inc(iCnttbxb, 1);

            Inc(iCntLbl, 1);
            Next;
         end;

         tbbt_search   .Top    := 21 + (40 * RecordCount);  //  22.06.2010  r.sch.
         tbxb_reset    .Top    := 21 + (40 * RecordCount);  //  22.06.2010  r.sch.

         if tbbt_search.Top + 140 >= Screen.Height then
     			frm_zuspflicht.Height:= Screen.Height - 180
         else
           frm_zuspflicht.Height := tbbt_search.Top + 140;    //  23.06.2010  r.sch.

         tbbt_search.taborder := litaborder;
         inc(litaborder);
         tbxb_reset.taborder := litaborder;
         sbx_ZusFeld.Realign;
      except
         on e: Exception do
         begin
            ErrorMsg('Tfrm_zuspflicht.CreZusFields', 'Fehler beim dynamischen Erzeugen der Zusatzfelder: ' +
               e.Message, 2000, True);
            Result := 0;
            dm_DB.my_q_CreZusFields.Close;
         end;
      end;
      dm_DB.my_q_CreZusFields.Close;
   end;

   GgfLogEvntEnd ('Tfrm_zuspflicht.CreZusFields Ende');
end;
//
//  Name: CreateUniversal
//  Parameters:
//  Description:
//  Return value:
// []  b.takacs
//------------------------------------------------------------------------------
procedure Tfrm_zuspflicht.CreateUniversal(search: boolean; var edt: array of TEdit; var iCntEdt: integer; sbxZusFeld: TJvScrollBox; IC: integer;
	lswert: string; var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
   sName: string; iLeft: integer; iWidth: integer; aAnchors: TAnchors; bColor: boolean = false; iTop: integer = -1);
begin
  with Dsc do
  begin
    edt[iCntEdt] := TEdit.Create(sbxZusFeld);
    edt[iCntEdt].Name := sName + IntToStr(iC);
    if lswert <> '' then
    begin
      edt[iCntEdt].Text := lswert;

    end
    else
    begin
      edt[iCntEdt].Text := '';
    end;
    edt[iCntEdt].Hint :=
      _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
      #34 + ' ' + _('suchen');

    if search then
    begin
      if bColor then  //gai_cfg_rights[iC] in frm_MainForm default false
      begin
        edt[iCntEdt].color := clwhite;
      end
      else
      begin
         edt[iCntEdt].color := cColorNoRightInit;
      end;
      edt[iCntEdt].ShowHint := false;
    end
    else
    begin

      if bColor then
      begin
         if (FieldByName('Optionen').AsInteger and liZusatzFeldOptEingabepflicht) <> 0 then
         begin
           edt[iCntEdt].Hint :=
              _('Hier knnen Sie im Feld') + ' ' + #34 + '*' +
              FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
           edt[iCntEdt].Color := cColorPflichtfeld;
         end
         else
           edt[iCntEdt].color := clwhite;
      end
      else
      begin
         edt[iCntEdt].color := cColorNoRightInit;
      end;

	    edt[iCntEdt].ShowHint := True;
    end;

    edt[iCntEdt].Align := alNone;
    edt[iCntEdt].Left := iLeft;
    if iTop = -1 then
	    edt[iCntEdt].Top := 21 + (38 * iC)
    else
	    edt[iCntEdt].Top := 21 + (38 * iC) - iTop;
    edt[iCntEdt].Height := 21;
    edt[iCntEdt].Width := iWidth;
    edt[iCntEdt].Anchors := aAnchors;
    edt[iCntEdt].Tag := FieldByName('Mode').AsInteger;
    edt[iCntEdt].Parent := sbxZusFeld;
    edt[iCntEdt].TabStop := true;
    edt[iCntEdt].taborder := litaborder;
    edt[iCntEdt].OnChange := zusfeldonchange;

    Inc(iCntEdt, 1);
    inc(litaborder);
  end;
end;
//
//  Name:
//  Parameters:
//  Description:
//  Return value:
// []  b.takacs
//------------------------------------------------------------------------------
procedure Tfrm_zuspflicht.CreateDatum(search:boolean; var dat: array of TJvDateEdit; var iCntDat: integer; sbxZusFeld: TJvScrollBox; IC: integer; lswert: string;
		var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
      sName: string; iLeft: integer; iWidth: integer; aAnchors: TAnchors; bColor: boolean = false; iTop: integer = -1);
begin
  with Dsc do
  begin
    dat[iCntDat] := TJvDateEdit.Create(sbxZusFeld);
    dat[iCntDat].Name := sName + IntToStr(iC);
    dat[iCntDat].Clear;
    dat[iCntDat].Hint :=
      _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
      #34 + ' ' + _('suchen');
    try
       if lsWert <> '' then
         dat [iCntDat].Text := lsWert;
    except
    	dat [iCntDat].Text := '';
    end;
    dat[iCntDat].Left := iLeft;
    if iTop = -1 then
	    dat[iCntDat].Top := 21 + (38 * iC)
    else
	    dat[iCntDat].Top := 21 + (38 * iC) - iTop;
    dat[iCntDat].Height := 21;
    dat[iCntDat].Width := iWidth;
    dat[iCntDat].Anchors := aAnchors;
    dat[iCntDat].Tag := FieldByName('Mode').AsInteger;
    dat[iCntDat].Parent := sbxZusFeld;
    dat[iCntDat].TabStop := true;
    dat[iCntDat].taborder := litaborder;
    dat[iCntDat].CheckOnExit := true;   //12.11.2011 b.takacs 3.5.0.142
    dat[iCntDat].OnChange := zusfeldonchange;
    if search then
    begin
      if bColor then  //gai_cfg_rights[iC] in frm_MainForm default false
      begin
	         dat[iCntDat].color := clwhite;
      end
      else
      begin
         dat[iCntDat].color := cColorNoRightInit;
      end;
	    dat[iCntDat].ShowHint := false;
    end
    else
    begin
      if bColor then  //gai_cfg_rights[iC] in frm_MainForm default false
      begin
         if (FieldByName('Optionen').AsInteger and liZusatzFeldOptEingabepflicht) <> 0 then
         begin
           dat[iCntdat].Hint :=
              _('Hier knnen Sie im Feld') + ' ' + #34 + '*' +
              FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
           dat[iCntdat].Color := cColorPflichtfeld;
         end
         else
           dat[iCntdat].Color := clWhite;
      end
      else
         dat[iCntDat].color := cColorNoRightInit;

      dat[iCntDat].ShowHint := True;
    end;

    Inc(iCntDat, 1);
    inc(litaborder);
  end;
end;
//
//  Name:
//  Parameters:
//  Description:
//  Return value:
// []  b.takacs
//------------------------------------------------------------------------------
procedure Tfrm_zuspflicht.CreateAuswahl(search: boolean; var cbx: array of TComboBox; var iCntCbx: integer; sbxZusFeld: TJvScrollBox; IC: integer;
		lswert: string; var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
      cbxName: string; cbxLeft: integer; cbxWidth: integer; cbxAnchors: TAnchors; ItemsCommaText: string; bColor: boolean = false; iTop: integer = -1; bFixed: Boolean = False);
var
   lipos2 : Integer;
begin
	with Dsc do
  begin
    cbx[iCntCbx] := TComboBox.Create(sbxZusFeld);
    cbx[iCntCbx].Name := cbxName + IntToStr(iC);
    if bFixed then
     cbx[iCntCbx].Style := csOwnerDrawFixed
    else
  	  cbx[iCntCbx].Style := csDropDown; //3.5.0.19 [ 2264 ] Auswahlfelder knnen beliebig manuell ausgefllt werden

    cbx[iCntCbx].Hint :=
      _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
      #34 + ' ' + _('suchen');

    cbx[iCntCbx].Left := cbxLeft;
    if iTop = -1 then
	    cbx[iCntCbx].Top := 21 + (38 * iC)
    else
	    cbx[iCntCbx].Top := 21 + (38 * iC) - iTop;
    cbx[iCntCbx].Height := 21;
    cbx[iCntCbx].Width := cbxWidth;
    cbx[iCntCbx].Anchors := cbxAnchors;
    cbx[iCntCbx].Tag := FieldByName('Mode').AsInteger;
    cbx[iCntCbx].Parent := sbxZusFeld;
    if search then
    begin
      if bColor then  //gai_cfg_rights[iC] in frm_MainForm default false
      begin
	         cbx[iCntCbx].color := clwhite;
      end
      else
      begin
         cbx[iCntCbx].color := cColorNoRightInit;
      end;
      cbx[iCntCbx].ShowHint  := false;
      cbx[iCntCBx].DropDownCount := 16;
      cbx[iCntCBx].OnExit    := onExitComboBoxBySearch;
      cbx[iCntCbx].ShowHint := false;

    end
    else
    begin
    	if bColor then  //gai_cfg_rights[iC] in frm_MainForm default false
      begin
         if (FieldByName('Optionen').AsInteger and liZusatzFeldOptEingabepflicht) <> 0 then
         begin
           cbx[iCntcbx].Hint :=
              _('Hier knnen Sie im Feld') + ' ' + #34 + '*' +
              FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
           cbx[iCntcbx].Color := cColorPflichtfeld;
         end
         else
           cbx[iCntCbx].color := clwhite;
      end
      else
      begin
         cbx[iCntCbx].color := cColorNoRightInit;
      end;


      cbx[iCntCBx].OnExit   := onExitComboBox;    // 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
      cbx[iCntCBx].OnChange := onChangeComboBox;  // 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
      cbx[iCntCbx].ShowHint := True;
    end;

    cbx[iCntCbx].Clear;
    if ItemsCommaText <> '' then
    begin
      cbx[iCntCbx].Items.CommaText := 'T,M,J';
    end
    else
    begin
      cbx[iCntCbx].Items := StrToWords6(FieldByName('Werte').AsString);
    end;

    cbx[iCntCbx].TabStop := true;
    cbx[iCntCbx].taborder := litaborder;
    cbx[iCntCbx].Items.Add('');
    if lsWert <> '' then
    begin
     cbx[iCntCbx].Text := lsWert;

     lipos2 := cbx[iCntCbx].Items.IndexOf(lsWert);
      if (lipos2 > -1) and (lsWert <> '') then
         cbx[iCntCbx].ItemIndex := lipos2;


     TextIntoList (cbx [iCntCbx]);  // 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
    end;

    Inc (iCntCbx, 1);
    inc (litaborder);
  end;
end;
//
//  Name:
//  Parameters:
//  Description:
//  Return value:
// []  b.takacs
//------------------------------------------------------------------------------
procedure Tfrm_zuspflicht.CreateMehrfachAuswahl(search: boolean; var lbl: array of tjvstatictext; var ZusFldFrame:TFrameZusFldMulti; var lfbit: array of TTBXButton;
		var jccb: array of TjvcheckedComboBox; var iCntCCbx: integer; var iCntbxb: integer; var lsDispName:string;
      sbxZusFeld: TJvScrollBox; IC: integer; lswert: string; var litaborder: integer; liZusatzFeldOptEingabepflicht: integer;
      Dsc: TMyQuery; var sAdd: string; var iCntLbl: integer; iLeft: integer; iWidth: integer; sArcName: string; event: TNotifyEvent; bColor: boolean = false; iTop: integer = -1);
type
   TFPStrWords = function(const InputStr: string): TStringList;
   
var
  lswor: TStringList;
  lipos2, licount2: integer;
  lfpmystrtowords1: TFPStrWords;
begin
	with Dsc do
  begin
    lsDispName := FieldByName('Disp_Name').AsString;
    sAdd := lbl[iCntLbl].Hint;
    ZusFldFrame := CreateTJvCheckedComboBox(sbxZusFeld, iC, iTop, iLeft, iWidth,
                   lsDispName, sAdd, sArcname, event, FieldByName('Mode').AsInteger);

    if search then
    begin
      if bColor then
      begin
      	ZusFldFrame.ComboBox.noFocusColor := clwhite;
      end
      else
         ZusFldFrame.ComboBox.noFocusColor := cColorNoRightInit;

    	ZusFldFrame.ComboBox.ShowHint:= false;
    end
    else
    begin
    	if bColor then
      begin
         if (FieldByName('Optionen').AsInteger and liZusatzFeldOptEingabepflicht) <> 0 then
         begin
           ZusFldFrame.ComboBox.Hint :=
              _('Hier knnen Sie im Feld') + ' ' + #34 + lsDispName +
              #34 + ' ' + _('suchen');
           ZusFldFrame.ComboBox.NoFocusColor := cColorPflichtfeld;
         end
         else
           ZusFldFrame.ComboBox.NoFocusColor := clWhite;
      end
      else
         ZusFldFrame.ComboBox.noFocusColor := cColorNoRightInit;

      ZusFldFrame.ComboBox.ShowHint:= true;
    end;
    ZusFldFrame.TabStop := true;
    ZusFldFrame.taborder := litaborder;
    ZusFldFrame.Button.TabStop := false;
    ZusFldFrame.ComboBox.TabStop := true;
    ZusFldFrame.ComboBox.taborder := litaborder;
    inc(litaborder);

    // [2270]
    if lswert <> '' then
    begin
      ZusFldFrame.ComboBox.Text:= lswert;
      lfpmystrtowords1:= StrToWords7;
      lswor:= lfpmystrtowords1(lswert);
      ZusFldFrame.ComboBox.SetUnCheckedAll();
      for licount2 := 0 to lswor.Count - 1 do
      begin
         lipos2 := ZusFldFrame.ComboBox.Items.IndexOf(lswor.Strings[licount2]);
         if (lipos2 > -1) and (lswor.Strings[licount2] <> '') then
            ZusFldFrame.ComboBox.Checked[lipos2] := true;
      end;
    end
    else
    begin
      ZusFldFrame.ComboBox.Text:= '';
    end;

  end;
end;
//
//  Name:
//  Parameters:
//  Description:
//  Return value:
// []  b.takacs
//------------------------------------------------------------------------------
procedure Tfrm_zuspflicht.CreateIntervall(search: boolean; var spe: array of TSpinEdit; var iCntSpi: integer; sbxZusFeld: TJvScrollBox; IC: integer;
		lswert: string; var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
		sName: string; iLeft: integer; iWidth: integer; aAnchors: TAnchors; bcolor: boolean = false; iTop: integer = -1);
var
	s1: string;
  x: integer;
begin
	with Dsc do
  begin
    spe[iCntSpi] := TSpinEdit.Create(sbxZusFeld);
    spe[iCntSpi].Name := sName + IntToStr(iC);
    spe[iCntSpi].Hint :=
      _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
      #34 + ' ' + _('suchen');
    spe[iCntSpi].Left := iLeft;
    if iTop = -1 then
	    spe[iCntSpi].Top := 21 + (38 * iC)
    else
	    spe[iCntSpi].Top := 21 + (38 * iC) - iTop; 
    spe[iCntSpi].Height := 21;
    spe[iCntSpi].Width := iWidth;
    spe[iCntSpi].MaxValue := maxint; // m.frey: war 31 gendert wegen Wehrling nicht Monat absolut sondern Laufzeit
    spe[iCntSpi].MinValue := 0;
    spe[iCntSpi].Value := 1;
    spe[iCntSpi].Text := '0';
    spe[iCntSpi].Anchors := aAnchors;

    if search then
    begin
      if bColor then  //gai_cfg_rights[iC] in frm_MainForm default false
	         spe[iCntSpi].color := clwhite
      else
         spe[iCntSpi].color := cColorNoRightInit;

      spe[iCntSpi].ShowHint  := false;
    end
    else
    begin
	   spe[iCntSpi].ShowHint := True;
     	if bColor then  //gai_cfg_rights[iC] in frm_MainForm default false
      begin
         if (FieldByName('Optionen').AsInteger and liZusatzFeldOptEingabepflicht) <> 0 then
         begin
           spe[iCntSpi].Hint :=
              _('Hier knnen Sie im Feld') + ' ' + #34 + '*' + FieldByName('Disp_Name').AsString +
              #34 + ' ' + _('suchen');
           spe[iCntSpi].Color := cColorPflichtfeld;
         end
         else
             spe[iCntSpi].color := clwhite;
      end
      else
         spe[iCntSpi].color := cColorNoRightInit;

    	spe[iCntSpi].OnChange := zusfeldonchange;
    end;

      if lswert <> '' then
      begin
        s1:= ''; //23.08.2011 b.takacs 3.5.1.9 [3157]
          for x:= 1 to pos(';',lswert) - 1 do
            s1:= s1 + lswert[x];
        spe[iCntSpi].Text:= s1
      end;


    spe[iCntSpi].Anchors := aAnchors;

    spe[iCntSpi].Tag := FieldByName('Mode').AsInteger;
    spe[iCntSpi].Parent := sbxZusFeld;
    spe[iCntSpi].TabStop := true;
    spe[iCntSpi].taborder := litaborder;
    inc(litaborder);
    Inc(iCntSpi, 1);
	end;
end;
//
//  Name: CreateUniversal
//  Parameters:
//  Description:
//  Return value:
// []  b.takacs
//------------------------------------------------------------------------------
procedure Tfrm_zuspflicht.CreateGanzZahl(search: boolean; var lganzzahl: array of TJvSpinEdit; var iCntganzzahl: integer; sbxZusFeld: TJvScrollBox; IC: integer;
      lswert: string; var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
		sName: string; iLeft: integer; iWidth: integer; aAnchors: TAnchors; bColor: boolean = false; iTop: integer = -1);
begin
	with Dsc do
  begin
    lganzzahl[iCntganzzahl] := TJvSpinEdit.Create(sbxZusFeld);
    lganzzahl[iCntganzzahl].Name := sName + IntToStr(iC);
    lganzzahl[iCntganzzahl].Hint :=
      _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
      #34 + ' ' + _('suchen');;

    lganzzahl[iCntganzzahl].Left := iLeft;
    if iTop = -1 then
	    lganzzahl[iCntganzzahl].Top := 21 + (38 * iC)
    else
	    lganzzahl[iCntganzzahl].Top := 21 + (38 * iC) - iTop;
    lganzzahl[iCntganzzahl].Height := 21;
    lganzzahl[iCntganzzahl].Width := iWidth;
    lganzzahl[iCntganzzahl].Anchors := aAnchors;
    lganzzahl[iCntganzzahl].Tag := FieldByName('Mode').AsInteger;
    lganzzahl[iCntganzzahl].Parent := sbxZusFeld;

    if lswert <> '' then
      lganzzahl[iCntganzzahl].text := lswert;

    if search then
    begin
      if bColor then  //gai_cfg_rights[iC] in frm_MainForm default false
      	lganzzahl[iCntganzzahl].color := clwhite
      else
         lganzzahl[iCntganzzahl].color := cColorNoRightInit;
	 	lganzzahl[iCntganzzahl].ShowHint := false;
    end
    else
    begin
    	if bColor then  //gai_cfg_rights[iC] in frm_MainForm default false
      begin
         if (FieldByName('Optionen').AsInteger and liZusatzFeldOptEingabepflicht) <> 0 then
         begin
           lganzzahl[iCntganzzahl].Hint :=
              _('Hier knnen Sie im Feld') + ' ' + #34 + '*' + FieldByName('Disp_Name').AsString +
              #34 + ' ' + _('suchen');
           lganzzahl[iCntganzzahl].Color := cColorPflichtfeld;
         end
         else
            lganzzahl[iCntganzzahl].color := clwhite;
      end
      else
      begin
         lganzzahl[iCntganzzahl].color := cColorNoRightInit;
      end;

	    lganzzahl[iCntganzzahl].ShowHint := True;
	    lganzzahl[iCntganzzahl].OnChange := zusfeldonchange;
	  end;

    lganzzahl[iCntganzzahl].TabStop:= true; //09.11.2011 b.takacs 3.5.1.55
    lganzzahl[iCntganzzahl].TabOrder:= litaborder; //09.11.2011 b.takacs 3.5.1.55
    inc(litaborder); //09.11.2011 b.takacs 3.5.1.55

    Inc(iCntganzzahl, 1);
  end;
end;
//
//  Name:
//  Parameters:
//  Description:
//  Return value:
// []  b.takacs
//------------------------------------------------------------------------------
procedure Tfrm_zuspflicht.CreateFliessKommaWaehrung(search: boolean; var ldouble: array of TJvSpinEdit; var iCntdouble: integer; sbxZusFeld: TJvScrollBox; IC: integer;
		lswert: string; var litaborder: integer; liZusatzFeldOptEingabepflicht: integer; Dsc: TMyQuery;
      sName: string; iLeft: integer; iWidth: integer; aAnchors: TAnchors; iTyp: integer; bColor: boolean = false; iTop: integer = -1);
begin
	with Dsc do
  begin
    ldouble[iCntdouble] := TjvSpinEdit.Create(sbxZusFeld);
    ldouble[iCntdouble].Name := sName + IntToStr(iC);
    ldouble[iCntdouble].Hint :=
      _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
      #34 + ' ' + _('suchen');
    if (FieldByName('Optionen').AsInteger and liZusatzFeldOptEingabepflicht) <> 0 then
    begin
      ldouble[iCntdouble].Hint :=
         _('Hier knnen Sie im Feld') + ' ' + #34 + '*' + FieldByName('Disp_Name').AsString +
         #34 + ' ' + _('suchen');
      ldouble[iCntdouble].Color := cColorPflichtfeld;
    end;
    ldouble[iCntdouble].Left := iLeft;
    if iTop = -1 then
	    ldouble[iCntdouble].Top := 21 + (38 * iC)
    else
    	ldouble[iCntdouble].Top := 21 + (38 * iC) - iTop;
    ldouble[iCntdouble].Height := 21;

    ldouble[iCntdouble].Anchors := aAnchors;

    if search then
    begin
      if bColor then  //gai_cfg_rights[iC] in frm_MainForm default false
      	ldouble[iCntdouble].color := clwhite
      else
         ldouble[iCntdouble].color := cColorNoRightInit;

      ldouble[iCntdouble].ShowHint := false;
      ldouble[iCntdouble].Width:= iWidth;
    end
    else
    begin
      if ((trunc(sbxZusFeld.Width / 2)) - 105) > 85 then
      begin
        ldouble[iCntdouble].Width := 2*75+10;
      end
      else
      begin
        ldouble[iCntdouble].Width := 2*75+10;
      end;
      ldouble[iCntdouble].ShowHint := True;
      ldouble[iCntdouble].OnChange := zusfeldonchange;
      if bColor then  //gai_cfg_rights[iC] in frm_MainForm default false
      begin
         if (FieldByName('Optionen').AsInteger and liZusatzFeldOptEingabepflicht) <> 0 then
         begin
           ldouble[iCntdouble].Hint :=
              _('Hier knnen Sie im Feld') + ' ' + #34 + '*' + FieldByName('Disp_Name').AsString +
              #34 + ' ' + _('suchen');
           ldouble[iCntdouble].Color := cColorPflichtfeld;
         end
         else
           ldouble[iCntdouble].Color := clWhite;
      end
      else
      begin
         ldouble[iCntdouble].color := cColorNoRightInit;
      end;
	 end;

    ldouble[iCntdouble].Tag := FieldByName('Mode').AsInteger;
    if ityp = 7 then
      ldouble[iCntdouble].Decimal := 10
    else
      ldouble[iCntdouble].Decimal := 2;

    ldouble[iCntdouble].ValueType := vtFloat;
    ldouble[iCntdouble].Parent := sbxZusFeld;

    if lswert <> '' then
      ldouble[iCntdouble].text := lswert;

    ldouble[iCntdouble].TabStop := true;
    ldouble[iCntdouble].TabOrder := litaborder;
    inc(litaborder);
    Inc(iCntdouble, 1);
  end;
end;
//
function Tfrm_zuspflicht.DelZusFields: integer;
var
   lcomp: Tcomponent;
begin
   Result := 0;
   if sbx_ZusFeld.ComponentCount = 0 then
      exit;
   try
      while sbx_ZusFeld.ComponentCount > 0 do
      begin
         lcomp := sbx_ZusFeld.Components[0];
         FreeAndNil(lcomp);
         inc(result, 1);
      end;
      ZusFldFrame := nil;
   except
      on e: Exception do
      begin
         ErrorMsg('DelZusFields', 'Fehler beim Entfernen der Zusatzfelder: ' +
            e.Message, 2006, True);
         Result := 0;
      end;
   end;

   tbbt_search.visible := false;
   tbxb_reset.visible := false;
   ftorpflichtfeld := 0;
end;

procedure Tfrm_zuspflicht.btn_okClick(Sender: TObject);
var
   TorlockPflichtfeld: integer;

begin
   if ChkZusfield(BD.GtDomain = 'ViewerV3') then    // wenn die Unit nicht vom Viewer aufgerufen wird
   begin                                            // brauchen wir auch kein checkprogramm ausfhren
     TorlockPflichtfeld := ftorpflichtfeld - fkeypflichtfeld;
     if TorlockPflichtfeld <> 0 then
     begin
        BfShowMessage(_('Sie mssen erst die Pflichtfelder ausfllen.\n' +
            'Pflichtfelder sind mit einem *(Stern) gekennzeichnet.\n' +
            'Fehlende Felder:') + IntToStr(torlockpflichtfeld));
        if TorlockPflichtfeld < 0 then
        begin
           logevnt('2 tor ' + IntToStr(ftorpflichtfeld) + ' key ' +
              IntToStr(fkeypflichtfeld));
        end;
        frm_zuspflicht.ModalResult := 0;
        exit;
     end;
     // hier knnte man die genderten Zusatzfelder ermitteln
     GetModifiedForHistory;
     frm_zuspflicht.ModalResult := mrOk;
   end
   else
    frm_zuspflicht.ModalResult := 0;

end;

function Tfrm_zuspflicht.ChkZusfield(bUseCheckprogram: Boolean): boolean;
var
   iCount: integer;
   sFeld, sName, sWert, lsParams, lsCheckPrg, lsinput: string;
   comp: TComponent;
   jvstcomp: tjvstatictext;
   lbchecked : Boolean;
begin
   GgfLogEvnt('ChkZusfield');
   Result := false;
   fkeypflichtfeld := 0;

   try
      try
         for iCount := 0 to (fiZusFCount - 1) do
         begin
            jvstcomp := tjvstatictext(sbx_ZusFeld.FindComponent('zlbl_Tmp' +
               IntToStr(iCount)));

            sFeld := jvstcomp.Hint;
            sName := copy(jvstcomp.Caption, 1, Length(jvstcomp.Caption) - 1);
            sWert := '';
            comp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));

            if comp is TEdit then
            begin
               sWert := TEdit(comp).Text;
            end;
            if comp is TJvDateEdit then
            begin
               sWert := TJvDateEdit(comp).Text;
               if swert = cEmptyDateString then
                  swert := '';
            end;
            if comp is TComboBox then
            begin
               sWert := TComboBox(comp).Text;
            end;
            if comp is TSpinEdit then
            begin
               sWert := TSpinEdit(comp).Text;
            end;
            if comp is TjvSpinEdit then
            begin
               sWert := TjvSpinEdit(comp).Text;
            end;
            if comp is TjvcheckedComboBox then
            begin
               sWert := TjvcheckedComboBox(comp).Text;
            end;

            if (swert = '""') or (swert = cEmptyDateString) or (swert = '0,0000000000')
                or (swert = '0') or (swert='0,00') then
                  swert := '';

            if (leftstr(sname, 1) = '*') and (swert <> '') then
               Inc(fkeypflichtfeld);

            if bUseCheckprogram and (swert <> '') then
            begin
            	if DbDoSkySQL(dm_db.my_q_Tmp,'select * from cfg_' + fsDestIarcname + ' where Feld_name = ' +
                  #39 + sFeld + #39) then
               begin
                  lbchecked := True;
                  lsCheckPrg:=dm_db.my_q_tmp.FieldByName('chck_prog').AsString;
                  if (dm_db.my_q_tmp.RecordCount <> 0) and
                    (dm_db.my_q_tmp.FieldDefList.Find('chck_prog') <> nil) then
                  begin
                     if (dm_db.my_q_tmp.FieldByName('chck_prog').AsString <> null) and
                       (lsCheckPrg <> '') then
                     begin

                        if not FileExists(lsCheckPrg) then
                        begin
                           BfShowMessage(_('Das Checkprogramm ' + extractfilename(lsCheckPrg) + ' konnte nicht gefunden werden.\nDie Eingabe wird zurckgewiesen.'));
                           Result := False;
                           Exit;
                        end;
                        lsParams := dm_DB.my_q_Arc.FieldByName('gdoc_id').AsString+' '+IntToStr(igArcid)+' '+dm_DB.my_q_Arc.FieldByName('doc_id').AsString +' '+ sName +' '+ sFeld +' '+IntToStr(igNewArcid)+' '+ sNewArcName;
                       	lbchecked :=
                          (ShellExecute_AndWait('', extractfilename(lsCheckPrg),
                          #34 + swert + #34 +' '+lsParams, extractfilepath(lsCheckPrg), SW_HIDE, True) = 0);
                     end;
                  end;
                  while not lbchecked do
                  begin
                     if InputQuery(_('Eingabeberprfung'),
                        _('Die Eingabe wurde zurckgewiesen. Bitte geben Sie einen gltigen Wert ein.'),
                        lsinput) then
                     begin
                      	swert := lsinput;
                        if comp is TEdit then
                        begin
                           TEdit(comp).Text := sWert;
                           // zuswert[icount]:=swert;
                        end;
                        if comp is TJvDateEdit then
                        begin
                           // showmessage ('swert of Dateedit = '+TJvDateEdit(comp).Text + inttostr(length( TJvDateEdit(comp).Text )));

                           if swert = cEmptyDateString then
                              swert := '';
                           TJvDateEdit(comp).Text := sWert;
                           // zuswert[icount]:=swert;
                        end;
                        if comp is TComboBox then
                        begin
                           TComboBox(comp).Text := sWert;
                           // zuswert[icount]:=swert;
                        end;
                        if comp is TSpinEdit then
                        begin
                           TSpinEdit(comp).Text := sWert;
                           // zuswert[icount]:=swert;
                        end;
                        if comp is TjvSpinEdit then
                        begin
                           TjvSpinEdit(comp).Text := sWert;
                           // zuswert[icount]:=swert;
                        end;
                        if comp is TjvcheckedComboBox then
                        begin
                           TjvcheckedComboBox(comp).Text := sWert;
                           // zuswert[icount]:=swert;
                        end;

                        lbchecked :=
                          (ShellExecute_AndWait('', extractfilename(lsCheckPrg),
                          #34 + lsinput + #34 +' '+lsParams, extractfilepath(lsCheckPrg), SW_HIDE, True) = 0);
                     end
                     else
                     begin
                        Result := False;
                        Exit; //18.02.2011 b.takacs 3.5.0.162
                     end;
                  end;
               end;
            end;
         end;
      except
         on e: Exception do
            ErrorMsg('ChkZusfield', 'Fehler beim Prfen auf Pflichtfelder: ' +
               e.Message, 2023, True);
      end;
      Result := True;
   finally

   end;
end;

procedure Tfrm_zuspflicht.GetModifiedForHistory;
var
   iCount: integer;
   sFeld, sName, sWert, lsCheckPrg, lsinput: string;
   comp, comp01: TComponent;
   jvstcomp: tjvstatictext;

begin
	if not bMove then
   	Exit;

   slHistory.Clear;

   try
      for iCount := 0 to (fiZusFCount - 1) do
      begin
         jvstcomp := tjvstatictext(sbx_ZusFeld.FindComponent('zlbl_Tmp' +
            IntToStr(iCount)));

         sFeld := jvstcomp.Hint;
         sName := copy(jvstcomp.Caption, 1, Length(jvstcomp.Caption) - 1);
         sWert := '';
         comp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));

         if comp is TEdit then
         begin
            if (TEdit(comp).Tag and 4) = 4 then
	            sWert := TEdit(comp).Text;
         end;
         if comp is TJvDateEdit then
         begin
            if (TJvDateEdit(comp).Tag and 4) = 4 then
               sWert := TJvDateEdit(comp).Text;
            if swert = cEmptyDateString then
               swert := '';
         end;
         if comp is TComboBox then
         begin
            if (TComboBox(comp).Tag and 4) = 4 then
            	sWert := TComboBox(comp).Text;
         end;
         if comp is TSpinEdit then
         begin
            if (TSpinEdit(comp).Tag and 4) = 4 then
            begin
            	comp01 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' +
                     IntToStr(iCount));
               if comp01 <> nil then
               begin
                  sWert := TSpinEdit(comp).Text + Tcombobox(comp01).text ;
               end;
            end;

         end;
         if comp is TjvSpinEdit then
         begin
            if (TjvSpinEdit(comp).Tag and 4) = 4 then
            	sWert := TjvSpinEdit(comp).Text;
         end;
         if comp is TjvcheckedComboBox then
         begin
            if (TjvcheckedComboBox(comp).Tag and 4) = 4 then
            	sWert := TjvcheckedComboBox(comp).Text;
         end;

         if sWert <> '' then
         begin
         	if LeftStr(sName,1) = '*' then
            	sName := Copy(sName,2,Length(sName) -1);
            slHistory.Add(Format(_('Zusatzfeld %s auf %s gesetzt'),[sName,sWert]));
         end;
      end;
   except
      on e: Exception do
         ErrorMsg('GetModifiedForHistory', 'Fehler beim Sammeln der Historyeintrge: ' +
            e.Message, 2023, True);
   end;
end;


function Tfrm_zuspflicht.CheckZusfieldsRights(UserID: Integer): Boolean;   // prfen ob es versehentlich Pflichtfelder ohne
     																		// Berechtigung fr den User gibt, dann mit einer
var 															  			// Fehlermeldung abbrechen
   lbhasxs : Boolean;
   iC : Integer;
   lmq, lmq2: TMyQuery;
begin
   GgfLogEvnt('CheckZusfieldsRights UserID:' + IntToStr(UserID));
   Result := true;
   try
      try
         lmq := DbCreateQuery;
         lmq2 := DbCreateQuery;
         lmq.Close;
         lmq.SQL.Text := 'Select * from cfg_' + fsDestIarcname + '  where  typ <> 4  order by pos';
         lmq.Open;
         lmq.First;

         if lmq.RecordCount = 0 then
         begin
            lmq.Close;
            Exit;
         end;

         lmq.First;
         sbx_ZusFeld.Update;

         lmq2.SQL.Text := 'show tables like ' + #39 + 'cfgxs_' + fsDestIarcname + #39;
         lmq2.execute;
         if lmq2.RecordCount > 0 then
         begin
            lbhasxs := true;
            lmq2.SQL.Text := 'select * from cfgxs_' + fsDestIarcname + ' where usr_id = ' + inttostr(UserID);
            lmq2.execute;
         end
         else
         begin
            lbhasxs := false;
         end;

         GgfLogEvnt('lbhasxs:' + BoolToStr(lbhasxs));

         if lbhasxs then
         begin
            for iC := 0 to (lmq.RecordCount - 1) do // Iteriere ber die Zusatzfelder
            begin
               if (lmq.FieldByName('Optionen').AsInteger and 1) = 1 then   // Eingabepflicht
               begin
                  Result := False;
                  lmq2.first;
                  while not lmq2.eof do
                  begin
                     if (lmq.FieldByName('cfg_id').AsInteger = lmq2.FieldByName('cfg_id').AsInteger) then
                     begin
                        Result := true;   // Feld wurde in der cfgxs gefunden, wir haben Rechte
                        break;
                     end;
                     lmq2.next;
                  end;
               end;

               if not Result then   // wir haben ein Pflichtfeld gefunden, wo wir aber keine Rechte drauf haben
               begin
                  BfShowMessage(_('Das Archiv hat Pflichtfelder, auf die Sie aber keine Berechtigung haben.\nDer Vorgang wird abgebrochen.'));
                  Break;

               end;

               lmq.Next;
            end;
         end;
      except
         on e: exception do
         	LogEvnt('Fehler bei berprfung der Pflichtfeldrechte');
      end;
   finally
   	lmq.Free;
      lmq2.Free;
      GgfLogEvnt('CheckZusfieldsRights result:' + booltostr(result));
   end;
end;



procedure Tfrm_zuspflicht.zusfeldonchange(Sender: TObject);
var
   lcc: Tcomponent;
   lsnc : string;
begin
	if not bShowing then
   	Exit;

   if sender.ClassName = 'TEdit' then
   begin
   	TEdit(Sender).Tag := TEdit(Sender).Tag or 4;
   end;
   if sender.ClassName = 'TComboBox' then
   begin
      TComboBox(Sender).Tag := TComboBox(Sender).Tag or 4;
   end;
   if sender.ClassName = 'TJvCheckedComboBox' then
   begin
      TJvCheckedComboBox(Sender).Tag := TJvCheckedComboBox(Sender).Tag or 4;
   end;
   if sender.ClassName = 'TJvDateEdit' then
   begin
      TJvDateEdit(Sender).Tag := TJvDateEdit(Sender).Tag or 4;
   end;
   if sender.ClassName = 'TSpinEdit' then
   begin
      TSpinEdit(Sender).Tag := TSpinEdit(Sender).Tag or 4;
   end;
   if sender.ClassName = 'TJvSpinEdit' then
   begin
      TJvSpinEdit(Sender).Tag := TJvSpinEdit(Sender).Tag or 4;
   end;
end;

procedure Tfrm_zuspflicht.Searchzusfield(Sender: TObject);
var lstlw: TStringList;
  procedure WertAuswerten(Werte:string;ComboBox: TJvCheckedComboBox);
   var i: integer;  sTmp: string;
   begin
      lstlw := StrToWords6 (Werte);
      try
         for i := 0 to lstlw.Count - 1 do
         begin
            sTmp := lstlw.Strings[i];
            if (ComboBox.Items.IndexOf(lstlw.Strings[i]) = -1) and  //noch nicht drin?
               (lstlw.Strings[i] <> '') then
            begin
               ComboBox.Items.Add(lstlw.Strings[i]);
            end;
         end;
      finally
         FreeAndNil(lstlw);
      end;
   end;

var
   lstmp, lssst: string;
   linum: integer;
   lcomp, lcomp1, lcompMfach, lfbedt: TComponent;
   ljvst: tjvstatictext;
   bpflicht: boolean;
   bNoRights: boolean;
   ncbx: TComponent;
   lsender: TTBXButton;
   xDateTmp: TDateTime;
   xAddField: clAddField;
   xTmp     : integer;
   bMehrFach: boolean;
  edt: array of TEdit;
  lbl: array of tjvstatictext;
  cbx: array of TComboBox;
  dat: array of TJvDateEdit;
  spe: array of TSpinEdit;
  lfbit: array of TTBXButton;
  jccb: array of TjvcheckedComboBox;
  lganzzahl: array of TJvSpinEdit;
  ldouble: array of TjvSpinEdit;
  iC, iTyp, iCntEdt, iCntCbx, iCntCCbx, iCntLbl, iCntDat,
  iCntchx, litaborder, licount2,
  iCntbxb, iCntSpi,
  iCnttbxb, iCntganzzahl, iCntdouble, liTop, liScroll, liOptionen: integer;
  lfont: tfont;
  lbfound, lbrechte: boolean;
  lswert, lsDispName: string;
  ZusFldFrame:TFrameZusFldMulti;
  lTyp     : eAddFieldType;
  sbxWidth: integer;

begin
   iCntEdt := 0;
   iCntCbx := 0;
   iCntLbl := 0;
   iCntDat := 0;
   iCntChx := 0;
   iCnttbxb := 0;
   iCntbxb := 0;
   iCntCCbx := 0;
   iCntSpi := 0;
   iCntganzzahl := 0;
   iCntdouble := 0;
   litaborder := 2;

   litop := tbbt_search.Top;
   liScroll:= 0;

   sbxWidth:= sbx_ZusFeld.Width;

	if (Sender as TTBXButton).ImageIndex = 1 then
   begin
      (Sender as TTBXButton).ImageIndex:= 0;
      bpflicht := false;
      bMehrFach:= false;
	   bNoRights := False;
      with frm_zuspflicht do
		begin
         lsender := TTBXButton(sender);
         lstmp := copy(lsender.name, length('zedt_Tmptbxb') + 1, length(lsender.name) - length('zedt_Tmptbxb'));
         trystrtoint(lstmp, linum);
         lcomp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + lstmp);
         ljvst := tjvstatictext(sbx_ZusFeld.FindComponent('zlbl_Tmp' + lstmp));
         lfbedt:= FindComponentRekursivFrame(sbx_ZusFeld, 'lfbzedt_Tmp' + lstmp);

         case ljvst.Tag of
           0:
           begin
              lssst := Tedit(lcomp).text;
              bpflicht := tedit(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  tedit(lcomp).Color = cColorNoRightInit;
           end;
           1:
           begin
              if TJvDateEdit(lcomp).text <> cEmptyDateString then
                 lssst    := FormatDateTime ('yyyy-mm-dd', StrToDate(TJvDateEdit(lcomp).text))
              else
                lssst:= '';
              bpflicht := TJvDateEdit(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  TJvDateEdit(lcomp).Color = cColorNoRightInit;
           end;
           2:
           begin
              lssst := TComboBox(lcomp).text;
              bpflicht := TComboBox(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  TComboBox(lcomp).Color = cColorNoRightInit;
           end;
           3:
           begin
              lssst := TComboBox(lcomp).text;
              if lcomp is TJvCheckedComboBox then  //12.10.2010 b.takacs [2755] 3.5.0.109
                bMehrfach:= true;
              bpflicht := TComboBox(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  TComboBox(lcomp).Color = cColorNoRightInit;
           end;
           5:
           begin
              lssst := tspinedit(lcomp).text;
              lcomp1 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + lstmp);
              lssst := lssst + TComboBox(lcomp1).text;
              lcomp1.Free;
              bpflicht := tspinedit(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  tspinedit(lcomp).Color = cColorNoRightInit;
           end;
           6,7,8:
           begin
              lssst := TJvSpinEdit(lcomp).Text;
              bpflicht := TJvSpinEdit(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  TJvSpinEdit(lcomp).Color = cColorNoRightInit;
           end;
         end;

         if lfbedt <> nil then
         (lfbedt as TTBXButton).visible:= false;

         lcomp1 := sbx_ZusFeld.FindComponent('jbzedt_Tmp' + lstmp);
         if lcomp1 <> nil then
         begin
         	lcomp1.free;
         end;
         dm_db.my_q_CreZusTmp.sql.text := 'select * from arc_' + fsDestIarcname +
           ' where ' + lsender.hint + ' like ' + #39 + '%' + lssst + '%' + #39 + ' order by ' + lsender.hint + ';';
         dm_db.my_q_CreZusTmp.execute;

         lcomp.Free;

         if litop + 74 > sbx_ZusFeld.Height then
             liscroll := 16
         else
             litop := tbbt_search.Top;

         ncbx:= TComboBox.Create(sbx_ZusFeld);
         ncbx.Name := 'zedt_Tmp' + lstmp;

         xTmp :=  sbx_ZusFeld.VertScrollBar.Position;

         (ncbx as TComboBox).Left := 28;
         (ncbx as TComboBox).Hint := lsender.Hint;
         (ncbx as TComboBox).Top := 21 + (38 * linum) - xTmp;
         (ncbx as TComboBox).Height := 21;
         (ncbx as TComboBox).Width := (sbx_ZusFeld.width - 70)-liScroll;
         (ncbx as TComboBox).Anchors := [akLeft, akTop, akRight];
         (ncbx as TComboBox).Parent := sbx_ZusFeld;
         // Die Komponente erst am Schlu sichtbar machen
         (ncbx as TComboBox).Clear;
         (ncbx as TComboBox).Items.Add('');

         xAddField := clArchiv.getInstance.AddFieldTab.findComp ((ncbx as TComboBox).Name);

         if (xAddField <> nil) then
         begin
         	xAddField.isCatchWord := true;
         end;

         if bpflicht then
         begin
         	(ncbx as TComboBox).Color := cColorPflichtfeld;
         end;
         if bNoRights then
         begin
         	(ncbx as TComboBox).Color := cColorNoRightInit;
         end;

         dm_db.my_q_CreZusTmp.First;
         while not dm_db.my_q_CreZusTmp.eof do
         begin
            if (dm_db.my_q_CreZusTmp.fieldbyname(lsender.Hint).asstring <> '')
             and (0 >= (ncbx as TComboBox).Items.IndexOf(dm_db.my_q_CreZusTmp.fieldbyname(lsender.Hint).asstring)) then
            begin
            	(ncbx as TComboBox).Items.Add(dm_db.my_q_CreZusTmp.fieldbyname(lsender.Hint).asstring);
            end;
            dm_db.my_q_CreZusTmp.Next;
         end;
         if (ncbx as TComboBox).Items.Count = 2 then
         begin
         	(ncbx as TComboBox).ItemIndex := 1;
            (ncbx as TComboBox).Tag := (ncbx as TComboBox).Tag or 4;
         end;

   	end;
   end
   else if ((Sender as TTBXButton).ImageIndex = 0) then
   begin
   	(Sender as TTBXButton).ImageIndex:= 1;
     	bpflicht := false;
     	bMehrFach:= false;
     	with frm_zuspflicht do
     	begin
        lsender := TTBXButton(sender);
        lstmp := copy(lsender.name, length('zedt_Tmptbxb') + 1, length(lsender.name) - length('zedt_Tmptbxb'));
        trystrtoint(lstmp, linum);
        lcomp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + lstmp);
        ljvst := tjvstatictext(sbx_ZusFeld.FindComponent('zlbl_Tmp' + lstmp));
        case ljvst.Tag of
           0:
           begin
              bpflicht := tedit(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  tedit(lcomp).Color = cColorNoRightInit;
           end;
           1:
           begin
              bpflicht := TJvDateEdit(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  TJvDateEdit(lcomp).Color = cColorNoRightInit;
           end;
           2:
           begin
              bpflicht := TComboBox(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  TComboBox(lcomp).Color = cColorNoRightInit;
           end;
           3:
           begin
              if lcomp is TJvCheckedComboBox then  //12.10.2010 b.takacs [2755] 3.5.0.109
                bMehrfach:= true;
              bpflicht := TJvCheckedComboBox(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  TJvCheckedComboBox(lcomp).Color = cColorNoRightInit;
           end;
           5:
           begin
              bpflicht := tspinedit(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  tspinedit(lcomp).Color = cColorNoRightInit;
           end;
           6,7,8:
           begin
              lssst := TJvSpinEdit(lcomp).Text;
              bpflicht := TJvSpinEdit(lcomp).Color = cColorPflichtfeld;
              bNoRights :=  TJvSpinEdit(lcomp).Color = cColorNoRightInit;
           end;
        end;

         lcomp1 := sbx_ZusFeld.FindComponent('jbzedt_Tmp' + lstmp);
         if lcomp1 <> nil then
         begin
           lcomp1.free;
         end;

			lcomp.Free;

         sbx_ZusFeld.Repaint;
         Application.ProcessMessages;

         dm_DB.my_q_CreZusTmp.SQL.Text := 'Select * from cfg_' + fsDestIarcname + '  where  (typ <> 4) and (Feld_Name=' + #39 + lsender.hint + #39 + ') order by pos';
         dm_db.my_q_CreZusTmp.execute;

         if litop + 74 > sbx_ZusFeld.Height then
         	liscroll := 16
         else
            litop := (ljvst as TJvStaticText).Top;

         xTmp :=  sbx_ZusFeld.VertScrollBar.Position;
         iTyp :=  dm_DB.my_q_CreZusTmp.FieldByName('Typ').AsInteger;
         lTyp :=  eAddFieldType(iTyp);
         IC:= strToInt(lstmp);
         if lTyp = zfld00_Universal then
         begin
                  SetLength(edt, iCntEdt + 1);
           CreateUniversal(false,edt,iCntEdt,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusTmp,
                                 'zedt_Tmp',28,(sbxWidth-70)-liScroll,[akLeft,akTop,akRight], not bNoRights,xTmp);
         end
         else
         if lTyp = zfld01_Datum then
         begin
            SetLength(dat, iCntDat + 1);
                   CreateDatum(false,dat,iCntDat,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusTmp,
                               'zedt_Tmp',28,150,[akLeft,akTop,akRight],not bNoRights,xTmp);
         end
         else
         if lTyp = zfld02_Auswahl then
         begin
            SetLength(cbx, iCntCbx + 1);
            CreateAuswahl(false,cbx,iCntCbx,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusTmp,
                                  'zedt_Tmp',28,(sbxWidth-70)-liScroll,[akLeft,akTop,akRight],'',not bNoRights,xTmp);
         end
         else
         if lTyp = zfld03_MehrfachAuswahl then
         begin
             SetLength(lbl, iCntLbl + 1);
            lbl[iCntLbl] := TJvStaticText.Create(nil);
            lbl[iCntLbl].Name := lsender.Name;
            lbl[iCntLbl].Hint := lsender.Hint;
            lbl[iCntLbl].Tag := lsender.Tag;
            lbl[iCntLbl].TabStop := false;


            CreateMehrfachauswahl(false,lbl,ZusFldFrame,lfbit,jccb,iCntCCbx,iCntbxb,lsDispName,sbx_ZusFeld,IC,lswert,litaborder,
               liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusTmp,sAdd,iCntLbl,28,(sbxWidth-70)-liScroll,fsDestIarcname,zusfeldonchange,not bNoRights,xTmp);
           SetLength(jccb, iCntCCbx + 1);
           jccb[iCntCCbx] := ZusFldFrame.ComboBox;
           Inc(iCntCCbx, 1);
           SetLength(lfbit, iCntbxb + 1);
           lfbit[iCntbxb] := ZusFldFrame.Button;
           ZusFldFrame.Button.Visible:= true;
           Inc(iCntbxb, 1);
         end
         else
         if lTyp = zfld05_Intervall then
         begin
            SetLength(spe, iCntSpi + 1);
            CreateIntervall(false,spe,iCntSpi,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusTmp,
                                  'zedt_Tmp',28,75,[akLeft,akTop],false,xTmp);
         end
         else
         if lTyp = zfld06_GanzZahl then
         begin
            SetLength(lganzzahl, iCntganzzahl + 1);
            CreateGanzZahl(false,lganzzahl,iCntganzzahl,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusTmp,
                                  'zedt_Tmp',28,75,[akLeft,akTop],not bNoRights,xTmp);
         end
         else
         if   (lTyp = zfld07_FliessKomma)
           or (ltyp = zfld08_Waehrung   ) then
         begin
            SetLength(ldouble, iCntdouble + 1);
            CreateFliessKommaWaehrung(false,ldouble,iCntdouble,sbx_ZusFeld,IC,lswert,litaborder,liZusatzFeldOptEingabepflicht,dm_DB.my_q_CreZusTmp,
                                  'zedt_Tmp',28,0,[akLeft,akTop],iTyp,not bNoRights,xTmp);
         end;
      end;
   end;
end;


procedure Tfrm_zuspflicht.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'u_ShDlgAddFields');
   slZusFeld:=Tstringlist.Create();
   slZusFeldWert:=Tstringlist.Create();
   slHistory:=Tstringlist.Create();
   bShowing := False;
   Self.Caption := _('Pflicht-Zusatzfelder');
   Self.tbbt_search.Caption := _('Suchen');
   Self.btn_ok.Caption := _('Verschieben');
   Self.btn_cancel.Caption := _('Abbrechen');
end;


procedure Tfrm_zuspflicht.tbbt_searchClick(Sender: TObject);
var
   iCount, licount2, litop, liscroll, xTmp: integer;
   comp, comp2, comp3, comp4, comp5, comp6, lfbedt: TComponent;
   lCompFrame : TComponent; //TFrameZusFldMulti;
   bfound, bpflicht: boolean;
   lstext: string;
   lsaddname, lsgroupby, lsSql, lsSql2, lsTmp: string;
   ncbx: TComboBox;
   lstlw: Tstringlist;
begin
   bpflicht := false;
   GgfLogEvnt('Tfrm_Main.btn_SearchClick');

   lsSQL := 'select * from arc_' + fsDestIarcname ;
   bfound := false;
   //Alle Zusatzfelder durchgehen
   for iCount := 0 to (sbx_ZusFeld.ComponentCount - 1) do
   begin
      comp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmpchx' + IntToStr(iCount));
      comp2 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));
      comp3 := FindComponentRekursivFrame(sbx_ZusFeld, 'zlbl_Tmp' + IntToStr(iCount));

      if comp = NIL then
        break;

      lsaddname := tlabel(comp3).Hint;

      if lsgroupby = '' then
      begin
         lsgroupby := lsaddname;
      end
      else
      begin
         lsgroupby := lsgroupby + ',' + lsaddname;
      end;
      if comp2 is Tedit then
      begin
         lstext := tedit(comp2).Text;
      end
      else
      if comp2 is TJvDateEdit then
      begin
         if TJvDateEdit(comp2).Text = cEmptyDateString then
            lstext := ''
         else
            lstext := FormatDateTime ('yyyy-mm-dd', StrToDate (TJvDateEdit(comp2).Text));
      end
      else
      if comp2 is TComboBox then
      begin
         lstext := TComboBox(comp2).Text;
      end
      else
      if comp2 is TjvcheckedComboBox then
      begin
         lstext := TjvcheckedComboBox(comp2).Text;
      end
      else
      if comp2 is Tspinedit then
      begin
         lstext := Tspinedit(comp2).Text;
         comp4 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(iCount));
         lstext := lstext + TComboBox(comp4).Text;
      end
      else
      if comp2 is TJvSpinEdit then
      begin
         lstext := TJvSpinEdit(comp2).Text;
      end;

      if Tcheckbox(comp).Checked then
      begin
         lstlw := StrToWords7(ParseSemicolonUseBackslash(lstext));

         lsSql2 :='';
         for licount2 := 0 to lstlw.Count - 1 do
         begin
            lsTmp := lstlw.Strings[licount2];
            if lsSql2 <> '' then
            	lsSql2 := lsSql2 + ' or ';
            lsSql2 := lsSql2 +  '(' + lsaddname + ' like ' + #39 + '%' + lsTmp + '%' + #39 + ')';
         end;

         if not bfound then
         begin
            if lstlw.count > 0 then
            begin
               lsSQL := lsSQL + ' where (' + lsSql2 + ')';
            end;
            bfound := true;
         end
         else
         begin
            if lstlw.count > 0 then
            begin
               lsSQL := lsSQL + ' and ' + '(' + lsSql2 + ')';
            end;
         end;
      end;
   end;

   lsSQL := lsSQL + ' group by ' + lsgroupby;
   dm_db.my_q_Tmp.sql.text := lsSQL;
   dm_db.my_q_Tmp.Execute;

   for iCount := 0 to (sbx_ZusFeld.ComponentCount - 1) do
   begin
      lCompFrame := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_Frame' + IntToStr(iCount));
      comp       := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmpchx'    + IntToStr(iCount));
      comp2      := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp'       + IntToStr(iCount));
      comp3      := FindComponentRekursivFrame(sbx_ZusFeld, 'zlbl_Tmp'       + IntToStr(iCount));
      comp4      := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_'  + IntToStr(iCount));
      comp6 	  := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_'    + IntToStr(iCount));

      if comp = Nil then
	      Break;

      if litop + 74 > sbx_ZusFeld.Height then
      	liscroll := 16
      else
         litop := tbbt_search.Top;

      if not Tcheckbox(comp).Checked then
      begin
         if comp2 is TjvDateedit then
            bpflicht := TjvDateedit(comp2).Color = cColorPflichtfeld
         else
         if comp2 is Tedit then
            bpflicht := tedit(comp2).Color = cColorPflichtfeld
         else
         if comp2 is TJvDateEdit then
            bpflicht := TJvDateEdit(comp2).Color = cColorPflichtfeld
         else
         if comp2 is TComboBox then
            bpflicht := TComboBox(comp2).Color = cColorPflichtfeld
         else
         if comp2 is TSpinEdit then
            bpflicht := TComboBox(comp2).Color = cColorPflichtfeld
         else
         if comp2 is TjvcheckedComboBox then
            bpflicht := TjvcheckedComboBox(comp2).NoFocusColor = cColorPflichtfeld
         else
         if comp2 is TJvSpinEdit then
            bpflicht := TJvSpinEdit(comp2).Color = cColorPflichtfeld;
         
         if lCompFrame <> nil then //3.5.0.11
         begin
            TFrameZusFldMulti(lCompFrame).FreeComboAndButton;
            FreeAndNil(lCompFrame);
         end
         else
         if comp2 <> nil then
         begin
            FreeAndNil(comp2);
         end;
         if comp4 <> nil then
         begin
            FreeAndNil(comp4);
         end;

         if comp6 <> nil then
         begin
         	FreeAndNil(comp6);
         end;

         xTmp := sbx_ZusFeld.VertScrollBar.Position;

         ncbx := TComboBox.Create(sbx_ZusFeld);
         ncbx.Name := 'zedt_Tmp' + IntToStr(iCount);
         ncbx.Left := 28;
         ncbx.Top := 21 + (38 * iCount) - xTmp;
         ncbx.Height := 21;
         ncbx.Width := (sbx_ZusFeld.Width - 70)-liScroll;
         ncbx.Anchors := [akLeft, akTop, akRight];
         ncbx.OnChange := zusfeldonchange;
         if Assigned(lCompFrame) then
         begin
            ncbx.Left := 0;
            ncbx.Top := 1;
            ncbx.Parent := TFrameZusFldMulti(lCompFrame); // Die Komponente erst am Schlu sichtbar machen
         end
         else
         begin
            ncbx.Left := 28;
            //ncbx.Top := litop;
            ncbx.Parent := sbx_ZusFeld; // Die Komponente erst am Schlu sichtbar machen
         end;

         ncbx.Clear;
         ncbx.Items.Add('');
         if bpflicht then
         begin
            ncbx.Color := cColorPflichtfeld;
         end;
         ncbx.Sorted := true;
         dm_db.my_q_Tmp.First;
         while not dm_db.my_q_Tmp.eof do
         begin
            if (dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring <> '')
               and (0 >= ncbx.Items.IndexOf(dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring)) then
            begin
               ncbx.Items.Add(dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring);
            end;
            dm_db.my_q_Tmp.Next;
         end;
         if ncbx.Items.Count <= 2 then // nur ein Eintrag (+ Leereintrag)
         begin
            (ncbx as TComboBox).ItemIndex := 1;
            (ncbx as TComboBox).Tag := (ncbx as TComboBox).Tag or 4;
         end;
      end;
   end;
end;


procedure Tfrm_zuspflicht.tbxb_resetClick(Sender: TObject);
begin
   DelZusFields;
   CreZusFields;
end;


procedure Tfrm_zuspflicht.setMoveOk (Ok: Boolean);
begin
 btn_ok.Enabled := Ok;
end;


procedure Tfrm_zuspflicht.OnChangeComboBox (Sender: TObject);
begin
 setMoveOk (getTextIdx (Sender as TComboBox) >= 0);
 TComboBox(Sender).Tag := TComboBox(Sender).Tag or 4;
end;


// 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
//
procedure Tfrm_zuspflicht.onExitComboBox (Sender: TObject);

var
 lBox : TComboBox;
 lText: String;

begin
   lBox  := Sender as TComboBox;
   lText := lBox.Text;

   if gExitFlag then
    begin
      gExitFlag := False;
      lBox.SetFocus;
      Abort;
    end;

   if adjustText (lBox) then
   begin
   	setMoveOk (True);
    end
    else
    begin
      setMoveOk   (False);
      ShowMessage (Format(_('Die Eingabe "%s" ist ungltig!'),[lText]) +#13
                         +_('Bitte whlen Sie einen Eintrag aus der Auswahlliste.'));
      lBox.SetFocus;
      gExitFlag := True;
    end;
end;
//
//  Name:
//  Parameters:
//  Description:
//  Return value:
// []  b.takacs
//------------------------------------------------------------------------------
procedure Tfrm_zuspflicht.onExitComboBoxBySearch (Sender: TObject);
  begin
    adjustText (TComboBox (Sender));
  end;
//
procedure Tfrm_zuspflicht.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  slZusFeld.Destroy;
  slZusFeldWert.Destroy;
end;

procedure Tfrm_zuspflicht.FormShow(Sender: TObject);
begin
  dm_DB.bgCancelfrmZuspflicht:= false; //25.03.2011 b.takacs [2813] 3.5.0.170
  bShowing := True;
end;

procedure Tfrm_zuspflicht.btn_cancelClick(Sender: TObject);
begin
   dm_DB.bgCancelfrmZuspflicht:= true; //25.03.2011 b.takacs [2813] 3.5.0.170
end;


//
//  Name:
//  Parameters:
//  Description:
//  Return value:
// [3126] b.takacs 28.07.2011 3.5.1.34
//------------------------------------------------------------------------------
procedure Tfrm_zuspflicht.RestoreAdditionalFields(Sender: TJvScrollBox);
var
	j: integer;
begin
	for j:= 0 to Sender.ControlCount-1 do
  begin
 	  Bfshowmessage(Sender.Components[j].Name);
  end;

end;

procedure Tfrm_zuspflicht.Feldzurckzuschalten1Click(Sender: TObject);
begin
  RestoreAdditionalFields(frm_zuspflicht.sbx_ZusFeld);  //28.07.2011 b.takacs 3.5.1.34 [3126]
end;

procedure Tfrm_zuspflicht.FormDestroy(Sender: TObject);
begin
	slHistory.Destroy;
end;

end.







