unit u_ShDocEditOpt;

(*
  ------------------------------------------------------------------------------
  Dialog zum Editieren von Objekt-Eigenschaften und Stempeln
  ------------------------------------------------------------------------------
  18.05.2010  r.sch.
  ------------------------------------------------------------------------------
*)

//////////////////////////////////////////////////////////////////////////////////////////////////////
//     NG u_DOCEditOpt Igel061122 Textlabel zeigt die Steuerzeichen der Textvariablen an

interface

{3.6<}
uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ComCtrls, Buttons, ExtCtrls, Registry, ievect, ImageEnView,
   ieview, hyiedefs, hyieutils, ImageEnProc, JvExStdCtrls, JvCombobox,
   JvListComb, Placemnt, gnugettext,
   u_ShBase, u_ShLowUtils, u_ShHighUtils, Mask, JvExMask, JvSpin,
  JvColorCombo;
{>3.6}

type
   Tfrm_DocEditOpt = class (TForm)
      pctrl_DocEditOpt: TPageControl;
      tbs_Standard: TTabSheet;
      tbs_Annotations: TTabSheet;
      btn_Cancel: TButton;
      btn_Save: TButton;
      btn_ok: TButton;
      tctrl_Annos: TTabControl;
      chbx_EnaRenderEn: TCheckBox;
      chbx_EnaAntialias: TCheckBox;
      grbx_Color: TGroupBox;
      lbl_CBackground: TLabel;
      lbl_CBorder: TLabel;
      lbl_CLabel: TLabel;
      lbl_CNoteBorder: TLabel;
      clbx_CBackground: TColorBox;
      clbx_CBorder: TColorBox;
      clbx_CLabel: TColorBox;
      clbx_CNoteBorder: TColorBox;
      grbx_Brush: TGroupBox;
      lbl_BBackground: TLabel;
      lbl_BBorder: TLabel;
      lbl_BLabel: TLabel;
      lbl_BNoteBorder: TLabel;
      grbx_Shape: TGroupBox;
      lbl_SShapeStart: TLabel;
      lbl_SShapeEnd: TLabel;
      lbl_SSHeight: TLabel;
      lbl_SSWidth: TLabel;
      pnl_SShape: TPanel;
      rbtn_SENo: TRadioButton;
      rbtn_SEOut: TRadioButton;
      rbtn_SEIn: TRadioButton;
      rbtn_SSNo: TRadioButton;
      rbtn_SSOut: TRadioButton;
      rbtn_SSIn: TRadioButton;
      edt_SSHeight: TEdit;
      edt_SSWidth: TEdit;
      grbx_Text: TGroupBox;
      lbl_TFont: TLabel;
      lbl_TFontAngle: TLabel;
      lbl_TFontSize: TLabel;
      sbtn_TFont: TSpeedButton;
      lbl_TLabelPos: TLabel;
      lbl_TAlign: TLabel;
      lbl_TGrad: TLabel;
      edt_TFont: TEdit;
      edt_TFontAngle: TEdit;
      edt_TFontSize: TEdit;
      cbx_TLabelPos: TComboBox;
      cbx_TAlign: TComboBox;
      memo_TObjText: TMemo;
      dlg_Schrift: TFontDialog;
      tbs_Stempel: TTabSheet;
      grbx_Stamps: TGroupBox;
      lv_Stamps: TListView;
    grp_StampBorder: TGroupBox;
      btn_NewStamp: TButton;
      btn_SaveStamp: TButton;
      btn_DelStamp: TButton;
      lbl_SName: TLabel;
      lbl_STyp: TLabel;
      memo_SText: TMemo;
      lbl_SText: TLabel;
      lbl_SBild: TLabel;
      edt_SName: TEdit;
      rbtn_SText: TRadioButton;
      rbtn_SBild: TRadioButton;
      edt_SBild: TEdit;
      sbtn_SBild: TSpeedButton;
      lbl_SFont: TLabel;
      edt_SFont: TEdit;
      sbtn_SFont: TSpeedButton;
      img_SBild: TImageEnView;
      lbl_SWidth: TLabel;
      edt_SHeight: TEdit;
      edt_SWidth: TEdit;
      lbl_SWidthMes: TLabel;
      LblText1: TLabel;
      lbl_Stemp_how2: TLabel;
      btn_transp: TButton;
      lv_eigenschaftstempel: TListView;
      frmsto_docoptionen: TFormStorage;
      cbx_textform: TCheckBox;
      grbx_Algem: TGroupBox;
      lbl_AObjName: TLabel;
      lbl_APenWidth: TLabel;
      lbl_ARulerTyp: TLabel;
      lbl_ARulerMeasure: TLabel;
      lbl_ATransp: TLabel;
      lbl_APixel: TLabel;
      lbl_objheight: TLabel;
      lbl_objwidth: TLabel;
      edt_AObjName: TEdit;
      edt_APenWidth: TEdit;
      cbx_ARulerTyp: TComboBox;
      cbx_ARulerMes: TComboBox;
      chbx_AOpenPoly: TCheckBox;
      chbx_AIsHiLite: TCheckBox;
      chbx_ASizeable: TCheckBox;
      chbx_AVisible: TCheckBox;
      chbx_AMoveable: TCheckBox;
      chbx_ASelectable: TCheckBox;
      edt_ATransp: TEdit;
      edt_objheight: TEdit;
      Edt_objwidth: TEdit;
      cbx_nummer: TComboBox;
      lbl_nummer: TLabel;
      chbx_TObjAutoSize: TCheckBox;
      chbx_TFontLocked: TCheckBox;
      cbx_autolineincrease: TCheckBox;
      cbx_autoincreasehigh: TCheckBox;
      cbx_BBackground: TJvImageComboBox;
      cbx_BBorder: TJvImageComboBox;
      cbx_BLabel: TJvImageComboBox;
      cbx_BNoteBorder: TJvImageComboBox;
    lbl1: TLabel;
    cbb_fav: TComboBoxEx;
    lbl_Textstyle: TLabel;
    lbl_Stampcolor: TLabel;
    clrbx_Stampborder: TColorBox;
    clrbx_Stampcolor: TColorBox;
    cbx_Textstyle: TJvImageComboBox;
    cbx_Stampstyle: TJvImageComboBox;
    cbx_Stampborder: TJvImageComboBox;
    lbl_Stampborder: TLabel;
    lbl_Deckkraft: TLabel;
    edt_Deckkraft1: TJvSpinEdit;
    chk_Anpassen: TCheckBox;
      procedure btn_SaveClick(Sender: TObject);
      procedure tctrl_AnnosChange(Sender: TObject);
      procedure tctrl_AnnosChanging(Sender: TObject; var AllowChange: boolean);
      procedure btn_okClick(Sender: TObject);
      procedure edt_SSHeightChange(Sender: TObject);
      procedure edt_SSWidthChange(Sender: TObject);
      procedure edt_APenWidthChange(Sender: TObject);
      procedure edt_ATranspChange(Sender: TObject);
      procedure edt_TFontAngleChange(Sender: TObject);
      procedure edt_TFontSizeChange(Sender: TObject);
      procedure cbx_TLabelPosChange(Sender: TObject);
      procedure cbx_TAlignChange(Sender: TObject);
      procedure cbx_ARulerTypChange(Sender: TObject);
      procedure cbx_ARulerMesChange(Sender: TObject);
      procedure sbtn_TFontClick(Sender: TObject);
//      procedure chbx_EnaRenderEnClick(Sender: TObject);
//      procedure chbx_EnaAntialiasClick(Sender: TObject);
      procedure edt_SBildChange(Sender: TObject);
      procedure btn_NewStampClick(Sender: TObject);
      procedure btn_SaveStampClick(Sender: TObject);
      procedure btn_DelStampClick(Sender: TObject);
      procedure lv_StampsClick(Sender: TObject);
      procedure sbtn_SBildClick(Sender: TObject);
      procedure rbtn_STextClick(Sender: TObject);
      procedure rbtn_SBildClick(Sender: TObject);
      procedure tbs_AnnotationsShow(Sender: TObject);
      procedure tbs_StandardShow(Sender: TObject);
      procedure tbs_StempelShow(Sender: TObject);
      procedure sbtn_SFontClick(Sender: TObject);
      procedure edt_SWidthChange(Sender: TObject);
      procedure edt_SHeightChange(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure img_SBildClick(Sender: TObject);
//      procedure btn_transpClick(Sender: TObject);
      procedure img_SBildMouseMove(Sender: TObject; Shift: TShiftState;
         X, Y: integer);
      procedure lv_eigenschaftstempelClick(Sender: TObject);
      procedure frmsto_docoptionenRestorePlacement(Sender: TObject);
      procedure cbx_nummerChange(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure memo_TObjTextKeyDown(Sender: TObject; var Key: Word;
         Shift: TShiftState);
    procedure chk_AnpassenClick(Sender: TObject);

   private
     //  private Deklarationen eingefhrt fr:
     //  12.05.2010  Vers. 3.5.0.76  [2197]  r.sch.

     mStampFavoOld: Integer;

     function  isCreateStampOk     (stampName: String ) : boolean;
     function  isSaveStampOk       (stampKey : string ) : boolean;
     function  existsStampName     (stampName: String ) : Boolean;
     procedure selectStampListItem (stampName: string );  overload;
     procedure selectStampListItem (Idx      : integer);  overload;


   protected
      { Private-Deklarationen }
      fifavnum: integer;
      procedure CreateParams(var Params: TCreateParams); override;
   public
      { Public-Deklarationen }
      floadedindex: integer;

      function  LoadObjVal             (ObjTyp: integer)      : boolean;
      function  SaveObjVal             (ObjTyp: integer)      : boolean;
      function  LoadDocEditOpt                                : boolean;
      function  SaveDocEditOpt                                : boolean;
      function  ListStamps             (fobjekteigen: boolean): boolean;
      function  LoadStamp              (StampKey    : string ): boolean;
      function  LoadStampEigenschaften (StampKey    : string ): boolean;
      function  CreStamp                                      : boolean;
      function  SavStamp               (StampKey    : string ): boolean;
      function  DelStamp               (StampKey    : string ): boolean;
//    procedure SetTransparent;
      procedure loadfavstampbuttons;
      function  ShowStampsElements   (StampTyp: Boolean): boolean;
      procedure EnableBreiteHoehe(bEnable: Boolean);
   end;

var
   frm_DocEditOpt: Tfrm_DocEditOpt;
   sGStampKey    : string; // aktuell bearbeiteter Stempel-Schlssel

(*
  ------------------------------------------------------------------------------
*)
implementation
(*
  ------------------------------------------------------------------------------
*)

{$R *.dfm}

//uses {u_MainForm, u_DocEditor,u_PickDialog,} u_dm_DocEditor  {, u_dm_ViewerMain,};

/////////////////////////////////////////////////////////////////////////////////////////////////////
//  Stempel lschen

function Tfrm_DocEditOpt.DelStamp(StampKey: string): boolean;
var
   reg: TRegistry;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            DeleteKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey);
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEditOpt.DelStamp',
               _('Fehler beim Schreiben in die Registrierung:') + e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;


(*
  Zweck:
    Selektiert einen Eintrag der ListView 'lv_stamps' ber den Listen-Index
  Eingabe:
    'Idx' Ist der zu selektierende Listen-Index
*)
procedure Tfrm_DocEditOpt.selectStampListItem (Idx: integer);
  begin
    if Idx  > lv_Stamps.Items.Count -1 then
       Idx := lv_Stamps.Items.Count -1;

    if lv_Stamps.Items.Count > 0 then
    begin
      lv_stamps.ItemIndex := Idx;
      sGStampKey          := lv_Stamps.Selected.SubItems.Strings [1];

      LoadStamp (sGStampKey);
    end;
  end;


(*
  Zweck:
    Selektiert einen Eintrag der ListView 'lv_stamps' ber den Namen
  Eingabe:
    'stampName' Ist der zu selektierende Stempel-Name
*)
procedure Tfrm_DocEditOpt.selectStampListItem (stampName: string);

  var
    lIdx   : Integer;
    lIdxMax: Integer;

  begin
    lIdxMax := lv_stamps.Items.Count -1;

    for lIdx := 0 to lIdxMax do
    begin
      if stampName = lv_stamps.Items.Item [lIdx].Caption then
      begin
        selectStampListItem (lIdx);
        break;
      end;
    end;
  end;


(*
  Zweck:
    berprft, ob der Stempel mit Hilfe der Daten aus der Dialog-Maske
    in der Win-Registry gesichert werden kann.
  Eingabe:
    'stampKey' Stempel-Schlssel aus der Win-Registry
  Rckgabe:
    true: Der Stempel darf gesichert werden.
*)
function Tfrm_DocEditOpt.isSaveStampOk (stampKey: string): boolean;

  var
    lStampName: string;
    lsMsg:      string;
  begin
    Result     := True;
    lStampName := edt_SName.Text;  //  Stempel-Name aus Masken-Feld entnehmen

    if trim (lStampName) = '' then
    begin
      lsMsg:=_('Es ist kein Stempel-Name vergeben worden!') +#13+#10
                 +_('Bitte Stempel-Namen eintragen!');
      MessageBox(Self.Handle,PChar(lsMSg),PChar(''),MB_OK);
      edt_SName.Text := '';
      edt_SName.SetFocus;

      Result := False;
    end
    else
    if trim (stampKey) = '' then
    begin
       lsMsg:=_('Der Stempel konnte nicht in der Regestry gespeichert werden!');
       MessageBox(Self.Handle,PChar(lsMSg),PChar(''),MB_OK);
       result := false;
       exit;
    end;
  end;


(*
  Zweck:
    Sichert die Daten eines Stempels in der Win-Registry.
  Voraussetzung:
    Der Stempel mu bereits in der Win-Registry vorhanden sein.
  Eingabe:
    'StampKey': Der Registry-Schlssel des Stempels
  Rckgabe:
    true: Der Eintrag in die Win-Registry hat geklappt.
*)
function Tfrm_DocEditOpt.SavStamp (StampKey: string): boolean;

type
  rListEntry =
    record
      Name  : String;
      FavoNr: Integer;
      Key   : String;
    end;

var
  reg: TRegistry;
  fsTmp: TFontStyles;
  reg1: TRegistry;
  shTmp: TIEShape;
  bsTmp: TBrushStyle;
  lpTmp: TIELabelPos;
  //    ssTmp: TIEVSoftShadow;
  psTmp: TPenStyle;
  rtTmp: TIEVRulerType;
  ruTmp: TIEUnits;
  osTmp: TIEVStyle;
  taTmp: TIEAlignment;
  lipencolor,
  lFavoNr,
  lIdx        : integer;
  lFavoExists : boolean;
  lListEntry  : rListEntry;
  lsMsg     : string;
  lsInfo    : string;
  lsStampText:string;
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.SavStamp');

   if not isSaveStampOk (StampKey) then
   begin
      Result := false;
      exit;
   end;

   Result     := True;
   reg        := TRegistry.Create;
   fsTmp      := dlg_Schrift.Font.Style;
   lipencolor := dlg_Schrift.Font.color;

   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;

            if not rbtn_SBild.Checked then  //  Bei Text-Stempeln die Bilddatei lschen,
              edt_SBild.Text := '';         //  denn beides wird zur Typ-Abfrage verwendet!

            if not rbtn_SText.Checked then
              memo_SText.Text := '';


            if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
               exit;

            lsStampText:= memo_SText.Text;
            lsStampText:= StringReplace(lsStampText,#13#10,'\n\r',[rfReplaceAll]);
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);

            WriteString     ('StampName',     edt_SName.Text            );
            WriteString     ('StampFile',     edt_SBild.Text            );
            WriteString     ('StampText',     lsStampText               );
            WriteBool       ('StampTyp',      rbtn_SBild.Checked        );
            WriteBool       ('StampFitToText',      chk_Anpassen.Checked);
            WriteInteger    ('StampHeight',   StrToInt(edt_SHeight.Text));
            WriteInteger    ('StampWidth',    StrToInt(edt_SWidth .Text));
            WriteInteger    ('FontColor',     dlg_Schrift.Font.Color    );
            WriteString     ('FontName',      dlg_Schrift.Font.Name     );
            WriteBinaryData ('FontStyle',     fsTmp, SizeOf(fsTmp)      );
            WriteInteger    ('FontSize',      dlg_Schrift.Font.size     );
            //WriteInteger    ('ObjFontHeight', dlg_Schrift.Font.size     );
            WriteInteger    ('ObjTransparency',    StrToInt(edt_Deckkraft1.Text));

            case cbx_Textstyle.ItemIndex of
                  0:
                     bsTmp := bsClear;
                  1:
                     bsTmp := bsSolid;
                  (*
                  2:
                     bsTmp := bsBDiagonal;
                  3:
                     bsTmp := bsVertical;
                  4:
                     bsTmp := bsHorizontal;
                  5:
                     bsTmp := bsCross;
                  6:
                     bsTmp := bsDiagCross;
                  7:
                     bsTmp := bsSolid;
                     *)
               end;
               WriteBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp));

               case cbx_Stampstyle.ItemIndex of
                  0:
                     bsTmp := bsClear;
                  1:
                     bsTmp := bsFDiagonal;
                  2:
                     bsTmp := bsBDiagonal;
                  3:
                     bsTmp := bsVertical;
                  4:
                     bsTmp := bsHorizontal;
                  5:
                     bsTmp := bsCross;
                  6:
                     bsTmp := bsDiagCross;
                  7:
                     bsTmp := bsSolid;
               end;
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));

               WriteInteger    ('objBrushColor',  clrbx_Stampcolor.Selected);

               case   cbx_Stampborder.ItemIndex of
                   0:
                      psTmp :=  psSolid;
                   1:
                      psTmp :=  psClear;
                   2:
                      psTmp :=  psDash;
                   3:
                      psTmp :=   psDashDot;
                   4:
                      psTmp := psDashDotDot;
                   5:
                      psTmp := psDot;
               end;
               WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));

               WriteInteger    ('objMemoBorderColor',  clrbx_Stampborder.Selected);

            lFavoNr     := cbb_fav.ItemIndex;  // aus Combo-Box
            lFavoExists := False;

            if lFavoNr > 0 then
            begin
               for lIdx := 0 to lv_stamps.Items.Count - 1 do
               begin
                 lListEntry.Name   :=            lv_stamps.Items.Item [lIdx].Caption;
                 lListEntry.FavoNr := StrToInt0 (lv_Stamps.Items.Item [lIdx].SubItems [0]);
                 lListEntry.Key    :=            lv_Stamps.Items.Item [lIdx].SubItems [1];

                  if    (lListEntry.FavoNr  > 0       )
                    and (lListEntry.FavoNr  = lFavoNr )
                    and (lListEntry.Key    <> StampKey)
                  then
                  begin
                    lFavoExists  := True;
                    break;
                  end;
               end;
            end;

            if lFavoExists then
            begin

               lsMsg:= Format(_('Es gibt bereits einen Stempel mit der Favoriten Nr: %d') +
                        #13 + _('Mchten Sie diese Nummer neu vergeben?'),[lFavoNr]);
               lsInfo:= _('Favoritennummer belegt');
               if MessageBox(Self.Handle,Pchar(lsMsg),PChar(lsInfo),
                 MB_ICONQUESTION or MB_YESNO) = mrNo
               then
               begin
                 lFavoNr           := mStampFavoOld;  //  12.05.2010  r.sch.  3.5.0.76  [2197]
                 cbb_fav.ItemIndex := mStampFavoOld;
               end
               else
               begin
                  //          reg.CloseKey;
                  reg1         := TRegistry.Create;
                  reg1.RootKey := HKEY_CURRENT_USER;

                  reg1.OpenKey      ('Software\bitfarm\Archiv_V3\Viewer\Stamps\'
                                    +lListEntry.Key, True);
                  reg1.WriteInteger ('favnr', 0);
                  reg1.CloseKey;
                  reg1.Free;
                  //        reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);
               end;
            end;

            if lFavoNr > 0 then
            begin
               WriteInteger('favnr', cbb_fav.ItemIndex);
            end
            else
            begin
               WriteInteger('favnr', 0);
            end;

            
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEditOpt.SavStamp',
               _('Fehler beim Schreiben in die Registrierung:') + e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;


(*
  Zweck:
    berprft, ob ein Stempel-Name in der Stempel-Liste
    (links in der Dialog-Maske) vorhanden ist.
  Rckgabe:
    true: Der Stempel-Name ist vorhanden.
*)
function Tfrm_DocEditOpt.existsStampName (stampName: String) : Boolean;
  var
    lIdx : Integer;

  begin
    Result := False;
    for lIdx := 0 to lv_Stamps.Items.Count -1 do   //  aus Stempel-Liste in der Maske
    begin
      if stampName = lv_Stamps.Items.Item [lIdx].Caption then
      begin
        Result := True;
        break;
      end;
    end;
  end;


(*
  Zweck:
    berprft, ob der Stempel mit Hilfe der Daten aus der Dialog-Maske
    in der Win-Registry angelegt werden kann.
  Eingabe:
    'stampName': Name des Stempels
  Rckgabe:
    true: Der Stempel darf angelegt werden.
*)
function Tfrm_DocEditOpt.isCreateStampOk (stampName: String) : boolean;
var
  lsMsg: string;

  begin
    Result     := True;

    if trim (stampName) = '' then
    begin
      lsMsg:=_('Es ist kein Stempel-Name vergeben worden!') +#13+#10
                 +_('Bitte Stempel-Namen eintragen!');
      MessageBox(Self.Handle,PChar(lsMSg),PChar(''),MB_OK);
      //ShowMessage();
      Result := False;
    end
    else

    if stampName <> lv_Stamps.Selected.Caption then
    begin
      
      if existsStampName (stampName) then
      begin
        lsMsg:= Format(_('Der Stempel-Name "%s" existiert bereits!') +#13+#10
                   +_('Bitte einen anderen Stempel-Namen whlen!'),[stampName]);

        MessageBox(Self.Handle,PChar(lsMSg),PChar(''),MB_OK);
        Result := False;
      end;
    end;

  end;


(*
  Zweck:
    Legt einen neuen Stempel in der Win-Registry an und
    initialisiert alle Variablen durch den Aufruf von 'LoadStamp'.
    Der globale Stempel-Schlssel 'sGStampKey' wird aktualisiert.
  Hinweis:
    Wird nur von 'btn_NewStampClick' aufgerufen.
    Da diese Methode als public deklariert ist kann nicht ausgeschlossen werden,
    da der Aufruf durch andere Units erfolgt.
  Rckgabe:
    true: Der Eintrag in die Win-Registry hat geklappt.
*)
function Tfrm_DocEditOpt.CreStamp: boolean;

var
  lReg      : TRegistry;
  sStampKey : string;
  lStampName: string;       //  12.05.2010  r.sch.   3.5.0.76  [2197]
  fsTmp     : TFontStyles;
  bsTmp     : TBrushStyle;
  psTmp     : TPenStyle;
  bOK       : Boolean;
  iIndex    : Integer;
begin
   GgfLogEvnt ('Tfrm_DocEditOpt.CreStamp');
   iIndex := 1;

   lStampName := 'Neuer Stempel_' + IntToStr(iIndex);
   while existsStampName(lStampName) do
   begin
      inc(iIndex);
      lStampName := 'Neuer Stempel_' + IntToStr(iIndex);
   end;

   edt_SName.Text := lStampName;
   edt_SName.SetFocus;

   Result := True;
   lReg   := TRegistry.Create;
   fsTmp  := [];
   bsTmp  := bsClear;
   psTmp  := psClear;
   DateTimeToString (sStampKey, 'ddmmyyyyhhnnss', Now);

   try
      try
         lReg.RootKey := HKEY_CURRENT_USER;
         lReg.OpenKey         ('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + sStampKey, True);
         // f.schneider das sind alle Regestrywerte die wir bentigen
         
         lReg.WriteString     ('StampName',  lStampName);
         lReg.WriteString     ('StampFile',  '');
         lReg.WriteString     ('StampText',  'neuer Text');
         lReg.WriteBool       ('StampTyp',   False);
         lReg.WriteInteger    ('StampHeight', 30);
         lReg.WriteInteger    ('StampWidth',  40);
         lReg.WriteBool       ('StampFitToText',True);
         lReg.WriteInteger    ('FontColor',    0);
         lReg.WriteInteger    ('FontSize',    72);
         lReg.WriteString     ('FontName',   'Arial');
         lReg.WriteBinaryData ('FontStyle',   fsTmp, SizeOf(fsTmp));
         lReg.WriteInteger    ('objBrushColor',  StrToInt('$ffffff'));
         lReg.WriteBinaryData ('ObjBrushStyle',   bsTmp, SizeOf(bsTmp));
         lReg.WriteInteger    ('ObjMemoBorderColor',  StrToInt('$0'));
         lReg.WriteBinaryData ('ObjMemoBorderStyle',   psTmp, SizeOf(psTmp));
         lReg.WriteBinaryData ('ObjMemoCharsBrushStyle',   bsTmp, SizeOf(bsTmp));
         lReg.WriteInteger    ('ObjTransparency', 255);
         lReg.WriteInteger    ('favnr', 0);
         lReg.CloseKey;
         mStampFavoOld := 0;
         sGStampKey    := sStampKey;

         LoadStamp  (sGStampKey);
         ListStamps (False);

         // f.schneider  das kann man auch nach release der Optionen machen
         //loadfavstampbuttons;
      except
         on e: Exception do
         begin
            ErrorMsg ('frm_DocEditOpt.CreStamp',
                      _('Fehler beim Schreiben in die Registrierung:') + e.Message,
                      2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned   (lReg) then
         FreeAndNil (lReg);
   end;
end;


(*
  Zweck:
    Holt die Daten eines Stempels aus der Win-Registry und
    belegt, wenn ntig initialisiert, alle Daten des Stempels.
    Die Dialog-Maske wird ausgefllt.
  Voraussetzung:
    Der Stempel mu bereits in der Win-Registry vorhanden sein.
  Eingabe:
    'StampKey': Der Registry-Schlssel des Stempels
  Rckgabe:
    true: Der Eintrag wurde aus der Win-Registry hat geladen.
*)
function Tfrm_DocEditOpt.LoadStamp(StampKey: string): boolean;
var
   reg: TRegistry;
   fsTmp: TFontStyles;
   bsTmp: TBrushStyle;
   psTmp: TPenStyle;
   sStampText:String;
   bStampTyp: Boolean;
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.LoadStamp');

   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;

            if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
               exit;

            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);

            if ValueExists('StampFitToText') then
               chk_Anpassen.Checked := ReadBool('StampFitToText')
            else
               chk_Anpassen.Checked := True;

            if ValueExists('StampTyp') then
            begin
               //rbtn_SBild.Checked := True;
               bStampTyp := ReadBool('StampTyp');
               if bStampTyp then
                  //rbtn_SBild.Checked := True
                  rbtn_SBildClick(self)
               else
                  //rbtn_SText.Checked := True;
                  rbtn_STextClick(self);
               //ShowStampsElements(ReadBool('StampTyp'));
            end
            else
            begin
               //rbtn_SText.Checked := True;
               ShowStampsElements(False);
            end;

            if ValueExists('StampName') then
               edt_SName.Text := ReadString('StampName')
            else
               edt_SName.Text := '(keine Bezeichnung)';

            if ValueExists('StampText') then
               sStampText := ReadString('StampText')
            else
               sStampText := '(kein Text)';

            sStampText := StringReplace(sStampText, '\n\r', #13#10, [rfReplaceAll]);
            memo_SText.Text := sStampText;

            if ValueExists('StampFile') then
               edt_SBild.Text := ReadString('StampFile')
            else
               edt_SBild.Text := '';

            if ValueExists('StampWidth') then
               edt_SWidth.Text := IntToStr(ReadInteger('StampWidth'))
            else
               edt_SWidth.Text := '40';
            if ValueExists('StampHeight') then
               edt_SHeight.Text := IntToStr(ReadInteger('StampHeight'))
            else
               edt_SHeight.Text := '30';

            if ValueExists('FontColor') then
               dlg_Schrift.Font.Color := ReadInteger('FontColor')
            else
               dlg_Schrift.Font.Color := 0;
            (* f.schneider  brauchen wir bei Stempel nicht, sie CreStamps
            if ValueExists('ObjFontColor') then
               dlg_Schrift.Font.Color := ReadInteger('ObjFontColor')
            else
               dlg_Schrift.Font.Color := 0;
            *)
            if ValueExists('FontName') then
            begin
               dlg_Schrift.Font.Name := ReadString('FontName');
               edt_TFont.Text := dlg_Schrift.Font.Name;
               edt_SFont.Text := edt_TFont.Text;
            end
            else
            begin
               dlg_Schrift.Font.Name := 'Arial';
               edt_TFont.Text := 'Arial';
               edt_SFont.Text := edt_TFont.Text;
            end;
            if ValueExists('FontStyle') then
            begin
               ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
               dlg_Schrift.Font.Style := fsTmp;
            end
            else
               dlg_Schrift.Font.Style := [];

            if ValueExists('FontSize') then
               dlg_Schrift.Font.Size := ReadInteger('FontSize')
            else
               dlg_Schrift.Font.Size := 72;

            if ValueExists('ObjFontHeight') then
            begin
               dlg_Schrift.Font.Size := ReadInteger('ObjFontHeight');
            end;

            if ValueExists('ObjMemoCharsBrushStyle') then
            begin
               ReadBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(fsTmp));

            end
            else
               bsTmp := bsClear;
            if bsTmp = bsClear then
              cbx_Textstyle.ItemIndex := 0;
            if bsTmp = bsSolid then
              cbx_Textstyle.ItemIndex := 1;
            (*
            if bsTmp = bsBDiagonal then
              cbx_Textstyle.ItemIndex := 2;
            if bsTmp = bsVertical then
              cbx_Textstyle.ItemIndex := 3;
            if bsTmp = bsHorizontal then
              cbx_Textstyle.ItemIndex := 4;
            if bsTmp = bsCross then
              cbx_Textstyle.ItemIndex := 5;
            if bsTmp = bsDiagCross then
              cbx_Textstyle.ItemIndex := 6;
            if bsTmp = bsSolid then
              cbx_Textstyle.ItemIndex := 7;
            *)
            if ValueExists('ObjBrushStyle') then
            begin
               ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(fsTmp));

            end
            else
               bsTmp := bsClear;
            if bsTmp = bsClear then
              cbx_Stampstyle.ItemIndex := 0;
            if bsTmp = bsFDiagonal then
              cbx_Stampstyle.ItemIndex := 1;
            if bsTmp = bsBDiagonal then
              cbx_Stampstyle.ItemIndex := 2;
            if bsTmp = bsVertical then
              cbx_Stampstyle.ItemIndex := 3;
            if bsTmp = bsHorizontal then
              cbx_Stampstyle.ItemIndex := 4;
            if bsTmp = bsCross then
              cbx_Stampstyle.ItemIndex := 5;
            if bsTmp = bsDiagCross then
              cbx_Stampstyle.ItemIndex := 6;
            if bsTmp = bsSolid then
              cbx_Stampstyle.ItemIndex := 7;

            if ValueExists('ObjBrushColor') then
               clrbx_Stampcolor.Selected := ReadInteger('ObjBrushColor')
            else
               dlg_Schrift.Font.Color := clWhite;

            if ValueExists('ObjMemoBorderStyle') then
            begin
               ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));

            end
            else
               psTmp := psClear;
            if psTmp = psSolid then
              cbx_Stampborder.ItemIndex := 0;
            if psTmp = psClear then
              cbx_Stampborder.ItemIndex := 1;
            if psTmp = psDash then
              cbx_Stampborder.ItemIndex := 2;
            if psTmp = psDashDot then
              cbx_Stampborder.ItemIndex := 3;
            if psTmp = psDashDotDot then
              cbx_Stampborder.ItemIndex := 4;
            if psTmp = psDot then
              cbx_Stampborder.ItemIndex := 5;
            
             if ValueExists('ObjMemoBorderColor') then
               clrbx_Stampborder.Selected := ReadInteger('ObjMemoBorderColor')
            else
               clrbx_Stampborder.ItemIndex := 1;

            if ValueExists('ObjTransparency') then
               edt_Deckkraft1.Text := IntToStr(ReadInteger('ObjTransparency'))
            else
               edt_Deckkraft1.Text := '255';

            if ValueExists('favnr') then
               cbb_fav.ItemIndex := readinteger('favnr')
            else
               cbb_fav.ItemIndex := 0;

            
            mStampFavoOld := cbb_fav.ItemIndex;  //  12.05.2010  r.sch.  3.5.0.76  [2197]

            CloseKey;
            if pctrl_DocEditOpt.ActivePageIndex = 2 then
            begin
               edt_SName.SetFocus;
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEditOpt.LoadStamp', 'Fehler beim Lesen des Registrierung: ' +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_DocEditOpt.ShowStampsElements(StampTyp: Boolean): boolean;
begin
  if not StampTyp then
  begin  //Textstempel

    // Bildelemente ausblenden
    rbtn_SBild.Checked := False;
    edt_SBild.Visible := False;
    sbtn_SBild.Visible := False;
    img_SBild.Visible := False;
    lbl_SBild.Visible := False;
    sbtn_SBild.Visible := False;
       
    // Textelement einblenden
    rbtn_SText.Checked := True;
    memo_SText.Enabled := True;
    edt_SFont.Enabled := True;
    sbtn_SFont.Enabled := True;
    lbl_SText.Visible := True;
    memo_SText.Visible := True;
    LblText1.Visible := True;
    lbl_SFont.Visible := True;
    edt_SFont.Visible := True;
    sbtn_SFont.Visible := True;
    lbl_Textstyle.Visible := True;
    clrbx_Stampborder.Visible := True;
    clrbx_Stampborder.ItemIndex := 16;
    cbx_Textstyle.Visible := True;
    cbx_Textstyle.ItemIndex := 0;
    lbl_Stampcolor.Visible := True;
    clrbx_Stampcolor.Visible := True;
    clrbx_Stampcolor.ItemIndex := 16;
    cbx_Stampstyle.Visible := True;
    cbx_Stampstyle.ItemIndex := 0;
    lbl_Stampborder.Visible := True;
    cbx_Stampborder.Visible := True;
    cbx_Stampborder.ItemIndex := 1;
    lbl_Deckkraft.Caption := 'Schriftdeckkraft:';
    chk_Anpassen.Visible := True;
    EnableBreiteHoehe(not chk_Anpassen.Checked);

  end
  else
  begin  //Bildstempel


  // Textelemente ausblenden
    rbtn_SText.Checked := False;
    memo_SText.Visible := False;
    edt_SFont.Visible := False;
    sbtn_SFont.Visible := False;
    lbl_SText.Visible := False;
    LblText1.Visible := False;
    lbl_SFont.Visible := False;
    edt_SFont.Visible := False;
    sbtn_SFont.Visible := False;
    lbl_Textstyle.Visible := False;
    clrbx_Stampborder.Visible := False;
    cbx_Textstyle.Visible := False;
    lbl_Stampcolor.Visible := False;
    clrbx_Stampcolor.Visible := False;
    cbx_Stampstyle.Visible := False;
    lbl_Stampborder.Visible := False;
    cbx_Stampborder.Visible := False;
    //lbl_Deckkraft.Visible := False;
    //edt_Deckkraft1.Visible := False;
    lbl_Deckkraft.Caption := 'Bilddeckkraft:';
    chk_Anpassen.Visible := False;
    EnableBreiteHoehe(True);

  // Bildelemente einblenden

    rbtn_SBild.Checked := True;
    if edt_SBild.Text <> '' then
      edt_SBildChange(self)
    else
      edt_SBild.Clear;                            
    edt_SBild.Enabled := True;
    edt_SBild.Visible := True;
    edt_SBild.Show;
    
    edt_SBild.Refresh;
    edt_SBild.Repaint;
    sbtn_SBild.Visible := True;
    img_SBild.Visible := True;
    lbl_SBild.Visible := True;

  end;

  grp_StampBorder.Repaint;
  grp_StampBorder.Refresh;



end;

procedure  Tfrm_DocEditOpt.EnableBreiteHoehe(bEnable: Boolean);
begin

       lbl_SWidth.Enabled :=  bEnable;
       edt_SWidth.Enabled :=  bEnable;
       lbl_SWidthMes.Enabled := bEnable;
       edt_SHeight.Enabled := bEnable;

end;




function Tfrm_DocEditOpt.ListStamps(fobjekteigen: boolean): boolean;
var
   reg: TRegistry;
   slStampKeys: TStrings;
   iCount: integer;
   lItem: TListItem;
   lmylistview: TListView;
   lbtyp: boolean;
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.ListStamps');

   Result := True;
   reg := TRegistry.Create;
   slStampKeys := TStringList.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps', True);
            GetKeyNames(slStampKeys);
            CloseKey;
            if fobjekteigen then
               lmylistview := lv_eigenschaftstempel
            else
               lmylistview := lv_Stamps;
            lmylistview.Clear;
            // check for benutzer sign

        {   if fileexists(pchar(BD.ExeDir+'\signs\'+sGUsrName+'.tif')) then
  begin
                  lItem := lv_Stamps.Items.Add;
                  litem.caption:= 'Signatur von '+sGUsrName;
                  litem.SubItems.Add()
                  slStampKeys.Add()
  end;
  }
            for iCount := 0 to (slStampKeys.Count - 1) do
            begin
               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +
                  slStampKeys.Strings[iCount], True);
               if fobjekteigen then
               begin
                  if ValueExists('StampTyp') then
                     lbtyp := ReadBool('StampTyp')
                  else
                     lbtyp := True;
                  if lbtyp then
                  begin
                     CloseKey;
                     continue;
                  end;
               end;
               lItem := lmylistview.Items.Add;
               if ValueExists('StampName') then
                  lItem.Caption := ReadString('StampName')
               else
                  lItem.Caption := 'unbekannter Stempel';

               if ValueExists('StampTyp') then
               begin
                  if ReadBool('StampTyp') then
                     lItem.ImageIndex := 1
                  else
                     lItem.ImageIndex := 0;
               end
               else
                  lItem.ImageIndex := 3;
               if not fobjekteigen then
               begin
                  if ValueExists('favnr') then
                  begin
                     litem.SubItems.Add(IntToStr(readinteger('favnr')));
                  end
                  else
                  begin
                     litem.SubItems.Add(' ');
                  end;
               end;
               lItem.SubItems.Add(slStampKeys.Strings[iCount]);
               CloseKey;
            end;
            if (slStampKeys.Count > 0) and (lmylistview.items.Count > 0) then
               //lmylistview.ItemIndex := 0;
         end;

         selectStampListItem (edt_SName.Text);  //  12.05.2010  r.sch.  3.5.0.76  [2197]
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEditOpt.ListStamps', _('Fehler beim Lesen der Registrierung:') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(slStampKeys) then
         FreeAndNil(slStampKeys);
   end;
end;

function Tfrm_DocEditOpt.LoadDocEditOpt: boolean;
   //////////////////////////////////////////////////////////////////
   ///  11.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion ld die Dokument Editor Einstellungen aus  ///
   ///  der Registrierung.                                        ///
   ///                                                            ///
   ///  Parameter: keine                                          ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   reg: TRegistry;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            if ValueExists('DE_RenderEng') then
               chbx_EnaRenderEn.Checked := ReadBool('DE_RenderEng')
            else
               chbx_EnaRenderEn.Checked := False;
            if ValueExists('DE_Antialias') then
               chbx_EnaAntialias.Checked := ReadBool('DE_Antialias')
            else
               chbx_EnaAntialias.Checked := False;
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEditOpt.LoadDocEditOpt',
               _('Fehler beim Lesen des Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_DocEditOpt.SaveDocEditOpt: boolean;
   //////////////////////////////////////////////////////////////////
   ///  11.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion sichert die Dokument Editor Einstellungen  ///
   ///  aus der Registrierung.                                    ///
   ///                                                            ///
   ///  Parameter: keine                                          ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   reg: TRegistry;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            WriteBool('DE_RenderEng', chbx_EnaRenderEn.Checked);
            WriteBool('DE_Antialias', chbx_EnaAntialias.Checked);
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEditOpt.SaveDocEditOpt',
               _('Fehler beim Schreiben in die Registrierung:') + e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_DocEditOpt.LoadObjVal(ObjTyp: integer): boolean;
   //////////////////////////////////////////////////////////////////
   ///  11.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function ld die Objekteigenschaften des Objekt-    ///
   ///  typs [ObjTyp] aus der Registrierung.                      ///
   ///                                                            ///
   ///  Parameter: ObjTyp        Objekttyp                        ///
   ///             0             Textmarker                       ///
   ///             1             Notiz                            ///
   ///             2             Beschriftung                     ///
   ///             3             Freihandlinie                    ///
   ///             4             Poligon                          ///
   ///             5             Ellipse                          ///
   ///             6             Rechteck                         ///
   ///             7             Pfeil                            ///
   ///             8             Messlinie                        ///
   ///             9             Winkel                           ///
   ///             10            Linie                            ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   sRegKey, lstampname, lszusstring: string;
   Reg: TRegistry;
   fsTmp: TFontStyles;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   //    ssTmp: TIEVSoftShadow;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;

begin
   Result := True;
   reg := TRegistry.Create;
   floadedindex := ObjTyp;
   if fifavnum = 0 then
   begin
      lszusstring := '';
   end
   else
   begin
      lszusstring := inttostr(fifavnum);
   end;
   try
      try
         cbx_textform.Visible := False;
         lbl_nummer.visible := false;
         cbx_nummer.Visible := False;
         clbx_CLabel.visible := true;
         clbx_CLabel.visible := false;
         clbx_CNoteBorder.visible := true;
         clbx_CNoteBorder.visible := false;
         case ObjTyp of
            0:
            begin
               sRegKey := 'HiLite' + lszusstring;
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
               lbl_nummer.visible := true;
               cbx_nummer.Visible := true;
               cbx_nummer.itemindex := fifavnum;
            end;
            1:
            begin
               sRegKey := 'Note' + lszusstring;
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := False;
               clbx_CBorder.Visible := False;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := True;
               clbx_CNoteBorder.Visible := True;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := False;
               cbx_BBorder.Visible := False;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := True;
               cbx_BNoteBorder.Visible := True;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := True;
               chbx_AIsHiLite.Visible := False;
               lbl_nummer.visible := true;
               cbx_nummer.Visible := true;
               cbx_nummer.itemindex := fifavnum;
            end;
            2:
            begin
               sRegKey := 'Text' + lszusstring;
               cbx_BBackground.ItemIndex := 0;
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := False;
               clbx_CBorder.Visible := False;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := True;
               clbx_CNoteBorder.Visible := True;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := False;
               cbx_BBorder.Visible := False;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := True;
               cbx_BNoteBorder.Visible := True;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := True;
               chbx_AIsHiLite.Visible := False;
               cbx_textform.Visible := True;
               lbl_nummer.visible := true;
               cbx_nummer.Visible := true;
               cbx_nummer.itemindex := fifavnum;
            end;
            3:
            begin
               sRegKey := 'Stempel';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := False;
               clbx_CBorder.Visible := False;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := True;
               clbx_CNoteBorder.Visible := True;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := False;
               cbx_BBorder.Visible := False;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := True;
               cbx_BNoteBorder.Visible := True;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := True;
               chbx_AIsHiLite.Visible := False;
            end;
            4:
            begin
               sRegKey := 'LineLabel';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := True;
               chbx_AIsHiLite.Visible := False;
            end;
            5:
            begin
               sRegKey := 'Polyline';
               lbl_CBackground.Visible := False;
               clbx_CBackground.Visible := False;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
            end;
            6:
            begin
               sRegKey := 'Poligon';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
            end;
            7:
            begin
               sRegKey := 'Ellipse';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
            end;
            8:
            begin
               sRegKey := 'Box';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := True;
            end;
            9:
            begin
               sRegKey := 'Arrow';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := False;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
               chbx_AIsHiLite.Checked := False;
            end;
            10:
            begin
               sRegKey := 'Ruler';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := False;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Checked := False;
            end;
            11:
            begin
               sRegKey := 'Angle';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
            end;
   {     12:
        begin
          sRegKey := 'Line';
          lbl_CBackground.Visible := True;
          clbx_CBackground.Visible := True;
          lbl_CBorder.Visible := False;
          clbx_CBorder.Visible := False;
          lbl_CLabel.Visible := False;
          clbx_CLabel.Visible := False;
          lbl_CNoteBorder.Visible := False;
          clbx_CNoteBorder.Visible := False;
          lbl_BBackground.Visible := False;
          cbx_BBackground.Visible := False;
          lbl_BBorder.Visible := False;
          cbx_BBorder.Visible := False;
          lbl_BLabel.Visible := False;
          cbx_BLabel.Visible := False;
          lbl_BNoteBorder.Visible := False;
          cbx_BNoteBorder.Visible := False;
          chbx_AIsHiLite.Checked := False;
        end;   }
            12:
            begin
               sRegKey := 'Buchungsstempel';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := False;
               clbx_CBorder.Visible := False;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := True;
               clbx_CNoteBorder.Visible := True;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := False;
               cbx_BBorder.Visible := False;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := True;
               cbx_BNoteBorder.Visible := True;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Checked := False;
            end;

            13:
            begin
               sRegKey := 'Freihand' + lszusstring;
               lbl_CBackground.Visible := False;
               clbx_CBackground.Visible := False;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
               lbl_nummer.visible := true;
               cbx_nummer.Visible := true;
               cbx_nummer.itemindex := fifavnum;
            end;
         end;
         with reg do
         begin
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;

            if ((Objtyp = 0) or (Objtyp = 5) or (Objtyp = 6) or
               (Objtyp = 7) or (Objtyp = 8) or (Objtyp = 9) or (Objtyp = 10)
               or (objtyp = 13)) then
            begin
               grbx_Text.Visible := False;
            end
            else
            begin
               grbx_Text.Visible := True;
            end;

            if ObjTyp = 3 then
            begin
               memo_TObjText.Visible := False;
               lv_eigenschaftstempel.Visible := True;
               if lv_eigenschaftstempel.SelCount > 0 then
               begin
                  lstampname := lv_eigenschaftstempel.Selected.SubItems.Strings[0];
               end
               else
               begin
                  ListStamps(True);
                  if lv_eigenschaftstempel.items.Count = 0 then
                  begin
                     ShowMessage(_('Kein Textstempel vorhanden.') + #13 +
                        _('Bitte erstellen Sie einen neuen Textstempel,') + ' ' + _('um diese Eigenschaften zu bearbeiten.'));
                     pctrl_DocEditOpt.ActivePage := tbs_Stempel;
                     tctrl_Annos.TabIndex := 0;
                     exit;
                  end;
                  lstampname := lv_eigenschaftstempel.items.item[0].SubItems.Strings[0];
               end;

               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + lstampname, True);

               if ValueExists('ObjBrushColor') then
                  clbx_CBackground.Selected := ReadInteger('ObjBrushColor')
               else
                  clbx_CBackground.Selected := 0;
               if ValueExists('ObjPenColor') then
               begin
                  //          clbx_CBorder.Selected := ReadInteger('ObjPenColor');
                  dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
               end
               else
               begin
                  //          clbx_CBorder.Selected := 0;
                  dlg_Schrift.Font.Color := 0;
               end;
               case ObjTyp of
                  0, 4, 5, 6, 7, 8, 9, 10, 11, 13:
                  begin
                     if ValueExists('ObjPenColor') then
                     begin
                        dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
                        clbx_CBorder.Selected := ReadInteger('ObjPenColor');
                     end
                     else
                     begin
                        clbx_CBorder.Selected := 0;
                     end;
                  end;
               end;
               if ValueExists('ObjLabelBrushColor') then
                  clbx_CLabel.Selected := ReadInteger('ObjLabelBrushColor')
               else
                  clbx_CLabel.Selected := 0;
               if ValueExists('ObjMemoBorderColor') then
                  clbx_CNoteBorder.Selected := ReadInteger('ObjMemoBorderColor')
               else
                  clbx_CNoteBorder.Selected := 0;
               if ValueExists('ObjAutoIncreaseLine') then
                  cbx_autolineincrease.checked := ReadBool('ObjAutoIncreaseLine')
               else
                  cbx_autolineincrease.checked := false;
               if ValueExists('ObjAutoIncreaseHeight') then
                  cbx_autoincreasehigh.checked := ReadBool('ObjAutoIncreaseHeight')
               else
                  cbx_autoincreasehigh.checked := false;
               if ValueExists('ObjBrushStyle') then
               begin
                  ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
                  case bsTmp of
                     bsSolid:
                        cbx_BBackground.ItemIndex := 7;
                     bsClear:
                        cbx_BBackground.ItemIndex := 0;
                     bsHorizontal:
                        cbx_BBackground.ItemIndex := 4;
                     bsVertical:
                        cbx_BBackground.ItemIndex := 3;
                     bsFDiagonal:
                        cbx_BBackground.ItemIndex := 1;
                     bsBDiagonal:
                        cbx_BBackground.ItemIndex := 2;
                     bsCross:
                        cbx_BBackground.ItemIndex := 5;
                     bsDiagCross:
                        cbx_BBackground.ItemIndex := 6;
                  end;
               end
               else
               begin
                  cbx_BBackground.ItemIndex := 0;
               end;
               if ValueExists('ObjLabelBrushStyle') then
               begin
                  ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
                  case bsTmp of
                     bsSolid:
                        cbx_BLabel.ItemIndex := 7;
                     bsClear:
                        cbx_BLabel.ItemIndex := 0;
                     bsHorizontal:
                        cbx_BLabel.ItemIndex := 4;
                     bsVertical:
                        cbx_BLabel.ItemIndex := 3;
                     bsFDiagonal:
                        cbx_BLabel.ItemIndex := 1;
                     bsBDiagonal:
                        cbx_BLabel.ItemIndex := 2;
                     bsCross:
                        cbx_BLabel.ItemIndex := 5;
                     bsDiagCross:
                        cbx_BLabel.ItemIndex := 6;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BLabel.ItemIndex := 0;
                  end;
               end
               else
               begin
                  cbx_BLabel.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BLabel.ItemIndex := 1;
                  end;
               end;

               if ValueExists('ObjPenStyle') then
               begin
                  ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
                  case psTmp of
                     psSolid:
                        cbx_BBorder.ItemIndex := 0;
                     psDash:
                        cbx_BBorder.ItemIndex := 2;
                     psDot:
                        cbx_BBorder.ItemIndex := 5;
                     psDashDot:
                        cbx_BBorder.ItemIndex := 3;
                     psDashDotDot:
                        cbx_BBorder.ItemIndex := 4;
                     psClear:
                        cbx_BBorder.ItemIndex := 1;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BBorder.ItemIndex := 1;
                  end;
               end
               else
               begin
                  cbx_BBorder.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BBorder.ItemIndex := 1;
                  end;
               end;
               if ValueExists('ObjMemoBorderStyle') then
               begin
                  ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
                  case psTmp of
                     psSolid:
                        cbx_BNoteBorder.ItemIndex := 0;
                     psDash:
                        cbx_BNoteBorder.ItemIndex := 2;
                     psDot:
                        cbx_BNoteBorder.ItemIndex := 5;
                     psDashDot:
                        cbx_BNoteBorder.ItemIndex := 3;
                     psDashDotDot:
                        cbx_BNoteBorder.ItemIndex := 4;
                     psClear:
                        cbx_BNoteBorder.ItemIndex := 1;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BNoteBorder.ItemIndex := 1;
                  end;

               end
               else
               begin
                  cbx_BNoteBorder.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BNoteBorder.ItemIndex := 1;
                  end;
               end;
               if ValueExists('ObjBeginShape') then
               begin
                  ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
                  case shTmp of
                     iesNONE:
                        rbtn_SSNo.Checked := True;
                     iesINARROW:
                        rbtn_SSIn.Checked := True;
                     iesOUTARROW:
                        rbtn_SSOut.Checked := True;
                  end;
               end
               else
                  rbtn_SSNo.Checked := True;
               if ValueExists('ObjEndShape') then
               begin
                  ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
                  case shTmp of
                     iesNONE:
                        rbtn_SENo.Checked := True;
                     iesINARROW:
                        rbtn_SEIn.Checked := True;
                     iesOUTARROW:
                        rbtn_SEOut.Checked := True;
                  end;
               end
               else
                  rbtn_SENo.Checked := True;
               if ValueExists('ObjShapeHeight') then
                  edt_SSHeight.Text := IntToStr(ReadInteger('ObjShapeHeight'))
               else
                  edt_SSHeight.Text := '0';
               if ValueExists('ObjShapeWidth') then
                  edt_SSWidth.Text := IntToStr(ReadInteger('ObjShapeWidth'))
               else
                  edt_SSWidth.Text := '0';
               if ValueExists('ObjName') then
                  edt_AObjName.Text := ReadString('ObjName')
               else
                  edt_AObjName.Text := 'neues Objekt';
               if ValueExists('ObjPenWidth') then
                  edt_APenWidth.Text := IntToStr(ReadInteger('ObjPenWidth'))
               else
                  edt_APenWidth.Text := '1';
               if ValueExists('ObjRulerType') then
               begin
                  ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
                  case rtTmp of
                     iertRULER:
                        cbx_ARulerTyp.ItemIndex := 0;
                     iertQUOTEBEGIN:
                        cbx_ARulerTyp.ItemIndex := 1;
                     iertQUOTECENTER:
                        cbx_ARulerTyp.ItemIndex := 2;
                     iertQUOTEEND:
                        cbx_ARulerTyp.ItemIndex := 3;
                  end;
               end
               else
                  cbx_ARulerTyp.ItemIndex := 0;
               if ValueExists('ObjRulerUnit') then
               begin
                  ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
                  case ruTmp of
                     ieuPIXELS:
                        cbx_ARulerMes.ItemIndex := 0;
                     ieuINCHES:
                        cbx_ARulerMes.ItemIndex := 1;
                     ieuKM:
                        cbx_ARulerMes.ItemIndex := 5;
                     ieuMETERS:
                        cbx_ARulerMes.ItemIndex := 4;
                     ieuCENTIMETERS:
                        cbx_ARulerMes.ItemIndex := 3;
                     ieuMILLIMETERS:
                        cbx_ARulerMes.ItemIndex := 2;
                     ieuMICRONS:
                        cbx_ARulerMes.ItemIndex := 6;
                     ieuNANOMETERS:
                        cbx_ARulerMes.ItemIndex := 7;
                  end;
               end
               else
                  cbx_ARulerMes.ItemIndex := 0;
               if ValueExists('ObjTransparency') then
                  edt_ATransp.Text := IntToStr(ReadInteger('ObjTransparency'))
               else
                  edt_ATransp.Text := '110';  //Igel0612151159
               if ValueExists('ObjHeight') then
                  edt_objheight.Text := IntToStr(ReadInteger('ObjHeight'))
               else
                  edt_objheight.Text := '400';
               if ValueExists('Objwidth') then
                  Edt_objwidth.Text := IntToStr(ReadInteger('Objwidth'))
               else
                  Edt_objwidth.Text := '400';
               if ValueExists('ObjPolylineClosed') then
                  chbx_AOpenPoly.Checked := not ReadBool('ObjPolylineClosed')
               else
                  chbx_AOpenPoly.Checked := False;
               if Objtyp <> 9 then
               begin
                  if ValueExists('ObjBoxHighlight') then
                     chbx_AIsHiLite.Checked := ReadBool('ObjBoxHighlight')
                  else
                     chbx_AIsHiLite.Checked := False;
               end;
               if ValueExists('ObjStyle') then
               begin
                  ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
                  chbx_ASelectable.Checked := ievsSelectable in osTmp;
                  chbx_AMoveable.Checked := ievsMoveable in osTmp;
                  chbx_ASizeable.Checked := ievsSizeable in osTmp;
                  chbx_AVisible.Checked := ievsVisible in osTmp;
               end
               else
               begin
                  chbx_ASelectable.Checked := True;
                  chbx_AMoveable.Checked := True;
                  chbx_ASizeable.Checked := True;
                  chbx_AVisible.Checked := True;
               end;
               if ValueExists('FontName') then
               begin
                  edt_TFont.Text := ReadString('FontName');
               end
               else
               begin
                  edt_TFont.Text := '';
               end;
               dlg_Schrift.Font.Name := edt_TFont.Text;
               edt_SFont.Text := edt_TFont.Text;
               if ValueExists('FontSize') then
               begin
                  dlg_Schrift.Font.Size := ReadInteger('FontSize');
                  edt_TFontSize.Text := IntToStr(ReadInteger('FontSize'));
               end
               else
               begin
                  dlg_Schrift.Font.Size := 72;
                  edt_TFontSize.Text := '72';
               end;
               if ValueExists('FontColor') then
               begin
                  dlg_Schrift.Font.color := ReadInteger('FontColor');
               end
               else
               if ValueExists('ObjFontColor') then
               begin
                  dlg_Schrift.Font.color := ReadInteger('ObjFontColor');
               end;
               if ValueExists('FontStyle') then
               begin
                  ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
                  dlg_Schrift.Font.Style := fsTmp;
               end
               else
                  dlg_Schrift.Font.Style := [];
               if ValueExists('ObjFontAngle') then
                  edt_TFontAngle.Text := FloatToStr(ReadFloat('ObjFontAngle'))
               else
                  edt_TFontAngle.Text := '0';
               if ValueExists('ObjLabelPosition') then
               begin
                  ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
                  case lpTmp of
                     ielBegin:
                        cbx_TLabelPos.ItemIndex := 0;
                     ielEnd:
                        cbx_TLabelPos.ItemIndex := 1;
                  end;
               end
               else
                  cbx_TLabelPos.ItemIndex := 0;
               if ValueExists('ObjTextAlign') then
               begin
                  ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
                  case taTmp of
                     iejLeft:
                        cbx_TAlign.ItemIndex := 0;
                     iejRight:
                        cbx_TAlign.ItemIndex := 1;
                     iejCenter:
                        cbx_TAlign.ItemIndex := 2;
                     iejJustify:
                        cbx_TAlign.ItemIndex := 3;
                  end;
               end
               else
                  cbx_TAlign.ItemIndex := 0;
               if ValueExists('ObjText') then
                  memo_TObjText.Text := ReadString('ObjText')
               else
                  memo_TObjText.Text := 'neuer Text';
               if ValueExists('ObjTextAutoSize') then
                  chbx_TObjAutoSize.Checked := ReadBool('ObjTextAutoSize')
               else
                  chbx_TObjAutoSize.Checked := False;
               if ValueExists('ObjFontLocked') then
                  chbx_TFontLocked.Checked := ReadBool('ObjFontLocked')
               else
                  chbx_TFontLocked.Checked := False;
               if ValueExists('Showtextform') then
                  cbx_textform.Checked := ReadBool('Showtextform')
               else
                  cbx_textform.Checked := false;
               CloseKey;
            end
            else
            begin
               lv_eigenschaftstempel.Visible := False;
               memo_TObjText.Visible := True;
               memo_TObjText.Update;
               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\' + sRegKey, True);
               if ValueExists('ObjBrushColor') then
                  clbx_CBackground.Selected := ReadInteger('ObjBrushColor')
               else
                  clbx_CBackground.Selected := 0;
               if ValueExists('ObjPenColor') then
               begin
                  //          clbx_CBorder.Selected := ReadInteger('ObjPenColor');
                  dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
               end
               else
               begin
                  //          clbx_CBorder.Selected := 0;
                  dlg_Schrift.Font.Color := 0;
               end;
               case ObjTyp of
                  0, 4, 5, 6, 7, 8, 9, 10, 11, 13:
                  begin
                     if ValueExists('ObjPenColor') then
                     begin
                        dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
                        clbx_CBorder.Selected := ReadInteger('ObjPenColor');
                     end
                     else
                     begin
                        clbx_CBorder.Selected := 0;
                     end;
                  end;
               end;
               if ValueExists('ObjLabelBrushColor') then
                  clbx_CLabel.Selected := ReadInteger('ObjLabelBrushColor')
               else
                  clbx_CLabel.Selected := 0;
               if ValueExists('ObjMemoBorderColor') then
                  clbx_CNoteBorder.Selected := ReadInteger('ObjMemoBorderColor')
               else
                  clbx_CNoteBorder.Selected := 0;
               if ValueExists('ObjAutoIncreaseLine') then
                  cbx_autolineincrease.checked := ReadBool('ObjAutoIncreaseLine')
               else
                  cbx_autolineincrease.checked := false;
               if ValueExists('ObjAutoIncreaseHeight') then
                  cbx_autoincreasehigh.checked := ReadBool('ObjAutoIncreaseHeight')
               else
                  cbx_autoincreasehigh.checked := false;
               if ValueExists('ObjBrushStyle') then
               begin
                  ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
                  case bsTmp of
                     bsSolid:
                        cbx_BBackground.ItemIndex := 7;
                     bsClear:
                        cbx_BBackground.ItemIndex := 0;
                     bsHorizontal:
                        cbx_BBackground.ItemIndex := 4;
                     bsVertical:
                        cbx_BBackground.ItemIndex := 3;
                     bsFDiagonal:
                        cbx_BBackground.ItemIndex := 1;
                     bsBDiagonal:
                        cbx_BBackground.ItemIndex := 2;
                     bsCross:
                        cbx_BBackground.ItemIndex := 5;
                     bsDiagCross:
                        cbx_BBackground.ItemIndex := 6;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BBackground.ItemIndex := 0;
                  end;
               end
               else
               begin
                  cbx_BBackground.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BBackground.ItemIndex := 0;
                  end;
               end;
               if ValueExists('ObjLabelBrushStyle') then
               begin
                  ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
                  case bsTmp of
                     bsSolid:
                        cbx_BLabel.ItemIndex := 7;
                     bsClear:
                        cbx_BLabel.ItemIndex := 0;
                     bsHorizontal:
                        cbx_BLabel.ItemIndex := 4;
                     bsVertical:
                        cbx_BLabel.ItemIndex := 3;
                     bsFDiagonal:
                        cbx_BLabel.ItemIndex := 1;
                     bsBDiagonal:
                        cbx_BLabel.ItemIndex := 2;
                     bsCross:
                        cbx_BLabel.ItemIndex := 5;
                     bsDiagCross:
                        cbx_BLabel.ItemIndex := 6;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BLabel.ItemIndex := 0;
                  end;
               end
               else
               begin
                  cbx_BLabel.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BLabel.ItemIndex := 1;
                  end;
               end;

               if ValueExists('ObjPenStyle') then
               begin
                  ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
                  case psTmp of
                     psSolid:
                        cbx_BBorder.ItemIndex := 0;
                     psDash:
                        cbx_BBorder.ItemIndex := 2;
                     psDot:
                        cbx_BBorder.ItemIndex := 5;
                     psDashDot:
                        cbx_BBorder.ItemIndex := 3;
                     psDashDotDot:
                        cbx_BBorder.ItemIndex := 4;
                     psClear:
                        cbx_BBorder.ItemIndex := 1;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BBorder.ItemIndex := 1;
                  end;
               end
               else
               begin
                  cbx_BBorder.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BBorder.ItemIndex := 1;
                  end;
               end;
               if ValueExists('ObjMemoBorderStyle') then
               begin
                  ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
                  case psTmp of
                     psSolid:
                        cbx_BNoteBorder.ItemIndex := 0;
                     psDash:
                        cbx_BNoteBorder.ItemIndex := 2;
                     psDot:
                        cbx_BNoteBorder.ItemIndex := 5;
                     psDashDot:
                        cbx_BNoteBorder.ItemIndex := 3;
                     psDashDotDot:
                        cbx_BNoteBorder.ItemIndex := 4;
                     psClear:
                        cbx_BNoteBorder.ItemIndex := 1;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BNoteBorder.ItemIndex := 1;
                  end;

               end
               else
               begin
                  cbx_BNoteBorder.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BNoteBorder.ItemIndex := 1;
                  end;
               end;
               if ValueExists('ObjBeginShape') then
               begin
                  ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
                  case shTmp of
                     iesNONE:
                        rbtn_SSNo.Checked := True;
                     iesINARROW:
                        rbtn_SSIn.Checked := True;
                     iesOUTARROW:
                        rbtn_SSOut.Checked := True;
                  end;
               end
               else
                  rbtn_SSNo.Checked := True;
               if ValueExists('ObjEndShape') then
               begin
                  ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
                  case shTmp of
                     iesNONE:
                        rbtn_SENo.Checked := True;
                     iesINARROW:
                        rbtn_SEIn.Checked := True;
                     iesOUTARROW:
                        rbtn_SEOut.Checked := True;
                  end;
               end
               else
                  rbtn_SENo.Checked := True;
               if ValueExists('ObjShapeHeight') then
                  edt_SSHeight.Text := IntToStr(ReadInteger('ObjShapeHeight'))
               else
                  edt_SSHeight.Text := '0';
               if ValueExists('ObjShapeWidth') then
                  edt_SSWidth.Text := IntToStr(ReadInteger('ObjShapeWidth'))
               else
                  edt_SSWidth.Text := '0';
               if ValueExists('ObjName') then
                  edt_AObjName.Text := ReadString('ObjName')
               else
                  edt_AObjName.Text := sRegKey;
               if ValueExists('ObjPenWidth') then
                  edt_APenWidth.Text := IntToStr(ReadInteger('ObjPenWidth'))
               else
                  edt_APenWidth.Text := '1';
               if ValueExists('ObjRulerType') then
               begin
                  ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
                  case rtTmp of
                     iertRULER:
                        cbx_ARulerTyp.ItemIndex := 0;
                     iertQUOTEBEGIN:
                        cbx_ARulerTyp.ItemIndex := 1;
                     iertQUOTECENTER:
                        cbx_ARulerTyp.ItemIndex := 2;
                     iertQUOTEEND:
                        cbx_ARulerTyp.ItemIndex := 3;
                  end;
               end
               else
                  cbx_ARulerTyp.ItemIndex := 0;
               if ValueExists('ObjRulerUnit') then
               begin
                  ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
                  case ruTmp of
                     ieuPIXELS:
                        cbx_ARulerMes.ItemIndex := 0;
                     ieuINCHES:
                        cbx_ARulerMes.ItemIndex := 1;
                     ieuKM:
                        cbx_ARulerMes.ItemIndex := 5;
                     ieuMETERS:
                        cbx_ARulerMes.ItemIndex := 4;
                     ieuCENTIMETERS:
                        cbx_ARulerMes.ItemIndex := 3;
                     ieuMILLIMETERS:
                        cbx_ARulerMes.ItemIndex := 2;
                     ieuMICRONS:
                        cbx_ARulerMes.ItemIndex := 6;
                     ieuNANOMETERS:
                        cbx_ARulerMes.ItemIndex := 7;
                  end;
               end
               else
                  cbx_ARulerMes.ItemIndex := 0;
               if ValueExists('ObjTransparency') then
                  edt_ATransp.Text := IntToStr(ReadInteger('ObjTransparency'))
               else
                  edt_ATransp.Text := '110';  //Igel0612151159

               if ValueExists('ObjHeight') then
                  edt_objheight.Text := IntToStr(ReadInteger('ObjHeight'))
               else
                  edt_objheight.Text := '400';
               if ValueExists('Objwidth') then
                  Edt_objwidth.Text := IntToStr(ReadInteger('Objwidth'))
               else
                  Edt_objwidth.Text := '400';
               if ValueExists('ObjPolylineClosed') then
                  chbx_AOpenPoly.Checked := not ReadBool('ObjPolylineClosed')
               else
               begin
                  if ObjTyp = 13 then
                  begin
                     chbx_AOpenPoly.Checked := True;
                  end
                  else
                  begin
                     chbx_AOpenPoly.Checked := False;
                  end;
               end;
               if Objtyp <> 9 then
               begin
                  if ValueExists('ObjBoxHighlight') then
                     chbx_AIsHiLite.Checked := ReadBool('ObjBoxHighlight')
                  else
                     chbx_AIsHiLite.Checked := False;
               end;
               if ValueExists('ObjStyle') then
               begin
                  ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
                  chbx_ASelectable.Checked := ievsSelectable in osTmp;
                  chbx_AMoveable.Checked := ievsMoveable in osTmp;
                  chbx_ASizeable.Checked := ievsSizeable in osTmp;
                  chbx_AVisible.Checked := ievsVisible in osTmp;
               end
               else
               begin
                  chbx_ASelectable.Checked := True;
                  chbx_AMoveable.Checked := True;
                  chbx_ASizeable.Checked := True;
                  chbx_AVisible.Checked := True;
               end;
               if ValueExists('ObjFontName') then
               begin
                  edt_TFont.Text := ReadString('ObjFontName');
               end
               else
               begin
                  edt_TFont.Text := '';
               end;
               dlg_Schrift.Font.Name := edt_TFont.Text;
               edt_SFont.Text := edt_TFont.Text;
               if ValueExists('ObjFontHeight') then
               begin
                  dlg_Schrift.Font.Size := ReadInteger('ObjFontHeight');
                  edt_TFontSize.Text := IntToStr(ReadInteger('ObjFontHeight'));
               end
               else
               begin
                  dlg_Schrift.Font.Size := 72;
                  edt_TFontSize.Text := '72';
               end;
               if ValueExists('ObjFontStyles') then
               begin
                  ReadBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
                  dlg_Schrift.Font.Style := fsTmp;
               end
               else
                  dlg_Schrift.Font.Style := [];
               if ValueExists('ObjFontAngle') then
                  edt_TFontAngle.Text := FloatToStr(ReadFloat('ObjFontAngle'))
               else
                  edt_TFontAngle.Text := '0';
               if ValueExists('ObjLabelPosition') then
               begin
                  ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
                  case lpTmp of
                     ielBegin:
                        cbx_TLabelPos.ItemIndex := 0;
                     ielEnd:
                        cbx_TLabelPos.ItemIndex := 1;
                  end;
               end
               else
                  cbx_TLabelPos.ItemIndex := 0;
               if ValueExists('ObjTextAlign') then
               begin
                  ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
                  case taTmp of
                     iejLeft:
                        cbx_TAlign.ItemIndex := 0;
                     iejRight:
                        cbx_TAlign.ItemIndex := 1;
                     iejCenter:
                        cbx_TAlign.ItemIndex := 2;
                     iejJustify:
                        cbx_TAlign.ItemIndex := 3;
                  end;
               end
               else
                  cbx_TAlign.ItemIndex := 0;
               if ValueExists('ObjText') then
                  memo_TObjText.Text := ReadString('ObjText')
               else
                  memo_TObjText.Text := 'neuer Text';
               if ValueExists('ObjTextAutoSize') then
                  chbx_TObjAutoSize.Checked := ReadBool('ObjTextAutoSize')
               else
                  chbx_TObjAutoSize.Checked := False;
               if ValueExists('ObjFontLocked') then
                  chbx_TFontLocked.Checked := ReadBool('ObjFontLocked')
               else
                  chbx_TFontLocked.Checked := False;
               if ValueExists('Showtextform') then
                  cbx_textform.Checked := ReadBool('Showtextform')
               else
                  cbx_textform.Checked := false;
               CloseKey;
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEditOpt.LoadObjVal', _('Fehler beim Lesen des Registrierung:') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

/////////////////////////////////////////////////////////////////////////////////////////////
//    Objekt eigenschaften in der Registrierung sichern  


function Tfrm_DocEditOpt.SaveObjVal(ObjTyp: integer): boolean;
   //////////////////////////////////////////////////////////////////
   ///  11.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function sichert die Objekteigenschaften des Ob-    ///
   ///  jekttyps [ObjTyp] in der Registrierung.                   ///
   ///                                                            ///
   ///  Parameter: ObjTyp        Objekttyp                        ///
   ///             0             Textmarker                       ///
   ///             1             Notiz                            ///
   ///             2             Beschriftung                     ///
   ///             3             Freihandlinie                    ///
   ///             4             Poligon                          ///
   ///             5             Ellipse                          ///
   ///             6             Rechteck                         ///
   ///             7             Pfeil                            ///
   ///             8             Messlinie                        ///
   ///             9             Winkel                           ///
   ///             10            Linie                            ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   sRegKey, lszusstring: string;
   Reg: TRegistry;
   fsTmp: TFontStyles;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   //    ssTmp: TIEVSoftShadow;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;

begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         if fifavnum = 0 then
         begin
            lszusstring := '';
         end
         else
         begin
            lszusstring := inttostr(fifavnum);
         end;
         case ObjTyp of
            0:
               sRegKey := 'HiLite' + lszusstring;
            1:
               sRegKey := 'Note' + lszusstring;
            2:
               sRegKey := 'Text' + lszusstring;
            3:
               sRegKey := 'Stempel';
            4:
               sRegKey := 'LineLabel';
            5:
               sRegKey := 'Polyline';
            6:
               sRegKey := 'Poligon';
            7:
               sRegKey := 'Ellipse';
            8:
               sRegKey := 'Box';
            9:
               sRegKey := 'Arrow';
            10:
               sRegKey := 'Ruler';
            11:
               sRegKey := 'Angle';
            12:
               sRegKey := 'Buchungsstempel';
            13:
               sRegKey := 'Freihand' + lszusstring;
         end;

         with reg do
         begin
            if ObjTyp = 3 then
            begin
               if lv_eigenschaftstempel.Selected = nil then
                  exit;

               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +
                  lv_eigenschaftstempel.Selected.SubItems.Strings[0], True);
               WriteInteger('ObjBrushColor', clbx_CBackground.Selected);
               WriteInteger('ObjPenColor', dlg_Schrift.Font.Color);
               WriteInteger('ObjLabelBrushColor', clbx_CLabel.Selected);
               WriteInteger('ObjMemoBorderColor', clbx_CNoteBorder.Selected);
               case cbx_BBackground.ItemIndex of
                  0:
                     bsTmp := bsClear;
                  1:
                     bsTmp := bsFDiagonal;
                  2:
                     bsTmp := bsBDiagonal;
                  3:
                     bsTmp := bsVertical;
                  4:
                     bsTmp := bsHorizontal;
                  5:
                     bsTmp := bsCross;
                  6:
                     bsTmp := bsDiagCross;
                  7:
                     bsTmp := bsSolid;
               end;
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               case cbx_BLabel.ItemIndex of
                  0:
                     bsTmp := bsClear;
                  1:
                     bsTmp := bsFDiagonal;
                  2:
                     bsTmp := bsBDiagonal;
                  3:
                     bsTmp := bsVertical;
                  4:
                     bsTmp := bsHorizontal;
                  5:
                     bsTmp := bsCross;
                  6:
                     bsTmp := bsDiagCross;
                  7:
                     bsTmp := bsSolid;
               end;
               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
               case cbx_BBorder.ItemIndex of
                  0:
                     psTmp := psSolid;
                  1:
                     psTmp := psClear;
                  2:
                     psTmp := psDash;
                  3:
                     psTmp := psDashDot;
                  4:
                     psTmp := psDashDotDot;
                  5:
                     psTmp := psDot;
               end;
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               case cbx_BNoteBorder.ItemIndex of
                  0:
                     psTmp := psSolid;
                  1:
                     psTmp := psClear;
                  2:
                     psTmp := psDash;
                  3:
                     psTmp := psDashDot;
                  4:
                     psTmp := psDashDotDot;
                  5:
                     psTmp := psDot;
               end;
               WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
               if rbtn_SSNo.Checked then
                  shTmp := iesNONE;
               if rbtn_SSIn.Checked then
                  shTmp := iesINARROW;
               if rbtn_SSOut.Checked then
                  shTmp := iesOUTARROW;
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if rbtn_SENo.Checked then
                  shTmp := iesNONE;
               if rbtn_SEIn.Checked then
                  shTmp := iesINARROW;
               if rbtn_SEOut.Checked then
                  shTmp := iesOUTARROW;
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               WriteInteger('ObjShapeHeight', StrToInt(edt_SSHeight.Text));
               WriteInteger('ObjShapeWidth', StrToInt(edt_SSWidth.Text));
               WriteString('ObjName', edt_AObjName.Text);
               WriteInteger('ObjPenWidth', StrToInt(edt_APenWidth.Text));
               case cbx_ARulerTyp.ItemIndex of
                  0:
                     rtTmp := iertRULER;
                  1:
                     rtTmp := iertQUOTEBEGIN;
                  2:
                     rtTmp := iertQUOTECENTER;
                  3:
                     rtTmp := iertQUOTEEND;
               end;
               WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
               case cbx_ARulerMes.ItemIndex of
                  0:
                     ruTmp := ieuPIXELS;
                  1:
                     ruTmp := ieuINCHES;
                  2:
                     ruTmp := ieuMILLIMETERS;
                  3:
                     ruTmp := ieuCENTIMETERS;
                  4:
                     ruTmp := ieuMETERS;
                  5:
                     ruTmp := ieuKM;
                  6:
                     ruTmp := ieuMICRONS;
                  7:
                     ruTmp := ieuNANOMETERS;
               end;
               WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
               WriteInteger('ObjTransparency', StrToInt(edt_ATransp.Text));
               WriteInteger('Objwidth', StrToInt(Edt_objwidth.Text));
               WriteInteger('Objheight', StrToInt(Edt_objheight.Text));
               WriteBool('ObjPolylineClosed', not chbx_AOpenPoly.Checked);
               WriteBool('ObjBoxHighlight', chbx_AIsHiLite.Checked);
               osTmp := [];
               if chbx_ASelectable.Checked then
                  osTmp := osTmp + [ievsSelectable];
               if chbx_AMoveable.Checked then
                  osTmp := osTmp + [ievsMoveable];
               if chbx_ASizeable.Checked then
                  osTmp := osTmp + [ievsSizeable];
               if chbx_AVisible.Checked then
                  osTmp := osTmp + [ievsVisible];
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               WriteString('ObjFontName', dlg_Schrift.Font.Name);
               WriteString('FontName', dlg_Schrift.Font.Name);
               WriteInteger('ObjFontColor', dlg_Schrift.Font.Color);
               WriteInteger('FontColor', dlg_Schrift.Font.Color);
               WriteInteger('ObjFontHeight', StrToInt(edt_TFontSize.Text));
               WriteInteger('Fontsize', StrToInt(edt_TFontSize.Text));
               WriteInteger('ObjFontSize', StrToInt(edt_TFontSize.Text));
               fsTmp := dlg_Schrift.Font.Style;
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
               WriteInteger('ObjFontHeight', StrToInt(edt_TFontSize.Text));
               WriteFloat('ObjFontAngle', StrToFloat(edt_TFontAngle.Text));
               case cbx_TLabelPos.ItemIndex of
                  0:
                     lpTmp := ielBegin;
                  1:
                     lpTmp := ielEnd;
               end;
               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
               case cbx_TAlign.ItemIndex of
                  0:
                     taTmp := iejLeft;
                  1:
                     taTmp := iejRight;
                  2:
                     taTmp := iejCenter;
                  3:
                     taTmp := iejJustify;
               end;
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
               WriteString('ObjText', memo_TObjText.Text);
               WriteBool('ObjTextAutoSize', chbx_TObjAutoSize.Checked);
               WriteBool('ObjFontLocked', chbx_TFontLocked.Checked);
               WriteBool('Showtextform', cbx_textform.Checked);
               CloseKey;
            end
            else
            begin
               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\' + sRegKey, True);
               WriteInteger('ObjBrushColor', clbx_CBackground.Selected);
               case ObjTyp of
                  0, 4, 5, 6, 7, 8, 9, 10, 11, 13:
                  begin
                     WriteInteger('ObjPenColor', clbx_CBorder.Selected);
                  end;
               else
               begin
                  WriteInteger('ObjPenColor', dlg_Schrift.Font.Color);
               end;
               end;
               WriteInteger('ObjLabelBrushColor', clbx_CLabel.Selected);
               WriteInteger('ObjMemoBorderColor', clbx_CNoteBorder.Selected);
               WriteBool('ObjAutoIncreaseLine', cbx_autolineincrease.checked);
               WriteBool('ObjAutoIncreaseHeight', cbx_autoincreasehigh.checked);
               case cbx_BBackground.ItemIndex of
                  0:
                     bsTmp := bsClear;
                  1:
                     bsTmp := bsFDiagonal;
                  2:
                     bsTmp := bsBDiagonal;
                  3:
                     bsTmp := bsVertical;
                  4:
                     bsTmp := bsHorizontal;
                  5:
                     bsTmp := bsCross;
                  6:
                     bsTmp := bsDiagCross;
                  7:
                     bsTmp := bsSolid;
               end;
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               case cbx_BLabel.ItemIndex of
                  0:
                     bsTmp := bsClear;
                  1:
                     bsTmp := bsFDiagonal;
                  2:
                     bsTmp := bsBDiagonal;
                  3:
                     bsTmp := bsVertical;
                  4:
                     bsTmp := bsHorizontal;
                  5:
                     bsTmp := bsCross;
                  6:
                     bsTmp := bsDiagCross;
                  7:
                     bsTmp := bsSolid;
               end;
               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
               case cbx_BBorder.ItemIndex of
                  0:
                     psTmp := psSolid;
                  1:
                     psTmp := psClear;
                  2:
                     psTmp := psDash;
                  3:
                     psTmp := psDashDot;
                  4:
                     psTmp := psDashDotDot;
                  5:
                     psTmp := psDot;
               end;
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               case cbx_BNoteBorder.ItemIndex of
                  0:
                     psTmp := psSolid;
                  1:
                     psTmp := psClear;
                  2:
                     psTmp := psDash;
                  3:
                     psTmp := psDashDot;
                  4:
                     psTmp := psDashDotDot;
                  5:
                     psTmp := psDot;
               end;
               WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
               if rbtn_SSNo.Checked then
                  shTmp := iesNONE;
               if rbtn_SSIn.Checked then
                  shTmp := iesINARROW;
               if rbtn_SSOut.Checked then
                  shTmp := iesOUTARROW;
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if rbtn_SENo.Checked then
                  shTmp := iesNONE;
               if rbtn_SEIn.Checked then
                  shTmp := iesINARROW;
               if rbtn_SEOut.Checked then
                  shTmp := iesOUTARROW;
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               WriteInteger('ObjShapeHeight', StrToInt(edt_SSHeight.Text));
               WriteInteger('ObjShapeWidth', StrToInt(edt_SSWidth.Text));
               WriteString('ObjName', edt_AObjName.Text);
               WriteInteger('ObjPenWidth', StrToInt(edt_APenWidth.Text));
               case cbx_ARulerTyp.ItemIndex of
                  0:
                     rtTmp := iertRULER;
                  1:
                     rtTmp := iertQUOTEBEGIN;
                  2:
                     rtTmp := iertQUOTECENTER;
                  3:
                     rtTmp := iertQUOTEEND;
               end;
               WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
               case cbx_ARulerMes.ItemIndex of
                  0:
                     ruTmp := ieuPIXELS;
                  1:
                     ruTmp := ieuINCHES;
                  2:
                     ruTmp := ieuMILLIMETERS;
                  3:
                     ruTmp := ieuCENTIMETERS;
                  4:
                     ruTmp := ieuMETERS;
                  5:
                     ruTmp := ieuKM;
                  6:
                     ruTmp := ieuMICRONS;
                  7:
                     ruTmp := ieuNANOMETERS;
               end;
               WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
               WriteInteger('ObjTransparency', StrToInt(edt_ATransp.Text));
               WriteInteger('Objwidth', StrToInt(Edt_objwidth.Text));
               WriteInteger('Objheight', StrToInt(Edt_objheight.Text));
               WriteBool('ObjPolylineClosed', not chbx_AOpenPoly.Checked);
               WriteBool('ObjBoxHighlight', chbx_AIsHiLite.Checked);
               osTmp := [];
               if chbx_ASelectable.Checked then
                  osTmp := osTmp + [ievsSelectable];
               if chbx_AMoveable.Checked then
                  osTmp := osTmp + [ievsMoveable];
               if chbx_ASizeable.Checked then
                  osTmp := osTmp + [ievsSizeable];
               if chbx_AVisible.Checked then
                  osTmp := osTmp + [ievsVisible];
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               WriteString('ObjFontName', dlg_Schrift.Font.Name);
               WriteInteger('ObjFontSize', StrToInt(edt_TFontSize.Text));
               WriteInteger('ObjFontHeight', StrToInt(edt_TFontSize.Text));
               fsTmp := dlg_Schrift.Font.Style;
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
               WriteInteger('FontSize', StrToInt(edt_TFontSize.Text));
               WriteFloat('ObjFontAngle', StrToFloat(edt_TFontAngle.Text));
               case cbx_TLabelPos.ItemIndex of
                  0:
                     lpTmp := ielBegin;
                  1:
                     lpTmp := ielEnd;
               end;
               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
               case cbx_TAlign.ItemIndex of
                  0:
                     taTmp := iejLeft;
                  1:
                     taTmp := iejRight;
                  2:
                     taTmp := iejCenter;
                  3:
                     taTmp := iejJustify;
               end;
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
               WriteString('ObjText', memo_TObjText.Text);
               WriteBool('ObjTextAutoSize', chbx_TObjAutoSize.Checked);
               WriteBool('ObjFontLocked', chbx_TFontLocked.Checked);
               WriteBool('Showtextform', cbx_textform.Checked);
               CloseKey;
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEditOpt.SaveObjVal',
               _('Fehler beim Schreiben in die Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;


procedure Tfrm_DocEditOpt.btn_SaveClick(Sender: TObject);
begin
  GgfLogEvntBeg ('Tfrm_DocEditOpt.btn_SaveClick Begin');

   if pctrl_DocEditOpt.ActivePage = tbs_Annotations then
   begin
      SaveObjVal(tctrl_Annos.TabIndex);
   end;
   SaveDocEditOpt;

  GgfLogEvntEnd ('Tfrm_DocEditOpt.btn_SaveClick End');
end;

procedure Tfrm_DocEditOpt.tctrl_AnnosChange(Sender: TObject);
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.tctrl_AnnosChange');

   LoadObjVal(tctrl_Annos.TabIndex);
end;

procedure Tfrm_DocEditOpt.tctrl_AnnosChanging(Sender: TObject;
   var AllowChange: boolean);
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.tctrl_AnnosChanging');

   SaveObjVal(tctrl_Annos.TabIndex);
end;

procedure Tfrm_DocEditOpt.btn_okClick(Sender: TObject);
begin
   ////////////////////////////////////////////////////////////////////////////////////

   //  Modifizierte Daten des Objektes Speichern
  GgfLogEvnt ('Tfrm_DocEditOpt.btn_okClick');

   if pctrl_DocEditOpt.ActivePage = tbs_Annotations then
   begin
      SaveObjVal(tctrl_Annos.TabIndex);
   end;
   SaveDocEditOpt;
end;

procedure Tfrm_DocEditOpt.edt_SSHeightChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_SSHeight.Text, iValue) then
      edt_SSHeight.Tag := iValue
   else
      edt_SSHeight.Text := IntToStr(edt_SSHeight.Tag);
end;

procedure Tfrm_DocEditOpt.edt_SSWidthChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_SSWidth.Text, iValue) then
      edt_SSWidth.Tag := iValue
   else
      edt_SSWidth.Text := IntToStr(edt_SSWidth.Tag);
end;

procedure Tfrm_DocEditOpt.edt_APenWidthChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_APenWidth.Text, iValue) then
      edt_APenWidth.Tag := iValue
   else
      edt_APenWidth.Text := IntToStr(edt_APenWidth.Tag);
end;

///////////////////////////////////////////////////////////////////////////////////
//  Transparenz aendern

procedure Tfrm_DocEditOpt.edt_ATranspChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_APenWidth.Text, iValue) then
   begin
      if iValue < 0 then
         iValue := 0;
      if iValue > 255 then
         iValue := 255;
      frm_docEditOPt.edt_APenWidth.Tag := iValue;

   end
   else
      edt_APenWidth.Text := IntToStr(edt_APenWidth.Tag);
end;

procedure Tfrm_DocEditOpt.edt_TFontAngleChange(Sender: TObject);
var
   fValue: double;
begin
   if TryStrToFloat(edt_APenWidth.Text, fValue) then
   begin
      if (fValue < -359) or (fValue > 359) then
      begin
         fValue := 0;
         edt_APenWidth.Text := '0';
      end;
   end
   else
      edt_APenWidth.Text := '0';
end;

procedure Tfrm_DocEditOpt.edt_TFontSizeChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_TFontSize.Text, iValue) then
   begin
      if iValue < 0 then
         iValue := 0;
      edt_TFontSize.Tag := iValue;
   end
   else
      edt_TFontSize.Text := IntToStr(edt_TFontSize.Tag);
end;

procedure Tfrm_DocEditOpt.cbx_TLabelPosChange(Sender: TObject);
begin
   if cbx_TLabelPos.ItemIndex = -1 then
      cbx_TLabelPos.ItemIndex := 0;
end;

procedure Tfrm_DocEditOpt.cbx_TAlignChange(Sender: TObject);
begin
   if cbx_TAlign.ItemIndex = -1 then
      cbx_TAlign.ItemIndex := 0;
end;

procedure Tfrm_DocEditOpt.cbx_ARulerTypChange(Sender: TObject);
begin
   if cbx_ARulerTyp.ItemIndex = -1 then
      cbx_ARulerTyp.ItemIndex := 0;
end;

procedure Tfrm_DocEditOpt.cbx_ARulerMesChange(Sender: TObject);
begin
   if cbx_ARulerMes.ItemIndex = -1 then
      cbx_ARulerMes.ItemIndex := 0;
end;

procedure Tfrm_DocEditOpt.sbtn_TFontClick(Sender: TObject);
begin
   if dlg_Schrift.Execute then
   begin
      edt_TFont.Text := dlg_Schrift.Font.Name;
      edt_SFont.Text := edt_TFont.Text;
      edt_TFontSize.Text := IntToStr(dlg_Schrift.Font.Size);
      if tctrl_Annos.TabIndex = 4 then
      begin
         clbx_CBorder.selected := dlg_Schrift.Font.color;
      end;
   end;
end;
(*
procedure Tfrm_DocEditOpt.chbx_EnaRenderEnClick(Sender: TObject);
begin
   frm_DocEdit.img_DocEdit.ObjGraphicRender := chbx_EnaRenderEn.Checked;
end;

procedure Tfrm_DocEditOpt.chbx_EnaAntialiasClick(Sender: TObject);
begin
   frm_DocEdit.img_DocEdit.ObjAntialias := chbx_EnaAntialias.Checked;
end;
  *)
procedure Tfrm_DocEditOpt.edt_SBildChange(Sender: TObject);
var iSWidth, iSHeight, dpix : Integer;
iev_myvect:TImageEnVect;
mesTmp: TIEUnits;
begin
   if FileExists(edt_SBild.Text) then
   begin
     img_SBild.IO.LoadFromFile(edt_SBild.Text);
     img_SBild.Show;
     iSWidth := img_SBild.IO.Params.Width;
     iSHeight := img_SBild.IO.Params.Height;
     dpix:=img_SBild.IO.Params.DpiX;
     iev_myvect := TImageEnVect.Create(self);
     iev_myvect.DpiX :=  img_SBild.IO.Params.DpiX;
     iev_myvect.DpiY :=  img_SBild.IO.Params.DpiY;
     with iev_myvect do
     begin
     mesTmp := MUnit;
     MUnit := ieuMILLIMETERS;
     edt_SWidth.Text := inttostr(Round(iSWidth * MeasureCoefX));
     edt_SHeight.Text:= inttostr(Round(iSHeight * MeasureCoefY));
     MUnit := mesTmp;

     end;

   end;

end;

procedure Tfrm_DocEditOpt.btn_NewStampClick(Sender: TObject);
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.btn_NewStampClick');

  CreStamp;

(* 11.05.2010  r.sch.  3.5.0.76  [2197]
   btn_SaveStamp.Enabled := True;
   btn_DelStamp.Enabled := True;
   btn_SaveStampClick(Sender);   //3.5.0.58 [2197]
*)
end;

procedure Tfrm_DocEditOpt.btn_SaveStampClick(Sender: TObject);
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.btn_SaveStampClick');
  if not isCreateStampOk (edt_SName.Text) then
  begin
    lv_Stamps.Selected.Caption := '';
    edt_SName.Text := '';
    edt_SName.SetFocus;
    exit;
  end;

   SavStamp   (sGStampKey);
   ListStamps (False);
   // f.schneider  das kann man auch nach release der Optionen machen
   //loadfavstampbuttons;
end;

procedure Tfrm_DocEditOpt.btn_DelStampClick(Sender: TObject);

var
  lStampName: string;
  liindex   : integer;
  lsMsg     : string;
  lsInfo    : string;
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.btn_DelStampClick');

   lStampName := Trim (edt_SName.Text);

   if lStampName = '' then
   begin
     selectStampListItem (0);
     Exit;
   end;

   // der Aufruf mittel MessageBox verhindert, das der Dialog DocEditOpt ausgeblendet wird
   // f.schneider
   lsMsg:= Format(_('Wollen Sie den Stempel "%s" wirklich lschen ?'),[lStampName]);
   lsInfo:= _('Stempel lschen ?');
   if MessageBox(Self.Handle,Pchar(lsMsg),PChar(lsInfo),
                 MB_ICONWARNING or MB_YESNO)
      = mrNo
   then
      Exit;

   if lv_Stamps.SelCount > 0 then
   begin
      liindex := lv_Stamps.Selected.Index;
      DelStamp(lv_Stamps.Selected.SubItems.Strings[1]);
      ListStamps(False);
      if (liindex < lv_stamps.Items.Count) then
      begin
         if liindex > 0 then
         begin
            lv_stamps.Items[liindex - 1].Selected := True;
            lv_stamps.Items.Item[liindex - 1].Focused := True;
         end
         else
         begin
            lv_stamps.Items[liindex].Selected := True;
            lv_stamps.Items.Item[liindex].Focused := True;
         end;
      end
      else
      begin
         if lv_stamps.Items.Count > 0 then
         begin
            lv_stamps.Items[0].Selected := True;
            lv_stamps.Items.Item[0].Focused := True;
         end;
      end;

      lv_stamps.SetFocus;
      lv_StampsClick (lv_stamps.Selected);
   end;
   // f.schneider  das kann man auch nach release der Optionen machen
   //loadfavstampbuttons;
end;

procedure Tfrm_DocEditOpt.lv_StampsClick (Sender: TObject);
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.lv_StampsClick');

   if Sender <> nil then
   begin
      if lv_Stamps.SelCount > 0 then
      begin
         sGStampKey := lv_Stamps.Selected.SubItems.Strings[1];
         LoadStamp(sGStampKey);

(* 11.05.2010  r.sch.  3.5.0.76  [2197]
   unntig!
         btn_SaveStamp.Enabled := True;
         btn_DelStamp.Enabled := True;
*)
      end;
   end;
end;

procedure Tfrm_DocEditOpt.sbtn_SBildClick(Sender: TObject);
var
   sFileName: string;
begin
   if PromptForFileName(sFileName) then
      edt_SBild.Text := sFileName;
end;

procedure Tfrm_DocEditOpt.rbtn_STextClick(Sender: TObject);
begin

  ShowStampsElements(false);


end;

procedure Tfrm_DocEditOpt.rbtn_SBildClick(Sender: TObject);
begin
   ShowStampsElements(True);

end;

procedure Tfrm_DocEditOpt.tbs_AnnotationsShow(Sender: TObject);
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.tbs_AnnotationsShow');

   LoadObjVal(tctrl_Annos.TabIndex);
end;

procedure Tfrm_DocEditOpt.tbs_StandardShow(Sender: TObject);
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.tbs_StandardShow');

   LoadDocEditOpt;
end;

procedure Tfrm_DocEditOpt.tbs_StempelShow (Sender: TObject);
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.tbs_StempelShow');
   (*
   ListStamps          (False);
   selectStampListItem (0);
   *)
end;

procedure Tfrm_DocEditOpt.sbtn_SFontClick(Sender: TObject);
begin
(*
if Assigned(dlg_Schrift) then
  FreeAndNil(dlg_Schrift);
   dlg_Schrift := TFontDialog.Create(frm_DocEditOpt);
   dlg_Schrift.OnApply(Self,frm_DocEditOpt.Handle);
   *)
   if dlg_Schrift.Execute then
      edt_SFont.Text := dlg_Schrift.Font.Name;
end;

procedure Tfrm_DocEditOpt.edt_SWidthChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_SWidth.Text, iValue) then
      edt_SWidth.Tag := iValue
   else
      edt_SWidth.Text := IntToStr(edt_SWidth.Tag);
end;

procedure Tfrm_DocEditOpt.edt_SHeightChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_SHeight.Text, iValue) then
      edt_SHeight.Tag := iValue
   else
      edt_SHeight.Text := IntToStr(edt_SHeight.Tag);
end;

procedure Tfrm_DocEditOpt.FormShow(Sender: TObject);
begin
   fifavnum := 0;

   //if pctrl_DocEditOpt.ActivePageIndex = 2 then
   //begin
      ListStamps          (False);
      selectStampListItem (0);

   //end;

end;

procedure Tfrm_DocEditOpt.img_SBildClick(Sender: TObject);
var
   cl_rgb: TRGB;
begin
  (* f.schneider  Solange nicht klar ist, ob wir eine Wahl der Transparenzfarbe
      bentigen, bzw wie diese funktionieren soll, bleibt das hier mal auskommentiert

   cl_rgb := TColor2TRGB(frm_PickColor.PickColor.Color);
   img_SBild.Proc.SetTransparentColors(cl_rgb, cl_rgb, 0);
    *)
end;
(*
procedure Tfrm_DocEditOpt.btn_transpClick(Sender: TObject);
begin
   frm_PickColor.Show;
end;
  *)
procedure Tfrm_DocEditOpt.img_SBildMouseMove(Sender: TObject;
   Shift: TShiftState; X, Y: integer);

var
   cl_rgb: TRGB;

begin
   (* f.schneider  Solange nicht klar ist, ob wir eine Wahl der Transparenzfarbe
      bentigen, bzw wie diese funktionieren soll, bleibt das hier mal auskommentiert

   // transform client coorindates to bitmap ones
   X := img_SBild.XScr2Bmp(X);
   Y := img_SBild.YScr2Bmp(Y);

   // check limits
   if (X >= 0) and (X < img_SBild.IEBitmap.Width) and (Y >= 0) and
      (Y < img_SBild.IEBitmap.Height) then
   begin
      cl_rgb := img_SBild.IEBitmap.Pixels[X, Y];
      frm_PickColor.PickColor.Color := TRGB2TColor(cl_rgb);
      with cl_rgb do
         frm_PickColor.Label3.Caption :=
            IntToStr(r) + ',' + IntToStr(g) + ',' + IntToStr(b);
   end;

   if ssLeft in Shift then
      SetTransparent;
      *)
end;

(*
procedure Tfrm_DocEditOpt.SetTransparent;
var
   cl_rgb: TRGB;
begin
   cl_rgb := TColor2TRGB(frm_PickColor.PickColor.Color);
   img_SBild.Proc.SetTransparentColors(cl_rgb, cl_rgb, 0);
end;
  *)
function Tfrm_DocEditOpt.LoadStampEigenschaften(StampKey: string): boolean;
var
   reg: TRegistry;
   fsTmp: TFontStyles;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   //    ssTmp: TIEVSoftShadow;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;
   li: integer;
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.LoadStampEigenschaften');

   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
               exit;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);
            if ValueExists('Stamptyp') then
            begin
               li := ReadInteger('Stamptyp');
               if li = 1 then
                  exit;
            end;

            if ValueExists('ObjBrushColor') then
               clbx_CBackground.Selected := ReadInteger('ObjBrushColor')
            else
               clbx_CBackground.Selected := 0;
            if ValueExists('ObjPenColor') then
            begin
               //          clbx_CBorder.Selected := ReadInteger('ObjPenColor');
               dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
            end
            else
            begin
               clbx_CBorder.Selected := 0;
               dlg_Schrift.Font.Color := 0;
            end;
            if ValueExists('ObjLabelBrushColor') then
               clbx_CLabel.Selected := ReadInteger('ObjLabelBrushColor')
            else
               clbx_CLabel.Selected := 0;
            if ValueExists('ObjMemoBorderColor') then
               clbx_CNoteBorder.Selected := ReadInteger('ObjMemoBorderColor')
            else
               clbx_CNoteBorder.Selected := 0;
            if ValueExists('ObjAutoIncreaseLine') then
               cbx_autolineincrease.checked := ReadBool('ObjAutoIncreaseLine')
            else
               cbx_autolineincrease.checked := false;
            if ValueExists('ObjAutoIncreaseHeight') then
               cbx_autoincreasehigh.checked := ReadBool('ObjAutoIncreaseHeight')
            else
               cbx_autoincreasehigh.checked := false;
            if ValueExists('ObjBrushStyle') then
            begin
               ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               case bsTmp of
                  bsSolid:
                     cbx_BBackground.ItemIndex := 7;
                  bsClear:
                     cbx_BBackground.ItemIndex := 0;
                  bsHorizontal:
                     cbx_BBackground.ItemIndex := 4;
                  bsVertical:
                     cbx_BBackground.ItemIndex := 3;
                  bsFDiagonal:
                     cbx_BBackground.ItemIndex := 1;
                  bsBDiagonal:
                     cbx_BBackground.ItemIndex := 2;
                  bsCross:
                     cbx_BBackground.ItemIndex := 5;
                  bsDiagCross:
                     cbx_BBackground.ItemIndex := 6;
               end;
               cbx_BBackground.Enabled := True;
            end
            else
            begin
               cbx_BBackground.ItemIndex := 0;

               cbx_BBackground.Enabled := True;
            end;
            if ValueExists('ObjLabelBrushStyle') then
            begin
               ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
               case bsTmp of
                  bsSolid:
                     cbx_BLabel.ItemIndex := 7;
                  bsClear:
                     cbx_BLabel.ItemIndex := 0;
                  bsHorizontal:
                     cbx_BLabel.ItemIndex := 4;
                  bsVertical:
                     cbx_BLabel.ItemIndex := 3;
                  bsFDiagonal:
                     cbx_BLabel.ItemIndex := 1;
                  bsBDiagonal:
                     cbx_BLabel.ItemIndex := 2;
                  bsCross:
                     cbx_BLabel.ItemIndex := 5;
                  bsDiagCross:
                     cbx_BLabel.ItemIndex := 6;
               end;
               cbx_BLabel.Enabled := True;
            end
            else
            begin
               cbx_BLabel.ItemIndex := 0;

               cbx_BLabel.Enabled := True;
            end;

            if ValueExists('ObjPenStyle') then
            begin
               ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               case psTmp of
                  psSolid:
                     cbx_BBorder.ItemIndex := 0;
                  psDash:
                     cbx_BBorder.ItemIndex := 2;
                  psDot:
                     cbx_BBorder.ItemIndex := 5;
                  psDashDot:
                     cbx_BBorder.ItemIndex := 3;
                  psDashDotDot:
                     cbx_BBorder.ItemIndex := 4;
                  psClear:
                     cbx_BBorder.ItemIndex := 1;
               end;
               cbx_BBorder.Enabled := True;
            end
            else
            begin
               cbx_BBorder.ItemIndex := 0;

               cbx_BBorder.Enabled := True;
            end;
            if ValueExists('ObjMemoBorderStyle') then
            begin
               ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
               case psTmp of
                  psSolid:
                     cbx_BNoteBorder.ItemIndex := 0;
                  psDash:
                     cbx_BNoteBorder.ItemIndex := 2;
                  psDot:
                     cbx_BNoteBorder.ItemIndex := 5;
                  psDashDot:
                     cbx_BNoteBorder.ItemIndex := 3;
                  psDashDotDot:
                     cbx_BNoteBorder.ItemIndex := 4;
                  psClear:
                     cbx_BNoteBorder.ItemIndex := 1;
               end;
               cbx_BNoteBorder.Enabled := True;

            end
            else
            begin
               cbx_BNoteBorder.ItemIndex := 0;

               cbx_BNoteBorder.Enabled := True;
            end;
            if ValueExists('ObjBeginShape') then
            begin
               ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               case shTmp of
                  iesNONE:
                     rbtn_SSNo.Checked := True;
                  iesINARROW:
                     rbtn_SSIn.Checked := True;
                  iesOUTARROW:
                     rbtn_SSOut.Checked := True;
               end;
            end
            else
               rbtn_SSNo.Checked := True;
            if ValueExists('ObjEndShape') then
            begin
               ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               case shTmp of
                  iesNONE:
                     rbtn_SENo.Checked := True;
                  iesINARROW:
                     rbtn_SEIn.Checked := True;
                  iesOUTARROW:
                     rbtn_SEOut.Checked := True;
               end;
            end
            else
               rbtn_SENo.Checked := True;
            if ValueExists('ObjShapeHeight') then
               edt_SSHeight.Text := IntToStr(ReadInteger('ObjShapeHeight'))
            else
               edt_SSHeight.Text := '0';
            if ValueExists('ObjShapeWidth') then
               edt_SSWidth.Text := IntToStr(ReadInteger('ObjShapeWidth'))
            else
               edt_SSWidth.Text := '0';
            if ValueExists('ObjName') then
               edt_AObjName.Text := ReadString('ObjName')
            else
               edt_AObjName.Text := 'neues Objekt';
            if ValueExists('ObjPenWidth') then
               edt_APenWidth.Text := IntToStr(ReadInteger('ObjPenWidth'))
            else
               edt_APenWidth.Text := '1';
            if ValueExists('ObjRulerType') then
            begin
               ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
               case rtTmp of
                  iertRULER:
                     cbx_ARulerTyp.ItemIndex := 0;
                  iertQUOTEBEGIN:
                     cbx_ARulerTyp.ItemIndex := 1;
                  iertQUOTECENTER:
                     cbx_ARulerTyp.ItemIndex := 2;
                  iertQUOTEEND:
                     cbx_ARulerTyp.ItemIndex := 3;
               end;
            end
            else
               cbx_ARulerTyp.ItemIndex := 0;
            if ValueExists('ObjRulerUnit') then
            begin
               ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
               case ruTmp of
                  ieuPIXELS:
                     cbx_ARulerMes.ItemIndex := 0;
                  ieuINCHES:
                     cbx_ARulerMes.ItemIndex := 1;
                  ieuKM:
                     cbx_ARulerMes.ItemIndex := 5;
                  ieuMETERS:
                     cbx_ARulerMes.ItemIndex := 4;
                  ieuCENTIMETERS:
                     cbx_ARulerMes.ItemIndex := 3;
                  ieuMILLIMETERS:
                     cbx_ARulerMes.ItemIndex := 2;
                  ieuMICRONS:
                     cbx_ARulerMes.ItemIndex := 6;
                  ieuNANOMETERS:
                     cbx_ARulerMes.ItemIndex := 7;
               end;
            end
            else
               cbx_ARulerMes.ItemIndex := 0;
            if ValueExists('ObjTransparency') then
               edt_ATransp.Text := IntToStr(ReadInteger('ObjTransparency'))
            else
               edt_ATransp.Text := '110';  //Igel0612151159
            if ValueExists('ObjPolylineClosed') then
               chbx_AOpenPoly.Checked := not ReadBool('ObjPolylineClosed')
            else
               chbx_AOpenPoly.Checked := False;
            if ValueExists('ObjBoxHighlight') then
               chbx_AIsHiLite.Checked := ReadBool('ObjBoxHighlight')
            else
               chbx_AIsHiLite.Checked := False;
            if ValueExists('ObjStyle') then
            begin
               ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               chbx_ASelectable.Checked := ievsSelectable in osTmp;
               chbx_AMoveable.Checked := ievsMoveable in osTmp;
               chbx_ASizeable.Checked := ievsSizeable in osTmp;
               chbx_AVisible.Checked := ievsVisible in osTmp;
            end
            else
            begin
               chbx_ASelectable.Checked := True;
               chbx_AMoveable.Checked := True;
               chbx_ASizeable.Checked := True;
               chbx_AVisible.Checked := True;
            end;

            if ValueExists('ObjHeight') then
               edt_objheight.Text := IntToStr(ReadInteger('ObjHeight'))
            else
               edt_objheight.Text := '400';
            if ValueExists('Objwidth') then
               Edt_objwidth.Text := IntToStr(ReadInteger('Objwidth'))
            else
               Edt_objwidth.Text := '400';

            if ValueExists('FontName') then
            begin
               edt_TFont.Text := ReadString('FontName');
            end
            else
            begin
               edt_TFont.Text := '';
            end;
            dlg_Schrift.Font.Name := edt_TFont.Text;
            edt_SFont.Text := edt_TFont.Text;
            if ValueExists('FontSize') then
            begin
               dlg_Schrift.Font.Size := ReadInteger('FontSize');
               edt_TFontSize.Text := IntToStr(ReadInteger('FontSize'));
            end
            else
            begin
               dlg_Schrift.Font.Size := 72;
               edt_TFontSize.Text := '72';
            end;
            if ValueExists('FontStyle') then
            begin
               ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
               dlg_Schrift.Font.Style := fsTmp;
            end
            else
               dlg_Schrift.Font.Style := [];
            if ValueExists('ObjFontAngle') then
               edt_TFontAngle.Text := FloatToStr(ReadFloat('ObjFontAngle'))
            else
               edt_TFontAngle.Text := '0';
            if ValueExists('ObjLabelPosition') then
            begin
               ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
               case lpTmp of
                  ielBegin:
                     cbx_TLabelPos.ItemIndex := 0;
                  ielEnd:
                     cbx_TLabelPos.ItemIndex := 1;
               end;
            end
            else
               cbx_TLabelPos.ItemIndex := 0;
            if ValueExists('ObjTextAlign') then
            begin
               ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
               case taTmp of
                  iejLeft:
                     cbx_TAlign.ItemIndex := 0;
                  iejRight:
                     cbx_TAlign.ItemIndex := 1;
                  iejCenter:
                     cbx_TAlign.ItemIndex := 2;
                  iejJustify:
                     cbx_TAlign.ItemIndex := 3;
               end;
            end
            else
               cbx_TAlign.ItemIndex := 0;
            if ValueExists('ObjText') then
               memo_TObjText.Text := ReadString('ObjText')
            else
               memo_TObjText.Text := 'neuer Text';
            if ValueExists('ObjTextAutoSize') then
               chbx_TObjAutoSize.Checked := ReadBool('ObjTextAutoSize')
            else
               chbx_TObjAutoSize.Checked := False;
            if ValueExists('ObjFontLocked') then
               chbx_TFontLocked.Checked := ReadBool('ObjFontLocked')
            else
               chbx_TFontLocked.Checked := False;
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEditOpt.LoadObjVal', _('Fehler beim Lesen des Registrierung:') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;


procedure Tfrm_DocEditOpt.lv_eigenschaftstempelClick(Sender: TObject);
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.lv_eigenschaftstempelClick');

   if lv_eigenschaftstempel.SelCount > 0 then
   begin
      sGStampKey := lv_eigenschaftstempel.Selected.SubItems.Strings[0];
      LoadStamp(sGStampKey);
      LoadObjVal(3);
   end;
end;

procedure Tfrm_DocEditOpt.loadfavstampbuttons;
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.loadfavstampbuttons');
   (*
   u_ShViewUtils.LoadFavStampbuttons( frm_mainform.tbx_fav1, frm_mainform.tbx_fav2,
         frm_mainform.tbx_fav3, frm_mainform.tbx_fav4, frm_mainform.tbx_fav5);

      u_ShViewUtils.LoadFavStampbuttons( tbx_fav1, tbx_fav2,
         tbx_fav3, tbx_fav4, tbx_fav5);
   *)

end;


procedure Tfrm_DocEditOpt.frmsto_docoptionenRestorePlacement(Sender: TObject);
begin
  GgfLogEvnt ('Tfrm_DocEditOpt.frmsto_docoptionenRestorePlacement');

   LoadObjVal(tctrl_Annos.TabIndex);
end;


procedure Tfrm_DocEditOpt.cbx_nummerChange(Sender: TObject);
begin
   fifavnum := cbx_nummer.ItemIndex;
   LoadObjVal(tctrl_Annos.TabIndex);
   cbx_nummer.setfocus;
end;


procedure Tfrm_DocEditOpt.memo_TObjTextKeyDown(Sender: TObject;
   var Key: Word; Shift: TShiftState);
begin
 if (Key = Ord('A')) and (ssCtrl in Shift) then
 begin
    TMemo(Sender).SelectAll;
    Key := 0;
 end;
end;

procedure Tfrm_DocEditOpt.FormCreate(Sender: TObject);
  begin
     TP_GlobalIgnoreClassProperty(TComboBoxEx, 'itemsex');
     TranslateComponent(self, 'Viewerv3');
     // manuelle Behandlung der TColorBox
     TranslateStrings(clbx_CBackground.Items, 'Delphi7');
     TranslateStrings(clbx_CBorder.Items, 'Delphi7');
     TranslateStrings(clbx_CLabel.Items, 'Delphi7');
     TranslateStrings(clbx_CNoteBorder.Items, 'Delphi7');

     //  Member-Initialisierung
     //
     mStampFavoOld := 0;

//     if not assigned(dm_DocEdit) then
//     begin
//        //Application.CreateForm(Tdm_DocEdit, dm_DocEdit);
//        // f.schneider
//        dm_DocEdit := Tdm_DocEdit.Create(Self);
//     end;

  end;

procedure Tfrm_DocEditOpt.CreateParams(var Params: TCreateParams);
  begin
     // so that mainform doesnt throw frm_docedit to background
     inherited;
     Params.ExStyle := Params.ExStyle; // or WS_EX_APPWINDOW;
     Params.WndParent := GetDesktopWindow;
  end;

procedure Tfrm_DocEditOpt.chk_AnpassenClick(Sender: TObject);
begin

  EnableBreiteHoehe(not chk_Anpassen.Checked);

end;


end.

