unit u_DocLink;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Grids, DBGrids, CRGrid, ComCtrls, Menus, gnugettext,
   {u_NewDocLink,} u_ShBase, u_ShLowUtils, u_ShHighUtils, ExtCtrls;

type
   Tfrm_DocLink = class (TFrame)
    lbl_LinkInfo: TLabel;
    dbgrd_Links: TCRDBGrid;
    pnl_input: TPanel;
    lbl_AnzLink: TLabel;
    lbl_Bez: TLabel;
    btn_ShowLnk: TButton;
    ButtonDel1Link: TButton;
    btn_allldoclinks: TButton;
    btn_LnkDel: TButton;
    btn_LnkImp: TButton;
    btn_LnkRen: TButton;
    btn_LnkCre: TButton;
    edt_Link: TEdit;
      procedure btn_LnkCreClick(Sender: TObject);
      procedure btn_LnkDelClick(Sender: TObject);
      procedure btn_LnkRenClick(Sender: TObject);
      procedure btn_LnkImpClick(Sender: TObject);
      procedure dbgrd_LinksCellClick(Column: TColumn);
      procedure btn_ShowLnkClick(Sender: TObject);
      procedure ButtonDel1LinkClick(Sender: TObject);
      procedure btn_allldoclinksClick(Sender: TObject);
   private
      { Private-Deklarationen }
      fbSelLink : Boolean;
   public
      { Public-Deklarationen }
      fbShowlinkcount: boolean;
      constructor Create(AOwner: TComponent); override;

      function AddDocToRef: boolean;
      function CreLink(AsLnkName:string): boolean;
      function CreAutoLink: boolean;
      function AutoLinkDoc: boolean;
      function DelLink(onlythisref: boolean): boolean;
      function DeloneDocLink(lsVerknName: string): boolean;
      function RenLink: boolean;
      function ImpLink: boolean;
      function SelLink: boolean;
      function GetDocs: boolean;
      function GetLinks: boolean;
      function SeaLink(Ref_Name: string): boolean;
      function GetQuickLinks(ArcID: integer = -1; DocID: integer = -1): boolean;
      function GetLinkedDocs: boolean;
      function CreLinknotinteractive: boolean;
      procedure EnableControls(enable : Boolean);

   end;

implementation

uses u_MainForm, u_dm_DB, {} u_dm_ViewerMain, u_ShSql{, u_ShDocument};

{$R *.dfm}

constructor Tfrm_DocLink.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  TranslateComponent(self, 'Viewerv3');
end;




function Tfrm_DocLink.GetQuickLinks(ArcID: integer = -1; DocID: integer = -1): boolean;
   ///////////////////////////////////////////////////////////////////
   ///   12.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Funktion ruft GetLinks auf und fllt das Ergebnis   ///
   ///   in eine ComboBox.                                         ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
var
   iCount, iCount2, i: integer;
   sltmp, lsadd, lsSQL, lsRefName: string;


///////////////////////////////////////// 29.11.2012 b.takacs 3.5.3.2 [T310] -->
		procedure AddLastLink;
    begin
         	if frm_Mainform.lbl_choosenlink.Caption <> '' then
          begin
            	lsRefName := frm_Mainform.lbl_choosenlink.Caption;
               if Pos('&', lsRefName) > 0 then
                  lsRefName := StringReplace(lsRefName,'&','&&',[rfReplaceAll]);

               dm_MainForm2.mnu_LinkDocRef.Add(newItem(lsRefName,
                  0, False, True, dm_MainForm2.LinkDocWithRef, 0, 'pum_Ref' + IntToStr(0)));
               dm_MainForm2.mnu_LinkDocRef.Items[0].Tag := 0;
   				end;
        end;
///////////////////////////////////////// 29.11.2012 b.takacs 3.5.3.2 [T310] <--


begin
   GgfLogevntBeg('Tfrm_DocLink.GetQuickLinks beg');
   try
///////////////////////////////////////////////// 17.08.2011	b.takacs

		if ArcID = -1 then
      begin
        ArcID:= iGArcID;
        DocID:= iGDocID;
      end;
///////////////////////////////////////////////// 17.08.2011	b.takacs
      (*
      if fbShowlinkcount then
      begin
         sltmp := 'SELECT distinct t1.ref_name, t1.ref_lnk,count(t1.ref_lnk) as count' +
            '  FROM sys_doclnk as t1 JOIN (SELECT ref_lnk ' +
            'FROM sys_doclnk WHERE  arc_id = ' + IntToStr(ArcID) + ' and doc_id = ' + IntToStr(DocID) +
            ') as t2 on(t1.ref_lnk=t2.ref_lnk)  group by ref_lnk  order by ref_lnk desc';

      end
      else
      begin
         sltmp := '';
         sltmp := 'select ref_name,ref_Lnk from sys_doclnk' +
            ' where arc_id = ' + IntToStr(ArcID) + ' and doc_id = ' +
            IntToStr(DocID) + ' order by ref_lnk desc';
      end;
      Result := frm_MainForm.DocShowTmpSQL(sltmp); //TmpSQL(sltmp); //02.11.2010 b.takacs 3.5.0.118
      *)

      Result := frm_MainForm.DocShowTmpSQL('Select ref_name from sys_doclnk' +
    				' where arc_id = ' + IntToStr(iGArcID) +' and doc_id = ' + IntToStr(iGDocID) +
               ' group by ref_name');

      if Result then
      begin
         Result := False;
         For i := 0 to dm_DB.my_q_DocShowTmp.RecordCount -1 do
         begin
            if frm_MainForm.TmpSQL('select * from sys_doclnk where ref_name = ' +#39 + dm_DB.my_q_DocShowTmp.FieldByName('ref_name').AsString+#39+
                                    ' group by arc_id, doc_id') then
            begin
               if lsSQL <> '' then
                  lsSQL := lsSQL + ' union ';
                lsSQL := lsSQL + 'Select ' + #39 +dm_DB.my_q_DocShowTmp.FieldByName('ref_name').AsString + #39 +' as ref_name, ' +
                         #39 + inttostr(dm_DB.my_q_tmp.Recordcount) + #39 + ' as count';
            end;
         	dm_DB.my_q_DocShowTmp.Next;
         end;

         if lsSQL <> '' then
         begin
         	Result := frm_MainForm.DocShowTmpSQL(lsSQL);
         end;
      end;

      //////////////////////////////////////////////////////////////////////
      //  pum_links pop up clearen

      frm_MainForm.tci_DocLink.Color := gclOlive;
      dm_MainForm2.pum_Links.Items.Clear;
      dm_MainForm2.mnu_DocLinks.Clear;
      //dm_MainForm2.mnu_LinkDocRef.Clear;
      dm_MainForm2.mnu_LinkDocAddtoRef.Clear;

      if Result then
      begin
///////////////////////////////////////// 29.11.2012 b.takacs 3.5.3.2 [T310] -->

         // letzte Verknpfung kann immer nur eine sein
         if dm_MainForm2.mnu_LinkDocRef.Count = 0 then
         begin
					 AddLastLink;
         end
         //// Oder gibt es schon ein Element drin...
         else if ( dm_MainForm2.mnu_LinkDocRef.Items[0].Caption <> frm_Mainform.lbl_choosenlink.Caption ) then
         begin
     			 dm_MainForm2.mnu_LinkDocRef.Clear;
         	 AddLastLink;
         end;
///////////////////////////////////////// 29.11.2012 b.takacs 3.5.3.2 [T310] <--
         iCount2 := 0;
         with dm_db.my_q_DocShowTmp do //dm_DB.my_q_Tmp do //02.11.2010 b.takacs 3.5.0.118
         begin
            First;
            while not EOF do
            begin

               if ((dm_MainForm2.pum_Links.Items.Find(FieldByName('ref_name').AsString) = nil)) then
               begin
                  if fbShowlinkcount then
                  begin
                     lsadd := ':' + FieldByName('count').AsString;
                  end
                  else
                  begin
                     lsadd := '';
                  end;
                  lsRefName := FieldByName('ref_name').AsString;
                  if Pos('&', lsRefName) > 0 then
                  	lsRefName := StringReplace(lsRefName,'&','&&',[rfReplaceAll]);

                  dm_MainForm2.pum_Links.Items.Add(
                     newItem(lsRefName + lsadd, 0, False, True,
                     dm_MainForm2.pum_LinkClick, 0, 'pum_Ref' + IntToStr(RecNo)));
                  dm_MainForm2.mnu_DocLinks.Add(
                  	newItem(lsRefName, 0, False, True,
                  	dm_MainForm2.pum_LinkClick, 0, 'pum_Ref' + IntToStr(RecNo)));
                  dm_MainForm2.mnu_LinkDocAddtoRef.Add(
                  	newItem(lsRefName, 0, False, True,
                     dm_MainForm2.LinkDocWithRef_New, 0, 'pum_Ref' + IntToStr(RecNo)));
                  //iCount := FieldByName('ref_Lnk').AsInteger;
                  //dm_MainForm2.pum_Links.Items[iCount2].Tag := iCount;
                  dm_MainForm2.pum_Links.Items[iCount2].hint := FieldByName('ref_name').AsString;
                  dm_MainForm2.mnu_DocLinks.Items[iCount2].Tag := iCount;
                  dm_MainForm2.mnu_DocLinks.Items[iCount2].hint :=
                     FieldByName('ref_name').AsString;
                  dm_MainForm2.mnu_LinkDocAddtoRef.Items[iCount2].Tag := iCount;
                  dm_MainForm2.mnu_LinkDocAddtoRef.Items[iCount2].hint :=
                     FieldByName('ref_name').AsString;
                  iCount2 := iCount2 + 1;
               end;
               frm_MainForm.tci_DocLink.color := clyellow;
               Next;
            end;
            Close;
         end;
      end
      else
      begin
         //LogEvnt('GetQuickLinks: '+ _('Fehler beim Auslesen der Verknpfungen fr dieses Dokument'));
         //frm_MainForm.setPanelInfo(_('Fehler beim Auslesen der Verknpfungen fr dieses Dokument'));
      end;

   finally
      GgfLogevntEnd('Tfrm_DocLink.GetQuickLinks end');
   end;
end;

function Tfrm_DocLink.GetLinks: boolean;
   ///////////////////////////////////////////////////////////////////
   ///   04.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Funktion liest aus der Tabelle sys_doclnk alle      ///
   ///   Referenzen zum aktuellen Dokument aus und setzt die       ///
   ///   Globalen Variablen iGRefID und sGRefName mit Werten aus   ///
   ///   dem ersten Datensatz.                                     ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
var lidocid, liarcid, i: integer;
	var sRefname, lsSQL : string;
begin
    sRefname := '';
    lidocid := iGDocID;
    liarcid := iGArcID;

   (* //das ergibt ein falsches Ergebnis, ein nahezu bldsinniges Ergebnis
      // f.schneider v3.5.1.62
   Result :=
      frm_MainForm.LnkSQL('SELECT distinct t2.ref_id, t1.ref_name, t1.ref_lnk,' +
      'count(t1.ref_lnk) as count, t2.arc_id ,t2.doc_id, sys_usr.usr_name FROM sys_doclnk as t1 ' +
      'left join sys_usr on (sys_usr.usr_id=t1.usr_id) ' +
      'JOIN (SELECT ref_lnk, ref_id,arc_id, doc_id FROM sys_doclnk WHERE  arc_id = ' + IntToStr(liarcid) +
      ' and doc_id = ' + IntToStr(lidocid) +
      ') as t2 on(t1.ref_lnk=t2.ref_lnk)  group by ref_lnk  order by ref_lnk desc'); *)


   (* so ist auch Mist, wenn es zu einer arcid/docid und ref_name 2 Eintrge gibt (warum auch immer)
      verdoppelt sich die anzahl der ber den Join gefundenen Dokumente
      Ich hole mir jetzt die ref_name zu einem Dokument, dann mach ich eine Abfrage rein ber diese
   Result := frm_MainForm.LnkSQL(
        'SELECT  t1.ref_id, t1.ref_name,  t2.ref_id, t2.ref_name, t2.ref_lnk, t2.usr_id,' +
        't2.arc_id ,t2.doc_id, count( * ) as count ' +
        'FROM sys_doclnk as t1 ' +
        'JOIN (SELECT ref_name, ref_lnk, ref_id, arc_id, doc_id , usr_id FROM sys_doclnk ' +
        'WHERE  arc_id = ' + IntToStr(liarcid) +' and doc_id = ' + IntToStr(lidocid) +') as t2 ' +
        'on t1.ref_name = t2.ref_name ' +
        'group by t2.ref_name order by t2.ref_name');
    *)

    Result := frm_MainForm.LnkSql('Select ref_name from sys_doclnk' +
    				' where arc_id = ' + IntToStr(liarcid) +' and doc_id = ' + IntToStr(lidocid) +
               ' group by ref_name');

    if Result then
    begin
      edt_Link.Text := dm_DB.my_q_Lnk.FieldByName('ref_name').AsString;
    	For i := 0 to dm_DB.my_q_Lnk.RecordCount -1 do
      begin
      	if frm_MainForm.TmpSQL('select * from sys_doclnk where ref_name = ' +#39 + dm_DB.my_q_Lnk.FieldByName('ref_name').AsString+#39+
         								' group by arc_id, doc_id') then
         begin
            if lsSQL <> '' then
            	lsSQL := lsSQL + ' union ';
             lsSQL := lsSQL + 'Select ' + #39 +dm_DB.my_q_Lnk.FieldByName('ref_name').AsString + #39 +' as ref_name, ' +
             			 #39 + inttostr(dm_DB.my_q_tmp.Recordcount) + #39 + ' as count';
         end;

         dm_DB.my_q_Lnk.Next;
      end;

      if lsSQL <> '' then
      begin
      	Result := frm_MainForm.LnkSQL(lsSQL);
      end;

    end
    else
    begin
      ErrorMsg('ShowDocLink',
         _('Fehler beim Auslesen der Verknpfungen fr dieses Dokument'), 2012, True);

    end;
   (*
   if Result then
      with dm_DB.my_q_Lnk do
      begin
         if RecordCount = 0 then
            exit;
         dbgrd_Links.AdjustColumns;
         iGRefLNK := FieldByName('ref_lnk').AsInteger;
         sGRefName := FieldByName('ref_name').AsString;
         iGRefID := FieldByName('ref_ID').AsInteger;
         edt_Link.Text := sGRefName;
      end
   else
      ErrorMsg('ShowDocLink',
         _('Fehler beim Auslesen der Verknpfungen fr dieses Dokument'), 2012, True);
   *)
end;

function Tfrm_DocLink.GetLinkedDocs: boolean;
   ///////////////////////////////////////////////////////////////////
   ///   04.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Funktion liest aus der Tabelle sys_doclnk die       ///
   ///   Anzahl aller Dokumente aus, die mit der aktuellen         ///
   ///   Referenz verbunden sind.                                  ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
begin
   (*
   if dm_DB.my_q_Lnk.RecordCount = 0 then
   begin
      lbl_AnzLink.Caption := _('Fr dieses Dokument existieren keine Verknpfungen.');
      edt_Link.Text := '';
      Result := False;
      btn_ShowLnk.Enabled := False;
      exit;
   end;

   btn_ShowLnk.Enabled := True;
   // search for ref_lnk and not ref_id

   Result :=
      frm_MainForm.TmpSQL('select ref_id, ref_name from sys_doclnk where ref_lnk = ' +
      IntToStr(iGRefLNK) + ' or (ref_id = ' + IntToStr(iGRefLNK) + ' and ref_lnk = 0)');
   if Result then
      lbl_AnzLink.Caption := 'Mit dieser Verknpfung sind ' +
         IntToStr(dm_DB.my_q_Tmp.RecordCount) + ' Dokumente verbunden.'
   else
      ErrorMsg('ShowDocLink', _('Fehler beim Auslesen der Verknpften Dokumente'),
         2011, True);
// f.schneider 3.5.1.48 wir nehmen das lowercase raus
//   edt_Link.Text := lowercase(sGRefName);
   if sGRefName <> '' then
	   edt_Link.Text := sGRefName;
   //dm_DB.my_q_Tmp.Close;
   *)
end;

function Tfrm_DocLink.SeaLink(Ref_Name: string): boolean;
var
   iCount, iCountTo, iTmpRefLNK, liref0rec, iTmpGDocID: integer;
   sTmpDocID, sTmpArcID, sTmpArcName, sTmpTblName, nog_sqlText,
   lstrsqlr: string;
begin
   Result := True;
   ///////////////////////////////////////////////////////////////////
   // Erzeugt eine suche fuer referenzen, die mit dem Suchword beginnen
   // red_id ref_lnk, put away (it would be the first reference!, which could be deleted
   // get ref_lnk

{     select the ref with ref name and igusrid where igusrid has rights to read in that arc!
select *  from sys_doclnk
where ref_name like 'abc' and 52 =(select usr_id from sys_arcxs where
FIND_IN_SET('read',sys_arcxs.rights) and usr_id=52 and sys_arcxs.arc_id =sys_doclnk.arc_id)
}
   // just search for the ref_lnk with the ref_name!
   nog_SqlText := 'select ref_lnk, ref_id from sys_doclnk where ref_Name like ' +
      #39 + Ref_Name + #39 + ' group by ref_lnk';
   if frm_MainForm.LnkSQL(nog_sqlText) then
   begin
      with dm_DB do
      begin
         if my_q_Lnk.RecordCount > 0 then
         begin

            DbCreateTempTable(sGTmpName);

            (*  // f.schneider  v3.5.1.62
            my_cmd.SQL.Text := 'drop table if exists tmp_' + sGTmpName;
            try
               my_cmd.Execute;
            except
               on e: Exception do
                  ErrorMsg('GetDocs',
                     _('Fehler beim Entfernen einer Temptabelle:') + e.Message, 1004, True);
            end;

            my_cmd.SQL.Text :=
               'CREATE TABLE `tmp_' + sGTmpName + '` (' +
               '`ARC_ID` BIGINT UNSIGNED NOT NULL,' +
               '`ArcName` VARCHAR(32) NOT NULL,' +
               '`TblName` VARCHAR(14) NOT NULL,' +
               '`DOC_ID` BIGINT UNSIGNED NOT NULL,' +
               '`DISP_NAME` VARCHAR(32) NOT NULL,' +
               '`DOC_LOC` VARCHAR(255) NOT NULL,' +
               '`EXT_LOC` VARCHAR(255) NOT NULL,' +
               '`ORI_LOC` VARCHAR(255) NOT NULL,' +
               '`USR_NAME` VARCHAR(32) NOT NULL,' +
               '`USR_ID` BIGINT UNSIGNED NOT NULL,' + '`TStamp` DATETIME NOT NULL,' +
               '`DOC_TXT` LONGTEXT,' + '`DOC_STATE` INTEGER UNSIGNED NOT NULL,' +
               '`OCR_QF` INTEGER SIGNED NOT NULL DEFAULT 0,' +
               '`SHA1` varchar(40),' +
               '`GDOC_ID` BIGINT UNSIGNED NOT NULL,' + '`OPTIONEN` INTEGER UNSIGNED NOT NULL' +     // 06.09.2010 b.takacs [2717]
               ', primary key (`ARC_ID`,`DOC_ID`)' + ') COMMENT = ' +
               #39 + _('Temptabelle fr Benutzer') + ' (USR_ID): ' + sGUsrName +
               ' (' + IntToStr(iGUsrID) + ')' + #39;
            try
               my_cmd.Execute;
            except
               on e: Exception do
                  ErrorMsg('GetDocs', _('Fehler beim Erzeugen einer Temptabelle:') +
                     e.Message, 1003, True);
            end;
            *)
            iCountTo := my_q_Lnk.RecordCount;
            liref0rec := 0;
            // get the ref_lnk for all verknpfungen which doenst have ref_lnk = 0;
            for iCount := 0 to (iCountTo - 1) do
            begin
               iTmpRefLNK := my_q_Lnk.FieldByName('ref_lnk').AsInteger;
               // couldnt think of        ref_id = ' + IntToStr(iTmpRefID) + ' and ref_lnk = 0'
               // so we take it away (which case could it be?)
               // get the infos about the ref_lnk and check for the permissions
               if iTmpRefLNK = 0 then

               begin
                  liref0rec := dm_db.my_q_Lnk.RecNo;
                  my_q_Lnk.Next;
                  continue;
               end
               else
               begin
                  lstrsqlr := 'select sys_doclnk.arc_id, Arc_Name, arc_tblname, doc_id,sys_arcxs.arc_id' +
                     ', sys_arcxs.usr_id from sys_doclnk left join sys_arcxs Using(arc_id) ' +
                     ' left join sys_arc Using(arc_id)' + ' where ref_lnk = ' + IntToStr(iTmpRefLNK) +
                     ' and sys_arcxs.arc_id = sys_doclnk.arc_id and ' + ' (FIND_IN_SET(' + #39 + 'read' +
                     #39 + ',sys_arcxs.rights) and sys_arcxs.usr_id=' + IntToStr(iGUsrID) + ') group by ref_id';
               end;
               my_q_Lnk.Next;
               if frm_MainForm.TmpSQL(lstrsqlr) then
               begin
                  if my_q_Tmp.recordcount = 0 then
                  begin
                     continue;
                  end;
                  while not my_q_Tmp.EOF do
                  begin
                     sTmpDocID :=
                        IntToStr(my_q_Tmp.FieldByName('doc_id').AsInteger);
                     sTmpArcID :=
                        IntToStr(my_q_Tmp.FieldByName('arc_id').AsInteger);
                     sTmpArcName :=
                        my_q_Tmp.FieldByName('arc_name').AsString;
                     sTmpTblName :=
                        my_q_Tmp.FieldByName('arc_tblname').AsString;
                     // 06.09.2010 b.takacs [2717]
         						 iTmpGDocID:= dm_DB.GetGDocIDByArcIDandDocID(StrToInt(sTmpArcID),StrToInt(sTmpDocID));

                     if sTmpTblName = '' then
                     begin
                        my_q_Tmp.Next;
                        continue;
                     end;
                     my_cmd.SQL.Text :=
                        'Insert into tmp_' + sGTmpName +
                        ' (arc_id, ArcName, TblName, doc_id, disp_name, doc_loc, ext_loc, ori_loc, ' //04.07.2011 b.takacs 3.5.1.25 ori_loc hinzugefgt
                        + 'usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf, gdoc_id, optionen) Select '  //06.09.2010 b.takacs [2717]
                        + sTmpArcID + ' as Arc_ID,' + #39 + sTmpArcName +
                        #39 + ' as ArcName,' + #39 + sTmpTblName + #39 +
                        ' as TblName,' +
                        'doc_id, disp_name, doc_loc, ext_loc, ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf, gdoc_id, optionen from arc_' //06.09.2010 b.takacs [2717] //04.07.2011 b.takacs 3.5.1.25 ori_loc hinzugefgt 
                        + sTmpTblName + ' as arc where doc_id = ' + sTmpDocID + '  on duplicate key update ' +
                        ' tmp_' + sGTmpName + '.doc_id = arc.doc_id ';
                     try
                        my_cmd.Execute;
                     except
                        on e: Exception do
                           ErrorMsg('SeaLink',
                              'Fehler beim Kopieren von Dokumenten in die Temptabelle: '
                              + e.Message, 1002, True);
                     end;
                     //lirefcount := lirefcount + dm_db.my_cmd.rowsaffected;
                     my_q_Tmp.Next;
                  end;
               end;
            end;
            //check for ref_lnk = 0
            if liref0rec <> 0 then
            begin
               nog_SqlText := 'select * from sys_doclnk where ref_Name like ' +
                  #39 + Ref_Name + #39 + ' and ref_lnk = 0';
               if frm_MainForm.LnkSQL(nog_sqlText) then
               begin
                  if my_q_Lnk.RecordCount > 0 then
                  begin
                     iCountTo := my_q_Lnk.RecordCount;
                     // get the ref_lnk for all verknpfungen which doenst have ref_lnk = 0;
                     for iCount := 0 to (iCountTo - 1) do
                     begin
                        lstrsqlr := 'select sys_doclnk.arc_id, Arc_Name, arc_tblname, doc_id,sys_arcxs.arc_id' +
                           ', sys_arcxs.usr_id from sys_doclnk left join sys_arcxs Using(arc_id) ' +
                           ' left join sys_arc Using(arc_id)' + ' where ref_id = ' + IntToStr(my_q_Lnk.FieldByName('ref_id').AsInteger) +
                           ' and sys_arcxs.arc_id = sys_doclnk.arc_id and ' + ' (FIND_IN_SET(' + #39 + 'read' +
                           #39 + ',sys_arcxs.rights) and sys_arcxs.usr_id=' + IntToStr(iGUsrID) + ') group by ref_id';

                        my_q_Lnk.Next;
                        if frm_MainForm.TmpSQL(lstrsqlr) then
                        begin
                           if my_q_Tmp.recordcount = 0 then
                           begin
                              continue;
                           end;
                           while not my_q_Tmp.EOF do
                           begin
                              sTmpDocID :=
                                 IntToStr(my_q_Tmp.FieldByName('doc_id').AsInteger);
                              sTmpArcID :=
                                 IntToStr(my_q_Tmp.FieldByName('arc_id').AsInteger);
                              sTmpArcName :=
                                 my_q_Tmp.FieldByName('arc_name').AsString;
                              sTmpTblName :=
                                 my_q_Tmp.FieldByName('arc_tblname').AsString;

                              if sTmpTblName = '' then
                              begin
                                 my_q_Tmp.Next;
                                 continue;
                              end;
                              my_cmd.SQL.Text :=
                                 'Insert into tmp_' + sGTmpName +
                                 ' (arc_id, ArcName, TblName, doc_id, disp_name, doc_loc, ext_loc, ori_loc, ' //04.07.2011 b.takacs 3.5.1.25 ori_loc hinzugefgt
                                 + 'usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf) Select '
                                 + sTmpArcID + ' as Arc_ID,' + #39 +
                                 sTmpArcName + #39 + ' as ArcName,' + #39 + sTmpTblName +
                                 #39 + ' as TblName,' +
                                 'doc_id, disp_name, doc_loc, ext_loc, ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf from arc_' //04.07.2011 b.takacs 3.5.1.25 ori_loc hinzugefgt 
                                 + sTmpTblName +
                                 ' as arc where doc_id = ' + sTmpDocID + '  on duplicate key update ' +
                                 ' tmp_' + sGTmpName + '.doc_id = arc.doc_id ';
                              try
                                 my_cmd.Execute;
                              except
                                 on e: Exception do
                                    ErrorMsg('SeaLink',
                                       _('Fehler beim Kopieren von Dokumenten in die Temptabelle:')
                                       +
                                       e.Message, 1002, True);
                              end;
                              //lirefcount := lirefcount + dm_db.my_cmd.rowsaffected;
                              my_q_Tmp.Next;
                           end;
                        end;
                     end;
                  end;
               end;
            end;
         end
         else // if my_q_Lnk.RecordCount > 0
         begin
            Result := false;
            dm_DB.my_q_Lnk.Close;
            exit;
         end;
      end;
   end;
   iGArcRecNo := -1;
   iGBorderRem := 1;

   bmultiarcquery := true;
   frm_MainForm.DelZusFields2(true);
   frm_MainForm.CreateStandardColumnsTrefferliste;
   frm_MainForm.QueryArc('Select Sql_No_cache * from tmp_' + sGTmpName + ' group by arc_id, doc_id order by tstamp desc');
   dm_MainForm2.mnu_TGoToArc.Visible := True;
   dm_DB.my_q_Lnk.Close;

end;

function Tfrm_DocLink.AutoLinkDoc: boolean;
   ///////////////////////////////////////////////////////////////////
   ///   10.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Function verknpft das aktuelle Dokument mit der    ///
   ///   aktuellen Auto-Referenz                                   ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
begin
   Result := True;
   if ((sGRefName = '')) then
   begin
      Result := False;
      Exit;
   end;
   if frm_MainForm.TmpSQL('select * from sys_doclnk where  ref_name like ' +
      #39 + sGRefName + #39) then
   begin
      if dm_DB.my_q_Tmp.RecordCount = 0 then
         exit
      else
         iGRefLNK := dm_DB.my_q_Tmp.FieldByName('ref_lnk').AsInteger;
   end;
   // check ref_lnk
   if frm_MainForm.TmpSQL('select * from sys_doclnk where arc_id = ' +
      IntToStr(iGArcID) + ' and doc_id = ' + IntToStr(iGDocID) +
      ' and ref_lnk = ' + IntToStr(iGRefLNK) + ' order by ref_lnk desc') then
   begin
      if dm_DB.my_q_Tmp.RecordCount > 0 then
      begin
         ShowMessage(_('Hinweis!') + #13 +
            _('Dieses Dokument ist bereits mit der aktuellen Referenz verknpft.'));
         //  dm_DB.my_q_Tmp.Close;
         exit;
      end;

      try
         with dm_DB.my_cmd do
         begin
            SQL.Text :=
               'insert into sys_doclnk (arc_id, doc_id, usr_id, ref_Name, Ref_lnk) ' +
               'Values (' + IntToStr(iGArcID) + ', ' + IntToStr(iGDocID) +
               ', ' + IntToStr(iGUsrID) + ', ' + #39 + sGRefName +
               #39 + ', ' + IntToStr(iGRefLNK) + ')';
            Execute;
            frm_MainForm.NewHistory(10, Format(_('Dokument mit Referenz %s verknpft'),[sGRefName]));
            frm_mainform.setpanelinfo( Format(
               _('Aktuelles Dokument mit Referenz %s verknpft.'),[sGRefName]));
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('AutoLinkDoc',
               _('Fehler beim Anlegen einer neuen Verknpfung:') + e.Message, 2012,
               True);
            Result := False;
         end;
      end;

      if result then
      begin
         frm_MainForm.tci_DocLink.Color := clYellow;
         GetLinks;
//         if frm_MainForm.pnlDocLinkList.Visible = True then
//            frm_MainForm.FillActDocLinkList;
      end;
   end
   else
      ErrorMsg('AutoLinkDoc', _('Fehler beim Abfragen der Verknpfungen.'), 2011,
         True);
end;

function Tfrm_DocLink.AddDocToRef: boolean;
var
   nog_SqlText: string;
   // Dokument zur
   ///////////////////////////////////////////////////////////////////
   ///   27.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Function verknpft ein gemerktes Dokument mit dem   ///
   ///   aktuellen Dokument                                         ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
begin
   Result := True;
   logevnt('Adding new Link ' + sGRefName);
   if (iGRArcID = -1) or (iGRDocID = -1) then
      exit;
   sGRefName := trim(ParseSemicolonWithoutBackslash(sGRefName));
   // check if verknfung already exists  with thi single Viewer.Document.
   nog_SqlText := 'select * from sys_doclnk where arc_id = ' +
      IntToStr(iGRArcID) + ' and doc_id = ' + IntToStr(iGRDocID) +
      ' and ref_Name = ' + #39 + sGRefName + #39 + ' order by ref_lnk desc';

   if frm_MainForm.TmpSQL(nog_SqlText) then
   begin
      if dm_DB.my_q_Tmp.RecordCount > 0 then
      begin
         //ShowMessage('Hinweis!' + #13 + 'Das gemerkte Dokument ist bereits mit dieser Referenz verknpft.');
         // dm_DB.my_q_Tmp.Close;
         exit;
      end;
      // check the ref_lnk verknfung
      nog_SqlText := 'select ref_lnk from sys_doclnk where' +
         ' ref_Name = ' + #39 + sGRefName + #39 + ' order by ref_lnk';
      if not frm_MainForm.TmpSQL(nog_SqlText) then
      begin
         // connection problem?
         exit;
      end;
      try
         if dm_DB.my_q_Tmp.RecordCount = 0 then
         begin
            exit;
         end;

         with dm_DB.my_cmd do
         begin
            SQL.Text :=
               'insert into sys_doclnk (arc_id, doc_id, usr_id, ref_Name, Ref_lnk) ' +
               'Values (' + IntToStr(iGRArcID) + ', ' + IntToStr(iGRDocID) +
               ', ' + IntToStr(iGUsrID) + ', ' + #39 + sGRefName +
               #39 + ', ' + dm_DB.my_q_Tmp.FieldByName('ref_lnk').AsString + ' )';
            Execute;

            if sIArcName= '' then 
            	sIArcName:= GSysArc[iGArcID].TblName;
            SQL.Text := 'Insert into slw_' + siArcName +
               ' (doc_id, doc_slw) Values (' + IntToStr(iGRDocID) +
               ', ' + #39 + sGRefName + #39 + ')';
            Execute;
            frm_mainform.setpanelinfo(
               Format(_('Gemerktes Dokument mit Referenz %s verknpft.'),[sGRefName]));
         end;
         iGRArcID := -1;
         iGRDocID := -1;
      except
         on e: Exception do
         begin
            ErrorMsg('AddDocToRef',
               _('Fehler beim Anlegen einer neuen Verknpfung:') + e.Message, 2012,
               True);
            Result := False;
         end;
      end;
   end
   else
      ErrorMsg('AddDocToRef', _('Fehler beim Abfragen der Verknpfungen.'), 2011,
         True);
end;

function Tfrm_DocLink.CreAutoLink: boolean;
   ///////////////////////////////////////////////////////////////////
   ///   10.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Function erzeugt in der Tabelle sys_doclnk eine     ///
   ///   neue Auto-Referenz und setzt die Globalen Variablen       ///
   ///   iGRefID und sGRefName.                                    ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
var
   sTmpDatum: string;
   iTmpArcID, licounter, iTmpDocID: integer;
begin
   Result := True;
   iTmpDocID := 0;
   iTmpArcID := 0;
   DateTimeToString(sTmpDatum, 'dd.mm.yy hh:mm:ss', now);
   sGRefName := 'AutoRef ' + sTmpDatum + '-' + IntToStr(iGUsrID);
// f.schneider 3.5.1.48 wir nehmen das lowercase raus
//   edt_Link.Text := trim(ParseSemicolonWithoutBackslash(lowercase(sGRefName)));

   edt_Link.Text := trim(ParseSemicolonWithoutBackslash(sGRefName));
   try
      with dm_DB.my_cmd do
      begin
         with frm_MainForm.dbgrd_Trefferliste do
         begin
            // ArcID vom gemerkten Dokument sichern
            iTmpDocID := iGDocID;
            // important for searchin from different arch (lager)
            iTmpArcID := iGArcID;
            // get (save) the name for the slw
            
            for licounter := 0 to SelectedRows.Count - 1 do
            begin
               dm_DB.my_q_Arc.GotoBookmark(Pointer(SelectedRows.Items[licounter]));

               iGRDocID := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
               if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
               begin
                  iGArcID := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
               end;
               SQL.Text :=
                  'insert into sys_doclnk (arc_id, doc_id, usr_id, ref_Name, Ref_lnk) ' +
                  'Values (' + IntToStr(iGArcID) + ', ' + IntToStr(iGDocID) +
                  ', ' + IntToStr(iGUsrID) + ', ' + #39 + sGRefName + #39 + ', 0)';
               Execute;
               iGRefID := InsertId;
               SQL.Text := 'Update sys_doclnk set ref_lnk = ' + IntToStr(iGRefID) +
                  ' where ref_id = ' + IntToStr(iGRefID);
               Execute;
               iGDocID := iGRDocID;
               // get the reflnk from the db!
               frm_MainForm.TmpSQL('select ref_lnk from sys_doclnk where ref_id = ' +
                  IntToStr(iGRefID));
               IGRefLNK := dm_DB.my_q_tmp.FieldByName('ref_lnk').AsInteger;

               frm_MainForm.NewHistory(10, Format(_('Dokument mit Referenz %s verknpft'),[edt_Link.Text]));
               iGDocID := itmpDocID;
               //sIarcname will be set by newhistory
               SQL.Text := 'Insert into slw_' + sIArcName +
                  ' (doc_id, doc_slw) Values (' + IntToStr(iGRDocID) +
                  ', ' + #39 + edt_Link.Text + #39 + ')';
               Execute;

               frm_mainform.setpanelinfo(Format(
                  _('Aktuelles Dokument mit Referenz %s verknpft.'),[edt_Link.Text]));
            end;
         end;
      end;
   except
      on e: Exception do
      begin
         ErrorMsg('CreAutoLink', _('Fehler beim Anlegen einer neuen Verknpfung:') +
            e.Message, 2012, True);
         Result := False;
         iGRefID := -1;
         createnewlink := False;
         iGArcID := iTmpArcID;
         iGDocID := itmpDocID;

         // RefArcID und RefDocID wiederherstellen
         iGRDocID := iTmpDocID;
      end;
   end;
   frm_MainForm.tci_DocLink.color := clyellow;
   iGArcID := iTmpArcID;
   iGDocID := itmpDocID;
   // RefArcID und RefDocID wiederherstellen
   iGRDocID := iTmpDocID;
   

   createnewlink := True;
   frm_Mainform.lbl_choosenlink.Caption := edt_Link.Text;
   frm_mainform.lbl_choosenLink.Visible := True;
   frm_mainform.img_link.Visible := True;
   GetLinks;
//   if frm_MainForm.pnlDocLinkList.Visible = True then
//      frm_MainForm.FillActDocLinkList;
end;

function Tfrm_DocLink.CreLink(AsLnkName:string): boolean;
   ///////////////////////////////////////////////////////////////////
   ///   04.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Function erzeugt in der Tabelle sys_doclnk eine     ///
   ///   neue Referenz und Ruft GetLinks auf um die Referenzen     ///
   ///   neu einzulesen.                                           ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///   m.frey: ergnzt mit Parameter AsLnkName.
   ///   Wenn leer, dann wie bisher.
   ///   Wenn angegeben, dann wird das als Name benutzt und keine Nachfragen mehr.
   ///                                                         
   ///////////////////////////////////////////////////////////////////
var
   sLnkName: string;
   ilRefLNK: integer;
   iTmpArcID, iTmpDocID, licounter: integer;
   lb:Boolean;
begin
   createnewlink := False;
   Result := True;
   sLnkName := trim(edt_Link.Text);
   if frm_MainForm.dbgrd_Trefferliste.SelectedRows.Count = 0 then
   begin
      BfShowMessage(_('Bitte whlen Sie ein Dokument aus und\nwiederholen Sie den Vorgang.'));
      exit;
   end;

   if AsLnkName='' then
      lb:=InputQuery(_('Neue Verknpfung anlegen...'),
         _('Bitte geben Sie eine Bezeichnung fr die ') + #13 + _('neue Verknpfung ein:'),
         sLnkName)
   else
   begin
      sLnkName:=AsLnkName;
      lb:=true;
   end;

   if lb then
   begin
      sGRefName := trim(ParseSemicolonWithoutBackslash(sLnkName));
      // f.schneider 3.5.1.48 wir nehmen das lowercase raus
      // edt_Link.Text := trim(ParseSemicolonWithoutBackslash(lowercase(sGRefName)));
      edt_Link.Text := sGRefName;

      if (sGRefName = '') then
      begin
         exit;
      end;
      try
         // get ref_lnk
         if frm_MainForm.TmpSQL(
            'select ref_lnk, ref_name from sys_doclnk where ref_name like ' +
            #39 + sGRefName + #39) then
         begin
            if dm_DB.my_q_Tmp.RecordCount > 0 then
            begin
               lb:=true;
               if AsLnkName=''then
                  lb:=BfMessageDlg(
                     _('Es existiert bereits eine Verkpfung mit diesem Namen.') + #13 +
                     _('Soll das Dokument mit dieser verknpft werden?'),
                     mtConfirmation, [mbYes, mbNo], 0) = mrYes;
               if lb then
               begin
                  // get the ref_lnk!
                  iGRefLNK := dm_DB.my_q_Tmp.FieldByName('ref_lnk').AsInteger;
                  sGRefName := dm_DB.my_q_Tmp.FieldByName('ref_name').AsString;
                  // ArcID vom gemerkten Dokument sichern
                  iTmpDocID := iGDocID;
                  // important for searchin from different arch (lager)
                  iTmpArcID := iGArcID;
                  iGRArcID := iGArcID; // RefArcID auf aktuelle ArcID setzen
                  // get (save) the name for the slw
                  
                  with frm_MainForm.dbgrd_Trefferliste do
                  begin
                     for licounter := 0 to SelectedRows.Count - 1 do
                     begin
                        dm_DB.my_q_Arc.GotoBookmark(Pointer(SelectedRows.Items[licounter]));

                        iGRDocID := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                        iGDocID :=  dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                        if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil)
                        then
                        begin
                           iGArcID := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                        end;
                        iGRArcID := iGArcID;
                        // DocID vom gemerkten Dokument sichern
                        if sIArcName = '' then
                        	sIArcName:=  dm_DB.my_q_Arc.FieldByName('TblName').AsString;
                        AddDocToRef; // Dokument zur Referenz hinzufgen
                        // set the history
                        frm_MainForm.NewHistory(4, Format(_('Schlagwort und Verknpfung %s angelegt.'),[edt_Link.Text]));
                     end;
                  end;
                  //we have now a link, so if isnt yellow set it now!
                  frm_MainForm.tci_DocLink.color := clyellow;
                  iGRArcID := iTmpArcID;
                  iGArcID := iTmpArcID;
                  iGDocID := itmpDocID;
                  // RefArcID und RefDocID wiederherstellen
                  iGRDocID := iTmpDocID;
                  frm_Mainform.lbl_choosenlink.Caption := edt_Link.Text;
                  frm_mainform.lbl_choosenLink.Visible := True;
                  frm_mainform.img_link.Visible := True;
                  exit;
               end
               else
               begin
                  exit;

               end;
            end
            else
            begin
               with dm_DB.my_cmd do
               begin
                  with frm_MainForm.dbgrd_Trefferliste do
                  begin
                     // ArcID vom gemerkten Dokument sichern
                     iTmpDocID := iGDocID;
                     // important for searchin from different arch (lager)
                     iTmpArcID := iGArcID;
                     iGRArcID := iGArcID; // RefArcID auf aktuelle ArcID setzen

                     
                     if SelectedRows.Count > 0 then
                     begin
                        dm_DB.my_q_Arc.GotoBookmark(Pointer(SelectedRows.Items[0]));
                        iGRDocID := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                        if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil)
                        then
                        begin
                           iGRArcID := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                           iGArcID :=  dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                        end;

                        SQL.Text :=
                           'Insert into sys_doclnk (arc_id, doc_id, usr_id, ref_name, ref_lnk) Values ('
                           + IntToStr(iGArcID) + ', ' + IntToStr(iGRDocID) +
                           ', ' + IntToStr(iGUsrID) + ', ' + #39 + edt_Link.Text + #39 + ', 0)';
                        Execute;
                        ilRefLNK := InsertId;
                        SQL.Text := 'Update sys_doclnk Set Ref_lnk = ' +
                           IntToStr(ilRefLNK) + ' where ref_id = ' + IntToStr(InsertId);
                        Execute;
                        iGDocID := iGRDocID;
                        frm_MainForm.NewHistory(4, Format(_('Schlagwort und Verknpfung %s angelegt.'),[edt_Link.Text]));

                        iGDocID := itmpDocID;
                        SQL.Text := 'Insert into slw_' + sIArcName +
                           ' (doc_id, doc_slw) Values (' + IntToStr(iGRDocID) +
                           ', ' + #39 + edt_Link.Text + #39 + ')';
                        Execute;
                        for licounter := 1 to SelectedRows.Count - 1 do
                        begin
                           dm_DB.my_q_Arc.GotoBookmark(Pointer(SelectedRows.Items[licounter]));

                           iGRDocID := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                           if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil)then
                           begin
                              iGRArcID := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                              iGArcID := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                           end;

                           SQL.Text :=
                              'Insert into sys_doclnk (arc_id, doc_id, usr_id, ref_name, ref_lnk) Values ('
                              + IntToStr(iGArcID) + ', ' + IntToStr(iGRDocID) +
                              ', ' + IntToStr(iGUsrID) + ', ' + #39 + edt_Link.Text + #39 + ', 0)';
                           Execute;
                           SQL.Text := 'Update sys_doclnk Set Ref_lnk = ' +
                              IntToStr(ilRefLNK) + ' where ref_id = ' + IntToStr(InsertId);
                           Execute;
                           iGDocID := iGRDocID;
                           frm_MainForm.NewHistory(4, Format(_('Schlagwort und Verknpfung %s angelegt.'),[edt_Link.Text]));

                           iGDocID := itmpDocID;
                           SQL.Text := 'Insert into slw_' + sIArcName +
                              ' (doc_id, doc_slw) Values (' + IntToStr(iGRDocID) +
                              ', ' + #39 + edt_Link.Text + #39 + ')';
                           Execute;
                        end;
                     end;
                  end;
                  frm_MainForm.tci_DocLink.color := clyellow;
                  iGArcID := iTmpArcID;
                  iGRArcID := iTmpArcID;
                  iGDocID := itmpDocID;
                  // RefArcID und RefDocID wiederherstellen
                  iGRDocID := iTmpDocID;

                  createnewlink := True;
               end;
            end;
         end
         else
         begin
            ShowMessage(_('Fehler bei der Abfrage der Datenbank!'));
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('CreLink', _('Fehler beim Anlegen einer neuen Verknpfung:') +
               e.Message, 2012, True);
            Result := False;
            createnewlink := False;
         end;
      end;
      frm_Mainform.lbl_choosenlink.Caption := edt_Link.Text;
      frm_mainform.lbl_choosenLink.Visible := True;
      frm_mainform.img_link.Visible := True;
      GetLinks;
//      if frm_MainForm.pnlDocLinkList.Visible = True then
//         frm_MainForm.FillActDocLinkList;

   end
   else
   begin
      Result := False;
      createnewlink := False;
   end;
end;

function Tfrm_DocLink.DelLink(onlythisref: boolean): boolean;
   ///////////////////////////////////////////////////////////////////
   ///   04.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Procedure entfernt aus der Tabelle sys_doclnk eine  ///
   ///   Referenz und Ruft GetLinks auf um die Referenzen neu      ///
   ///   einzulesen.                                               ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
var
   slref, lsarcname, lsVerknName: string;
   lidocid, liarcid: integer;
   DlgForm: TForm;
   mdresult: TModalResult;
begin
   if dm_DB.my_q_Lnk.RecordCount = 0 then
      Exit;

   Result := True;
   lsVerknName:=edt_Link.Text;
   if lsVerknName = '' then
      exit;
   DlgForm := CreateMessageDialog(Format(_('Sind Sie sicher, dass Sie die Verknpfung %s wirklich lschen mchten?'),[lsVerknName]), mtConfirmation, [mbNo, mbYes]);
   DlgForm.ActiveControl := TButton(DlgForm.FindComponent('No'));
   mdresult := DlgForm.ShowModal;
   DlgForm.Release;

   if mdresult = mrYes then
   begin
      try
         // check for  iGRefLNK = 0 else all lnk with iGRefLNK = 0 will be deleted!

         if onlythisref then
         begin
            if iGRefLNK = 0 then
            begin
               slref := '';
            end
            else
            begin
               //todo, check what this do!!!!
               //            slref := ' or ref_lnk = ' + IntToStr(iGRefLNK);
            end;
            slref := ' ref_id = ' + IntToStr(iGRefID) + slref;
         end
         else
         begin
            slref := ' ref_name = ' + #39 + trim(lsVerknName) + #39;
         end;
         dm_DB.my_q_tmp_2.SQL.Text := 'select * from sys_doclnk where ' + slref;
         dm_DB.my_q_tmp_2.Execute;

         while not dm_DB.my_q_tmp_2.EOF do
         begin
            frm_MainForm.NewHistory(6, Format(_('Verknpfung %s gelscht'),[lsVerknName]));
            dm_DB.my_q_tmp_2.Next;
         end;

         // will be already done above in the while loop
         //      frm_MainForm.NewHistory(6, 'Verknpfung ' + lsVerknName + ' gelscht');
         dm_DB.my_cmd.SQL.Text :=
            'delete from sys_doclnk where ' + slref;
         dm_DB.my_cmd.Execute;
         if not onlythisref then
         begin
            if sgrefname = trim(lsVerknName) then
            begin
               sgrefname := '';
            end;
            lsVerknName := '';
         end;
         dbgrd_Links.datasource.dataset.refresh;
      except
         on e: Exception do
         begin
            ErrorMsg('DelLink', _('Fehler beim Lschen einer Verknpfung:') +
               e.Message, 2013, True);
            Result := False;
         end;
      end;
      GetLinks;
      GetQuickLinks;
   end;
end;

function Tfrm_DocLink.DeloneDocLink(lsVerknName: string): boolean;
   ///////////////////////////////////////////////////////////////////
   ///   070515 erstellt von N.Gering                              ///
   ///                                                             ///
   ///   Diese Procedure entfernt aus der Tabelle sys_doclnk eine  ///
   ///   Verknuepfung zu einem Dokument und Ruft GetLinks auf um   //
   //    die Referenzen neu                                        ///
   ///   einzulesen.                                               ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
begin
   Result := True;
   lsVerknName:=edt_Link.Text;
   if (dm_DB.my_q_Lnk.RecordCount = 0) or (lsVerknName = '') then
      Exit;

   if BfMessageDlg(Format(_('Sind Sie sicher, dass Sie das Dokument aus der Verknpfung %s entfernen mchten?'),[lsVerknName]), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      try
			//dm_DB.my_cmd.SQL.Text := 'delete from sys_doclnk where ref_ID = ' + IntToStr(iGRefID);
         dm_DB.my_cmd.SQL.Text := 'delete from sys_doclnk where arc_id = ' + IntToStr(iGArcID) +
                           ' and doc_id = '  + IntToStr(iGDocID) +
                           ' and ref_name = ' + #39 + lsVerknName + #39;
         dm_DB.my_cmd.Execute;

      except
         on e: Exception do
         begin
            ErrorMsg('DelLink',  _('Fehler beim Entfernen eines Dokumentes aus einer Verknpfung:') +
               e.Message, 2013, True);
            Result := False;
            Exit;
         end;
      end;

      frm_MainForm.NewHistory(6, Format(_('Dokument aus Verknpfung %s entfernt'),[lsVerknName]));
      dbgrd_Links.datasource.dataset.refresh;
      GetLinks;       // use getlinks so doc will not disappear from trefferliste
      GetQuickLinks;  // use GetQuickLinks to change color of tci_DocLink and change pum_links
      
   end;
end;

function Tfrm_DocLink.RenLink: boolean;
   ///////////////////////////////////////////////////////////////////
   ///   04.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Procedure benennt in der Tabelle sys_doclnk eine    ///
   ///   Referenz um und Ruft GetLinks auf um die Referenzen neu   ///
   ///   einzulesen.                                               ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
var
   sLnkName, sOldName: string;
begin
   Result := True;
   sLnkName := edt_Link.Text;
   sOldName := sLnkName;
   if InputQuery(_('Verknpfung umbenennen...'),
      _('Bitte geben Sie eine neue Bezeichnung fr') + #13 + _('die Verknpfung ein:'),
      sLnkName) then
   begin
      edt_Link.Text := sLnkName;
      try
         dm_DB.my_cmd.SQL.Text :=
            'update sys_doclnk set ref_name = ' + #39 + edt_Link.Text +
            #39 + ' where ref_id = ' + IntToStr(iGRefID) + ' or ref_lnk = ' +
            IntToStr(iGRefLNK);
         dm_DB.my_cmd.Execute;
         frm_MainForm.NewHistory(5, Format( _('Verknpfung %s in %s umbenannt'),[sOldName, edt_Link.Text ]));
      except
         on e: Exception do
         begin
            ErrorMsg('RenLink', _('Fehler beim Umbenennen einer Verknpfung:') +
               e.Message, 2014, True);
            Result := False;
         end;
      end;
      GetLinks;
   end;
end;

function Tfrm_DocLink.ImpLink: boolean;
   ///////////////////////////////////////////////////////////////////
   ///   04.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Procedure Importiert aus dem aktuellen Dokument     ///
   ///   die Schlagworte als Referenz und Ruft LnkCreate auf       ///
   ///   um eine neue Referenz zu erzeugen                         ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
begin
   Result := True;
   with frm_MainForm do
   begin
      if TmpSQL('select * from slw_' + sIArcName + ' where doc_id = ' +
         IntToStr(iGDocID)) then
      begin
         try
            edt_Link.Text := '';
            with dm_DB.my_q_Tmp do
            begin
               while not EOF do
               begin
                  edt_Link.Text :=
                     edt_Link.Text + FieldByName('doc_slw').AsString + ' ';
                  Next;
               end;
               Close;
            end;
         except
            on e: Exception do
            begin
               Result := False;
               ErrorMsg('ImpLink', _('Fehler beim Importieren von Schlagworten:') +
                  e.Message, 2020, True);
            end;
         end;
      end
      else
      begin
         Result := False;
         ErrorMsg('ImpLink', _('Fehler beim Auslesen der Schlagworte'),
            2024,
            True);
      end;
   end;
   btn_LnkCreClick(self);
end;

function Tfrm_DocLink.SelLink: boolean;
   ///////////////////////////////////////////////////////////////////
   ///   04.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Function selektiert eine Referenz aus der Ver-      ///
   ///   knpfungsliste und setzt die Variablen iGRefID und        ///
   ///   sGRefName.                                                ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
var
	lsRefName :string;
begin
   Result := True;
   If dm_DB.my_q_Lnk.RecordCount = 0 then
      Exit;

   try
      with dm_DB.my_q_Lnk do
      begin
         (*if FieldByName('ref_lnk').AsInteger = 0 then
            iGRefID := FieldByName('ref_id').AsInteger
         else
         begin  *)
            //iGRefLNK := FieldByName('ref_lnk').AsInteger;
            //iGRefID := FieldByName('ref_id').AsInteger;
            edt_Link.Text := FieldByName('ref_name').AsString;
            sGRefName := FieldByName('ref_name').AsString;
            frm_mainform.lbl_ChoosenLink.Caption := sGRefName;

            frm_Mainform.lbl_ChoosenLink.Visible := True;
            frm_Mainform.img_link.Visible := True;

            dm_MainForm2.mnu_LinkDocRef.Clear;
            lsRefName := frm_Mainform.lbl_choosenlink.Caption;
            if Pos('&', lsRefName) > 0 then
               lsRefName := StringReplace(lsRefName,'&','&&',[rfReplaceAll]);

            dm_MainForm2.mnu_LinkDocRef.Add(
               newItem(lsRefName, 0, False, True,
               dm_MainForm2.LinkDocWithRef, 0, 'pum_Ref' + IntToStr(0)));
            dm_MainForm2.mnu_LinkDocRef.Items[0].Tag := 0;
         //end;
      end;
   except
      on e: Exception do
      begin
         ErrorMsg('ImpLink', _('Fehler beim Selektieren einer Verknpfung:') +
            e.Message, 2021, True);
         Result := False;
      end;
   end;
   frm_MainForm.ActivateLinkDoc(Result);
   //GetLinkedDocs;
end;

function Tfrm_DocLink.GetDocs: boolean;
var
   sTmpDocID, sTmpArcID, sTmpArcName, sTmpTblName, lsRefName: string;
   iTmpGDocID: integer;
begin
   // check the rights!

    if frm_MainForm.TmpSQL(
    'select sys_doclnk.arc_id, Arc_Name, arc_tblname, doc_id, sys_arcxs.arc_id, ' +
    ' sys_arcxs.usr_id ' +
    ' from sys_doclnk left join sys_arc Using(arc_id) left join sys_arcxs Using(arc_id) ' +
    ' where ref_name like ' + #39 + sGRefName + #39 +
    ' and sys_arcxs.arc_id = sys_doclnk.arc_id and ' + ' (FIND_IN_SET(' +
    #39 + 'read' + #39 + ',sys_arcxs.rights) and sys_arcxs.usr_id=' +
    IntToStr(iGUsrID) + ' ) group by ref_id order by ref_id desc') then
    begin
       Result := True;
       with dm_DB do
       begin

           DbCreateTempTable(sGTmpName);

          while not my_q_Tmp.EOF do
          begin
             sTmpDocID := IntToStr(my_q_Tmp.FieldByName('doc_id').AsInteger);
             sTmpArcID := IntToStr(my_q_Tmp.FieldByName('arc_id').AsInteger);
             // 06.09.2010 b.takacs [2717]
             iTmpGDocID:= dm_DB.GetGDocIDByArcIDandDocID(StrToInt(sTmpArcID),StrToInt(sTmpDocID));
             sTmpArcName := my_q_Tmp.FieldByName('arc_name').AsString;
             sTmpTblName := my_q_Tmp.FieldByName('arc_tblname').AsString;
             my_cmd.SQL.Text := 'Insert into tmp_' + sGTmpName +
                ' (arc_id, ArcName, TblName, doc_id, disp_name, doc_loc, ext_loc, ori_loc,' +
                'usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf, gdoc_id, optionen) Select ' +   // 06.09.2010 b.takacs [2717]
                sTmpArcID + ' as Arc_ID,' + #39 + sTmpArcName + #39 +
                ' as ArcName,' + #39 + sTmpTblName + #39 + ' as TblName,' +
                'doc_id, disp_name, doc_loc, ext_loc, ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf, ' + IntToStr(iTmpGDocID) + ', optionen from arc_'   // 06.09.2010 b.takacs [2717]
                + sTmpTblName + ' as arc where doc_id = ' + sTmpDocID + '  on duplicate key update ' +
                ' tmp_' + sGTmpName + '.doc_id = arc.doc_id ';
             try
                my_cmd.Execute;
             except
                on e: Exception do
                   ErrorMsg('GetDocs',
                      _('Fehler beim Kopieren von Dokumenten in die Temptabelle:') +
                      e.Message, 1002, True);
             end;
             my_q_Tmp.Next;
          end;
       end;
       iGArcRecNo := -1;
       iGBorderRem := 1;
       bmultiarcquery := true;
       frm_MainForm.DelZusFields2(true);
       frm_MainForm.CreateStandardColumnsTrefferliste;

       frm_MainForm.QueryArc('Select Sql_No_cache * from tmp_' + sGTmpName + ' order by tstamp desc');

       frm_mainform.lbl_choosenLink.Caption := sGRefName;
       edt_Link.Text := sGRefName;
       // Grafische Anzeige der Gruppe als linkMaenge ausschalten
       frm_mainform.img_link.Visible := True;
       frm_mainform.lbl_choosenLink.Hint := '';
       frm_mainform.lbl_choosenLink.Visible := True;

       dm_MainForm2.mnu_LinkDocRef.Clear;
       if frm_Mainform.lbl_choosenlink.Caption <> '' then
       begin
       	lsRefName := frm_Mainform.lbl_choosenlink.Caption;
         if Pos('&', lsRefName) > 0 then
            lsRefName := StringReplace(lsRefName,'&','&&',[rfReplaceAll]);

          dm_MainForm2.mnu_LinkDocRef.Add(newItem(lsRefName, 0, False, True,
          	dm_MainForm2.LinkDocWithRef, 0, 'pum_Ref' + IntToStr(0)));
          dm_MainForm2.mnu_LinkDocRef.Items[0].Tag := 0;
       end;

       bMultiArcQuery := True;
       dm_MainForm2.mnu_TGoToArc.Visible := True;
       // reset wvl list if called a new query arc request
       frm_mainform.dbgrd_wvl.hide;
       wvlhasfocus := False;
       frm_mainform.wvlshowbuttons(false);
       frm_mainform.dbgrd_wvl.Show;
       frm_MainForm.ActivateLinkDoc(True);
    end
    else
    	Result := False;

end;

procedure Tfrm_DocLink.btn_LnkCreClick(Sender: TObject);
begin
   frm_MainForm.ActivateLinkDoc(CreLink(''));
end;

procedure Tfrm_DocLink.btn_LnkDelClick(Sender: TObject);
begin
   DelLink(False);
//   if frm_MainForm.pnlDocLinkList.Visible then
//   	frm_MainForm.FillActDocLinkList;
end;

procedure Tfrm_DocLink.btn_LnkRenClick(Sender: TObject);
begin
   RenLink;
end;

procedure Tfrm_DocLink.btn_LnkImpClick(Sender: TObject);
begin
   ImpLink;
end;

procedure Tfrm_DocLink.dbgrd_LinksCellClick(Column: TColumn);
begin
  if fbSelLink then
  	Exit;

  fbSelLink := True;
  try
	  SelLink;
  finally
  	fbSelLink := False;
  end;

end;

procedure Tfrm_DocLink.btn_ShowLnkClick(Sender: TObject);
begin
   if  dm_DB.my_q_Lnk.RecordCount > 0 then
   begin
	   sGRefName := dm_DB.my_q_Lnk.FieldByName('ref_name').AsString;
   	GetDocs;
		frm_MainForm.HandleDoc;
   end;

end;

procedure Tfrm_DocLink.ButtonDel1LinkClick(Sender: TObject);
begin
   //DelLink(True);
   GgfLogevnt('fra_DocLinkButton1Click');
   DelOneDocLInk(edt_Link.Text);
//   if frm_MainForm.pnlDocLinkList.Visible then
//   	frm_MainForm.FillActDocLinkList;
end;

procedure Tfrm_DocLink.btn_allldoclinksClick(Sender: TObject);
var
   iCount, iCountTo, iTmpRefLNK, iTmpGDocID, arcid: integer;
   sTmpDocID, sTmpArcID, sTmpArcName, sTmpTblName, lsSQL: string;
begin
   // Sucht alle Dokumente aller Verknpfungen des aktuellen Dokuments
   try
     EnableControls(False);
     Screen.Cursor := crHourGlass;

     if dm_DB.my_q_Lnk.RecordCount > 0 then
     begin
        try
            dm_db.my_q_Lnk.First;
            lsSQL := 'select sys_doclnk.arc_id, sys_doclnk.doc_id from sys_doclnk ' +
            'left join sys_arcxs on sys_doclnk.arc_id = sys_arcxs.arc_id and sys_arcxs.usr_id= ' +inttostr(iGUsrID) +
            ' where (ref_Name like ' + #39 +
              dm_db.my_q_Lnk.FieldByName('ref_name').AsString + #39;
            dm_db.my_q_Lnk.Next;
            while not dm_db.my_q_Lnk.EOF do
            begin
              lsSQL := lsSQL + ' or ref_Name like ' + #39 +
                 dm_db.my_q_Lnk.FieldByName('ref_name').AsString + #39;
              dm_db.my_q_Lnk.Next;
            end;
            dm_db.my_q_Lnk.First;
            lsSQL := lsSQL + ') ' +
            ' and  (FIND_IN_SET( ' +#39+ 'read' +#39+',sys_arcxs.rights) and sys_arcxs.usr_id='+inttostr(iGUsrID) +') ' +
            ' group by sys_doclnk.arc_id, sys_doclnk.doc_id ';
            sGRefName := dm_db.my_q_Lnk.FieldByName('ref_name').AsString;
            frm_MainForm.lbl_ChoosenLink.Caption := sGRefName;
            edt_Link.Text := sGRefName;

            if frm_MainForm.TmpSQL_2(lsSQL) then
            begin
              with dm_DB do
              begin
                 if my_q_tmp_2.RecordCount > 0 then
                 begin

                    DbCreateTempTable(sGTmpName);
                    my_q_tmp_2.First;

                    for iCount := 0 to (my_q_tmp_2.RecordCount - 1) do
                    begin
                        arcid := dm_db.my_q_tmp_2.FieldByName('arc_id').AsInteger;
                    		lsSQL :=  'select ' +inttostr(arcid) + ' as arc_id, ' +
                        #39+ GSysArc[arcid].ArcName +#39+  ' as arcname, ' +
                        #39+ GSysArc[arcid].TblName +#39+  ' as tblname, doc_id, disp_name, doc_loc, ext_loc, ori_loc, ' +
                        'usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf, gdoc_id, optionen ' +
								'from arc_' + GSysArc[arcid].TblName + ' ' +
								'where doc_id = ' + dm_db.my_q_tmp_2.FieldByName('doc_id').AsString;
                    		my_cmd.SQL.Text :=
                          'Insert into tmp_' + sGTmpName +
                          ' (arc_id, ArcName, TblName, doc_id, disp_name, doc_loc, ext_loc, ori_loc, ' //04.07.2011 b.takacs 3.5.1.25 ori_loc hinzugefgt
                          + 'usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf, gdoc_id, optionen) ' + lsSQL;
                       try
                          my_cmd.Execute;
                       except
                          on e: Exception do
                             LogEvnt(_('btn_allldoclinksClick: Fehler beim Kopieren von Dokumenten in die Temptabelle:') + e.Message);
                       end;
                       my_q_tmp_2.Next;
                    end;

                 end
                 else
                 begin
                    exit;
                    //dm_DB.my_q_Lnk.Close;  //f.schneider
                 end;
              end;
            end;

        except
          on e: Exception do
          begin
             LogEvnt(_('btn_allldoclinksClick: Fehler beim Kopieren von Dokumenten in die Temptabelle:') + e.Message);
              Exit;
          end;
        end;

       iGArcRecNo := -1;
       iGBorderRem := 1;
       frm_MainForm.DelZusFields2(true);
       bMultiArcQuery := True;
       frm_MainForm.CreateStandardColumnsTrefferliste;

       frm_MainForm.QueryArc('Select Sql_No_cache * from tmp_' + sGTmpName +
          ' group by arc_id,doc_id order by tstamp desc');
       dm_MainForm2.mnu_TGoToArc.Visible := True;
		 frm_MainForm.HandleDoc;
     end;

   finally
   	EnableControls(True);
      Screen.Cursor := crDefault;
   end;

end;

// den scheiss schreib ich jetzt komplett neu
(*
procedure Tfrm_DocLink.btn_allldoclinksClick(Sender: TObject);
var
   iCount, iCountTo, iTmpRefLNK, iTmpGDocID: integer;
   sTmpDocID, sTmpArcID, sTmpArcName, sTmpTblName, nog_sqlText: string;

begin
   // Sucht alle Dokumente aller Verknpfungen des aktuellen Dokuments
   try
     EnableControls(False);
     Screen.Cursor := crHourGlass;

     if dm_DB.my_q_Lnk.RecordCount > 0 then
     begin
        try
            dm_db.my_q_Lnk.First;
            nog_SqlText := 'select ref_lnk from sys_doclnk where ref_Name like ' + #39 +
              dm_db.my_q_Lnk.FieldByName('ref_name').AsString + #39;
            dm_db.my_q_Lnk.Next;
            while not dm_db.my_q_Lnk.EOF do
            begin
              nog_SqlText := nog_SqlText + ' or ref_Name like ' + #39 +
                 dm_db.my_q_Lnk.FieldByName('ref_name').AsString + #39;
              dm_db.my_q_Lnk.Next;
            end;
            dm_db.my_q_Lnk.First;
            sGRefName := dm_db.my_q_Lnk.FieldByName('ref_name').AsString;
            frm_MainForm.lbl_ChoosenLink.Caption := sGRefName;
            edt_Link.Text := sGRefName;

            nog_SqlText := nog_SqlText + ' group by arc_id,doc_id ';
            if frm_MainForm.TmpSQL_2(nog_sqlText) then
            begin
              with dm_DB do
              begin
                 if my_q_tmp_2.RecordCount > 0 then
                 begin

                     DbCreateTempTable(sGTmpName);

                    (*  // f.schneider  v3.5.1.62

                    my_cmd.SQL.Text := 'drop table if exists tmp_' + sGTmpName;
                    try
                       my_cmd.Execute;
                    except
                       on e: Exception do
                          ErrorMsg('GetDocs',
                             _('Fehler beim Entfernen einer Temptabelle:') + e.Message, 1004, True);
                    end;

                    my_cmd.SQL.Text :=
                       'CREATE TABLE `tmp_' + sGTmpName + '` (' +
                       '`ARC_ID` BIGINT UNSIGNED NOT NULL,' +
                       '`ArcName` VARCHAR(32) NOT NULL,' +
                       '`TblName` VARCHAR(14) NOT NULL,' +
                       '`DOC_ID` BIGINT UNSIGNED NOT NULL,' +
                       '`DISP_NAME` VARCHAR(32) NOT NULL,' +
                       '`DOC_LOC` VARCHAR(255) NOT NULL,' +
                       '`EXT_LOC` VARCHAR(255) NOT NULL,' +
                       '`ORI_LOC` VARCHAR(255) NOT NULL,' +
                       '`USR_NAME` VARCHAR(32) NOT NULL,' + 
                       '`USR_ID` BIGINT UNSIGNED NOT NULL,' + '`TStamp` DATETIME NOT NULL,' +
                       '`DOC_TXT` LONGTEXT,' + '`DOC_STATE` INTEGER UNSIGNED NOT NULL,' +
                       '`OCR_QF` INTEGER SIGNED NOT NULL DEFAULT 0,' +
                       '`SHA1` varchar(40),' +
                       // 06.09.2010 b.takacs [2717]
                       '`GDOC_ID` BIGINT UNSIGNED NOT NULL,' + '`OPTIONEN` INTEGER UNSIGNED NOT NULL' +
                       ', primary key (`ARC_ID`,`DOC_ID`)' + ') COMMENT = ' +
                       #39 + 'Temptabelle fr Benutzer (USR_ID): ' + sGUsrName +
                       ' (' + IntToStr(iGUsrID) + ')' + #39;
                    try
                       my_cmd.Execute;
                    except
                       on e: Exception do
                          ErrorMsg('GetDocs', _('Fehler beim Erzeugen einer Temptabelle:') +
                             e.Message, 1003, True);
                    end;
                    *)(*
                {if my_q_Lnk.RecordCount > 1 then
                begin
                  if BfMessageDlg(
                    'Es wurde mehr als eine Verknpfungsmenge mit diesem Namen gefunden.' +
                    #13 + 'Sollen alle Verknpfungen angezeigt werden?', mtConfirmation,
                    [mbYes, mbNo], 0) = mrYes then
                    iCountTo := my_q_Lnk.RecordCount
                  else
                    iCountTo := 1;

                end
                else
                  iCountTo := 1;
                  }
                    iCountTo := my_q_tmp_2.RecordCount;
                    // get the ref_lnk for all verknpfungen
                    for iCount := 0 to (iCountTo - 1) do
                    begin
                       iTmpRefLNK := my_q_tmp_2.FieldByName('ref_lnk').AsInteger;
                       my_q_tmp_2.Next;
                       // couldnt think of        ref_id = ' + IntToStr(iTmpRefID) + ' and ref_lnk = 0'
                       // so we take it away (which case could it be?)
                       // get the infos about the ref_lnk and check for the permissions
                       if frm_MainForm.TmpSQL(
                          'select sys_doclnk.arc_id, Arc_Name, arc_tblname, doc_id,sys_arcxs.arc_id,' +
                          'sys_arcxs.usr_id from sys_doclnk left join sys_arcxs Using(arc_id) ' +
                          ' left join sys_arc Using(arc_id)' + ' where ref_lnk = ' +
                          IntToStr(iTmpRefLNK) + ' and sys_arcxs.arc_id = sys_doclnk.arc_id and ' +
                          ' (FIND_IN_SET(' + #39 + 'read' + #39 +
                          ',sys_arcxs.rights) and sys_arcxs.usr_id=' + IntToStr(iGUsrID) +
                          ') group by ref_id') then
                       begin
                          while not my_q_Tmp.EOF do
                          begin
                             sTmpDocID :=
                                IntToStr(my_q_Tmp.FieldByName('doc_id').AsInteger);
                             sTmpArcID :=
                                IntToStr(my_q_Tmp.FieldByName('arc_id').AsInteger);
                             sTmpArcName :=
                                my_q_Tmp.FieldByName('arc_name').AsString;
                             sTmpTblName :=
                                my_q_Tmp.FieldByName('arc_tblname').AsString;
                             // 06.09.2010 b.takacs [2717]
                             iTmpGDocID:= dm_DB.GetGDocIDByArcIDandDocID(StrToInt(sTmpArcID),StrToInt(sTmpDocID));

                             my_cmd.SQL.Text :=
                                'Insert into tmp_' + sGTmpName +
                                ' (arc_id, ArcName, TblName, doc_id, disp_name, doc_loc, ext_loc, ori_loc, ' //04.07.2011 b.takacs 3.5.1.25 ori_loc hinzugefgt
                                + 'usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf, gdoc_id, optionen) Select '      // 06.09.2010 b.takacs [2717]
                                + sTmpArcID + ' as Arc_ID,' + #39 + sTmpArcName +
                                #39 + ' as ArcName,' + #39 + sTmpTblName + #39 +
                                ' as TblName,' +
                                'doc_id, disp_name, doc_loc, ext_loc, ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf, ' + IntToStr(iTmpGDocID) + ', optionen from arc_'   // 06.09.2010 b.takacs [2717] //04.07.2011 b.takacs 3.5.1.25 ori_loc hinzugefgt
                                + sTmpTblName + ' as arc where doc_id = ' + sTmpDocID + '  on duplicate key update ' +
                                ' tmp_' + sGTmpName + '.doc_id = arc.doc_id ';
                             try
                                my_cmd.Execute;
                             except
                                on e: Exception do
                                   LogEvnt(_('btn_allldoclinksClick: Fehler beim Kopieren von Dokumenten in die Temptabelle:') + e.Message);
                             end;
                             my_q_Tmp.Next;
                          end;
                       end;
                    end;
                 end
                 else
                 begin
                    exit;
                    //dm_DB.my_q_Lnk.Close;  //f.schneider
                 end;
              end;
            end;

        except
          on e: Exception do
          begin
             LogEvnt(_('btn_allldoclinksClick: Fehler beim Kopieren von Dokumenten in die Temptabelle:') + e.Message);
              Exit;
          end;
        end;

       iGArcRecNo := -1;
       iGBorderRem := 1;
    //GgfLogEvnt('5'); //13.12.2010 b.takacs debugtest
       frm_MainForm.DelZusFields2(true);
    //GgfLogEvnt('52'); //13.12.2010 b.takacs debugtest
       frm_MainForm.CreateStandardColumnsTrefferliste;
    //GgfLogEvnt('53'); //13.12.2010 b.takacs debugtest

       bMultiArcQuery := True;
       frm_MainForm.QueryArc('Select Sql_No_cache * from tmp_' + sGTmpName +
          ' group by arc_id,doc_id order by tstamp desc');
       bMultiArcQuery := True;
       dm_MainForm2.mnu_TGoToArc.Visible := True;

     end;

   finally
   		EnableControls(True);
     Screen.Cursor := crDefault;
   end;

end;
*)



function Tfrm_DocLink.CreLinknotinteractive: boolean;
   ///////////////////////////////////////////////////////////////////
   ///   04.05.2005 Erstellt by SV                                 ///
   ///                                                             ///
   ///   Diese Function erzeugt in der Tabelle sys_doclnk eine     ///
   ///   neue Referenz und Ruft GetLinks auf um die Referenzen     ///
   ///   neu einzulesen.                                           ///
   ///                                                             ///
   ///   Rckgabe: True bei Erfolg                                 ///
   ///             False bei Fehlschlag                            ///
   ///                                                             ///
   ///////////////////////////////////////////////////////////////////
var
   iTmpArcID, iTmpDocID, licounter, larcid, ldocid: integer;
begin
   iTmpArcID := 0;
   iTmpDocID := 0;
   createnewlink := False;
   Result := True;
   sGRefName := trim(ParseSemicolonUseBackslash(sGRefName));
// f.schneider 3.5.1.48 wir nehmen das lowercase raus
//   edt_Link.Text := trim(ParseSemicolonUseBackslash(lowercase(sGRefName)));
   edt_Link.Text :=  sGRefName;
   if (sGRefName = '') then
   begin
      exit;
   end;
   try
      // get ref_lnk
      if frm_MainForm.TmpSQL(
         'select ref_lnk, ref_name from sys_doclnk where ref_name like ' +
         #39 + sGRefName + #39) then
      begin
         if dm_DB.my_q_Tmp.RecordCount > 0 then
         begin
            // get the ref_lnk!
            iGRefLNK := dm_DB.my_q_Tmp.FieldByName('ref_lnk').AsInteger;
            sGRefName :=
               dm_DB.my_q_Tmp.FieldByName('ref_name').AsString;
            // ArcID vom gemerkten Dokument sichern

            iGRArcID := iGArcID; // RefArcID auf aktuelle ArcID setzen
            // get (save) the name for the slw
            

            with frm_MainForm.dbgrd_Trefferliste do
            begin
               for licounter := 0 to SelectedRows.Count - 1 do
               begin
                  dm_DB.my_q_Arc.GotoBookmark(Pointer(SelectedRows.Items[licounter]));

                  ldocid :=   dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                  iGRDocID := ldocid;
                  if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil)
                  then
                  begin
                     larcid := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                     iGRArcID := larcid;
                  end
                  else
                  begin
                    iGRArcID := iGArcID;
                    larcid := iGArcID;
                  end;

                  // DocID vom gemerkten Dokument sichern
                  AddDocToRef; // Dokument zur Referenz hinzufgen
                  // set the history
                  frm_MainForm.NewHistory(4, Format(_('Schlagwort und Verknpfung %s angelegt.'),[edt_Link.Text]));
               end;
            end;

            //we have now a link, so if isnt yellow set it now!
            frm_MainForm.tci_DocLink.color := clyellow;

            frm_Mainform.lbl_choosenlink.Caption := edt_Link.Text;
            frm_mainform.lbl_choosenLink.Visible := True;
            frm_mainform.img_link.Visible := true;
            exit;
         end
         else
         begin
            with dm_DB.my_cmd do
            begin
               try
                  with frm_MainForm.dbgrd_Trefferliste do
                  begin

                     iGRArcID := iGArcID; // RefArcID auf aktuelle ArcID setzen
                     // get (save) the name for the slw

                     for licounter := 0 to SelectedRows.Count - 1 do
                     begin
                        dm_DB.my_q_Arc.GotoBookmark(Pointer(SelectedRows.Items[licounter]));
                        ldocid := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                        iGRDocID := ldocid;
                        if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil)
                        then
                        begin
                           larcid := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                           iGRArcID := larcid;
                        end
                        else
                          iGRArcID := iGArcID;


                        SQL.Text :=
                           'Insert into sys_doclnk (arc_id, doc_id, usr_id, ref_name, ref_lnk) Values ('
                           + IntToStr(iGRArcID) + ', ' + IntToStr(iGRDocID) + ', ' +
                           IntToStr(iGUsrID) + ', ' + #39 + edt_Link.Text + #39 + ', 0)';
                        Execute;
                        SQL.Text := 'Update sys_doclnk Set Ref_lnk = ' +
                           IntToStr(InsertId) + ' where ref_id = ' + IntToStr(InsertId);
                        Execute;
                        iGDocID := iGRDocID;
                        frm_MainForm.NewHistory(4, Format(_('Schlagwort und Verknpfung %s angelegt.'),[edt_Link.Text]));


                        SQL.Text := 'Insert into slw_' + sIArcName +
                           ' (doc_id, doc_slw) Values (' + IntToStr(iGRDocID) +
                           ', ' + #39 + edt_Link.Text + #39 + ')';
                        Execute;
                     end;
                  end;
                  frm_MainForm.tci_DocLink.color := clyellow;
               finally
                  createnewlink := True;
               end;
            end;
         end;
      end
      else
      begin
         ShowMessage(_('Fehler bei der Abfrage der Datenbank!'));
      end;
   except
      on e: Exception do
      begin
         ErrorMsg('CreLink', _('Fehler beim Anlegen einer neuen Verknpfung:') +
            e.Message, 2012, True);
         Result := False;

         createnewlink := False;
      end;
   end;
   frm_Mainform.lbl_choosenlink.Caption := edt_Link.Text;
   frm_mainform.lbl_choosenLink.Visible := True;
   frm_mainform.img_link.Visible := true;
   GetLinks;
   dm_MainForm2.mnu_TLinkDoc.Enabled := false;
end;


procedure Tfrm_DocLink.EnableControls(enable : Boolean);
begin
    btn_ShowLnk.enabled := enable;
    btn_allldoclinks.enabled := enable;
    btn_LnkDel.enabled := enable;
    ButtonDel1Link.enabled := enable;
    
end;


end.






