unit u_EditInfo;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, gnugettext;

type
   Tfrm_EditInfo = class (TForm)
      memo_Info: TMemo;
      btn_speichern: TButton;
      Panel1: TPanel;
      procedure btn_speichernClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_EditInfo: Tfrm_EditInfo;

implementation

uses u_dm_DB, u_mainForm;

{$R *.dfm}

procedure Tfrm_EditInfo.btn_speichernClick(Sender: TObject);
begin
   frm_MainForm.memo_Info.Text := memo_info.Text;
   frm_MainForm.tbi_SaveEdit.Click;
   //save routine der Infozeile aufrufen
   Close;
end;

procedure Tfrm_EditInfo.FormShow(Sender: TObject);
begin
   memo_Info.Lines.Clear;
   //  memo_Info.Text:=memo_info.Text;
   with dm_DB.my_q_time do
   begin
      memo_info.Text := FieldByName('Info').AsString;
   end;
   if frm_MainForm.tbi_MATask.Checked then
      // wenn die Mitarbeiter Tasks angezeigt werden
      // soll das memofeld nicht editierbar sein
   begin
      panel1.Visible := False;
      memo_info.ReadOnly := True;
   end
   else
   begin
      panel1.Visible := True;
      memo_info.ReadOnly := False;
   end;
end;

procedure Tfrm_EditInfo.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
