//-----------------------------------------------------------------------------
// Projekt:    Bitfarm-Archiv Viewer
// Entwickler: Frey
// Erstellt:   2009-10-02
// Name:       u_ViewBase
// Typ:        Unit
// Zweck:      Fr Viewer low-level Definitionen
//-----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------}

unit u_ViewBase;

{###############################} INTERFACE {###############################}

uses
   StrUtils, Types,
   u_ShBase;

const
  sfVoransicht = 1;
  sfVolltext   = 2;
  sfDocLink    = 3;
  sfHistory    = 4;
  sfRechte     = 5;
  sfNix        = 6;
  sfCommentary = 7;

const
  // Angemeldet als: = 0
  cStatusPanelUser   = 1;
  // Server:         = 2
  cStatusPanelServer = 3;
  cStatusPanelDoc    = 5;
  cStatusPanelInfo   = 7;

  cStatusPanelDocIdTrennzeichen = '/';


type
  // ein Typ zur Speicherung von Anzeigezustnden   
  TDocViewSave = record
                   Doc: TArcDocId; // Das Dokument
                   Page: integer; // Die Seite
                 end;
  TDocViewSaves = array [0..5] of TDocViewSave;
       

{############################} IMPLEMENTATION {#############################}


//-----------------------------------------------------------------------------
begin end.
//-----------------------------------------------------------------------------