unit u_login_optionen;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls;

type
   Tfrm_Login_Optionen = class (TForm)
      cbx_delete_frmdata: TCheckBox;
      btn_log_opt_cancel: TButton;
      btn_log_opt_ok: TButton;
      procedure btn_log_opt_cancelClick(Sender: TObject);
      procedure btn_log_opt_okClick(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_Login_Optionen: Tfrm_Login_Optionen;
implementation
uses u_MainForm, Registry;
{$R *.dfm}

procedure Tfrm_Login_Optionen.btn_log_opt_cancelClick(Sender: TObject);
begin
   frm_Login_Optionen.close;
end;

procedure Tfrm_Login_Optionen.btn_log_opt_okClick(Sender: TObject);
var
   Reg: TRegistry;
begin
   if cbx_delete_frmdata.Checked then
   begin
      try
         Reg := TRegistry.Create;
         Reg.RootKey := HKEY_CURRENT_USER;
         Reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\', True);
         Reg.deletekey('Formdata');


      finally
         if Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
   frm_Login_Optionen.close;
end;

end.
