unit u_voransichtopt;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ComCtrls, Buttons, ExtCtrls, Registry, ievect, ImageEnView,
   ieview, hyiedefs, hyieutils, ImageEnProc, JvExStdCtrls, JvCombobox,
   JvListComb, Placemnt, gnugettext, ImgList,
   u_ShLowUtils, u_ShDm, u_HighUtils;


type
   Tfrm_voransichtoptionen = class (TForm)
      pctrl_DocEditOpt: TPageControl;
      tbs_Standard: TTabSheet;
      tbs_Annotations: TTabSheet;
      btn_Cancel: TButton;
      btn_Save: TButton;
      btn_ok: TButton;
      tctrl_Annos: TTabControl;
      chbx_EnaRenderEn: TCheckBox;
      chbx_EnaAntialias: TCheckBox;
      grbx_Color: TGroupBox;
      lbl_CBackground: TLabel;
      lbl_CBorder: TLabel;
      lbl_CLabel: TLabel;
      lbl_CNoteBorder: TLabel;
      clbx_CBackground: TColorBox;
      clbx_CBorder: TColorBox;
      clbx_CLabel: TColorBox;
      clbx_CNoteBorder: TColorBox;
      grbx_Brush: TGroupBox;
      lbl_BBackground: TLabel;
      lbl_BBorder: TLabel;
      lbl_BLabel: TLabel;
      lbl_BNoteBorder: TLabel;
      cbx_BBackground_old: TComboBoxEx;
      cbx_BBorder_old: TComboBoxEx;
      cbx_BLabel_old: TComboBoxEx;
      cbx_BNoteBorder_old: TComboBoxEx;
      grbx_Shape: TGroupBox;
      lbl_SShapeStart: TLabel;
      lbl_SShapeEnd: TLabel;
      lbl_SSHeight: TLabel;
      lbl_SSWidth: TLabel;
      pnl_SShape: TPanel;
      rbtn_SENo: TRadioButton;
      rbtn_SEOut: TRadioButton;
      rbtn_SEIn: TRadioButton;
      rbtn_SSNo: TRadioButton;
      rbtn_SSOut: TRadioButton;
      rbtn_SSIn: TRadioButton;
      edt_SSHeight: TEdit;
      edt_SSWidth: TEdit;
      grbx_Algem: TGroupBox;
      lbl_AObjName: TLabel;
      lbl_APenWidth: TLabel;
      lbl_ARulerTyp: TLabel;
      lbl_ARulerMeasure: TLabel;
      lbl_ATransp: TLabel;
      lbl_APixel: TLabel;
      edt_AObjName: TEdit;
      edt_APenWidth: TEdit;
      cbx_ARulerTyp: TComboBox;
      cbx_ARulerMes: TComboBox;
      chbx_AOpenPoly: TCheckBox;
      chbx_AIsHiLite: TCheckBox;
      chbx_ASizeable: TCheckBox;
      chbx_AVisible: TCheckBox;
      chbx_AMoveable: TCheckBox;
      chbx_ASelectable: TCheckBox;
      edt_ATransp: TEdit;
      grbx_Text: TGroupBox;
      lbl_TFont: TLabel;
      lbl_TFontAngle: TLabel;
      lbl_TFontSize: TLabel;
      sbtn_TFont: TSpeedButton;
      lbl_TLabelPos: TLabel;
      lbl_TAlign: TLabel;
      lbl_TGrad: TLabel;
      chbx_TFontLocked: TCheckBox;
      edt_TFont: TEdit;
      edt_TFontAngle: TEdit;
      edt_TFontSize: TEdit;
      cbx_TLabelPos: TComboBox;
      cbx_TAlign: TComboBox;
      chbx_TObjAutoSize: TCheckBox;
      memo_TObjText: TMemo;
      dlg_Schrift: TFontDialog;
      tbs_Stempel: TTabSheet;
      grbx_Stamps: TGroupBox;
      lv_Stamps: TListView;
      grbx_StampProp: TGroupBox;
      btn_NewStamp: TButton;
      btn_SaveStamp: TButton;
      btn_DelStamp: TButton;
      lbl_SName: TLabel;
      lbl_STyp: TLabel;
      memo_SText: TMemo;
      lbl_SText: TLabel;
      lbl_SBild: TLabel;
      edt_SName: TEdit;
      rbtn_SText: TRadioButton;
      rbtn_SBild: TRadioButton;
      edt_SBild: TEdit;
      sbtn_SBild: TSpeedButton;
      lbl_SFont: TLabel;
      edt_SFont: TEdit;
      sbtn_SFont: TSpeedButton;
      img_SBild: TImageEnView;
      lbl_SHeight: TLabel;
      lbl_SWidth: TLabel;
      edt_SHeight: TEdit;
      edt_SWidth: TEdit;
      lbl_SHeightMes: TLabel;
      lbl_SWidthMes: TLabel;
      LblText1: TLabel;
      lbl_Stemp_how2: TLabel;
      btn_transp: TButton;
      stt_fav: tlabel;
      lv_eigenschaftstempel: TListView;
      cbx_fav: TComboBoxEx;
      frmsto_docoptionen: TFormStorage;
      cbx_textform: TCheckBox;
      cbx_nummer: TComboBox;
      lbl_nummer: TLabel;
      lbl_objheight: TLabel;
      lbl_objwidth: TLabel;
      edt_objheight: TEdit;
      Edt_objwidth: TEdit;
      cbx_autolineincrease: TCheckBox;
      cbx_autoincreasehigh: TCheckBox;
      cbx_BBackground: TJvImageComboBox;
      il_BrushStyle: TImageList;
      cbx_BBorder: TJvImageComboBox;
      cbx_BNoteBorder: TJvImageComboBox;
      cbx_BLabel: TJvImageComboBox;
      il_PenStyle: TImageList;
      procedure btn_SaveClick(Sender: TObject);
      procedure tctrl_AnnosChange(Sender: TObject);
      procedure tctrl_AnnosChanging(Sender: TObject; var AllowChange: boolean);
      procedure btn_okClick(Sender: TObject);
      procedure edt_SSHeightChange(Sender: TObject);
      procedure edt_SSWidthChange(Sender: TObject);
      procedure edt_APenWidthChange(Sender: TObject);
      procedure edt_ATranspChange(Sender: TObject);
      procedure edt_TFontAngleChange(Sender: TObject);
      procedure edt_TFontSizeChange(Sender: TObject);
      procedure cbx_TLabelPosChange(Sender: TObject);
      procedure cbx_TAlignChange(Sender: TObject);
      procedure cbx_ARulerTypChange(Sender: TObject);
      procedure cbx_ARulerMesChange(Sender: TObject);
      procedure sbtn_TFontClick(Sender: TObject);
      procedure chbx_EnaRenderEnClick(Sender: TObject);
      procedure chbx_EnaAntialiasClick(Sender: TObject);
      procedure edt_SBildChange(Sender: TObject);
      procedure btn_NewStampClick(Sender: TObject);
      procedure btn_SaveStampClick(Sender: TObject);
      procedure btn_DelStampClick(Sender: TObject);
      procedure lv_StampsClick(Sender: TObject);
      procedure sbtn_SBildClick(Sender: TObject);
      procedure rbtn_STextClick(Sender: TObject);
      procedure rbtn_SBildClick(Sender: TObject);
      procedure tbs_AnnotationsShow(Sender: TObject);
      procedure tbs_StandardShow(Sender: TObject);
      procedure tbs_StempelShow(Sender: TObject);
      procedure sbtn_SFontClick(Sender: TObject);
      procedure edt_SWidthChange(Sender: TObject);
      procedure edt_SHeightChange(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure img_SBildClick(Sender: TObject);
      procedure btn_transpClick(Sender: TObject);
      procedure img_SBildMouseMove(Sender: TObject; Shift: TShiftState;
         X, Y: integer);
      procedure lv_eigenschaftstempelClick(Sender: TObject);
      procedure frmsto_docoptionenRestorePlacement(Sender: TObject);
      procedure cbx_nummerChange(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure memo_TObjTextKeyDown(Sender: TObject; var Key: Word;
         Shift: TShiftState);
   private
      { Private-Deklarationen }
      fifavnum: integer;
   public
      { Public-Deklarationen }
      floadedindex: integer;
      function LoadObjVal(ObjTyp: integer): boolean;
      function SaveObjVal(ObjTyp: integer): boolean;
      function LoadDocEditOpt: boolean;
      function SaveDocEditOpt: boolean;
      function ListStamps(fobjekteigen: boolean): boolean;
      function LoadStamp(StampKey: string): boolean;
      function LoadStampEigenschaften(StampKey: string): boolean;
      function CreStamp: boolean;
      function SavStamp(StampKey: string): boolean;
      function DelStamp(StampKey: string): boolean;
      procedure SetTransparent;
      procedure loadfavstampbuttons;
   end;

var
   frm_voransichtoptionen: Tfrm_voransichtoptionen;
   sGStampKey: string; // aktuell bearbeiteter Stempel Key


implementation

uses u_PickDialog, u_MainForm;

{$R *.dfm}/////////////////////////////////////////////////////////////////////////////////////////////////////
//  Stemple lschen

function Tfrm_voransichtoptionen.DelStamp(StampKey: string): boolean;
var
   reg: TRegistry;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            DeleteKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey);
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_voransichtoptionen.DelStamp',
               _('Fehler beim Schreiben in die Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_voransichtoptionen.SavStamp(StampKey: string): boolean;
var
   reg: TRegistry;
   fsTmp: TFontStyles;
   reg1: TRegistry;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   //    ssTmp: TIEVSoftShadow;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;
   lipencolor, lifavin, lifavin1, licounter: integer;
   lbfavexists: boolean;
   lschangename: string;
begin
   Result := True;
   lifavin1 := 0;
   reg := TRegistry.Create;
   fsTmp := dlg_Schrift.Font.Style;
   lipencolor := dlg_Schrift.Font.color;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
               exit;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);
            WriteString('StampName', edt_SName.Text);
            WriteString('StampFile', edt_SBild.Text);
            WriteString('StampText', memo_SText.Text);
            WriteBool('StampTyp', rbtn_SBild.Checked);
            WriteInteger('FontColor', dlg_Schrift.Font.Color);
            WriteInteger('objFontColor', dlg_Schrift.Font.Color);
            WriteString('FontName', dlg_Schrift.Font.Name);
            WriteBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
            WriteInteger('FontSize', dlg_Schrift.Font.size);
            WriteInteger('ObjFontHeight', dlg_Schrift.Font.size);
            WriteInteger('StampHeight', StrToInt(edt_SHeight.Text));
            WriteInteger('StampWidth', StrToInt(edt_SWidth.Text));
            lifavin := cbx_fav.ItemIndex;
            lbfavexists := False;
            if lifavin > 0 then
            begin
               for licounter := 0 to lv_stamps.Items.Count - 1 do
               begin
                  if StampKey <> lv_stamps.Items.Item[licounter].Caption then
                  begin
                     if (lv_Stamps.items.item[licounter].subitems[0] = ' ') or
                        (lv_Stamps.items.item[licounter].subitems[0] = '') then
                     begin
                        continue;
                     end;
                     try
                        lifavin1 := StrToInt(lv_Stamps.items.item[licounter].subitems[0]);
                     except
                        on e: Exception do
                        begin
                        end;
                     end;
                     if (lifavin1 = lifavin) and
                        (StampKey <> lv_stamps.Items.Item[licounter].SubItems[1]) then
                     begin
                        //                     setlength(laifavs,lv_stamps.Items.Count);
                        lschangename := lv_Stamps.items.item[licounter].SubItems[1];
                        lbfavexists := True;
                        break;
                     end;
                  end;
               end;
            end;
            if lbfavexists then
            begin
               if MessageDlg(_('Es gibt bereits einen Stempel mit diesem Favoritennummer.') +
                  #13 + _('Mchten Sie diese Nummer neu vergeben?'),
                  mtConfirmation,
                  [mbYes, mbNo], 0) = mrNo then
               begin
                  lifavin := 0;
               end
               else
               begin
                  //          reg.CloseKey;
                  reg1 := TRegistry.Create;
                  reg1.RootKey := HKEY_CURRENT_USER;
                  reg1.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +
                     lschangename, True);
                  reg1.WriteInteger('favnr', 0);
                  reg1.CloseKey;
                  reg1.Free;
                  //        reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);
               end;
            end;

            if lifavin > 0 then
            begin
               WriteInteger('favnr', cbx_fav.ItemIndex);
            end
            else
            begin
               WriteInteger('favnr', 0);
            end;
            WriteInteger('ObjBrushColor', 0);
            WriteInteger('ObjPenColor', lipencolor);
            WriteInteger('ObjLabelBrushColor', 0);
            WriteInteger('ObjMemoBorderColor', 0);
            bsTmp := bsClear;
            WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));

            bsTmp := bsClear;
            WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));

            psTmp := psClear;
            WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            psTmp := psClear;

            WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
            shTmp := iesNONE;
            WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            shTmp := iesNONE;
            WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            WriteInteger('ObjShapeHeight', 0);
            WriteInteger('ObjShapeWidth', 0);
            WriteString('ObjName', 'Text-Anno');
            WriteInteger('ObjPenWidth', 1);
            rtTmp := iertRULER;
            WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
            ruTmp := ieuPIXELS;
            WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
            WriteInteger('ObjTransparency', 0);
            WriteInteger('objWidth', 400);
            WriteInteger('objHeight', 400);

            WriteBool('ObjPolylineClosed', True);
            WriteBool('ObjBoxHighlight', True);
            osTmp := [];
            osTmp := osTmp + [ievsSelectable];
            osTmp := osTmp + [ievsMoveable];
            osTmp := osTmp + [ievsSizeable];
            osTmp := osTmp + [ievsVisible];
            WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            WriteString('ObjFontName', dlg_Schrift.Font.Name);
            WriteInteger('ObjFontHeight', dlg_Schrift.Font.size);
            fsTmp := dlg_Schrift.Font.Style;
            WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            WriteFloat('ObjFontAngle', 0);
            lpTmp := ielBegin;

            WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
            taTmp := iejLeft;

            WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
            WriteString('ObjText', _('Neue Text-Annotation'));
            WriteBool('ObjTextAutoSize', True);
            WriteBool('ObjFontLocked', False);
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_voransichtoptionen.SavStamp',
               _('Fehler beim Schreiben in die Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_voransichtoptionen.CreStamp: boolean;
var
   reg: TRegistry;
   sStampKey: string;
   fsTmp: TFontStyles;
begin
   Result := True;
   reg := TRegistry.Create;
   fsTmp := [];
   DateTimeToString(sStampKey, 'ddmmyyyyhhnnss', Now);
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + sStampKey, True);
            WriteString('StampName', _('Neuer Stempel'));
            WriteString('StampFile', '');
            WriteString('StampText', _('neuer Text'));
            WriteBool('StampTyp', False);
            WriteInteger('FontColor', 0);
            WriteString('FontName', 'Arial');
            WriteBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
            WriteInteger('FontSize', 72);
            WriteInteger('StampHeight', 30);
            WriteInteger('StampWidth', 40);
            CloseKey;
         end;
         sGStampKey := sStampKey;
         //LoadStamp(sGStampKey); //3.5.0.43 [2197]
         SavStamp(sGStampKey); //3.5.0.43 [2197]
      except
         on e: Exception do
         begin
            ErrorMsg('frm_voransichtoptionen.CreStamp',
               _('Fehler beim Schreiben in die Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_voransichtoptionen.LoadStamp(StampKey: string): boolean;
var
   reg: TRegistry;
   fsTmp: TFontStyles;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
               exit;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);
            if ValueExists('StampName') then
               edt_SName.Text := ReadString('StampName')
            else
               edt_SName.Text := _('(keine Bezeichnung)');
            if ValueExists('StampTyp') then
            begin
               if not ReadBool('StampTyp') then
               begin
                  rbtn_SText.Checked := True;
                  memo_SText.Enabled := True;
                  edt_SFont.Enabled := True;
                  sbtn_SFont.Enabled := True;
                  edt_SBild.Enabled := False;
                  edt_SBild.Text := '';
                  sbtn_SBild.Enabled := False;
                  img_SBild.Enabled := False;
               end
               else
               begin
                  rbtn_SBild.Checked := True;
                  memo_SText.Enabled := False;
                  memo_SText.Text := '';
                  edt_SBild.Enabled := False;
                  edt_SFont.Enabled := False;
                  sbtn_SFont.Enabled := True;
                  sbtn_SBild.Enabled := True;
                  img_SBild.Enabled := True;
               end;
            end
            else
               rbtn_SText.Checked := True;
            if ValueExists('StampText') then
               memo_SText.Text := ReadString('StampText')
            else
               memo_SText.Text := '(kein Text)';
            if ValueExists('StampFile') then
               edt_SBild.Text := ReadString('StampFile')
            else
               edt_SBild.Text := '';
            if ValueExists('StampWidth') then
               edt_SWidth.Text := IntToStr(ReadInteger('StampWidth'))
            else
               edt_SWidth.Text := '40';
            if ValueExists('StampHeight') then
               edt_SHeight.Text := IntToStr(ReadInteger('StampHeight'))
            else
               edt_SHeight.Text := '30';
            if ValueExists('FontColor') then
               dlg_Schrift.Font.Color := ReadInteger('FontColor')
            else
               dlg_Schrift.Font.Color := 0;
            if ValueExists('ObjFontColor') then
               dlg_Schrift.Font.Color := ReadInteger('ObjFontColor')
            else
               dlg_Schrift.Font.Color := 0;
            if ValueExists('FontName') then
            begin
               edt_TFont.Text := ReadString('FontName');
            end
            else
            begin
               edt_TFont.Text := 'Arial';
            end;
            dlg_Schrift.Font.Name := edt_TFont.Text;
            edt_SFont.Text := edt_TFont.Text;
            if ValueExists('FontStyle') then
            begin
               ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
               dlg_Schrift.Font.Style := fsTmp;
            end
            else
               dlg_Schrift.Font.Style := [];
            if ValueExists('FontSize') then
               dlg_Schrift.Font.Size := ReadInteger('FontSize')
            else
               dlg_Schrift.Font.Size := 72;

            if ValueExists('ObjFontHeight') then
            begin
               dlg_Schrift.Font.Size := ReadInteger('ObjFontHeight');
            end;

            if ValueExists('favnr') then
            begin
               cbx_fav.ItemIndex := readinteger('favnr');
            end
            else
            begin
               cbx_fav.ItemIndex := 0;
            end;

            CloseKey;
            if pctrl_DocEditOpt.ActivePageIndex = 2 then
            begin
               edt_SName.SetFocus;
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_voransichtoptionen.LoadStamp', _('Fehler beim Lesen des Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_voransichtoptionen.ListStamps(fobjekteigen: boolean): boolean;
var
   reg: TRegistry;
   slStampKeys: TStrings;
   iCount: integer;
   lItem: TListItem;
   lmylistview: TListView;
   lbtyp: boolean;
begin
   Result := True;
   reg := TRegistry.Create;
   slStampKeys := TStringList.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps', True);
            GetKeyNames(slStampKeys);
            CloseKey;
            if fobjekteigen then
               lmylistview := lv_eigenschaftstempel
            else
               lmylistview := lv_Stamps;
            lmylistview.Clear;
            // check for benutzer sign

        {   if fileexists(pchar(BD.ExeDir+'\signs\'+sGUsrName+'.tif')) then
  begin
                  lItem := lv_Stamps.Items.Add;
                  litem.caption:= 'Signatur von '+sGUsrName;
                  litem.SubItems.Add()
                  slStampKeys.Add()
  end;
  }
            for iCount := 0 to (slStampKeys.Count - 1) do
            begin
               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +
                  slStampKeys.Strings[iCount], True);
               if fobjekteigen then
               begin
                  if ValueExists('StampTyp') then
                     lbtyp := ReadBool('StampTyp')
                  else
                     lbtyp := True;
                  if lbtyp then
                  begin
                     CloseKey;
                     continue;
                  end;
               end;
               lItem := lmylistview.Items.Add;
               if ValueExists('StampName') then
                  lItem.Caption := ReadString('StampName')
               else
                  lItem.Caption := 'unbekannter Stempel';

               if ValueExists('StampTyp') then
               begin
                  if ReadBool('StampTyp') then
                     lItem.ImageIndex := 1
                  else
                     lItem.ImageIndex := 0;
               end
               else
                  lItem.ImageIndex := 3;
               if not fobjekteigen then
               begin
                  if ValueExists('favnr') then
                  begin
                     litem.SubItems.Add(IntToStr(readinteger('favnr')));
                  end
                  else
                  begin
                     litem.SubItems.Add(' ');
                  end;
               end;
               lItem.SubItems.Add(slStampKeys.Strings[iCount]);
               CloseKey;
            end;
            if (slStampKeys.Count > 0) and (lmylistview.items.Count > 0) then
               lmylistview.ItemIndex := 0;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_voransichtoptionen.ListStamps', _('Fehler beim Lesen der Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(slStampKeys) then
         FreeAndNil(slStampKeys);
   end;
end;

function Tfrm_voransichtoptionen.LoadDocEditOpt: boolean;
   //////////////////////////////////////////////////////////////////
   ///  11.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion ld die Dokument Editor Einstellungen aus  ///
   ///  der Registrierung.                                        ///
   ///                                                            ///
   ///  Parameter: keine                                          ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   reg: TRegistry;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            if ValueExists('DE_RenderEng') then
               chbx_EnaRenderEn.Checked := ReadBool('DE_RenderEng')
            else
               chbx_EnaRenderEn.Checked := False;
            if ValueExists('DE_Antialias') then
               chbx_EnaAntialias.Checked := ReadBool('DE_Antialias')
            else
               chbx_EnaAntialias.Checked := False;
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_voransichtoptionen.LoadDocEditOpt',
               _('Fehler beim Lesen des Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_voransichtoptionen.SaveDocEditOpt: boolean;
   //////////////////////////////////////////////////////////////////
   ///  11.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion sichert die Dokument Editor Einstellungen  ///
   ///  aus der Registrierung.                                    ///
   ///                                                            ///
   ///  Parameter: keine                                          ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   reg: TRegistry;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            WriteBool('DE_RenderEng', chbx_EnaRenderEn.Checked);
            WriteBool('DE_Antialias', chbx_EnaAntialias.Checked);
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_voransichtoptionen.SaveDocEditOpt',
               _('Fehler beim Schreiben in die Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_voransichtoptionen.LoadObjVal(ObjTyp: integer): boolean;
   //////////////////////////////////////////////////////////////////
   ///  11.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function ld die Objekteigenschaften des Objekt-    ///
   ///  typs [ObjTyp] aus der Registrierung.                      ///
   ///                                                            ///
   ///  Parameter: ObjTyp        Objekttyp                        ///
   ///             0             Textmarker                       ///
   ///             1             Notiz                            ///
   ///             2             Beschriftung                     ///
   ///             3             Freihandlinie                    ///
   ///             4             Poligon                          ///
   ///             5             Ellipse                          ///
   ///             6             Rechteck                         ///
   ///             7             Pfeil                            ///
   ///             8             Messlinie                        ///
   ///             9             Winkel                           ///
   ///             10            Linie                            ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   sRegKey, lstampname: string;
   Reg: TRegistry;
   fsTmp: TFontStyles;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   //    ssTmp: TIEVSoftShadow;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;
   lszusstring: string;
begin
   Result := True;
   reg := TRegistry.Create;
   floadedindex := ObjTyp;
   if fifavnum = 0 then
   begin
      lszusstring := '';
   end
   else
   begin
      lszusstring := inttostr(fifavnum);
   end;
   try
      try
         cbx_textform.Visible := False;
         lbl_nummer.visible := false;
         cbx_nummer.Visible := False;
         clbx_CLabel.visible := true;
         clbx_CLabel.visible := false;
         clbx_CNoteBorder.visible := true;
         clbx_CNoteBorder.visible := false;
         case ObjTyp of
            0:
            begin
               sRegKey := 'HiLite' + lszusstring;
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
               lbl_nummer.visible := true;
               cbx_nummer.Visible := true;
               cbx_nummer.itemindex := fifavnum;
            end;
            1:
            begin
               sRegKey := 'Note' + lszusstring;
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := False;
               clbx_CBorder.Visible := False;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := True;
               clbx_CNoteBorder.Visible := True;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := False;
               cbx_BBorder.Visible := False;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := True;
               cbx_BNoteBorder.Visible := True;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := True;
               chbx_AIsHiLite.Visible := False;
               lbl_nummer.visible := true;
               cbx_nummer.Visible := true;
               cbx_nummer.itemindex := fifavnum;
            end;
            2:
            begin
               sRegKey := 'Text' + lszusstring;
               cbx_BBackground.ItemIndex := 0;
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := False;
               clbx_CBorder.Visible := False;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := True;
               clbx_CNoteBorder.Visible := True;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := False;
               cbx_BBorder.Visible := False;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := True;
               cbx_BNoteBorder.Visible := True;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := True;
               chbx_AIsHiLite.Visible := False;
               cbx_textform.Visible := True;
               lbl_nummer.visible := true;
               cbx_nummer.Visible := true;
               cbx_nummer.itemindex := fifavnum;
            end;
            3:
            begin
               sRegKey := 'Stempel';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := False;
               clbx_CBorder.Visible := False;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := True;
               clbx_CNoteBorder.Visible := True;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := False;
               cbx_BBorder.Visible := False;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := True;
               cbx_BNoteBorder.Visible := True;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := True;
               lbl_nummer.visible := false;
               cbx_nummer.Visible := false;
               chbx_AIsHiLite.Visible := False;
            end;
            4:
            begin
               sRegKey := 'LineLabel';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := True;
               chbx_AIsHiLite.Visible := False;
            end;
            5:
            begin
               sRegKey := 'Polyline';
               lbl_CBackground.Visible := False;
               clbx_CBackground.Visible := False;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
            end;
            6:
            begin
               sRegKey := 'Poligon';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
            end;
            7:
            begin
               sRegKey := 'Ellipse';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
            end;
            8:
            begin
               sRegKey := 'Box';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := True;
            end;
            9:
            begin
               sRegKey := 'Arrow';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := False;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
               chbx_AIsHiLite.Checked := False;
            end;
            10:
            begin
               sRegKey := 'Ruler';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := False;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Checked := False;
            end;
            11:
            begin
               sRegKey := 'Angle';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
            end;
            12:
            begin
               sRegKey := 'Buchungsstempel';
               lbl_CBackground.Visible := True;
               clbx_CBackground.Visible := True;
               lbl_CBorder.Visible := False;
               clbx_CBorder.Visible := False;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := True;
               clbx_CNoteBorder.Visible := True;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := False;
               cbx_BBorder.Visible := False;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := True;
               cbx_BNoteBorder.Visible := True;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Checked := False;
            end;

            13:
            begin
               sRegKey := 'Freihand' + lszusstring;
               lbl_CBackground.Visible := False;
               clbx_CBackground.Visible := False;
               lbl_CBorder.Visible := True;
               clbx_CBorder.Visible := True;
               lbl_CLabel.Visible := False;
               clbx_CLabel.Visible := False;
               lbl_CNoteBorder.Visible := False;
               clbx_CNoteBorder.Visible := False;
               lbl_BBackground.Visible := True;
               cbx_BBackground.Visible := True;
               lbl_BBorder.Visible := True;
               cbx_BBorder.Visible := True;
               lbl_BLabel.Visible := False;
               cbx_BLabel.Visible := False;
               lbl_BNoteBorder.Visible := False;
               cbx_BNoteBorder.Visible := False;
               grbx_Brush.Visible := True;
               grbx_Text.Visible := False;
               chbx_AIsHiLite.Visible := False;
               lbl_nummer.visible := true;
               cbx_nummer.Visible := true;
               cbx_nummer.itemindex := fifavnum;
            end;
         end;
         with reg do
         begin
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;

            if ((Objtyp = 0) or (Objtyp = 5) or (Objtyp = 6) or
               (Objtyp = 7) or (Objtyp = 8) or (Objtyp = 9) or (Objtyp = 10)
               or (objtyp = 13)) then
            begin
               grbx_Text.Visible := True;
               grbx_Text.Visible := False;
            end
            else
            begin
               grbx_Text.Visible := True;
            end;

            if ObjTyp = 3 then
            begin
               memo_TObjText.Visible := False;
               lv_eigenschaftstempel.Visible := True;
               if lv_eigenschaftstempel.SelCount > 0 then
               begin
                  lstampname := lv_eigenschaftstempel.Selected.SubItems.Strings[0];
               end
               else
               begin
                  ListStamps(True);
                  if lv_eigenschaftstempel.items.Count = 0 then
                  begin
                     BfShowMessage(_('Kein Textstempel vorhanden.') +
                        #13 +_('Bitte erstellen Sie einen neuen Textstempel, um diese Eigenschaften zu bearbeiten.'));
                     pctrl_DocEditOpt.ActivePage := tbs_Stempel;
                     tctrl_Annos.TabIndex := 0;
                     exit;
                  end;
                  lstampname := lv_eigenschaftstempel.items.item[0].SubItems.Strings[0];
               end;
               lv_eigenschaftstempel.SetFocus;
               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + lstampname, True);

               if ValueExists('ObjBrushColor') then
                  clbx_CBackground.Selected := ReadInteger('ObjBrushColor')
               else
                  clbx_CBackground.Selected := 0;
               if ValueExists('ObjPenColor') then
               begin
                  //          clbx_CBorder.Selected := ReadInteger('ObjPenColor');
                  dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
               end
               else
               begin
                  //          clbx_CBorder.Selected := 0;
                  dlg_Schrift.Font.Color := 0;
               end;
               case ObjTyp of
                  0, 4, 5, 6, 7, 8, 9, 10, 11, 13:
                  begin
                     if ValueExists('ObjPenColor') then
                     begin
                        dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
                        clbx_CBorder.Selected := ReadInteger('ObjPenColor');
                     end
                     else
                     begin
                        clbx_CBorder.Selected := 0;
                     end;
                  end;
               end;
               if ValueExists('ObjLabelBrushColor') then
                  clbx_CLabel.Selected := ReadInteger('ObjLabelBrushColor')
               else
                  clbx_CLabel.Selected := 0;
               if ValueExists('ObjMemoBorderColor') then
                  clbx_CNoteBorder.Selected := ReadInteger('ObjMemoBorderColor')
               else
                  clbx_CNoteBorder.Selected := 0;
               if ValueExists('ObjAutoIncreaseLine') then
                  cbx_autolineincrease.checked := ReadBool('ObjAutoIncreaseLine')
               else
                  cbx_autolineincrease.checked := false;
               if ValueExists('ObjAutoIncreaseHeight') then
                  cbx_autoincreasehigh.checked := ReadBool('ObjAutoIncreaseHeight')
               else
                  cbx_autoincreasehigh.checked := false;
               if ValueExists('ObjBrushStyle') then
               begin
                  ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
                  case bsTmp of
                     bsSolid:
                        cbx_BBackground.ItemIndex := 7;
                     bsClear:
                        cbx_BBackground.ItemIndex := 0;
                     bsHorizontal:
                        cbx_BBackground.ItemIndex := 4;
                     bsVertical:
                        cbx_BBackground.ItemIndex := 3;
                     bsFDiagonal:
                        cbx_BBackground.ItemIndex := 1;
                     bsBDiagonal:
                        cbx_BBackground.ItemIndex := 2;
                     bsCross:
                        cbx_BBackground.ItemIndex := 5;
                     bsDiagCross:
                        cbx_BBackground.ItemIndex := 6;
                  end;
               end
               else
               begin
                  cbx_BBackground.ItemIndex := 0;
               end;
               if ValueExists('ObjLabelBrushStyle') then
               begin
                  ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
                  case bsTmp of
                     bsSolid:
                        cbx_BLabel.ItemIndex := 7;
                     bsClear:
                        cbx_BLabel.ItemIndex := 0;
                     bsHorizontal:
                        cbx_BLabel.ItemIndex := 4;
                     bsVertical:
                        cbx_BLabel.ItemIndex := 3;
                     bsFDiagonal:
                        cbx_BLabel.ItemIndex := 1;
                     bsBDiagonal:
                        cbx_BLabel.ItemIndex := 2;
                     bsCross:
                        cbx_BLabel.ItemIndex := 5;
                     bsDiagCross:
                        cbx_BLabel.ItemIndex := 6;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BLabel.ItemIndex := 0;
                  end;
               end
               else
               begin
                  cbx_BLabel.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BLabel.ItemIndex := 1;
                  end;
               end;

               if ValueExists('ObjPenStyle') then
               begin
                  ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
                  case psTmp of
                     psSolid:
                        cbx_BBorder.ItemIndex := 0;
                     psDash:
                        cbx_BBorder.ItemIndex := 2;
                     psDot:
                        cbx_BBorder.ItemIndex := 5;
                     psDashDot:
                        cbx_BBorder.ItemIndex := 3;
                     psDashDotDot:
                        cbx_BBorder.ItemIndex := 4;
                     psClear:
                        cbx_BBorder.ItemIndex := 1;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BBorder.ItemIndex := 1;
                  end;
               end
               else
               begin
                  cbx_BBorder.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BBorder.ItemIndex := 1;
                  end;
               end;
               if ValueExists('ObjMemoBorderStyle') then
               begin
                  ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
                  case psTmp of
                     psSolid:
                        cbx_BNoteBorder.ItemIndex := 0;
                     psDash:
                        cbx_BNoteBorder.ItemIndex := 2;
                     psDot:
                        cbx_BNoteBorder.ItemIndex := 5;
                     psDashDot:
                        cbx_BNoteBorder.ItemIndex := 3;
                     psDashDotDot:
                        cbx_BNoteBorder.ItemIndex := 4;
                     psClear:
                        cbx_BNoteBorder.ItemIndex := 1;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BNoteBorder.ItemIndex := 1;
                  end;

               end
               else
               begin
                  cbx_BNoteBorder.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BNoteBorder.ItemIndex := 1;
                  end;
               end;
               if ValueExists('ObjBeginShape') then
               begin
                  ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
                  case shTmp of
                     iesNONE:
                        rbtn_SSNo.Checked := True;
                     iesINARROW:
                        rbtn_SSIn.Checked := True;
                     iesOUTARROW:
                        rbtn_SSOut.Checked := True;
                  end;
               end
               else
                  rbtn_SSNo.Checked := True;
               if ValueExists('ObjEndShape') then
               begin
                  ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
                  case shTmp of
                     iesNONE:
                        rbtn_SENo.Checked := True;
                     iesINARROW:
                        rbtn_SEIn.Checked := True;
                     iesOUTARROW:
                        rbtn_SEOut.Checked := True;
                  end;
               end
               else
                  rbtn_SENo.Checked := True;
               if ValueExists('ObjShapeHeight') then
                  edt_SSHeight.Text := IntToStr(ReadInteger('ObjShapeHeight'))
               else
                  edt_SSHeight.Text := '0';
               if ValueExists('ObjShapeWidth') then
                  edt_SSWidth.Text := IntToStr(ReadInteger('ObjShapeWidth'))
               else
                  edt_SSWidth.Text := '0';
               if ValueExists('ObjName') then
                  edt_AObjName.Text := ReadString('ObjName')
               else
                  edt_AObjName.Text := _('neues Objekt');
               if ValueExists('ObjPenWidth') then
                  edt_APenWidth.Text := IntToStr(ReadInteger('ObjPenWidth'))
               else
                  edt_APenWidth.Text := '1';
               if ValueExists('ObjRulerType') then
               begin
                  ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
                  case rtTmp of
                     iertRULER:
                        cbx_ARulerTyp.ItemIndex := 0;
                     iertQUOTEBEGIN:
                        cbx_ARulerTyp.ItemIndex := 1;
                     iertQUOTECENTER:
                        cbx_ARulerTyp.ItemIndex := 2;
                     iertQUOTEEND:
                        cbx_ARulerTyp.ItemIndex := 3;
                  end;
               end
               else
                  cbx_ARulerTyp.ItemIndex := 0;
               if ValueExists('ObjRulerUnit') then
               begin
                  ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
                  case ruTmp of
                     ieuPIXELS:
                        cbx_ARulerMes.ItemIndex := 0;
                     ieuINCHES:
                        cbx_ARulerMes.ItemIndex := 1;
                     ieuKM:
                        cbx_ARulerMes.ItemIndex := 5;
                     ieuMETERS:
                        cbx_ARulerMes.ItemIndex := 4;
                     ieuCENTIMETERS:
                        cbx_ARulerMes.ItemIndex := 3;
                     ieuMILLIMETERS:
                        cbx_ARulerMes.ItemIndex := 2;
                     ieuMICRONS:
                        cbx_ARulerMes.ItemIndex := 6;
                     ieuNANOMETERS:
                        cbx_ARulerMes.ItemIndex := 7;
                  end;
               end
               else
                  cbx_ARulerMes.ItemIndex := 0;
               if ValueExists('ObjTransparency') then
                  edt_ATransp.Text := IntToStr(ReadInteger('ObjTransparency'))
               else
                  edt_ATransp.Text := '110';

               if ValueExists('ObjHeight') then
                  edt_objheight.Text := IntToStr(ReadInteger('ObjHeight'))
               else
                  edt_objheight.Text := '400';
               if ValueExists('Objwidth') then
                  Edt_objwidth.Text := IntToStr(ReadInteger('Objwidth'))
               else
                  Edt_objwidth.Text := '400';

               if ValueExists('ObjPolylineClosed') then
                  chbx_AOpenPoly.Checked := not ReadBool('ObjPolylineClosed')
               else
                  chbx_AOpenPoly.Checked := False;
               if Objtyp <> 9 then
               begin
                  if ValueExists('ObjBoxHighlight') then
                     chbx_AIsHiLite.Checked := ReadBool('ObjBoxHighlight')
                  else
                     chbx_AIsHiLite.Checked := False;
               end;
               if ValueExists('ObjStyle') then
               begin
                  ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
                  chbx_ASelectable.Checked := ievsSelectable in osTmp;
                  chbx_AMoveable.Checked := ievsMoveable in osTmp;
                  chbx_ASizeable.Checked := ievsSizeable in osTmp;
                  chbx_AVisible.Checked := ievsVisible in osTmp;
               end
               else
               begin
                  chbx_ASelectable.Checked := True;
                  chbx_AMoveable.Checked := True;
                  chbx_ASizeable.Checked := True;
                  chbx_AVisible.Checked := True;
               end;
               if ValueExists('FontName') then
               begin
                  edt_TFont.Text := ReadString('FontName');
               end
               else
               begin
                  edt_TFont.Text := '';
               end;
               dlg_Schrift.Font.Name := edt_TFont.Text;
               edt_SFont.Text := edt_TFont.Text;
               if ValueExists('FontSize') then
               begin
                  dlg_Schrift.Font.Size := ReadInteger('FontSize');
                  edt_TFontSize.Text := IntToStr(ReadInteger('FontSize'));
               end
               else
               begin
                  dlg_Schrift.Font.Size := 72;
                  edt_TFontSize.Text := '72';
               end;
               if ValueExists('FontColor') then
               begin
                  dlg_Schrift.Font.color := ReadInteger('FontColor');
               end
               else
               if ValueExists('ObjFontColor') then
               begin
                  dlg_Schrift.Font.color := ReadInteger('ObjFontColor');
               end;
               if ValueExists('FontStyle') then
               begin
                  ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
                  dlg_Schrift.Font.Style := fsTmp;
               end
               else
                  dlg_Schrift.Font.Style := [];
               if ValueExists('ObjFontAngle') then
                  edt_TFontAngle.Text := FloatToStr(ReadFloat('ObjFontAngle'))
               else
                  edt_TFontAngle.Text := '0';
               if ValueExists('ObjLabelPosition') then
               begin
                  ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
                  case lpTmp of
                     ielBegin:
                        cbx_TLabelPos.ItemIndex := 0;
                     ielEnd:
                        cbx_TLabelPos.ItemIndex := 1;
                  end;
               end
               else
                  cbx_TLabelPos.ItemIndex := 0;
               if ValueExists('ObjTextAlign') then
               begin
                  ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
                  case taTmp of
                     iejLeft:
                        cbx_TAlign.ItemIndex := 0;
                     iejRight:
                        cbx_TAlign.ItemIndex := 1;
                     iejCenter:
                        cbx_TAlign.ItemIndex := 2;
                     iejJustify:
                        cbx_TAlign.ItemIndex := 3;
                  end;
               end
               else
                  cbx_TAlign.ItemIndex := 0;
               if ValueExists('ObjText') then
                  memo_TObjText.Text := ReadString('ObjText')
               else
                  memo_TObjText.Text := _('neuer Text');
               if ValueExists('ObjTextAutoSize') then
                  chbx_TObjAutoSize.Checked := ReadBool('ObjTextAutoSize')
               else
                  chbx_TObjAutoSize.Checked := False;
               if ValueExists('ObjFontLocked') then
                  chbx_TFontLocked.Checked := ReadBool('ObjFontLocked')
               else
                  chbx_TFontLocked.Checked := False;
               if ValueExists('Showtextform') then
                  cbx_textform.Checked := ReadBool('Showtextform')
               else
                  cbx_textform.Checked := false;
               CloseKey;
            end
            else
            begin
               lv_eigenschaftstempel.Visible := False;
               memo_TObjText.Visible := True;
               memo_TObjText.Update;
               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\' + sRegKey, True);
               if ValueExists('ObjBrushColor') then
                  clbx_CBackground.Selected := ReadInteger('ObjBrushColor')
               else
                  clbx_CBackground.Selected := 0;
               if ValueExists('ObjPenColor') then
               begin
                  //          clbx_CBorder.Selected := ReadInteger('ObjPenColor');
                  dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
               end
               else
               begin
                  //          clbx_CBorder.Selected := 0;
                  dlg_Schrift.Font.Color := 0;
               end;
               case ObjTyp of
                  0, 4, 5, 6, 7, 8, 9, 10, 11, 13:
                  begin
                     if ValueExists('ObjPenColor') then
                     begin
                        dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
                        clbx_CBorder.Selected := ReadInteger('ObjPenColor');
                     end
                     else
                     begin
                        clbx_CBorder.Selected := 0;
                     end;
                  end;
               end;
               if ValueExists('ObjLabelBrushColor') then
                  clbx_CLabel.Selected := ReadInteger('ObjLabelBrushColor')
               else
                  clbx_CLabel.Selected := 0;
               if ValueExists('ObjMemoBorderColor') then
                  clbx_CNoteBorder.Selected := ReadInteger('ObjMemoBorderColor')
               else
                  clbx_CNoteBorder.Selected := 0;
               if ValueExists('ObjAutoIncreaseLine') then
                  cbx_autolineincrease.checked := ReadBool('ObjAutoIncreaseLine')
               else
                  cbx_autolineincrease.checked := false;
               if ValueExists('ObjAutoIncreaseHeight') then
                  cbx_autoincreasehigh.checked := ReadBool('ObjAutoIncreaseHeight')
               else
                  cbx_autoincreasehigh.checked := false;
               if ValueExists('ObjBrushStyle') then
               begin
                  ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
                  case bsTmp of
                     bsSolid:
                        cbx_BBackground.ItemIndex := 7;
                     bsClear:
                        cbx_BBackground.ItemIndex := 0;
                     bsHorizontal:
                        cbx_BBackground.ItemIndex := 4;
                     bsVertical:
                        cbx_BBackground.ItemIndex := 3;
                     bsFDiagonal:
                        cbx_BBackground.ItemIndex := 1;
                     bsBDiagonal:
                        cbx_BBackground.ItemIndex := 2;
                     bsCross:
                        cbx_BBackground.ItemIndex := 5;
                     bsDiagCross:
                        cbx_BBackground.ItemIndex := 6;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BBackground.ItemIndex := 0;
                  end;
               end
               else
               begin
                  cbx_BBackground.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BBackground.ItemIndex := 0;
                  end;
               end;
               if ValueExists('ObjLabelBrushStyle') then
               begin
                  ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
                  case bsTmp of
                     bsSolid:
                        cbx_BLabel.ItemIndex := 7;
                     bsClear:
                        cbx_BLabel.ItemIndex := 0;
                     bsHorizontal:
                        cbx_BLabel.ItemIndex := 4;
                     bsVertical:
                        cbx_BLabel.ItemIndex := 3;
                     bsFDiagonal:
                        cbx_BLabel.ItemIndex := 1;
                     bsBDiagonal:
                        cbx_BLabel.ItemIndex := 2;
                     bsCross:
                        cbx_BLabel.ItemIndex := 5;
                     bsDiagCross:
                        cbx_BLabel.ItemIndex := 6;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BLabel.ItemIndex := 0;
                  end;
               end
               else
               begin
                  cbx_BLabel.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BLabel.ItemIndex := 1;
                  end;
               end;

               if ValueExists('ObjPenStyle') then
               begin
                  ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
                  case psTmp of
                     psSolid:
                        cbx_BBorder.ItemIndex := 0;
                     psDash:
                        cbx_BBorder.ItemIndex := 2;
                     psDot:
                        cbx_BBorder.ItemIndex := 5;
                     psDashDot:
                        cbx_BBorder.ItemIndex := 3;
                     psDashDotDot:
                        cbx_BBorder.ItemIndex := 4;
                     psClear:
                        cbx_BBorder.ItemIndex := 1;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BBorder.ItemIndex := 1;
                  end;
               end
               else
               begin
                  cbx_BBorder.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BBorder.ItemIndex := 1;
                  end;
               end;
               if ValueExists('ObjMemoBorderStyle') then
               begin
                  ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
                  case psTmp of
                     psSolid:
                        cbx_BNoteBorder.ItemIndex := 0;
                     psDash:
                        cbx_BNoteBorder.ItemIndex := 2;
                     psDot:
                        cbx_BNoteBorder.ItemIndex := 5;
                     psDashDot:
                        cbx_BNoteBorder.ItemIndex := 3;
                     psDashDotDot:
                        cbx_BNoteBorder.ItemIndex := 4;
                     psClear:
                        cbx_BNoteBorder.ItemIndex := 1;
                  end;
                  if objtyp = 2 then
                  begin
                     cbx_BNoteBorder.ItemIndex := 1;
                  end;

               end
               else
               begin
                  cbx_BNoteBorder.ItemIndex := 0;

                  if objtyp = 2 then
                  begin
                     cbx_BNoteBorder.ItemIndex := 1;
                  end;
               end;
               if ValueExists('ObjBeginShape') then
               begin
                  ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
                  case shTmp of
                     iesNONE:
                        rbtn_SSNo.Checked := True;
                     iesINARROW:
                        rbtn_SSIn.Checked := True;
                     iesOUTARROW:
                        rbtn_SSOut.Checked := True;
                  end;
               end
               else
                  rbtn_SSNo.Checked := True;
               if ValueExists('ObjEndShape') then
               begin
                  ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
                  case shTmp of
                     iesNONE:
                        rbtn_SENo.Checked := True;
                     iesINARROW:
                        rbtn_SEIn.Checked := True;
                     iesOUTARROW:
                        rbtn_SEOut.Checked := True;
                  end;
               end
               else
                  rbtn_SENo.Checked := True;
               if ValueExists('ObjShapeHeight') then
                  edt_SSHeight.Text := IntToStr(ReadInteger('ObjShapeHeight'))
               else
                  edt_SSHeight.Text := '0';
               if ValueExists('ObjShapeWidth') then
                  edt_SSWidth.Text := IntToStr(ReadInteger('ObjShapeWidth'))
               else
                  edt_SSWidth.Text := '0';
               if ValueExists('ObjName') then
                  edt_AObjName.Text := ReadString('ObjName')
               else
                  edt_AObjName.Text := sRegKey;
               if ValueExists('ObjPenWidth') then
                  edt_APenWidth.Text := IntToStr(ReadInteger('ObjPenWidth'))
               else
                  edt_APenWidth.Text := '1';
               if ValueExists('ObjRulerType') then
               begin
                  ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
                  case rtTmp of
                     iertRULER:
                        cbx_ARulerTyp.ItemIndex := 0;
                     iertQUOTEBEGIN:
                        cbx_ARulerTyp.ItemIndex := 1;
                     iertQUOTECENTER:
                        cbx_ARulerTyp.ItemIndex := 2;
                     iertQUOTEEND:
                        cbx_ARulerTyp.ItemIndex := 3;
                  end;
               end
               else
                  cbx_ARulerTyp.ItemIndex := 0;
               if ValueExists('ObjRulerUnit') then
               begin
                  ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
                  case ruTmp of
                     ieuPIXELS:
                        cbx_ARulerMes.ItemIndex := 0;
                     ieuINCHES:
                        cbx_ARulerMes.ItemIndex := 1;
                     ieuKM:
                        cbx_ARulerMes.ItemIndex := 5;
                     ieuMETERS:
                        cbx_ARulerMes.ItemIndex := 4;
                     ieuCENTIMETERS:
                        cbx_ARulerMes.ItemIndex := 3;
                     ieuMILLIMETERS:
                        cbx_ARulerMes.ItemIndex := 2;
                     ieuMICRONS:
                        cbx_ARulerMes.ItemIndex := 6;
                     ieuNANOMETERS:
                        cbx_ARulerMes.ItemIndex := 7;
                  end;
               end
               else
                  cbx_ARulerMes.ItemIndex := 0;
               if ValueExists('ObjTransparency') then
                  edt_ATransp.Text := IntToStr(ReadInteger('ObjTransparency'))
               else
                  edt_ATransp.Text := '110';  

               if ValueExists('ObjHeight') then
                  edt_objheight.Text := IntToStr(ReadInteger('ObjHeight'))
               else
                  edt_objheight.Text := '400';
               if ValueExists('Objwidth') then
                  Edt_objwidth.Text := IntToStr(ReadInteger('Objwidth'))
               else
                  Edt_objwidth.Text := '400';
       { if  ValueExists('Objwidth') then
          Objwidth[idx] := ReadInteger('Objwidth', 400);
        if  ValueExists('objheight') then
          Objheight[idx] := ReadInteger('objheight', 400);}
               if ValueExists('ObjPolylineClosed') then
                  chbx_AOpenPoly.Checked := not ReadBool('ObjPolylineClosed')
               else
               begin
                  if ObjTyp = 13 then
                  begin
                     chbx_AOpenPoly.Checked := True;
                  end
                  else
                  begin
                     chbx_AOpenPoly.Checked := False;
                  end;
               end;
               if Objtyp <> 9 then
               begin
                  if ValueExists('ObjBoxHighlight') then
                     chbx_AIsHiLite.Checked := ReadBool('ObjBoxHighlight')
                  else
                     chbx_AIsHiLite.Checked := False;
               end;
               if ValueExists('ObjStyle') then
               begin
                  ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
                  chbx_ASelectable.Checked := ievsSelectable in osTmp;
                  chbx_AMoveable.Checked := ievsMoveable in osTmp;
                  chbx_ASizeable.Checked := ievsSizeable in osTmp;
                  chbx_AVisible.Checked := ievsVisible in osTmp;
               end
               else
               begin
                  chbx_ASelectable.Checked := True;
                  chbx_AMoveable.Checked := True;
                  chbx_ASizeable.Checked := True;
                  chbx_AVisible.Checked := True;
               end;
               if ValueExists('ObjFontName') then
               begin
                  edt_TFont.Text := ReadString('ObjFontName');
               end
               else
               begin
                  edt_TFont.Text := '';
               end;
               dlg_Schrift.Font.Name := edt_TFont.Text;
               edt_SFont.Text := edt_TFont.Text;
               if ValueExists('ObjFontHeight') then
               begin
                  dlg_Schrift.Font.Size := ReadInteger('ObjFontHeight');
                  edt_TFontSize.Text := IntToStr(ReadInteger('ObjFontHeight'));
               end
               else
               begin
                  dlg_Schrift.Font.Size := 72;
                  edt_TFontSize.Text := '72';
               end;
               if ValueExists('ObjFontStyles') then
               begin
                  ReadBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
                  dlg_Schrift.Font.Style := fsTmp;
               end
               else
                  dlg_Schrift.Font.Style := [];
               if ValueExists('ObjFontAngle') then
                  edt_TFontAngle.Text := FloatToStr(ReadFloat('ObjFontAngle'))
               else
                  edt_TFontAngle.Text := '0';
               if ValueExists('ObjLabelPosition') then
               begin
                  ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
                  case lpTmp of
                     ielBegin:
                        cbx_TLabelPos.ItemIndex := 0;
                     ielEnd:
                        cbx_TLabelPos.ItemIndex := 1;
                  end;
               end
               else
                  cbx_TLabelPos.ItemIndex := 0;
               if ValueExists('ObjTextAlign') then
               begin
                  ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
                  case taTmp of
                     iejLeft:
                        cbx_TAlign.ItemIndex := 0;
                     iejRight:
                        cbx_TAlign.ItemIndex := 1;
                     iejCenter:
                        cbx_TAlign.ItemIndex := 2;
                     iejJustify:
                        cbx_TAlign.ItemIndex := 3;
                  end;
               end
               else
                  cbx_TAlign.ItemIndex := 0;
               if ValueExists('ObjText') then
                  memo_TObjText.Text := ReadString('ObjText')
               else
                  memo_TObjText.Text := _('neuer Text');
               if ValueExists('ObjTextAutoSize') then
                  chbx_TObjAutoSize.Checked := ReadBool('ObjTextAutoSize')
               else
                  chbx_TObjAutoSize.Checked := False;
               if ValueExists('ObjFontLocked') then
                  chbx_TFontLocked.Checked := ReadBool('ObjFontLocked')
               else
                  chbx_TFontLocked.Checked := False;
               if ValueExists('Showtextform') then
                  cbx_textform.Checked := ReadBool('Showtextform')
               else
                  cbx_textform.Checked := false;
               CloseKey;
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_voransichtoptionen.LoadObjVal', _('Fehler beim Lesen des Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

/////////////////////////////////////////////////////////////////////////////////////////////
//    Objekt eigenschaften in der Registrierung sichern  


function Tfrm_voransichtoptionen.SaveObjVal(ObjTyp: integer): boolean;
   //////////////////////////////////////////////////////////////////
   ///  11.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function sichert die Objekteigenschaften des Ob-    ///
   ///  jekttyps [ObjTyp] in der Registrierung.                   ///
   ///                                                            ///
   ///  Parameter: ObjTyp        Objekttyp                        ///
   ///             0             Textmarker                       ///
   ///             1             Notiz                            ///
   ///             2             Beschriftung                     ///
   ///             3             Freihandlinie                    ///
   ///             4             Poligon                          ///
   ///             5             Ellipse                          ///
   ///             6             Rechteck                         ///
   ///             7             Pfeil                            ///
   ///             8             Messlinie                        ///
   ///             9             Winkel                           ///
   ///             10            Linie                            ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   sRegKey: string;
   Reg: TRegistry;
   fsTmp: TFontStyles;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   //    ssTmp: TIEVSoftShadow;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;
   lszusstring: string;
begin
   Result := True;
   reg := TRegistry.Create;
   if fifavnum = 0 then
   begin
      lszusstring := '';
   end
   else
   begin
      lszusstring := inttostr(fifavnum);
   end;
   try
      try
         case ObjTyp of
            0:
               sRegKey := 'HiLite' + lszusstring;
            1:
               sRegKey := 'Note' + lszusstring;
            2:
               sRegKey := 'Text' + lszusstring;
            3:
               sRegKey := 'Stempel';
            4:
               sRegKey := 'LineLabel';
            5:
               sRegKey := 'Polyline';
            6:
               sRegKey := 'Poligon';
            7:
               sRegKey := 'Ellipse';
            8:
               sRegKey := 'Box';
            9:
               sRegKey := 'Arrow';
            10:
               sRegKey := 'Ruler';
            11:
               sRegKey := 'Angle';
            12:
               sRegKey := 'Buchungsstempel';
            13:
               sRegKey := 'Freihand' + lszusstring;
         end;

         with reg do
         begin
            if ObjTyp = 3 then
            begin
               if lv_eigenschaftstempel.Selected = nil then
                  exit;

               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +
                  lv_eigenschaftstempel.Selected.SubItems.Strings[0], True);
               WriteInteger('ObjBrushColor', clbx_CBackground.Selected);
               WriteInteger('ObjPenColor', dlg_Schrift.Font.Color);
               WriteInteger('ObjLabelBrushColor', clbx_CLabel.Selected);
               WriteInteger('ObjMemoBorderColor', clbx_CNoteBorder.Selected);
               case cbx_BBackground.ItemIndex of
                  0:
                     bsTmp := bsClear;
                  1:
                     bsTmp := bsFDiagonal;
                  2:
                     bsTmp := bsBDiagonal;
                  3:
                     bsTmp := bsVertical;
                  4:
                     bsTmp := bsHorizontal;
                  5:
                     bsTmp := bsCross;
                  6:
                     bsTmp := bsDiagCross;
                  7:
                     bsTmp := bsSolid;
               end;
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               case cbx_BLabel.ItemIndex of
                  0:
                     bsTmp := bsClear;
                  1:
                     bsTmp := bsFDiagonal;
                  2:
                     bsTmp := bsBDiagonal;
                  3:
                     bsTmp := bsVertical;
                  4:
                     bsTmp := bsHorizontal;
                  5:
                     bsTmp := bsCross;
                  6:
                     bsTmp := bsDiagCross;
                  7:
                     bsTmp := bsSolid;
               end;
               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
               case cbx_BBorder.ItemIndex of
                  0:
                     psTmp := psSolid;
                  1:
                     psTmp := psClear;
                  2:
                     psTmp := psDash;
                  3:
                     psTmp := psDashDot;
                  4:
                     psTmp := psDashDotDot;
                  5:
                     psTmp := psDot;
               end;
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               case cbx_BNoteBorder.ItemIndex of
                  0:
                     psTmp := psSolid;
                  1:
                     psTmp := psClear;
                  2:
                     psTmp := psDash;
                  3:
                     psTmp := psDashDot;
                  4:
                     psTmp := psDashDotDot;
                  5:
                     psTmp := psDot;
               end;
               WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
               if rbtn_SSNo.Checked then
                  shTmp := iesNONE;
               if rbtn_SSIn.Checked then
                  shTmp := iesINARROW;
               if rbtn_SSOut.Checked then
                  shTmp := iesOUTARROW;
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if rbtn_SENo.Checked then
                  shTmp := iesNONE;
               if rbtn_SEIn.Checked then
                  shTmp := iesINARROW;
               if rbtn_SEOut.Checked then
                  shTmp := iesOUTARROW;
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               WriteInteger('ObjShapeHeight', StrToInt(edt_SSHeight.Text));
               WriteInteger('ObjShapeWidth', StrToInt(edt_SSWidth.Text));
               WriteString('ObjName', edt_AObjName.Text);
               WriteInteger('ObjPenWidth', StrToInt(edt_APenWidth.Text));
               case cbx_ARulerTyp.ItemIndex of
                  0:
                     rtTmp := iertRULER;
                  1:
                     rtTmp := iertQUOTEBEGIN;
                  2:
                     rtTmp := iertQUOTECENTER;
                  3:
                     rtTmp := iertQUOTEEND;
               end;
               WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
               case cbx_ARulerMes.ItemIndex of
                  0:
                     ruTmp := ieuPIXELS;
                  1:
                     ruTmp := ieuINCHES;
                  2:
                     ruTmp := ieuMILLIMETERS;
                  3:
                     ruTmp := ieuCENTIMETERS;
                  4:
                     ruTmp := ieuMETERS;
                  5:
                     ruTmp := ieuKM;
                  6:
                     ruTmp := ieuMICRONS;
                  7:
                     ruTmp := ieuNANOMETERS;
               end;
               WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
               WriteInteger('ObjTransparency', StrToInt(edt_ATransp.Text));
               WriteInteger('Objwidth', StrToInt(Edt_objwidth.Text));
               WriteInteger('Objheight', StrToInt(Edt_objheight.Text));
               WriteBool('ObjPolylineClosed', not chbx_AOpenPoly.Checked);
               WriteBool('ObjBoxHighlight', chbx_AIsHiLite.Checked);
               osTmp := [];
               if chbx_ASelectable.Checked then
                  osTmp := osTmp + [ievsSelectable];
               if chbx_AMoveable.Checked then
                  osTmp := osTmp + [ievsMoveable];
               if chbx_ASizeable.Checked then
                  osTmp := osTmp + [ievsSizeable];
               if chbx_AVisible.Checked then
                  osTmp := osTmp + [ievsVisible];
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               WriteString('ObjFontName', dlg_Schrift.Font.Name);
               WriteString('FontName', dlg_Schrift.Font.Name);
               WriteInteger('ObjFontColor', dlg_Schrift.Font.Color);
               WriteInteger('FontColor', dlg_Schrift.Font.Color);
               WriteInteger('ObjFontHeight', StrToInt(edt_TFontSize.Text));
               WriteInteger('Fontsize', StrToInt(edt_TFontSize.Text));
               WriteInteger('ObjFontSize', StrToInt(edt_TFontSize.Text));
               fsTmp := dlg_Schrift.Font.Style;
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
               WriteInteger('ObjFontHeight', StrToInt(edt_TFontSize.Text));
               WriteFloat('ObjFontAngle', StrToFloat(edt_TFontAngle.Text));
               case cbx_TLabelPos.ItemIndex of
                  0:
                     lpTmp := ielBegin;
                  1:
                     lpTmp := ielEnd;
               end;
               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
               case cbx_TAlign.ItemIndex of
                  0:
                     taTmp := iejLeft;
                  1:
                     taTmp := iejRight;
                  2:
                     taTmp := iejCenter;
                  3:
                     taTmp := iejJustify;
               end;
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
               WriteString('ObjText', memo_TObjText.Text);
               WriteBool('ObjTextAutoSize', chbx_TObjAutoSize.Checked);
               WriteBool('ObjFontLocked', chbx_TFontLocked.Checked);
               WriteBool('Showtextform', cbx_textform.Checked);
               CloseKey;
            end
            else
            begin
               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\' + sRegKey, True);
               WriteInteger('ObjBrushColor', clbx_CBackground.Selected);
               case ObjTyp of
                  0, 4, 5, 6, 7, 8, 9, 10, 11, 13:
                  begin
                     WriteInteger('ObjPenColor', clbx_CBorder.Selected);
                  end;
               else
               begin
                  WriteInteger('ObjPenColor', dlg_Schrift.Font.Color);
               end;
               end;
               WriteInteger('ObjLabelBrushColor', clbx_CLabel.Selected);
               WriteInteger('ObjMemoBorderColor', clbx_CNoteBorder.Selected);
               WriteBool('ObjAutoIncreaseLine', cbx_autolineincrease.checked);
               WriteBool('ObjAutoIncreaseHeight', cbx_autoincreasehigh.checked);
               case cbx_BBackground.ItemIndex of
                  0:
                     bsTmp := bsClear;
                  1:
                     bsTmp := bsFDiagonal;
                  2:
                     bsTmp := bsBDiagonal;
                  3:
                     bsTmp := bsVertical;
                  4:
                     bsTmp := bsHorizontal;
                  5:
                     bsTmp := bsCross;
                  6:
                     bsTmp := bsDiagCross;
                  7:
                     bsTmp := bsSolid;
               end;
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               case cbx_BLabel.ItemIndex of
                  0:
                     bsTmp := bsClear;
                  1:
                     bsTmp := bsFDiagonal;
                  2:
                     bsTmp := bsBDiagonal;
                  3:
                     bsTmp := bsVertical;
                  4:
                     bsTmp := bsHorizontal;
                  5:
                     bsTmp := bsCross;
                  6:
                     bsTmp := bsDiagCross;
                  7:
                     bsTmp := bsSolid;
               end;
               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
               case cbx_BBorder.ItemIndex of
                  0:
                     psTmp := psSolid;
                  1:
                     psTmp := psClear;
                  2:
                     psTmp := psDash;
                  3:
                     psTmp := psDashDot;
                  4:
                     psTmp := psDashDotDot;
                  5:
                     psTmp := psDot;
               end;
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               case cbx_BNoteBorder.ItemIndex of
                  0:
                     psTmp := psSolid;
                  1:
                     psTmp := psClear;
                  2:
                     psTmp := psDash;
                  3:
                     psTmp := psDashDot;
                  4:
                     psTmp := psDashDotDot;
                  5:
                     psTmp := psDot;
               end;
               WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
               if rbtn_SSNo.Checked then
                  shTmp := iesNONE;
               if rbtn_SSIn.Checked then
                  shTmp := iesINARROW;
               if rbtn_SSOut.Checked then
                  shTmp := iesOUTARROW;
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if rbtn_SENo.Checked then
                  shTmp := iesNONE;
               if rbtn_SEIn.Checked then
                  shTmp := iesINARROW;
               if rbtn_SEOut.Checked then
                  shTmp := iesOUTARROW;
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               WriteInteger('ObjShapeHeight', StrToInt(edt_SSHeight.Text));
               WriteInteger('ObjShapeWidth', StrToInt(edt_SSWidth.Text));
               WriteString('ObjName', edt_AObjName.Text);
               WriteInteger('ObjPenWidth', StrToInt(edt_APenWidth.Text));
               case cbx_ARulerTyp.ItemIndex of
                  0:
                     rtTmp := iertRULER;
                  1:
                     rtTmp := iertQUOTEBEGIN;
                  2:
                     rtTmp := iertQUOTECENTER;
                  3:
                     rtTmp := iertQUOTEEND;
               end;
               WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
               case cbx_ARulerMes.ItemIndex of
                  0:
                     ruTmp := ieuPIXELS;
                  1:
                     ruTmp := ieuINCHES;
                  2:
                     ruTmp := ieuMILLIMETERS;
                  3:
                     ruTmp := ieuCENTIMETERS;
                  4:
                     ruTmp := ieuMETERS;
                  5:
                     ruTmp := ieuKM;
                  6:
                     ruTmp := ieuMICRONS;
                  7:
                     ruTmp := ieuNANOMETERS;
               end;
               WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
               WriteInteger('ObjTransparency', StrToInt(edt_ATransp.Text));
               WriteInteger('Objwidth', StrToInt(Edt_objwidth.Text));
               WriteInteger('Objheight', StrToInt(Edt_objheight.Text));
               WriteBool('ObjPolylineClosed', not chbx_AOpenPoly.Checked);
               WriteBool('ObjBoxHighlight', chbx_AIsHiLite.Checked);
               osTmp := [];
               if chbx_ASelectable.Checked then
                  osTmp := osTmp + [ievsSelectable];
               if chbx_AMoveable.Checked then
                  osTmp := osTmp + [ievsMoveable];
               if chbx_ASizeable.Checked then
                  osTmp := osTmp + [ievsSizeable];
               if chbx_AVisible.Checked then
                  osTmp := osTmp + [ievsVisible];
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               WriteString('ObjFontName', dlg_Schrift.Font.Name);
               WriteInteger('ObjFontSize', StrToInt(edt_TFontSize.Text));
               WriteInteger('ObjFontHeight', StrToInt(edt_TFontSize.Text));
               fsTmp := dlg_Schrift.Font.Style;
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
               WriteInteger('FontSize', StrToInt(edt_TFontSize.Text));
               WriteFloat('ObjFontAngle', StrToFloat(edt_TFontAngle.Text));
               case cbx_TLabelPos.ItemIndex of
                  0:
                     lpTmp := ielBegin;
                  1:
                     lpTmp := ielEnd;
               end;
               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
               case cbx_TAlign.ItemIndex of
                  0:
                     taTmp := iejLeft;
                  1:
                     taTmp := iejRight;
                  2:
                     taTmp := iejCenter;
                  3:
                     taTmp := iejJustify;
               end;
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
               WriteString('ObjText', memo_TObjText.Text);
               WriteBool('ObjTextAutoSize', chbx_TObjAutoSize.Checked);
               WriteBool('ObjFontLocked', chbx_TFontLocked.Checked);
               WriteBool('Showtextform', cbx_textform.Checked);
               CloseKey;
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_voransichtoptionen.SaveObjVal',
               _('Fehler beim Schreiben in die Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;


procedure Tfrm_voransichtoptionen.btn_SaveClick(Sender: TObject);
begin
   if pctrl_DocEditOpt.ActivePage = tbs_Annotations then
   begin
      SaveObjVal(tctrl_Annos.TabIndex);
   end;
   SaveDocEditOpt;
end;

procedure Tfrm_voransichtoptionen.tctrl_AnnosChange(Sender: TObject);
begin
   LoadObjVal(tctrl_Annos.TabIndex);
end;

procedure Tfrm_voransichtoptionen.tctrl_AnnosChanging(Sender: TObject;
   var AllowChange: boolean);
begin
   SaveObjVal(tctrl_Annos.TabIndex);
end;

procedure Tfrm_voransichtoptionen.btn_okClick(Sender: TObject);
begin
   ////////////////////////////////////////////////////////////////////////////////////

   //  Modifizierte Daten des Objektes Speichern


   if pctrl_DocEditOpt.ActivePage = tbs_Annotations then
   begin
      SaveObjVal(tctrl_Annos.TabIndex);
   end;
   SaveDocEditOpt;
end;

procedure Tfrm_voransichtoptionen.edt_SSHeightChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_SSHeight.Text, iValue) then
      edt_SSHeight.Tag := iValue
   else
      edt_SSHeight.Text := IntToStr(edt_SSHeight.Tag);
end;

procedure Tfrm_voransichtoptionen.edt_SSWidthChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_SSWidth.Text, iValue) then
      edt_SSWidth.Tag := iValue
   else
      edt_SSWidth.Text := IntToStr(edt_SSWidth.Tag);
end;

procedure Tfrm_voransichtoptionen.edt_APenWidthChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_APenWidth.Text, iValue) then
      edt_APenWidth.Tag := iValue
   else
      edt_APenWidth.Text := IntToStr(edt_APenWidth.Tag);
end;

///////////////////////////////////////////////////////////////////////////////////
//  Transparenz aendern

procedure Tfrm_voransichtoptionen.edt_ATranspChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_APenWidth.Text, iValue) then
   begin
      if iValue < 0 then
         iValue := 0;
      if iValue > 255 then
         iValue := 255;
      frm_voransichtoptionen.edt_APenWidth.Tag := iValue;

   end
   else
      edt_APenWidth.Text := IntToStr(edt_APenWidth.Tag);
end;

procedure Tfrm_voransichtoptionen.edt_TFontAngleChange(Sender: TObject);
var
   fValue: double;
begin
   if TryStrToFloat(edt_APenWidth.Text, fValue) then
   begin
      if (fValue < -359) or (fValue > 359) then
      begin
         fValue := 0;
         edt_APenWidth.Text := '0';
      end;
   end
   else
      edt_APenWidth.Text := '0';
end;

procedure Tfrm_voransichtoptionen.edt_TFontSizeChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_TFontSize.Text, iValue) then
   begin
      if iValue < 0 then
         iValue := 0;
      edt_TFontSize.Tag := iValue;
   end
   else
      edt_TFontSize.Text := IntToStr(edt_TFontSize.Tag);
end;

procedure Tfrm_voransichtoptionen.cbx_TLabelPosChange(Sender: TObject);
begin
   if cbx_TLabelPos.ItemIndex = -1 then
      cbx_TLabelPos.ItemIndex := 0;
end;

procedure Tfrm_voransichtoptionen.cbx_TAlignChange(Sender: TObject);
begin
   if cbx_TAlign.ItemIndex = -1 then
      cbx_TAlign.ItemIndex := 0;
end;

procedure Tfrm_voransichtoptionen.cbx_ARulerTypChange(Sender: TObject);
begin
   if cbx_ARulerTyp.ItemIndex = -1 then
      cbx_ARulerTyp.ItemIndex := 0;
end;

procedure Tfrm_voransichtoptionen.cbx_ARulerMesChange(Sender: TObject);
begin
   if cbx_ARulerMes.ItemIndex = -1 then
      cbx_ARulerMes.ItemIndex := 0;
end;

procedure Tfrm_voransichtoptionen.sbtn_TFontClick(Sender: TObject);
begin
   if dlg_Schrift.Execute then
   begin
      edt_TFont.Text := dlg_Schrift.Font.Name;
      edt_SFont.Text := edt_TFont.Text;
      edt_TFontSize.Text := IntToStr(dlg_Schrift.Font.Size);
   end;
end;

procedure Tfrm_voransichtoptionen.chbx_EnaRenderEnClick(Sender: TObject);
begin
   frm_mainform.fra_Voransicht.img_docview.ObjGraphicRender := chbx_EnaRenderEn.Checked;
end;

procedure Tfrm_voransichtoptionen.chbx_EnaAntialiasClick(Sender: TObject);
begin
   frm_mainform.fra_Voransicht.img_docview.ObjAntialias := chbx_EnaAntialias.Checked;
end;

procedure Tfrm_voransichtoptionen.edt_SBildChange(Sender: TObject);
begin
   if FileExists(edt_SBild.Text) then
      img_SBild.IO.LoadFromFile(edt_SBild.Text);
end;

procedure Tfrm_voransichtoptionen.btn_NewStampClick(Sender: TObject);
begin
   CreStamp;
   btn_SaveStamp.Enabled := True;
   btn_DelStamp.Enabled := True;
   btn_SaveStampClick(Sender);   //3.5.0.58 [2197]
end;

procedure Tfrm_voransichtoptionen.btn_SaveStampClick(Sender: TObject);
begin
   SavStamp(sGStampKey);
   ListStamps(False);
   loadfavstampbuttons;
end;

procedure Tfrm_voransichtoptionen.btn_DelStampClick(Sender: TObject);
var
   liindex: integer;
begin
   if lv_Stamps.SelCount > 0 then
   begin
      liindex := lv_Stamps.Selected.Index;
      DelStamp(lv_Stamps.Selected.SubItems.Strings[1]);
      ListStamps(False);
      if (liindex < lv_stamps.Items.Count) then
      begin
         if liindex > 0 then
         begin
            lv_stamps.Items[liindex - 1].Selected := True;
            lv_stamps.Items.Item[liindex - 1].Focused := True;
         end
         else
         begin
            lv_stamps.Items[liindex].Selected := True;
            lv_stamps.Items.Item[liindex].Focused := True;
         end;
      end
      else
      begin
         if lv_stamps.Items.Count > 0 then
         begin
            lv_stamps.Items[0].Selected := True;
            lv_stamps.Items.Item[0].Focused := True;
         end;
      end;
      lv_stamps.SetFocus;
      lv_StampsClick(lv_stamps.Selected);
   end;
   loadfavstampbuttons;
end;

procedure Tfrm_voransichtoptionen.lv_StampsClick(Sender: TObject);
begin
   if Sender <> nil then
   begin
      if lv_Stamps.SelCount > 0 then
      begin
         sGStampKey := lv_Stamps.Selected.SubItems.Strings[1];
         LoadStamp(sGStampKey);
         btn_SaveStamp.Enabled := True;
         btn_DelStamp.Enabled := True;
      end;
   end;
end;

procedure Tfrm_voransichtoptionen.sbtn_SBildClick(Sender: TObject);
var
   sFileName: string;
begin
   if PromptForFileName(sFileName) then
      edt_SBild.Text := sFileName;
end;

procedure Tfrm_voransichtoptionen.rbtn_STextClick(Sender: TObject);
begin
   if rbtn_SText.Checked then
   begin
      rbtn_SText.Checked := True;
      memo_SText.Enabled := True;
      sbtn_SFont.Enabled := True;
      edt_SFont.Enabled := True;
      edt_SBild.Enabled := False;
      sbtn_SBild.Enabled := False;
      img_SBild.Visible := False;
      edt_SWidth.Enabled := False;
      edt_SHeight.Enabled := False;
      LblText1.Visible := True;
   end;
end;

procedure Tfrm_voransichtoptionen.rbtn_SBildClick(Sender: TObject);
begin
   if rbtn_SBild.Checked then
   begin
      rbtn_SBild.Checked := True;
      memo_SText.Enabled := False;
      sbtn_SFont.Enabled := False;
      edt_SFont.Enabled := False;
      edt_SBild.Enabled := True;
      sbtn_SBild.Enabled := True;
      img_SBild.Visible := True;
      edt_SWidth.Enabled := True;
      edt_SHeight.Enabled := True;
      LblText1.Visible := False;
   end;
end;

procedure Tfrm_voransichtoptionen.tbs_AnnotationsShow(Sender: TObject);
begin
   LoadObjVal(tctrl_Annos.TabIndex);
end;

procedure Tfrm_voransichtoptionen.tbs_StandardShow(Sender: TObject);
begin
   LoadDocEditOpt;
end;

procedure Tfrm_voransichtoptionen.tbs_StempelShow(Sender: TObject);
begin
   ListStamps(False);
end;

procedure Tfrm_voransichtoptionen.sbtn_SFontClick(Sender: TObject);
begin
   if dlg_Schrift.Execute then
      edt_SFont.Text := dlg_Schrift.Font.Name;
end;

procedure Tfrm_voransichtoptionen.edt_SWidthChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_SWidth.Text, iValue) then
      edt_SWidth.Tag := iValue
   else
      edt_SWidth.Text := IntToStr(edt_SWidth.Tag);
end;

procedure Tfrm_voransichtoptionen.edt_SHeightChange(Sender: TObject);
var
   iValue: integer;
begin
   if TryStrToInt(edt_SHeight.Text, iValue) then
      edt_SHeight.Tag := iValue
   else
      edt_SHeight.Text := IntToStr(edt_SHeight.Tag);
end;

procedure Tfrm_voransichtoptionen.FormShow(Sender: TObject);
begin
   fifavnum := 0;
   LblText1.Caption := _('Textvariablen:') + ' %D = ' + _('Datum') + ', %Z = ' + _('Zeit') + ',' + #10 + ' %U = ' + _('User');
   LoadObjVal(tctrl_Annos.TabIndex);
end;

procedure Tfrm_voransichtoptionen.img_SBildClick(Sender: TObject);
var
   cl_rgb: TRGB;
begin
   cl_rgb := TColor2TRGB(frm_PickColor.PickColor.Color);
   img_SBild.Proc.SetTransparentColors(cl_rgb, cl_rgb, 0);
end;

procedure Tfrm_voransichtoptionen.btn_transpClick(Sender: TObject);
begin
   frm_PickColor.Show;
end;

procedure Tfrm_voransichtoptionen.img_SBildMouseMove(Sender: TObject;
   Shift: TShiftState; X, Y: integer);

var
   cl_rgb: TRGB;

begin
   // transform client coorindates to bitmap ones
   X := img_SBild.XScr2Bmp(X);
   Y := img_SBild.YScr2Bmp(Y);

   // check limits
   if (X >= 0) and (X < img_SBild.IEBitmap.Width) and (Y >= 0) and
      (Y < img_SBild.IEBitmap.Height) then
   begin
      cl_rgb := img_SBild.IEBitmap.Pixels[X, Y];
      frm_PickColor.PickColor.Color := TRGB2TColor(cl_rgb);
      with cl_rgb do
         frm_PickColor.Label3.Caption :=
            IntToStr(r) + ',' + IntToStr(g) + ',' + IntToStr(b);
   end;

   if ssLeft in Shift then
      SetTransparent;
end;


procedure Tfrm_voransichtoptionen.SetTransparent;
var
   cl_rgb: TRGB;
begin
   cl_rgb := TColor2TRGB(frm_PickColor.PickColor.Color);
   img_SBild.Proc.SetTransparentColors(cl_rgb, cl_rgb, 0);
end;

function Tfrm_voransichtoptionen.LoadStampEigenschaften(StampKey: string): boolean;
var
   reg: TRegistry;
   fsTmp: TFontStyles;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   //    ssTmp: TIEVSoftShadow;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;
   li: integer;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
               exit;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);
            if ValueExists('Stamptyp') then
            begin
               li := ReadInteger('Stamptyp');
               if li = 1 then
                  exit;
            end;

            if ValueExists('ObjBrushColor') then
               clbx_CBackground.Selected := ReadInteger('ObjBrushColor')
            else
               clbx_CBackground.Selected := 0;
            if ValueExists('ObjPenColor') then
            begin
               //          clbx_CBorder.Selected := ReadInteger('ObjPenColor');
               dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
            end
            else
            begin
               clbx_CBorder.Selected := 0;
               dlg_Schrift.Font.Color := 0;
            end;
            if ValueExists('ObjLabelBrushColor') then
               clbx_CLabel.Selected := ReadInteger('ObjLabelBrushColor')
            else
               clbx_CLabel.Selected := 0;
            if ValueExists('ObjMemoBorderColor') then
               clbx_CNoteBorder.Selected := ReadInteger('ObjMemoBorderColor')
            else
               clbx_CNoteBorder.Selected := 0;
            if ValueExists('ObjAutoIncreaseLine') then
               cbx_autolineincrease.checked := ReadBool('ObjAutoIncreaseLine')
            else
               cbx_autolineincrease.checked := false;
            if ValueExists('ObjAutoIncreaseHeight') then
               cbx_autoincreasehigh.checked := ReadBool('ObjAutoIncreaseHeight')
            else
               cbx_autoincreasehigh.checked := false;

            if ValueExists('ObjBrushStyle') then
            begin
               ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               case bsTmp of
                  bsSolid:
                     cbx_BBackground.ItemIndex := 7;
                  bsClear:
                     cbx_BBackground.ItemIndex := 0;
                  bsHorizontal:
                     cbx_BBackground.ItemIndex := 4;
                  bsVertical:
                     cbx_BBackground.ItemIndex := 3;
                  bsFDiagonal:
                     cbx_BBackground.ItemIndex := 1;
                  bsBDiagonal:
                     cbx_BBackground.ItemIndex := 2;
                  bsCross:
                     cbx_BBackground.ItemIndex := 5;
                  bsDiagCross:
                     cbx_BBackground.ItemIndex := 6;
               end;
               cbx_BBackground.Enabled := True;
            end
            else
            begin
               cbx_BBackground.ItemIndex := 0;

               cbx_BBackground.Enabled := True;
            end;
            if ValueExists('ObjLabelBrushStyle') then
            begin
               ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
               case bsTmp of
                  bsSolid:
                     cbx_BLabel.ItemIndex := 7;
                  bsClear:
                     cbx_BLabel.ItemIndex := 0;
                  bsHorizontal:
                     cbx_BLabel.ItemIndex := 4;
                  bsVertical:
                     cbx_BLabel.ItemIndex := 3;
                  bsFDiagonal:
                     cbx_BLabel.ItemIndex := 1;
                  bsBDiagonal:
                     cbx_BLabel.ItemIndex := 2;
                  bsCross:
                     cbx_BLabel.ItemIndex := 5;
                  bsDiagCross:
                     cbx_BLabel.ItemIndex := 6;
               end;
               cbx_BLabel.Enabled := True;
            end
            else
            begin
               cbx_BLabel.ItemIndex := 0;

               cbx_BLabel.Enabled := True;
            end;

            if ValueExists('ObjPenStyle') then
            begin
               ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               case psTmp of
                  psSolid:
                     cbx_BBorder.ItemIndex := 0;
                  psDash:
                     cbx_BBorder.ItemIndex := 2;
                  psDot:
                     cbx_BBorder.ItemIndex := 5;
                  psDashDot:
                     cbx_BBorder.ItemIndex := 3;
                  psDashDotDot:
                     cbx_BBorder.ItemIndex := 4;
                  psClear:
                     cbx_BBorder.ItemIndex := 1;
               end;
               cbx_BBorder.Enabled := True;
            end
            else
            begin
               cbx_BBorder.ItemIndex := 0;

               cbx_BBorder.Enabled := True;
            end;
            if ValueExists('ObjMemoBorderStyle') then
            begin
               ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
               case psTmp of
                  psSolid:
                     cbx_BNoteBorder.ItemIndex := 0;
                  psDash:
                     cbx_BNoteBorder.ItemIndex := 2;
                  psDot:
                     cbx_BNoteBorder.ItemIndex := 5;
                  psDashDot:
                     cbx_BNoteBorder.ItemIndex := 3;
                  psDashDotDot:
                     cbx_BNoteBorder.ItemIndex := 4;
                  psClear:
                     cbx_BNoteBorder.ItemIndex := 1;
               end;
               cbx_BNoteBorder.Enabled := True;

            end
            else
            begin
               cbx_BNoteBorder.ItemIndex := 0;

               cbx_BNoteBorder.Enabled := True;
            end;
            if ValueExists('ObjBeginShape') then
            begin
               ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               case shTmp of
                  iesNONE:
                     rbtn_SSNo.Checked := True;
                  iesINARROW:
                     rbtn_SSIn.Checked := True;
                  iesOUTARROW:
                     rbtn_SSOut.Checked := True;
               end;
            end
            else
               rbtn_SSNo.Checked := True;
            if ValueExists('ObjEndShape') then
            begin
               ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               case shTmp of
                  iesNONE:
                     rbtn_SENo.Checked := True;
                  iesINARROW:
                     rbtn_SEIn.Checked := True;
                  iesOUTARROW:
                     rbtn_SEOut.Checked := True;
               end;
            end
            else
               rbtn_SENo.Checked := True;
            if ValueExists('ObjShapeHeight') then
               edt_SSHeight.Text := IntToStr(ReadInteger('ObjShapeHeight'))
            else
               edt_SSHeight.Text := '0';
            if ValueExists('ObjShapeWidth') then
               edt_SSWidth.Text := IntToStr(ReadInteger('ObjShapeWidth'))
            else
               edt_SSWidth.Text := '0';
            if ValueExists('ObjName') then
               edt_AObjName.Text := ReadString('ObjName')
            else
               edt_AObjName.Text := _('neues Objekt');
            if ValueExists('ObjPenWidth') then
               edt_APenWidth.Text := IntToStr(ReadInteger('ObjPenWidth'))
            else
               edt_APenWidth.Text := '1';
            if ValueExists('ObjRulerType') then
            begin
               ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
               case rtTmp of
                  iertRULER:
                     cbx_ARulerTyp.ItemIndex := 0;
                  iertQUOTEBEGIN:
                     cbx_ARulerTyp.ItemIndex := 1;
                  iertQUOTECENTER:
                     cbx_ARulerTyp.ItemIndex := 2;
                  iertQUOTEEND:
                     cbx_ARulerTyp.ItemIndex := 3;
               end;
            end
            else
               cbx_ARulerTyp.ItemIndex := 0;
            if ValueExists('ObjRulerUnit') then
            begin
               ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
               case ruTmp of
                  ieuPIXELS:
                     cbx_ARulerMes.ItemIndex := 0;
                  ieuINCHES:
                     cbx_ARulerMes.ItemIndex := 1;
                  ieuKM:
                     cbx_ARulerMes.ItemIndex := 5;
                  ieuMETERS:
                     cbx_ARulerMes.ItemIndex := 4;
                  ieuCENTIMETERS:
                     cbx_ARulerMes.ItemIndex := 3;
                  ieuMILLIMETERS:
                     cbx_ARulerMes.ItemIndex := 2;
                  ieuMICRONS:
                     cbx_ARulerMes.ItemIndex := 6;
                  ieuNANOMETERS:
                     cbx_ARulerMes.ItemIndex := 7;
               end;
            end
            else
               cbx_ARulerMes.ItemIndex := 0;
            if ValueExists('ObjTransparency') then
               edt_ATransp.Text := IntToStr(ReadInteger('ObjTransparency'))
            else
               edt_ATransp.Text := '110';  
            if ValueExists('ObjPolylineClosed') then
               chbx_AOpenPoly.Checked := not ReadBool('ObjPolylineClosed')
            else
               chbx_AOpenPoly.Checked := False;
            if ValueExists('ObjBoxHighlight') then
               chbx_AIsHiLite.Checked := ReadBool('ObjBoxHighlight')
            else
               chbx_AIsHiLite.Checked := False;
            if ValueExists('ObjStyle') then
            begin
               ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               chbx_ASelectable.Checked := ievsSelectable in osTmp;
               chbx_AMoveable.Checked := ievsMoveable in osTmp;
               chbx_ASizeable.Checked := ievsSizeable in osTmp;
               chbx_AVisible.Checked := ievsVisible in osTmp;
            end
            else
            begin
               chbx_ASelectable.Checked := True;
               chbx_AMoveable.Checked := True;
               chbx_ASizeable.Checked := True;
               chbx_AVisible.Checked := True;
            end;
            if ValueExists('ObjHeight') then
               edt_objheight.Text := IntToStr(ReadInteger('ObjHeight'))
            else
               edt_objheight.Text := '400';
            if ValueExists('Objwidth') then
               Edt_objwidth.Text := IntToStr(ReadInteger('Objwidth'))
            else
               Edt_objwidth.Text := '400';
            if ValueExists('FontName') then
            begin
               edt_TFont.Text := ReadString('FontName');
            end
            else
            begin
               edt_TFont.Text := '';
            end;
            dlg_Schrift.Font.Name := edt_TFont.Text;
            edt_SFont.Text := edt_TFont.Text;
            if ValueExists('FontSize') then
            begin
               dlg_Schrift.Font.Size := ReadInteger('FontSize');
               edt_TFontSize.Text := IntToStr(ReadInteger('FontSize'));
            end
            else
            begin
               dlg_Schrift.Font.Size := 72;
               edt_TFontSize.Text := '72';
            end;
            if ValueExists('FontStyle') then
            begin
               ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
               dlg_Schrift.Font.Style := fsTmp;
            end
            else
               dlg_Schrift.Font.Style := [];
            if ValueExists('ObjFontAngle') then
               edt_TFontAngle.Text := FloatToStr(ReadFloat('ObjFontAngle'))
            else
               edt_TFontAngle.Text := '0';
            if ValueExists('ObjLabelPosition') then
            begin
               ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
               case lpTmp of
                  ielBegin:
                     cbx_TLabelPos.ItemIndex := 0;
                  ielEnd:
                     cbx_TLabelPos.ItemIndex := 1;
               end;
            end
            else
               cbx_TLabelPos.ItemIndex := 0;
            if ValueExists('ObjTextAlign') then
            begin
               ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
               case taTmp of
                  iejLeft:
                     cbx_TAlign.ItemIndex := 0;
                  iejRight:
                     cbx_TAlign.ItemIndex := 1;
                  iejCenter:
                     cbx_TAlign.ItemIndex := 2;
                  iejJustify:
                     cbx_TAlign.ItemIndex := 3;
               end;
            end
            else
               cbx_TAlign.ItemIndex := 0;
            if ValueExists('ObjText') then
               memo_TObjText.Text := ReadString('ObjText')
            else
               memo_TObjText.Text := _('neuer Text');
            if ValueExists('ObjTextAutoSize') then
               chbx_TObjAutoSize.Checked := ReadBool('ObjTextAutoSize')
            else
               chbx_TObjAutoSize.Checked := False;
            if ValueExists('ObjFontLocked') then
               chbx_TFontLocked.Checked := ReadBool('ObjFontLocked')
            else
               chbx_TFontLocked.Checked := False;
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_voransichtoptionen.LoadObjVal', _('Fehler beim Lesen des Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;


procedure Tfrm_voransichtoptionen.lv_eigenschaftstempelClick(Sender: TObject);
begin
   if lv_eigenschaftstempel.SelCount > 0 then
   begin
      sGStampKey := lv_eigenschaftstempel.Selected.SubItems.Strings[0];
      LoadStamp(sGStampKey);
      LoadObjVal(3);
   end;
end;

procedure Tfrm_voransichtoptionen.loadfavstampbuttons;
begin
   u_HighUtils.LoadFavStampbuttons( frm_mainform.tbx_fav1, frm_mainform.tbx_fav2,
         frm_mainform.tbx_fav3, frm_mainform.tbx_fav4, frm_mainform.tbx_fav5);
end;


procedure Tfrm_voransichtoptionen.frmsto_docoptionenRestorePlacement(Sender: TObject);
begin
   LoadObjVal(tctrl_Annos.TabIndex);
end;


procedure Tfrm_voransichtoptionen.cbx_nummerChange(Sender: TObject);
begin
   fifavnum := cbx_nummer.ItemIndex;
   LoadObjVal(tctrl_Annos.TabIndex);
   cbx_nummer.setfocus;
end;

procedure Tfrm_voransichtoptionen.memo_TObjTextKeyDown(Sender: TObject;
   var Key: Word; Shift: TShiftState);
begin
   if (Key = Ord('A')) and (ssCtrl in Shift) then
   begin
      TMemo(Sender).SelectAll;
      Key := 0;
   end;
end;

procedure Tfrm_voransichtoptionen.FormCreate(Sender: TObject);
begin
   TP_GlobalIgnoreClassProperty(TComboBoxEx, 'itemsex');
   TranslateComponent(self, 'Viewerv3');
   // manuelle Behandlung der TColorBox
   TranslateStrings(clbx_CBackground.Items, 'Delphi7');
   TranslateStrings(clbx_CBorder.Items, 'Delphi7');
   TranslateStrings(clbx_CLabel.Items, 'Delphi7');
   TranslateStrings(clbx_CNoteBorder.Items, 'Delphi7');
end;

end.
