unit u_wvlpflichfelder;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, JvExForms, JvScrollBox, strutils, {} u_dm_ViewerMain,
   TBXDkPanels, gnugettext,
   u_ShLowUtils, u_ShBase, u_ShDm, u_dm_DB, u_ShDbUtils, u_ShFrameZusFldMulti,
   u_ShDefs;

type
   Tfrm_zuspflicht = class (TForm)
      sbx_ZusFeld: TJvScrollBox;
      Panel1: TPanel;
      tbxb_reset: TTBXButton;
      tbbt_search: TTBXButton;
      Panel2: TPanel;
      Panel3: TPanel;
      btn_ok: TTBXButton;
      btn_cancel: TTBXButton;

      procedure btn_okClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure tbxb_resetClick(Sender: TObject);
      procedure tbbt_searchClick(Sender: TObject);
   private
      { Private-Deklarationen }
      ZusFldFrame:TFrameZusFldMulti;

      procedure zusfeldonchange(Sender: TObject);
      procedure Searchzusfield(Sender: TObject);

      procedure setMoveOk (Ok: Boolean);
   public
      { Public-Deklarationen }
      fTorpflichtfeld: integer;
      fkeypflichtfeld: integer;
      fsDestIarcname: string;
      fsSrcIarcname: string;
      fiZusFcount: integer;
      NOG_Fieldlist: TStringList;
      function CreZusFields: integer;
      function DelZusFields: integer;
      function ChkZusfield: boolean;

      procedure onChangeComboBox (Sender: TObject);  // 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
      procedure onExitComboBox   (Sender: TObject);  // 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
   end;

var
   frm_zuspflicht: Tfrm_zuspflicht;

implementation

uses
  JvStaticText, JvToolEdit, u_Mainform, JvCombobox, spin, JvSpin,
  u_ShCompUtils;

var
  (*  Zweck:
        Beim Klick IN die ComboBox kann u.U. onExit aktiviert werden.
        Um Probleme damit zu verhindern wird dieses Flag genutzt.
  *)
  gExitFlag: Boolean;

{$R *.dfm}

(*
  Zweck:
    Zusatzfelder im Dialog erzeugen
  ACHTUNG!
    Dieser Quelltext ist redundant mit 'Tfrm_MainForm.CreZusFields'
*)
function Tfrm_zuspflicht.CreZusFields: integer;
var
   edt: array of TEdit;
   //lbl: Array of tlabel;
   lbl: array of tjvstatictext;
   cbx: array of TComboBox;
   dat: array of TJvDateEdit;
   chx: array of Tcheckbox;
   tbxb: array of TTBXButton;
   ccb: array of TcheckBox;
   spe: array of TSpinEdit;
   lfbit: array of TTBXButton;
   jccb: array of TjvcheckedComboBox;
   lganzzahl: array of TJvSpinEdit;
   ldouble: array of TjvSpinEdit;
   iC, iCsave, iEdt, iCbx, iDat, iTyp, iCntEdt, iCntCbx, iCntCCbx, iCntLbl, iCntDat,
   iCntchx, litaborder, licount2, iCntbxb, iCntSpi,
   iCnttbxb, iCntganzzahl, iCntdouble: integer;
   lfont: tfont;
   lbfound, lbfoundre, lbrechte: boolean;
   lswert, sAdd, lsDispName: string;
   lstlw: Tstringlist;
   ZusFldFrame:TFrameZusFldMulti;

   lTyp     : eAddFieldType;

begin
   GgfLogEvntBeg ('Tfrm_zuspflicht.CreZusFields Beginn');

   iCntEdt := 0;
   iCntCbx := 0;
   iCntLbl := 0;
   iCntDat := 0;
   iCntChx := 0;
   iCnttbxb := 0;
   iCntbxb := 0;
   iCntCCbx := 0;
   iCntSpi := 0;
   iCntganzzahl := 0;
   iCntdouble := 0;
   litaborder := 2;
   tbbt_search.Visible := false;
   tbxb_reset.visible := false;
   if not Assigned(NOG_Fieldlist) then
      NOG_Fieldlist := TStringList.Create
   else
      NOG_Fieldlist.Clear;
   lbrechte := false;
   dm_DB.my_q_tmpcrestatus1.SQL.Text := 'show tables like  "cfgxs_' + sIArcName + '"';
   try
      dm_DB.my_q_tmpcrestatus1.execute;
   except on e: exception do
      begin
      end;
   end;
   if dm_DB.my_q_tmpcrestatus1.recordcount > 0 then
   begin
      dm_DB.my_q_tmpcrestatus1.SQL.Text := 'SELECT * FROM cfgxs_' + sIArcName + ' where usr_id = ' + inttostr(iGUsrID);
      try
         dm_DB.my_q_tmpcrestatus1.execute;
      except on e: exception do
         begin
         end;
      end;
      lbrechte := true;
   end;
   with dm_DB.my_q_Tmp do
   begin
      if sbx_ZusFeld.ComponentCount > 0 then
         DelZusFields;

      DbExecSql(dm_DB.my_q_Tmp,'Select * from cfg_' + fsDestIarcname + ' where typ <> 4 order by pos'); //wegen vtiger 2182
      try
         Result := RecordCount;
         if Result = 0 then
         begin
            Close;
            Exit;
         end;
         dm_db.my_q_ngtmp.sql.Text := 'select * from cfg_' + fsSrcIarcname + ' where typ <> 4 order by pos';
         dm_db.my_q_ngtmp.execute;

         tbbt_search.visible := true;
         tbxb_reset.visible := true;
         Filtered := False;
         SetLength(lbl, RecordCount);
         fTorPflichtfeld := 0;

         sbx_ZusFeld.AutoScroll := True;
         sbx_ZusFeld.Refresh;
         for iC := 0 to (RecordCount - 1) do
         begin
            iTyp := FieldByName('Typ').AsInteger;
            lbl[iCntLbl] := tjvstatictext.Create(sbx_ZusFeld);
            lbl[iCntLbl].Name := 'zlbl_Tmp' + IntToStr(iC);
            lbl[iCntLbl].Caption := FieldByName('Disp_Name').AsString + ':';

            lbfound := false;
            if lbrechte then
            begin
               dm_DB.my_q_tmpcrestatus1.first;
               while not dm_DB.my_q_tmpcrestatus1.eof do
               begin
                  if dm_DB.my_q_tmpcrestatus1.fieldbyname('CFG_ID').AsInteger = FieldByName('CFG_ID').AsInteger then
                  begin
                     break;
                  end;
                  dm_DB.my_q_tmpcrestatus1.next;
               end;
            end;
            lswert := '';
            dm_db.my_q_ngtmp.first;
            while not dm_db.my_q_ngtmp.eof do
            begin
               if dm_db.my_q_ngtmp.FieldByName('Disp_Name').AsString =
                  FieldByName('Disp_Name').AsString then
               begin
                  lbfound := true;
                  break;
               end;
               dm_db.my_q_ngtmp.Next;
            end;
            if lbfound then
            begin
               if (dm_db.my_q_Arc.FieldDefList.Find(dm_db.my_q_ngtmp.FieldByName('Feld_Name').AsString) = nil)
               then
               begin
                  dm_db.my_q_tmp_CreStatus.sql.Text := 'select * from arc_' + fsSrcIarcname + ' where doc_id =' + inttostr(igdocid);
                  dm_db.my_q_tmp_CreStatus.execute;
                  if (dm_db.my_q_tmp_CreStatus.FieldDefList.Find(dm_db.my_q_ngtmp.FieldByName('Feld_Name').AsString) <> nil) then
                  begin
                     lswert := dm_db.my_q_tmp_CreStatus.FieldByName(dm_db.my_q_ngtmp.FieldByName('Feld_Name').AsString).asstring;
                  end
                  else
                  begin
                     lswert := '';
                  end;
               end
               else
               begin
                  lswert := dm_db.my_q_arc.FieldByName(dm_db.my_q_ngtmp.FieldByName('Feld_Name').AsString).AsString;
               end;
            end;
            lfont := canvas.Font;
            canvas.Font := lbl[iCntLbl].Font;
            lbl[iCntLbl].Width := 4 + canvas.TextWidth(lbl[iCntLbl].Caption);
            canvas.Font := lfont;

            // set NOG_fieldlist always when assigning lbl.caption
            NOG_fieldList.Add(lbl[iCntLbl].Caption);
            // Beschreibeung des namens des Pflichtfeldes modifizieren

            if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then  // Datenfeld Optionen prfen ob 1
            begin
               lbl[iCntLbl].Caption := '*' + lbl[iCntLbl].Caption;

               //Nog_Feldername[iC+1] := lbl[iCntLbl].Caption;
               //showmessage ('IC = '+ inttostr(ic+1) +  Nog_Feldername[iC+1]);
            end;

            lbl[iCntLbl].Hint := FieldByName('Feld_Name').AsString;
            lbl[iCntLbl].ParentShowHint := True;
            lbl[iCntLbl].Left := 8;
            lbl[iCntLbl].Top := 8 + (40 * iC);
            lbl[iCntLbl].Height := 13;
            lbl[iCntLbl].Tag := FieldByName('typ').AsInteger;
            lbl[iCntLbl].Parent := sbx_ZusFeld;

            if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
            begin
               //   logevnt('1.5 TorPflichtfeld '+inttostr(TorPflichtfeld));
               Inc(ftorPflichtfeld);
            end;

            lTyp          := eAddFieldType (iTyp);
//          lAddField.Typ := lTyp;

//          if iTyp = 0 then
            if lTyp = zfld00_Universal then
            begin
               SetLength(edt, iCntEdt + 1);
               edt[iCntEdt] := TEdit.Create(sbx_ZusFeld);
               edt[iCntEdt].Name := 'zedt_Tmp' + IntToStr(iC);
               if lswert <> '' then
               begin
                  edt[iCntEdt].Text := lswert;

               end
               else
               begin
                  edt[iCntEdt].Text := '';
               end;
               edt[iCntEdt].Hint :=
                  _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
                  #34 + ' ' + _('suchen');

               if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
               begin
                  edt[iCntEdt].Hint :=
                     _('Hier knnen Sie im Feld') + ' ' + #34 + '*' +
                     FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
                  edt[iCntEdt].Color := cColorPflichtfeld;
               end;

               edt[iCntEdt].ShowHint := True;
               edt[iCntEdt].Left := 28;
               edt[iCntEdt].Top := 21 + (40 * iC);
               edt[iCntEdt].Height := 21;
               edt[iCntEdt].Width := (sbx_ZusFeld.Width - 70);
               edt[iCntEdt].Anchors := [akLeft, akTop, akRight];
               edt[iCntEdt].Tag := FieldByName('Mode').AsInteger;
               edt[iCntEdt].Parent := sbx_ZusFeld;
               edt[iCntEdt].taborder := litaborder;
               // Die Komponente erst am Schlu sichtbar machen
               Inc(iCntEdt, 1);
               inc(litaborder);
            end
            else

//          if iTyp = 1 then
            if lTyp = zfld01_Datum then
            begin
               // set just the proper length     (+2 cause there is always 2 date boxes)
               SetLength(dat, iCntDat + 1);
               dat[iCntDat] := TJvDateEdit.Create(sbx_ZusFeld);
               dat[iCntDat].Name := 'zedt_Tmp' + IntToStr(iC);
               dat[iCntDat].Clear;
               dat[iCntDat].Hint :=
                  _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
                  #34 + ' ' + _('suchen');

               if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
               begin
                  dat[iCntdat].Hint :=
                     _('Hier knnen Sie im Feld') + ' ' + #34 + '*' +
                     FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
                  dat[iCntdat].Color := cColorPflichtfeld;
               end;

               if lsWert <> '' then
                  dat [iCntDat].Text := lsWert;

               dat[iCntDat].ShowHint := True;
               dat[iCntDat].Left := 28;
               dat[iCntDat].Top := 21 + (40 * iC);
               dat[iCntDat].Height := 21;
               dat[iCntDat].Width := (sbx_ZusFeld.Width - 70);
               dat[iCntDat].Anchors := [akLeft, akTop, akRight];
               dat[iCntDat].Tag := FieldByName('Mode').AsInteger;
               dat[iCntDat].Parent := sbx_ZusFeld;
               dat[iCntDat].taborder := litaborder;
               // Die Komponente erst am Schlu sichtbar machen
               Inc(iCntDat, 1);
               inc(litaborder);
            end
            else

//          if iTyp = 2 then
            if lTyp = zfld02_Auswahl then
            begin
               // set just the proper length
               SetLength(cbx, iCntCbx + 1);
               cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
               cbx[iCntCbx].Name := 'zedt_Tmp' + IntToStr(iC);
               cbx[iCntCbx].Style := csDropDown; //3.5.0.19 [ 2264 ] Auswahlfelder knnen beliebig manuell ausgefllt werden
               cbx[iCntCbx].Hint :=
                  _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
                  #34 + ' ' + _('suchen');

               if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
               begin
                  cbx[iCntcbx].Hint :=
                     _('Hier knnen Sie im Feld') + ' ' + #34 + '*' +
                     FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
                  cbx[iCntcbx].Color := cColorPflichtfeld;
               end;

               cbx[iCntCbx].ShowHint := True;
               cbx[iCntCbx].Left := 28;
               cbx[iCntCbx].Top := 21 + (40 * iC);
               cbx[iCntCbx].Height := 21;
               cbx[iCntCbx].Width := (sbx_ZusFeld.Width - 70);
               cbx[iCntCbx].Anchors := [akLeft, akTop, akRight];
               cbx[iCntCbx].Tag := FieldByName('Mode').AsInteger;
               cbx[iCntCbx].Parent := sbx_ZusFeld;
               // Die Komponente erst am Schlu sichtbar machen
               cbx[iCntCbx].Clear;
               cbx[iCntCbx].Items.CommaText := FieldByName('Werte').AsString;
               cbx[iCntCbx].taborder := litaborder;
               cbx[iCntCBx].OnExit   := onExitComboBox;    // 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
               cbx[iCntCBx].OnChange := onChangeComboBox;  // 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
               cbx[iCntCbx].Items.Add('');

               if lsWert <> '' then
               begin
                 cbx [iCntCbx].Text := lsWert;
                 TextIntoList (cbx [iCntCbx]);  // 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
               end;


               Inc (iCntCbx, 1);
               inc (litaborder);
            end
            else

//          if iTyp = 3 then
            if lTyp = zfld03_MehrfachAuswahl then
            begin
               lsDispName := FieldByName('Disp_Name').AsString;
               sAdd := lbl[iCntLbl].Hint;

               ZusFldFrame := CreateTJvCheckedComboBox(sbx_ZusFeld, iC,
                                      30, {105} sbx_ZusFeld.Width - 70,
                                      lsDispName, sAdd, fsDestIarcname,
                                      zusfeldonchange,
                                      FieldByName('Mode').AsInteger);
               ZusFldFrame.ComboBox.taborder := litaborder;
               inc(litaborder);
               // [2270]
               if lswert <> '' then
               begin
                  ZusFldFrame.ComboBox.Text:= lswert;
               end
               else
               begin
                  ZusFldFrame.ComboBox.Text:= '';
               end;
               if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
               begin
                  ZusFldFrame.ComboBox.Hint :=
                     _('Hier knnen Sie im Feld') + ' ' + #34 + lsDispName +
                     #34 + ' ' + _('suchen');
                  ZusFldFrame.ComboBox.NoFocusColor := cColorPflichtfeld;
               end;
               { ist doppelt, zur Dokumentation noch drin, f.schneider
               // Ticket [2270] r.schirmacher, Vers.:3.5.0.76, 11.05.2010
               //
               if lsWert <> '' then
                 ZusFldFrame.ComboBox.Text := lsWert;
                }
               SetLength(jccb, iCntCCbx + 1);
               jccb[iCntCCbx] := ZusFldFrame.ComboBox;
               Inc(iCntCCbx, 1);
               SetLength(lfbit, iCntbxb + 1);
               lfbit[iCntbxb] := ZusFldFrame.Button;
               Inc(iCntbxb, 1);
            end
            else

//          if ityp = 5 then
            if lTyp = zfld05_Intervall then
            begin
               // set just the proper length
               SetLength(spe, iCntSpi + 1);
               // cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
               spe[iCntSpi] := TSpinEdit.Create(sbx_ZusFeld);
               spe[iCntSpi].Name := 'zedt_Tmp' + IntToStr(iC);
               spe[iCntSpi].Hint :=
                  _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
                  #34 + ' ' + _('suchen');;
               spe[iCntSpi].ShowHint := True;
               spe[iCntSpi].Left := 30;
               spe[iCntSpi].Top := 21 + (40 * iC);
               spe[iCntSpi].Height := 21;
               spe[iCntSpi].Width := 75;
               spe[iCntSpi].MaxValue := maxint; // m.frey: war 31 gendert wegen Wehrling nicht Monat absolut sondern Laufzeit
               spe[iCntSpi].MinValue := 1;
               spe[iCntSpi].Value := 1;
               spe[iCntSpi].color := clwhite;
               if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
               begin
                  spe[iCntSpi].Hint :=
                     _('Hier knnen Sie im Feld') + ' ' + #34 + '*' + FieldByName('Disp_Name').AsString +
                     #34 + ' ' + _('suchen');
                  spe[iCntSpi].Color := cColorPflichtfeld;
               end;
               //          spe[iCntSpi].Text:='1';
               spe[iCntSpi].Anchors := [akLeft, akTop];
               //          spe[iCntSpi].OnKeyUp := EnableSave;
               spe[iCntSpi].OnChange := zusfeldonchange;
               //          spe[iCntSpi].OnKeyDown := DoSearchOnenter;
               // cbx[iCntCbx].OnChange := BtnEnableSave;
               // Mode:= exakt, wortende, wortanfang, wortbestandteil
               spe[iCntSpi].Tag := FieldByName('Mode').AsInteger;
               spe[iCntSpi].Parent := sbx_ZusFeld;
               spe[iCntSpi].taborder := litaborder;
               inc(litaborder);
               // Die Komponente erst am Schlu sichtbar machen
               spe[iCntSpi].Clear;
               //cbx[iCntCbx].readonly;
               Inc(iCntSpi, 1);
               SetLength(cbx, iCntCbx + 1);
               // cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
               cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
               cbx[iCntCbx].Name := 'zedt_Tmp_cbx_' + IntToStr(iC);
               cbx[iCntCbx].Style := csDropDown; //3.5.0.19 [ 2264 ] Auswahlfelder knnen beliebig manuell ausgefllt werden
               cbx[iCntCbx].Hint :=
                  _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
                  #34 + ' ' + _('suchen');;
               cbx[iCntCbx].ShowHint := True;

               //'cbx[iCntCbx].Left := sbx_ZusFeld.Width - 105;
               cbx[iCntCbx].Left := spe[iCntSpi-1].Left + spe[iCntSpi-1].Width + 10;

               cbx[iCntCbx].Top := 21 + (40 * iC);
               cbx[iCntCbx].Height := 21;
               cbx[iCntCbx].Width := 75;
               //'cbx[iCntCbx].Anchors := [akTop, akRight];
               cbx[iCntCbx].Anchors := [akTop, akLeft];
               //          cbx[iCntCbx].OnKeyUp := EnableSave;
               cbx[iCntCbx].OnChange := zusfeldonchange;
               //          cbx[iCntCBx].OnKeyDown := DoSearchOnenter;
               // cbx[iCntCbx].OnChange := BtnEnableSave;
               // Mode:= exakt, wortende, wortanfang, wortbestandteil
               cbx[iCntCbx].Tag := FieldByName('Mode').AsInteger;
               cbx[iCntCbx].Parent := sbx_ZusFeld;
               cbx[iCntCbx].taborder := litaborder;
               inc(litaborder);
               // Die Komponente erst am Schlu sichtbar machen
               cbx[iCntCbx].Clear;
               cbx[iCntCbx].Items.CommaText := 'T,M,J';
               cbx[iCntCbx].Items.Add('');
               //cbx[iCntCbx].readonly;
               cbx[iCntCbx].color := clwhite;
               if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
               begin
                  cbx[iCntCbx].Hint :=
                     _('Hier knnen Sie im Feld') + ' ' + #34 + '*' + FieldByName('Disp_Name').AsString +
                     #34 + ' ' + _('suchen');
                  cbx[iCntCbx].Color := cColorPflichtfeld;
               end;
               Inc(iCntCbx, 1);

            end
            else

//          if iTyp = 6 then
            if lTyp = zfld06_GanzZahl then
            begin
               // set just the proper length     (+2 cause there is always 2 date boxes)
               SetLength(lganzzahl, iCntganzzahl + 1);
               lganzzahl[iCntganzzahl] := TJvSpinEdit.Create(sbx_ZusFeld);
               lganzzahl[iCntganzzahl].Name := 'zedt_Tmp' + IntToStr(iC);
               lganzzahl[iCntganzzahl].Hint :=
                  _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
                  #34 + ' ' + _('suchen');;
               lganzzahl[iCntganzzahl].ShowHint := True;

               if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
               begin
                  lganzzahl[iCntganzzahl].Hint :=
                     _('Hier knnen Sie im Feld') + ' ' + #34 + '*' + FieldByName('Disp_Name').AsString +
                     #34 + ' ' + _('suchen');
                  lganzzahl[iCntganzzahl].Color := cColorPflichtfeld;
               end;
               lganzzahl[iCntganzzahl].Left := 28;
               lganzzahl[iCntganzzahl].Top := 21 + (40 * iC);
               lganzzahl[iCntganzzahl].Height := 21;
               // skywalker20070612 set the width of the zusatzfeld
               // equal the width of the normal date search
               //'lganzzahl[iCntganzzahl].Width := 85;
               lganzzahl[iCntganzzahl].Width := 75;
               // ((trunc(sbx_ZusFeld.Width / 2)) - 30);

               lganzzahl[iCntganzzahl].Anchors := [akLeft, akTop];
               lganzzahl[iCntganzzahl].OnChange := zusfeldonchange;
               lganzzahl[iCntganzzahl].Tag := FieldByName('Mode').AsInteger;
               lganzzahl[iCntganzzahl].Parent := sbx_ZusFeld;

                 { if  (lbfound and lbrechte) or (not lbrechte) then
                  begin
           lganzzahl[iCntganzzahl].taborder:=litaborder;
                inc(litaborder);
                end;
                 if liindex > -1 then
                begin
                  lganzzahl[iCntganzzahl].text:= ZusWert.Strings[liindex];
                end;   }
               if lswert <> '' then
               begin
                  lganzzahl[iCntganzzahl].text := lswert;
               end;

               // Die Komponente erst am Schlu sichtbar machen
               Inc(iCntganzzahl, 1);
               // zur Deaktivierung der dynamischen Erzeugung des Zusatzfeldes Datum hier Begin der Auskommentares
            end
            else

//          if (iTyp = 7) or (ityp = 8) then
            if   (lTyp = zfld07_FliessKomma)
              or (ltyp = zfld08_Waehrung   )
            then
            begin
               // set just the proper length     (+2 cause there is always 2 date boxes)
               SetLength(ldouble, iCntdouble + 1);
               ldouble[iCntdouble] := TjvSpinEdit.Create(sbx_ZusFeld);
               ldouble[iCntdouble].Name := 'zedt_Tmp' + IntToStr(iC);
               ldouble[iCntdouble].Hint :=
                  _('Hier knnen Sie im Feld') + ' ' + #34 + FieldByName('Disp_Name').AsString +
                  #34 + ' ' + _('suchen');
               ldouble[iCntdouble].ShowHint := True;

               if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
               begin
                  ldouble[iCntdouble].Hint :=
                     _('Hier knnen Sie im Feld') + ' ' + #34 + '*' + FieldByName('Disp_Name').AsString +
                     #34 + ' ' + _('suchen');
                  ldouble[iCntdouble].Color := cColorPflichtfeld;
               end;
               ldouble[iCntdouble].Left := 30;
               ldouble[iCntdouble].Top := 21 + (40 * iC);
               ldouble[iCntdouble].Height := 21;
               // skywalker20070612 set the width of the zusatzfeld
               // equal the width of the normal date search
               if ((trunc(sbx_ZusFeld.Width / 2)) - 105) > 85 then
               begin
                  //'ldouble[iCntdouble].Width := ((trunc(sbx_ZusFeld.Width / 2)) - 105);
                  ldouble[iCntdouble].Width := 2*75+10;
               end
               else
               begin
                  //'ldouble[iCntdouble].Width := 85;
                  ldouble[iCntdouble].Width := 2*75+10;
               end;
               // ((trunc(sbx_ZusFeld.Width / 2)) - 30);

               ldouble[iCntdouble].Anchors := [akLeft, akTop];
               ldouble[iCntdouble].OnChange := zusfeldonchange;
               ldouble[iCntdouble].Tag := FieldByName('Mode').AsInteger;
               if ityp = 7 then
               begin
                  ldouble[iCntdouble].Decimal := 10;
               end
               else
               begin
                  ldouble[iCntdouble].Decimal := 2;
               end;
               ldouble[iCntdouble].ValueType := vtFloat;
               ldouble[iCntdouble].Parent := sbx_ZusFeld;

            {      if  (lbfound and lbrechte) or (not lbrechte) then
                  begin
           ldouble[iCntdouble].taborder:=litaborder;
                inc(litaborder);
                end;
                 if liindex > -1 then
                begin
                  ldouble[iCntdouble].text:= ZusWert.Strings[liindex];
                end;
                  }         if lswert <> '' then
               begin
                  ldouble[iCntdouble].text := lswert;
               end;
               {          if gai_cfg_rights[iC] then
                         begin
                        ldouble[iCntdouble].color := clwhite;
                        end
                        else
                        begin
                        ldouble[iCntdouble].color := gcnrz;
                        end;              }
               // Die Komponente erst am Schlu sichtbar machen
               Inc(iCntdouble, 1);
               // zur Deaktivierung der dynamischen Erzeugung des Zusatzfeldes Datum hier Begin der Auskommentares
            end;
            lbl[iCntLbl].Parent := sbx_ZusFeld;
            // Die Komponenten erst am Schlu sichtbar machen

            //
            SetLength(chx, iCntchx + 1);
            chx[iCntchx] := Tcheckbox.Create(sbx_ZusFeld);
            chx[iCntChx].Name := 'zedt_Tmpchx' + IntToStr(iC);
            chx[iCntchx].Left := 8;
            chx[iCntchx].Top := 21 + (40 * iC);
            chx[iCntchx].Height := 21;
            chx[iCntchx].Width := (20);
            chx[iCntchx].Anchors := [akLeft, akTop];
            chx[iCntchx].Tag := FieldByName('Mode').AsInteger;
            chx[iCntchx].Caption := '';
            chx[iCntchx].Parent := sbx_ZusFeld;
            chx[iCntchx].TabStop := false;
            inc(iCntchx, 1);

            SetLength(tbxb, iCnttbxb + 1);
            tbxb[iCnttbxb] := TTBXButton.Create(sbx_ZusFeld);
            tbxb[iCnttbxb].Name := 'zedt_Tmptbxb' + IntToStr(iC);
            tbxb[iCnttbxb].Left := (sbx_ZusFeld.Width - 25);
            tbxb[iCnttbxb].Top := 21 + (40 * iC);
            tbxb[iCnttbxb].Height := 21;
            tbxb[iCnttbxb].Width := (15);
            tbxb[iCnttbxb].Anchors := [akright, akTop];
            tbxb[iCnttbxb].Tag := FieldByName('Mode').AsInteger;
            tbxb[iCnttbxb].Caption := '';
            tbxb[iCnttbxb].hint := FieldByName('Feld_Name').AsString;
            tbxb[iCnttbxb].showhint := false;
            tbxb[iCnttbxb].Onclick := Searchzusfield;
            tbxb[iCnttbxb].Images := dm_Shared.il_ShScroll; //dm_MainForm2.jv_scroll;
            tbxb[iCnttbxb].ImageIndex := 1;
            tbxb[iCnttbxb].TabStop := false;

            tbxb[iCnttbxb].Parent := sbx_ZusFeld;

            inc(iCnttbxb, 1);

            Inc(iCntLbl, 1);
            Next;
         end; // for iC := 0 to (RecordCount - 1) do

         tbbt_search   .Top    := 21 + (40 * RecordCount);  //  22.06.2010  r.sch.
         tbxb_reset    .Top    := 21 + (40 * RecordCount);  //  22.06.2010  r.sch.
         frm_zuspflicht.Height := tbbt_search.Top + 140;    //  23.06.2010  r.sch.

//         if tbbt_search.Top < 21 + (40 * RecordCount) then
//         begin
//            tbbt_search.Top := 21 + (40 * RecordCount);
//            tbxb_reset.top := 21 + (40 * RecordCount);
//         end;

         tbbt_search.taborder := litaborder;
         inc(litaborder);
         tbxb_reset.taborder := litaborder;
      except
         on e: Exception do
         begin
            ErrorMsg('Tfrm_zuspflicht.CreZusFields', 'Fehler beim dynamischen Erzeugen der Zusatzfelder: ' +
               e.Message + #13 +
               'Bitte beenden Sie die Anwendung und starten diese erneut!', 2000, True);
            Result := 0;
            dm_DB.my_q_Tmp.Close;
         end;
      end;
      dm_DB.my_q_Tmp.Close;
   end;

   GgfLogEvntEnd ('Tfrm_zuspflicht.CreZusFields Ende');
end;

function Tfrm_zuspflicht.DelZusFields: integer;
var
   lcomp: Tcomponent;
begin
   Result := 0;
   if sbx_ZusFeld.ComponentCount = 0 then
      exit;
   try
      while sbx_ZusFeld.ComponentCount > 0 do
      begin
         lcomp := sbx_ZusFeld.Components[0];
         freeandnil(lcomp);
         //      sbx_IZus.Components[0].Free;
         inc(result, 1);
      end;
      ZusFldFrame := nil;
   except
      on e: Exception do
      begin
         ErrorMsg('DelZusFields', 'Fehler beim Entfernen der Zusatzfelder: ' +
            e.Message, 2006, True);
         Result := 0;
      end;
   end;

   tbbt_search.visible := false;
   tbxb_reset.visible := false;
   ftorpflichtfeld := 0;
end;

procedure Tfrm_zuspflicht.btn_okClick(Sender: TObject);
var
   torlockpflichtfeld: integer;
begin
   chkzusfield;
   torlockpflichtfeld := ftorpflichtfeld - fkeypflichtfeld;
   //showmessage ('torpflichtfeld (Inhalt nach Prfung) = '+ inttostr(torpflichtfeld));
   if TorlockPflichtfeld <> 0 then
   begin
      ShowMessage('Sie mssen erst die Pflichtfelder ausfllen.' +
         #13 + 'Pflichtfelder sind mit einem *(Stern) gekennzeichnet.' +
         #13 + 'Fehlende Felder:' + IntToStr(torlockpflichtfeld));
      if torlockpflichtfeld < 0 then
      begin
         logevnt('2 tor ' + IntToStr(ftorpflichtfeld) + ' key ' +
            IntToStr(fkeypflichtfeld));
      end;
      frm_zuspflicht.ModalResult := 0;
      exit;
   end;
   frm_zuspflicht.ModalResult := mrOk;
end;


function Tfrm_zuspflicht.ChkZusfield: boolean;
var // ini: TIniFile;
   iCount: integer;
   sFeld, sName, sWert: string;
   comp: TComponent;
   jvstcomp: tjvstatictext;
begin
   Result := false;//[Warnung] u_wvlpflichfelder.pas(916): Rckgabewert der Funktion 'Tfrm_zuspflicht.ChkZusfield' knnte undefiniert sein
   fkeypflichtfeld := 0;
   ///  ini := TIniFile.Create(FileName);
   try
      try
         //with ini do
         //begin     
         //    logevnt('3 TorPflichtfeld '+inttostr(TorPflichtfeld));
         for iCount := 0 to (fiZusFCount - 1) do
         begin
            jvstcomp := tjvstatictext(sbx_ZusFeld.FindComponent('zlbl_Tmp' +
               IntToStr(iCount)));

            sFeld := jvstcomp.Hint;
            sName := copy(jvstcomp.Caption, 1, Length(jvstcomp.Caption) - 1);
            sWert := '';
            comp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));
            if comp is TEdit then
            begin
               sWert := TEdit(comp).Text;
               // zuswert[icount]:=swert;
            end;
            if comp is TJvDateEdit then
            begin
               // showmessage ('swert of Dateedit = '+TJvDateEdit(comp).Text + inttostr(length( TJvDateEdit(comp).Text )));
               sWert := TJvDateEdit(comp).Text;
               if swert = frm_mainform.fdatestringempty then
                  swert := '';
               // zuswert[icount]:=swert;
            end;
            if comp is TComboBox then
            begin
               sWert := TComboBox(comp).Text;
               // zuswert[icount]:=swert;
            end;
            if comp is TSpinEdit then
            begin
               sWert := TSpinEdit(comp).Text;
               // zuswert[icount]:=swert;
            end;
            if comp is TjvSpinEdit then
            begin
               sWert := TjvSpinEdit(comp).Text;
               // zuswert[icount]:=swert;
            end;
            if comp is TjvcheckedComboBox then
            begin
               sWert := TjvcheckedComboBox(comp).Text;
               // zuswert[icount]:=swert;
            end;

            //WriteString('Zusatzfelder', 'ZusTitel' + IntToStr(iCount + 1), sName);
            //showmessage  ('ZusTitel' + IntToStr(iCount+1 )+ ' '+ sName);
            //showmessage  ('ZusFeld'  + IntToStr(iCount+1 )+ ' '+ sFeld);
            //showmessage  ('ZusWert'  + IntToStr(iCount+1 )+ ' '+ sWert);
            //          showmessage ('swert = :'+swert); 
            //    logevnt('4 TorPflichtfeld '+inttostr(TorPflichtfeld)+ ' '+sName);
            //    logevnt('1 keypflichtfeld '+inttostr(keypflichtfeld));
            if (leftstr(sname, 1) = '*') and (swert <> '') then
               Inc(fkeypflichtfeld);
            //    logevnt('2 keypflichtfeld '+inttostr(keypflichtfeld)+ ' '+sName);
         end;
         //end;
      except
         on e: Exception do
            ErrorMsg('btn_CreJob', 'Fehler beim Erstellen der Vorlagen Datei: ' +
               e.Message, 2023, True);
      end;
   finally
      //if Assigned(ini) then FreeAndNil(ini);
   end;
end;


procedure Tfrm_zuspflicht.zusfeldonchange(Sender: TObject);
begin
   if sender.ClassName = 'TEdit' then
   begin
   end;
   if sender.ClassName = 'TComboBox' then
   begin
   end;
   if sender.ClassName = 'TJvDateEdit' then
   begin
   end;
end;


procedure Tfrm_zuspflicht.Searchzusfield(Sender: TObject);
var
   lstmp, lssst: string;
   linum: integer;
   lcomp, lcomp1: TComponent;
   ljvst: tjvstatictext;
   bpflicht: boolean;
   ncbx: TComboBox;
   lsender: TTBXButton;
   lsItem: string; //[2351]
   FrameZusFldMulti: TFrameZusFldMulti; //[2351]
begin
   bpflicht := false;//[Warnung] u_wvlpflichfelder.pas(1084): Variable 'bpflicht' ist mglicherweise nicht initialisiert worden
   lsender := TTBXButton(sender);
   lstmp := copy(lsender.name, length('zedt_Tmptbxb') + 1, length(lsender.name) - length('zedt_Tmptbxb'));
   trystrtoint(lstmp, linum);
   lcomp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + lstmp);
   ljvst := tjvstatictext(sbx_ZusFeld.FindComponent('zlbl_Tmp' + lstmp));
   case ljvst.Tag of
      0:
      begin
         lssst := Tedit(lcomp).text;

         if tedit(lcomp).Color = cColorPflichtfeld then
         begin
            bpflicht := true;
         end
         else
         begin
            bpflicht := false;
         end;
      end;
      1:
      begin
         lssst := TJvDateEdit(lcomp).text;
         if TJvDateEdit(lcomp).Color = cColorPflichtfeld then
         begin
            bpflicht := true;
         end
         else
         begin
            bpflicht := false;
         end;
      end;
      2:
      begin
         lssst := TComboBox(lcomp).text;
         if TComboBox(lcomp).Color = cColorPflichtfeld then
         begin
            bpflicht := true;
         end
         else
         begin
            bpflicht := false;
         end;
      end;
      3:
      begin
         FrameZusFldMulti := TFrameZusFldMulti(TControl(lcomp).Parent); //[2351]
         lssst := TComboBox(lcomp).text;
         if TComboBox(lcomp).Color = cColorPflichtfeld then
         begin
            bpflicht := true;
         end
         else
         begin
            bpflicht := false;
         end;
      end;
      5:
      begin
         lssst := tspinedit(lcomp).text;
         lcomp1 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + lstmp);
         lssst := lssst + TComboBox(lcomp1).text;
         lcomp1.Free;
         if tspinedit(lcomp).Color = cColorPflichtfeld then
         begin
            bpflicht := true;
         end
         else
         begin
            bpflicht := false;
         end;
      end;
   end;

   lcomp1 := sbx_ZusFeld.FindComponent('jbzedt_Tmp' + lstmp);
   if lcomp1 <> nil then
   begin
      lcomp1.free;
   end;
   dm_db.my_q_Tmp.sql.text := 'select * from arc_' + fsDestIarcname +
      ' where ' + lsender.hint + ' like ' + #39 + '%' + lssst + '%' + #39;
   dm_db.my_q_Tmp.execute;

   lcomp.Free;
   ncbx := TComboBox.Create(sbx_ZusFeld);


   ncbx.Name := 'zedt_Tmp' + lstmp;
              {  cbx[iCntCbx].Hint := 'Hier knnen Sie im Feld ' + #34 +
                  FieldByName('Disp_Name').AsString + #34 + ' suchen';

                if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                  begin
                    cbx[iCntcbx].Hint := 'Hier knnen Sie im Feld ' + #34 + '*'
                      + FieldByName('Disp_Name').AsString + #34 + ' suchen';
                    cbx[iCntcbx].Color := cColorPflichtfeld;
                  end;
               }

   //                cbx[iCntCbx].ShowHint := True;
   ncbx.Left := 28;
   ncbx.Top := 21 + (40 * linum);
   ncbx.Height := 21;
   ncbx.Width := (sbx_ZusFeld.Width - 80);
   ncbx.Anchors := [akLeft, akTop, akRight];
   ncbx.OnChange := zusfeldonchange;
   //                ncbx.Tag := FieldByName('Mode').AsInteger;
   ncbx.Parent := sbx_ZusFeld;
   // Die Komponente erst am Schlu sichtbar machen
   ncbx.Clear;
   ncbx.Items.Add('');
   if bpflicht then
   begin
      ncbx.Color := cColorPflichtfeld;
   end;
   dm_db.my_q_Tmp.First;
   while not dm_db.my_q_Tmp.eof do
   begin
      if (dm_db.my_q_Tmp.fieldbyname(lsender.Hint).asstring <> '')
         and (0 >= ncbx.Items.IndexOf(dm_db.my_q_Tmp.fieldbyname(lsender.Hint).asstring)) then
      begin
         //ncbx.Items.Add(dm_db.my_q_Tmp.fieldbyname(lsender.Hint).asstring);
         //[2351]
         lsItem := dm_db.my_q_Tmp.fieldbyname(lsender.Hint).asstring;
         if Assigned(FrameZusFldMulti) then
            ComboBoxAddOneKomma(ncbx,lsItem)
         else
            ncbx.Items.Add(lsItem);
      end;
      dm_db.my_q_Tmp.Next;
   end;
end;


procedure Tfrm_zuspflicht.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

procedure Tfrm_zuspflicht.tbbt_searchClick(Sender: TObject);
var
   iCount, licount2: integer;
   comp, comp2, comp3, comp4, comp5: tcomponent;
   bfound, bpflicht: boolean;
   lsconju: string;
   lstext: string;
   lsaddname, lsgroupby: string;
   ncbx: TComboBox;
   lstlw: Tstringlist;

begin
   bpflicht := false;//[Warnung] u_wvlpflichfelder.pas(1399): Variable 'bpflicht' ist mglicherweise nicht initialisiert worden
   dm_db.my_q_Tmp.sql.text := 'select * from arc_' + fsDestIarcname;
   lsconju := ' and ';
   bfound := false;
   for iCount := 0 to (iGZusFCount - 1) do
   begin
      comp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmpchx' + IntToStr(iCount));
      comp2 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));
      comp3 := sbx_ZusFeld.FindComponent('zlbl_Tmp' + IntToStr(iCount));
      //    comp5:= sbx_ZusFeld.FindComponent('jbzedt_Tmp' + IntToStr(iCount));
      lsaddname := tlabel(comp3).Hint;

      if lsgroupby = '' then
      begin
         lsgroupby := lsaddname;
      end
      else
      begin
         lsgroupby := lsgroupby + ',' + lsaddname;
      end;
      if comp2 is Tedit then
      begin
         lstext := tedit(comp2).Text;
      end
      else
      if comp2 is TJvDateEdit then
      begin
         lstext := TJvDateEdit(comp2).Text;
      end
      else
      if comp2 is TComboBox then
      begin
         lstext := TComboBox(comp2).Text;
      end
      else
      if comp2 is TjvcheckedComboBox then
      begin
         lstext := TjvcheckedComboBox(comp2).Text;
      end
      else
      if comp2 is Tspinedit then
      begin
         lstext := Tspinedit(comp2).Text;
         comp4 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(iCount));
         lstext := lstext + TComboBox(comp4).Text;
      end;

      if Tcheckbox(comp).Checked then
      begin
         lstlw := StrToWords(ParserSemiColonusebackspace(lstext));
         if not bfound then
         begin
            if lstlw.count > 0 then
            begin
               dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' where (';
               for licount2 := 0 to lstlw.Count - 1 do
               begin
                  lstlw.Strings[licount2] := Trim(stringreplace(lstlw.Strings[licount2], ',', '', [rfReplaceAll]));
                  if licount2 = 0 then
                  begin
                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + '(' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end
                  else
                  begin
                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' or (' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end;
               end;
               dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ')';
            end;
            bfound := true;
         end
         else
         begin
            dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + lsconju + '(';
            if lstlw.count > 0 then
            begin
               for licount2 := 0 to lstlw.Count - 1 do
               begin
                  lstlw.Strings[licount2] := Trim(stringreplace(lstlw.Strings[licount2], ',', '', [rfReplaceAll]));
                  if licount2 = 0 then
                  begin
                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + '(' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end
                  else
                  begin
                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' or (' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end;
               end;
               dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ')';
            end;
         end;
         freeandnil(lstlw);
      end;
   end;
   dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' group by ' + lsgroupby;
   dm_db.my_q_Tmp.Execute;

   for iCount := 0 to (iGZusFCount - 1) do
   begin
      comp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmpchx' + IntToStr(iCount));
      comp2 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));
      comp3 := sbx_ZusFeld.FindComponent('zlbl_Tmp' + IntToStr(iCount));
      comp4 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(iCount));
      comp5 := sbx_ZusFeld.FindComponent('lfbzedt_Tmp' + IntToStr(iCount));

      if comp2 is TjvDateedit then
      begin
         continue;
      end;

      if not Tcheckbox(comp).Checked then
      begin
         if comp2 is Tedit then
         begin
            if tedit(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TJvDateEdit then
         begin
            if TJvDateEdit(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TComboBox then
         begin
            if TComboBox(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TSpinEdit then
         begin
            if TComboBox(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TjvcheckedComboBox then
         begin
            if TjvcheckedComboBox(comp2).NoFocusColor = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end;
         comp2.Free;
         if comp4 <> nil then
         begin
            comp4.free;
         end;
         if comp5 <> nil then
         begin
            comp5.free;
         end;
         ncbx := TComboBox.Create(sbx_ZusFeld);
         ncbx.Name := 'zedt_Tmp' + IntToStr(iCount);
              {  cbx[iCntCbx].Hint := 'Hier knnen Sie im Feld ' + #34 +
                  FieldByName('Disp_Name').AsString + #34 + ' suchen';

                if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                  begin
                    cbx[iCntcbx].Hint := 'Hier knnen Sie im Feld ' + #34 + '*'
                      + FieldByName('Disp_Name').AsString + #34 + ' suchen';
                    cbx[iCntcbx].Color := cColorPflichtfeld;
                  end;
               }
         //                cbx[iCntCbx].ShowHint := True;
         ncbx.Left := 28;
         ncbx.Top := 21 + (40 * iCount);
         ncbx.Height := 21;
         ncbx.Width := (sbx_ZusFeld.Width - 60);
         ncbx.Anchors := [akLeft, akTop, akRight];
         //                ncbx.Tag := FieldByName('Mode').AsInteger;
         ncbx.OnChange := zusfeldonchange;
         ncbx.Parent := sbx_ZusFeld;
         // Die Komponente erst am Schlu sichtbar machen
         ncbx.Clear;
         ncbx.Items.Add('');
         if bpflicht then
         begin
            ncbx.Color := cColorPflichtfeld;
         end;
         ncbx.Sorted := true;
         dm_db.my_q_Tmp.First;
         while not dm_db.my_q_Tmp.eof do
         begin
            if (dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring <> '')
               and (0 >= ncbx.Items.IndexOf(dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring)) then
            begin
               ncbx.Items.Add(dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring);
            end;
            dm_db.my_q_Tmp.Next;
         end;
         //                comp2.Items.CommaText := FieldByName('Werte').AsString;
         //                comp2.onchange :=zusfeldonchange;
      end;
   end;
end;


procedure Tfrm_zuspflicht.tbxb_resetClick(Sender: TObject);
begin
   DelZusFields;
   CreZusFields;
end;


procedure Tfrm_zuspflicht.setMoveOk (Ok: Boolean);
  begin
    btn_ok.Enabled := Ok;
  end;


// 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
//
procedure Tfrm_zuspflicht.OnChangeComboBox (Sender: TObject);
  begin
    setMoveOk (getTextIdx (Sender as TComboBox) >= 0);
  end;


// 27.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
//
procedure Tfrm_zuspflicht.onExitComboBox (Sender: TObject);

  var
    lBox : TComboBox;
    lText: String;

  begin
    lBox  := Sender as TComboBox;
    lText := lBox.Text;

    if gExitFlag then
    begin
      gExitFlag := False;
      lBox.SetFocus;
      Exit;
    end;

    if adjustText (lBox) then
    begin
      setMoveOk (True);
    end
    else
    begin
      setMoveOk   (False);
      ShowMessage (Format(_('Die Eingabe "%s" ist ungltig!'),[lText]) +#13
                         +_('Bitte whlen Sie einen Eintrag aus der Auswahlliste.'));

      lBox.SetFocus;
      gExitFlag := True;
    end;
  end;

end.

