program bfaSpooldienst;

uses
  SvcMgr,
  u_bfaSpooldienst in 'u_bfaSpooldienst.pas' {bfaSpoolSrv: TService};

{$R *.RES}

begin
  // Fr Windows 2003 Server muss StartServiceCtrlDispatcher
  // CoRegisterClassObject aufgerufen werden, das von Application.Initialize
  // indirekt aufgerufen werden kann. TServiceApplication.DelayInitialize ermglicht,
  // dass Application.Initialize von TService.Main aufgerufen werden kann
  // (nachdem StartServiceCtrlDispatcher aufgerufen wurde).
  //
  // Eine verzgerte Initialisierung des Application-Objekts knnte sich auf
  // Ereignisse auswirken, die dann vor der Initialisierung auftreten, wie z.B.
  // TService.OnCreate. Dies wird nur empfohlen, wenn ServiceApplication
  // ein Klassenobjekt bei OLE registriert und sollte nur in Verbindung mit
  // Windows 2003 Server verwendet werden.
  //
  // Application.DelayInitialize := True;
  //
  if not Application.DelayInitialize or Application.Installing then
    Application.Initialize;
  Application.CreateForm(TbfaSpoolSrv, bfaSpoolSrv);
  Application.Run;
end.
