program countfiles;

{$APPTYPE CONSOLE}

uses
   SysUtils, Classes, Windows;

var
   pfad, ext: String;
   liste: TStringList;
   i: Integer;
   list: String;

{$R *.res}

function ReadDir(Path, Mask: string; ShowPath: boolean): TStringlist;
var SRec: TSearchRec;
begin
   Path := IncludeTrailingBackslash(Path);
   result := TStringList.Create;
   try
      if FindFirst(Path + Mask, not faDirectory, SRec) <> 0 then
         exit;
      repeat
         case ShowPath of
            True:
               result.Add(Path + SRec.Name);
            False:
               result.Add(SRec.Name);
         end;
      until FindNext(SRec) <> 0;
   finally
      //FindClose(SRec);

   end;
end;


begin
   { TODO -oUser -cConsole Main : Hier Code einfgen }


   WriteLN('bitfarm-Archiv(2010)  countfiles.exe (GPL)');
   WriteLN('liest die Anzahl an Dateien aus einem bestimmten Verzeichnis');
   WriteLN('entsprechend einer Maske (zB *.job)');
   WriteLN('Aufruf  countfiles.exe <pfad><maske>{-l|-lf}');
   WriteLN('-l      listet die gefundenen Dateien auf');
   WriteLN('-lf     gibt den Namen der ersten entsprechenden Datei aus');
   WriteLN('-ll     gibt den Namen der letzten entsprechenden Datei aus');
   WriteLN('Die Anzahl wird als ExitCode der Routine zurueckgegeben');


   pfad := Paramstr(1);
   ext := Paramstr(2);

   if (paramstr(3) = '-l') then
      list := 'liste';
   if (paramstr(3) = '-lf') then
      list := 'erste';
   if (paramstr(3) = '-ll') then
      list := 'letzte';

   liste := ReadDir(pfad, ext, False);

   writeLN('Anzahl:' + inttostr(liste.count));
   exitcode := liste.count;

   if liste.Count > 0 then
   begin
      if list = 'liste' then
      begin
         for i := 0 to liste.Count - 1 do
            writelN(liste.strings[i]);
      end;


      if list = 'erste' then
         WriteLN(liste.Strings[0]);

      if list = 'letzte' then
         WriteLN(liste.Strings[liste.count - 1]);

   end
   else
      WriteLN('');

   exit;

end.
