unit u_Info;

interface
///////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
// Igel0701101353 Feature modifieyed Copyright to 7
//
uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, jpeg, ExtCtrls, gnugettext,
   u_ShLowUtils;
function GetVersionInfo: string; //#3.5

type
   Tfrm_Info = class (TForm)
      img_Logo: TImage;
      lbl_Info1: TLabel;
      lbl_Info2: TLabel;
      lbl_Info3: TLabel;
      lbl_Info4: TLabel;
      lbl_Info5: TLabel;
      lbl_Info6: TLabel;
      lbl_Info8: TLabel;
      lbl_Info7: TLabel;
      Button1: TButton;
      procedure img_LogoClick(Sender: TObject);
      procedure btn_CloseClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormShow(Sender: TObject);
      procedure FormKeyUp(Sender: TObject; var Key: Word;
         Shift: TShiftState);
      procedure Button1Click(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_Info: Tfrm_Info;

implementation

uses u_Rights;

{$R *.dfm}

{3.6<}
function GetVersionInfo: string;
var
   VerInfoSize: DWord;
   VerInfo: Pointer;
   VerValueSize: DWord;
   VerValue: PVSFixedFileInfo;
   Dummy: DWord;
begin
   VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
   GetMem(VerInfo, VerInfoSize);
   GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
   VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
   with VerValue^ do
   begin
      result := IntTostr(dwFileVersionMS shr 16);
      result := result + '.' + IntTostr(dwFileVersionMS and $FFFF);
      result := result + '.' + IntTostr(dwFileVersionLS shr 16);
      result := result + '.' + IntTostr(dwFileVersionLS and $FFFF);
   end;
   FreeMem(VerInfo, VerInfoSize);
end;
{>3.6}


procedure Tfrm_Info.img_LogoClick(Sender: TObject);
begin
   //frm_Info.Caption := 'Test';
   If (lbl_Info1.Caption = 'bitfarm Archiv V3 Administrator - Version ' + GetVersionInfo) then
   begin
      lbl_Info1.Caption := 'Idee, Design && Konzept by:';
      lbl_Info2.Caption := 'Sebastian Vlke';
      lbl_Info3.Caption := 'Untere Weitzberg Strasse 2';
      lbl_Info4.Caption := '35745 Herborn-Burg    (c) 2005';
      lbl_Info5.Caption := 'eMail:';
      lbl_Info6.Caption := 'n.achtfalter@gmx.net';
      lbl_Info7.Visible := False;
      exit;
   end;

   If (lbl_Info1.Caption = 'Idee, Design && Konzept by:') then
   begin
      lbl_Info1.Caption := 'bitfarm Archiv V3 Administrator - Version ' + GetVersionInfo;
      lbl_Info2.Caption := 'bitfarm Informationssysteme GmbH';
      lbl_Info3.Caption := 'Sandstrasse 108';
      lbl_Info4.Caption := '57072 Siegen';
      lbl_Info5.Caption := 'HotLine:';
      lbl_Info6.Caption := '0271-31396-0';
      lbl_Info7.Visible := True;
      exit;
   end;
end;

procedure Tfrm_Info.btn_CloseClick(Sender: TObject);

begin
   frm_Info.Destroy;
end;

procedure Tfrm_Info.FormClose(Sender: TObject; var Action: TCloseAction);
//var alpha: byte;
begin
 { for alpha := 255 downto 0 do
  begin
    frm_Info.AlphaBlendValue := alpha;
    sleep(10);
  end;
  frm_Info.Release; }
end;

procedure Tfrm_Info.FormShow(Sender: TObject);
begin
   lbl_Info1.Caption := 'bitfarm Archiv V3 Administrator - Version ' + GetVersionInfo
end;

procedure Tfrm_Info.FormKeyUp(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin
   if key = vk_escape then
      frm_Info.Close;
end;

procedure Tfrm_Info.Button1Click(Sender: TObject);
begin
   Application.CreateForm(Tfrm_Rights, frm_Rights);
   frm_Rights.ShowModal;
   frm_Rights.Release;
end;

procedure Tfrm_Info.FormCreate(Sender: TObject);
begin
   TranslateComponent(self);
end;

end.
