unit u_createDB;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TCreateNewDB = class(TForm)
    lbl_Profil: TLabel;
    edt_Profil: TEdit;
    lbl_Server: TLabel;
    edt_Server: TEdit;
    lbl_DBName: TLabel;
    edt_dbname: TEdit;
    btn_Create: TButton;
    btn_Cancel: TButton;
    lbl_user: TLabel;
    edt_User: TEdit;
    lbl_Pass: TLabel;
    edt_Pass: TEdit;
    lbl_Port: TLabel;
    edt_Port: TEdit;
    procedure edt_ProfilChange(Sender: TObject);
    procedure edt_ServerChange(Sender: TObject);
    procedure edt_dbnameChange(Sender: TObject);
    procedure edt_UserChange(Sender: TObject);
    procedure edt_PassChange(Sender: TObject);
    procedure edt_PortChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    function enableBTN: Boolean;
  public
    { Public-Deklarationen }
  end;

var
  CreateNewDB: TCreateNewDB;

implementation

{$R *.dfm}


function TCreateNewDB.enableBTN():Boolean;
begin
   btn_Create.Enabled := (Trim(edt_Profil.Text) <> '') and (Trim(edt_Server.Text) <> '')
                     and (Trim(edt_dbname.Text) <> '') and (Trim(edt_User.Text) <> '')
                     and (Trim(edt_Pass.Text) <> '')   and (Trim(edt_Port.Text) <> '');

end;


procedure TCreateNewDB.edt_ProfilChange(Sender: TObject);
begin
   enableBTN;
end;

procedure TCreateNewDB.edt_ServerChange(Sender: TObject);
begin
   enableBTN;
end;

procedure TCreateNewDB.edt_dbnameChange(Sender: TObject);
begin
	enableBTN;
end;

procedure TCreateNewDB.edt_UserChange(Sender: TObject);
begin
   enableBTN;
end;

procedure TCreateNewDB.edt_PassChange(Sender: TObject);
begin
   enableBTN;
end;

procedure TCreateNewDB.edt_PortChange(Sender: TObject);
begin
   enableBTN;
end;

procedure TCreateNewDB.FormCreate(Sender: TObject);
begin
	TranslateComponent(Self);
end;

end.
