unit u_statusrights;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, JvExStdCtrls, JvListBox, Buttons, ComCtrls, gnugettext,
   u_ShLowUtils, u_ShDbUtils;

type
   Tfrm_Statusrights = class (TForm)
      lv_UsrGrp: TListView;
      lv_ArcMember: TListView;
      sbtn_ArcRAddMem: TSpeedButton;
      sbtn_ArcRRemMem: TSpeedButton;
      lv_status: TListView;
      btn_stsxsdefault: TButton;
      Label5: TLabel;
      btn_del: TButton;
    edtUser: TEdit;
      Edit2: TEdit;
      Label6: TLabel;
      Label7: TLabel;
    btn_Close: TButton;
    btn_ReadOnly: TButton;
      procedure FormShow(Sender: TObject);
      procedure sbtn_ArcRAddMemClick(Sender: TObject);
      procedure btn_CloseClick(Sender: TObject);
      procedure lv_statusSelectItem(Sender: TObject; Item: TListItem;
         Selected: Boolean);
      procedure btn_stsxsdefaultClick(Sender: TObject);
      procedure btn_tablestatusClick(Sender: TObject);
      procedure btn_delClick(Sender: TObject);
      procedure Edit2KeyUp(Sender: TObject; var Key: Word;
         Shift: TShiftState);
      procedure edtUserKeyUp(Sender: TObject; var Key: Word;
         Shift: TShiftState);
      procedure FormCreate(Sender: TObject);
    procedure btn_ReadOnlyClick(Sender: TObject);
   private
      procedure checkexistency;
      { Private-Deklarationen }
   public
      procedure readrights;
      procedure readgroupsuser;
      { Public-Deklarationen }
   end;

var
   frm_Statusrights: Tfrm_Statusrights;

implementation

uses u_mainform, strutils, u_dm_mainform;
{$R *.dfm}

procedure Tfrm_Statusrights.readrights;
var listsid: integer;
begin
  GgfLogEvntBeg('Tfrm_Statusrights.readrights begin');
   try
      if  DbTableExist('stsxs_' + GArcTblName) then
      begin
        if lv_Status.SelCount > 0 then
         begin
            listsid := integer(lv_Status.Selected.Data);
            try

               if dm_mainform.UsrSelectedSZ('select usr_Name from sys_usr left join  stsxs_' + GArcTblName + ' as a on sys_usr.usr_id = a.usr_id ' +
                  'and Grp_ID = 0  where grp_ID = 0 and sts_id =' + inttostr(listsid) +
                  ' and not (usr_name like ' + #39 + 'del\_%' + #39 + ') group by usr_name order by usr_name') then
               begin
                  lv_ArcMember.Items.Clear;
                  while not dm_mainform.my_q_usr_selected_sz.Eof do
                  begin
                     with lv_ArcMember.Items.Add do
                     begin
                        Caption := dm_mainform.my_q_usr_selected_sz.FieldByName('usr_name').AsString;
                        ImageIndex := 3;
                     end;
                     dm_mainform.my_q_usr_selected_sz.Next;
                  end;
               end
               else ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'), 2013, True);

               if dm_mainform.GrpSQLSelectedSZ('select grp_Name from sys_grp left join stsxs_' + GArcTblName + ' as a on sys_grp.grp_id = a.grp_id ' +
                  ' and Usr_ID = 0 where sts_id =' + inttostr(listsid) +
                  ' and not (grp_name like ' + #39 + 'del\_%' + #39 + ') order by grp_name') then
               begin
                  while not dm_mainform.my_q_Grp_selected_sz.Eof do
                  begin
                     with lv_ArcMember.Items.Add do
                     begin
                        Caption := dm_mainform.my_q_Grp_selected_sz.FieldByName('grp_name').AsString;
                        ImageIndex := 2;
                     end;
                     dm_mainform.my_q_Grp_selected_sz.Next;
                  end;
               end
               else ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'), 2013, True);

            except
               on e: exception do
                  ErrorMsg('sbtn_ArcRRemMemClick', _('Fehler beim Entfernen einer Gruppe aus einem Archiv:')+' ' + e.Message, 2019, True);
            end;
         end;

      end;
   finally
      GgfLogEvntEnd('Tfrm_zusatzrights.readrights end');
   end
end;


procedure Tfrm_Statusrights.readgroupsuser;
var listsid: integer;
stsxs:Boolean;
sSQL: string;
begin
   stsxs:=False;
   GgfLogEvntBeg('Tfrm_Statusrights.readgroupsuser begin');
   try

     if  DbTableExist('stsxs_' + GArcTblName) then
          stsxs:=True;

     if lv_Status.SelCount > 0 then
     begin
        listsid := integer(lv_Status.Selected.Data);
        lv_UsrGrp.Items.Clear;

        if stsxs then
          sSQL:= 'select grp_Name from sys_grp left join stsxs_' + GArcTblName + ' as a on sys_grp.grp_id = a.grp_id ' +
           'and sts_id = ' + IntToStr(listsid) + ' and Usr_ID = 0 where a.Grp_ID is NULL  ' +
           ' and not (grp_name like ' + #39 + 'del\_%' + #39 + ') order by grp_name'
        else
           sSQL:= 'select grp_Name from sys_grp where not (grp_name like '+#39+'del\_%'+#39+') order by grp_Name';

        if dm_MainForm.GrpSQLALLSZ(sSQL) then
        begin
           while not dm_MainForm.my_q_grp_all_sz.Eof do
           begin
              if lowercase(leftstr(dm_mainform.my_q_grp_all_sz.FieldByName('grp_name').AsString, 4)) <> 'del_' then
              begin
                 with lv_UsrGrp.Items.Add do
                 begin

                    Caption := dm_mainform.my_q_grp_all_sz.FieldByName('grp_name').AsString;
                    ImageIndex := 2;
                 end;
              end;
              dm_mainform.my_q_grp_all_sz.Next;
           end;
        end
        else ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'), 2013, True);

        if stsxs then
          sSQL:=  'select usr_Name from sys_usr left join stsxs_' + GArcTblName + ' as a  on sys_usr.usr_id = a.usr_id ' +
           'and Grp_ID = 0 and sts_id = ' + IntToStr(listsid) + ' where grp_ID is null ' +
           ' and not (usr_name like ' + #39 + 'del\_%' + #39 + ') group by usr_name order by usr_name'
        else
          sSQL:= 'select usr_Name from sys_usr where not (usr_name like '+#39+'del\_%'+#39+') order by usr_Name';

        if dm_mainform.UsrSQLALLSZ(sSQL) then
        begin
           while not dm_MainForm.my_q_usr_all_sz.Eof do
           begin
              if lowercase(leftstr(dm_mainform.my_q_usr_all_sz.FieldByName('usr_name').AsString, 4)) <> 'del_' then
              begin
                 with lv_UsrGrp.Items.Add do
                 begin
                    Caption := dm_MainForm.my_q_usr_all_sz.FieldByName('usr_name').AsString;
                    ImageIndex := 3;
                 end;
              end;
              dm_MainForm.my_q_usr_all_sz.Next;
           end;
        end
        else ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'), 2013, True);
     end;

   finally
      GgfLogEvntEnd('Tfrm_Statusrights.readgroupsuser end');
   end

end;

procedure Tfrm_Statusrights.FormShow(Sender: TObject);
begin
   frm_MainForm.ArchivSQL('select * from sts_' + GArcTblName + ' order by sts_id');
   lv_status.Items.Clear;
   while not dm_mainform.my_qry_Arc.Eof do
   begin

      lv_status.AddItem(dm_mainform.my_qry_Arc.FieldByName('sts_Name').AsString, TObject(dm_mainform.my_qry_Arc.FieldByName('sts_id').AsInteger));

      dm_mainform.my_qry_Arc.Next;
   end;
   readrights;
   readgroupsuser;

   btn_tablestatusClick(Sender);
end;


procedure Tfrm_Statusrights.sbtn_ArcRAddMemClick(Sender: TObject);
var TmpUpdStr, lsCaption, lsSql: String;
   licount, lGrpID, lUsrID, listsid: integer;
begin
   checkexistency;
   if lv_Status.SelCount > 0 then
   begin
      listsid := integer(lv_Status.Selected.Data);
   end
   else
   begin
      exit;
   end;
   
   if lv_UsrGrp.SelCount <> 0 then
   begin
      lsCaption := lv_UsrGrp.Selected.Caption;
      if lv_UsrGrp.Selected.ImageIndex = 3 then
      begin
         lsSql := 'Select * from sys_usr where Usr_Name = ' + #39 + lsCaption + #39;
         if frm_MainForm.TMPSQL(lsSql) then
         begin
            lUsrID := dm_mainform.my_q_tmp.FieldByName('Usr_ID').AsInteger;
            try
               lsSql := 'Insert into stsxs_' + GArcTblName + ' (STS_ID, USR_ID, Grp_ID) Values (' + IntToStr(listsid) + ', ' + IntToStr(lUsrID) + ', 0)';
               DbX(lsSql);
            except
               on e: exception do
                  ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Hinzufgen eines Benutzers in ein Archiv:')+' ' + e.Message, 2015, True);
            end;
         end
         else ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Auslesen der USR_ID eines Benutzers'), 2014, True);

         for licount := 0 to lv_ArcMember.Items.Count - 1 do
         begin
            if lv_ArcMember.Items.Item[licount].Caption = lsCaption then
            begin
               lv_ArcMember.ItemIndex := licount;
               break;
            end;
         end;

         if lv_UsrGRP_item >= lv_usrGrp.Items.Count then
         begin
            lv_usrGrp.ItemIndex := lv_usrGrp.Items.Count - 1;
         end
         else
         begin
            lv_usrGrp.ItemIndex := lv_UsrGRP_item
         end;
         readrights;
         readgroupsuser;
         btn_tablestatusClick(SENDER);
         exit;
      end;

      if lv_UsrGrp.Selected.ImageIndex = 2 then
      begin
         lsSql := 'Select * from sys_grp where grp_name = ' + #39 + lsCaption + #39;
         if frm_mainform.TMPSQL(lsSql) then
         begin
            lGrpID := dm_mainform.my_q_tmp.FieldByName('Grp_id').AsInteger;
            if frm_mainform.TMPSQL('Select * from sys_grpusr where grp_id = ' + IntToStr(lGrpID)) then
            begin
               while not dm_mainform.my_q_tmp.Eof do
               begin
                  TmpUpdStr := TmpUpdStr + '(' + IntToStr(listsid) + ',' + IntToStr(dm_mainform.my_q_tmp.FieldByName('USR_ID').AsInteger) + ',' + IntToStr(lGrpID) + '),';
                  dm_mainform.my_q_tmp.Next;
               end;
               TmpUpdStr := TmpUpdStr + '(' + IntToStr(listsid) + ',0,' + IntToStr(lGrpID) + ')';
               try
                  lsSql := 'insert into stsxs_' + GArcTblName + ' (STS_ID, USR_ID, Grp_ID) Values ' + TmpUpdStr;
                  DbX(lsSql);
               except
                  on e: exception do
                  begin
                     ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Hinzufgen eines Benutzers in ein Archiv:')+' ' + e.Message, 2015, True);
                     exit;
                  end;
               end;
            end
            else ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Auslesen der Benutzer einer Gruppe'), 2012, True);
         end
         else ErrorMsg('sbtn_ArcRAddMemClick', _('Fehler beim Auslesen der Grp_ID'), 2015, True);

         readrights;
         readgroupsuser;
         btn_tablestatusClick(SENDER);
         exit;
      end;
   end;
   btn_tablestatusClick(SENDER);
end;

procedure Tfrm_Statusrights.btn_CloseClick(Sender: TObject);
var lsMember, lsFeld, lsSql: string;  liImageIndex, liStsId: integer;
begin
   if not Assigned(lv_ArcMember.Selected)
   then Exit;
   checkexistency;

   lsMember := AddQuote(lv_ArcMember.Selected.Caption);
   liImageIndex := lv_ArcMember.Selected.ImageIndex;
   lsFeld := AddQuote(lv_status.Selected.Caption);
   liStsId := DbTableColumnGetInteger('Select * from sts_'+GArcTblName+' where sts_Name = ' + lsFeld);

   if (liStsId > 0) and (lv_ArcMember.SelCount <> 0) then
   begin
      case liImageIndex of
         3 : //User
         begin
            GUsrID := DbTableColumnGetInteger('Select * from sys_usr where Usr_Name = ' + lsMember);
            if GUsrID = -1 then
               ErrorMsg('btn_CloseClick', _('Fehler beim Auslesen der USR_ID eines Benutzers'), 2014, True)
            else
               begin
                  try
                     lsSql := 'delete from stsxs_' + GArcTblName +
                              ' where  (usr_id = ' + IntToStr(GUsrID) + ') and (Grp_ID = 0) ' +
                              ' and ( sts_id = '+IntToStr(liStsId)+' )';
                     DbX(lsSql);
                  except
                     on e: exception do
                        ErrorMsg('btn_CloseClick', _('Fehler beim Entfernen eines Benutzers aus einem Archiv:')+' ' + e.Message, 2018, True);
                  end;

                  if lv_Arcmem_item >= lv_ArcMember.Items.Count then
                  begin
                     lv_ArcMember.ItemIndex := lv_ArcMember.Items.Count - 1;
                  end
                  else
                  begin
                     lv_ArcMember.ItemIndex := lv_ArcMem_item;
                  end;
               end;
         end;

         2: // Gruppe
         begin
            GGrpID := DbTableColumnGetInteger('Select * from sys_grp where grp_name = ' + lsMember);
            if GGrpID = -1 then
               ErrorMsg('btn_CloseClick', _('Fehler beim Auslesen der GRP_ID eines Benutzers'), 2012, True)
            else
               try
                  lsSql := 'delete from stsxs_' + GArcTblName +
                           ' where  (Grp_ID = ' + IntToStr(GGrpID)+') ' +
                           ' and ( sts_id = '+IntToStr(liStsId)+'  )';
                  DbX(lsSql);
               except
                  on e: exception do
                     ErrorMsg('btn_CloseClick', _('Fehler beim Entfernen einer Gruppe aus einem Archiv:')+' ' + e.Message, 2019, True);
               end;
         end;
      end;
   end;
   readrights;
   readgroupsuser;
   btn_tablestatusClick(SENDER);
end;

procedure Tfrm_Statusrights.lv_statusSelectItem(Sender: TObject;
   Item: TListItem; Selected: Boolean);
begin
   try

      readrights;
      readgroupsuser;
   except
      on e: exception do
         ErrorMsg('lv_statusSelectItem', _('Fehler beim Auflisten einer Gruppe:')+' ' + e.Message, 2019, True);
   end;
   btn_tablestatusClick(Sender);
end;

procedure Tfrm_Statusrights.btn_stsxsdefaultClick(Sender: TObject);
var listsid: integer;
begin
   checkexistency;
   if lv_Status.SelCount > 0 then
   begin
      listsid := integer(lv_Status.Selected.Data);
      try
         // rejoin where stsxs_id is null
         DbX('insert into stsxs_' + GArcTblName + ' (sts_id,usr_id, grp_id) ' +
            ' select ' + inttostr(listsid) + ' , a.usr_id, a.grp_id from sys_arcxs as a left join stsxs_' +
            GArcTblName + ' as b on (b.usr_id=a.usr_id and b.grp_id= a.grp_id) where arc_id = ' + inttostr(Garcid) +
            ' and (find_in_set(' + #39 + 'write' + #39 + ', rights) or  find_in_set(' + #39 + 'modify' + #39 + ', rights))' +
            ' and ((stsxs_id is null) or (sts_id <> ' + inttostr(listsid) + ' ))');
      except
         on e: exception do
            ErrorMsg('btn_stsxsdefaultClick', _('Fehler beim Setzen der Defaultrechte:')+' ' + e.Message, 2019, True);
      end;
      readrights;
      readgroupsuser;
      btn_tablestatusClick(SENDER);
   end;
end;

procedure Tfrm_Statusrights.btn_tablestatusClick(Sender: TObject);
begin
   try
      if not DbTableExist('stsxs_' + GArcTblName) then
      begin
         label5.Caption := _('Noch keine Statusfeldrechte gesetzt.');
         btn_del.Enabled:=False;
         btn_ReadOnly.Enabled:=True;
      end
      else
      begin
        frm_MainForm.ArchivSQL('select * from stsxs_' + GArcTblName );
         if  dm_mainform.my_qry_Arc.RecordCount = 0 then
          label5.Caption := _('Es sind Statusfeldrechte gesetzt (nur lesend).')
         else
         label5.Caption := _('Es sind Statusfeldrechte gesetzt.');
         btn_del.Enabled:=True;
         btn_ReadOnly.Enabled:=False;
      end;
   except on e: exception do
      begin
      end;
   end;
end;

procedure Tfrm_Statusrights.btn_delClick(Sender: TObject);
begin
    if MessageDlg(_('Sind Sie sicher, dass Sie die Rechte lschen mchten?')
      , mtWarning, [mbYes, mbCancel], 0) = mrCancel then
      Exit;

   try
      DbX('Drop Table stsxs_' + GArcTblName);
   except
      on e: Exception do
         ErrorMsg('btn_delClick', _('Fehler beim Lschen der stsxs_ Archivtabelle:')+' ' + e.Message, 1004, True);
   end;
   //readrights;
   //readgroupsuser;
   lv_ArcMember.Clear;
   btn_tablestatusClick(SENDER);
end;


procedure Tfrm_Statusrights.Edit2KeyUp(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin

   lv_ArcMember.Items.Clear;
   if Edit2.text <> '' then
   begin
      dm_mainform.my_q_usr_selected_sz.first;
      while not dm_mainform.my_q_usr_selected_sz.eof do
      begin
         if pos(lowercase(Edit2.text),
            lowercase(dm_mainform.my_q_usr_selected_sz.fieldbyname('usr_name').AsString)) > 0
         then
         begin

            with lv_ArcMember.Items.Add do
            begin
               Caption := dm_mainform.my_q_Usr_selected_sz.FieldByName('usr_name').AsString;
               ImageIndex := 3;
            end;
         end;


         dm_mainform.my_q_usr_selected_sz.next;
      end;
      dm_mainform.my_q_grp_selected_sz.first;
      while not dm_mainform.my_q_grp_selected_sz.eof do
      begin
         if pos(lowercase(Edit2.text),
            lowercase(dm_mainform.my_q_grp_selected_sz.fieldbyname('grp_name').AsString)) > 0
         then
         begin

            with lv_ArcMember.Items.Add do
            begin
               Caption := dm_mainform.my_q_grp_selected_sz.FieldByName('grp_name').AsString;
               ImageIndex := 2;
            end;
         end;


         dm_mainform.my_q_grp_selected_sz.next;
      end;
   end
   else
   begin
      dm_mainform.my_q_usr_selected_sz.first;
      while not dm_mainform.my_q_usr_selected_sz.eof do
      begin

         with lv_ArcMember.Items.Add do
         begin
            Caption := dm_mainform.my_q_Usr_selected_sz.FieldByName('usr_name').AsString;
            ImageIndex := 3;
         end;


         dm_mainform.my_q_usr_selected_sz.next;
      end;
      dm_mainform.my_q_grp_selected_sz.first;
      while not dm_mainform.my_q_grp_selected_sz.eof do
      begin
         with lv_ArcMember.Items.Add do
         begin
            Caption := dm_mainform.my_q_grp_selected_sz.FieldByName('grp_name').AsString;
            ImageIndex := 2;
         end;
         dm_mainform.my_q_grp_selected_sz.next;
      end;
   end;
end;

procedure Tfrm_Statusrights.edtUserKeyUp(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin
   lv_UsrGrp.Items.Clear;
   if edtUser.text <> '' then
   begin
      dm_mainform.my_q_grp_all_sz.first;
      while not dm_mainform.my_q_grp_all_sz.eof do
      begin
         if pos(lowercase(edtUser.text),
            lowercase(dm_mainform.my_q_grp_all_sz.fieldbyname('grp_name').AsString)) > 0
         then
         begin
            with lv_UsrGrp.Items.Add do
            begin
               Caption := dm_mainform.my_q_grp_all_sz.FieldByName('grp_name').AsString;
               ImageIndex := 2;
            end;
         end;
         dm_mainform.my_q_grp_all_sz.next;
      end;
      dm_mainform.my_q_usr_all_sz.first;
      while not dm_mainform.my_q_usr_all_sz.eof do
      begin
         if pos(lowercase(edtUser.text),
            lowercase(dm_mainform.my_q_usr_all_sz.fieldbyname('usr_name').AsString)) > 0
         then
         begin
            with lv_UsrGrp.Items.Add do
            begin
               Caption := dm_mainform.my_q_Usr_all_sz.FieldByName('usr_name').AsString;
               ImageIndex := 3;
            end;
         end;
         dm_mainform.my_q_usr_all_sz.next;
      end;
   end
   else
   begin
      dm_mainform.my_q_grp_all_sz.first;
      while not dm_mainform.my_q_grp_all_sz.eof do
      begin
         with lv_UsrGrp.Items.Add do
         begin
            Caption := dm_mainform.my_q_grp_all_sz.FieldByName('grp_name').AsString;
            ImageIndex := 2;
         end;
         dm_mainform.my_q_grp_all_sz.next;
      end;
      dm_mainform.my_q_usr_all_sz.first;
      while not dm_mainform.my_q_usr_all_sz.eof do
      begin
         with lv_UsrGrp.Items.Add do
         begin
            Caption := dm_mainform.my_q_Usr_all_sz.FieldByName('usr_name').AsString;
            ImageIndex := 3;
         end;
         dm_mainform.my_q_usr_all_sz.next;
      end;
   end;
end;

procedure Tfrm_Statusrights.checkexistency;
begin
   try
      if not DbTableExist('stsxs_' + GArcTblName) then
      begin
         DbX('CREATE TABLE `' + 'stsxs_' + GArcTblName + '` (' +
            '`stsxs_id` bigint(20) unsigned NOT NULL auto_increment  PRIMARY KEY,' +
            '`sts_id` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            '`usr_id` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            '`grp_id` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 +
            ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
            'COMMENT=' + #39 + 'Rechte fr Dokumentstatussetzen eines Archives' + #39);
      end;
        {
        readrights;
        readgroupsuser;}
   except
      on e: exception do
         ErrorMsg('sbtn_ArcRRemMemClick', _('Fehler beim Entfernen einer Gruppe aus einem Archiv:')+' ' + e.Message, 2019, True);
   end;
end;

procedure Tfrm_Statusrights.FormCreate(Sender: TObject);
begin
   TranslateComponent(self);
end;

procedure Tfrm_Statusrights.btn_ReadOnlyClick(Sender: TObject);
begin
   checkexistency;
   readrights;
   readgroupsuser;
   btn_tablestatusClick(SENDER);
end;

end.
