program CountPages;

{$APPTYPE CONSOLE}

uses

  SysUtils,
  imageenproc,
  ImageEnView,
  Classes,
  hyieUtils,
  hyiedefs,
  ImageEnIO,
  strutils,
  Windows;

{$R *.res}

var img: TImageEnView;
    //slFilterList: TStrings;
    //iFlt, iPos, iPage: Integer;
    //sCmd, sPrm: String;
  
function GetVersionInfo: string;
var
  VerInfoSize: DWord;
  VerInfo: Pointer;
  VerValueSize: DWord;
  VerValue: PVSFixedFileInfo;
  Dummy: DWord;
begin
  VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
  GetMem(VerInfo, VerInfoSize);
  GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
  VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
  with VerValue^ do
  begin
    result := IntTostr(dwFileVersionMS shr 16);
    result := result + '.' + IntTostr(dwFileVersionMS and $FFFF);
    result := result + '.' + IntTostr(dwFileVersionLS shr 16);
    result := result + '.' + IntTostr(dwFileVersionLS and $FFFF);
  end;
  FreeMem(VerInfo, VerInfoSize);
end;


begin
  { TODO -oUser -cConsole Main : Hier Code einfgen }
    ExitCode := 0;
  //slFilterList := TStringList.Create;
  WriteLn('bitfarm Archiv CountPages Version: '+ GetVersionInfo);
  WriteLn('(c) 2007 by bitfarm Informationssysteme GmbH, Siegen');   
  img := TImageEnView.Create(nil);
  img.IO.AsyncMode := False;
  img.IO.AutoAdjustDPI := True;
   try
      WriteLn('Ermittel die Anzahl der Seiten der Bilddatei...');
      if FileExists(ParamStr(1)) then
        img.IO.ParamsFromFile(ParamStr(1))
      else
        ExitCode := 1;

      begin
        WriteLn('Anzahl Seiten:' + IntToStr(img.IO.Params.TIFF_ImageCount) );
      end

   except
      on e: exception do
      begin
        ExitCode := 255;
        WriteLn('Allgemeiner Anwendungsfehler: ' + e.Message);
      end;
   end;

   if assigned(img) then freeandnil(img);


end.
