unit u_Optionen;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, ComCtrls, TBXDkPanels, JvExComCtrls, JvComCtrls, TB2Dock,
   TB2ToolWindow, TBX, TB2Item, TB2Toolbar, StdCtrls, JvExStdCtrls,
   JvCombobox, JvListComb, Mask, JvExMask, JvSpin, JvEdit, JvValidateEdit,
   imageenio, Registry, IniFiles, JvCheckBox, JvExControls, JvComponent,
   JvImageSquare, JvLabel, printers, gnugettext,
   u_ShLowUtils, u_ShHighUtils, u_ShBase, ExtCtrls;

type
   Tfrm_Optionen = class (TForm)
      twnd_Optionen: TTBXToolWindow;
      tpnl_OptBackground: TTBXAlignmentPanel;
      tpnl_OptButtons: TTBXAlignmentPanel;
      jpctrl_Optionen: TJvPageControl;
    tbtn_Uebernehmen: TTBXButton;
    tbtn_Abbrechen: TTBXButton;
    tbtn_Speichern: TTBXButton;
      tbs_StdOpt: TTabSheet;
      tbs_ScanOpt: TTabSheet;
      jcbx_Profiles: TJvImageComboBox;
      tlb_Tools: TTBXToolbar;
      tbi_TDelProfile: TTBXItem;
      tbi_TNewGProfile: TTBXItem;
      tbi_TNewUProfile: TTBXItem;
      tbsep_T1: TTBXSeparatorItem;
      tbi_TSaveProfile: TTBXItem;
      tbsep_T2: TTBXSeparatorItem;
      tbi_TImpProfiles: TTBXItem;
      tbi_TExpProfiles: TTBXItem;
      tlbl_ScanProfile: TTBXLabel;
      jcbx_Scanner: TJvImageComboBox;
      jrbtn_ScanByID: TTBXRadioButton;
      jrbtn_ScanByName: TTBXRadioButton;
      tlbl_Scanner: TTBXLabel;
      tlbl_ScanType: TTBXLabel;
      jcbx_Erfassung: TJvImageComboBox;
      jcbx_BitDepth: TJvImageComboBox;
      tlbl_Erfassung: TTBXLabel;
      tlbl_Farbtiefe: TTBXLabel;
      jcbx_XDPI: TJvImageComboBox;
      jcbx_YDPI: TJvImageComboBox;
      tlbl_DPIX: TTBXLabel;
      tlbl_DPIY: TTBXLabel;
      jchbx_Proportional: TTBXCheckBox;
      tlbl_BigX: TTBXLabel;
      tlbl_Papier: TTBXLabel;
      jedt_Bright: TJvSpinEdit;
      jedt_Contr: TJvSpinEdit;
      jedt_Thres: TJvSpinEdit;
      tlbl_Helligkeit: TTBXLabel;
      tlbl_Kontrast: TTBXLabel;
      tlbl_Schwellert: TTBXLabel;
      jcbx_Transfer: TJvImageComboBox;
      tlbl_Transfer: TTBXLabel;
      jcbx_Papierausricht: TJvImageComboBox;
      jedt_Rotate: TJvSpinEdit;
      tlbl_Rotation: TTBXLabel;
      tlbl_Ausrichtung: TTBXLabel;
      jrbtn_UseADF: TTBXCheckBox;
      jrbtn_UseDuplex: TTBXCheckBox;
      jrbtn_StapelScan: TTBXCheckBox;
      jcbx_Kompression: TJvImageComboBox;
      tlbl_Kompression: TTBXLabel;
      tlbl_Optionen: TTBXLabel;
      tlbl_ScanPropInfo: TTBXLabel;
      tlbl_ProNotSaved: TTBXLabel;
      tlbl_StdScanProf: TTBXLabel;
      tlbl_StdLgr: TTBXLabel;
      tlbl_StdArc: TTBXLabel;
      jcbx_StdScanProfile: TJvComboBox;
      jcbx_StdLgr: TJvComboBox;
      jcbx_StdArc: TJvComboBox;
      jchk_UseStdLgrArc: TJvCheckBox;
      jcbx_Skin: TJvComboBox;
      tlbl_Skin: TTBXLabel;
      jcbx_PapierFormat: TJvComboBox;
      JvImageSquare1: TJvImageSquare; // Blindfarbe zur Filterung auswhlen
      chbx_CloseOnArc: TCheckBox;
      jlbl_Filter: TJvLabel;
      cbx_Printers: TJvComboBox;
      TBXLabel1: TTBXLabel;
      cbx_pnachArc: TCheckBox;
      chbx_UseStdPrn: TCheckBox;
      Label1: TLabel;
      jrbtn_UseInvers: TTBXCheckBox;
      jrbtn_FiltLeer: TTBXCheckBox;
      chbx_inspageontop: TCheckBox;
      JvSE_leerkb: TJvSpinEdit;
      TBXLabel2: TTBXLabel;
      jvspndt_filterthreshold: TJvSpinEdit;
      jvspndt_filterbackground: TJvSpinEdit;
      grpbx_filter: TGroupBox;
      jcbx_Filter: TJvComboBox;
      jvlbl_filterbackground: TJvLabel;
      jvlbl_filterschwellwert: TJvLabel;
      tbxlb_pixelflavor: TTBXLabel;
      jcbx_pixelflavor: TJvComboBox;
      chb_zusatzreset: TCheckBox;
      cbx_showdoc: TCheckBox;
      cbx_cpclipbrdgdocid: TCheckBox;
      cbx_recalccompression: TCheckBox;
      cbx_outlookole: TCheckBox;
      cbx_noocr: TCheckBox;
      cbx_fastpath: TCheckBox;
      cbx_noautologin: TCheckBox;
      cbx_pflichtfeld: TCheckBox;
    Panel1: TPanel;
    jchbx_Ausschnitt: TTBXCheckBox;
    jedt_CutLeft: TJvValidateEdit;
    jedt_CutRight: TJvValidateEdit;
    jedt_CutTop: TJvValidateEdit;
    jedt_CutBottom: TJvValidateEdit;
    tlbl_Links: TTBXLabel;
    tlbl_Rechts: TTBXLabel;
    tlbl_Oben: TTBXLabel;
    tlbl_Unten: TTBXLabel;
    chk_Tooltip: TCheckBox;
    chk_Uncompressed: TCheckBox;
    lbl_Filter: TLabel;
    edt_Filter: TEdit;
    cbx_IgnoreTwainError: TTBXCheckBox;
      procedure jcbx_ScannerChange(Sender: TObject);
      procedure jchbx_AusschnittChange(Sender: TObject);
      procedure tbs_ScanOptShow(Sender: TObject);
      procedure tbi_TNewGProfileClick(Sender: TObject);
      procedure tbi_TNewUProfileClick(Sender: TObject);
      procedure tbi_TDelProfileClick(Sender: TObject);
      procedure tbi_TSaveProfileClick(Sender: TObject);
      procedure jcbx_ProfilesChange(Sender: TObject);
      procedure jcbx_XDPIChange(Sender: TObject);
      procedure jcbx_YDPIChange(Sender: TObject);
      procedure jrbtn_ScanByIDChange(Sender: TObject);
      procedure jrbtn_ScanByNameChange(Sender: TObject);
      procedure jcbx_ErfassungChange(Sender: TObject);
      procedure jcbx_BitDepthChange(Sender: TObject);
      procedure jchbx_ProportionalChange(Sender: TObject);
      procedure jcbx_TransferChange(Sender: TObject);
      procedure jcbx_PapierformatChange(Sender: TObject);
      procedure jedt_BrightChange(Sender: TObject);
      procedure jedt_ContrChange(Sender: TObject);
      procedure jedt_ThresChange(Sender: TObject);
      procedure jedt_RotateChange(Sender: TObject);
      procedure jcbx_PapierausrichtChange(Sender: TObject);
      procedure jedt_CutLeftChange(Sender: TObject);
      procedure jedt_CutTopChange(Sender: TObject);
      procedure jedt_CutRightChange(Sender: TObject);
      procedure jedt_CutBottomChange(Sender: TObject);
      procedure jrbtn_UseADFChange(Sender: TObject);
      procedure jrbtn_UseDuplexChange(Sender: TObject);
      procedure jrbtn_StapelScanChange(Sender: TObject);
      procedure jcbx_KompressionChange(Sender: TObject);
      procedure tbtn_SpeichernClick(Sender: TObject);
      procedure tbtn_AbbrechenClick(Sender: TObject);
      procedure tbtn_UebernehmenClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure tbi_TExpProfilesClick(Sender: TObject);
      procedure tbi_TImpProfilesClick(Sender: TObject);
      procedure tbs_StdOptShow(Sender: TObject);
      procedure jcbx_StdLgrChange(Sender: TObject);
      procedure jcbx_StdArcChange(Sender: TObject);
      procedure jchk_UseStdLgrArcClick(Sender: TObject);
      procedure jcbx_SkinChange(Sender: TObject);
      procedure jcbx_FilterChange(Sender: TObject);
      procedure rb_blindfarbe_einClick(Sender: TObject);
      procedure rb_blindfarbe_ausClick(Sender: TObject);
      procedure chbx_UseStdPrnClick(Sender: TObject);

      procedure cbx_PrintersChange(Sender: TObject);
      procedure cbx_pnachArcClick(Sender: TObject);
      procedure jcbx_ErfassungSelect(Sender: TObject);
      procedure jcbx_FilterSelect(Sender: TObject);
      procedure FormCreate(Sender: TObject);
    procedure cbx_showdocClick(Sender: TObject);
    procedure cbx_IgnoreTwainErrorChange(Sender: TObject);
    procedure edt_FilterChange(Sender: TObject);
    procedure cbx_fastpathClick(Sender: TObject); private
      { Private-Deklarationen }
      function GetAvailScanners: boolean;
      function GetAllProfiles: boolean;
      function CreNewProfile(CreGlobalProfile: boolean): boolean;
      function DelCurProfile: boolean;
      function SavCurProfile: boolean;
      function LoaCurProfile: boolean;
      function ExpProfiles(FileName: String): boolean;
      function ImpProfiles(FileName: String): boolean;
      function SaveOpt: boolean;
      function LoadOpt: boolean;
      procedure ProfileControls(Active: boolean);
      procedure ChkProChange;
      procedure GetSkins;
   public
      { Public-Deklarationen }
   end;

var
   frm_Optionen: Tfrm_Optionen;

implementation

{$R *.dfm}
uses u_Main, u_dm_Main, u_dm_TBX;

procedure Tfrm_Optionen.ChkProChange;
begin
   if tlbl_ProNotSaved.Visible then
   begin
      if BfMessageDlg(_('Achtung! Sie haben Einstellungen an einem Profil gendert.\nMchten Sie diese nun auch speichern?'), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
         SavCurProfile;
   end;
end;

procedure Tfrm_Optionen.GetSkins;
var iCount: Integer;
begin
   jcbx_Skin.Items.Clear;
   for iCount := 0 to (dm_TBX.tbx_Switch.ThemeCount - 1) do
      jcbx_Skin.Items.Add(dm_TBX.tbx_Switch.Themes[iCount]);
   jcbx_Skin.ItemIndex := 0;
end;

function Tfrm_Optionen.ExpProfiles(FileName: String): boolean;
var reg: TRegistry;
   ini: TIniFile;
   iCount, iType: Integer;
   slProfile: TStringList;
   sSection: String;
begin
   result := True;
   reg := TRegistry.Create;
   ini := TIniFile.Create(FileName);
   slProfile := TSTringList.Create;
   ini.WriteString('Version', 'Version', '3.2.0.0');
   try
      try
         with reg do
         begin
            for iType := 0 to 1 do
            begin
               // Exportiere User-Profile...
               case iType of
                  0:
                     RootKey := HKEY_CURRENT_USER;
                  1:
                     RootKey := HKEY_LOCAL_MACHINE;
               end;
               OpenKey('Software\bitfarm\Archiv_V3\scan\profiles', True);
               reg.GetKeyNames(slProfile);
               CloseKey;
               case iType of
                  0:
                     ini.WriteInteger('Version', 'UserCount', slProfile.Count);
                  1:
                     ini.WriteInteger('Version', 'GlobalCount', slProfile.Count);
               end;
               for iCount := 0 to (slProfile.Count - 1) do
               begin
                  OpenKey('Software\bitfarm\Archiv_V3\scan\profiles\' + slProfile.Strings[iCount], True);
                  case iType of
                     0:
                        sSection := 'UProfile' + IntToStr(iCount);
                     1:
                        sSection := 'GProfile' + IntToStr(iCount);
                  end;
                  ini.WriteString(sSection, 'Name', slProfile.Strings[iCount]);
                  ini.WriteInteger(sSection, 'BitDepth', ReadInteger('BitDepth'));
                  ini.WriteFloat(sSection, 'BrightCur', ReadFloat('BrightCur'));
                  ini.WriteFloat(sSection, 'BrightMax', ReadFloat('BrightMax'));
                  ini.WriteFloat(sSection, 'BrightMin', ReadFloat('BrightMin'));
                  ini.WriteInteger(sSection, 'ColorMode', ReadInteger('ColorMode'));
                  ini.WriteInteger(sSection, 'Compression', ReadInteger('Compression'));
                  ini.WriteFloat(sSection, 'ContrastCur', ReadFloat('ContrastCur'));
                  if jcbx_Filter.enabled and ValueExists('Filter') then
                     ini.WriteInteger(sSection, 'Filter', ReadInteger('Filter'));
                  if jvspndt_filterthreshold.enabled and ValueExists('FilterThreshold') then
                     ini.WriteFloat(sSection, 'FilterThreshold', ReadFloat('FilterThreshold'));
                  if jvspndt_filterbackground.enabled and ValueExists('FilterBackground') then
                     ini.WriteFloat(sSection, 'FilterBackground', ReadFloat('FilterBackground'));
                  ini.WriteFloat(sSection, 'ContrastMax', ReadFloat('ContrastMax'));
                  ini.WriteFloat(sSection, 'ContrastMin', ReadFloat('ContrastMin'));
                  ini.WriteFloat(sSection, 'Cut_Top', ReadFloat('Cut_Top'));
                  ini.WriteFloat(sSection, 'Cut_Left', ReadFloat('Cut_Left'));
                  ini.WriteFloat(sSection, 'Cut_Right', ReadFloat('Cut_Right'));
                  ini.WriteFloat(sSection, 'Cut_Bottom', ReadFloat('Cut_Bottom'));
                  ini.WriteBool(sSection, 'Cutted', ReadBool('Cutted'));
                  ini.WriteInteger(sSection, 'DPIX', ReadInteger('DPIX'));
                  ini.WriteInteger(sSection, 'DPIY', ReadInteger('DPIY'));
                  ini.WriteBool(sSection, 'Opt_ADF', ReadBool('Opt_ADF'));

                  if valueexists('PixelFlavor') then
                  begin
                     ini.WriteInteger(sSection, 'PixelFlavor', ReadInteger('PixelFlavor'));
                  end;
                  ini.WriteBool(sSection, 'Opt_Duplex', ReadBool('Opt_Duplex'));
                  ini.WriteBool(sSection, 'Opt_Stacked', ReadBool('Opt_Stacked'));
                  ini.WriteInteger(sSection, 'PaperFormat', ReadInteger('PaperFormat'));
                  ini.WriteInteger(sSection, 'PaperType', ReadInteger('PaperType'));
                  ini.WriteBool(sSection, 'Proportional', ReadBool('Proportional'));
                  ini.WriteFloat(sSection, 'Rotation', ReadFloat('Rotation'));
                  ini.WriteBool(sSection, 'ScanByID', ReadBool('ScanByID'));
                  ini.WriteBool(sSection, 'ScanByName', ReadBool('ScanByName'));
                  ini.WriteInteger(sSection, 'ScanID', ReadInteger('ScanID'));
                  ini.WriteString(sSection, 'ScanName', ReadString('ScanName'));
                  ini.WriteFloat(sSection, 'ThresholdCur', ReadFloat('ThresholdCur'));
                  ini.WriteFloat(sSection, 'ThresholdMax', ReadFloat('ThresholdMax'));
                  ini.WriteFloat(sSection, 'ThresholdMin', ReadFloat('ThresholdMin'));
                  ini.WriteInteger(sSection, 'Transfer', ReadInteger('Transfer'));
                  CloseKey;
               end;
            end;
         end;
      except
         on e: exception do
         begin
            result := False;
            ShowMessage(_('Fehler beim Exportieren der Profile:') + ' ' + e.Message);
         end;
      end;
   finally
      if Assigned(ini) then
         FreeAndNil(ini);
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(slProfile) then
         FreeAndNil(slProfile);
   end;
end;

function Tfrm_Optionen.ImpProfiles(FileName: String): boolean;
var reg: TRegistry;
   ini: TIniFile;
   iCount, iType, iProCount: Integer;
   sSection: String;
begin
   result := True;
   reg := TRegistry.Create;
   ini := TIniFile.Create(FileName);
   iProCount := 0;
   try
      try
         with ini do
         begin
            if Copy(ReadString('Version', 'Version', ''), 1, 3) <> '3.2' then
            begin
               result := False;
               exit;
            end;
            for iType := 0 to 1 do
            begin
               case iType of
                  0:
                  begin
                     reg.RootKey := HKEY_CURRENT_USER;
                     iProCount := ReadInteger('Version', 'UserCount', 0);
                  end;
                  1:
                  begin
                     reg.RootKey := HKEY_LOCAL_MACHINE;
                     iProCount := ReadInteger('Version', 'GlobalCount', 0);
                  end;
               end;
               for iCount := 0 to (iProCount - 1) do
               begin
                  case iType of
                     0:
                        sSection := 'UProfile' + IntToStr(iCount);
                     1:
                        sSection := 'GProfile' + IntToStr(iCount);
                  end;
                  reg.OpenKey('Software\bitfarm\Archiv_V3\scan\profiles\' + ReadString(sSection, 'Name', sSection), True);
                  reg.WriteInteger('BitDepth', ReadInteger(sSection, 'BitDepth', 0));
                  reg.WriteFloat('BrightCur', ReadFloat(sSection, 'BrightCur', 0));
                  reg.WriteFloat('BrightMax', ReadFloat(sSection, 'BrightMax', 0));
                  reg.WriteFloat('BrightMin', ReadFloat(sSection, 'BrightMin', 0));
                  reg.WriteInteger('ColorMode', ReadInteger(sSection, 'ColorMode', 0));
                  reg.WriteInteger('Compression', ReadInteger(sSection, 'Compression', 0));
                  reg.WriteFloat('ContrastCur', ReadFloat(sSection, 'ContrastCur', 0));
                  if jcbx_Filter.enabled then
                     reg.WriteInteger('Filter', ReadInteger(sSection, 'Filter', 0));
                  if jvspndt_FilterThreshold.enabled then
                     reg.WriteFloat('FilterThreshold', ReadFloat(sSection, 'FilterThreshold', 0));
                  if jvspndt_FilterBackground.enabled then
                     reg.WriteFloat('FilterBackground', ReadFloat(sSection, 'FilterBackground', 0));
                  reg.WriteFloat('ContrastMax', ReadFloat(sSection, 'ContrastMax', 0));
                  reg.WriteFloat('ContrastMin', ReadFloat(sSection, 'ContrastMin', 0));
                  reg.WriteFloat('Cut_Top', ReadFloat(sSection, 'Cut_Top', 0));
                  reg.WriteFloat('Cut_Left', ReadFloat(sSection, 'Cut_Left', 0));
                  reg.WriteFloat('Cut_Right', ReadFloat(sSection, 'Cut_Right', 0));
                  reg.WriteFloat('Cut_Bottom', ReadFloat(sSection, 'Cut_Bottom', 0));
                  reg.WriteBool('Cutted', ReadBool(sSection, 'Cutted', False));
                  reg.WriteInteger('DPIX', ReadInteger(sSection, 'DPIX', 5));
                  reg.WriteInteger('DPIY', ReadInteger(sSection, 'DPIY', 5));
                  reg.WriteBool('Opt_ADF', ReadBool(sSection, 'Opt_ADF', false));
                  reg.WriteBool('Opt_Duplex', ReadBool(sSection, 'Opt_Duplex', false));
                  reg.WriteBool('Opt_Stacked', ReadBool(sSection, 'Opt_Stacked', false));
                  reg.WriteInteger('PaperFormat', ReadInteger(sSection, 'PaperFormat', 0));
                  reg.WriteInteger('PaperType', ReadInteger(sSection, 'PaperType', 0));
                  reg.WriteBool('Proportional', ReadBool(sSection, 'Proportional', True));
                  reg.WriteFloat('Rotation', ReadFloat(sSection, 'Rotation', 0));
                  reg.WriteBool('ScanByID', ReadBool(sSection, 'ScanByID', True));
                  reg.WriteBool('ScanByName', ReadBool(sSection, 'ScanByName', False));
                  reg.WriteInteger('ScanID', ReadInteger(sSection, 'ScanID', 0));
                  reg.WriteString('ScanName', ReadString(sSection, 'ScanName', ''));
                  reg.WriteFloat('ThresholdCur', ReadFloat(sSection, 'ThresholdCur', 0));
                  reg.WriteFloat('ThresholdMax', ReadFloat(sSection, 'ThresholdMax', 0));
                  reg.WriteFloat('ThresholdMin', ReadFloat(sSection, 'ThresholdMin', 0));
                  reg.WriteInteger('Transfer', ReadInteger(sSection, 'Transfer', 0));


                  reg.WriteInteger('PixelFlavor', ReadInteger(sSection, 'PixelFlavor', 0));
                  reg.CloseKey;
               end;
            end;
         end;
      except
         on e: exception do
         begin
            result := False;
            ShowMessage(_('Fehler beim Importieren der Profile:') + ' ' + e.Message);
         end;
      end;
   finally
      if Assigned(ini) then
         FreeAndNil(ini);
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_Optionen.CreNewProfile(CreGlobalProfile: boolean): boolean;
var sProfileName, sDefaultName: String;
   iCount: Integer;
   reg: TRegistry;
   addItem: TJvImageItem;
begin
   reg := TRegistry.Create;
   result := False;
   iCount := jcbx_Profiles.Items.Count + 1;
   if CreGlobalProfile then
      sDefaultName := _('Neues_Globales_Profil_') else sDefaultName := _('Neues_Benutzer_Profil_');
   sDefaultName := sDefaultName + IntToStr(iCount);
   sProfileName := BfInputBox(_('Bitte geben Sie einen Namen fr das neue Scan-Profil ein:'),_('Neues Scan-Profil anlegen...'),sDefaultName);
   //if InputQuery(_('Neues Scan-Profil anlegen...'), _('Bitte geben Sie einen Namen fr das neue Scan-Profil ein:'), sProfileName) then
   if sProfileName <> '' then
   begin
      try
         try
            with reg do
            begin
               if CreGlobalProfile then
                  RootKey := HKEY_LOCAL_MACHINE else RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\scan\profiles', True);
               if KeyExists(sProfileName) then
               begin
                  BfShowMessage(_('Es existiert bereits ein Profil mit dieser Bezeichnung.\n' +
                     'Bitte geben Sie eine andere Profilbezeichnung ein.'));
                  exit;
               end;
               addItem := jcbx_Profiles.Items.Add;
               addItem.Text := sProfileName;
               if CreGlobalProfile then
               begin
                  addItem.ImageIndex := 15;
                  addItem.LinkedObject := TObject(0);
               end
               else
               begin
                  addItem.ImageIndex := 16;
                  addItem.LinkedObject := TObject(1);
               end;
               jcbx_Profiles.ItemIndex := addItem.Index;
               ProfileControls(False);
               tlbl_ProNotSaved.Visible := True;
               result := True;
				// v3.5.0.26
               // Maske noch auf Standardwerte zurcksetzen
               jcbx_Scanner.ItemIndex:=-1;
               jcbx_Erfassung.ItemIndex:=0;
               jcbx_ErfassungChange(Self);
               jcbx_XDPI.ItemIndex:=5;
               jcbx_YDPI.ItemIndex:=5;
               jchbx_Proportional.Checked:=True;
               jcbx_Transfer.ItemIndex:=2;
               jcbx_PapierFormat.ItemIndex:=1;

               jedt_Bright.Value:=0;
               jedt_Contr.Value:=0;
               jedt_Thres.Value:=0;
               jedt_Rotate.Value:=0;

               jchbx_Ausschnitt.Checked:=False;
               jedt_CutLeft.Value:=0;
               jedt_CutRight.Value:=0;
               jedt_CutTop.Value:=0;
               jedt_CutBottom.Value:=0;
               jcbx_Papierausricht.ItemIndex:=0;

               jcbx_pixelflavor.ItemIndex:=0;
               jrbtn_UseADF.Checked:=False;
               jrbtn_UseDuplex.Checked:=False;
               jrbtn_ScanByID.Checked:=True;
               jrbtn_ScanByName.Checked:=False;
               jrbtn_UseDuplex.Checked:=False;
               jrbtn_StapelScan.Checked:=False;
               jrbtn_UseInvers.Checked:=False;
               jrbtn_FiltLeer.Checked:=False;
               JvSE_leerkb.Value:=0;
               cbx_IgnoreTwainError.Checked := True;
            end;
         except
            on e: Exception do
            begin
               ShowMessage(_('Fehler beim Erstellen eines Scan-Profiles:') +' ' + e.Message);
               exit;
            end;
         end;
      finally
         reg.CloseKey;
         if Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;

procedure Tfrm_Optionen.ProfileControls(Active: boolean);
begin
   tbi_TNewGProfile.Enabled := Active;
   tbi_TNewUProfile.Enabled := Active;
   tbi_TExpProfiles.Enabled := Active;
   tbi_TImpProfiles.Enabled := Active;
   jcbx_Profiles.Enabled := Active;
end;

function Tfrm_Optionen.DelCurProfile: boolean;
var reg: TRegistry;
begin
   result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            if jcbx_Profiles.ItemIndex < 0 then
              Exit;
            case jcbx_Profiles.Items.Items[jcbx_Profiles.ItemIndex].ImageIndex of
               15:
                  RootKey := HKEY_LOCAL_MACHINE;
               16:
                  RootKey := HKEY_CURRENT_USER;
            else
               exit;
            end;
            OpenKey('Software\bitfarm\Archiv_V3\scan\profiles', True);
            DeleteKey(jcbx_Profiles.Text);
            CloseKey;
         end;
      except
         on e: exception do
         begin
            ShowMessage(_('Fehler beim Entfernen eines Profils:') + ' ' + e.Message);
            result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_Optionen.SavCurProfile: boolean;
var reg: TRegistry;

   //    iCount: Integer;
begin
   result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\ManuScan3.1\Optionen', True);
            WriteBool('pnachArc', cbx_pnachArc.Checked);
            WriteString('ManuPrinter', label1.caption);
            closekey;
         end;


         with reg do
         begin
            if jcbx_Profiles.ItemIndex < 0 then
              Exit;
            case jcbx_Profiles.Items.Items[jcbx_Profiles.ItemIndex].ImageIndex of
               15:
                  RootKey := HKEY_LOCAL_MACHINE;
               16:
                  RootKey := HKEY_CURRENT_USER;
            else
               exit;
            end;
            OpenKey('Software\bitfarm\Archiv_V3\scan\profiles\' + jcbx_Profiles.Text, True);
            WriteInteger('ScanID', jcbx_Scanner.ItemIndex);
            WriteString('ScanName', jcbx_Scanner.Text);
            WriteBool('ScanByID', jrbtn_ScanByID.Checked);
            WriteBool('ScanByName', jrbtn_ScanByName.Checked);
            if jcbx_Erfassung.ItemIndex = 0 then
            begin
               WriteInteger('ColorMode', 0);
               WriteInteger('BitDepth', 0);
            end
            else if jcbx_Erfassung.ItemIndex = 1 then
            begin
               WriteInteger('ColorMode', 1);
               WriteInteger('BitDepth', 1);
            end
            else if jcbx_Erfassung.ItemIndex = 2 then
            begin
               WriteInteger('ColorMode', 1);
               WriteInteger('BitDepth', 2);
            end
            else
            if jcbx_Erfassung.ItemIndex = 3 then
            begin
               WriteInteger('ColorMode', 2);
               WriteInteger('BitDepth', 2);
            end;

            WriteInteger('DPIX', jcbx_XDPI.ItemIndex);
            WriteInteger('DPIY', jcbx_YDPI.ItemIndex);
            WriteInteger('PixelFlavor', jcbx_pixelflavor.ItemIndex);

            WriteBool('Proportional', jchbx_Proportional.Checked);
            WriteInteger('Transfer', jcbx_Transfer.ItemIndex);
            WriteInteger('PaperType', jcbx_Papierformat.ItemIndex);
            WriteFloat('BrightMin', jedt_Bright.MinValue);
            WriteFloat('BrightCur', jedt_Bright.Value);
            WriteFloat('BrightMax', jedt_Bright.MaxValue);
            WriteFloat('ContrastMin', jedt_Contr.MinValue);
            WriteFloat('ContrastCur', jedt_Contr.Value);
            if jcbx_Filter.enabled then
               WriteInteger('Filter', jcbx_Filter.ItemIndex);
            if jvspndt_FilterThreshold.enabled then
               WriteFloat('FilterThreshold', jvspndt_filterthreshold.Value);
            if jvspndt_FilterBackground.enabled then
               WriteFloat('FilterBackground', jvspndt_filterbackground.Value);
            WriteFloat('ContrastMax', jedt_Contr.MaxValue);
            WriteFloat('ThresholdMin', jedt_Thres.MinValue);
            WriteFloat('ThresholdCur', jedt_Thres.Value);
            WriteFloat('ThresholdMax', jedt_Thres.MaxValue);
            WriteFloat('Rotation', jedt_Rotate.Value);
            WriteInteger('PaperFormat', jcbx_Papierausricht.ItemIndex);
            WriteBool('Cutted', jchbx_Ausschnitt.Checked);
			// v3.5.0.26
            WriteFloat('Cut_Top', jedt_CutTop.Value * Zoll);
            WriteFloat('Cut_Left', jedt_CutLeft.Value * Zoll);
            WriteFloat('Cut_Right', jedt_CutRight.Value * Zoll);
            WriteFloat('Cut_Bottom', jedt_CutBottom.Value * Zoll);
            WriteBool('Opt_ADF', jrbtn_UseAdf.Checked);
            WriteBool('Opt_Duplex', jrbtn_UseDuplex.Checked);
            WriteBool('Opt_Stacked', jrbtn_StapelScan.Checked);
            //WriteInteger('Compression', jcbx_Kompression.ItemIndex);
            WriteBool('Opt_UseInvers', jrbtn_UseInvers.Checked);
            WriteBool('Opt_FiltLeer', jrbtn_FiltLeer.Checked);
            WriteBool('IgnoreTWAINError', cbx_IgnoreTwainError.Checked);
            WriteFloat('Opt_Leerkb', JvSE_leerkb.value);
			// v3.5.0.26
            //WriteInteger('Compression', jcbx_Kompression.ItemIndex);

            if jcbx_Erfassung.ItemIndex > 0 then
            begin
              if jcbx_Kompression.text = 'JPG' then
                WriteInteger('Compression', 3)
              else
              if jcbx_Kompression.text = 'PackBits' then
                WriteInteger('Compression', 4)
              else
              if jcbx_Kompression.text = 'LZW' then
                WriteInteger('Compression', 5)
              else
                WriteInteger('Compression', 0);


              (*case  jcbx_Kompression.ItemIndex of

               0:  //JPEG
                WriteInteger('Compression', 3);
               1:  //PackBits
                 WriteInteger('Compression', 4);
               2: //LZW
                 WriteInteger('Compression', 5);
               3: //Keine Kompression
                 WriteInteger('Compression', 0);
              else
                 WriteInteger('Compression', 0);
              end;  *)


            end
            else
            begin
               case  jcbx_Kompression.ItemIndex of
                  0:  //CCTIT 4
                   WriteInteger('Compression', 2);
                 1: //Keine Kompression
                   WriteInteger('Compression', 0);
                else
                   WriteInteger('Compression', 0);
               end;

            end;



            CloseKey;
         end;
      except
         on e: exception do
         begin
            ShowMessage(_('Fehler beim Speichern eines Profils:') + ' ' + e.Message);
            result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_Optionen.LoaCurProfile: boolean;
var reg: TRegistry;
    liCompIndex, indexoffset, colmode: Integer;
   //    iCount: Integer;
   //    AddItem: TJvImageItem;
begin
   result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            if jcbx_Profiles.ItemIndex < 0 then
              Exit;
            case jcbx_Profiles.Items.Items[jcbx_Profiles.ItemIndex].ImageIndex of
               15:
                  RootKey := HKEY_LOCAL_MACHINE;
               16:
                  RootKey := HKEY_CURRENT_USER;
            else
               exit;
            end;
            OpenKey('Software\bitfarm\Archiv_V3\scan\profiles\' + jcbx_Profiles.Text, True);
            jcbx_Scanner.ItemIndex := ReadInteger('ScanID');
            jcbx_Scanner.Text := ReadString('ScanName');
            if ReadBool('ScanByID') then
            begin
               jrbtn_ScanByID.Checked := True;
               jrbtn_ScanByName.Checked := False;
            end;
            if ReadBool('ScanByName') then
            begin
               jrbtn_ScanByID.Checked := False;
               jrbtn_ScanByName.Checked := True;
            end;
            colmode:= ReadInteger('ColorMode');
            if colmode = 0 then                       // Schwarz-weiss
	            jcbx_Erfassung.ItemIndex :=  0;
            if colmode = 1 then                       // Graustufen
            begin
            	if ReadInteger('BitDepth') = 0 then   // das kann eigentlich nicht sein, es muss 1 (4bit) oder 2 (8bit) sein
               begin                                 // das ist in versionen vor v3.5.1.13 so und wird hier korrigiert
                  jcbx_Erfassung.ItemIndex := 2;     // wir stellen auf 8bit Graustufe
                  WriteInteger('BitDepth',2);
               end;
               if ReadInteger('BitDepth') = 1 then   // 4bit
               begin
                  jcbx_Erfassung.ItemIndex := 1;
               end;
               if ReadInteger('BitDepth') = 2 then   // 8bit
               begin
                  jcbx_Erfassung.ItemIndex := 2;
               end;
            end;
            if colmode = 2 then                      // Farbe
	            jcbx_Erfassung.ItemIndex := 3;
            if jcbx_Erfassung.ItemIndex <> 3 then
            begin
               grpbx_filter.Enabled := true;
               jlbl_Filter.enabled := true;
               jcbx_Filter.enabled := true;
            end
            else
            begin
               grpbx_filter.Enabled := false;
               jlbl_Filter.enabled := false;
               jcbx_Filter.enabled := false;
            end;
            if jlbl_Filter.enabled and (jcbx_Filter.ItemIndex < 4) and (jcbx_Filter.ItemIndex > 0) then
            begin
               jvlbl_filterschwellwert.enabled := true;
               jvspndt_filterthreshold.enabled := true;
               jvlbl_filterbackground.enabled := true;
               jvspndt_filterbackground.enabled := true;
            end
            else
            begin
               jvlbl_filterschwellwert.enabled := false;
               jvspndt_filterthreshold.enabled := false;
               jvlbl_filterbackground.enabled := false;
               jvspndt_filterbackground.enabled := false;
            end;
            jcbx_BitDepth.ItemIndex := ReadInteger('BitDepth');
            jcbx_XDPI.ItemIndex := ReadInteger('DPIX');
            jcbx_YDPI.ItemIndex := ReadInteger('DPIY');
            jchbx_Proportional.Checked := ReadBool('Proportional');
            jcbx_Transfer.ItemIndex := ReadInteger('Transfer');
            jcbx_PapierFormat.ItemIndex := ReadInteger('PaperType');
            if ValueExists('BrightMin') then
               jedt_Bright.MinValue := ReadFloat('BrightMin');
            if ValueExists('BrightCur') then
               jedt_Bright.Value := ReadFloat('BrightCur');
            if ValueExists('BrightMax') then
               jedt_Bright.MaxValue := ReadFloat('BrightMax');
            if ValueExists('ContrastMin') then
               jedt_Contr.MinValue := ReadFloat('ContrastMin');
            if ValueExists('ContrastCur') then
               jedt_Contr.Value := ReadFloat('ContrastCur');
            if ValueExists('FilterThreshold') then
               jvspndt_filterthreshold.Value := ReadFloat('FilterThreshold');
            if ValueExists('FilterBackground') then
               jvspndt_filterbackground.Value := ReadFloat('FilterBackground');
            if ValueExists('ContrastMax') then
               jedt_Contr.MaxValue := ReadFloat('ContrastMax');
            jedt_Thres.MinValue := ReadFloat('ThresholdMin');
            jedt_Thres.Value := ReadFloat('ThresholdCur');
            jedt_Thres.MaxValue := ReadFloat('ThresholdMax');
            jedt_Rotate.Value := ReadFloat('Rotation');
            // Papierausrichtung auslesen...
            jcbx_PapierAusricht.ItemIndex := ReadInteger('PaperFormat');
            if ValueExists('Filter') then
            begin
               jcbx_Filter.ItemIndex := ReadInteger('Filter');
               if jcbx_Filter.enabled and (jcbx_Filter.ItemIndex < 4) and (jcbx_Filter.ItemIndex > 0) then
               begin
                  jvlbl_filterschwellwert.enabled := true;
                  jvspndt_filterthreshold.enabled := true;
                  jvlbl_filterbackground.enabled := true;
                  jvspndt_filterbackground.enabled := true;
               end
               else
               begin
                  jvlbl_filterschwellwert.enabled := false;
                  jvspndt_filterthreshold.enabled := false;
                  jvlbl_filterbackground.enabled := false;
                  jvspndt_filterbackground.enabled := false;
               end;
            end;

            if ValueExists('PixelFlavor') then
            begin

               jcbx_pixelflavor.itemindex := ReadInteger('PixelFlavor');
            end
            else
            begin
               jcbx_pixelflavor.itemindex := 0;
            end;
            jchbx_Ausschnitt.Checked := ReadBool('Cutted');
			// v3.5.0.26
            jedt_CutTop.Value := ReadFloat('Cut_Top') / Zoll;
            jedt_CutLeft.Value := ReadFloat('Cut_Left') / Zoll;
            jedt_CutRight.Value := ReadFloat('Cut_Right') / Zoll;
            jedt_CutBottom.Value := ReadFloat('Cut_Bottom') / Zoll;
            jrbtn_UseAdf.Checked := ReadBool('Opt_ADF');
            jrbtn_UseDuplex.Checked := ReadBool('Opt_Duplex');
            jrbtn_StapelScan.Checked := ReadBool('Opt_Stacked');
            if ValueExists('Opt_UseInvers') then
               jrbtn_UseInvers.Checked := ReadBool('Opt_UseInvers');
            if ValueExists('Opt_FiltLeer') then
               jrbtn_FiltLeer.Checked := ReadBool('Opt_FiltLeer');
            if ValueExists('Opt_Leerkb') then
               JvSE_leerkb.Value := ReadFloat('Opt_Leerkb');
            if ValueExists('IgnoreTWAINError') then
               cbx_IgnoreTwainError.Checked := ReadBool('IgnoreTWAINError')
            else
               cbx_IgnoreTwainError.Checked := True;
            liCompIndex := ReadInteger('Compression');
			// v3.5.0.26
            jcbx_ErfassungChange(self);

            if jcbx_Erfassung.ItemIndex = 0 then
            begin
              case  liCompIndex of
                 0:  // keine Kompression
                   jcbx_Kompression.ItemIndex :=1;
                 2:  // CCTIT 4
                    jcbx_Kompression.ItemIndex :=0;
              else // keine Kompression
                jcbx_Kompression.ItemIndex :=1;
              end;

            end;

            if jcbx_Erfassung.ItemIndex = 1 then
            begin
              case  liCompIndex of
                 0:  // keine Kompression
                   jcbx_Kompression.ItemIndex :=2;
                 4:  // PackBits
                    jcbx_Kompression.ItemIndex :=0;
                 5:  // LZW
                    jcbx_Kompression.ItemIndex :=1;
              else // keine Kompression
                	jcbx_Kompression.ItemIndex :=2;
              end;

            end
            else
            begin
              case  liCompIndex of
                 0:  // keine Kompression
                   jcbx_Kompression.ItemIndex :=3;
                 3:  // JPG
                    jcbx_Kompression.ItemIndex :=0;
                 4:  // PackBits
                    jcbx_Kompression.ItemIndex :=1;
                 5:  // LZW
                    jcbx_Kompression.ItemIndex :=2;
              else // keine Kompression
                	jcbx_Kompression.ItemIndex :=3;
              end;

            end;

            CloseKey;
            frm_Optionen.tlbl_ProNotSaved.Visible := false;
         end;
      except
         on e: exception do
         begin
            ShowMessage(_('Fehler beim Laden eines Profils:') + ' ' + e.Message);
            result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_Optionen.SaveOpt: Boolean;
var reg: TRegistry;
begin
   result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\ManuScan3.1\Optionen', True);
            WriteBool('pnachArc', cbx_pnachArc.Checked);
            closekey;
         end;


         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\ManuScan3.1\Optionen', True);
            if jcbx_StdScanProfile.ItemIndex <> -1 then
            begin
               WriteInteger('StdProfileType', Integer(jcbx_StdScanProfile.Items.Objects[jcbx_StdScanProfile.ItemIndex]));
               WriteString('StdProfileName', jcbx_StdScanProfile.Items.Strings[jcbx_StdScanProfile.ItemIndex]);
            end;
            if not jchk_UseStdLgrArc.Checked then
            begin
               WriteInteger('StdLgrID', Integer(jcbx_StdLgr.Items.Objects[jcbx_StdLgr.ItemIndex]));
               WriteString('StdLgr', jcbx_StdLgr.Items.Strings[jcbx_StdLgr.ItemIndex]);
               WriteInteger('StdArcID', Integer(jcbx_StdArc.Items.Objects[jcbx_StdArc.ItemIndex]));
               WriteString('StdArc', jcbx_StdArc.Items.Strings[jcbx_StdArc.ItemIndex]);
            end;
            WriteBool('UseLastLgrArc', jchk_UseStdLgrArc.Checked);
            WriteBool('CloseOnArc', chbx_CloseOnArc.Checked);
            WriteBool('Resetzusatzfields', chb_zusatzreset.Checked);
            WriteBool('ShowDocViewer', cbx_showdoc.Checked);
            WriteBool('cpclipbrdgdocid', cbx_cpclipbrdgdocid.Checked);
            WriteBool('noautologin', cbx_noautologin.Checked);
            WriteBool('inputpflicht', cbx_pflichtfeld.Checked);
            WriteBool('recalccompr', cbx_recalccompression.Checked);
            WriteBool('Oleoutlook', cbx_outlookole.checked);
            WriteBool('noocr', cbx_noocr.Checked);
            WriteBool('fastpath', cbx_fastpath.Checked);
			// v3.5.0.26
            WriteBool('tooltip', chk_Tooltip.Checked);
            WriteBool('uncompressed', chk_Uncompressed.Checked);
            WriteString('Skin', jcbx_Skin.Text);
            WriteString('JobFilter', edt_Filter.Text);
            /////////////////////////////////////////////////////////////////////
            //
            //  Druckerauswahl sichern
            if chbx_UseStdPrn.Checked then
            begin
               WriteInteger('UseStdPrn', -1)
            end
            else WriteInteger('UseStdPrn', cbx_Printers.ItemIndex);

            WriteBool('inspageontop', chbx_inspageontop.Checked);
            binspageontop := chbx_inspageontop.Checked;
         end;
      except
         on e: exception do
         begin
            ErrorMsg('SaveOpt', 'Fehler beim speichern der Optionen: ' + e.Message, 2000, True);
            result := False;
         end;
      end;
   finally
      reg.CloseKey;
   end;
end;

function Tfrm_Optionen.LoadOpt: Boolean;
var reg: TRegistry;
begin
   result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\ManuScan3.1\Optionen', True);
            If valueExists('pnachArc') then
            begin
               cbx_pnachArc.Checked := readbool('pnachArc');
               // cbx_Printers.Enabled := cbx_pnachArc.Checked;
            end;
            closekey;
         end;

         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\ManuScan3.1\Optionen', True);
            //        if ValueExists('StdProfileType') then WriteInteger('StdProfileType', Integer(jcbx_StdScanProfile.Items.Objects[jcbx_StdScanProfile.ItemIndex]));
            if ValueExists('StdProfileName') then
               jcbx_StdScanProfile.ItemIndex := jcbx_StdScanProfile.Items.IndexOf(ReadString('StdProfileName'));
            if ValueExists('UseLastLgrArc') then
            begin
               jchk_UseStdLgrArc.Checked := ReadBool('UseLastLgrArc');
               jchk_UseStdLgrArc.OnClick(self);
               if ValueExists('StdLgrID') then
               begin
                  jcbx_StdLgr.ItemIndex := jcbx_StdLgr.Items.IndexOfObject(TObject(ReadInteger('StdLgrID')));
                  jcbx_StdLgr.OnChange(self);
               end;
               if ValueExists('StdArcID') then
               begin
                  jcbx_StdArc.ItemIndex := jcbx_StdArc.Items.IndexOfObject(TObject(ReadInteger('StdArcID')));
               end;
            end;
            if ValueExists('Skin') then
            begin
               jcbx_Skin.ItemIndex := jcbx_Skin.Items.IndexOf(ReadString('Skin'));
               jcbx_Skin.OnChange(self);
            end;
            if ValueExists('CloseOnArc') then
               chbx_CloseOnArc.Checked := ReadBool('CloseOnArc');
            if ValueExists('Resetzusatzfields') then
               chb_zusatzreset.Checked := ReadBool('Resetzusatzfields');
            if ValueExists('UseStdPrn') then
               cbx_Printers.ItemIndex := ReadInteger('UseStdPrn');
            if ValueExists('inspageontop') then
               chbx_inspageontop.Checked := ReadBool('inspageontop');
            if ValueExists('ShowDocViewer') then
               cbx_showdoc.Checked := ReadBool('ShowDocViewer');
            if ValueExists('cpclipbrdgdocid') then
               cbx_cpclipbrdgdocid.Checked := ReadBool('cpclipbrdgdocid');
            if ValueExists('inputpflicht') then
               cbx_pflichtfeld.Checked := ReadBool('inputpflicht');
            if ValueExists('noautologin') then
               cbx_noautologin.Checked := ReadBool('noautologin');
            if ValueExists('recalccompr') then
               cbx_recalccompression.Checked := ReadBool('recalccompr');

            if ValueExists('Oleoutlook') then
               cbx_outlookole.Checked := ReadBool('Oleoutlook');
            if ValueExists('noocr') then
               cbx_noocr.Checked := ReadBool('noocr');
            if ValueExists('tooltip') then
               chk_Tooltip.Checked := ReadBool('tooltip');
            if ValueExists('uncompressed') then
               chk_Uncompressed.Checked := ReadBool('uncompressed');
            if ValueExists('JobFilter') then
               edt_Filter.Text := Trim(ReadString('JobFilter'));
            if edt_Filter.Text <> '' then
                cbx_fastpath.Enabled := False;
            if ValueExists('fastpath') then
               cbx_fastpath.Checked := ReadBool('fastpath');
         end;
      except
         on e: exception do
         begin
            ErrorMsg('SaveOpt', 'Fehler beim laden der Optionen: ' + e.Message, 2000, True);
            result := False;
         end;
      end;
   finally
      reg.CloseKey;
   end;
end;

function Tfrm_Optionen.GetAllProfiles: Boolean;
   //////////////////////////////////////////////////////////////////////////
   ///                                                                    ///
   /// Diese Funktion liest aus der Registry die vorhandenen Benutzer und ///
   /// Globalen Scanprofile aus und schreibt diese in eine JvComboBox auf ///
   /// dem Options Formular.                                              ///
   ///                                                                    ///
   /// Result:                                                            ///
   /// Boolscher Wert                     True bei Erfolg                 ///
   ///                                    False bei Fehlschlag            ///
   ///                                                                    ///
   //////////////////////////////////////////////////////////////////////////
var reg: TRegistry;
   iCount, iSaveIndex: Integer;
   slProfiles: TStringList;
   AddItem: TJvImageItem;
begin
   result := True;
	// v3.5.0.26
   iSaveIndex := jcbx_Profiles.ItemIndex;
   reg := TRegistry.Create;
   slProfiles := TStringList.Create;
   try
      try
         with reg do
         begin
            // Combobox leeren...
            jcbx_Profiles.Items.Clear;
            // Globale Profile auslesen...
            RootKey := HKEY_LOCAL_MACHINE;
            OpenKey('Software\bitfarm\Archiv_V3\scan\profiles', True);
            GetKeyNames(slProfiles);
            for iCount := 0 to (slProfiles.Count - 1) do
            begin
               AddItem := jcbx_Profiles.Items.Add;
               AddItem.ImageIndex := 15;
               AddItem.Text := slProfiles.Strings[iCount];
               AddItem.LinkedObject := TObject(0);
            end;
            CloseKey;
            // User Profile auslesen...
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\scan\profiles', True);
            GetKeyNames(slProfiles);
            for iCount := 0 to (slProfiles.Count - 1) do
            begin
               AddItem := jcbx_Profiles.Items.Add;
               AddItem.ImageIndex := 16;
               AddItem.Text := slProfiles.Strings[iCount];
               AddItem.LinkedObject := TObject(1);
            end;
            CloseKey;
			// v3.5.0.26
            if (iSaveIndex>=0) and (iSaveIndex < jcbx_Profiles.Items.Count)
            then
               jcbx_Profiles.ItemIndex := iSaveIndex
            else
               jcbx_Profiles.ItemIndex := 0;
         end;
      except
         on e: exception do
         begin
            result := False;
            ShowMessage(e.Message);
         end;
      end;
   finally
      FreeAndNil(reg);
      FreeAndNil(slProfiles);
   end;
end;

function Tfrm_Optionen.GetAvailScanners: Boolean;
var iCount: Integer;
   iNewScanItem: TJvImageItem;
   Scanner: TIETwainParams;
begin
   result := True;
   jcbx_Scanner.Items.Clear;
   Scanner := frm_Main.img_Pages.MIO.TWainParams; //  dm_Main.imgio_Scan.TWainParams;
   Scanner.FreeResources;
   if Scanner.SourceCount = 0 then
   begin
      result := False;
      exit;
   end;
   try
      for iCount := 0 to (Scanner.SourceCount - 1) do
      begin
         iNewScanItem := jcbx_Scanner.Items.Add;
         iNewScanItem.ImageIndex := 0;
         iNewScanItem.Text := Scanner.SourceName[iCount];
      end;
      jcbx_Scanner.ItemIndex := Scanner.GetDefaultSource;
      //    GetScannerParams(Scanner.GetDefaultSource, '');
   except
      result := False;
   end;
end;

procedure Tfrm_Optionen.jcbx_ScannerChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jchbx_AusschnittChange(Sender: TObject);
begin
   jedt_CutTop.Enabled := Jchbx_Ausschnitt.Checked;
   jedt_CutLeft.Enabled := Jchbx_Ausschnitt.Checked;
   jedt_CutRight.Enabled := Jchbx_Ausschnitt.Checked;
   jedt_CutBottom.Enabled := Jchbx_Ausschnitt.Checked;
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.tbs_ScanOptShow(Sender: TObject);
begin
   GetAllProfiles;
   if not GetAvailScanners then
      ShowMessage(_('Es wurden keine Scanner gefunden oder es trat ein Fehler bei der Abfrage der Scanner auf!'));
   tlbl_ProNotSaved.Visible := False;
   if jcbx_Profiles.Items.Count > 0 then
      LoaCurProfile;
end;

procedure Tfrm_Optionen.tbi_TNewGProfileClick(Sender: TObject);
begin
   if (GsWindowsVersion = '6.0') or (GsWindowsVersion = '6.1') or (GsWindowsVersion = '6.2') then
   begin
     if not IsUserAdmin then
     begin
			BfShowMessage(_('Hinweis: Um ein globales Profil anzulegen muss ManuscanV3\nals Administrator ausgefhrt werden.'));
         Exit;
     end;

   end;

   CreNewProfile(True);
end;

procedure Tfrm_Optionen.tbi_TNewUProfileClick(Sender: TObject);
begin
   CreNewProfile(False);
end;

procedure Tfrm_Optionen.tbi_TDelProfileClick(Sender: TObject);
begin
   if not tlbl_ProNotSaved.Visible then
      DelCurProfile
   else tlbl_ProNotSaved.Visible := False;
   ProfileControls(True);
   GetAllProfiles;
end;

procedure Tfrm_Optionen.jcbx_ProfilesChange(Sender: TObject);
begin
   LoaCurProfile;
   tlbl_ProNotSaved.Visible := False;
end;

procedure Tfrm_Optionen.jcbx_XDPIChange(Sender: TObject);
begin
   if jchbx_Proportional.Checked then
      jcbx_YDPI.ItemIndex := jcbx_XDPI.ItemIndex;
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jcbx_YDPIChange(Sender: TObject);
begin
   if jchbx_Proportional.Checked then
      jcbx_XDPI.ItemIndex := jcbx_YDPI.ItemIndex;
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jrbtn_ScanByIDChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jrbtn_ScanByNameChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jcbx_ErfassungChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
	// v3.5.0.26
   if  jcbx_Erfassung.ItemIndex = 0 then    // Schwarz-Weiss
   begin
      //jcbx_Kompression.Clear;
      jcbx_Kompression.Items.Clear;
      //jcbx_Kompression.Images.AddImages(dm_Main.jil_Optionen);
      jcbx_Kompression.Items.AddText('CCITT 4');
      jcbx_Kompression.Items.AddText('keine Kompression');
      jcbx_Kompression.Items[0].ImageIndex:=4;
      jcbx_Kompression.Items[1].ImageIndex:=4;
      jcbx_Kompression.ItemIndex :=0;
   end;

   if  jcbx_Erfassung.ItemIndex = 1 then     // Grau 4bit
   begin
      //jcbx_Kompression.Clear;
      jcbx_Kompression.Items.Clear;
      //jcbx_Kompression.Images.AddImages(dm_Main.jil_Optionen);
      jcbx_Kompression.Items.AddText('PackBits');
      jcbx_Kompression.Items.AddText('LZW');
      jcbx_Kompression.Items.AddText('keine Kompression');
      jcbx_Kompression.Items[0].ImageIndex:=4;
      jcbx_Kompression.Items[1].ImageIndex:=4;
      jcbx_Kompression.Items[2].ImageIndex:=4;
      jcbx_Kompression.ItemIndex :=1;
   end;

   if  jcbx_Erfassung.ItemIndex = 2 then     // Grau 8bit
   begin
      //jcbx_Kompression.Clear;
      jcbx_Kompression.Items.Clear;
      //jcbx_Kompression.Images.AddImages(dm_Main.jil_Optionen);
      jcbx_Kompression.Items.AddText('JPG');
      jcbx_Kompression.Items.AddText('PackBits');
      jcbx_Kompression.Items.AddText('LZW');
      jcbx_Kompression.Items.AddText('keine Kompression');
      jcbx_Kompression.Items[0].ImageIndex:=4;
      jcbx_Kompression.Items[1].ImageIndex:=4;
      jcbx_Kompression.Items[2].ImageIndex:=4;
      jcbx_Kompression.Items[3].ImageIndex:=4;
      jcbx_Kompression.ItemIndex :=0;
   end;

   if  jcbx_Erfassung.ItemIndex = 3 then      // Farbe
   begin
      //jcbx_Kompression.Clear;
      jcbx_Kompression.Items.Clear;
      //jcbx_Kompression.Images.AddImages(dm_Main.jil_Optionen);
      jcbx_Kompression.Items.AddText('JPG');
      jcbx_Kompression.Items.AddText('PackBits');
      jcbx_Kompression.Items.AddText('LZW');
      jcbx_Kompression.Items.AddText('keine Kompression');
      jcbx_Kompression.Items[0].ImageIndex:=4;
      jcbx_Kompression.Items[1].ImageIndex:=4;
      jcbx_Kompression.Items[2].ImageIndex:=4;
      jcbx_Kompression.Items[3].ImageIndex:=4;
      jcbx_Kompression.ItemIndex :=0;
   end;

   if jcbx_Erfassung.ItemIndex <> 3 then
   begin
      grpbx_filter.Enabled := true;
      jlbl_Filter.enabled := true;
      jcbx_Filter.enabled := true;
   end
   else
   begin
      grpbx_filter.Enabled := false;
      jlbl_Filter.enabled := false;
      jcbx_Filter.enabled := false;
   end;
end;

procedure Tfrm_Optionen.jcbx_BitDepthChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jchbx_ProportionalChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jcbx_TransferChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jcbx_PapierformatChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jedt_BrightChange(Sender: TObject);
begin
   if jedt_Bright.Modified then
      tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jedt_ContrChange(Sender: TObject);
begin
   if jedt_Contr.Modified then
      tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jedt_ThresChange(Sender: TObject);
begin
   if jedt_Thres.Modified then
      tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jedt_RotateChange(Sender: TObject);
begin
   if jedt_Rotate.Modified then
      tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jcbx_PapierausrichtChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jedt_CutTopChange(Sender: TObject);
begin
   if jedt_CutTop.Modified then
      tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jedt_CutLeftChange(Sender: TObject);
begin
   if jedt_CutLeft.Modified then
      tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jedt_CutRightChange(Sender: TObject);
begin
   if jedt_CutRight.Modified then
      tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jedt_CutBottomChange(Sender: TObject);
begin
   if jedt_CutBottom.Modified then
      tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jrbtn_UseADFChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jrbtn_UseDuplexChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jrbtn_StapelScanChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.jcbx_KompressionChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
end;

// v3.5.0.26
procedure Tfrm_Optionen.tbi_TSaveProfileClick(Sender: TObject);
begin
   SavCurProfile;
   ProfileControls(True);
   GetAllProfiles;
   LoaCurProfile;
   tlbl_ProNotSaved.Visible := False;
end;

procedure Tfrm_Optionen.tbtn_UebernehmenClick(Sender: TObject);
begin
   tbi_TSaveProfileClick(self);
   //  ChkProChange;
   SaveOpt;
end;

procedure Tfrm_Optionen.tbtn_AbbrechenClick(Sender: TObject);
begin
   //ChkProChange;
   // Wegen ModalResult=mrCancel wird das Fenster hier geschlossen
end;

// v3.5.0.26
procedure Tfrm_Optionen.tbtn_SpeichernClick(Sender: TObject);
begin
   ChkProChange;
   SaveOpt;
   //SavCurProfile;
   // Wegen ModalResult=mrOk wird das Fenster hier geschlossen
end;

procedure Tfrm_Optionen.FormShow(Sender: TObject);
begin
   jpctrl_Optionen.ParentColor := False;
   jpctrl_Optionen.Color := clWindow;
   jpctrl_Optionen.ActivePageIndex := 0;
   cbx_Printers.Clear;
   cbx_Printers.Items := Printer.Printers;

   LoadOpt;
   // label1.Caption:= printer.Printers
   label1.Caption := inttostr(printers.Printer.PrinterIndex);
end;

procedure Tfrm_Optionen.tbi_TExpProfilesClick(Sender: TObject);
var sFileName: String;
begin
   sFileName := '';
   if PromptForFileName(sFileName, _('Profildateien (*.Pro)|*.PRO'), 'PRO', _('Profile exportieren...'), '', True) then
   begin
      ExpProfiles(sFileName);
   end;
end;

procedure Tfrm_Optionen.tbi_TImpProfilesClick(Sender: TObject);
var sFileName: String;
begin
   sFileName := '';
   if PromptForFileName(sFileName, _('Profildateien (*.Pro)|*.PRO'), 'PRO', _('Profile importieren...'), '', False) then
   begin
      ImpProfiles(sFileName);
      GetAllProfiles;
   end;
end;

procedure Tfrm_Optionen.tbs_StdOptShow(Sender: TObject);
var iCount: Integer;
begin
   GetAllProfiles;
   GetSkins;
   jcbx_StdScanProfile.Items.Clear;
   for iCount := 0 to (jcbx_Profiles.Items.Count - 1) do
      jcbx_StdScanProfile.Items.AddObject(jcbx_Profiles.Items.Items[iCount].Text, TObject(jcbx_Profiles.Items.Items[iCount].ImageIndex));
   jcbx_StdScanProfile.ItemIndex := 0;
   ReadCbxLgr(jcbx_StdLgr, frm_Main.dbtv_Main);
end;

procedure Tfrm_Optionen.jcbx_StdLgrChange(Sender: TObject);
var iTmpID: Integer;
begin
   jcbx_StdLgr.ItemIndex := jcbx_StdLgr.Items.IndexOf(jcbx_StdLgr.Text);
   if jcbx_StdLgr.ItemIndex <> -1 then
   begin
      iTmpID := iGLgrID;
      iGLgrID := Integer(jcbx_StdLgr.Items.Objects[jcbx_StdLgr.ItemIndex]);
      ReadCbxArc(jcbx_StdArc, iGUsrID, iGLgrID);
      iGLgrID := iTmpID;
   end;
end;

procedure Tfrm_Optionen.jcbx_StdArcChange(Sender: TObject);
begin
   // Mach nix;
end;

procedure Tfrm_Optionen.jchk_UseStdLgrArcClick(Sender: TObject);
begin
   jcbx_StdLgr.Enabled := not jchk_UseStdLgrArc.Checked;
   jcbx_StdArc.Enabled := not jchk_UseStdLgrArc.Checked;
   tlbl_StdLgr.Enabled := not jchk_UseStdLgrArc.Checked;
   tlbl_StdArc.Enabled := not jchk_UseStdLgrArc.Checked;
end;

procedure Tfrm_Optionen.jcbx_SkinChange(Sender: TObject);
begin
   if jcbx_Skin.ItemIndex <> -1 then
      dm_TBX.tbx_Switch.Theme := jcbx_Skin.Items.Strings[jcbx_Skin.ItemIndex];
end;

procedure Tfrm_Optionen.jcbx_FilterChange(Sender: TObject);
begin
   tlbl_ProNotSaved.Visible := True;
   if (jcbx_Filter.ItemIndex < 4) and (jcbx_Filter.ItemIndex > 0) then
   begin
      jvlbl_filterschwellwert.enabled := true;
      jvspndt_filterthreshold.enabled := true;
      jvlbl_filterbackground.enabled := true;
      jvspndt_filterbackground.enabled := true;
   end
   else
   begin
      jvlbl_filterschwellwert.enabled := false;
      jvspndt_filterthreshold.enabled := false;
      jvlbl_filterbackground.enabled := false;
      jvspndt_filterbackground.enabled := false;
   end;
end;
procedure Tfrm_Optionen.rb_blindfarbe_einClick(Sender: TObject);
begin
   jcbx_filter.Enabled := true;
   jlbl_Filter.enabled := true;
end;
procedure Tfrm_Optionen.rb_blindfarbe_ausClick(Sender: TObject);
begin
   jcbx_filter.Enabled := false;
   jlbl_Filter.enabled := false;
end;
procedure Tfrm_Optionen.chbx_UseStdPrnClick(Sender: TObject);
begin
   if chbx_UseStdPrn.Checked then
   begin
      cbx_Printers.Enabled := False;
      cbx_Printers.Text := 'Windows Standarddrucker';
      printer.PrinterIndex := -1;
   end
   else
   begin
      cbx_Printers.Enabled := True;
      cbx_Printers.ItemIndex := 0;
   end;
end;
procedure Tfrm_Optionen.cbx_PrintersChange(Sender: TObject);
var  reg: TRegistry;
begin
   printer.PrinterIndex := cbx_Printers.ItemIndex;
   label1.Caption := inttostr(printer.PrinterIndex);
   reg := TRegistry.Create;
   with reg do
   begin
      closekey;
      RootKey := HKEY_CURRENT_USER;
      OpenKey('Software\bitfarm\Archiv_V3\ManuScan3.1\Optionen\', True);
      WriteString('ManuPrinter', inttostr(cbx_Printers.ItemIndex));
      //WriteInteger('ManuPrinter', cbx_Printers.ItemIndex);
      CloseKey;
   end;
end;
{
 with reg do
      begin
        CloseKey;
        RootKey := HKEY_CURRENT_USER;
        OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
        WriteString ('ViewerFilePath',ExtractFilePath(ParamStr(0)));
}
procedure Tfrm_Optionen.cbx_pnachArcClick(Sender: TObject);
//var  reg: tregistry;
begin
   //  cbx_pnachArc.Checked := not cbx_pnachArc.Checked;
   if cbx_pnachArc.Checked = true then
   begin
      frm_main.lbl_pnachArc.Caption := '1';
    {
    with reg do
    begin
      RootKey := HKEY_CURRENT_USER;
      OpenKey('Software\bitfarm\Archiv_V3\ManuScan3.1\Optionen', True);
      if ValueExists('ManuPrinter') then
      begin
        printer.PrinterIndex := strtoint (readstring('ManuPrinter'));
      end;
      closekey;
    end;
    }
   end
   else frm_main.lbl_pnachArc.Caption := '0';
end;

procedure Tfrm_Optionen.jcbx_ErfassungSelect(Sender: TObject);
begin
   if jcbx_Erfassung.ItemIndex <> 3 then
   begin
      grpbx_filter.Enabled := true;
      jlbl_Filter.enabled := true;
      jcbx_Filter.enabled := true;
   end
   else
   begin
      grpbx_filter.Enabled := false;
      jlbl_Filter.enabled := false;
      jcbx_Filter.enabled := false;
   end;
   if grpbx_filter.Enabled and (jcbx_Filter.ItemIndex < 4) and (jcbx_Filter.ItemIndex > 0) then
   begin
      jvlbl_filterschwellwert.enabled := true;
      jvspndt_filterthreshold.enabled := true;
      jvlbl_filterbackground.enabled := true;
      jvspndt_filterbackground.enabled := true;
   end
   else
   begin
      jvlbl_filterschwellwert.enabled := false;
      jvspndt_filterthreshold.enabled := false;
      jvlbl_filterbackground.enabled := false;
      jvspndt_filterbackground.enabled := false;
   end;
end;

procedure Tfrm_Optionen.jcbx_FilterSelect(Sender: TObject);
begin
   if (jcbx_Filter.ItemIndex < 4) and (jcbx_Filter.ItemIndex > 0) then
   begin
      jvlbl_filterschwellwert.enabled := true;
      jvspndt_filterthreshold.enabled := true;
      jvlbl_filterbackground.enabled := true;
      jvspndt_filterbackground.enabled := true;
   end
   else
   begin
      jvlbl_filterschwellwert.enabled := false;
      jvspndt_filterthreshold.enabled := false;
      jvlbl_filterbackground.enabled := false;
      jvspndt_filterbackground.enabled := false;
   end;
end;

procedure Tfrm_Optionen.FormCreate(Sender: TObject);
begin
   TranslateComponent(self);
end;

procedure Tfrm_Optionen.cbx_showdocClick(Sender: TObject);
begin
	if cbx_showdoc.Checked then
   begin
   	cbx_fastpath.Checked := True;
      cbx_fastpath.Enabled := False;
   end
   else
   begin
   	cbx_fastpath.Checked := False;
      cbx_fastpath.Enabled := True;
   end;
end;

procedure Tfrm_Optionen.cbx_IgnoreTwainErrorChange(Sender: TObject);
begin
	tlbl_ProNotSaved.Visible := True;
end;

procedure Tfrm_Optionen.edt_FilterChange(Sender: TObject);
begin
   if Trim(edt_Filter.Text) <> '' then
   begin
      cbx_fastpath.Checked := False;
      cbx_fastpath.Enabled := False;
   end
   else
   begin
      cbx_fastpath.Enabled := True;
   end;
end;

procedure Tfrm_Optionen.cbx_fastpathClick(Sender: TObject);
begin
	if cbx_fastpath.Checked then
   begin
      edt_Filter.Enabled := False;
      lbl_Filter.Enabled := False;
   end
   else
   begin
      edt_Filter.Enabled := True;
      lbl_Filter.Enabled := True;
   end;

end;

end.
