unit u_zusatzconfig;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, JvExForms, JvScrollBox, strutils,
   TBXDkPanels, registry, gnugettext,
   u_ShBase, u_ShLowUtils, u_ShDm, u_ShFrameZusFldMulti;

type
   Tfrm_zuspflicht = class (TForm)
      sbx_ZusFeld: TJvScrollBox;
      Panel1: TPanel;
      tbxb_reset: TTBXButton;
      tbbt_search: TTBXButton;
      Panel2: TPanel;
    btn_ok: TTBXButton;
    btn_cancel: TTBXButton;
      procedure btn_okClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure tbxb_resetClick(Sender: TObject);
      procedure tbbt_searchClick(Sender: TObject);
   private
      ZusFldFrame:TFrameZusFldMulti;
      procedure zusfeldonchange(Sender: TObject);
      procedure Searchzusfield(Sender: TObject);
   public
      { Public-Deklarationen }
      fTorpflichtfeld: integer;
      fkeypflichtfeld: integer;
      fsDestIarcname: string;
      fsSrcIarcname: string;
      fiZusFcount: integer;
      NOG_Fieldlist: TStringList;
      function CreZusFields: integer;
      function DelZusFields: integer;
      function ChkZusfield: boolean;
   end;

var
   frm_zuspflicht: Tfrm_zuspflicht;

implementation

uses u_dm_DB, JvStaticText, JvToolEdit, JvCombobox, spin, u_main;

{$R *.dfm}

function Tfrm_zuspflicht.CreZusFields: integer;
var
   edt: array of TEdit;
   //lbl: Array of tlabel;
   lbl: array of tjvstatictext;
   cbx: array of TComboBox;
   dat: array of TJvDateEdit;
   tbxb: array of TTBXButton;
   jccb: array of TjvcheckedComboBox;
   lfbit: array of TTBXButton;
   spe: array of TSpinEdit;
   chx: array of Tcheckbox;
   iC, iEdt, iCbx, iDat, iTyp, iCntEdt, iCntCbx, iCntLbl, iCntDat,
   litaborder, iCntCCbx, licount2, iCntbxb, iCntSpi, iCntchx,
   iCnttbxb: integer;
   lfont: tfont;
   lbfound: boolean;
   lswert, sAdd, lsDispName: string;
   lstlw: Tstringlist;
   reg: Tregistry;
   ZusFldFrame:TFrameZusFldMulti;
begin
   iCntEdt := 0;
   iCntCbx := 0;
   iCntLbl := 0;
   iCntDat := 0;
   iCntChx := 0;
   iCnttbxb := 0;
   iCntbxb := 0;
   iCntCCbx := 0;
   iCntSpi := 0;
   litaborder := 2;
   tbbt_search.Visible := false;
   tbxb_reset.visible := false;
   if not Assigned(NOG_Fieldlist) then
      NOG_Fieldlist := TStringList.Create
   else
      NOG_Fieldlist.Clear;
   with dm_DB.my_q_Tmp do
   begin
      if sbx_ZusFeld.ComponentCount > 0 then
         DelZusFields;
      SQL.Text := 'Select * from cfg_' + fsDestIarcname + ' where typ <> 4 order by pos';
      Open;
      First;
      try
         Result := RecordCount;
         if RecordCount = 0 then
         begin
            Close;
            Exit;
         end;
      {
      Filtered := True;
      Filter := 'Typ = 0';
      iEdt := RecordCount;
      Filter := 'Typ = 1';
      iDat := RecordCount;
      Filter := 'Typ = 2';
      iCbx := RecordCount;
      }
         tbbt_search.visible := true;
         tbxb_reset.visible := true;
         Filtered := False;
         SetLength(lbl, RecordCount);
         //    logevnt('0 TorPflichtfeld '+inttostr(TorPflichtfeld));
         fTorPflichtfeld := 0; // Igel0705021024

         sbx_ZusFeld.AutoScroll := True;
         sbx_ZusFeld.Refresh;

         reg := Tregistry.create;
         try
            try
               with reg do
               begin
                  RootKey := HKEY_CURRENT_USER;
                  OpenKey('Software\bitfarm\Archiv_V3\Importtools\' + sGProfil + '\' + inttostr(iGArcID), True);
                  for iC := 0 to (RecordCount - 1) do
                  begin
                     iTyp := FieldByName('Typ').AsInteger;
                     lbl[iCntLbl] := tjvstatictext.Create(sbx_ZusFeld);
                     lbl[iCntLbl].Name := 'zlbl_Tmp' + IntToStr(iC);
                     lbl[iCntLbl].Caption := FieldByName('Disp_Name').AsString + ':';

                     lbfound := false;
                     lswert := '';
                     lfont := canvas.Font;
                     canvas.Font := lbl[iCntLbl].Font;
                     lbl[iCntLbl].Width := 4 + canvas.TextWidth(lbl[iCntLbl].Caption);
                     canvas.Font := lfont;

                     // set NOG_fieldlist always when assigning lbl.caption
                     NOG_fieldList.Add(lbl[iCntLbl].Caption);
                     // Beschreibeung des namens des Pflichtfeldes modifizieren
                     (*
                     if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then  // Datenfeld Optionen prfen ob 1
                     begin

                        lbl[iCntLbl].Caption := '*' + lbl[iCntLbl].Caption;

                        //Nog_Feldername[iC+1] := lbl[iCntLbl].Caption;
                        //showmessage ('IC = '+ inttostr(ic+1) +  Nog_Feldername[iC+1]);
                     end;
                       *)

                     if valueexists(FieldByName('Feld_Name').AsString) then
                     begin
                        lswert := readstring(FieldByName('Feld_Name').AsString);
                     end
                     else
                     begin
                        lswert := '';
                     end;
                     lbl[iCntLbl].Hint := FieldByName('Feld_Name').AsString;
                     lbl[iCntLbl].ParentShowHint := True;
                     lbl[iCntLbl].Left := 8;
                     lbl[iCntLbl].Top := 8 + (40 * iC);
                     lbl[iCntLbl].Height := 13;
                     lbl[iCntLbl].Tag := FieldByName('typ').AsInteger;
                     lbl[iCntLbl].Parent := sbx_ZusFeld;
                     // showmessage  (FieldByName('Optionen').AsString);   // Igel0703061328 Torzhler fr Pflichtfelder

                     //    logevnt('1 TorPflichtfeld '+inttostr(TorPflichtfeld)+' '+lbl[iCntLbl].Caption);
                     if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                     begin
                        //   logevnt('1.5 TorPflichtfeld '+inttostr(TorPflichtfeld));
                        Inc(ftorPflichtfeld);
                     end;

                     //   logevnt('2 TorPflichtfeld '+inttostr(TorPflichtfeld)+' '+lbl[iCntLbl].Caption);
                     if iTyp = 0 then
                     begin
                        SetLength(edt, iCntEdt + 1);
                        edt[iCntEdt] := TEdit.Create(sbx_ZusFeld);
                        edt[iCntEdt].Name := 'zedt_Tmp' + IntToStr(iC);
                        if lswert <> '' then
                        begin
                           edt[iCntEdt].Text := lswert;

                        end
                        else
                        begin
                           edt[iCntEdt].Text := '';
                        end;
                        edt[iCntEdt].Hint :=
                           'Hier knnen Sie im Feld ' + #34 + FieldByName('Disp_Name').AsString +
                           #34 + ' suchen';
                        (*
                        if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                        begin
                           edt[iCntEdt].Hint :=
                              'Hier knnen Sie im Feld ' + #34 + '*' +
                              FieldByName('Disp_Name').AsString + #34 + ' suchen';
                           edt[iCntEdt].Color := cColorPflichtfeld;
                        end;
                          *)
                        edt[iCntEdt].ShowHint := True;
                        edt[iCntEdt].Left := 28;
                        edt[iCntEdt].Top := 21 + (40 * iC);
                        edt[iCntEdt].Height := 21;
                        edt[iCntEdt].Width := (sbx_ZusFeld.Width - 70);
                        edt[iCntEdt].Anchors := [akLeft, akTop, akRight];
                        edt[iCntEdt].Tag := FieldByName('Mode').AsInteger;
                        edt[iCntEdt].Parent := sbx_ZusFeld;
                        edt[iCntEdt].taborder := litaborder;
                        // Die Komponente erst am Schlu sichtbar machen
                        Inc(iCntEdt, 1);
                        inc(litaborder);
                     end
                     else
                     if iTyp = 1 then
                     begin
                        // set just the proper length     (+2 cause there is always 2 date boxes)
                        SetLength(dat, iCntDat + 2);
                        dat[iCntDat] := TJvDateEdit.Create(sbx_ZusFeld);
                        dat[iCntDat].Name := 'zedt_Tmp' + IntToStr(iC);
                        dat[iCntDat].Clear;
                        dat[iCntDat].Hint :=
                           'Hier knnen Sie im Feld ' + #34 + FieldByName('Disp_Name').AsString +
                           #34 + ' suchen';
                        (*
                        if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                        begin
                           dat[iCntdat].Hint :=
                              'Hier knnen Sie im Feld ' + #34 + '*' +
                              FieldByName('Disp_Name').AsString + #34 + ' suchen';
                           dat[iCntdat].Color := cColorPflichtfeld;
                        end;
                          *)

                        if lswert <> '' then
                        begin
                           dat[iCntDat].Text := lswert;
                        end
                        else
                        begin
                        end;
                        dat[iCntDat].ShowHint := True;
                        dat[iCntDat].Left := 28;
                        dat[iCntDat].Top := 21 + (40 * iC);
                        dat[iCntDat].Height := 21;
                        dat[iCntDat].Width := (sbx_ZusFeld.Width - 70);
                        dat[iCntDat].Anchors := [akLeft, akTop, akRight];
                        dat[iCntDat].Tag := FieldByName('Mode').AsInteger;
                        dat[iCntDat].Parent := sbx_ZusFeld;
                        dat[iCntDat].taborder := litaborder;
                        // Die Komponente erst am Schlu sichtbar machen
                        Inc(iCntDat, 1);
                        inc(litaborder);
                     end
                     else
                     if iTyp = 2 then
                     begin
                        // set just the proper length
                        SetLength(cbx, iCntCbx + 1);
                        cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
                        cbx[iCntCbx].Name := 'zedt_Tmp' + IntToStr(iC);
                        cbx[iCntCbx].Style := csDropDown; //3.5.0.19 [ 2264 ] Auswahlfelder knnen beliebig manuell ausgefllt werden
                        cbx[iCntCbx].Hint :=
                           'Hier knnen Sie im Feld ' + #34 + FieldByName('Disp_Name').AsString +
                           #34 + ' suchen';
                        (*
                        if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                        begin
                           cbx[iCntcbx].Hint :=
                              'Hier knnen Sie im Feld ' + #34 + '*' +
                              FieldByName('Disp_Name').AsString + #34 + ' suchen';
                           cbx[iCntcbx].Color := cColorPflichtfeld;
                        end;
                          *)

                        cbx[iCntCbx].ShowHint := True;
                        cbx[iCntCbx].Left := 28;
                        cbx[iCntCbx].Top := 21 + (40 * iC);
                        cbx[iCntCbx].Height := 21;
                        cbx[iCntCbx].Width := (sbx_ZusFeld.Width - 70);
                        cbx[iCntCbx].Anchors := [akLeft, akTop, akRight];
                        cbx[iCntCbx].Tag := FieldByName('Mode').AsInteger;
                        cbx[iCntCbx].Parent := sbx_ZusFeld;
                        // Die Komponente erst am Schlu sichtbar machen
                        cbx[iCntCbx].Clear;
                        cbx[iCntCbx].Items := StrToWords6(FieldByName('Werte').AsString);
                        cbx[iCntCbx].taborder := litaborder;
                        cbx[iCntCbx].Items.Add('');
                        if lswert <> '' then
                        begin
                           cbx[iCntCbx].Text := lswert;
                        end
                        else
                        begin
                        end;
                        Inc(iCntCbx, 1);
                        inc(litaborder);
                     end
                     else
                     if iTyp = 3 then  //Mehrfachauswahlfeld
                     begin
                        lsDispName := FieldByName('Disp_Name').AsString;
                        sAdd := lbl[iCntLbl].Hint;
                        ZusFldFrame := CreateTJvCheckedComboBox(sbx_ZusFeld, iC,
                                          30, sbx_ZusFeld.Width - 90,
                                          lsDispName, sAdd, fsDestIarcname,
                                          zusfeldonchange,
                                          FieldByName('Mode').AsInteger);
                        ZusFldFrame.ComboBox.taborder := litaborder;
                        inc(litaborder);
                        //ZusFldFrame.FillJvCheckedComboBox(sAdd, fsDestIarcname);
                        //m.frey: ist doch auch mist: ZusFldFrame.ComboBox.Clear;
                        (*
                        if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                        begin
                           ZusFldFrame.ComboBox.Hint := 'Hier knnen Sie im Feld ' + #34 + '*' + lsDispName + #34 + ' suchen';
                           ZusFldFrame.ComboBox.NoFocusColor := cColorPflichtfeld;
                        end;
                        *)
                        //ZusFldFrame.FillJvCheckedComboBox(sAdd, fsDestIarcname);

                        if lswert <> '' then
                        begin
                           ZusFldFrame.ComboBox.text := lswert;
                        end;

                        // set just the proper length
                        SetLength(jccb, iCntCCbx + 1);
                        jccb[iCntCCbx] := ZusFldFrame.ComboBox;
                        Inc(iCntCCbx, 1);
                        SetLength(lfbit, iCntbxb + 1);
                        lfbit[iCntbxb] := ZusFldFrame.Button;
                        Inc(iCntbxb, 1);
                     end
                     else
                     if ityp = 5 then
                     begin
                        // set just the proper length
                        SetLength(spe, iCntSpi + 1);
                        // cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
                        spe[iCntSpi] := TSpinEdit.Create(sbx_ZusFeld);
                        spe[iCntSpi].Name := 'zedt_Tmp' + IntToStr(iC);
                        spe[iCntSpi].Hint :=
                           'Hier knnen Sie im Feld ' + #34 +
                           FieldByName('Disp_Name').AsString + #34 + ' suchen';
                        spe[iCntSpi].ShowHint := True;
                        spe[iCntSpi].Left := 30;
                        spe[iCntSpi].Top := 21 + (40 * iC);
                        spe[iCntSpi].Height := 21;
                        spe[iCntSpi].Width := 75;
                        spe[iCntSpi].MaxValue := maxint; // m.frey: war 31 gendert wegen Wehrling nicht Monat absolut sondern Laufzeit
                        spe[iCntSpi].MinValue := 1;
                        spe[iCntSpi].Value := 1;
                        spe[iCntSpi].color := clwhite;
                        (*
                        if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                        begin
                           spe[iCntSpi].Hint := 'Hier knnen Sie im Feld ' + #34 + '*' + FieldByName('Disp_Name').AsString + #34 + ' suchen';
                           spe[iCntSpi].Color := cColorPflichtfeld;
                        end;
                        *)
                        //          spe[iCntSpi].Text:='1';
                        spe[iCntSpi].Anchors := [akLeft, akTop];
                        //          spe[iCntSpi].OnKeyUp := EnableSave;
                        spe[iCntSpi].OnChange := zusfeldonchange;
                        //          spe[iCntSpi].OnKeyDown := DoSearchOnenter;
                        // cbx[iCntCbx].OnChange := BtnEnableSave;
                        // Mode:= exakt, wortende, wortanfang, wortbestandteil
                        spe[iCntSpi].Tag := FieldByName('Mode').AsInteger;
                        spe[iCntSpi].Parent := sbx_ZusFeld;
                        spe[iCntSpi].taborder := litaborder;
                        inc(litaborder);
                        // Die Komponente erst am Schlu sichtbar machen
                        spe[iCntSpi].Clear;
                        if lswert <> '' then
                        begin
                           spe[iCntSpi].text := copy(lswert, 1, length(lswert) - 1);
                        end;
                        //cbx[iCntCbx].readonly;
                        Inc(iCntSpi, 1);
                        SetLength(cbx, iCntCbx + 1);
                        // cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
                        cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
                        cbx[iCntCbx].Style := csDropDown; //3.5.0.19 [ 2264 ] Auswahlfelder knnen beliebig manuell ausgefllt werden
                        cbx[iCntCbx].Name := 'zedt_Tmp_cbx_' + IntToStr(iC);
                        cbx[iCntCbx].Hint :=
                           'Hier knnen Sie im Feld ' + #34 +
                           FieldByName('Disp_Name').AsString + #34 + ' suchen';
                        cbx[iCntCbx].ShowHint := True;
                        //'cbx[iCntCbx].Left := sbx_ZusFeld.Width - 105;
                        cbx[iCntCbx].Left := spe[iCntSpi-1].Left + spe[iCntSpi-1].Width + 10;
                        cbx[iCntCbx].Top := 21 + (40 * iC);
                        cbx[iCntCbx].Height := 21;
                        cbx[iCntCbx].Width := 75;
                        cbx[iCntCbx].Anchors := [akTop, akLeft];
                        //          cbx[iCntCbx].OnKeyUp := EnableSave;
                        cbx[iCntCbx].OnChange := zusfeldonchange;
                        //          cbx[iCntCBx].OnKeyDown := DoSearchOnenter;
                        // cbx[iCntCbx].OnChange := BtnEnableSave;
                        // Mode:= exakt, wortende, wortanfang, wortbestandteil
                        cbx[iCntCbx].Tag := FieldByName('Mode').AsInteger;
                        cbx[iCntCbx].Parent := sbx_ZusFeld;
                        cbx[iCntCbx].taborder := litaborder;
                        inc(litaborder);
                        // Die Komponente erst am Schlu sichtbar machen
                        cbx[iCntCbx].Clear;
                        cbx[iCntCbx].Items.CommaText := 'T,M,J';
                        cbx[iCntCbx].Items.Add('');
                        //cbx[iCntCbx].readonly;
                        cbx[iCntCbx].color := clwhite;

                        if lswert <> '' then
                        begin
                           cbx[iCntCbx].text := copy(lswert, length(lswert), 1);
                        end;
                        (*
                        if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                        begin
                           cbx[iCntCbx].Hint := 'Hier knnen Sie im Feld ' + #34 + '*' + FieldByName('Disp_Name').AsString + #34 + ' suchen';
                           cbx[iCntCbx].Color := cColorPflichtfeld;
                        end;
                        *)
                        Inc(iCntCbx, 1);
                     end;
                     lbl[iCntLbl].Parent := sbx_ZusFeld;
                     // Die Komponenten erst am Schlu sichtbar machen

                     //
                     SetLength(chx, iCntchx + 1);
                     chx[iCntchx] := Tcheckbox.Create(sbx_ZusFeld);
                     chx[iCntChx].Name := 'zedt_Tmpchx' + IntToStr(iC);
                     chx[iCntchx].Left := 8;
                     chx[iCntchx].Top := 21 + (40 * iC);
                     chx[iCntchx].Height := 21;
                     chx[iCntchx].Width := (20);
                     chx[iCntchx].Anchors := [akLeft, akTop];
                     chx[iCntchx].Tag := FieldByName('Mode').AsInteger;
                     chx[iCntchx].Caption := '';
                     chx[iCntchx].Parent := sbx_ZusFeld;
                     chx[iCntchx].TabStop := false;
                     inc(iCntchx, 1);

                     SetLength(tbxb, iCnttbxb + 1);
                     tbxb[iCnttbxb] := TTBXButton.Create(sbx_ZusFeld);
                     tbxb[iCnttbxb].Name := 'zedt_Tmptbxb' + IntToStr(iC);
                     tbxb[iCnttbxb].Left := (sbx_ZusFeld.Width - 25);
                     tbxb[iCnttbxb].Top := 21 + (40 * iC);
                     tbxb[iCnttbxb].Height := 21;
                     tbxb[iCnttbxb].Width := (15);
                     tbxb[iCnttbxb].Anchors := [akright, akTop];
                     tbxb[iCnttbxb].Tag := FieldByName('Mode').AsInteger;
                     tbxb[iCnttbxb].Caption := '';
                     tbxb[iCnttbxb].hint := FieldByName('Feld_Name').AsString;
                     tbxb[iCnttbxb].showhint := false;
                     tbxb[iCnttbxb].Onclick := Searchzusfield;
                     tbxb[iCnttbxb].Images := dm_Shared.il_ShScroll; //dm_Main.jil_scroll;
                     tbxb[iCnttbxb].ImageIndex := 1;
                     tbxb[iCnttbxb].TabStop := false;

                     tbxb[iCnttbxb].Parent := sbx_ZusFeld;

                     inc(iCnttbxb, 1);

                     Inc(iCntLbl, 1);
                     Next;
                  end;
                  if tbbt_search.Top < 21 + (40 * iC) then
                  begin
                     tbbt_search.Top := 21 + (40 * iC);

                     tbxb_reset.top := 21 + (40 * iC);
                  end;
                  tbbt_search.taborder := litaborder;
                  inc(litaborder);
                  tbxb_reset.taborder := litaborder;
               end;
            except
               on e: exception do
               begin
                  ErrorMsg('ReadReg', 'Fehler beim laden der Optionen: ' + e.Message,
                     2000, True);
               end;
            end;
         finally
            begin
               reg.CloseKey;
               if Assigned(reg) then
                  freeandnil(reg);
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('Tfrm_zuspflicht.CreZusFields', 'Fehler beim dynamischen Erzeugen der Zusatzfelder: ' +
               e.Message + #13 +
               'Bitte beenden Sie die Anwendung und starten diese erneut!', 2000, True);
            Result := 0;
            dm_DB.my_q_Tmp.Close;
         end;
      end;
      dm_DB.my_q_Tmp.Close;
   end;
end;

function Tfrm_zuspflicht.DelZusFields: integer;
var
   lcomp: Tcomponent;
begin
   Result := 0;
   if sbx_ZusFeld.ComponentCount = 0 then
      exit;
   try
      while sbx_ZusFeld.ComponentCount > 0 do
      begin
         lcomp := sbx_ZusFeld.Components[0];
         freeandnil(lcomp);
         //      sbx_IZus.Components[0].Free;
         inc(result, 1);
      end;
      ZusFldFrame := nil;
   except
      on e: Exception do
      begin
         ErrorMsg('DelZusFields', 'Fehler beim Entfernen der Zusatzfelder: ' +
            e.Message, 2006, True);
         Result := 0;
      end;
   end;

   tbbt_search.visible := false;
   tbxb_reset.visible := false;
   ftorpflichtfeld := 0;
end;

procedure Tfrm_zuspflicht.btn_okClick(Sender: TObject);

begin
   //chkzusfield;

   frm_zuspflicht.ModalResult := mrOk;
end;


function Tfrm_zuspflicht.ChkZusfield: boolean;
   //Igel0703071045 Ueberpruefung der Eingaben auf Pflichgtfeldern
var // ini: TIniFile;
   iCount: integer;
   sFeld, sName, sWert: string;
   comp: TComponent;
   jvstcomp: tjvstatictext;
begin
   Result := False;
   fkeypflichtfeld := 0;
   ///  ini := TIniFile.Create(FileName);
   try
      try
         //with ini do
         //begin     
         //    logevnt('3 TorPflichtfeld '+inttostr(TorPflichtfeld));
         for iCount := 0 to (fiZusFCount - 1) do
         begin
            jvstcomp := tjvstatictext(sbx_ZusFeld.FindComponent('zlbl_Tmp' +
               IntToStr(iCount)));

            sFeld := jvstcomp.Hint;
            sName := copy(jvstcomp.Caption, 1, Length(jvstcomp.Caption) - 1);
            sWert := '';
            comp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));
            if comp is TEdit then
            begin
               sWert := TEdit(comp).Text;
               // zuswert[icount]:=swert;
            end;
            if comp is TJvDateEdit then
            begin
               // showmessage ('swert of Dateedit = '+TJvDateEdit(comp).Text + inttostr(length( TJvDateEdit(comp).Text )));
               sWert := TJvDateEdit(comp).Text;
               if swert = '  .  .    ' then
                  swert := '';
               // zuswert[icount]:=swert;
            end;
            if comp is TComboBox then
            begin
               sWert := TComboBox(comp).Text;
               // zuswert[icount]:=swert;
            end;
            //WriteString('Zusatzfelder', 'ZusTitel' + IntToStr(iCount + 1), sName);
            //showmessage  ('ZusTitel' + IntToStr(iCount+1 )+ ' '+ sName);
            //showmessage  ('ZusFeld'  + IntToStr(iCount+1 )+ ' '+ sFeld);
            //showmessage  ('ZusWert'  + IntToStr(iCount+1 )+ ' '+ sWert);
            //          showmessage ('swert = :'+swert); 
            //    logevnt('4 TorPflichtfeld '+inttostr(TorPflichtfeld)+ ' '+sName);
            //    logevnt('1 keypflichtfeld '+inttostr(keypflichtfeld));
            if (leftstr(sname, 1) = '*') and (swert <> '') then
               Inc(fkeypflichtfeld);
            //    logevnt('2 keypflichtfeld '+inttostr(keypflichtfeld)+ ' '+sName);
         end;
         //end;
      except
         on e: Exception do
            ErrorMsg('btn_CreJob', 'Fehler beim Erstellen der Vorlagen Datei: ' +
               e.Message, 2023, True);
      end;
   finally
      //if Assigned(ini) then FreeAndNil(ini);
   end;
end;


procedure Tfrm_zuspflicht.zusfeldonchange(Sender: TObject);
begin
   if sender.ClassName = 'TEdit' then
   begin
   end;
   if sender.ClassName = 'TComboBox' then
   begin
   end;
   if sender.ClassName = 'TJvDateEdit' then
   begin
   end;
end;


procedure Tfrm_zuspflicht.Searchzusfield(Sender: TObject);
var
   lstmp, lssst: string;
   linum: integer;
   lcomp, lcomp1: TComponent;
   ljvst: tjvstatictext;
   bpflicht: boolean;
   ncbx: TComboBox;
   lsender: TTBXButton;
   lsItem: string; //[2351]
   FrameZusFldMulti: TFrameZusFldMulti; //[2351]
begin
   bpflicht := false;
   lsender := TTBXButton(sender);
   lstmp := copy(lsender.name, length('zedt_Tmptbxb') + 1, length(lsender.name) - length('zedt_Tmptbxb'));
   trystrtoint(lstmp, linum);
   lcomp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + lstmp);
   ljvst := tjvstatictext(sbx_ZusFeld.FindComponent('zlbl_Tmp' + lstmp));
   case ljvst.Tag of
      0:
      begin
         lssst := Tedit(lcomp).text;

         if tedit(lcomp).Color = cColorPflichtfeld then
         begin
            bpflicht := true;
         end
         else
         begin
            bpflicht := false;
         end;
      end;
      1:
      begin
         lssst := TJvDateEdit(lcomp).text;
         if TJvDateEdit(lcomp).Color = cColorPflichtfeld then
         begin
            bpflicht := true;
         end
         else
         begin
            bpflicht := false;
         end;
      end;
      2:
      begin
         lssst := TComboBox(lcomp).text;
         if TComboBox(lcomp).Color = cColorPflichtfeld then
         begin
            bpflicht := true;
         end
         else
         begin
            bpflicht := false;
         end;
      end;
      3:
      begin
         FrameZusFldMulti := TFrameZusFldMulti(TControl(lcomp).Parent); //[2351]
         lssst := TComboBox(lcomp).text;
         if TComboBox(lcomp).Color = cColorPflichtfeld then
         begin
            bpflicht := true;
         end
         else
         begin
            bpflicht := false;
         end;
      end;
      5:
      begin
         lssst := tspinedit(lcomp).text;
         lcomp1 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + lstmp);
         lssst := lssst + TComboBox(lcomp1).text;
         lcomp1.Free;
         if tspinedit(lcomp).Color = cColorPflichtfeld then
         begin
            bpflicht := true;
         end
         else
         begin
            bpflicht := false;
         end;
      end;
   end;

   lcomp1 := sbx_ZusFeld.FindComponent('jbzedt_Tmp' + lstmp);
   if lcomp1 <> nil then
   begin
      lcomp1.free;
   end;
   dm_db.my_q_Tmp.sql.text := 'select * from arc_' + fsDestIarcname +
      ' where ' + lsender.hint + ' like ' + #39 + '%' + lssst + '%' + #39;
   dm_db.my_q_Tmp.execute;

   lcomp.Free;
   ncbx := TComboBox.Create(sbx_ZusFeld);


   ncbx.Name := 'zedt_Tmp' + lstmp;
              {  cbx[iCntCbx].Hint := 'Hier knnen Sie im Feld ' + #34 +
                  FieldByName('Disp_Name').AsString + #34 + ' suchen';

                if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                  begin
                    cbx[iCntcbx].Hint := 'Hier knnen Sie im Feld ' + #34 + '*'
                      + FieldByName('Disp_Name').AsString + #34 + ' suchen';
                    cbx[iCntcbx].Color := cColorPflichtfeld;
                  end;
               }

   //                cbx[iCntCbx].ShowHint := True;
   ncbx.Left := 28;
   ncbx.Top := 21 + (40 * linum);
   ncbx.Height := 21;
   ncbx.Width := (sbx_ZusFeld.Width - 80);
   ncbx.Anchors := [akLeft, akTop, akRight];
   ncbx.OnChange := zusfeldonchange;
   //                ncbx.Tag := FieldByName('Mode').AsInteger;
   ncbx.Parent := sbx_ZusFeld;
   // Die Komponente erst am Schlu sichtbar machen
   ncbx.Clear;
   ncbx.Items.Add('');
   if bpflicht then
   begin
      ncbx.Color := cColorPflichtfeld;
   end;
   dm_db.my_q_Tmp.First;
   while not dm_db.my_q_Tmp.eof do
   begin
      if (dm_db.my_q_Tmp.fieldbyname(lsender.Hint).asstring <> '')
         and (0 >= ncbx.Items.IndexOf(dm_db.my_q_Tmp.fieldbyname(lsender.Hint).asstring)) then
      begin
         //ncbx.Items.Add(dm_db.my_q_Tmp.fieldbyname(lsender.Hint).asstring);
         //[2351]
         lsItem := dm_db.my_q_Tmp.fieldbyname(lsender.Hint).asstring;
         if Assigned(FrameZusFldMulti) then
            ComboBoxAddOneKomma(ncbx,lsItem)
         else
            ncbx.Items.Add(lsItem);
      end;
      dm_db.my_q_Tmp.Next;
   end;
end;


procedure Tfrm_zuspflicht.FormCreate(Sender: TObject);
begin
   TranslateComponent(self);
end;

procedure Tfrm_zuspflicht.tbbt_searchClick(Sender: TObject);
var
   iCount, licount2: integer;
   comp, comp2, comp3, comp4, comp5: tcomponent;
   bfound, bpflicht: boolean;
   lsconju: string;
   lstext: string;
   lsaddname, lsgroupby: string;
   ncbx: TComboBox;
   lstlw: Tstringlist;

begin
   bpflicht := False;
   dm_db.my_q_Tmp.sql.text := 'select * from arc_' + fsDestIarcname;
   lsconju := ' and ';
   bfound := false;
   for iCount := 0 to (iGZusFCount - 1) do
   begin
      comp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmpchx' + IntToStr(iCount));
      comp2 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));
      comp3 := sbx_ZusFeld.FindComponent('zlbl_Tmp' + IntToStr(iCount));
      //    comp5:= sbx_ZusFeld.FindComponent('jbzedt_Tmp' + IntToStr(iCount));
      lsaddname := tlabel(comp3).Hint;

      if lsgroupby = '' then
      begin
         lsgroupby := lsaddname;
      end
      else
      begin
         lsgroupby := lsgroupby + ',' + lsaddname;
      end;
      if comp2 is Tedit then
      begin
         lstext := tedit(comp2).Text;
      end
      else
      if comp2 is TJvDateEdit then
      begin
         lstext := TJvDateEdit(comp2).Text;
      end
      else
      if comp2 is TComboBox then
      begin
         lstext := TComboBox(comp2).Text;
      end
      else
      if comp2 is TjvcheckedComboBox then
      begin
         lstext := TjvcheckedComboBox(comp2).Text;
      end
      else
      if comp2 is Tspinedit then
      begin

         lstext := Tspinedit(comp2).Text;
         comp4 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(iCount));
         lstext := lstext + TComboBox(comp4).Text;
      end;;
      if Tcheckbox(comp).Checked then
      begin
         lstlw := StrToWords(ParserSemiColonusebackspace(lstext));
         if not bfound then
         begin

            if lstlw.count > 0 then
            begin
               dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' where (';
               for licount2 := 0 to lstlw.Count - 1 do
               begin
                  lstlw.Strings[licount2] := Trim(stringreplace(lstlw.Strings[licount2], ',', '', [rfReplaceAll]));
                  if licount2 = 0 then
                  begin
                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + '(' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end
                  else
                  begin

                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' or (' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end;
               end;
               dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ')';
            end;
            bfound := true;
         end
         else
         begin

            dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + lsconju + '(';
            if lstlw.count > 0 then
            begin
               for licount2 := 0 to lstlw.Count - 1 do
               begin
                  lstlw.Strings[licount2] := Trim(stringreplace(lstlw.Strings[licount2], ',', '', [rfReplaceAll]));
                  if licount2 = 0 then
                  begin
                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + '(' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end
                  else
                  begin

                     dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' or (' + lsaddname + ' like ' +
                        #39 + '%' + lstlw.Strings[licount2] + '%' + #39 + ')';
                  end;
               end;
               dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ')';
            end;
         end;
         freeandnil(lstlw);
      end;
   end;
   dm_db.my_q_Tmp.sql.text := dm_db.my_q_Tmp.sql.text + ' group by ' + lsgroupby;
   dm_db.my_q_Tmp.Execute;

   for iCount := 0 to (iGZusFCount - 1) do
   begin
      comp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmpchx' + IntToStr(iCount));
      comp2 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));
      comp3 := sbx_ZusFeld.FindComponent('zlbl_Tmp' + IntToStr(iCount));
      comp4 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(iCount));
      comp5 := sbx_ZusFeld.FindComponent('lfbzedt_Tmp' + IntToStr(iCount));

      if comp2 is TjvDateedit then
      begin
         continue;
      end;

      if not Tcheckbox(comp).Checked then
      begin
         if comp2 is Tedit then
         begin
            if tedit(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TJvDateEdit then
         begin
            if TJvDateEdit(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TComboBox then
         begin
            if TComboBox(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TSpinEdit then
         begin

            if TComboBox(comp2).Color = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end
         else
         if comp2 is TjvcheckedComboBox then
         begin

            if TjvcheckedComboBox(comp2).NoFocusColor = cColorPflichtfeld then
            begin
               bpflicht := true;
            end
            else
            begin
               bpflicht := false;
            end;
         end;
         comp2.Free;
         if comp4 <> nil then
         begin
            comp4.free;
         end;
         if comp5 <> nil then
         begin
            comp5.free;
         end;

         ncbx := TComboBox.Create(sbx_ZusFeld);
         ncbx.Name := 'zedt_Tmp' + IntToStr(iCount);
              {  cbx[iCntCbx].Hint := 'Hier knnen Sie im Feld ' + #34 +
                  FieldByName('Disp_Name').AsString + #34 + ' suchen';

                if (FieldByName('Optionen').AsInteger and cZusatzFeldOptEingabepflicht) <> 0 then
                  begin
                    cbx[iCntcbx].Hint := 'Hier knnen Sie im Feld ' + #34 + '*'
                      + FieldByName('Disp_Name').AsString + #34 + ' suchen';
                    cbx[iCntcbx].Color := cColorPflichtfeld;
                  end;
               }
         //                cbx[iCntCbx].ShowHint := True;
         ncbx.Left := 28;
         ncbx.Top := 21 + (40 * iCount);
         ncbx.Height := 21;
         ncbx.Width := (sbx_ZusFeld.Width - 60);
         ncbx.Anchors := [akLeft, akTop, akRight];
         //                ncbx.Tag := FieldByName('Mode').AsInteger;
         ncbx.OnChange := zusfeldonchange;
         ncbx.Parent := sbx_ZusFeld;
         // Die Komponente erst am Schlu sichtbar machen
         ncbx.Clear;
         ncbx.Items.Add('');
         if bpflicht then
         begin
            ncbx.Color := cColorPflichtfeld;
         end;
         ncbx.Sorted := true;
         dm_db.my_q_Tmp.First;
         while not dm_db.my_q_Tmp.eof do
         begin
            if (dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring <> '')
               and (0 >= ncbx.Items.IndexOf(dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring)) then
            begin
               ncbx.Items.Add(dm_db.my_q_Tmp.fieldbyname(tlabel(comp3).Hint).asstring);
            end;
            dm_db.my_q_Tmp.Next;
         end;
         //                comp2.Items.CommaText := FieldByName('Werte').AsString;
         //                comp2.onchange :=zusfeldonchange;
      end;
   end;
end;


procedure Tfrm_zuspflicht.tbxb_resetClick(Sender: TObject);
begin
   DelZusFields;
   CreZusFields;
end;

end.
