(*
  All the code presented in this unit is Copyright Peter D Johnson
  www.delphidabbler.com, (c) 2004.

  The code may be used in any way providing it is not sold or passed off as
  the work of another person.

  The code is used at the user's own risk. No guarantee or warranty is provided.
*)

unit UMySingleInst;

interface

uses
   Windows,
   USingleInst;

type
   TMySingleInst = class (TSingleInst)
   protected
      function WdwClassName: string; override;
      function WaterMark: DWORD; override;
   end;

implementation

{ TMySingleInst }

function TMySingleInst.WaterMark: DWORD;
begin
   Result := $DE1CBDAB;
end;

function TMySingleInst.WdwClassName: string;
begin
   Result := 'DelphiDabbler.SingleInstDemo.1';
end;

initialization

   RegisterSingleInstClass(TMySingleInst);

end.
