unit U_comobj;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
   ComObj, ActiveX, ViewerV3_TLB, StdVcl;

type
   TViewerdoc = class (TAutoObject, IViewerdoc)
   protected
      function display(arc_id, doc_id: Integer): HResult; stdcall;
      function close: HResult; stdcall;
      function scan: HResult; stdcall;
      function displaygdoc(gdocid: Int64): HResult; stdcall;
   end;

implementation

uses ComServ, sysutils, u_Mainform;

function TViewerdoc.display(arc_id, doc_id: Integer): HResult;
begin
   frm_MainForm.HandleParam(inttostr(arc_id) + '.' + inttostr(doc_id));
end;

function TViewerdoc.close: HResult;
begin
   frm_MainForm.HandleParam('-C:');
end;

function TViewerdoc.scan: HResult;
begin
   frm_MainForm.HandleParam('-M:');
end;

function TViewerdoc.displaygdoc(gdocid: Int64): HResult;
begin
   frm_MainForm.HandleParam('-G:' + inttostr(gdocid));
end;

initialization
   TAutoObjectFactory.Create(ComServer, TViewerdoc, Class_Viewerdoc,
      ciMultiInstance, tmApartment);
end.
