program ViewerV3;

{$R 'LizRecht.res' 'LizRecht.rc'}
{$R 'suchenavi.res' 'suchenavi.rc'}
{%ToDo 'ViewerV3.todo'}
{%File 'FastMM4Options.inc'}

uses
  FastMM4 in 'FastMM4.pas',
  gnugettext in 'gnugettext.pas',
  Forms,
  u_MainForm in 'u_MainForm.pas' {frm_MainForm},
  u_dm_ViewerMain in 'u_dm_ViewerMain.pas' {dm_MainForm2: TDataModule},
  u_ShVoransicht in '..\Shared\u_ShVoransicht.pas' {frm_Voransicht: TFrame},
  u_Volltext in 'u_Volltext.pas' {frm_Volltext: TFrame},
  u_History in 'u_History.pas' {frm_History: TFrame},
  u_DocLink in 'u_DocLink.pas' {frm_DocLink: TFrame},
  u_dm_DB in 'u_dm_DB.pas' {dm_DB: TDataModule},
  u_Info in 'u_Info.pas' {frm_Info},
  u_Rights in 'u_Rights.pas' {frm_Rights},
  u_Login in 'u_Login.pas' {frm_Login},
  u_NewPass in 'u_NewPass.pas' {frm_NewPass},
  u_LeerFrame in 'u_LeerFrame.pas' {frm_Nix: TFrame},
  u_DeSpeckle in 'u_DeSpeckle.pas' {frm_DeSpeckle},
  u_SlwEdit in 'u_SlwEdit.pas' {frm_SlwEdit},
  u_SendMailLnk in 'u_SendMailLnk.pas' {frm_SendMailLnk},
  u_AskSendMail in 'u_AskSendMail.pas' {frm_AskSendMail},
  u_Optionen in 'u_Optionen.pas' {frm_Optionen},
  u_BrowseForPath in 'u_BrowseForPath.pas',
  u_HistDetail in 'u_HistDetail.pas' {frm_HistDetail},
  u_DocEditor in 'u_DocEditor.pas' {frm_DocEdit},
  u_dm_DocEditor in 'u_dm_DocEditor.pas' {dm_DocEdit: TDataModule},
  u_DelDoc in 'u_DelDoc.pas' {frm_DelDoc},
  u_ObjectOpt in 'u_ObjectOpt.pas' {frm_ObjectOpt},
  u_ObjInfo in 'u_ObjInfo.pas' {frm_AnnoInfo},
  u_DocEditOpt in 'u_DocEditOpt.pas' {frm_DocEditOpt},
  u_ShStamps in '..\Shared\u_ShStamps.pas' {frm_Stamps},
  u_dm_Skins in 'u_dm_Skins.pas' {dm_Themes: TDataModule},
  u_MrgDocs in 'u_MrgDocs.pas' {frm_MrgDocs},
  u_AddDocTimer in 'u_AddDocTimer.pas' {frm_AddDocTime},
  u_DlgWords in 'u_DlgWords.pas' {frm_DlgWords},
  u_WaitInfo in 'u_WaitInfo.pas' {frm_Wait},
  u_PrintPreview in 'u_PrintPreview.pas' {frm_PrintPreview},
  u_EditInfo in 'u_EditInfo.pas' {frm_EditInfo},
  u_DocEditAsk in 'u_DocEditAsk.pas' {frm_DocEditAsk},
  u_askSendMailType in 'u_askSendMailType.pas' {frm_askSendMailType},
  u_Mailform in 'u_Mailform.pas' {frm_MailForm},
  u_ShowLayer in 'u_ShowLayer.pas' {frm_ShowLayer},
  u_TechInf in 'u_TechInf.pas' {frm_techinf},
  u_PickDialog in 'u_PickDialog.pas' {frm_PickColor},
  u_UsRLayerRights in 'u_UsRLayerRights.pas' {frm_UsrLayerRights},
  u_askForSave in 'u_askForSave.pas' {frm_AskForSave},
  u_threadedvoransicht in 'u_threadedvoransicht.pas',
//  u_de_Eingabetext in 'u_de_Eingabetext.pas' {frm_textanno},
  u_threadedansicht in 'u_threadedansicht.pas',
  Collision in 'Collision.pas',
  Vectors in 'Vectors.pas',
  ViewerV3_TLB in 'ViewerV3_TLB.pas',
  USingleInst in 'USingleInst.pas',
  //u_wvlpflichfelder in 'u_wvlpflichfelder.pas' {frm_zuspflicht},
  u_ShDlgAddFields in '..\Shared\u_ShDlgAddFields.pas' {frm_zuspflicht},
  u_OpenOffice in 'u_OpenOffice.pas' {$IFDEF COMOBJ},
  U_comobj in 'U_comobj.pas' {$ENDIF},
  u_voransichtopt in 'u_voransichtopt.pas' {frm_voransichtoptionen},
  U_threadedannoscheck in 'U_threadedannoscheck.pas',
  u_wvlwlt in 'u_wvlwlt.pas' {frm_wvlwlt},
  ActiveDs_TLB in 'ActiveDs_TLB.pas',
  u_mrgdocs_reorder in 'u_mrgdocs_reorder.pas' {frm_mrgdocreorder},
  u_ShLowUtils in '..\Shared\u_ShLowUtils.pas',
  u_ViewBase in 'u_ViewBase.pas',
  u_ShBase in '..\Shared\u_ShBase.pas',
  u_HighUtils in 'u_HighUtils.pas',
  u_ShDbUtils in '..\Shared\u_ShDbUtils.pas',
  u_ShHighUtils in '..\Shared\u_ShHighUtils.pas',
  u_ShFrameZusFldMulti in '..\Shared\u_ShFrameZusFldMulti.pas' {FrameZusFldMulti: TFrame},
  u_ShDm in '..\Shared\u_ShDm.pas' {dm_Shared: TDataModule},
  u_ShSql in '..\Shared\u_ShSql.pas',
  u_ShDefs in '..\Shared\u_ShDefs.pas',
  u_ShRecTab in '..\Shared\u_ShRecTab.pas',
  u_ShCompUtils in '..\Shared\u_ShCompUtils.pas';

{$R *.TLB}

{$R *.res}

begin
   if SingleInst.CanStartApp then
   begin
      HintWindowClass := Tmyhint;
      Application.Initialize;
      Application.Title := 'bitfarm Archiv V3 - Viewer';
      Application.CreateForm(Tdm_Shared, dm_Shared);
      Application.CreateForm(Tdm_MainForm2, dm_MainForm2);
      Application.CreateForm(Tfrm_MainForm, frm_MainForm);
      GgfLogEvnt('create 1');
      GgfLogEvnt('create 2');
      Application.CreateForm(Tdm_DB, dm_DB);
      GgfLogEvnt('create 3');
      Application.CreateForm(Tdm_Themes, dm_Themes);
      GgfLogEvnt('create 4');
      Application.CreateForm(Tfrm_EditInfo, frm_EditInfo);
      GgfLogEvnt('create 7');
      Application.CreateForm(Tfrm_MailForm, frm_MailForm);
      GgfLogEvnt('create 10');
      Application.CreateForm(Tfrm_ShowLayer, frm_ShowLayer);
      GgfLogEvnt('create 11');
      Application.CreateForm(Tfrm_PickColor, frm_PickColor);
      GgfLogEvnt('create 15');
      Application.CreateForm(Tfrm_UsrLayerRights, frm_UsrLayerRights);
      GgfLogEvnt('create 16');
      Application.Run;
   end;
end.
