unit u_DeSpeckle;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, gnugettext;

type
   Tfrm_DeSpeckle = class (TForm)
      cbx_RemPixel: TComboBox;
      lbl_RemPixel: TLabel;
      btn_Remove: TButton;
      btn_Cancel: TButton;
      procedure cbx_RemPixelChange(Sender: TObject);
      procedure btn_CancelClick(Sender: TObject);
      procedure btn_RemoveClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   protected
      procedure CreateParams(var Params: TCreateParams); override;
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_DeSpeckle: Tfrm_DeSpeckle;

implementation

{$R *.dfm}

procedure Tfrm_DeSpeckle.cbx_RemPixelChange(Sender: TObject);
begin
   frm_Despeckle.Tag := cbx_RemPixel.ItemIndex;
end;

procedure Tfrm_DeSpeckle.btn_CancelClick(Sender: TObject);
begin
   frm_DeSpeckle.Tag := -1;
end;

procedure Tfrm_DeSpeckle.btn_RemoveClick(Sender: TObject);
begin
   frm_Despeckle.Tag := cbx_RemPixel.ItemIndex;
end;

procedure Tfrm_DeSpeckle.CreateParams(var Params: TCreateParams);
begin
   inherited;
   Params.ExStyle := Params.ExStyle; // or WS_EX_APPWINDOW;
   Params.WndParent := GetDesktopWindow;
end;

procedure Tfrm_DeSpeckle.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
