unit u_DelDoc;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, gnugettext;

type
   Tfrm_DelDoc = class (TForm)
      lbl_Hinweis_1: TLabel;
      lbl_Passwort: TLabel;
      btn_DelDoc: TButton;
      btn_Cancel: TButton;
      edt_PassWd: TEdit;
      procedure btn_DelDocClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_DelDoc: Tfrm_DelDoc;

implementation

uses u_dm_DB, u_MainForm, u_ShLowUtils;

{$R *.dfm}


// todo delete from filesystem the document (doc_loc, ori_doc and ext_loc)
procedure Tfrm_DelDoc.btn_DelDocClick(Sender: TObject);
var
   //sTmpArcName, sTmpTblName: string;
   {iTmpArcID, iTmpDocID, }iCount, ilrecords: integer;
   DlgForm: TForm;
   ilusr_ids: array of integer;
   mdresult: TModalResult;
begin
   // ask the password of the user
   // before deleting,
   // todo should check permissions

   // new just put in sys_docxs the file with no permissions for all!
   // check revisionssicher
   if Pos(sGArcPath, ExtractFilePath(
      dm_DB.my_q_Arc.FieldByName('doc_loc').AsString)) = 1 then  // revisionssicher
   begin
      BfShowMessage(_('Revisionssicher abgelegtes Dokument -> Exit'));
      exit;
   end;

   DlgForm := CreateMessageDialog(_('Mchten Sie wirklich dieses Dokument lschen?'),
      mtWarning, [mbNo, mbYes, mbCancel]);
   DlgForm.ActiveControl := TButton(DlgForm.FindComponent('No'));
   mdresult := DlgForm.ShowModal;
   DlgForm.Release;
   if mdresult <> mrYes then
   begin
      exit;
   end;


   //check for all users if the doc rights exists
   // if yes update to '' else insert a new entry for this arc_id,doc_id
   // and usr_id a new right ''
   frm_MainForm.TmpSQL('select usr_id from sys_usr');
   setlength(ilusr_ids, dm_db.my_q_Tmp.RecordCount);
   ilrecords := dm_db.my_q_Tmp.RecordCount;
   dm_db.my_q_Tmp.First;
   // do a 2 pass so you dont have problems with queries
   for icount := 0 to ilrecords - 1 do
   begin
      ilusr_ids[icount] := dm_db.my_q_Tmp.FieldByName('usr_id').AsInteger;
      dm_db.my_q_Tmp.Next;
   end;

   for icount := 0 to ilrecords - 1 do
   begin
      dm_db.my_q_Tmp.SQL.Text :=
         ' select docxs_id  from sys_docxs where  arc_id = ' + IntToStr(iGArcID) +
         ' and doc_id =' + IntToStr(iGDocID) + ' and usr_id = ' +
         IntToStr(ilusr_ids[icount]);
      dm_db.my_q_Tmp.Execute;
      if dm_db.my_q_Tmp.RecordCount = 0 then
      begin
         dm_db.my_q_Tmp.sql.Text :=
            'insert into sys_docxs  (arc_id,doc_id, rights, usr_id) values (' +
            IntToStr(iGArcID) + ',' + IntToStr(iGDocID) + ',' + IntToStr(0) +
            ',' + IntToStr(ilusr_ids[icount]) + '); ';
         // use open just for 1 set and execute for the rest!
         dm_db.my_q_Tmp.Execute;
      end
      else
      begin
         dm_db.my_q_Tmp.SQL.Text :=
            ' update sys_docxs set rights=' + #39 + #39 + ' where  arc_id = ' +
            IntToStr(iGArcID) + ' and doc_id =' + IntToStr(iGDocID) +
            ' and usr_id = ' + IntToStr(ilusr_ids[icount]) + ' and docxs_id =' +
            dm_db.my_q_Tmp.FieldByName('docxs_id').AsString;
         dm_db.my_q_Tmp.Execute;
      end;
   end;
   // refresh dbgrd_trefferliste
   dm_db.my_q_Arc.Refreshrecord;
   if igarcrecno <> dm_db.my_q_Arc.recno then
   begin
      dm_db.my_q_Arc.recno := igarcrecno;
   end;
   // show new result
   frm_Mainform.dbgrd_Trefferliste.Hide;
   frm_Mainform.dbgrd_Trefferliste.Show;
end;

procedure Tfrm_DelDoc.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
