unit u_NewPass;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, Inifiles, gnugettext,
   u_ShBase, u_ShLowUtils;

type
   Tfrm_NewPass = class (TForm)
      lbl_CurPass: TLabel;
      edt_CurPass: TEdit;
      lbl_NewPass: TLabel;
      lbl_CnfPass: TLabel;
      edt_CnfPass: TEdit;
      btn_SavPass: TButton;
      btn_CnlPass: TButton;
      edt_NewPass: TEdit;
      Shape1: TShape;
      procedure btn_SavPassClick(Sender: TObject);
      procedure btn_CnlPassClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_NewPass: Tfrm_NewPass;

implementation

uses u_dm_DB, u_MainForm;

{$R *.dfm}

procedure Tfrm_NewPass.btn_SavPassClick(Sender: TObject);
   procedure SaveIni(sCryptPass: string);
   var ini: TIniFile;
   begin
      (**)
      try
         ini := TIniFile.Create(BD.MyLoginIniName);
         ini.WriteString('User', 'Password', sCryptPass);
         //ini.UpdateFile;
      finally
         if Assigned(ini) then
            FreeAndNil(ini);
      end;
      (**)
   end;
var sCryptPass: string;  lb:Boolean;
begin
   if frm_MainForm.TmpSQL('select * from sys_usr where Usr_ID = ' +
      IntToStr(iGUsrID)) then
      with dm_DB.my_q_Tmp do
         begin
            lb:=DeCrypt(FieldByName('usr_pass').AsString, GlobalKey) = edt_CurPass.Text;
            if lb then
               if edt_NewPass.Text = edt_CnfPass.Text then
               begin
                  Edit;
                  sCryptPass := EnCrypt(edt_NewPass.Text, GlobalKey);
                  FieldByName('usr_pass').AsString := sCryptPass;
                  Post;
                  Close;
                  SaveIni(sCryptPass); //m.frey
                  frm_NewPass.ModalResult := mrOk;
               end
               else
                  ErrorMsg('btn_SavPassClick',
                     _('Die beiden eingegebenen Passwrter sind nicht Identisch!'),
                     2009, True)
            else
               ErrorMsg('btn_SavPassClick',
                  _('Das eingegebene Passwort stimmt nicht mit dem Aktuellen berein!'),
                  2010, True)
         end
   else
      ErrorMsg('btn_SavPassClick', _('Fehler beim Auslesen eines Benutzeres'),
         2005, True);
end;

procedure Tfrm_NewPass.btn_CnlPassClick(Sender: TObject);
begin
   frm_NewPass.ModalResult := mrCancel;
end;

procedure Tfrm_NewPass.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
