unit u_Optionen;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// UNIT Optionenfenster
// Autor: Norbert Gering

// Igel           u_optionen Zeitsync mit bitfarm Archiv Server einbauen
// Igel0701251031 u_optionen Korrektur der mouserad umkehrfunktion zum Zoomen
// Igel0610131750 Wiedervorlageintervall auf 5 Minuten gesetzt
// Igel0611271710 u_optionen 10mm platz im Baum erzeugen


interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, ComCtrls, StdCtrls, ExtCtrls, Registry, TB2Dock, TB2ToolWindow,
   TBX, Printers, ShellApi, StrUtils, MFEdit, Mask, JvExMask, JvToolEdit,
   JvCombobox, JvExStdCtrls, JvListComb, inifiles, DateUtils, Placemnt, Spin,
   JvExComCtrls, JvHotKey, gnugettext, Buttons, DB, MemDS, DBAccess,
   MyAccess,
   u_ShLowUtils, u_ShDm;

type
   Tfrm_Optionen = class (TForm)
      btn_Save: TButton;
      btn_Cancel: TButton;
      btn_OK: TButton;
      twnd_Optionen: TTBXToolWindow;
      frmsto_optionen: TFormStorage;
    pgc_Optionen: TPageControl;
    ts_Alg: TTabSheet;
    lbl_AZoom: TLabel;
    lbl_StdMail: TLabel;
    lbl_StdDesp: TLabel;
    lbl_SkinTxt: TLabel;
    lbl1: TLabel;
    lbl_stddir: TLabel;
    lbl2: TLabel;
    cbb_AZoom: TComboBox;
    cbb_StdMail: TComboBox;
    cbb_StdDesp: TComboBox;
    chk_AutoPreview: TCheckBox;
    cbb_Skin: TComboBox;
    cbb_Printers: TComboBox;
    chk_UseStdPrn: TCheckBox;
    chk_ExportPDF: TCheckBox;
    chk_LinkMailer: TCheckBox;
    chk_HintBalloons: TCheckBox;
    chk_ShowRoot: TCheckBox;
    chk_InvertDirection: TCheckBox;
    chk_SyncTimebitfarm: TCheckBox;
    cbb_Timeserver: TComboBox;
    chk_crproridoc: TCheckBox;
    chk_nologinwindow: TCheckBox;
    chk_mslogon: TCheckBox;
    chk_slwnoterecord: TCheckBox;
    chk_vtxnoterecord: TCheckBox;
    chk_outlookole: TCheckBox;
    chk_changepage: TCheckBox;
    edt_stsdir: TEdit;
    btn_searchstddir: TButton;
    chk_showlinkcount: TCheckBox;
    chk_ocrclip: TCheckBox;
    chk_volltextkeywordspdf: TCheckBox;
    chk_OcrAdd: TCheckBox;
    JvHotKeyOcr: TJvHotKey;
    ts_Tasks: TTabSheet;
    lbl_ChkTasksTimer: TLabel;
    chk_DocTimer: TCheckBox;
    cbb_ChkTasksTimer: TComboBox;
    chk_ChkTasksTimer: TCheckBox;
    chk_rts: TCheckBox;
    chk_ermail: TCheckBox;
    chk_einzelinbe: TCheckBox;
    chk_showallwvl: TCheckBox;
    tbc_favwvl: TTabControl;
    lbl_Datum: TLabel;
    lbl_Notiz: TLabel;
    lblStaticText2: TLabel;
    lblStaticText3: TLabel;
    lblStaticText4: TLabel;
    lblStaticText5: TLabel;
    lblStaticText6: TLabel;
    lbl_wvlopt: TLabel;
    mmo_Info: TMemo;
    JvCCB_je: TJvCheckedComboBox;
    JvCCB_efa: TJvCheckedComboBox;
    JvCCB_eb: TJvCheckedComboBox;
    jchb_opttim: TJvCheckedComboBox;
    btn_favwvlsave: TButton;
    se_abstand: TSpinEdit;
    ts_Such: TTabSheet;
    lbl_Hits: TLabel;
    chk_VtxSlw: TCheckBox;
    chk_SemVtx: TCheckBox;
    chk_ListDocInUse: TCheckBox;
    chk_FillZusFields: TCheckBox;
    chk_AddAsterix: TCheckBox;
    chk_AppAsterix: TCheckBox;
    chk_ZusManChg: TCheckBox;
    chk_advanceduser: TCheckBox;
    chk_SavLastArcLgr: TCheckBox;
    chk_AutoDispNew: TCheckBox;
    cbb_Hits: TComboBox;
    ts_Fav: TTabSheet;
    lbl_Lgr: TLabel;
    lbl_Fav1Txt: TLabel;
    lbl_Fav2Txt: TLabel;
    lbl_Fav3Txt: TLabel;
    lbl_Fav4Txt: TLabel;
    lbl_Fav5Txt: TLabel;
    lbl_Arc: TLabel;
    lbl_Src: TLabel;
    bvl_1: TBevel;
    bvl_2: TBevel;
    bvl_3: TBevel;
    bvl_4: TBevel;
    lbl_StdLgr: TLabel;
    lbl_StdArc: TLabel;
    cbb_Lgr_1: TComboBox;
    cbb_Arc_1: TComboBox;
    cbb_Lgr_2: TComboBox;
    cbb_Arc_2: TComboBox;
    cbb_Lgr_3: TComboBox;
    cbb_Arc_3: TComboBox;
    cbb_Lgr_4: TComboBox;
    cbb_Arc_4: TComboBox;
    cbb_Lgr_5: TComboBox;
    cbb_Arc_5: TComboBox;
    chk_Used_1: TCheckBox;
    cbb_Src_5: TComboBox;
    cbb_Src_4: TComboBox;
    cbb_Src_3: TComboBox;
    cbb_Src_2: TComboBox;
    cbb_Src_1: TComboBox;
    chk_Used_2: TCheckBox;
    chk_Used_3: TCheckBox;
    chk_Used_4: TCheckBox;
    chk_Used_5: TCheckBox;
    cbb_StdLgr: TComboBox;
    cbb_StdArc: TComboBox;
    ts_anpassen: TTabSheet;
    pgc_anpassen: TPageControl;
    ts_datei: TTabSheet;
    img_datei: TImage;
    ts_seite: TTabSheet;
    img_seite: TImage;
    ts_grel: TTabSheet;
    img_grel: TImage;
    ts_wvl: TTabSheet;
    img_wvl: TImage;
    ts_favanpassen: TTabSheet;
    img_favanpassen: TImage;
    ts_lgr: TTabSheet;
    img_lgr: TImage;
    ts_status: TTabSheet;
    img_status: TImage;
    ts_export: TTabSheet;
    img_export: TImage;
    ts_doctools: TTabSheet;
    img_doctools: TImage;
    chk_anpassenvisible: TCheckBox;
    ts_wvlfav: TTabSheet;
    lbl3: TLabel;
    lbl_ebdelfav: TLabel;
    lbl4: TLabel;
    lbl5: TLabel;
    lbl6: TLabel;
    lbl7: TLabel;
    lbl8: TLabel;
    lbl9: TLabel;
    lbl10: TLabel;
    lbl11: TLabel;
    lbl12: TLabel;
    img1: TImage;
    img2: TImage;
    img3: TImage;
    img4: TImage;
    img5: TImage;
    img6: TImage;
    img7: TImage;
    img8: TImage;
    img9: TImage;
    img10: TImage;
    mmo_infodelwvl: TMemo;
    mmo_infodelwvl1: TMemo;
    mmo_infodelwvl2: TMemo;
    mmo_infodelwvl3: TMemo;
    mmo_infodelwvl4: TMemo;
    mmo_infodelwvl5: TMemo;
    mmo_infodelwvl6: TMemo;
    mmo_infodelwvl7: TMemo;
    mmo_infodelwvl8: TMemo;
    mmo_infodelwvl9: TMemo;
    jcbx_work0: TJvCheckedComboBox;
    jcbx_work1: TJvCheckedComboBox;
    jcbx_work2: TJvCheckedComboBox;
    jcbx_work3: TJvCheckedComboBox;
    jcbx_work4: TJvCheckedComboBox;
    jcbx_work5: TJvCheckedComboBox;
    jcbx_work6: TJvCheckedComboBox;
    jcbx_work7: TJvCheckedComboBox;
    jcbx_work9: TJvCheckedComboBox;
    jcbx_work8: TJvCheckedComboBox;
    ts_wvllt: TTabSheet;
    tbc_favwvl2: TTabControl;
    lbl13: TLabel;
    lbl14: TLabel;
    lbl15: TLabel;
    lbl16: TLabel;
    lbl17: TLabel;
    lbl18: TLabel;
    lbl19: TLabel;
    lbl20: TLabel;
    mmo_Info1: TMemo;
    jvccb_je2: TJvCheckedComboBox;
    jvccb_efa2: TJvCheckedComboBox;
    jvccb_eb2: TJvCheckedComboBox;
    jchb_opttim2: TJvCheckedComboBox;
    btn_wvlwltsave: TButton;
    se_abstand2: TSpinEdit;
    btn_wvldelimp: TButton;
      procedure FormShow(Sender: TObject);
      procedure cbb_StdLgrChange(Sender: TObject);
      procedure cbb_Lgr_1Change(Sender: TObject);
      procedure cbb_Lgr_2Change(Sender: TObject);
      procedure cbb_Lgr_3Change(Sender: TObject);
      procedure cbb_Lgr_4Change(Sender: TObject);
      procedure cbb_Lgr_5Change(Sender: TObject);
      procedure btn_SaveClick(Sender: TObject);
      procedure btn_OKClick(Sender: TObject);
      procedure chk_SavLastArcLgrClick(Sender: TObject);
      procedure cbb_SkinChange(Sender: TObject);
      procedure chk_UseStdPrnClick(Sender: TObject);
      procedure chk_ChkTasksTimerClick(Sender: TObject);
      procedure cbb_ChkTasksTimerChange(Sender: TObject);
      procedure chk_ShowRootClick(Sender: TObject);
      procedure chk_SyncTimebitfarmClick(Sender: TObject);
      procedure cbb_TimeserverSelect(Sender: TObject);
      procedure btn_favwvlsaveClick(Sender: TObject);
      procedure tbc_favwvlChange(Sender: TObject);
      procedure chk_anpassenvisibleClick(Sender: TObject);
      procedure pgc_anpassenChange(Sender: TObject);
      procedure btn_wvlwltsaveClick(Sender: TObject);
      procedure tbc_favwvl2Change(Sender: TObject);
      procedure btn_wvldelimpClick(Sender: TObject);
      procedure btn_searchstddirClick(Sender: TObject);
      procedure btn_hotkeysaveClick(Sender: TObject);
      procedure tbc_hotsearchChange(Sender: TObject);
      procedure pgc_OptionenChange(Sender: TObject);
      procedure cbb_hotsearchlgrChange(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure btn_addvertretungClick(Sender: TObject);
      procedure btn_removevertretungClick(Sender: TObject);
    procedure edt_vertavaChange(Sender: TObject);
    procedure edt_vertreChange(Sender: TObject);
    procedure VertretungSetEnabled(Sender: TObject);
   private
      procedure loadvertretungsown;
      function checkforholydayloops(liusridsrc, ldusriddst: integer; ldstart,
         ldend: Tdatetime): boolean;
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      gSLitemsworkers: TStringList;
      procedure SaveDelwvl;
      procedure LoadDelwvl;
      function InitOption: boolean;
      function CheckReg: boolean;
      function ReadReg: boolean;
      function WriteReg: boolean;
      function GetArc(cbxLgr, cbxArc: TComboBox): boolean;
   end;

var
   frm_Optionen: Tfrm_Optionen;

implementation

{$R *.dfm}

uses {} u_dm_ViewerMain, u_MainForm, u_dm_Skins, u_dm_DB;

function Tfrm_Optionen.InitOption: boolean;
   //////////////////////////////////////////////////////////////////
   ///  30.05.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion initalisiert die Grundeinstellungen fr    ///
   ///  die Lager & Archive in den Optionen und Favoriten.        ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iCount: integer;
begin
   Result := True;
   cbx_Printers.Clear;
   cbx_Printers.Items := Printer.Printers;
   cbx_Skin.Clear;
   for iCount := 0 to (dm_Themes.skinSw.ThemeCount - 1) do
      cbx_Skin.Items.Add(dm_Themes.skinSw.Themes[iCount]);
   cbx_Skin.ItemIndex := 0;
   try
      cbx_StdLgr.Items := frm_MainForm.cbx_Lager.Items;
      cbx_StdLgr.ItemIndex := 0;
      cbx_StdArc.Items := frm_MainForm.cbx_Archiv.Items;
      cbx_StdArc.ItemIndex := 0;
      cbx_Lgr_1.Items := frm_MainForm.cbx_Lager.Items;
      cbx_Lgr_1.ItemIndex := 0;
      cbx_Arc_1.Items := frm_MainForm.cbx_Archiv.Items;
      cbx_Arc_1.ItemIndex := 0;
      cbx_Src_1.ItemIndex := 0;
      cbx_Lgr_2.Items := frm_MainForm.cbx_Lager.Items;
      cbx_Lgr_2.ItemIndex := 0;
      cbx_Arc_2.Items := frm_MainForm.cbx_Archiv.Items;
      cbx_Arc_2.ItemIndex := 0;
      cbx_Src_2.ItemIndex := 0;
      cbx_Lgr_3.Items := frm_MainForm.cbx_Lager.Items;
      cbx_Lgr_3.ItemIndex := 0;
      cbx_Arc_3.Items := frm_MainForm.cbx_Archiv.Items;
      cbx_Arc_3.ItemIndex := 0;
      cbx_Src_3.ItemIndex := 0;
      cbx_Lgr_4.Items := frm_MainForm.cbx_Lager.Items;
      cbx_Lgr_4.ItemIndex := 0;
      cbx_Arc_4.Items := frm_MainForm.cbx_Archiv.Items;
      cbx_Arc_4.ItemIndex := 0;
      cbx_Src_4.ItemIndex := 0;
      cbx_Lgr_5.Items := frm_MainForm.cbx_Lager.Items;
      cbx_Lgr_5.ItemIndex := 0;
      cbx_Arc_5.Items := frm_MainForm.cbx_Archiv.Items;
      cbx_Arc_5.ItemIndex := 0;
      cbx_Src_5.ItemIndex := 0;


      cbx_hotsearchlgr.Items := frm_MainForm.cbx_Lager.Items;
      cbx_hotsearchlgr.ItemIndex := 0;
      cbx_hotsearcharc.Items := frm_MainForm.cbx_Archiv.Items;
      cbx_hotsearcharc.ItemIndex := 0;

      tbc_hotsearchChange(nil);
   except
      on e: Exception do
      begin
         Result := False;
         ErrorMsg('frm_Optionen.InitOption', _('Fehler beim Initalisieren der Optionen: ') +
            e.Message, 2033, True);
      end;
   end;
end;

function Tfrm_Optionen.CheckReg: boolean;
   //////////////////////////////////////////////////////////////////
   ///  30.05.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion berprft alle Registryschlssel der       ///
   ///  Optionen und Favoriten und setzt die fehlenden Schlssel  ///
   ///  mit Standard Einstellungen.                               ///
   ///
   ///  Grundeinstellung Registry erzeugen                        ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   reg: TRegistry;
begin
   reg := TRegistry.Create;
   Result := True;
   with reg do
   begin
      try
         try
            RootKey := HKEY_CURRENT_USER;
            // berprfen der Options-Einstellungen
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            if not ValueExists('MouseRadDirection') then
            begin
               WriteBool('MouseRadDirection', False);
            end;
        {
        if not ValueExists('StdLgr') then
          WriteString('StdLgr', '');
          }
            if not ValueExists('StdArc') then
               WriteString('StdArc', 'alle Archive');
            if not ValueExists('Theme') then
               WriteString('Theme', 'Default');
            if not ValueExists('AZoom') then
               WriteInteger('Azoom', 1);
            if not ValueExists('StdMail') then
               WriteInteger('StdMail', 2);
            if not ValueExists('StdDesp') then
               WriteInteger('StdDesp', 4);
            if not ValueExists('Hits') then
               WriteString('Hits', '50');
            if not ValueExists('ListDocInUse') then
               WriteBool('ListDocInUse', True);
            if not ValueExists('SemVtx') then
               WriteBool('SemVtx', False);
            if not ValueExists('FillZusFields') then
               WriteBool('FillZusFields', True);
            if not ValueExists('SavLastArcLgr') then
               WriteBool('SavLastArcLgr', True);
            if not ValueExists('AutoPreView') then
               WriteBool('AutoPreView', True);
            if not ValueExists('AddAsterix') then
               WriteBool('AddAsterix', True);
            if not ValueExists('AppAsterix') then
               WriteBool('AppAsterix', True);
            if not ValueExists('VtxSlw') then
               WriteBool('VtxSlw', True);
            if not ValueExists('DocTimer') then
               WriteBool('DocTimer', True);
            if not ValueExists('ShowRoot') then
               WriteBool('ShowRoot', False);
            // Root in Lager und Archive ausblende bringt 10mm
            if not ValueExists('AutoDispNew') then
            begin
               WriteBool('AutoDispNew', False);
            end;
            if not ValueExists('ZusManChg') then
               WriteBool('ZusManChg', True);
            if not ValueExists('UseStdPrn') then
               WriteInteger('UseStdPrn', -1);
            if not ValueExists('ExportPDF') then
               WriteBool('ExportPDF', True);
            if not ValueExists('volltextkeywordspdf') then
               WriteBool('volltextkeywordspdf', False);
            if not ValueExists('UseIntMail') then
               WriteBool('UseIntMail', True);
            if not ValueExists('BalloonHints') then
               WriteBool('BalloonHints', False);
            if not ValueExists('ChkTasksTimer') then
               WriteBool('ChkTasksTimer', True);
            if not ValueExists('ChkTasksInterval') then
               WriteInteger('ChkTasksInterval', 2);
            if not ValueExists('AdvancedUser') then
               WriteBool('AdvancedUser', False);
            CloseKey;
            // Einlesen der Favoriten-Einstellungen
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Favoriten', True);
            if not ValueExists('FavLgr1') then
               WriteString('FavLgr1', '');
            if not ValueExists('FavArc1') then
               WriteString('FavArc1', '');
            if not ValueExists('FavSrc1') then
               WriteInteger('FavSrc1', 0);
            if not ValueExists('FavUse1') then
               WriteBool('FavUse1', False);
            if not ValueExists('FavLgr2') then
               WriteString('FavLgr2', '');
            if not ValueExists('FavArc2') then
               WriteString('FavArc2', '');
            if not ValueExists('FavSrc2') then
               WriteInteger('FavSrc2', 0);
            if not ValueExists('FavUse2') then
               WriteBool('FavUse2', False);
            if not ValueExists('FavLgr3') then
               WriteString('FavLgr3', '');
            if not ValueExists('FavArc3') then
               WriteString('FavArc3', '');
            if not ValueExists('FavSrc3') then
               WriteInteger('FavSrc3', 0);
            if not ValueExists('FavUse3') then
               WriteBool('FavUse3', False);
            if not ValueExists('FavLgr4') then
               WriteString('FavLgr4', '');
            if not ValueExists('FavArc4') then
               WriteString('FavArc4', '');
            if not ValueExists('FavSrc4') then
               WriteInteger('FavSrc4', 0);
            if not ValueExists('FavUse4') then
               WriteBool('FavUse4', False);
            if not ValueExists('FavLgr5') then
               WriteString('FavLgr5', '');
            if not ValueExists('FavArc5') then
               WriteString('FavArc5', '');
            if not ValueExists('FavSrc5') then
               WriteInteger('FavSrc5', 0);
            if not ValueExists('FavUse5') then
               WriteBool('FavUse5', False);
         except
            on e: Exception do
            begin
               Result := False;
               ErrorMsg('frm_Optionen.ReadReg', _('Fehler beim berprfen der Registrierung:') +
                  e.Message, 2031, True);
            end;
         end;
      finally
         if Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;

function Tfrm_Optionen.ReadReg: boolean;
   //////////////////////////////////////////////////////////////////
   ///  30.05.2005 Erstellt by SV.                                ///
   ///  Registry read Registry lesen                                                          ///
   ///  Diese Funktion berprft alle Registryschlssel der       ///
   ///  Optionen und Favoriten und liest alle vorhandenen Sch-    ///
   ///  Schlssel aus.                                            ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////

var
   reg: TRegistry;
   //err: integer;

   // Neue functions, kann die vielen if ersetzen
   function CheckReadBool(const Name: string): Boolean;
   begin
      if reg.ValueExists(Name) then
         Result := reg.ReadBool(Name)
      else
         Result := False;
   end;
   function CheckReadInteger(const Name: string): Integer;
   begin
      if reg.ValueExists(Name) then
         Result := reg.ReadInteger(Name)
      else
         Result := 0;
   end;
   function CheckReadIntegerDef(const Name: string; Def: integer): Integer;
   begin
      if reg.ValueExists(Name) then
         Result := reg.ReadInteger(Name)
      else
         Result := Def;
   end;
   function CheckReadString(const Name: string): string;
   begin
      if reg.ValueExists(Name) then
         Result := reg.ReadString(Name)
      else
         Result := '';
   end;

begin
   reg := TRegistry.Create;
   Result := True;
   with reg do
   begin
      try
         try
            RootKey := HKEY_CURRENT_USER;
            // Einlesen der Options-Einstellungen
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            cbx_InvertDirection.Checked := CheckReadBool('MouseRadDirection');
            cbx_StdLgr.Text := CheckReadString('StdLgr');
            cbx_StdArc.Text := CheckReadString('StdArc');
            cbx_AZoom.ItemIndex := CheckReadInteger('Azoom');
            cbx_StdMail.ItemIndex := CheckReadInteger('StdMail');
            cbx_StdDesp.ItemIndex := CheckReadInteger('StdDesp');
            cbx_Hits.Text := CheckReadString('Hits');
            chbx_ListDocInUse.Checked := CheckReadBool('ListDocInUse');
            chbx_SemVtx.Checked := CheckReadBool('SemVtx');
            chbx_FillZusFields.Checked := CheckReadBool('FillZusFields');
            chbx_SavLastArcLgr.Checked := CheckReadBool('SavLastArcLgr');
            cbx_AutoPreview.Checked := CheckReadBool('AutoPreView');
            chbx_AddAsterix.Checked := CheckReadBool('AddAsterix');
            chbx_AppAsterix.Checked := CheckReadBool('AppAsterix');
            chbx_VTXSLW.Checked := CheckReadBool('VtxSlw');
            cbx_Skin.Text := CheckReadString('Theme');
            chbx_DocTimer.Checked := CheckReadBool('DocTimer');
            cbx_showallwvl.Checked := CheckReadBool('showallwvlbutton');

            chbx_AutoDispNew.Checked := CheckReadBool('AutoDispNew');
            cbx_slwnoterecord.Checked := CheckReadBool('Noteslwrecord');
            cbx_vtxnoterecord.Checked := CheckReadBool('Notevtxrecord');
            cbx_ocrclip.Checked := CheckReadBool('OCRClip');

            cbx_OcrAdd.Checked := CheckReadBool('OcrAdd');
            JvHotKeyOcr.Hotkey := CheckReadIntegerDef('OcrKey', 16473);

            chbx_ZusManChg.Checked := CheckReadBool('ZusManChg');
            cbx_Printers.ItemIndex := CheckReadInteger('UseStdPrn');
            cbx_LinkMailer.Checked := CheckReadBool('UseIntMail');
            cbx_ExportPDF.Checked := CheckReadBool('ExportPDF');
            cbx_volltextkeywordspdf.Checked := CheckReadBool('volltextkeywordspdf');
            chbx_SyncTimebitfarm.Checked := CheckReadBool('SyncTime');

            if ValueExists('bfaTimeServer') then
            begin
               ngtimeserver := readstring('bfaTimeServer');
               cb_Timeserver.Text := ngtimeserver;
               {err := }ShellExecute(0, 'open', PChar(BD.EnvSystemRoot + '\system32\cmd.exe'),
                  PChar('/c net time ' + ngtimeserver + '/set /yes'), nil, SW_hide);
            end;

            cbx_Crproridoc.Checked := CheckReadBool('Crproridoc');
            cbx_nologinwindow.Checked := CheckReadBool('nologinwindow');
            cbx_mslogon.Checked := CheckReadBool('mslogon');
            cbx_outlookole.Checked := CheckReadBool('Oleoutlook');
            edt_stsdir.Text := CheckReadString('standardlgrsave');
            cbx_changepage.Checked := CheckReadBool('Changepagebyenter');
            cbx_Showlinkcount.Checked := CheckReadBool('Showlinkcount');
            JvHk_hotsearch.Hotkey := CheckReadInteger('HotsearchHK');
            cbx_HintBalloons.Checked := CheckReadBool('BalloonHints');
            chbx_ChkTasksTimer.Checked := CheckReadBool('ChkTasksTimer');
            cbx_rts.Checked := CheckReadBool('ReturntoSender');
            cbx_ermail.Checked := CheckReadBool('Erinnerungsmail');

            //  if ValueExists('Einzelmodusinbearbeitung') then cbx_einzelinbe.Checked := ReadBool('Einzelmodusinbearbeitung');

            if ValueExists('ChkTasksInterval') then
               cbx_ChkTasksTimer.Text := IntToStr(ReadInteger('ChkTasksInterval'));
            chbx_ChkTasksTimer.OnClick(self);
            if cbx_Printers.ItemIndex = -1 then
            begin
               cbx_UseStdPrn.Checked := True;
               cbx_Printers.Text := _('Windows-Standarddrucker');
               cbx_Printers.Enabled := False;
            end
            else
            begin
               cbx_UseStdPrn.Checked := False;
               cbx_Printers.Enabled := True;
            end;

            cbx_advanceduser.Checked := CheckReadBool('AdvancedUser');

            CloseKey;

            // Einlesen der Favoriten-Einstellungen
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Favoriten', True);
            cbx_Lgr_1.Text := CheckReadString('FavLgr1');
            cbx_Arc_1.Text := CheckReadString('FavArc1');
            cbx_Src_1.ItemIndex := CheckReadInteger('FavSrc1');
            chbx_Used_1.Checked := CheckReadBool('FavUse1');
            cbx_Lgr_2.Text := CheckReadString('FavLgr2');
            cbx_Arc_2.Text := CheckReadString('FavArc2');
            cbx_Src_2.ItemIndex := CheckReadInteger('FavSrc2');
            chbx_Used_2.Checked := CheckReadBool('FavUse2');
            cbx_Lgr_3.Text := CheckReadString('FavLgr3');
            cbx_Arc_3.Text := CheckReadString('FavArc3');
            cbx_Src_3.ItemIndex := CheckReadInteger('FavSrc3');
            chbx_Used_3.Checked := CheckReadBool('FavUse3');
            cbx_Lgr_4.Text := CheckReadString('FavLgr4');
            cbx_Arc_4.Text := CheckReadString('FavArc4');
            cbx_Src_4.ItemIndex := CheckReadInteger('FavSrc4');
            chbx_Used_4.Checked := CheckReadBool('FavUse4');
            cbx_Lgr_5.Text := CheckReadString('FavLgr5');
            cbx_Arc_5.Text := CheckReadString('FavArc5');
            cbx_Src_5.ItemIndex := CheckReadInteger('FavSrc5');
            chbx_Used_5.Checked := CheckReadBool('FavUse5');
         except
            on e: Exception do
            begin
               Result := False;
               ErrorMsg('frm_Optionen.ReadReg', _('Fehler beim Einlesen der Registrierung: ') +
                  e.Message, 2029, True);
            end;
         end;
      finally
         if Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;

function Tfrm_Optionen.WriteReg: boolean;
   //////////////////////////////////////////////////////////////////
   ///  30.05.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion schreibt alle Options und Favoriten Ein-   ///
   ///  stellungen in die Registrierung.                          ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   reg, reg1: TRegistry;
   icount: integer;
   lbfavdir: boolean;
   sFav, ls: string;
begin
   reg := TRegistry.Create;
   reg1 := TRegistry.Create;
   Result := True;
   with reg do
   begin
      try
         try
            RootKey := HKEY_CURRENT_USER;
            // Einlesen der Options-Einstellungen
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            WriteString('bfaTimeServer', ngtimeserver);
            WriteBool('MouseRadDirection', cbx_InvertDirection.Checked);
            WriteString('StdLgr', cbx_StdLgr.Text);
            WriteString('StdArc', cbx_StdArc.Text);
            //cb_Timeserver.Items.Strings[cb_Timeserver.itemindex]
            WriteInteger('AZoom', cbx_AZoom.ItemIndex);
            WriteInteger('StdMail', cbx_StdMail.ItemIndex);
            WriteInteger('StdDesp', cbx_StdDesp.ItemIndex);
            WriteString('Hits', cbx_Hits.Text);
            WriteBool('ListDocInUse', chbx_ListDocInUse.Checked);
            WriteBool('SemVtx', chbx_SemVtx.Checked);
            WriteBool('FillZusFields', chbx_FillZusFields.Checked);
            WriteBool('SavLastArcLgr', chbx_SavLastArcLgr.Checked);
            WriteBool('OcrAdd', cbx_OcrAdd.Checked);
            WriteInteger('OcrKey', JvHotKeyOcr.Hotkey);
            WriteBool('AutoPreView', cbx_AutoPreview.Checked);
            WriteBool('SyncTime', chbx_SyncTimebitfarm.Checked);
            // Igel070612 Serverzeit des bfa Servers holen S1
            WriteBool('AddAsterix', chbx_AddAsterix.Checked);
            WriteBool('AppAsterix', chbx_AppAsterix.Checked);
            WriteBool('VtxSlw', chbx_VTXSLW.Checked);
            WriteBool('DocTimer', chbx_DocTimer.Checked);
            WriteBool('showallwvlbutton', cbx_showallwvl.Checked);
            WriteString('Theme', cbx_Skin.Text);
            WriteBool('AutoDispNew', chbx_AutoDispNew.Checked);
            WriteBool('Noteslwrecord', cbx_slwnoterecord.Checked);
            WriteBool('Notevtxrecord', cbx_vtxnoterecord.Checked);
            WriteBool('OCRClip', cbx_ocrclip.Checked);
            WriteBool('ZusManChg', chbx_ZusManChg.Checked);
            WriteBool('ExportPDF', cbx_ExportPDF.Checked);
            WriteBool('volltextkeywordspdf', cbx_volltextkeywordspdf.Checked);

            WriteBool('UseIntMail', cbx_LinkMailer.Checked);
            WriteBool('BalloonHints', cbx_HintBalloons.Checked);
            WriteBool('ChkTasksTimer', chbx_ChkTasksTimer.Checked);
            WriteBool('ReturntoSender', cbx_rts.Checked);
            WriteBool('Erinnerungsmail', cbx_ermail.Checked);
            //        WriteBool('Einzelmodusinbearbeitung', cbx_einzelinbe.Checked);

            WriteInteger('ChkTasksInterval', StrToInt(cbx_ChkTasksTimer.Text));
            WriteBool('Crproridoc', cbx_Crproridoc.Checked);
            GbCrproridoc := cbx_Crproridoc.Checked;
            WriteBool('nologinwindow', cbx_nologinwindow.Checked);
            WriteBool('mslogon', cbx_mslogon.Checked);
            WriteBool('Oleoutlook', cbx_outlookole.checked);
            WriteString('standardlgrsave', edt_stsdir.Text);
            WriteBool('Showlinkcount', cbx_Showlinkcount.checked);
            WriteBool('Changepagebyenter', cbx_changepage.checked);

            if cbx_changepage.checked then
            begin
               frm_mainform.tbxse_page.OnChange := nil;
            end
            else
            begin
               frm_mainform.tbxse_page.OnChange := frm_mainform.tbxse_pageChange;
            end;

            ls := '';
            if tbc_hotsearch.TabIndex > 0 then
            begin
               ls := inttostr(tbc_hotsearch.TabIndex - 1);
            end;

            WriteInteger('HotsearchHK' + ls, JvHk_hotsearch.Hotkey);

            reg1.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen\Hotsearch', True);

            reg1.WriteString('StdLgr' + ls, cbx_hotsearchlgr.Text);
            reg1.WriteString('StdArc' + ls, cbx_hotsearcharc.Text);
            reg1.CloseKey;

            if cbx_UseStdPrn.Checked then
               WriteInteger('UseStdPrn', -1)
            else
               WriteInteger('UseStdPrn', cbx_Printers.ItemIndex);

            WriteBool('AdvancedUser', cbx_advanceduser.Checked);
            CloseKey;
            // Einlesen der Favoriten-Einstellungen
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Favoriten', True);
            WriteString('FavLgr1', cbx_Lgr_1.Text);
            WriteString('FavArc1', cbx_Arc_1.Text);
            WriteInteger('FavSrc1', cbx_Src_1.ItemIndex);
            WriteBool('FavUse1', chbx_Used_1.Checked);
            WriteString('FavLgr2', cbx_Lgr_2.Text);
            WriteString('FavArc2', cbx_Arc_2.Text);
            WriteInteger('FavSrc2', cbx_Src_2.ItemIndex);
            WriteBool('FavUse2', chbx_Used_2.Checked);
            WriteString('FavLgr3', cbx_Lgr_3.Text);
            WriteString('FavArc3', cbx_Arc_3.Text);
            WriteInteger('FavSrc3', cbx_Src_3.ItemIndex);
            WriteBool('FavUse3', chbx_Used_3.Checked);
            WriteString('FavLgr4', cbx_Lgr_4.Text);
            WriteString('FavArc4', cbx_Arc_4.Text);
            WriteInteger('FavSrc4', cbx_Src_4.ItemIndex);
            WriteBool('FavUse4', chbx_Used_4.Checked);
            WriteString('FavLgr5', cbx_Lgr_5.Text);
            WriteString('FavArc5', cbx_Arc_5.Text);
            WriteInteger('FavSrc5', cbx_Src_5.ItemIndex);
            WriteBool('FavUse5', chbx_Used_5.Checked);

            for iCount := 1 to 5 do
            begin
               lbfavdir := False;
               sFav := IntToStr(iCount);
               if Tcombobox(FindComponent('cbx_Arc_' + sfav)).Text <> '' then
               begin
                  lbfavdir := True;
               end;

               if Tcombobox(FindComponent('cbx_Lgr_' + sfav)).Text <> '' then
               begin
                  lbfavdir := True;
               end;

               if lbfavdir then
               begin
                  TTBXitem(frm_mainform.FindComponent('tbi_Fav' + sfav)).Enabled := True;
                  TTBXitem(frm_mainform.FindComponent('tbi_Fav' + sfav)).visible := True;
               end
               else
               begin
                  TTBXitem(frm_mainform.FindComponent('tbi_Fav' + sfav)).Enabled := False;
                  TTBXitem(frm_mainform.FindComponent('tbi_Fav' + sfav)).visible := False;
               end;
            end;

         except
            on e: Exception do
            begin
               Result := False;
               ErrorMsg('frm_Optionen.WriteReg', 'Fehler beim Speichern der Registrierung: ' +
                  e.Message, 2030, True);
            end;
         end;
      finally
         reg.closekey;
         if Assigned(reg) then
            FreeAndNil(reg);
         if Assigned(reg1) then
            FreeAndNil(reg1);
      end;
   end;
end;

function Tfrm_Optionen.GetArc(cbxLgr, cbxArc: TComboBox): boolean;
   //////////////////////////////////////////////////////////////////
   ///  30.05.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion kopiert die Items aus                      ///
   ///  frm_MainForm.cbx_Lager und frm_MainForm.cbx_Archiv in     ///
   ///  die ComboBoxen in cbxLgr und cbxArc.                      ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   sTmpLgr: string;
begin
   Result := True;
   try
      with frm_MainForm do
      begin
         sTmpLgr := cbx_Lager.Text;
         cbx_Lager.ItemIndex := -1;
         cbx_Lager.Text := cbxLgr.Text;
         cbx_LagerChange(self);
         cbxArc.Items := cbx_Archiv.Items;
         cbxArc.ItemIndex := 0;
         cbx_Lager.ItemIndex := -1;
         cbx_Lager.Text := sTmpLgr;
         cbx_LagerChange(self);
      end;
   except
      on e: Exception do
      begin
         Result := False;
         ErrorMsg('frm_Optionen.GetArc',
            _('Fehler beim Kopieren der Lager und Archiv-Listen: ') +
            e.Message, 2032, True);
      end;
   end;
end;

procedure Tfrm_Optionen.FormShow(Sender: TObject);
var
   iCount: integer;
   ljcbxtmp: TJvCheckedComboBox;
begin
   InitOption;
   CheckReg;
   ReadReg;
   frm_MainForm.TmpSQL('select usr_id, usr_Name  from sys_usr where (usr_name not like  '
      + #39 + 'DEL\_%' + #39 + ') and (usr_name not like  ' + #39 +
      'system' + #39 + ') order by usr_name');
   jvde_startvertretung.Date := now;
   jvde_endvertretung.Date := now + 14;
   for iCount := 0 to (dm_DB.my_q_Tmp.RecordCount - 1) do
   begin
      jvccb_eb.Items.Add(dm_DB.my_q_Tmp.FieldByName('usr_name').AsString);
      jvccb_eb2.Items.Add(dm_DB.my_q_Tmp.FieldByName('usr_name').AsString);
      dm_DB.my_q_Tmp.Next;
   end;
   dm_DB.my_q_Tmp.Close;
   frm_MainForm.TmpSQL(
      'select grp_id, grp_Name,  grp_name from sys_grp ' +
      ' order by grp_name');
   //statictext1.Caption:=inttostr (dm_DB.my_q_Tmp.RecordCount); // schreibt die Anzahl der Gruppen
   for iCount := 0 to (dm_DB.my_q_Tmp.RecordCount - 1) do
   begin
      jvccb_je.Items.Add(dm_DB.my_q_Tmp.FieldByName('grp_name').AsString);
      jvccb_efa.Items.Add(dm_DB.my_q_Tmp.FieldByName('grp_name').AsString);
      jvccb_je2.Items.Add(dm_DB.my_q_Tmp.FieldByName('grp_name').AsString);
      jvccb_efa2.Items.Add(dm_DB.my_q_Tmp.FieldByName('grp_name').AsString);
      dm_DB.my_q_Tmp.Next;
   end;
   dm_DB.my_q_Tmp.Close;
   // should load the wvlfav
   //  LoadDelwvl;
   tbc_favwvlChange(self);
   tbc_favwvl2Change(self);

   if frm_MainForm.TmpSQL(
      'Select Sql_No_cache * from sys_usr where flags = 1 order by usr_name') then
   begin
      try
         // igel061011
         with dm_DB.my_q_Tmp do
         begin
            gSLitemsworkers := TStringList.Create;
            for  icount := 0 to 9 do
            begin
               ljcbxtmp := TJvCheckedComboBox(frm_Optionen.FindComponent(
                  'jcbx_work' + IntToStr(icount)));
               ljcbxtmp.Clear;
               First;
               while not EOF do
               begin
                  ljcbxtmp.Items.Add(FieldByName('usr_name').AsString);
                  gSLitemsworkers.Add(FieldByName('usr_ID').AsString);
           {
          AddItem      := ljcbxtmp.Items.Add;
          AddItem.Text := FieldByName('usr_name').AsString;
          AddItem.LinkedObject :=
            TObject(FieldByName('usr_ID').AsInteger);
          AddItem.ImageIndex := 8;}
                  Next;
               end;
            end;
            dm_DB.my_q_Tmp.Close;
         end;
      except
         on e: Exception do
            ErrorMsg('ReadCbxUsr', _('Fehler beim Auslesen aller Benutzer: ') +
               e.Message, 2015, True);
      end;
   end
   else
      ErrorMsg('ReadCbxUsr', 'Fehler bei Select Sql_No_cache Anweisung!', 2002,
         True);
   // should load the wvldel
   LoadDelwvl;
   
   if pctrl_Optionen.ActivePageIndex = 8 then //[2327]
   begin
      loadvertretungsown;
   end;
end;

procedure Tfrm_Optionen.cbb_StdLgrChange(Sender: TObject);
begin
   GetArc(cbx_StdLgr, cbx_StdArc);
end;

procedure Tfrm_Optionen.cbb_Lgr_1Change(Sender: TObject);
begin
   GetArc(cbx_Lgr_1, cbx_Arc_1);
end;

procedure Tfrm_Optionen.cbb_Lgr_2Change(Sender: TObject);
begin
   GetArc(cbx_Lgr_2, cbx_Arc_2);
end;

procedure Tfrm_Optionen.cbb_Lgr_3Change(Sender: TObject);
begin
   GetArc(cbx_Lgr_3, cbx_Arc_3);
end;

procedure Tfrm_Optionen.cbb_Lgr_4Change(Sender: TObject);
begin
   GetArc(cbx_Lgr_4, cbx_Arc_4);
end;

procedure Tfrm_Optionen.cbb_Lgr_5Change(Sender: TObject);
begin
   GetArc(cbx_Lgr_5, cbx_Arc_5);
end;

procedure Tfrm_Optionen.btn_SaveClick(Sender: TObject);
begin
   WriteReg;
   SaveDelwvl;
end;

procedure Tfrm_Optionen.btn_OKClick(Sender: TObject);
begin
   WriteReg;
   SaveDelwvl;
end;

procedure Tfrm_Optionen.chk_SavLastArcLgrClick(Sender: TObject);
begin
   if chbx_SavLastArcLgr.Checked then
   begin
      cbx_StdLgr.Enabled := False;
      cbx_StdArc.Enabled := False;
   end
   else
   begin
      cbx_StdLgr.Enabled := True;
      cbx_StdArc.Enabled := True;
   end;
end;

procedure Tfrm_Optionen.cbb_SkinChange(Sender: TObject);
begin
   if cbx_Skin.Items.IndexOf(cbx_Skin.Text) <> -1 then
      dm_Themes.skinSw.Theme := cbx_Skin.Text;
end;

procedure Tfrm_Optionen.chk_UseStdPrnClick(Sender: TObject);
begin
   if cbx_UseStdPrn.Checked then
   begin
      cbx_Printers.Enabled := False;
      cbx_Printers.Text := _('Windows-Standarddrucker');
   end
   else
   begin
      cbx_Printers.Enabled := True;
      cbx_Printers.ItemIndex := 0;
   end;
end;

procedure Tfrm_Optionen.chk_ChkTasksTimerClick(Sender: TObject);
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Wiedervorlage periodisch auf neue Dokumente pruefen
// Bis auf weiteres deaktiviert aufgrund Anforderung HS vom 060728
// NG
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
begin
   cbx_ChkTasksTimer.Enabled := chbx_ChkTasksTimer.Checked;
   lbl_ChkTasksTimer.Enabled := chbx_ChkTasksTimer.Checked;
end;

procedure Tfrm_Optionen.cbb_ChkTasksTimerChange(Sender: TObject);
var
   iVal: integer;
begin
   if not TryStrToInt(cbx_ChkTasksTimer.Text, iVal) then
      cbx_ChkTasksTimer.Text := '5';
   //Igel0610131750 Wiedervorlageintervall auf 5 Minuten gesetzt
end;

procedure Tfrm_Optionen.chk_ShowRootClick(Sender: TObject);
begin
   if cbx_InvertDirection.Checked = True then
      frm_Mainform.fra_Voransicht.img_DocView.MouseWheelParams.InvertDirection := True;
   if cbx_InvertDirection.Checked = False then
      frm_Mainform.fra_Voransicht.img_DocView.MouseWheelParams.InvertDirection := False;
   //Igel0701251031 Korrekttur der mouserad umkehrfunktion zum Zoomen
end;

procedure Tfrm_Optionen.chk_SyncTimebitfarmClick(Sender: TObject);
var
   icount: integer;
   cmd, parameter, aparameter: string;
   tempstringList: TStrings;
   si: TStartupInfo;
   pi: TProcessInformation;
   //errb: longbool;
begin
   if chbx_SyncTimebitfarm.Checked then
      // Zeit Sychronisieren mit   net time \\servername /set /yes

   begin
      tempStringList := TStringList.Create;

      FillChar(si, SizeOf(si), 0);
      si.cb := SizeOf(si);
      si.dwFlags := STARTF_USESHOWWINDOW;
      si.wShowWindow := SW_hide;

      // set pi properly
      FillChar(pi, SizeOf(pi), 0);
      //err:= ShellExecute(0,nil,PChar(%systemroot%+'\system32\cmd.exe /c net time \\sv02 /set /yes'), Nil, Nil, SW_NORMAL);
      //parameter:= '/c  dir > c:\nogtest.txt';
      // parameter:= '/c /q net time \\sv02 /set /yes'; // Zur entwicklungszeit mit dem Produktiv Server synken
      //parameter:= '/c net view > '+BD.EnvTemp+'\netview.lst';
      //err:=ShellExecute(0,'open',PChar(BD.EnvSystemRoot+'\system32\cmd.exe'),PChar(parameter),nil, SW_hide);
      // showmessage (inttostr(err));
      //sleep(120);

      //iskywalker20070613 exchanged shellexecute with createprocess (from   http://www.dsdt.info/tipps/?id=456 )
      // set cmd and parameter!
      cmd := BD.EnvSystemRoot + '\system32\\cmd.exe';
      parameter := '/c net view > ' + BD.EnvTemp + '\netview.lst';
      // fill Aparameter: this string should have the cmd and parameter arguments
      AParameter := Format('"%s" %s', [cmd, TrimRight(parameter)]);
      //start create Process: no process name, cmd with parameter, ,,,,,where it should be started, si, pi
      {errb := }CreateProcess(nil, PChar(AParameter), nil, nil, longbool(False),
         CREATE_DEFAULT_ERROR_MODE or CREATE_NEW_CONSOLE or
         NORMAL_PRIORITY_CLASS, nil, PChar(BD.EnvSystemRoot + '\system32\'), si, pi);
      // wait till process is finished
      while WaitForSingleObject(pi.hProcess, 1) <> Wait_Object_0 do
      begin
         Application.ProcessMessages;
      end;
      try
         if fileexists(BD.EnvTemp + '\netview.lst') then
         begin
            tempStringList.LoadFromFile(BD.EnvTemp + '\netview.lst');
            //Datei laden

            tempStringList.Delete(0); // Zeile' Servername und beschreibung leschen
            tempStringList.Delete(0);
            // Zeile' ----------------------------------------------------------------------------------------' lschen !
            for icount := 0 to tempstringList.Count - 1 do
            begin
               if leftstr(tempStringList[icount], 2) = '\\' then
                  cb_Timeserver.Items.Add(
                     copy(tempStringList[icount], 1, pos(' ', tempStringList[icount])));
            end;
         end;
      except
      end;
   end;
end;

procedure Tfrm_Optionen.cbb_TimeserverSelect(Sender: TObject);
var
   parameter, param1: string;
   //err: integer;
begin
   param1 := cb_Timeserver.Items.Strings[cb_Timeserver.ItemIndex];
   parameter := '/c net time ' + param1 + '/set /yes';
   {err := }ShellExecute(0, 'open', PChar(BD.EnvSystemRoot + '\system32\cmd.exe'), PChar(parameter), nil, SW_hide);
   ngtimeserver := param1;
end;

procedure Tfrm_Optionen.btn_favwvlsaveClick(Sender: TObject);
var
   lini: Tinifile;
   lstaskfavnr: string;
   litimeroptionen, licounter: integer;
begin
   lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvlfav.ini');

   lstaskfavnr := 'Task' + IntToStr(tbc_favwvl.TabIndex);
   try
      try
         with lini do
         begin
            WriteString('Version', 'Version', '3.0');

{        DateTimeToString(sDatum, 'dd.mm.yyyy', StartOfTheDay(dtp_DocTime.DateTime));
        DateTimeToString(sAlarm, 'dd.mm.yyyy', StartOfTheDay(dtp_Alarm.DateTime));
 }
            litimeroptionen := 0;
            for licounter := 0 to jchb_opttim.Items.Count - 1 do
            begin
               // Nach Erledigung zurck 2
               // Erinnerungsmail senden 4
               // nicht Einzelmodusinbearbeitung 8
          {
Kein Einzelmodus in Bearbeitung}

               if jchb_opttim.IsChecked(licounter) then
               begin
                  litimeroptionen := litimeroptionen or (1 shl (licounter + 1));
               end;
            end;
            WriteInteger(lstaskfavnr, 'Optionen', litimeroptionen);
            WriteString(lstaskfavnr, 'Workersje', jvccb_je.GetText);
            WriteString(lstaskfavnr, 'Workersefa', jvccb_efa.GetText);
            WriteString(lstaskfavnr, 'Workerseb', jvccb_eb.GetText);
     {   WriteString(lstaskfavnr, 'Termin', sDatum);
        WriteString(lstaskfavnr, 'Alarm', sAlarm);}
            WriteInteger(lstaskfavnr, 'Abstand', sped_abstand.Value);
            WriteString(lstaskfavnr, 'Info', memo_Info.Text);
            frm_mainform.tbx_favwvl.Visible := true;
            frm_mainform.loadfavwvlhints;
         end;
      except
         on e: Exception do
         begin
         end;
      end;
   finally
      begin
         if Assigned(lini) then
         begin
            lini.UpdateFile;
            FreeAndNil(lini);
         end;
      end;
   end;
end;

procedure Tfrm_Optionen.tbc_favwvlChange(Sender: TObject);
var
   lini: Tinifile;
   ls, lstaskfavnr: string;
   litimeroptionen, licounter, liindex: integer;
   lstrl: TStringList;
begin
   lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvlfav.ini');
   lstaskfavnr := 'Task' + IntToStr(tbc_favwvl.TabIndex);
   try
      try
         with lini do
         begin
            litimeroptionen := 0;
            if Valueexists(lstaskfavnr, 'Optionen') then
            begin
               litimeroptionen := ReadInteger(lstaskfavnr, 'Optionen', litimeroptionen);
            end;
            for licounter := 0 to jchb_opttim.Items.Count - 1 do
            begin
               // Nach Erledigung zurck 2
               // Erinnerungsmail senden 4
               // nicht Einzelmodusinbearbeitung 8

               if ((litimeroptionen and (1 shl (licounter + 1))) =
                  (1 shl (licounter + 1))) then
               begin
                  jchb_opttim.Checked[licounter] := True;
               end
               else
               begin
                  jchb_opttim.Checked[licounter] := False;
               end;
            end;

            //3.5.0.54 [2427]
            (**)
            ls := ReadString(lstaskfavnr, 'Workersje', '');
            //3.5.0.54 ls := stringreplace(ls, ',', ' ', [rfReplaceAll]);
            lstrl := StrToWords7(ls);
            (**)
            (*
            lstrl := StrToWords(stringreplace(ReadString(lstaskfavnr,
               'Workersje', ''), ',', ' ', [rfReplaceAll]));
            *)
            lstrl := StrToWords(ls);
            jvccb_je.SetUnCheckedAll(nil);
            for licounter := 0 to lstrl.Count - 1 do
            begin
               liindex := jvccb_je.Items.IndexOf(lstrl.Strings[licounter]);
               if liindex > -1 then
               begin
                  jvccb_je.Checked[liindex] := True;
               end;
            end;
            lstrl.Free;
            
            ls := ReadString(lstaskfavnr, 'Workersefa', '');
            //3.5.0.54 [2427] ls := stringreplace(ls, ',', ' ', [rfReplaceAll]);
            lstrl := StrToWords7(ls);
            jvccb_efa.SetUnCheckedAll(nil);
            for licounter := 0 to lstrl.Count - 1 do
            begin
               liindex := jvccb_efa.Items.IndexOf(lstrl.Strings[licounter]);
               if liindex > -1 then
               begin
                  jvccb_efa.Checked[liindex] := True;
               end;
            end;
            lstrl.Free;
            
            ls := ReadString(lstaskfavnr, 'Workerseb', '');
            //3.5.0.54 [2427] ls := stringreplace(ls, ',', ' ', [rfReplaceAll]);
            lstrl := StrToWords7(ls);
            jvccb_eb.SetUnCheckedAll(nil);
            for licounter := 0 to lstrl.Count - 1 do
            begin
               liindex := jvccb_eb.Items.IndexOf(lstrl.Strings[licounter]);
               if liindex > -1 then
               begin
                  jvccb_eb.Checked[liindex] := True;
               end;
            end;
            lstrl.Free;
            
            {  sDatum := ReadString(lstaskfavnr, 'Termin', '');
              sAlarm := ReadString(lstaskfavnr, 'Alarm', '');
              if sDatum <> '' then
              begin
                dtp_DocTime.datetime := StrToDate(sdatum);
              end
              else
              begin
                dtp_DocTime.datetime := now;
              end;
              if sAlarm <> '' then
              begin
                dtp_Alarm.DateTime := StrToDate(sAlarm);
              end
              else
              begin
                dtp_Alarm.datetime := now + 14;
              end;        }
            sped_abstand.value := ReadInteger(lstaskfavnr, 'Abstand', 7);
            memo_Info.Text := ReadString(lstaskfavnr, 'Info', '');
         end;
      except
         on e: Exception do
         begin
         end;
      end;
   finally
      begin
         if Assigned(lini) then
         begin
            lini.UpdateFile;
            FreeAndNil(lini);
         end;
      end;
   end;
end;


procedure Tfrm_Optionen.SaveDelwvl;
var
   lini: Tinifile;
   lsworkeridlist: string;
   licounter, licounter1: integer;
   lmtmp: TMEMO;
   ljcbxtmp: TJvCheckedComboBox;
begin
   lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvldelfav.ini');
   try
      try
         with lini do
         begin
            WriteString('Version', 'Version', '3.0');
            lsworkeridlist := '';
            for  licounter := 0 to 9 do
            begin
               lsworkeridlist := '';
               ljcbxtmp := TJvCheckedComboBox(FindComponent('jcbx_work' +
                  IntToStr(licounter)));
               for licounter1 := 0 to ljcbxtmp.Items.Count - 1 do
               begin
                  // Nach Erledigung zurck 2
                  // Erinnerungsmail senden 4
                  // nicht Einzelmodusinbearbeitung 8

                  if ljcbxtmp.IsChecked(licounter1) then
                  begin
                     lsworkeridlist :=
                        gSLitemsworkers.Strings[licounter1] + ',' + lsworkeridlist;
                  end;
                  //             label2.Caption:= label2.Caption+' '+JvCheckedComboBox1.Items.Strings[licounter];
               end;

               if lsworkeridlist = '' then
               begin
                  lsworkeridlist := '-1';
               end;
               WriteString('Task' + IntToStr(licounter), 'Workerid', lsworkeridlist);


               lmtmp := TMEMO(FindComponent('memo_infodelwvl' + IntToStr(licounter)));
               WriteString('Task' + IntToStr(licounter), 'Info', lmtmp.Text);
            end;
         end;
      except
         on e: Exception do
         begin
         end;
      end;
   finally
      begin
         if Assigned(lini) then
         begin
            lini.UpdateFile;
            FreeAndNil(lini);
         end;
      end;
   end;
   frm_mainform.loadfavdelwvlhints;
end;

procedure Tfrm_Optionen.LoadDelwvl;
var
   lini: Tinifile;
   licounter, liindex, licounter1: integer;
   lstrl: TStringList;
   lmtmp: TMEMO;
   ljcbxtmp: TJvCheckedComboBox;
begin
   lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvldelfav.ini');
   try
      try
         with lini do
         begin
            for  licounter := 0 to 9 do
            begin
               //  liindex:= Readinteger('Task'+inttostr(licounter), 'Workerid',-1);
               if assigned(lstrl) then
                  FreeAndNil(lstrl);
               lstrl := StrToWords7(
                  stringreplace(ReadString('Task' + IntToStr(licounter), 'Workerid', ''),
                  ',', ' ', [rfReplaceAll]));
               ljcbxtmp := TJvCheckedComboBox(FindComponent('jcbx_work' +
                  IntToStr(licounter)));
               for licounter1 := 0 to lstrl.Count - 1 do
               begin
                  // Nach Erledigung zurck 2
                  // Erinnerungsmail senden 4
                  // nicht Einzelmodusinbearbeitung 8

                  liindex := gSLitemsworkers.IndexOf(lstrl.strings[licounter1]);
                  if liindex > -1 then
                  begin
                     //            lsworkeridlist:=  gSLitemsworkers.Strings[licounter1]+','+lsworkeridlist;
                     ljcbxtmp.Checked[liindex] := True;
                  end;
                  //             label2.Caption:= label2.Caption+' '+JvCheckedComboBox1.Items.Strings[licounter];
               end;

{  if liindex = -1 then
  begin
    ljbicmbx.ItemIndex:= -1;
  end
  else
  begin
  ljbicmbx.ItemIndex:= ljbicmbx.Items.IndexOfLinkedObject(tobject(liindex));
  end;}
               lmtmp := TMEMO(FindComponent('memo_infodelwvl' + IntToStr(licounter)));
               lmtmp.Text := ReadString('Task' + IntToStr(licounter), 'Info', '');
            end;
         end;
      except
         on e: Exception do
         begin
         end;
      end;
   finally
      begin
         if Assigned(lini) then
         begin
            lini.UpdateFile;
            FreeAndNil(lini);
            if assigned(lstrl) then
               FreeAndNil(lstrl);
         end;
      end;
   end;
end;


procedure Tfrm_Optionen.chk_anpassenvisibleClick(Sender: TObject);
begin
   //      frm_mainform.fms_MainForm.readstring('tlb_ViewerCtrl_Visible','')
   case pc_anpassen.ActivePageIndex of
      0:
      begin
         frm_mainform.tlb_ViewerCtrl.visible := cbx_anpassenvisible.Checked;
      end;
      1:
      begin
         frm_mainform.tlb_Zoom2.visible := cbx_anpassenvisible.Checked;
      end;
      2:
      begin
         frm_mainform.tbxt_stempel.visible := cbx_anpassenvisible.Checked;
      end;
      3:
      begin
         frm_mainform.tbx_favwvl.visible := cbx_anpassenvisible.Checked;
      end;
      4:
      begin
         frm_mainform.tlb_favoriten.visible := cbx_anpassenvisible.Checked;
      end;
      5:
      begin
         frm_mainform.tlb_lager.visible := cbx_anpassenvisible.Checked;
      end;
      6:
      begin
         frm_mainform.tlb_status.visible := cbx_anpassenvisible.Checked;
      end;
      7:
      begin
         frm_mainform.tbxt_export.Visible := cbx_anpassenvisible.Checked;
      end;
      8:
      begin
         frm_mainform.tbxt_werkzeuge.Visible := cbx_anpassenvisible.Checked;
      end;
   end;
end;

procedure Tfrm_Optionen.pgc_anpassenChange(Sender: TObject);
begin
   case pc_anpassen.ActivePageIndex of
      0:
      begin
         cbx_anpassenvisible.Checked := frm_mainform.tlb_ViewerCtrl.visible;
      end;
      1:
      begin
         cbx_anpassenvisible.Checked := frm_mainform.tlb_Zoom2.visible;
      end;
      2:
      begin
         cbx_anpassenvisible.Checked := frm_mainform.tbxt_stempel.visible;
      end;
      3:
      begin
         cbx_anpassenvisible.Checked := frm_mainform.tbx_favwvl.visible;
      end;
      4:
      begin
         cbx_anpassenvisible.Checked := frm_mainform.tlb_favoriten.visible;
      end;
      5:
      begin
         cbx_anpassenvisible.Checked := frm_mainform.tlb_lager.visible;
      end;
      6:
      begin
         cbx_anpassenvisible.Checked := frm_mainform.tlb_status.visible;
      end;
      7:
      begin
         cbx_anpassenvisible.Checked := frm_mainform.tbxt_export.Visible;
      end;
      8:
      begin
         cbx_anpassenvisible.Checked := frm_mainform.tbxt_werkzeuge.Visible;
      end;
   end;
end;

procedure Tfrm_Optionen.btn_wvlwltsaveClick(Sender: TObject);
var
   lini: Tinifile;
   lstaskfavnr: string;
   litimeroptionen, licounter: integer;
begin
   if ((jvccb_efa2.CheckedCount + jvccb_je2.CheckedCount) > 1) then
   begin
      showmessage(_('Nur ein Adressat(Gruppe) fr Wiedervorlage/Aufgaben-Weiterleitung mglich.'));
      exit;
   end;
   // this is so, cause else the  redirect would be a multiplication odf the one
   // wvl (miracle)
   if jchb_opttim2.ischecked(0) and (jvccb_eb2.CheckedCount > 1) then
   begin
      showmessage(_('Nur ein Adressat(Benutzer) fr Wiedervorlage/Aufgaben-Weiterleitung') +
         #13 +
         _('mit "Nach Erledigung zurck" mglich.'));
      exit;
   end;
   lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvlwlt.ini');
   lstaskfavnr := 'Task' + IntToStr(tbc_favwvl2.TabIndex);
   try
      try
         with lini do
         begin
            WriteString('Version', 'Version', '3.0');

{        DateTimeToString(sDatum, 'dd.mm.yyyy', StartOfTheDay(dtp_DocTime.DateTime));
        DateTimeToString(sAlarm, 'dd.mm.yyyy', StartOfTheDay(dtp_Alarm.DateTime));
 }
            litimeroptionen := 0;
            for licounter := 0 to jchb_opttim2.Items.Count - 1 do
            begin
               // Nach Erledigung zurck 2
               // Erinnerungsmail senden 4
               // nicht Einzelmodusinbearbeitung 8

               if jchb_opttim2.IsChecked(licounter) then
               begin
                  litimeroptionen := litimeroptionen or (1 shl (licounter + 1));
               end;
            end;
            WriteInteger(lstaskfavnr, 'Optionen', litimeroptionen);
            WriteString(lstaskfavnr, 'Workersje', jvccb_je2.GetText);
            WriteString(lstaskfavnr, 'Workersefa', jvccb_efa2.GetText);
            WriteString(lstaskfavnr, 'Workerseb', jvccb_eb2.GetText);
     {   WriteString(lstaskfavnr, 'Termin', sDatum);
        WriteString(lstaskfavnr, 'Alarm', sAlarm);}
            WriteInteger(lstaskfavnr, 'Abstand', sped_abstand2.Value);
            WriteString(lstaskfavnr, 'Info', memo_Info2.Text);
            frm_mainform.loadfavwvlhints;
         end;
      except
         on e: Exception do
         begin
         end;
      end;
   finally
      begin
         if Assigned(lini) then
         begin
            lini.UpdateFile;
            FreeAndNil(lini);
         end;
      end;
   end;
end;

procedure Tfrm_Optionen.tbc_favwvl2Change(Sender: TObject);

var
   lini: Tinifile;
   ls, lstaskfavnr: string;
   litimeroptionen, licounter, liindex: integer;
   lstrl: TStringList;
begin
   lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvlwlt.ini');
   lstaskfavnr := 'Task' + IntToStr(tbc_favwvl2.TabIndex);
   try
      try
         with lini do
         begin
            litimeroptionen := 0;
            if Valueexists(lstaskfavnr, 'Optionen') then
            begin
               litimeroptionen := ReadInteger(lstaskfavnr, 'Optionen', litimeroptionen);
            end;
            for licounter := 0 to jchb_opttim2.Items.Count - 1 do
            begin
               // Nach Erledigung zurck 2
               // Erinnerungsmail senden 4
               // nicht Einzelmodusinbearbeitung 8
               if ((litimeroptionen and (1 shl (licounter + 1))) =
                  (1 shl (licounter + 1))) then
               begin
                  jchb_opttim2.Checked[licounter] := True;
               end
               else
               begin
                  jchb_opttim2.Checked[licounter] := False;
               end;
            end;
            
            ls := ReadString(lstaskfavnr, 'Workersje', '');
            ls := stringreplace(ls, ',', ' ', [rfReplaceAll]);
            lstrl := StrToWords7(ls);
            jvccb_je2.SetUnCheckedAll(nil);
            for licounter := 0 to lstrl.Count - 1 do
            begin
               liindex := jvccb_je2.Items.IndexOf(lstrl.Strings[licounter]);
               if liindex > -1 then
               begin
                  jvccb_je2.Checked[liindex] := True;
               end;
            end;
            lstrl.Free;

            ls := ReadString(lstaskfavnr, 'Workersefa', '');
            ls := stringreplace(ls, ',', ' ', [rfReplaceAll]);
            lstrl := StrToWords7(ls);
            jvccb_efa2.SetUnCheckedAll(nil);
            for licounter := 0 to lstrl.Count - 1 do
            begin
               liindex := jvccb_efa2.Items.IndexOf(lstrl.Strings[licounter]);
               if liindex > -1 then
               begin
                  jvccb_efa2.Checked[liindex] := True;
               end;
            end;
            lstrl.Free;

            ls := ReadString(lstaskfavnr, 'Workerseb', '');
            ls := stringreplace(ls, ',', ' ', [rfReplaceAll]);
            lstrl := StrToWords7(ls);
            jvccb_eb2.SetUnCheckedAll(nil);
            for licounter := 0 to lstrl.Count - 1 do
            begin
               liindex := jvccb_eb2.Items.IndexOf(lstrl.Strings[licounter]);
               if liindex > -1 then
               begin
                  jvccb_eb2.Checked[liindex] := True;
               end;
            end;
            lstrl.Free;
            
            {  sDatum := ReadString(lstaskfavnr, 'Termin', '');
              sAlarm := ReadString(lstaskfavnr, 'Alarm', '');
              if sDatum <> '' then
              begin
                dtp_DocTime.datetime := StrToDate(sdatum);
              end
              else
              begin
                dtp_DocTime.datetime := now;
              end;
              if sAlarm <> '' then
              begin
                dtp_Alarm.DateTime := StrToDate(sAlarm);
              end
              else
              begin
                dtp_Alarm.datetime := now + 14;
              end;        }
            sped_abstand2.value := ReadInteger(lstaskfavnr, 'Abstand', 7);
            memo_Info2.Text := ReadString(lstaskfavnr, 'Info', '');
         end;
      except
         on e: Exception do
         begin
         end;
      end;
   finally
      begin
         if Assigned(lini) then
         begin
            lini.UpdateFile;
            FreeAndNil(lini);
         end;
      end;
   end;
end;


procedure Tfrm_Optionen.btn_wvldelimpClick(Sender: TObject);
var
   litimeroptionen, licounter, liindex, licounter1: integer;
   lstrl: TStringList;
   lmtmp: TMEMO;
   ljcbxtmp: TJvCheckedComboBox;
   lini, lini1: Tinifile;
   lstaskfavnr: string;
begin
   if not fileexists(BD.AppdataBitfarmPd + 'wvldelfav.ini') then
      exit;
   try
      lmtmp := Tmemo.Create(nil);
      lini1 := tinifile.Create(BD.AppdataBitfarmPd + 'wvlwlt.ini');
      lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvldelfav.ini');

      try
         lini1.WriteString('Version', 'Version', '3.0');
         with lini do
         begin
            for  licounter := 0 to 9 do
            begin
               lstaskfavnr := 'Task' + IntToStr(licounter);
               //  liindex:= Readinteger('Task'+inttostr(licounter), 'Workerid',-1);
               lstrl := StrToWordswvl(
                  stringreplace(ReadString('Task' + IntToStr(licounter), 'Workerid', ''),
                  ',', ' ', [rfReplaceAll]));
               ljcbxtmp := TJvCheckedComboBox(FindComponent('jcbx_work' +
                  IntToStr(licounter)));
               jvccb_eb2.SetUnCheckedAll(nil);
               for licounter1 := 0 to lstrl.Count - 1 do
               begin
                  // Nach Erledigung zurck 2
                  // Erinnerungsmail senden 4
                  // nicht Einzelmodusinbearbeitung 8

                  liindex := gSLitemsworkers.IndexOf(lstrl.strings[licounter1]);
                  if liindex > -1 then
                  begin
                     //            lsworkeridlist:=  gSLitemsworkers.Strings[licounter1]+','+lsworkeridlist;
                     //ljcbxtmp.Checked[liindex] := True;
                     jvccb_eb2.checked[jvccb_eb2.Items.IndexOf(ljcbxtmp.Items.Strings[liindex])] := true;
                  end;
                  //             label2.Caption:= label2.Caption+' '+JvCheckedComboBox1.Items.Strings[licounter];
               end;

{  if liindex = -1 then
  begin
    ljbicmbx.ItemIndex:= -1;
  end
  else
  begin
  ljbicmbx.ItemIndex:= ljbicmbx.Items.IndexOfLinkedObject(tobject(liindex));
  end;}
               lmtmp.Text := ReadString(lstaskfavnr, 'Info', '');
               if trim(jvccb_eb2.GetText) <> '' then
               begin
                  with lini1 do
                  begin
                     litimeroptionen := 0;
                     WriteInteger(lstaskfavnr, 'Optionen', litimeroptionen);
                     WriteString(lstaskfavnr, 'Workersje', '');
                     WriteString(lstaskfavnr, 'Workersefa', '');
                     WriteString(lstaskfavnr, 'Workerseb', jvccb_eb2.GetText);
     {   WriteString(lstaskfavnr, 'Termin', sDatum);
        WriteString(lstaskfavnr, 'Alarm', sAlarm);}
                     WriteInteger(lstaskfavnr, 'Abstand', 7);
                     WriteString(lstaskfavnr, 'Info', lmtmp.Text);
                  end;
               end;
            end;
         end;
      except
         on e: Exception do
         begin
         end;
      end;
   finally
      begin
         if Assigned(lini) then
         begin
            lini.UpdateFile;
            FreeAndNil(lini);
            if assigned(lstrl) then
               FreeAndNil(lstrl);
         end;
         if Assigned(lini1) then
         begin
            lini1.UpdateFile;
            FreeAndNil(lini1);
            tbc_favwvl2Change(self);
            frm_mainform.loadfavwvlhints;
         end;
         if Assigned(lmtmp) then
         begin
            FreeAndNil(lmtmp);
         end;
      end;
   end;
end;


procedure Tfrm_Optionen.btn_searchstddirClick(Sender: TObject);
var
   dir: string;
begin
   dir := edt_stsdir.Text;
   if not NogSelectDirectory(_('Bitte whlen Sie ein Verzeichnis'),
      '\',
      dir, False, False, True) then
   begin
      exit;
   end;
   edt_stsdir.Text := dir;
end;

procedure Tfrm_Optionen.btn_hotkeysaveClick(Sender: TObject);
var
   reg: TRegistry;
   ls: string;
begin
   reg := TRegistry.Create;
   with reg do
   begin
      try
         try
            RootKey := HKEY_CURRENT_USER;
            // berprfen der Options-Einstellungen
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            ls := '';
            if tbc_hotsearch.TabIndex > 0 then
            begin
               ls := inttostr(tbc_hotsearch.TabIndex - 1);
            end;

            WriteInteger('HotsearchHK' + ls, JvHk_hotsearch.Hotkey);
            CloseKey;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen\Hotsearch', True);

            WriteString('StdLgr' + ls, cbx_hotsearchlgr.Text);
            WriteString('StdArc' + ls, cbx_hotsearcharc.Text);
            CloseKey;
         except
            on e: Exception do
            begin
               ErrorMsg('frm_Optionen.WriteReg', _('Fehler beim Speichern der Registrierung: ') +
                  e.Message, 2030, True);
            end;
         end;
      finally
         if Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;

procedure Tfrm_Optionen.tbc_hotsearchChange(Sender: TObject);
var
   reg, reg1: TRegistry;
   ls: string;
begin
   reg := TRegistry.Create;
   reg1 := TRegistry.Create;
   reg1.rootkey := HKEY_CURRENT_USER;
   with reg do
   begin
      try
         try
            RootKey := HKEY_CURRENT_USER;
            JvHk_hotsearch.Hotkey := 0;
            // berprfen der Options-Einstellungen
            if OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', False) then
            begin
               ls := '';
               if tbc_hotsearch.TabIndex > 0 then
               begin
                  ls := inttostr(tbc_hotsearch.TabIndex - 1);
               end;
               if valueexists('HotsearchHK' + ls) then
                  JvHk_hotsearch.Hotkey := ReadInteger('HotsearchHK' + ls);
               CloseKey;
               if OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen\Hotsearch', False) then
               begin
                  reg1.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen\', false);
                  if reg1.valueexists('HotsearchHK' + ls) then
                     cbx_hotsearchlgr.Text := ReadString('StdLgr' + ls)
                  else
                     cbx_hotsearchlgr.Text := '';
                  if reg1.valueexists('HotsearchHK' + ls) then
                     cbx_hotsearcharc.Text := ReadString('StdArc' + ls)
                  else
                     cbx_hotsearcharc.Text := '';
                  reg1.closekey;
                  CloseKey;
               end
               else
               begin
                  cbx_hotsearchlgr.Text := '';
                  cbx_hotsearcharc.Text := '';
               end;
            end
            else
            begin
            end;
         except
            on e: Exception do
            begin
               ErrorMsg('frm_Optionen.WriteReg', _('Fehler beim Speichern der Registrierung: ') +
                  e.Message, 2030, True);
            end;
         end;
      finally
         if Assigned(reg) then
            FreeAndNil(reg);
         if Assigned(reg1) then
            FreeAndNil(reg1);
      end;
   end;
end;


procedure Tfrm_Optionen.pgc_OptionenChange(Sender: TObject); //[2327]
begin
   if pctrl_Optionen.ActivePageIndex = 7 then
   begin
      tbc_hotsearchChange(sender);
   end;
   if pctrl_Optionen.ActivePageIndex = 8 then
   begin
      loadvertretungsown;
   end;
end;

procedure Tfrm_Optionen.cbb_hotsearchlgrChange(Sender: TObject);
begin
   GetArc(cbx_hotsearchlgr, cbx_hotsearcharc);
end;

procedure Tfrm_Optionen.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

//-----------------------------------------------------------------------------
procedure Tfrm_Optionen.loadvertretungsown;
var
   myitem: Tlistitem;
begin
   with dm_db do
   begin
      my_q_vertretungava.sql.Text := 'select * from sys_usr as u left join sys_holyday as s on(u.usr_id=s.usr_id_src)' +
         //' where  flags = 1 and ' +
         ' where (find_in_set("enabled",Flags)>0) and ' + //3.5.0.74 [2522]

{ not (u.usr_id in (select usr_id_dst from sys_holyday where usr_id_src='+
inttostr(integer(iGUsrid))+
')) and '+}
         '(u.usr_id <> ' + inttostr(iGUsrid) + ')' +
         //' group by u.usr_id';
         ' group by u.usr_id order by u.usr_name'; //[ 2319 ] Vertreter sollten alphabetisch sortiert sein
      try
         my_q_vertretungava.execute;
      except on e: exception do
         begin
         end;
      end;
      lv_vertretungava.Items.Clear;
      lv_vertretungava.clear;
      while not my_q_vertretungava.eof do
      begin
         //todo: check for superior of superior
         myitem := lv_vertretungava.Items.Add;
         myitem.Caption := my_q_vertretungava.FieldByName('usr_name').AsString;
         myitem.ImageIndex := 8;
         my_q_vertretungava.Next;
      end;

      my_q_vertretung.sql.Text := 'select * from sys_usr as u left join sys_holyday as s on(u.usr_id=s.usr_id_dst)' +
         //' where flags = 1 and usr_id_src = ' + inttostr(iGUsrid) +
         ' where (find_in_set("enabled",Flags)>0) and usr_id_src = ' + inttostr(iGUsrid) + //3.5.0.74 [2522]
         ' and (not isnull(usr_id_dst)) ';
      try
         my_q_vertretung.execute;
      except on e: exception do
         begin
         end;
      end;
      lv_vertretung.Items.Clear;
      lv_vertretung.clear;
      while not my_q_vertretung.eof do
      begin
         with lv_vertretung.Items.Add do
         begin
            Caption := my_q_vertretung.FieldByName('usr_name').AsString;
            subitems.Add(my_q_vertretung.FieldByName('start').AsString);
            subitems.Add(my_q_vertretung.FieldByName('end').AsString);
            subitems.Add(my_q_vertretung.FieldByName('hol_id').AsString);
            ImageIndex := 8;
         end;

         my_q_vertretung.Next;
      end;
   end;
   VertretungSetEnabled(nil);
end;

//-----------------------------------------------------------------------------
procedure Tfrm_Optionen.btn_addvertretungClick(Sender: TObject);
var
   lid: string;
   lbfound: boolean;
begin
   //jvde_startvertretung.CheckValidDate
   if lv_vertretungava.Selected = nil then
   begin
      exit;
   end;
   if (frm_mainform.fdatestringempty = jvde_endvertretung.text) or
      (
      frm_mainform.fdatestringempty = jvde_startvertretung.text) then
   begin
      exit;
   end;
   lbfound := false;
   with dm_db do
   begin
      my_q_vertretungava.first;
      while not my_q_vertretungava.eof do
      begin
         if lv_vertretungava.Selected.Caption =
            my_q_vertretungava.FieldByName('usr_name').AsString then
         begin
            lbfound := true;
            lid := my_q_vertretungava.FieldByName('usr_id').AsString;
            break;
         end;
         my_q_vertretungava.Next;
      end;
      if lbfound then
      begin
         if my_q_vertretung.recordcount = 0 then
         begin
 {try
      dm_MainForm2.my_Cmd.sql.text := 'insert into sys_superior (usr_id_src, usr_id_dst,start, end) Values (' +
      inttostr(integer(jvii_urlauber.Items.Items[jvii_urlauber.itemindex].linkedobject))+','+
      ')';
      dm_MainForm2.my_Cmd.Execute;
    except
      on e: exception do ErrorMsg('spb_addvertretungClick', 'Fehler beim Hinzufgen eines Benutzers in eine Gruppe: ' + e.Message, 1002, True);
    end;     }
         end;
         if not checkforholydayloops(integer(igusrid), my_q_vertretungava.FieldByName('usr_id').asinteger,
            jvde_startvertretung.date, jvde_endvertretung.date + 0.999999) then
         begin
            showmessage('Konflikt mit einer anderen Vertretungszuweisung!');
            exit;
         end;
         try
            dm_db.my_Cmd.sql.text := 'insert into sys_holyday (usr_id_src, usr_id_dst,start, end) Values (' +
               inttostr(integer(igusrid)) +
               ', ' + lid + ',:start,:end)';
            dm_db.my_Cmd.ParamByName('start').AsDateTime := jvde_startvertretung.date;
            dm_db.my_Cmd.ParamByName('end').AsDateTime := jvde_endvertretung.date + 0.999999;
            dm_db.my_Cmd.Execute;
         except
            on e: exception do
               ErrorMsg('spb_addvertretungClick', 'Fehler beim Hinzufgen eines Benutzers in eine Gruppe: ' + e.Message, 1002, True);
         end;
      end;
      loadvertretungsown;
   end;
end;


//-----------------------------------------------------------------------------
function Tfrm_Optionen.checkforholydayloops(liusridsrc, ldusriddst: integer; ldstart, ldend: Tdatetime): boolean;
var lmy_q: TMyQuery;
begin
   result := true;
   try
      lmy_q := TMyQuery.Create(nil);
      lmy_q.Connection := dm_db.my_Con;
      lmy_q.sql.text := 'select * from sys_holyday where usr_id_src = ' + inttostr(ldusriddst) +
         ' and ((:mend between start and end)  or (:mstart between start and end) or ' +
         '(end between :mstart and :mend) or (start between :mstart and :mend))';
      lmy_q.ParamByName('mstart').AsDateTime := ldstart;
      lmy_q.ParamByName('mend').AsDateTime := ldend;
      try
         lmy_q.Execute;
      except on e: exception
            do
         begin
            result := false;
         end;
      end;
      if lmy_q.RecordCount > 0 then
      begin
         while not lmy_q.Eof do
         begin
            if lmy_q.fieldbyname('usr_id_dst').AsInteger = liusridsrc then
            begin
               result := false;
               break;
            end;
            if not checkforholydayloops(liusridsrc, lmy_q.fieldbyname('usr_id_dst').AsInteger, ldstart, ldend) then
            begin
               result := false;
               break;
            end;
            lmy_q.next;
         end;
      end;
   finally
      if assigned(lmy_q) then
         freeandnil(lmy_q);
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfrm_Optionen.btn_removevertretungClick(Sender: TObject);
var
   lbfound: boolean;
   lid: string;
begin
   if lv_vertretung.Selected = nil then
   begin
      exit;
   end;

   lbfound := false;
   with dm_db do
   begin
      my_q_tmp.sql.text := 'select * from sys_usr';
      my_q_tmp.execute;
      my_q_tmp.first;
      while not my_q_tmp.eof do
      begin
         if lv_vertretung.Selected.Caption =
            my_q_tmp.FieldByName('usr_name').AsString then
         begin
            lbfound := true;
            lid := my_q_tmp.FieldByName('usr_id').AsString;
            break;
         end;
         my_q_tmp.Next;
      end;
      if lbfound then
      begin
         if my_q_vertretung.recordcount = 0 then
         begin
             {try
              dm_MainForm2.my_Cmd.sql.text := 'insert into sys_superior (usr_id_src, usr_id_dst,start, end) Values (' +
              inttostr(integer(jvii_urlauber.Items.Items[jvii_urlauber.itemindex].linkedobject))+','+
              ')';
              dm_MainForm2.my_Cmd.Execute;
            except
              on e: exception do ErrorMsg('spb_addvertretungClick', 'Fehler beim Hinzufgen eines Benutzers in eine Gruppe: ' + e.Message, 1002, True);
            end;     }
         end;
         try

            dm_db.my_Cmd.sql.text := 'delete from sys_holyday where usr_id_src = ' +
               inttostr(integer(igusrid)) +
               ' and usr_id_dst = ' + lid + ' and hol_id = :holid';
            dm_db.my_Cmd.ParamByName('holid').Asstring := lv_vertretung.Selected.SubItems[2];
            dm_db.my_Cmd.Execute;
         except
            on e: exception do
               ErrorMsg('spb_addvertretungClick', 'Fehler beim Hinzufgen eines Benutzers in eine Gruppe: ' + e.Message, 1002, True);
         end;
      end;
      loadvertretungsown;
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfrm_Optionen.edt_vertavaChange(Sender: TObject); //[2327]
var lsUsername: string;  lbDazu: Boolean;
begin
   lv_vertretungava.Clear;
   lv_vertretungava.Items.Clear;
   dm_db.my_q_vertretungava.first;
   while not dm_db.my_q_vertretungava.Eof do
   begin
      lsUsername := dm_db.my_q_vertretungava.FieldByName('usr_name').AsString;
      lbDazu := true;
      if (edt_vertava.text <> '') then
      begin
         if pos(lowercase(edt_vertava.text), lowercase(lsUsername)) = 0 then
            lbDazu := False;
      end;
      if lbDazu then
         with lv_vertretungava.Items.Add do
         begin
            caption := lsUsername;
            ImageIndex := 8;
         end;
      dm_db.my_q_vertretungava.Next;
   end;
   VertretungSetEnabled(nil);
end;

//-----------------------------------------------------------------------------
procedure Tfrm_Optionen.edt_vertreChange(Sender: TObject); //[2327]
var lsUsername: string;  lbDazu: Boolean;
begin
   lv_vertretung.Items.Clear;
   lv_vertretung.clear;
   dm_db.my_q_vertretung.first;
   while not dm_db.my_q_vertretung.eof do
   begin
      lsUsername := dm_db.my_q_vertretung.FieldByName('usr_name').AsString;
      lbDazu := true;
      if edt_vertre.text <> '' then
      begin
         if pos(lowercase(edt_vertre.text), lowercase(lsUsername)) = 0 then
            lbDazu := false;
      end;
      if lbDazu then
         with lv_vertretung.Items.Add do
         begin
            Caption := lsUsername;
            subitems.Add(dm_db.my_q_vertretung.FieldByName('start').AsString);
            subitems.Add(dm_db.my_q_vertretung.FieldByName('end').AsString);
            subitems.Add(dm_db.my_q_vertretung.FieldByName('hol_id').AsString);
            ImageIndex := 8;
         end;
      dm_db.my_q_vertretung.Next;
   end;
   VertretungSetEnabled(nil);
end;

//-----------------------------------------------------------------------------
procedure Tfrm_Optionen.VertretungSetEnabled(Sender: TObject);
begin
   spb_addvertretung.Enabled := lv_vertretungava.Selected <> nil;
   spb_removevertretung.Enabled := lv_vertretung.Selected <> nil;
end;

//-----------------------------------------------------------------------------


end.
