unit u_ShowLayer;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, Buttons, ComCtrls, Grids, DBGrids, CRGrid, gnugettext,
   u_ShLowUtils;

type
   Tfrm_ShowLayer = class (TForm)
      Panel1: TPanel;
      lbl_layer01: TLabel;
      lbl_LayerName: TLabel;
      sbtn_PrivatLayer: TSpeedButton;
      sbtn_OpenLayer: TSpeedButton;
      sbtn_UserLayer: TSpeedButton;
      lb_usranno: TListBox;
      lv_usrAnno: TListView;
      lbl_uid: TLabel;
      Label1: TLabel;
      Label2: TLabel;
      procedure btn_PrivatLayerClick(Sender: TObject);
      procedure btn_openlayerClick(Sender: TObject);
      procedure Button3Click(Sender: TObject);
      procedure sbtn_PrivatLayerClick(Sender: TObject);
      procedure sbtn_OpenLayerClick(Sender: TObject);
      procedure sbtn_UserLayerClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure lb_usrannoClick(Sender: TObject);
      procedure lb_usrannoDblClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);

   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_ShowLayer: Tfrm_ShowLayer;

implementation

uses u_DocEditor, u_dm_DB, u_MainForm;

{$R *.dfm}

procedure Tfrm_ShowLayer.btn_PrivatLayerClick(Sender: TObject);
begin
   lbl_layername.Caption := _('privat Layer');
end;

procedure Tfrm_ShowLayer.btn_openlayerClick(Sender: TObject);
begin
   lbl_layername.Caption := _('offener Layer');
end;

procedure Tfrm_ShowLayer.Button3Click(Sender: TObject);
begin
   lbl_layerName.Caption := _('Benutzerlayer von Norbert');
end;

procedure Tfrm_ShowLayer.sbtn_PrivatLayerClick(Sender: TObject);
begin
   lbl_layername.Caption := _('privat');
   frm_DocEdit.LoadDoc(0);
end;

procedure Tfrm_ShowLayer.sbtn_OpenLayerClick(Sender: TObject);
begin
   lbl_layername.Caption := _('ffentlich');

   //Tfrm_DocEdit.tbsi_topenLayer.checked:= true;
end;

procedure Tfrm_ShowLayer.sbtn_UserLayerClick(Sender: TObject);
begin
   // lbl_layername.caption:= lb_usrAnno.Items.Strings[lb_usrAnno.;
   //lbl_layername.caption:=lv_usrAnno.Items
   /// lv_UsrMail.Items[x].SubItems.Text)
   // aItem:=lv_usrAnno.Selected;

   //lbl_layername:= lbl_layername + aitem.items.subitems.strings[0];
   frm_DocEdit.lbl_UsrAnno.Caption := lbl_uid.Caption;
   frm_MainForm.tbx_privNote.Hint :=
      _('Zeige private Anmerkung von User') + ' ' + lbl_LayerName.Caption + ' ';
   frm_showLayer.Close;
end;

procedure Tfrm_ShowLayer.FormShow(Sender: TObject);
var
   ngSql: string;
begin
   //sbtn_privatLayer. down :=true;
   label1.Caption := IntToStr(igArcID);
   label2.Caption := IntToStr(igDocID);

   // if frm_MainForm.TmpSQL('select usr_name, Usr_id from sys_usr where Usr_name not like '+#39+'DEL\_%'+#39+'order by usr_Name') then

   ngSql := 'select doc_id, usr_name, src_usr_ID, sys_docxs.usr_id, rights ' +
      'from sys_usr left join sys_docxs ' +
      'on (sys_usr.usr_id = sys_docxs.src_usr_id )' + 'where sys_docxs.doc_id =' +
      #39 + IntToStr(igDocID) + #39 + ' and sys_docxs.usr_id = ' + #39 +
      IntToStr(iGUsrID) + #39 + ' and sys_docxs.Rights like ' + #39 +
      '%ap%' + #39 + ' order by usr_Name';


   if frm_MainForm.TmpSQL('select doc_id, usr_name, src_usr_ID, sys_docxs.usr_id, rights '
      + 'from sys_usr left join sys_docxs ' +
      'on (sys_usr.usr_id = sys_docxs.src_usr_id )' + 'where sys_docxs.doc_id =' +
      #39 + IntToStr(igDocID) + #39 + ' and sys_docxs.usr_id = ' + #39 +
      IntToStr(iGUsrID) + #39 + ' and sys_docxs.Rights like ' + #39 +
      '%ap%' + #39 + ' order by usr_Name') then

      // MySQL Browser query

      // select src_usr_ID, rights, usr_name ,rigths
      // from sys_usr inner join sys_docxs
      // on ( sys_usr.usr_id = sys_docxs.usr_id)
      // where doc_id = 136 and sys_docxs.usr_id = 8


      // erzeugt die folgenden Auswahlmenge

      // .. ansatz
      // doc_id  usr_name                src_usr_id    usr_id    rights
      //    136  n.gering                13             8        list, ... ,apread, apmodify
      //    136  n.gering                10             8        list, ... ,apread
      //    136  n.gering                12             8        list, ... ,apread, apmodify


      // frm_MainForm.TmpSQL('select usr_name, Usr_id from sys_usr where Usr_name not like ' + #39 + 'DEL\_%' + #39 + 'order by usr_Name') then
      with dm_DB.my_q_Tmp do
      begin
         // Damit auf die eigene Annotation (privat) zurueckgeschaltet werden kann, wird hier der aktuell angemeldete User aufgefuehrt
         lb_usrAnno.Items.Clear;
         lbl_uid.Caption := IntToStr(iGUsrID);
         with lv_UsrAnno.Items.Add do
         begin
            lb_usrAnno.Items.Add(sGUsrName);
            ImageIndex := 40;
            Caption := sGUsrName;
            SubItems.Text := IntToStr(iGUsrID);
         end;
         // ende des eigenen user in Listbox chreiben
         while not EOF do
         begin
            try
               //ImageIndex := 40;
               lb_usrAnno.Items.Add(FieldByName('Usr_Name').AsString);

               with lv_UsrAnno.Items.Add do
               begin
                  ImageIndex := 40;
                  Caption := FieldByName('Usr_Name').AsString;
                  SubItems.Text := FieldByName('Usr_ID').AsString;
               end;
               Next;
            except
               on e: Exception do
               begin
                  ErrorMsg('User wurde entwertet',
                     _('Fehler beim Einlesen eines Benutzers: ') +
                     e.Message, 2005,
                     True);
               end;
            end;
         end;
      end
   else
   begin
      ErrorMsg('User wurde entwertet', _('Fehler beim Einlesen der Benutzer.'),
         2015, True);
   end;
end;

procedure Tfrm_ShowLayer.lb_usrannoClick(Sender: TObject);
var
   i: integer;
begin
   for i := 0 to lb_usranno.Items.Count - 1 do
   begin
      if lb_usranno.Selected[i] then
         lbl_LayerName.Caption := lb_usranno.items.strings[i];
      if frm_MainForm.TmpSQL('select Usr_id from sys_usr where Usr_name = ' +
         #39 + lbl_LayerName.Caption + #39) then
         with dm_DB.my_q_Tmp do
         begin
            lbl_uid.Caption := FieldByName('Usr_ID').AsString;
         end;
   end;
end;

procedure Tfrm_ShowLayer.lb_usrannoDblClick(Sender: TObject);
begin
   sbtn_UserLayerClick(self);
end;

procedure Tfrm_ShowLayer.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
