unit u_ThreadFetch;

interface

uses
   Classes, DB;

type
   TMyQueryFetch = class (TThread)
   private
      FDataSet: TDataSet;
   protected
      procedure Execute; override;
   public
      constructor Create(DataSet: TDataSet);
   end;

implementation

{ TMyQueryFetch }

constructor TMyQueryFetch.Create(DataSet: TDataSet);
begin
   inherited Create(True);
   FDataSet := DataSet;
   FreeOnTerminate := True;
end;

procedure TMyQueryFetch.Execute;
begin
   FDataSet.Open;
   FDataSet.First;
end;

end.
