unit u_man_fav;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, Menus, VirtualTrees, JvSimpleXml, ComCtrls, typinfo,
   StdCtrls, Mask, JvExMask, JvToolEdit, Xdom_4_1;

type
   Tfrm_Manfav = class (TForm)
      vst_favfolder: TVirtualStringTree;
      MainMenu1: TMainMenu;
      pump_man_favfolder: TPopupMenu;
      addfolder: TMenuItem;
      addfile: TMenuItem;
      delfile: TMenuItem;
      pump_man_favfile: TPopupMenu;
      MainMenu2: TMainMenu;
      JvSimpleXML1: TJvSimpleXML;
      TreeView1: TTreeView;
      XmlToDomParser1: TXmlToDomParser;
      StandardResourceResolver1: TStandardResourceResolver;
      DomImplementation1: TDomImplementation;
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormShow(Sender: TObject);
      procedure vst_favfolderGetText(Sender: TBaseVirtualTree;
         Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
         var CellText: WideString);
      procedure vst_favfolderDblClick(Sender: TObject);
      procedure TreeView1DblClick(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      procedure loadfavtree;
      { Public-Deklarationen }
   end;


var
   frm_Manfav: Tfrm_Manfav;

implementation

uses u_MainForm, IniFiles, u_dm_DB;

{$R *.dfm}

procedure Tfrm_Manfav.FormClose(Sender: TObject; var Action: TCloseAction);
var
   sldesignpath: string;
begin
   sldesignpath := GetSystemVariable('APPDATA') + '\bitfarm-archiv';
   //  vst_favfile.SaveToFile(sldesignpath + '\favtree.vts');
end;

procedure Tfrm_Manfav.FormShow(Sender: TObject);
begin
   loadfavtree;
end;


procedure Tfrm_Manfav.loadfavtree;
var
   limode, linumber, liCount: integer;
   lsname: string;
   liini: Tinifile;

   lNode: PVirtualNode;
   lddata: PTreeData;
begin
   liini := Tinifile.Create(GetSystemVariable('APPDATA') +
      '\bitfarm-archiv\Lesezeichen.ini');
   linumber := liini.readinteger('Lesezeichen', 'count', 0);
{     for licount:=0 to linumber-1 do
     begin
       lnode:=vst_favfile.addchild(nil);
       lddata:=vst_favfile.getnodedata(lnode);
       lddata^.Caption:=liini.ReadString('fav'+inttostr(licount),'name','Les');
       lddata.nr:=licount;
     end;}
end;

procedure Tfrm_Manfav.vst_favfolderGetText(Sender: TBaseVirtualTree;
   Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
   var CellText: WideString);
var
   lddata: PTreeData;
begin
   lddata := Sender.GetNodeData(Node);
   if Assigned(lddata) then
      CellText := lddata.Caption;
end;

procedure Tfrm_Manfav.vst_favfolderDblClick(Sender: TObject);
var
   lddata: PTreeData;
   Node: PVirtualNode;
begin
   with Sender as TBaseVirtualTree do
   begin
      Node := FocusedNode;
      lddata := GetNodeData(Node);
      if Assigned(lddata) then
      begin
         frm_MainForm.fav_nr := lddata.nr;
         frm_MainForm.tbx_dummyitemClick(Sender);
      end;
   end;
end;


procedure Tfrm_Manfav.TreeView1DblClick(Sender: TObject);
begin
   //     TreeView1.Selected.Data;
end;


end.
