unit u_wvlwlt;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, Buttons, TBXStatusBars, Mask, JvExMask, JvToolEdit, JvCombobox,
   StdCtrls, ComCtrls, MFEdit, JvExStdCtrls, JvListComb, gnugettext, DB,
   MemDS, DBAccess, MyAccess,
   u_ShLowUtils;

type
   Tfrm_wvlwlt = class (TForm)
      lbl_Datum: TLabel;
      lbl_Notiz: TLabel;
      Label2: TLabel;
      StaticText2: TLabel;
      StaticText3: TLabel;
      StaticText4: TLabel;
      StaticText5: TLabel;
      StaticText6: TLabel;
      st_wvlopt: TLabel;
      dtp_DocTime: TMFDateTimeEdit;
      memo_Info: TMemo;
      stb_AddDocTime: TTBXStatusBar;
      sbtn_OK: TSpeedButton;
      sbtn_Cancel: TSpeedButton;
    dtp_Alarm: TMFDateTimeEdit;
    JvCCB_eb: TJvCheckedComboBox;
    JvCCB_efa: TJvCheckedComboBox;
    JvCCB_je: TJvCheckedComboBox;
    jchb_opttim: TJvCheckedComboBox;
      procedure sbtn_OKClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure sbtn_CancelClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_wvlwlt: Tfrm_wvlwlt;

implementation

{$R *.dfm}

uses u_dm_db, u_MainForm, DateUtils, u_Optionen, {} u_dm_ViewerMain;

procedure Tfrm_wvlwlt.sbtn_OKClick(Sender: TObject);

var
   sDatum, slsqlrequest, lsushed: string;
   iTmpArcID, iTmpDocID, iStat, liInsID, licounter, lirecordnumber,
   litimeroptionen: integer;
   lsmemotext, lsStart, lsworkersid, lstmp,
   lstmp1, lstmp2, lsidw: string;
   bUpdate, lbfound, lbfound1: boolean;
   lstrl, lsgrpe, lsgrpf: TStringList;
begin
   GgfLogEvnt('frm_wvlwlt.sbtn_OKClick');
   lsgrpf := nil;
   lsgrpe := nil;
   lstrl := nil;
   // DateTimeToString(sDatum, 'yyyy-mm-dd hh:nn:ss', StartOfTheDay(dtp_TimerNG.DateTime));
   DateTimeToString(sDatum, 'yyyy-mm-dd hh:nn:ss',
      StartOfTheDay(dtp_DocTime.DateTime));

   bUpdate := False;
   lirecordnumber := dm_DB.my_q_Time.RecNo;

   if jchb_opttim.ischecked(0) and (jvccb_eb.CheckedCount > 1) then
   begin
      BfShowMessage(_('Nur ein Adressat(Benutzer) fr Wiedervorlage/Aufgaben-Weiterleitung') + #13 +
         _('mit "Nach Erledigung zurck" mglich.'));
      exit;
   end;
   if frm_mainform.dbgrd_wvl.selectedrows.Count = 1 then
   begin
      with dm_DB.my_cmd do
      begin
         // wenn mehr als Null elemente fuer die Wiedervorlage/Aufgaben vorgemerkt sind
         if dm_DB.my_q_Time.RecordCount > 0 then
            // Recordcount enthaelt die Anzahl der Wiedervorlagen
         begin
            iStat := dm_DB.my_q_Time.FieldByName('status').AsInteger;
            // den Status der WVL aus DB lesen
            // Status 0 = offen, 1 = in Bearbeitung , 2 = fertig
            // todo test if this is really meaning fulll (if refresh does work!)
            dm_DB.my_q_Time.SQLRefresh.Clear;
            // set request so it returns just 1 entry!
            slsqlrequest :=
               'Select Sql_No_cache tim_id, tim_ref, sys_timer.grp_id, termin, sys_arc.arc_id, arc_name, arc_tblname, doc_id,'
               + ' doc_titel, if(grp_name is not null, grp_name, usr_name) as usr_name,' +
               ' erinnerung, info, status, optionen, usr_id_work, usr_id_shed from sys_timer '
               +
               'left join sys_arc using(arc_id) ' +
               ' left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' +
               ' left join sys_grp on sys_grp.grp_id = sys_timer.grp_id ' +
               ' where tim_id = ' + dm_DB.my_q_Time.FieldByName('tim_id').AsString;
{      slsqlrequest:=StringReplace(dm_DB.my_q_Time.sql.text,'order by termin','',[rfReplaceAll])
      + ' and  tim_id = '+dm_DB.my_q_Time.FieldByName('tim_id').Asstring+' order by termin';}
            dm_DB.my_q_Time.SQLRefresh.Add(slsqlrequest);

            dm_DB.my_q_Time.RefreshRecord;
            if iStat <> dm_DB.my_q_Time.FieldByName('status').AsInteger then
            begin
               BfShowMessage(_('Der Status des Dokumentes wurde bereits von einem anderen Benutzer gendert.')
                  + #13 + _('Bitte berprfen Sie den neuen Status!') +
                  #13 +
                  #13 + _('Es erfolgte keine nderung an der Wiedervorlage/Aufgaben.'));
               frm_MainForm.FillControls(False);
               exit;
            end;

            lstrl := StrToWordswvl2(JvCCB_eb.GetText);

            lsgrpf := StrToWordswvl2(JvCCB_efa.gettext);
            lsgrpe := StrToWordswvl2(JvCCB_je.gettext);

            lsmemotext := memo_Info.Text;
            litimeroptionen := 0;
            if (lsgrpf.Count + lsgrpe.Count > 1)
            then
            begin
               if (lsgrpf.Count + lsgrpe.Count > 1) then
               begin
                  BfShowMessage(_('Nur ein Adressat(Gruppe oder Benutzer) fr Wiedervorlage/Aufgaben-Weiterleitung mglich.'));
               end;
               exit;
            end;
            if (lstrl.Count > 0) and ((lsgrpf.Count + lsgrpe.Count) > 0) then
            begin
               BfShowMessage(_('Erlaubt werden entweder nur einzelne Bearbeiter oder eine Gruppe.'));
               exit;
            end;

            if (lstrl.Count > 1) then
            begin
               frm_MainForm.TmpSQL('Select * from sys_timerhist where tim_ref=' +
                  dm_DB.my_q_Time.FieldByName('tim_ref').AsString + ' and usr_id_shed =' +
                  dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString + ' and ((optionen & 2)=2)');

               if
               dm_DB.my_q_Tmp.RecordCount = 0 then
               begin
                  BfShowMessage(_('Nur ein Adressat(Benutzer) fr Wiedervorlage/Aufgaben-Weiterleitung') +
                     #13 +
                     _('mit "Nach Erledigung zurck" mglich') + #13 +
                     _('(auch in der Weiterleitung-Kette).'));
                  exit;
               end;
            end;
            if ((dm_DB.my_q_Time.FieldByName('optionen').asinteger and 1) = 1) then
            begin
               BfShowMessage(_('Wiedervorlage/Aufgaben-Weiterleitung beim Modus "Jeder einzeln" wird') +
                  #13 +
                  _('noch nicht unterstzt.'));
               exit;
            end;
            for licounter := 0 to jchb_opttim.Items.Count - 1 do
            begin
               // Nach Erledigung zurck 2
               // Erinnerungsmail senden 4
               // nicht Einzelmodusinbearbeitung 8

               if jchb_opttim.IsChecked(licounter) then
               begin
                  litimeroptionen := litimeroptionen or (1 shl (licounter + 1));
               end;
            end;
            //gruppe auflsen
            if dm_DB.my_q_Time.FieldByName('grp_id').asinteger <> 0 then
            begin
               Sql.Text := 'delete from sys_timer where tim_ref = ' + dm_DB.my_q_Time.FieldByName('tim_ref').Asstring +
                  ' and tim_id <> ' + dm_DB.my_q_Time.FieldByName('tim_id').AsString;
               Execute;
            end;
            //wvl erzeugen
            lstmp := '';
            //einzelner benutzer
            lbfound1 := false;

            //check if return to sender
            // if there is an entry for the actual wvl
            //since for the 1. time wlt it is set but for stting a wvl there
            // is no entry     
            // u0 -> u1,rts ;  there is no sys_timerhist there
            // u0 -> u1,rts -> u2,rts there should be 2 (maybe one, but saver is 2) entries in sys_timerhist
            if ((dm_DB.my_q_Time.FieldByName('optionen').asinteger and 2) = 2)
            then
            begin
               frm_MainForm.TmpSQL('Select * from sys_timerhist where tim_ref=' +
                  dm_DB.my_q_Time.FieldByName('tim_ref').AsString + ' and usr_id_shed =' +
                  dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString);
               if
               dm_DB.my_q_Tmp.RecordCount = 0 then
               begin
                  Sql.Text :=
                     'insert into sys_timerhist (tim_id, tim_ref,usr_id_shed, optionen) values '
                     + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                     ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                     ',' + dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString +
                     ',' + dm_DB.my_q_Time.FieldByName('optionen').AsString + ')';
                  Execute;
                  lsushed := IntToStr(iGusrid);
               end;
            end;
            if
            ((litimeroptionen and 2) = 2) then
            begin
               //save some information about this wvl
               Sql.Text :=
                  'insert into sys_timerhist (tim_id, tim_ref,usr_id_shed, optionen) values '
                  + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                  ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                  ',' + dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString +
                  ',' + dm_DB.my_q_Time.FieldByName('optionen').AsString + ')';
               Execute;
               lsushed := IntToStr(iGusrid);
            end
            else
            begin
               lsushed := dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString;
            end;

            //be sure last user was in (maybe came through dbimp
            if gbhasctrlwvl then
            begin
               //todo: gruppe erlauben
               frm_MainForm.TmpSQL('Select * from sys_ctlrtimer where tim_ref=' +
                  dm_DB.my_q_Time.FieldByName('tim_ref').AsString + ' and usr_id_shed =' +
                  dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString);
               if dm_DB.my_q_Tmp.RecordCount = 0 then
               begin
                  Sql.Text :=
                     'insert into sys_ctlrtimer (tim_id, tim_ref,usr_id_work,' +
                     'usr_id_shed, info) values '
                     + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                     ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                     ',' + IntToStr(iGusrid) +
                     ',' + dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString +
                     ',' + #39 + dm_DB.my_q_Time.FieldByName('info').AsString + #39 + ')';
                  try
                     Execute;
                  except on e: Exception do
                     begin
                     end;
                  end;
               end;
            end;


            //todo: what happens if user was deleted? (very unlikely)
            for licounter := 0 to lstrl.Count - 1 do
            begin
               lbfound := false;

               frm_MainForm.TmpSQL('Select * from sys_usr');
               dm_DB.my_q_Tmp.first;
               while not dm_DB.my_q_Tmp.Eof do
               begin
                  if dm_DB.my_q_Tmp.fieldbyname('usr_name').asstring =
                     lstrl.Strings[licounter] then
                  begin
                     lbfound := true;
                     break;
                  end;
                  dm_DB.my_q_Tmp.next;
               end;
               if not lbfound then
               begin
                  continue;
               end;

               lsidw := dm_DB.my_q_Tmp.fieldbyname('usr_id').asstring;

               if lsidw = '' then
               begin
                  lsidw := dm_DB.my_q_Tmp.fieldbyname('usr_id').asstring;
               end;
               // first user

               if (not lbfound1) then
               begin
                  lbfound1 := true;
                  if gbhasctrlwvl then
                  begin
                     //todo: gruppe erlauben
                     Sql.Text :=
                        'insert into sys_ctlrtimer (tim_id, tim_ref,usr_id_work,' +
                        'usr_id_shed, info) values '
                        + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                        ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                        ',' + lsidw +
                        ',' + IntToStr(iGusrid) +
                        ',' + #39 + dm_DB.my_q_Time.FieldByName('info').AsString + #39 + ')';
                     try
                        Execute;
                     except on e: Exception do
                        begin
                        end;
                     end;
                  end;
                  try
                     Sql.Text :=
                        'Update sys_timer set Termin  = :termin, info = :info,  usr_id_work =:uwork, ' +
                        'usr_id_shed = :ushed, status = :status, ' +
                        'grp_id = :grp_id, erinnerung = :erinnerung, optionen = :optionen ' +
                        'where tim_id=' + dm_DB.my_q_Time.FieldByName(
                        'tim_id').AsString;
                     dm_DB.my_Cmd.ParamByName('grp_id').AsString := '0';
                     dm_DB.my_Cmd.ParamByName('status').AsString := '0';
                     dm_DB.my_Cmd.ParamByName('info').AsString := lsmemotext;
                     dm_DB.my_Cmd.ParamByName('termin').AsDateTime :=
                        dtp_DocTime.DateTime;
                     dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                        dtp_Alarm.DateTime;
                     dm_DB.my_Cmd.ParamByName('optionen').AsInteger :=
                        litimeroptionen;
                     dm_DB.my_Cmd.ParamByName('uwork').Asstring :=
                        lsidw;
                     dm_DB.my_Cmd.ParamByName('ushed').AsInteger :=
                        iGusrid; //iGUsrID;

                     Execute;
                     lstmp := lstrl.Strings[licounter];
                  except
                     on e: Exception do
                     begin
                        ErrorMsg('frm_MainForm.tbx_wvlfavdelbear0Click',
                           _('Fehler beim Hinzufgen eines Dokumentes zur Wiedervorlage/Aufgaben:') +
                           e.Message, 2023, True);
                     end;
                  end;
               end
               else
               begin
                  try
                     dm_DB.my_Cmd.SQL.Text :=
                        'Insert into sys_timer (grp_id, arc_id, doc_id, doc_Titel, usr_id_work,'
                        + ' usr_id_shed, termin, erinnerung, optionen, info, status) '
                        + 'Values (:grpid, :arcid, :docid, :doctitel,  :uwork, :ushed, :termin,'
                        + ' :erinnerung, :optionen, :info, :status)';
                     dm_DB.my_Cmd.ParamByName('grpid').AsString := '0';
                     dm_DB.my_Cmd.ParamByName('arcid').AsInteger :=
                        dm_DB.my_q_Time.FieldByName('arc_id').AsInteger;
                     dm_DB.my_Cmd.ParamByName('docid').AsInteger :=
                        dm_DB.my_q_Time.FieldByName('doc_id').AsInteger;
                     dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
                        dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
                     dm_DB.my_Cmd.ParamByName('uwork').Asinteger :=
                        dm_DB.my_q_Tmp.fieldbyname('usr_id').Asinteger;
                     dm_DB.my_Cmd.ParamByName('ushed').AsInteger :=
                        iGusrid; //iGUsrID;
                     dm_DB.my_Cmd.ParamByName('termin').AsDateTime := dtp_DocTime.DateTime;
                     // alarm changes like sdatum but relatively

                     dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                        dtp_Alarm.DateTime;
                     dm_DB.my_Cmd.ParamByName('optionen').AsInteger :=
                        litimeroptionen;

                     dm_DB.my_Cmd.ParamByName('info').AsString := lsmemotext;
                     // status should be changed also in the database and not only in cbx_status.
                     dm_DB.my_Cmd.ParamByName('status').AsString := '0';
{            dm_DB.my_Cmd.ParamByName('timref').AsString :=
              dm_DB.my_q_Time.FieldByName('tim_Ref').AsString;}
                     dm_DB.my_Cmd.Execute;
                     liInsID := dm_DB.my_Cmd.InsertId;
                     dm_DB.my_Cmd.SQL.Text :=
                        'Update sys_timer set tim_ref = ' + IntToStr(liInsID) +
                        ' where tim_id = ' + IntToStr(liInsID);
                     dm_DB.my_Cmd.Execute;

                     if gbhasctrlwvl then
                     begin
                        //reproduce the same "history of the first" for all sequence
                        //todo: gruppe erlauben
                        Sql.Text :=
                           'insert into sys_ctlrtimer (tim_id, tim_ref,usr_id_work,' +
                           'usr_id_shed, info) select ' +
                           IntToStr(liInsID) +
                           ',' + IntToStr(liInsID) +
                           ',usr_id_work' +
                           ',usr_id_shed' +
                           ',info  from sys_ctlrtimer where tim_ref =' +
                           dm_DB.my_q_Time.FieldByName('tim_Ref').AsString;
                        try
                           Execute;
                        except on e: Exception do
                           begin
                           end;
                        end;
                     end;
                     lstmp := lstmp + ',' + lstrl.Strings[licounter];
                  except
                     on e: Exception do
                     begin
                        ErrorMsg('frm_MainForm.tbx_wvlfavdelbear0Click',
                           _('Fehler beim Hinzufgen eines Dokumentes zur Wiedervorlage/Aufgaben: ') +
                           e.Message, 2023, True);
                     end;
                  end;
               end;
               // delete actual tim_id
            end;

            //gruppe jeder einzelne
            for licounter := 0 to lsgrpe.Count - 1 do
            begin
               frm_MainForm.TmpSQL(
                  'Select * from sys_grpusr left join sys_usr using (usr_id) left join sys_grp ' +
                  'on (sys_grpusr.grp_id=sys_grp.grp_id) where grp_name = ' + #39 +
                  lsgrpe.Strings[licounter] + #39 + ' and usr_name not like ' +
                  #39 + 'DEL\_%' + #39);

               try
                  if dm_DB.my_q_Tmp.RecordCount > 0 then
                  begin
                     if gbhasctrlwvl then
                     begin
                        //todo: gruppe erlauben
                        Sql.Text :=
                           'insert into sys_ctlrtimer (tim_id, tim_ref,usr_id_work,' +
                           'grp_id,usr_id_shed, info) values '
                           + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                           ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                           ',' + dm_DB.my_q_Tmp.fieldbyname('usr_id').AsString +
                           ',' + dm_DB.my_q_Tmp.fieldbyname('grp_id').AsString +
                           ',' + IntToStr(iGusrid) +
                           ',' + #39 + dm_DB.my_q_Time.FieldByName('info').AsString + #39 + ')';
                        try
                           Execute;
                        except on e: Exception do
                           begin
                           end;
                        end;
                     end;
                     Sql.Text :=
                        'Update sys_timer set Termin  = :termin, info = :info,  usr_id_work =:uwork, ' +
                        'usr_id_shed = :ushed, status = :status ,'
                        + ' grp_id = :grpid, erinnerung = :erinnerung, optionen = :optionen '
                        + ' where tim_id=' + dm_DB.my_q_Time.FieldByName(
                        'tim_id').AsString;
                     dm_DB.my_Cmd.ParamByName('grpid').asinteger :=
                        dm_DB.my_q_Tmp.FieldByName('grp_id').asinteger;
                     dm_DB.my_Cmd.ParamByName('status').asinteger := 0;
                     dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                        dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
                     dm_DB.my_Cmd.ParamByName('ushed').AsInteger :=
                        iGusrid; //iGUsrID;
                     dm_DB.my_Cmd.ParamByName('termin').AsDateTime := dtp_DocTime.DateTime;

                     dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                        dtp_Alarm.DateTime;
                     dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen or 1;

                     dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
                     dm_DB.my_Cmd.Execute;


                     dm_DB.my_q_Tmp.Next;
                     while not dm_DB.my_q_Tmp.EOF do
                     begin
                        dm_DB.my_Cmd.SQL.Text :=
                           'Insert into sys_timer (tim_ref, grp_id, arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) '
                           +
                           'Values (:timref, :grpid, :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :erinnerung, :optionen, :info)';
                        dm_DB.my_Cmd.ParamByName('timref').AsInteger := dm_DB.my_q_Time.FieldByName(
                           'tim_ref').asinteger;
                        dm_DB.my_Cmd.ParamByName('grpid').asinteger :=
                           dm_DB.my_q_Tmp.FieldByName('grp_id').asinteger;
                        dm_DB.my_Cmd.ParamByName('arcid').AsInteger := iGArcID;
                        dm_DB.my_Cmd.ParamByName('docid').AsInteger := iGDocID;
                        dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
                           dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
                        dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                           dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
                        dm_DB.my_Cmd.ParamByName('ushed').AsInteger :=
                           iGusrid;
                        dm_DB.my_Cmd.ParamByName('termin').AsDateTime := dtp_DocTime.DateTime;

                        dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                           dtp_Alarm.DateTime;
                        dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen or 1;

                        dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
                        dm_DB.my_Cmd.Execute;


                        dm_DB.my_q_Tmp.Next;
                     end;
                  end;
               except
                  on e: Exception do
                  begin
                     ErrorMsg('frm_MainForm.tbx_wvlfavdelbear0Click',
                        _('Fehler beim Hinzufgen eines Dokumentes zur Wiedervorlage/Aufgaben: ') +
                        e.Message, 2023, True);
                  end;
               end;
            end;

            //gruppe einer fr alle

            for licounter := 0 to lsgrpf.Count - 1 do
            begin
               //               susr:= sUsr+'#'+jvccb_efa.items.Strings[i] +' ';
               frm_MainForm.TmpSQL(
                  'Select * from sys_grpusr left join sys_usr using (usr_id)  left join sys_grp ' +
                  'on (sys_grpusr.grp_id=sys_grp.grp_id) where grp_name = ' + #39 +
                  lsgrpf.Strings[licounter] + #39 + ' and usr_name not like  ' +
                  #39 + 'DEL\_%' + #39);

               try
                  if dm_DB.my_q_Tmp.RecordCount > 0 then
                  begin
                     if gbhasctrlwvl then
                     begin
                        //todo: gruppe erlauben
                        Sql.Text :=
                           'insert into sys_ctlrtimer (tim_id, tim_ref,usr_id_work,' +
                           ' grp_id,usr_id_shed, info) values '
                           + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                           ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                           ',' + dm_DB.my_q_Tmp.fieldbyname('usr_id').AsString +
                           ',' + dm_DB.my_q_Tmp.fieldbyname('grp_id').AsString +
                           ',' + IntToStr(iGusrid) +
                           ',' + #39 + dm_DB.my_q_Time.FieldByName('info').AsString + #39 + ')';
                        try
                           Execute;
                        except on e: Exception do
                           begin
                           end;
                        end;
                     end;
                     Sql.Text :=
                        'Update sys_timer set Termin  = :termin, info = :info,  usr_id_work =:uwork, ' +
                        'usr_id_shed = :ushed, status = :status ,'
                        + ' grp_id = :grpid, erinnerung = :erinnerung, optionen = :optionen '
                        + ' where tim_id=' + dm_DB.my_q_Time.FieldByName(
                        'tim_id').AsString;
                     dm_DB.my_Cmd.ParamByName('grpid').asinteger :=
                        dm_DB.my_q_Tmp.FieldByName('grp_id').asinteger;
                     dm_DB.my_Cmd.ParamByName('status').asinteger := 0;
                     dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                        dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
                     dm_DB.my_Cmd.ParamByName('ushed').AsInteger :=
                        iGusrid; //iGUsrID;
                     dm_DB.my_Cmd.ParamByName('termin').AsDateTime := dtp_DocTime.DateTime;

                     dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                        dtp_Alarm.DateTime;
                     dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen;

                     dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
                     dm_DB.my_Cmd.Execute;

                     dm_DB.my_q_Tmp.Next;
                     while not dm_DB.my_q_Tmp.EOF do
                     begin
                        dm_DB.my_Cmd.SQL.Text :=
                           'Insert into sys_timer (tim_ref, grp_id, arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) ' +
                           'Values (:timref, :grpid, :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :erinnerung, :optionen, :info)';
                        dm_DB.my_Cmd.ParamByName('timref').AsInteger := dm_DB.my_q_Time.FieldByName(
                           'tim_ref').asinteger;
                        dm_DB.my_Cmd.ParamByName('grpid').asinteger :=
                           dm_DB.my_q_Tmp.FieldByName('grp_id').asinteger;
                        dm_DB.my_Cmd.ParamByName('arcid').AsInteger := iGArcID;
                        dm_DB.my_Cmd.ParamByName('docid').AsInteger := iGDocID;
                        dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
                           dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
                        dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                           dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
                        dm_DB.my_Cmd.ParamByName('ushed').AsInteger :=
                           iGusrid;
                        dm_DB.my_Cmd.ParamByName('termin').AsDateTime := dtp_DocTime.DateTime;

                        dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                           dtp_Alarm.DateTime;
                        dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen;

                        dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
                        dm_DB.my_Cmd.Execute;


                        dm_DB.my_q_Tmp.Next;
                     end;
                  end;
               except
                  on e: Exception do
                  begin
                     ErrorMsg('frm_MainForm.tbx_wvlfavdelbear0Click',
                        _('Fehler beim Hinzufgen eines Dokumentes zur Wiedervorlage/Aufgaben: ') +
                        e.Message, 2023, True);
                  end;
               end;
            end;
            bUpdate := True;
         end;
         // nur Updaten wenn auch wirklich ein SQL Update erfolgt ist
         if bUpdate then
         begin
            //tbi_ShowDocClick(self);
{only needed when status ready
        if frm_mainform.cbx_Status.ItemIndex = 2 then
          CancelStatus;}
            iTmpArcID := iGArcID;
            iTmpDocID := iGDocID;
            iGArcID := iGTimArcID;
            iGDocID := iGTimDocID;
            frm_MainForm.NewHistory(18,
               _('Wiedervorlage/Aufgaben') + ' ' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
               ' ' + _('gendert. Berarbeiternamen:') + lstmp + _(';Bearbeiter:') + ' ' +
               Trim(lstrl.text + lsgrpf.text + lsgrpe.text) + '; ' + _('Termin:') + ' ' + sDatum + ' ' + _('Status:') + ' ' +
               frm_MainForm.cbx_Status.Text);
            iGArcID := iTmpArcID;
            iGDocID := iTmpDocID;
            if frm_mainform.tbi_MyTask.Checked then
               frm_mainform.ShowDocsKW(iGKWYear, iGKW);
            if frm_mainform.tbi_MATask.Checked then
               frm_mainform.ShowMATasks;

            // reselect the old
            frm_wvlwlt.ModalResult := mrOk;
            dm_DB.my_q_Time.RecNo := lirecordnumber;
            frm_mainform.FillCOntrols(False);
            frm_mainform.tbi_ShowDocClick(self);
            wvlhasfocus := True;
            frm_mainform.wvlshowbuttons(True);
            // make this one be selected and marked!
            frm_mainform.dbgrd_wvl.SelectedRows.CurrentRowSelected := True;
            // commented out so wvl dont jump (loose selection and hide and show)

            frm_mainform.RefreshStatus;
         end;
      end;
   end
   else
   begin
      BfShowMessage(_('Bitte whlen Sie eine Wiedervorlage/Aufgabe.'));
   end;
end;

procedure Tfrm_wvlwlt.FormShow(Sender: TObject);
var li, litimeropt, iCount: integer;
begin
   frm_MainForm.TmpSQL('select usr_id, usr_Name  from sys_usr where (usr_name not like  '
      + #39 + 'DEL\_%' + #39 + ') and (usr_name not like  ' + #39 +
      'system' + #39 + ') order by usr_name');

   for iCount := 0 to (dm_DB.my_q_Tmp.RecordCount - 1) do
   begin
      JvCCB_eb.Items.Add(dm_DB.my_q_Tmp.FieldByName('usr_name').AsString);
      dm_DB.my_q_Tmp.Next;
   end;
   dm_DB.my_q_Tmp.Close;
   frm_MainForm.TmpSQL(
      'select grp_id, grp_Name,  grp_name from sys_grp  ' +
      ' order by grp_name');
   //statictext1.Caption:=inttostr (dm_DB.my_q_Tmp.RecordCount); // schreibt die Anzahl der Gruppen
   for iCount := 0 to (dm_DB.my_q_Tmp.RecordCount - 1) do
   begin
      jvccb_je.Items.Add(dm_DB.my_q_Tmp.FieldByName('grp_name').AsString);
      jvccb_efa.Items.Add(dm_DB.my_q_Tmp.FieldByName('grp_name').AsString);
      dm_DB.my_q_Tmp.Next;
   end;
   dm_DB.my_q_Tmp.Close;
   dtp_DocTime.DateTime := StartOfTheDay(now);
   dtp_Alarm.DateTime := (dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
      dm_DB.my_q_Time.FieldByName('termin').AsDateTime) + dtp_DocTime.DateTime;
   memo_Info.text := dm_DB.my_q_Time.FieldByName('info').asstring;
   litimeropt := dm_DB.my_q_Time.FieldByName('Optionen').asinteger;

   for li := 1 to 2 do
   begin
      if ((1 shl li) and litimeropt) > 0 then
      begin
         jchb_opttim.checked[li - 1] := true;
      end;
   end;
end;

procedure Tfrm_wvlwlt.sbtn_CancelClick(Sender: TObject);
begin
   frm_wvlwlt.ModalResult := mrCancel;
end;

procedure Tfrm_wvlwlt.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;


end.
