unit u_de_Eingabetext;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Buttons, ieVect, ImageEnView, ImageEnProc,
   JvExControls, JvScrollText, JvExStdCtrls, JvRichEdit, JvEditorCommon,
   JvEditor, ieview, JvMemo, gnugettext;

type
   Tfrm_textanno = class (TForm)
      stct_meminfo: TLabel;
      btn_abbruch: TBitBtn;
      btn_ok: TBitBtn;
      iev_myvect: TImageEnVect;
      JvMemo1: TJvMemo;
      procedure btn_okClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      lftextwidth: integer;
      lflinescount: integer;
      lftext: string;
   protected
      procedure CreateParams(var Params: TCreateParams); override;
      { Private-Deklarationen }
   public
      property TExtwidth: integer Read lftextwidth;
      property Linescount: integer Read lflinescount Write lflinescount;
      property Text: string Read lftext;
      function getlongestline(fstl: TStrings): string;
      procedure textanObjektpassen(fstl: TStrings);
      { Public-Deklarationen }
   end;

var
   frm_textanno: Tfrm_textanno;

implementation

uses u_DocEditor;

{$R *.dfm}

function Tfrm_textanno.getlongestline(fstl: TStrings): string;
var
   lii, lil, lilinel: integer;
begin
   if fstl.Count = 0 then
   begin
      Result := '';
      exit;
   end;
   lilinel := 0;
   lftextwidth := 0;
   for lii := 0 to fstl.Count - 1 do
   begin
      lil := length(fstl.Strings[lii]);
      if lftextwidth < lil then
      begin
         lftextwidth := lil;
         lilinel := lii;
      end;
   end;
   Result := fstl.Strings[lilinel];
end;

procedure Tfrm_textanno.btn_okClick(Sender: TObject);
begin
   textanObjektpassen(JvMemo1.Lines);
end;

procedure Tfrm_textanno.textanObjektpassen(fstl: TStrings);
var
   lileng, sta, sto, limax, lilinelength: integer;
   lslongestline: string;
begin
   limax := 0;
   lileng := length(fstl.Text);
   // setwidth;
   sta := 0;
   while (sta < lileng) do
   begin
      sto := Pos(#$D#$A, copy(fstl.Text, sta, lileng));
      if sto = 0 then
         sto := lileng - sta + 2;
      // search the max;

      if sto > limax then
         limax := sto;

      sta := sto + sta + 1;
   end;

   Linescount := fstl.Count;

   lslongestline := getlongestline(fstl);
   if lslongestline = '' then
   begin
      iev_myvect.ObjText[-1] := '';
      exit;
   end;

   lilinelength := iev_myvect.GetCanvas.TextWidth(lslongestline);
   iev_myvect.ObjWidth[-1] :=
      trunc(lilinelength * iev_myvect.ObjFontHeight[-1] / 10);
   //frm_textanno.TExtwidth*trunc(3*abs(img_DocEdit.ObjFontHeight[hobj])/5);
   iev_myvect.ObjHeight[-1] := frm_textanno.Linescount *
      (trunc(abs(iev_myvect.ObjFontHeight[-1]) * 3 / 2));
   //     img_DocEdit.ObjText[hobj]:= frm_textanno.Text;

   iev_myvect.ObjText[-1] := fstl.Text;
end;

procedure Tfrm_textanno.CreateParams(var Params: TCreateParams);
begin
   inherited;
   Params.ExStyle := Params.ExStyle; // or WS_EX_APPWINDOW;
   Params.WndParent := GetDesktopWindow;
end;

procedure Tfrm_textanno.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
